• | Table of Contents
• | Reviews
• | CD-ROM
• | Reader Reviews
• | Errata
Mac OS X: The Missing Manual, 2nd Edition
By David Pogue
Publisher | : O'Reilly
Pub Date | : October 2002
ISBN | : 0-596-00450-8
Pages | : 725

New York Times computer columnist David Pogue has just updated his bestselling Mac OS X: The Missing Manual! And once again, he applies his scrupulous objectivity to this exciting new operating system, revealing which new features work well and which do not. With new material on almost every page, this second edition offers a wealth of detail on the myriad changes in OS X 10.2.


• | Table of Contents
• | Reviews
• | CD-ROM
• | Reader Reviews
• | Errata
Mac OS X: The Missing Manual, 2nd Edition
By David Pogue
Publisher | : O'Reilly
Pub Date | : October 2002
ISBN | : 0-596-00450-8
Pages | : 725

Copyright
The Missing Credits
 | About the Author
 | About the Creative Team
 | Acknowledgments
Introduction
 | What Mac OS X 10.2 Gives You
 | What Mac OS X Takes Away
 | Three OSes in One
 | About this Book
 | The Very Basics
Part I: The Mac OS X Desktop
 | Chapter 1. Folders and Windows
 |  | Section 1.1. Getting into Mac OS X
 |  | Section 1.2. Windows and How to Work Them
 |  | Section 1.3. The Three Window Views
 |  | Section 1.4. Icon View
 |  | Section 1.5. List View
 |  | Section 1.6. Column View
 |  | Section 1.7. Logging Out, Shutting Down
 |  | Section 1.8. Getting Help in Mac OS X
 | Chapter 2. Organizing Your Stuff
 |  | Section 2.1. The Mac OS X Folder Structure
 |  | Section 2.2. Icon Names
 |  | Section 2.3. Selecting Icons
 |  | Section 2.4. Moving and Copying Icons
 |  | Section 2.5. Aliases: Icons in Two Places at Once
 |  | Section 2.6. Favorites
 |  | Section 2.7. The Trash
 |  | Section 2.8. Get Info
 |  | Section 2.9. Finding Files 1: The Search Bar
 |  | Section 2.10. Finding Files 2: The Find Program
 | Chapter 3. Dock, Desktop, and Toolbar
 |  | Section 3.1. The Dock
 |  | Section 3.2. Setting Up the Dock
 |  | Section 3.3. Using the Dock
 |  | Section 3.4. The Finder Toolbar
 |  | Section 3.5. Designing Your Desktop
 |  | Section 3.6. Menulets: The Missing Manual
Part II: Applications in Mac OS X
 | Chapter 4. Programs and Documents
 |  | Section 4.1. Launching Mac OS X Programs
 |  | Section 4.2. Juggling Programs with the Dock
 |  | Section 4.3. How Documents Know Their Parents
 |  | Section 4.4. Controlling Menus from the Keyboard
 |  | Section 4.5. The Save and Open Dialog Boxes
 |  | Section 4.6. Three Kinds of Programs: Cocoa, Carbon, Classic
 |  | Section 4.7. The Cocoa Difference
 |  | Section 4.8. Installing Mac OS X Programs
 | Chapter 5. Back to Mac OS 9
 |  | Section 5.1. Two Roads to Mac OS 9
 |  | Section 5.2. Classic: Mac OS 9 on Mac OS X
 |  | Section 5.3. Restarting in Mac OS 9
 |  | Section 5.4. Four Tricks for Faster Switching
 | Chapter 6. Moving Data
 |  | Section 6.1. Moving Data Between Documents
 |  | Section 6.2. Exchanging Data with Other Macs
 |  | Section 6.3. Exchanging Data with Windows PCs
 | Chapter 7. An Introduction to AppleScript
 |  | Section 7.1. Running Ready-Made AppleScripts
 |  | Section 7.2. Writing Your Own AppleScripts
 |  | Section 7.3. Recording Scripts in "Watch Me" Mode
 |  | Section 7.4. Saving a Script
 |  | Section 7.5. Writing Commands by Hand
 |  | Section 7.6. Where to Learn More
Part III: The Components of Mac OS X
 | Chapter 8. System Preferences
 |  | Section 8.1. The System Preferences Window
 |  | Section 8.2. Accounts
 |  | Section 8.3. CDs & DVDs
 |  | Section 8.4. Classic
 |  | Section 8.5. ColorSync
 |  | Section 8.6. Date & Time
 |  | Section 8.7. Desktop
 |  | Section 8.8. Displays
 |  | Section 8.9. Dock
 |  | Section 8.10. Energy Saver
 |  | Section 8.11. General
 |  | Section 8.12. International
 |  | Section 8.13. Internet
 |  | Section 8.14. Keyboard
 |  | Section 8.15. Login Items
 |  | Section 8.16. Mouse
 |  | Section 8.17. My Account
 |  | Section 8.18. Network
 |  | Section 8.19. QuickTime
 |  | Section 8.20. Screen Effects
 |  | Section 8.21. Sharing
 |  | Section 8.22. Software Update
 |  | Section 8.23. Sound
 |  | Section 8.24. Speech
 |  | Section 8.25. Startup Disk
 |  | Section 8.26. Universal Access
 | Chapter 9. The Free Programs
 |  | Section 9.1. Your Free Mac OS X Programs
 |  | Section 9.2. Utilities: Your Mac OS X Toolbox
 | Chapter 10. CDs, DVDs, and iTunes
 |  | Section 10.1. How the Mac Does Disks
 |  | Section 10.2. Burning CDs and DVDs
 |  | Section 10.3. iTunes 3: The CD and MP3 Jukebox
 |  | Section 10.4. Playing DVD Movies
Part IV: The Technologies of Mac OS X
 | Chapter 11. One Mac, Many Users
 |  | Section 11.1. Introducing User Accounts
 |  | Section 11.2. Setting Up Accounts
 |  | Section 11.3. Setting Up the Login/Logout Process
 |  | Section 11.4. Signing In
 |  | Section 11.5. Simple Finder and Other "Rubber Walls"
 |  | Section 11.6. Logging Out
 |  | Section 11.7. The Root Account
 | Chapter 12. Networking
 |  | Section 12.1. Wiring the Network
 |  | Section 12.2. File Sharing
 |  | Section 12.3. Networking with Windows
 |  | Section 12.4. Managing Groups
 |  | Section 12.5. Dialing in from the Road
 |  | Section 12.6. Forgettable Passwords: The Keychain
 | Chapter 13. Graphics, Fonts, and Printing
 |  | Section 13.1. Mac Meets Printer
 |  | Section 13.2. Making the Printout
 |  | Section 13.3. Managing Printouts
 |  | Section 13.4. Printer Sharing
 |  | Section 13.5. PDF Files
 |  | Section 13.6. Fonts in Mac OS X
 |  | Section 13.7. Font Fuzziness on the Screen
 |  | Section 13.8. ColorSync
 |  | Section 13.9. Graphics in Mac OS X
 |  | Section 13.10. Screen-Capture Keystrokes
 | Chapter 14. Sound, Movies, Speech, and Handwriting
 |  | Section 14.1. Playing Sounds
 |  | Section 14.2. Recording Sound
 |  | Section 14.3. QuickTime Movies
 |  | Section 14.4. Speech Recognition
 |  | Section 14.5. The Mac Talks Back
 |  | Section 14.6. Inkwell: Handwriting Recognition
 | Chapter 15. Terminal: Doorway to Unix
 |  | Section 15.1. Terminal
 |  | Section 15.2. Navigating in Unix
 |  | Section 15.3. Working with Files and Directories
 |  | Section 15.4. Online Help
 |  | Section 15.5. Terminal Preferences
 |  | Section 15.6. Terminal Tips and Tricks
 | Chapter 16. Fun with Unix
 |  | Section 16.1. Moving Unmovable Files and Directories
 |  | Section 16.2. Enabling the Root Account
 |  | Section 16.3. Eight Useful Unix Utilities
 |  | Section 16.4. Where to Go from Here
 |  | Section 16.5. Putting It Together
 | Chapter 17. Hacking Mac OS X
 |  | Section 17.1. TinkerTool: Customization 101
 |  | Section 17.2. Redefining Keystrokes
 |  | Section 17.3. Redoing Mac OS X's Graphics
 |  | Section 17.4. Replacing Your Home-Folder Icon
 |  | Section 17.5. Replacing the Finder Icons
 |  | Section 17.6. Rewriting the Words
Part V: Mac OS X Online
 | Chapter 18. Internet Setup, the Firewall, and .Mac
 |  | Section 18.1. The Best News You've Heard All Day
 |  | Section 18.2. Connecting by Dial-up Modem
 |  | Section 18.3. Broadband Connections
 |  | Section 18.4. AirPort Networks
 |  | Section 18.5. The Jaguar Firewall
 |  | Section 18.6. Switching Locations
 |  | Section 18.7. Multihoming
 |  | Section 18.8. Internet Sharing
 |  | Section 18.9. .Mac Services
 |  | Section 18.10. Internet Location Files
 | Chapter 19. Mail and Address Book
 |  | Section 19.1. Setting Up Mail
 |  | Section 19.2. Checking Your Mail
 |  | Section 19.3. Writing Messages
 |  | Section 19.4. Reading Email
 |  | Section 19.5. The Spam Filter
 |  | Section 19.6. Address Book
 | Chapter 20. Sherlock 3, iChat, and iCal
 |  | Section 20.1. Sherlock 3
 |  | Section 20.2. iChat
 |  | Section 20.3. iCal and iSync
 | Chapter 21. SSH, FTP, VPN, and Web Sharing
 |  | Section 21.1. Web Sharing
 |  | Section 21.2. FTP
 |  | Section 21.3. Connecting from the Road
 |  | Section 21.4. Remote Access with SSH
 |  | Section 21.5. Virtual Private Networking
Part VI: Appendixes
 | Appendix A. Installing Mac OS X 10.2
 |  | Section A.1. Getting Ready to Install
 |  | Section A.2. Four Kinds of Installation
 |  | Section A.3. The Basic Installation
 |  | Section A.4. The Upgrade Installation
 |  | Section A.5. The Clean Install
 |  | Section A.6. The Setup Assistant
 |  | Section A.7. Uninstalling Mac OS X
 | Appendix B. Troubleshooting
 |  | Section B.1. Problems That Aren't Problems
 |  | Section B.2. Minor Eccentric Behavior
 |  | Section B.3. Frozen Programs (Force Quitting)
 |  | Section B.4. Error Messages When Opening
 |  | Section B.5. The Wrong Program Opens
 |  | Section B.6. Can't Empty the Trash
 |  | Section B.7. Can't Move or Rename an Icon
 |  | Section B.8. Application Won't Open
 |  | Section B.9. Program Icons Turn to Folders
 |  | Section B.10. Startup Problems
 |  | Section B.11. Fixing the Disk
 |  | Section B.12. Where to Get Troubleshooting Help
 | Appendix C. The "Where'd It Go?" Dictionary (Mac Version)
 |  | Section C.1. Classic Mac Features
 | Appendix D. The "Where'd It Go?" Dictionary (Windows Version)
 |  | Section D.1. Common Windows Functions
 | Appendix E. Where to Go From Here
 |  | Section E.1. Web Sites
 |  | Section E.2. Advanced Books
 |  | Section E.3. Email Lists
 | Appendix F. The Master Mac OS X Keystroke List
 |  | Section F.1. The Master List
Colophon


Copyright

Copyright © 2002 Pogue Press, LLC.

Printed in the United States of America.

Published by Pogue Press/O'Reilly & Associates, Inc., 1005 Gravenstein Highway North, Sebastopol, CA 95472.

O'Reilly & Associates books may be purchased for educational, business, or sales promotional use. Online editions are also available for most titles (http://safari.oreilly.com). For more information, contact our corporate/institutional sales department: (800) 998-9938 or corporate@oreilly.com.

Missing Manual, the Missing Manual logo, and "The book that should have been in the box" are registered trademarks of Pogue Press, LLC.

Many of the designations used by manufacturers and sellers to distinguish their products are claimed as trademarks. Where those designations appear in this book, and Pogue Press was aware of a trademark claim, the designations have been capitalized.

While every precaution has been taken in the preparation of this book, the publisher and authors assume no responsibility for errors or omissions, or for damages resulting from the use of the information contained herein.


The Missing Credits

    About the Author

    About the Creative Team

    Acknowledgments


About the Author

David Pogue is the weekly computer columnist for the New York Times and the creator of the Missing Manual series. He's the author or co-author of 25 books, including five in this series and six in the "For Dummies" line (including Magic, Opera, Classical Music, and The Flat-Screen iMac). In his other life, David is a former Broadway show conductor, a magician, and a pianist (www.davidpogue.com).

He welcomes feedback about Missing Manual titles by email: david@pogueman.com. (If you need technical help, however, please refer to the sources in Appendix E.)


About the Creative Team

Nan Barber (copy editor) co-authored Office X for the Macintosh: The Missing Manual and Office 2001 for Macintosh: The Missing Manual. As the principal copy editor for this series, she has edited the titles on iPhoto, Mac OS 9, AppleWorks 6, iMovie, Dreamweaver 4, and Windows XP. Email: nanbarber@mac.com.

John Cacciatore (copy editor) works out of his home office in Woburn, Mass., where he is ardently engaged in the English major's freelance trinity: writing, editing, and proofing. Email: j_cacciatore@yahoo.com.

Dennis Cohen (technical reviewer) has served as the technical reviewer for many bestselling Mac books, including several editions of Macworld Mac Secrets and most Missing Manual titles. He's the co-author of AppleWorks 6 for Dummies, Macworld AppleWorks 6 Bible, and Macworld Mac OS X Bible. Email: drcohen@mac.com.

Phil Simpson (design and layout) works out of his office in Stamford, Connecticut, where he has had his graphic design business since 1982. He is experienced in many facets of graphic design, including corporate identity, publication design, and corporate and medical communications. Email: pmsimpson@earthlink.net.

Alan Graham (research and testing) is an author for the O'Reilly Network and a design consultant for 3D, video, Web, user-interface, and FileMaker Pro. He has appeared in Wired, The London Observer, CNET Radio's Mac Show Live, and Po Bronson's bestselling book, Nudist on the Late Shift. (He is not the nudist.)

Joseph Schorr (Chapter 9 co-author and Address Book coverage) is a frequent contributor to Macworld and a senior product manager at Extensis, Inc. He wrote Macworld's "Secrets" column for several years and co-authored six editions of Macworld Mac Secrets. He began collaborating with David Pogue in 1982—on musical comedies at Yale.

Chris Stone (author of Chapter 15 and Chapter 16) is the Senior Macintosh Systems Administrator at O'Reilly & Associates. Though at times it might appear otherwise, he really does love his wife Miho and sons Andy and J.J. (much) more than Macs and the San Francisco Giants. Email: cjstone@mac.com

Jason Snell (iChat, Simple Finder, and Inkwell sections) is the editor of Macworld magazine. He also edits the Web sites TeeVee (www.teevee.org) and InterText (www.intertext.com) and teaches at UC Berkeley's Graduate School of Journalism. He lives in Mill Valley, California, with his wife and daughter.


Acknowledgments

The Missing Manual series is a joint venture between the dream team introduced on these pages and O'Reilly & Associates: Tim O'Reilly, Mark Brokering, and company.

I'm grateful to all of them, and to AppleScript genius Bill Briggs for his help on Chapter 7; Apple's Ken Bereskin and Bill Evans for their technical assistance; to the resourceful Noah Zerkin for helping my first-edition prose escape PageMaker; and Jennifer Barber, Chuck Brandstater, Kate Briggs, Stephanie English, Danny Marcus, Jim Elferdink, and Elizabeth "Eagle Eye" Tonis for their proofreading smarts. Thanks to David Rogelberg for believing in the idea, and above all, to Jennifer, Kelly, and Tia, who make these books—and everything else—possible.

The Missing Manual Series

Missing Manual books are designed to be superbly written guides to computer products that don't come with printed manuals (which is just about all of them). Each book features a handcrafted index; cross-references to specific page numbers (not just "See Chapter 14"); and a promise never to use an apostrophe in the possessive word its. Current and upcoming titles include:

  • iPhoto: The Missing Manual by David Pogue, Joseph Schorr, & Derrick Story

  • Dreamweaver MX: The Missing Manual by David Sawyer McFarland

  • Photoshop Elements 2: The Missing Manual by Donnie O'Quinn

  • Switching to the Mac: The Missing Manual by David Pogue

  • Mac OS X Hints by Rob Griffiths

  • Office X for Macintosh: The Missing Manual by Nan Barber, Tonya Engst, & David Reynolds

  • AppleWorks 6: The Missing Manual by Jim Elferdink & David Reynolds

  • iMovie 2: The Missing Manual by David Pogue

  • Mac OS 9: The Missing Manual by David Pogue

  • Windows XP Home Edition: The Missing Manual by David Pogue

  • Windows XP Pro: The Missing Manual by David Pogue, Craig Zacker, and Linda Zacker


Introduction

Without a doubt, Mac OS X is a stunning technical achievement. In fact, it may be the most advanced personal-computer operating system on earth. But beware its name.

The X is meant to be a Roman numeral, pronounced "ten." Unfortunately, many people see "Mac OS X" and say "Mac O.S. ex." That's a sure way to get funny looks in public.

Then there's the "Mac OS" part—what a misnomer! Mac OS X is not, in fact, the Mac OS. Under the hood, it bears no resemblance whatsoever to the traditional Mac operating system. Apple designed Mac OS X to look something like the old Mac system software, and certain features have been written to work like they used to. But all of that is just an elaborate fake-out. Mac OS X is utterly new, written from scratch. It's not so much Mac OS X, in other words, as Steve Jobs 1.0.

If you've never used a computer before, none of this matters. You have nothing to unlearn. You'll find an extremely simple, beautifully designed desktop waiting for you.

But if you're one of the millions of people who have grown accustomed to Windows or the traditional Mac OS, Mac OS X may come as a bit of a shock. Hundreds of features you thought you knew have been removed, replaced, or relocated. (If you ever find yourself groping for an old, favorite feature, see Appendix C and Appendix D, the "Where'd it go?" dictionaries for former Mac OS 9 and Windows people.)

Why did Apple throw out the operating system that made it famous to begin with? Through the years, Apple kept on piling new features onto a software foundation originally poured in 1984, doing its best to perform nips and tucks to the ancient software to make it resemble something modern. But underneath, the original foundation was beginning to creak, and programmers complained of the "spaghetti code" that the Mac OS had become.

Apple felt that there wasn't much point in undertaking a dramatic system-software overhaul if they couldn't nail every key feature of modern computer technology in the process, especially crash-proofness. Starting from scratch—and jettisoning the system software we'd come to know over the years—was the only way to do it.

The result is an operating system that provides a liberating sense of freedom and stability—but one that, for existing computer fans, requires a good deal of learning (and forgetting).

Most people eventually conclude that the trade-off is well worth making. But in fact, you have little choice. Apple is switching to Mac OS X, and if you expect to remain a Mac user, sooner or later, you will, too.


What Mac OS X 10.2 Gives You

The main thing you gain by moving to Mac OS X is stability. You and your Mac may go for years without ever witnessing a system crash. Oh, it's technically possible for Mac OS X to crash—but few have actually witnessed such an event. Rumors of such crashes circulate on the Internet like Bigfoot sightings. (If it happens to you, turn promptly to Appendix B.)

Underneath the gorgeous, shimmering, translucent desktop of Mac OS X is Unix, the industrial-strength, rock-solid OS that drives many a Web site and university. It's not new by any means; in fact, it's decades old, and has been polished by generations of programmers. That's precisely why Steve Jobs and his team chose it as the basis for the NeXT operating system (which Jobs worked on during his twelve years away from Apple), which Apple bought in 1997 to turn into Mac OS X.

All About "Jaguar"

What's this business about Jaguar?

Most software companies develop their wares in secret, using code names to refer to new products to throw outsiders off the scent. Apple's code names for Mac OS X and its descendants have been named after big cats: Mac OS X was Cheetah, 10.1 was Puma, and 10.2 was Jaguar.

Usually, the code name is dropped as soon as the product is complete. It's generally given a new name by the marketing department. In Mac OS X 10.2's case, though, Apple thought that the Jaguar name was cool enough that it retained the name for the finished product. It even seems to suggest the new system's speed and power. That's why the CD and the box feature Jaguar fur as a design element.

In most countries, the word "Jaguar" even appears on the box—but not everywhere. In the United Kingdom, for example, jaguar fur still appears on the box and the CD, but Apple carefully refrains from using the term Jaguar. That's a result of threatening memos from the automaker. Evidently, Jaguar Cars, Ltd. worries that consumers might be confused and—when shopping for a $75,000 sports car—might walk out with a $130 software kit by mistake.

But crash resistance isn't only the big-ticket item. The list below identifies the highlights, both of Mac OS X itself and of the 10.2 (Jaguar) version. (Apple says it added 150 new features to Mac OS X in Jaguar. The truth is, Apple undercounted.)

  • New desktop features. In addition to the familiar list and icon views, Mac OS X offers something called column view, which lets you burrow deeply into nested folders without leaving a trail of open windows.

    At your option, every desktop window can also display a button-studded toolbar, exactly as in a Web browser. You can install and remove buttons there (frequently used files or programs, for example) just by dragging.

    The Finder (the Mac's desktop world) even offers an Undo command that really works. It can restore to its original folder an icon that you just dragged, for example.

    10.2 news: In version 10.2, the Finder really matured, turning from a squeaky-voiced teenager to a star college athlete. For starters, Apple gave the Finder the one additional feature it sorely needed: speed. It's really fast, especially when starting up, opening windows, and launching programs, including the Classic simulator (more on that in a moment).

    There are lots of other touches, too. The toolbar now has a Forward button, not just Back. When you replace a file with another one of the same name, you're now told whether it's older or newer than the one you're moving, just as in older Mac OS versions and Windows. "Spring-loaded" folders are back. A new icon-view option puts file names to the right of their icons, conserving space. A new, optional second line under an icon's name tells you how many items are in a folder, what the dimensions are of a graphic, and so on. The old Get Info command is back, too, with a few sweet new tricks.

    If you work with the very young or technophobic, you'll appreciate 10.2's ability to hide certain programs and options from certain people. It can even pare itself down to a completely blank desktop (called Simple Finder) with almost no menus at all.

    Finally, there's a new Search bar in every Finder toolbar for searching the window you're in, plus a speedy new system-wide Find command. No longer must you haul the massive, slow Sherlock program to the screen just to search your disk for a file or two.

  • The Dock. At the bottom of the screen, you'll find a row of beautiful, photorealistic icons. This is the Dock, the single most controversial and important new feature in Mac OS X. All at once, it's a launcher, a status display, and an organizational tool. Chapter 3 covers the Dock in astounding detail.

    10.2 news: The Dock's background is now solid rather than striped. But don't think that Apple enhanced the dock with nothing more impressive than a new background—oh, no! It also added (in the Sound panel of System Preferences) the option to play a tiny whoosh sound when you drag something off the Dock.

  • Advanced graphics. What the programmers get excited about is the set of advanced graphics technologies called things like Quartz (for two-dimensional graphics) and OpenGL (for three-dimensional graphics). For the rest of us, these technologies translate into a beautiful, translucent look for the desktop (a design scheme Apple calls Aqua); smooth looking (antialiased) lettering everywhere on the screen; and the ability to turn any document on the screen into an Adobe Acrobat (PDF) file (Section 13.5).

    10.2 news: Mac OS X 10.2 takes the good looks to a new extreme, with subtler colors, more opaque menus, a new "wait" cursor (a spinning beachball, spinning CD, or spinning lollipop, depending on whom you ask), and self-changing desktop pictures (at intervals you specify). A new button makes it even easier to save a document as a PDF file, and 10.2 comes with even more free fonts.

    10.2 also introduces Quartz Extreme, a technology that offloads graphics calculations to your Mac's video card to make them even faster, as well as add visual effects like crossfades and a drop shadow under the cursor. To benefit from Quartz Extreme, your Mac's video card must be on The List (GeForce2 MX, GeForce3, GeForce4 MX, GeForce4 Ti, or any "AGP-based ATI Radeon" card). Unfortunately, this list excludes the white iBooks sold in 2001 and 2002, along with older PowerBooks.

  • Advanced networking. When it comes to hooking up your Mac to other computers, including those on the Internet, few operating systems can touch Mac OS X. It offers advanced features like multihoming, which, for example, lets your laptop switch automatically and invisibly from its cable modem settings to its dial-up modem settings when you take it on the road.

    10.2 news: Macs and Windows PCs can now "see" each other on a network automatically, so that you can open, copy, and work on files on each other's machines as though the age-old religious war between Macs and PCs had never even existed. The new OS also introduces something called Rendezvous, a fledgling technology that, someday, will let programs and hardware add-ons "see" and recognize each other on a network without any setup at all.

  • Lots of accessory programs. Mac OS X comes with a broad array of interesting software. Some, like Mail, you may wind up using every day; others, like the 3-D, voice-activated Chess program, are designed primarily to let you and Apple show off Mac OS X to flabbergasted onlookers.

    10.2 news: In Jaguar, the list of freebies is even longer. Now there's iChat, an AOL-compatible instant-messaging program; iCal, a calendar program that syncs with Palm organizers; and Sherlock 3, which finds useful information on the Web (flight info, movies, stocks, phone numbers, and so on) and even organizes it for you. The existing programs have been beefed up, too—now there's a junk-mail zapper in Mail, page-navigation controls in Preview, a scientific mode (and editable paper-tape option) in the Calculator, a system-wide Address Book, and so on.

  • Simpler everything. Most applications in Mac OS X show up as a single icon. Behind the scenes, they may have dozens of individual software crumbs, just like the programs of Mac OS 9 or Windows—but Mac OS X treats that single icon as though it's a folder. All the support files are hidden away inside, where you don't have to look at them. In other words, to remove a program from your Mac, you just drag the application's single icon to the Trash, without having to worry that you're leaving scraps behind.

  • Voice control, keyboard control. You can operate every menu in every program entirely from the keyboard or—new in 10.2—even by voice. These are terrific timesavers for efficiency freaks.

    10.2 news: Speaking of speaking: Several of 10.2's many new features for the disabled are useful for almost anybody—including the system's ability to read aloud any text in any program. Web pages, email, your novel, you name it. In fact, you can even turn the Mac's spoken performance into an MP3 file, ready to transfer to your iPod music player to enjoy on the road.

  • Tighter Internet integration. Mac OS X makes your Mac more a part of the Internet than it ever has been before. Not only can you treat an iDisk (Section 18.9.3) as though it's an external hard drive, available all the time, but Mac OS X includes the famous and popular Apache Web server. That's Unix software that lets your Mac be a Web site, dishing out Web pages to all comers (Section 21.1.1).

    10.2 news: 10.2 takes Internet features to a new level. For corporate types, Mac OS X now offers virtual private networking, so you can dial into the corporate office securely over the Internet. For economical types, the new Internet Sharing feature lets you share a single Internet connection (like one cable modem or DSL box) with a whole network of Macs. And for safety types, the new Mac OS X firewall keeps your Mac secure from the invasive efforts of Internet no-goodniks.

  • A command-line interface. In general, Apple has completely hidden from you every trace of the Unix operating system that lurks beneath Mac OS X's beautiful skin. For the benefit of programmers and other technically oriented fans, however, Apple left uncovered a couple of tiny passageways into that far more complex realm.

    Chapter 15 and Chapter 16 cover Mac OS X's Unix underpinnings in more depth. For now, it's enough to note that, if you like, you can capitalize on the command-line interface of Mac OS X. That simply means that you can type out cryptic commands, which the Mac executes instantly and efficiently, in an all-text window.

  • If you're splurting your orange juice, outraged at the irony, well, you wouldn't be the first. Apple is, of course, the company who put itself on the map by establishing the superiority of the graphic interface—mouse, icons, menus, and windows. The requirement to type out memorized commands, Apple led us to believe, should die a quick and ugly death. Yet here it is again, in what's supposed to be the world's most modern and advanced operating system.

    Truth is, there's not much harm in it. The command line is completely hidden until you ask for it. It's very useful for programmers, network administrators, and other people for whom the computer is not just an adventure—it's a job.

  • Better hardware integration. In Mac OS X 10.2, Apple cleaned up its act regarding external gadgetry. USB printer sharing is back, so that several Macs on a network can use the same injket printer. Just in case your printer doesn't have a Mac OS X-compatible driver yet, Apple provided CUPS (Common Unix Printer System), a secret configuration page that makes many older printers work with Mac OS X. The Mac can now speak Bluetooth—if equipped with Apple's $50 Bluetooth adapter and some other Bluetooth gadget to speak to, like a Bluetooth-equipped Palm or a Bluetooth cellphone. And the new Energy Saver has special options for laptops—like separate settings for battery and power-cord use.

  • A better installer. The Mac OS X 10.2 installer offers some welcome new options—like a "clean install" option that gives you an all-new, fresh copy of Mac OS X without requiring you to back up your whole Mac.

  • Other 10.2 tweaks. The complete list of changes in Mac OS X 10.2 would fill a book—in fact, you're holding it. But some of the nicest changes aren't so much new features as the removal of bugs and glitches. Macs don't show up in duplicate and triplicate in the Connect to Server window. Icons now stay put on the desktop where you left them. Renaming icons now works as it should. And so on.

    On the other hand, even 10.2 isn't bug-free in the original release. That's why installing the upgrades that occasionally come your way via your Internet connection—10.2.1 and beyond—is an excellent idea.

Mac OS X: the Buzzword-Compliant Operating System

You can't read an article about Mac OS X without hearing certain technical buzzwords that were once exclusively the domain of computer engineers. Apple is understandably proud that Mac OS X offers all of these sophisticated, state-of-the-art operating system features. Unfortunately, publicizing them means exposing the rest of us to a lot of fairly unnecessary geek terms. Here's what they mean:

Preemptive multitasking. Most people know that multitasking means "doing more than one thing at once." The Mac has always been capable of making a printout, downloading a file, and letting you type away in a word processor, all at the same time.

Unfortunately, the Mac OS 7/8/9 (and Windows 95/98/Me) version of multitasking works by the rule of the playground: the bully gets what he wants. If one of your programs insists on hogging the attention of your Mac's processor (because it's crashing, for example), it leaves the other programs gasping for breath. This arrangement is called cooperative multitasking. Clearly, it works only if your programs are in fact cooperating with each other.

Mac OS X's preemptive multitasking system brings a teacher to the playground to make sure that every program gets a fair amount of time from the Mac's processor. The result is that the programs get along much better, and a poorly written or crashing program isn't permitted to send the other ones home crying.

Multithreading. Multithreading means "doing more than one thing at once," too, but in this case it's referring to a single program. Even while iMovie is exporting your movie, for example, it lets you continue editing at the same time. Not all Mac OS 9 programs offered this feature, but all programs written especially for Mac OS X do. (Note, however, that programs that are simply adapted for Mac OS X—"Carbonized" software, as described in Section 4.6—don't necessarily offer this feature.)

Symmetrical multiprocessing. Macs containing more than one processor chip are nothing new. But before Mac OS X, only specially written programs—Adobe Photoshop filters, for example—benefited from the speed boost.

But no more. Mac OS X automatically capitalizes on multiple processors, sharing the workload of multiple programs (or even multithreaded tasks within a single program), meaning that every Mac OS X program gets accelerated. Mac OS X is smart enough to dole out processing tasks evenly, so that both (or all) of your processors are being put to productive use.

Dynamic memory allocation. As noted below, Mac OS X programs no longer have fixed RAM allotments. The operating system giveth and taketh away your programs' memory in real time, so that no RAM is wasted. For you, this system means better stability, less hassle.

Memory protection. In Mac OS X, every program runs in its own indestructible memory bubble—another reason Mac OS X is so much more stable than its predecessors. If one program crashes, it isn't allowed to poison the well of RAM that other programs might want to use, as in Mac OS 9. Programs may still freeze or quit unexpectedly; the world will never be entirely free of sloppy programmers. But in Mac OS 9, you would have seen a message that says, "Save open documents and restart." In Mac OS X, you'll be delighted to find that the message says, "The application 'Bomber' has unexpectedly quit. The system and other applications have not been affected."


What Mac OS X Takes Away

Getting used to the new features is very easy. But if you're used to the old Mac operating system, what's harder is unlearning what you had worked so hard to master. You'll find yourself especially alarmed at how few troubleshooting steps are required—or even possible—in Mac OS X. For example:

  • Extension conflicts. The number one destabilizing factor of the traditional Macintosh has been banished forever: Mac OS X doesn't use system extensions and control panels. It's time to forget all of the troubleshooting routines Mac fans have had to learn over the years, including pressing the Shift key at startup, using Extensions Manager, and buying Conflict Catcher. You will never again perform an extension conflict test, trying to figure out which extension is making your Mac freeze. Those routines have no meaning in Mac OS X.

    Software companies can still add new features to your Mac, just as they once did using extensions—but now they'll do it by writing startup applications, which is a much safer, more organized method that can't destabilize your Mac.

  • Memory controls. There's no Memory control panel in Mac OS X. Nor will you find a Get Info window for each application that lets you change its memory allotment. This is great news.

    Mac OS X manages memory quickly, intelligently, and constantly. The reason you don't allot a certain amount of your Mac's memory to a program, as you had to do in Mac OS 9, is that Mac OS X simply gives each running program as much memory as it needs. And if you undertake some task that requires more memory, Mac OS X instantly gives that program more memory—on the fly.

    So what happens if you're running 125 programs at once? Mac OS X uses virtual memory, a scheme by which it lays down pieces of the programs running in the background onto your hard drive, so that it may devote your actual RAM to the programs in front. But this virtual memory scheme bears very little relationship to the relatively crude, slow virtual memory of the old Mac OS. In Mac OS X, this shuffling happens almost instantaneously, and virtual memory is called in only to park pieces of applications as necessary.

    The bottom line: You can forget everything you knew about concepts like virtual memory, the Disk Cache, the Get Info window's memory boxes for applications, and the panic of getting out-of-memory messages. For the most part, they're gone forever.

  • Rebuilding the desktop. If you don't remember having to perform this arcane procedure on your Mac, you don't know how lucky you are. Unlike Mac OS 9, Mac OS X doesn't have the unfortunate habit of holding onto the icons, in its internal database, of programs long since deleted from your hard drive. As a result, you never have to rebuild that desktop, and you'll never see the symptoms that suggest that it's time for desktop rebuilding (a general slowdown and generic icons replacing the usual custom ones).

  • The [image] menu and Application menu. The menus at the upper corners of the screen, which used to anchor the Mac desktop experience, have been eliminated or changed in Mac OS X. As noted above, the Dock takes on their functions.

    You'll still find an [image] menu in Mac OS X, but it's no longer a place to store aliases of your favorite files and folders. Instead, it lists commands, such as Restart and Shut Down, that are relevant no matter what program you're using.

  • The Control Strip. This handy floating strip of tiles is gone, too. Its replacement is the set of menulets in the upper-right corner of the screen, on the menu bar. This is now where you make quick control panel settings, like adjusting the volume, checking your laptop battery charge, and so on.

  • Icon labels, Encrypt, Put Away, sound recording... As you explore Mac OS X, you'll continue to find—or, rather, not find—Mac OS 9 features that no longer exist. Some are gone for good; for example, there hasn't been much outcry that Button view is no more.

    On the other hand, Apple continues to restore old-standby features with every successive version of Mac OS X. Version 10.2, for example, restores Simple Finder, spring-loaded folders, randomized desktop pictures, and even a version of pop-up windows.

    Finally, remember that some features aren't actually gone—they've just been moved. Before you panic, consult Appendix C for a neat, alphabetical list of every traditional Mac feature and its status in the new operating system.


Three OSes in One

Despite the fact that many individual aspects of the new operating system have been revisited and redesigned to make them simpler, the big Mac OS X picture is actually a bit complex. For the next few years, at least, you'll have to contend with elements of three different operating systems that Apple fused together to make Mac OS X: Something old, something new (and blue), and something borrowed.

  • Unix. As noted above, the very old portion is Unix. (You may also hear the terms Darwin, OpenStep, and NextStep; these are all variations of Unix. NextStep, later renamed OpenStep, was the version adapted by Steve Jobs during his years at NeXT. Much of Mac OS X, in fact, is based on the work done by Jobs and his team at NeXT.)

    Unix is beloved by programmers, it's rock-solid, and it eliminates almost all of the troubleshooting headaches Mac fans once endured. But it's the very antithesis of Macintosh simplicity. Unix couldn't be much more user-hostile: it requires you to type out cryptic commands, for example. The mouse is pretty much irrelevant.

    Fortunately, as noted above, you may never even see it. Apple has almost completely hidden Mac OS X's Unix personality from you, leaving only a few tiny keyholes through which you can peek at it (see Chapter 15).

  • Aqua. What covers up Mac OS X's technical underpinnings is an extremely clean, beautiful operating-system overlay called Aqua. (That's the new and blue part.) This is the look of Mac OS X, in which buttons look like glistening globs of Colgate Very Berry Gel, menus are translucent, and tiny animations seem to make your screen live and breathe.

  • Mac OS 9 (Classic). Only software programs especially written or adapted for Mac OS X benefit from many of Mac OS X's new features, including its stability. This is the bad news about Mac OS X: you need all-new programs to run on it. That's right—you'll have to get upgrades to the new, Mac OS X-tailored versions of Word, Excel, FreeHand, Photoshop, FileMaker, Quicken, and whatever other programs you use.

    That doesn't mean that you can't use the 18,000 existing Macintosh applications, however. The first time you double-click the icon of one these pre-Mac OS X programs each day, you wait about a minute as a special Mac OS 9 emulation program called Classic starts up. In effect, you're running one operating system within another. Your old programs then open, work, and look just as they did in Mac OS 9, but they don't enjoy any of the new Mac OS X features. If a Classic program crashes, for example, the whole Classic bubble crashes (but you still don't have to restart the Mac—just Classic).

    Chapter 5 contains full details about using Classic. For now, resign yourself to the fact that using a Mac OS X, at least for the next couple of years, generally means having to master elements of two different operating systems—the old and the new.

Despite the fact that elements of three different operating systems power Mac OS X, there's no reason to panic. You can safely ignore the Unix part. And even the Mac OS 9 part is transitional. Years from now, when nobody makes anything but Mac OS X-savvy applications, you won't even have to think about the Classic mode.


About this Book

Unfortunately, by way of a printed guide to Mac OS X, Apple provides only a flimsy "getting started" booklet. To find your way around, you're expected to use Apple's online help system. And as you'll quickly discover, these help pages are tersely written, offer very little technical depth, lack useful examples, provide no tutorials whatsoever, and often aren't accessible at all unless you're online. You can't even mark your place, underline, or read it in the bathroom. And there's not a word about the powerful Unix underpinnings of Mac OS X.

The purpose of this book, then, is to serve as the manual that should have accompanied Mac OS X—version 10.2 in particular. You won't find a single page that hasn't changed since the first edition. Not only are the new Jaguar features covered in depth, but you'll also find a great deal of refinement in the discussions of original Mac OS X features: more tips and tricks, clever uses for old ideas, and greater context borne of the passage of time.

This second edition also takes a more inclusive approach. Whereas the original edition was written exclusively for the benefit of former Mac OS 9 fans, this book points out the changes you'll find as you move to Mac OS X from both older Macs and Microsoft Windows.

Mac OS X: The Missing Manual is designed to accommodate readers at every technical level. The primary discussions are written for advanced-beginner or intermediate Mac users. But if you're a first-time Mac user, miniature sidebar articles called Up To Speed provide the introductory information you need to understand the topic at hand. If you're an advanced Mac user, on the other hand, keep your eye out for similar shaded boxes called Power Users' Clinic. They offer more technical tips, tricks, and shortcuts for the more experienced Mac fan.

About the Outline

Mac OS X: The Missing Manual is divided into six parts, each containing several chapters:

  • Part I, The Mac OS X Desktop, covers everything you see on the screen when you turn on a Mac OS X computer: the Dock, icons, windows, menus, scroll bars, the Trash, aliases, the [image] menu, and so on.

  • Part II, Applications in Mac OS X, is dedicated to the proposition that an operating system is little more than a launch pad for programs—the actual applications you use in your everyday work, such as email programs, Web browsers, word processors, graphics suites, and so on. These chapters describe how to work with applications in Mac OS X: how to launch them, switch among them, swap data between them, use them to create and open files, and control them using the AppleScript automation software. This is also where you can find out about using your old, pre-Mac OS X programs (by running the Classic program).

  • Part III, The Components of Mac OS X, is an item-by-item discussion of the individual software nuggets that make up this operating system. These chapters include a guided tour of the System and Applications folders on your hard drive.

  • Part IV, The Technologies of Mac OS X, treads in more advanced topics. Networking, dialing into your Mac from the road, and setting up private accounts for people who share a single Mac are, of course, tasks Mac OS X was born to do—and these chapters show you how to do it. Other chapters cover the prodigious visual talents of Mac OS X (fonts, printing, graphics, handwriting recognition), its multimedia gifts (sound, speech, movies), and the Unix beneath.

  • Part V, Mac OS X Online, covers all the special Internet-related features of Mac OS X, including the built-in Mail email program, the Sherlock Web-searching program, iChat for instant-messaging, Web sharing, Internet sharing, the firewall, and Apple's online .Mac services (which include email accounts, secure file-backup features, Web hosting, and so on). If you're feeling particularly advanced, you'll also find instructions on exploiting Mac OS X's Unix underpinnings for connecting to your Mac from across the wires—FTP, SSH, VPN, and so on.

At the end of the book, you'll find several appendixes. They include two "Where'd it go?" listings, one for traditional Mac features and another for Windows features (to help you find their new locations in Mac OS X); guidance in installing this operating system; a troubleshooting handbook; and a list of resources for further study.

About These Arrows

Throughout this book, and throughout the Missing Manual series, you'll find sentences like this one: "Open the System folder [image] Libraries [image] Fonts folder." That's shorthand for a much longer instruction that directs you to open three nested folders in sequence, like this: "On your hard drive, you'll find a folder called System. Open that. Inside the System folder window is a folder called Libraries; double-click it to open it. Inside that folder is yet another one called Fonts. Double-click to open it, too."

Similarly, this kind of shorthand helps to simplify the business of choosing commands in menus, such as a [image] Dock [image] Position on Left, as shown in Figure P-1.

Figure P-1. In this book, arrow notations help to simplify folder and menu instructions. For example, "Choose Dock Position on Left" is a more compact way of saying, "From the menu, choose Dock ; from the submenu that then appears, choose Position on Left," as shown here.

About MissingManuals.com

If you have an Internet account, visit the www.missingmanuals.com Web site. Click the "Missing CD-ROM" link to reveal a neat, organized, chapter-by-chapter list of the shareware and freeware mentioned in this book. (As noted on the inside back cover, having the software online instead of on a CD-ROM saved you $5 on the cost of the book.)

But the Web site also offers corrections and updates to the book (to see them, click the book's title, then click Errata). In fact, you're invited and encouraged to submit such corrections and updates yourself. In an effort to keep the book as up-to-date and accurate as possible, each time we print more copies of this book, we'll make any confirmed corrections you've suggested. We'll also note such changes on the Web site, so that you can mark important corrections into your own copy of the book, if you like. And we'll keep the book current as Apple releases more Mac OS X 10.2 updates.

In the meantime, we'd love to hear your own suggestions for new books in the Missing Manual line. There's a place for that on the Web site, too, as well as a place to sign up for free email notification of new titles in the series.


The Very Basics

To use this book, and indeed to use a Macintosh computer, you need to know a few basics. This book assumes that you're familiar with a few terms and concepts:

  • Clicking. This book gives you three kinds of instructions that require you to use the mouse that's attached to your Mac. To click means to point the arrow cursor at something on the screen and then—without moving the cursor at all—to press and release the clicker button on the mouse (or your laptop trackpad). To double-click, of course, means to click twice in rapid succession, again without moving the cursor at all. And to drag means to move the cursor while pressing the button.

    When you're told to [image] -click something, you click while pressing the [image] key (which is next to the Space bar). Such related procedures as Shift-clicking, Option-clicking, and Control-clicking work the same way—just click while pressing the corresponding key at the bottom of your keyboard.

  • Menus. The menus are the words at the top of your screen: File, Edit, and so on. (the [image] menu at the top left corner of your screen is a menu, too.) Click one to make a list of commands appear, as though they're written on a window shade you've just pulled down.

    Some people click to open a menu and then release the mouse button; after reading the menu command choices, they click again on the one they want. Other people like to press the mouse button continuously after the initial click on the menu title, drag down the list to the desired command, and only then release the mouse button. Either method works fine.

  • Keyboard shortcuts. If you're typing along in a burst of creative energy, it's sometimes disruptive to have to take your hand off the keyboard, grab the mouse, and then use a menu (for example, to use the Bold command). That's why many experienced Mac fans prefer to trigger menu commands by pressing certain combinations on the keyboard. For example, in most word processors, you can press [image] -B to produce a boldface word. When you read an instruction like "press [image] -B," start by pressing the [image] key; while it's down, type the letter B, and then release both keys.

  • Icons. The colorful inch-tall pictures that appear in your various desktop folders are the icons—graphic symbols that represent each program, disk, and document on your computer. If you click an icon one time, it darkens; you've just highlighted or selected it, in readiness to manipulate it by using, for example, a menu command.

Version 10.2.3 and Beyond

Only a few months after the debut of Mac OS X 10.2, Apple began its traditional flood of system updates: multi-megabyte installers that patch holes, fix bugs, improve compatibility with external gadgets, and make the whole system work more smoothly.

Version 10.2.1, for example, introduced a long list of bug fixes in several broad categories:

Disc Burning Enhancements improve compatibility of burned CDs with Windows and fixes bugs in iTunes CD burning and Disk Utility. The 10.2.1 update also makes the Mac compatible with a long list of new CD burners.

Digital Hub Enhancements fix glitches with certain cameras, scanners, and camcorders, and fix the "mouse and keyboard don't work after waking" problem.

Networking and Mail Enhancements include fixes for various mail-importing, mail-sending, ISP-connecting, and Mac OS X Server problems.

Printing Enhancements remove certain error messages and add more HP printer compatibility.

Miscellaneous Enhancements include fixes for slow Web graphics, Entourage glitches, "ticking hard drive" problems, missing Help files, certain "wake from sleep" irregularities, and certain kernel panics.

Version 10.2.2 was a similar touch-up, featuring stability tweaks to Address Book, iChat, the built-in firewall, Mail, Print Center, Rendezvous, Sherlock, and file sharing with Windows.

The 10.2.3 update of January 2003 offered a few more meaningful fixes (plus a long list of obscure ones). For example, when you burn CDs destined for use on Windows machines, they're no longer cluttered with Mac-specific (and, on the Mac, invisible) files and folders like the Desktop folder. Navigating the columnar Open and Save dialog boxes by keyboard behaves more like it does in Finder list views. And you can drag documents onto the Print Center program icon to print them. (If you drag a folder onto Print Center, you even get a printout of its contents.) Predictably, version 10.2.3 is also compatible with even more CD burners and digital cameras.

You don't have to do anything in particular to get these updates: One day you'll be online with your Mac, and a Software Update dialog box will appear before you, offering you the chance to download and install the patch. Almost always, doing so is a good idea—but be prepared to download corresponding patches for Photoshop, Office, and your other programs.

If you've mastered this much information, you have all the technical background you need to enjoy Mac OS X: The Missing Manual.


Part I: The Mac OS X Desktop

Chapter 1: Folders and Windows

Chapter 2: Organizing Your Stuff

Chapter 3: Dock, Desktop, and Toolbar


Chapter 1. Folders and Windows

    Section 1.1. Getting into Mac OS X

    Section 1.2. Windows and How to Work Them

    Section 1.3. The Three Window Views

    Section 1.4. Icon View

    Section 1.5. List View

    Section 1.6. Column View

    Section 1.7. Logging Out, Shutting Down

    Section 1.8. Getting Help in Mac OS X


1.1 Getting into Mac OS X

When you turn on a Mac with the latest version of Mac OS X, you'll know right away you're not in Kansas anymore. For the first time in the history of the Macintosh, no little smiling-Mac icon appears when you hit the power button. Instead, an Apple logo greets you, soon followed by an animated, liquidy blue progress bar.

1.1.1 Logging In

What happens next depends on whether you are the Mac's sole proprietor or have to share it with other people in an office, school, or household.

  • If it's your own Mac, and you've already been through the Mac OS X setup process described in Appendix A, no big deal. You arrive at the Mac OS X desktop.

  • If it's a shared Mac, you may encounter the Login dialog box, shown in Figure 1-1. Click your name in the list (or type it, if there's no list). Type your password if you're asked for it, and click Log In (or press Return). You arrive at the desktop. Chapter 11 offers much more on this business of user accounts and logging in.

1.1.2 The Elements of the Mac OS X Desktop

Upon first starting up Mac OS X, most people emit (or manage to suppress) two successive gasps. The first is one of amazement, as the shimmering, three-dimensional Mac OS X desktop appears—a new world on an old machine (see Figure 1-2).

The second gasp is one of dismay, which comes upon closer examination of the strangely named folders and icons in the main hard drive window. Don't panic.

Most of the objects on your screen are nothing more than updated versions of the elements made famous by the older Mac OS or Windows. The Mac OS X folder structure may be unfamiliar, but it's not hard to grasp. Here's a quick tour (see Figure 1-2).

NOTE

If your desktop looks absolutely nothing like this—no menus, no icons, almost nothing on the Dock—then somebody in charge of your Mac has turned on Simple Finder mode for you. Details in Section 11.5.

Figure 1-1. Left: On Macs configured to accommodate different people at different times, this is one of the first things you see upon turning on the computer. Click your name. (If the list is long, you may have to scroll to find your name—or just type the first couple of letters of it.) Right: At this point, you're asked to type in your password. Type it and then click Log In (or press Return or Enter; pressing these keys always "clicks" the blue, pulsing button in a dialog box). If you've typed the wrong password, the entire dialog box vibrates, in effect shaking its little dialog-box head, suggesting that you guess again. (See Chapter 11.)
1.1.2.1 Disk icons

Here they are, just where they've always been: the icons of your hard drive and any other disks attached to your Mac. Double-click to open one, as always.

You may notice that icons in Mac OS X are much larger than they were in previous operating systems. You can make them almost any size you like (see Section 1.4), but Apple made them bigger for two reasons. First, in this era of monitors with ever larger resolution, the icons on our screens have been getting ever smaller and more difficult to see.

Second, Apple thinks its Mac OS X icons look really cool.

NOTE

The desktop also includes a folder alias called "Desktop (Mac OS 9)." It's a side effect of the fact that you may be doing a lot of switching back and forth between Mac OS 9 and Mac OS X, at least at first. This folder contains whatever you left sitting out on the desktop when you were working in Mac OS 9. (If you're sure there's nothing important inside, you can throw it away.)

Figure 1-2. The Mac OS X landscape looks like a futuristic version of Windows or the Mac OS. This is just a starting point, however. You can dress it up with a different background picture, adjust your windows in a million ways, and of course fill the Dock with only the programs, disks, folders, and files you care about.
1.1.2.2 The Dock

This ribbon of translucent, almost photographic icons is a launcher for the programs, files, folders, and disks you use often.

In principle, the Dock is very simple:

  • Programs go on the left side. Everything else goes on the right, including documents, folders, and disks. (Figure 1-2 shows the dividing line.)

  • You can add a new icon to the Dock by dragging it there. Rearrange Dock icons by dragging them like tiles on a puzzle. Remove a Dock icon by dragging it away from the Dock, and enjoy the animated puff of smoke that appears when you release the mouse button. (You can't remove the icon of a program that's currently open, however.)

  • Click something once to open it. A tiny triangle underneath a program's icon lets you know that it's open.

  • Each Dock icon sprouts a pop-up menu; a folder can show you what's inside, for example. To see the menu, hold the mouse button down on a Dock icon, or Control-click it, or (if you have a two-button mouse) right-click it.

Because the Dock is such a critical component of Mac OS X, Apple has decked it out with enough customization controls to keep you busy experimenting for months. You can change its size, move it to the sides of your screen, hide it entirely, and so on. Chapter 3 contains complete instructions for using and understanding the Dock.

1.1.2.3 The menu

Though stripped of its stripes, you might say that the [image] menu has finally earned its stripes: It houses important Mac-wide commands that used to be scattered—sometimes illogically—in other menus. For example, the Sleep, Restart, and Shut Down commands now appear here, where they're always available.

Some of the elements are traditional [image] menu items from Mac OS 9, including System Preferences (formerly Control Panels), Recent Items, and About This Mac. Others are new to Mac OS X, including Dock, Location, and Log Out. You'll learn the functions of these commands later in the book. For now, the point is that you can no longer add your own icons to the [image] menu. In Mac OS X, this menu never changes— it looks the same on every Mac OS X computer in the world.

1.1.2.4 The menu bar

If you're used to Mac OS 9, you'll see a few new nuances in Mac OS X menus:

  • They're translucent. You can actually see through an open menu to whatever window is beneath. This feature doesn't particularly help you—in fact, critics claim that it makes the commands in the menu harder to read. But only an operating system with graphics software as powerful as Mac OS X's could even pull off such a sophisticated graphics treat. Consider translucent menus a bit of showoff-ware.

  • They stay down. For years, Macintosh menus remained open for only 15 seconds before snapping closed again. That's because when a menu was open, all other Macintosh activity stopped.

    Mac OS X, however, is multithreaded, which means that it's perfectly capable of carrying on with its background activities while you study its open, translucent menus. Therefore, Mac OS X menus stay open until you click the mouse, press a key, or buy a new computer, whichever comes first.

  • They've been rearranged. The first menu in every program is no longer called File. Like the Application menu that used to appear at the right end of the menu bar, its boldface name tells you at a glance what program you're in. The commands in this new Application menu include About (which tells you what version of the program you're using), Preferences, Quit, and commands like Hide Others and Show All (which help you control window clutter, as described in Section 4.2.3).

    TIP

    Mac OS X offers a new keystroke for hiding the windows of the program you're currently using: -H. That's a great tip when, for example, you're browsing the Web but want to duck back to the desktop for some quick administrative task.

    In short, the Application menu finally makes sense. All of its commands actually pertain to the application you're using.

    The File and Edit menus come next. As in the past, the File menu contains commands for opening, saving, and closing files (see the logic?). The Edit menu contains the Cut, Copy, and Paste commands.

    The last menu is almost always Help. As in the past, it opens a miniature Web browser that lets you search the online Mac Help files for explanatory text (see Section 1.8).

  • You can operate them from the keyboard. For the first time in Macintosh history, you can now operate every menu in every program entirely from the keyboard. You'll find the details in Section 4.4.

Otherwise, aside from the new typeface (Lucida Grande), the menu bar looks and works much like it has in operating systems past.


1.2 Windows and How to Work Them

In designing Mac OS X, one of Apple's key goals was to address the window-proliferation problem. As you create more files, stash them in more folders, and launch more programs, it's easy to wind up paralyzed before a screen awash with cluttered, overlapping rectangles. Mac OS X offers some clever new tools for retaining control.

1.2.1 Title Bar

The title bar has several functions. First, when several windows are open, the darkened window name and light pinstripes tell you which window is active (in front); windows in the background appear dimmed, with translucent, slightly darker-striped title bars. Second, the pinstripes act as a handle that let you move the entire window around on the screen. That's a critical tool in Mac OS X, because you can no longer drag the other three edges of a window to move it.

TIP

Here's a nifty keyboard shortcut that debuted in Mac OS X 10.2: For the first time in Mac history, you can cycle through the different open windows in one program without using the mouse. Just press [image] -~ (that is, the tilde key, to the left of the number 1 key). With each press, you bring a different window forward within the current program. It works both in the Finder and in your everyday programs.

(On the other hand, the [image] -~ keystroke no longer summons the Go To Folder dialog box. The new keystroke for that is Shift- [image] -G.)

After you've opened one folder that's inside another, the title bar's secret folder hierarchy menu is an efficient way to backtrack—to return to the enclosing window. Figure 1-3 reveals everything about the process after this key move: press the [image] key as you click the name of the window. (You can release the [image] key immediately after clicking.)

By choosing the name of a folder from this menu, you open the corresponding window. When browsing the contents of the Users folder, for example, you can return to the main hard drive window by [image] -clicking the folder name Users and choosing Macintosh HD from the menu.

TIP

Keyboard lovers, take note. Instead of using this title bar menu, you can also jump to the enclosing window by pressing [image] -up arrow. Add the Option key if you want to switch into "Old Finder Mode" in the process (see Section 1.2.7).

Pressing [image] -down arrow takes you back into the folder you started in, assuming that it's still highlighted. (This makes more sense when you try it than when you read it.)

Once you've mastered simple dragging, you're ready for these three terrific title bar tips:

  • Pressing the [image] key lets you drag the title bar area of an inactive window—one that's partly covered by a window in front—without bringing it to the front.

    As a matter of fact, depending on the program you're clicking into, you can operate any control in a background window without bringing it to the front—its resize box, buttons, pop-up menus, and even scroll bars. In fact, you can even drag through text without bringing a window forward. In every case, just keeping [image] pressed as you click or drag is the secret.

    NOTE

    Only Cocoa programs, as described in Section 4.6, offer the full range of [image] -clickable controls. In general, programs that have simply been Carbonized respond only to [image] -clicking title-bar elements.

    By the way, you can always close (or minimize or zoom) a background window without the help of the [image] key. Just click its title bar buttons normally. Mac OS X does its thing without taking you out of your current window or program.

  • One more title bar trick: By double-clicking the stripes, you minimize the window, making it collapse into the Dock exactly as though you had clicked the minimize button (Section 1.2.3).

  • The Option key means "apply this action to all windows." For example, Option-double-clicking any title bar minimizes all desktop windows, sending them flying to the Dock.

Figure 1-3. Press and click a window's title bar (top) to summon the hidden folder hierarchy menu (bottom). The Finder isn't the only program that offers this trick, by the way. It also works in most other Mac OS X-compatible programs, and even many Mac OS 9 programs.

1.2.2 Close Button

As the tip of your cursor crosses the three buttons at the upper-left corner of a window, tiny symbols appear inside them: x, -, and +. Ignore the gossip that these symbols were added to help colorblind people who can't distinguish the colors red, yellow, and green; colorblind people are perfectly capable of distinguishing the buttons by their positions, just as they do with traffic lights.

Instead, these cues appear to distinguish the buttons when all three are identical gray, as they are when you use Graphite mode (Section 8.11). They also signal you when it's time to click. For example, as described in the previous section, you can use these three buttons even when the window is not frontmost. You know the buttons are ripe for the clicking when you see the little symbols appear under your cursor.

Figure 1-4. When Steve Jobs unveiled Mac OS X at a Macworld Expo in 1999, he said that his goal was to oversee the creation of an interface so attractive, "you just want to lick it." Desktop windows, with their juicy, fruit-flavored controls, are a good starting point.

The most important window gadget is the close button, the red, droplet-like button in the upper-left corner (see Figure 1-4). Clicking it closes the window, which collapses back into the icon from which it came.

TIP

If, while working on a document, you see a tiny dot in the center of the close button, Mac OS X is trying to tell you that you haven't yet saved your work. The dot goes away when you save the document.

The universal keyboard equivalent of the close button is [image] -W (for window)—a keystroke well worth memorizing. If you get into the habit of dismissing windows with that deft flex of your left hand, you'll find it far easier to close several windows in a row, because you don't have to aim for successive close buttons.

In many programs, something special happens if you're pressing the Option key when using the close button or its [image] -W equivalent: You close all open windows. This trick is especially useful in the Finder, where a quest for a particular document may have left your screen plastered with open windows for which you have no further use. Option-clicking the close button of any one window (or pressing [image] -Option-W) closes all of them.

On the other hand, the Option-key trick doesn't close all windows in every program—only those in the current program. Option- [image] losing an AppleWorks document closes all AppleWorks windows, but your Finder windows remain open. Moreover, Option- [image] losing works only in enlightened applications, such as AppleWorks, Quicken, and the Finder. (In this department, Microsoft is not yet enlightened.)

1.2.3 Minimize Button

Click this yellow drop of gel to minimize any Mac window, sending it shrinking, with a genie-like animated effect, into the right end of the Dock, where it then appears as an icon. The window isn't gone; it hasn't actually closed. It's just out of your way for the moment, as though you've set it down on a shelf. To bring it back, click the newly created Dock icon (see Figure 1-5, and see Chapter 3 for more about the Dock).

Minimizing a window in this way is a great window management tool. In the Finder, minimizing a window lets you see whatever icons were hiding behind it. In a word processor, this technique lets you type up a memo that requires frequent consultation of a spreadsheet behind it.

TIP

If you enjoy the ability to roll up your windows in this way, remember that you actually have a bigger target than the tiny minimize button. The entire striped title bar becomes a giant minimize button when you double-click anywhere on it.

Better yet, you can also minimize a window from the keyboard by pressing [image] -M. That's a keystroke worth memorizing on Day One.

Adjusting the Genie Speed

Apple has a name for the animation you see when you minimize, open, or close a window: the genie effect, because it so closely resembles the way Barbara Eden, Robin Williams, and other TV and movie genies entered and exited their magic lamps and bottles.

But you don't have to watch the "genie" animation precisely the same way, day in and day out. You can slow it down or speed it up like this:

Slow it down. Whenever Steve Jobs does a Mac OS X demo, one of his favorite bits is slowing down the animation so that we can see it in all its graceful, slow motion. How does he do that?

If you Shift-click a window's minimize button, it collapses into the Dock at about one-fifth its usual speed—an effect sure to produce gasps from the onlookers. (Alas, the Control and Control-Shift variations of Mac OS X 10.1 and earlier are no longer in 10.2.) The Shift key also slows down the un-minimizing animation, the one you see when you click a window icon in the dock to restore it to full size.

If you add Shift to the keystroke that opens a disk or folder ( [image] -O), meanwhile, you get a related effect: a very cool, very useless slo-mo window-opening effect. It follows, of course, that if you Shift-click a window's Close button, the window closes painfully slowly. Cool!

Speed it up. There's no keystroke for making the animation go faster. You can, however, substitute a faster style of minimizing animation.

To do so, choose [image] [image] Dock [image] Dock Preferences. From the "Minimize using" pop-up menu, choose Scale Effect, and then close the window. Now, instead of collapsing through an invisible funnel, minimized windows simply shrink as they fly down to the dock, remaining rectangular, requiring less computing by Mac OS X and therefore taking less than a second to disappear.

The minimize button harbors only one hidden feature, but it's very entertaining. If you Option-click it, all windows in the current program shrink away simultaneously—great when you've got several Web browser windows open, for example, or an abundance of word processor documents. (Unfortunately, there's no one-click method for un-minimizing all of the windows in that program. You have to click them one at a time on the Dock.)

Figure 1-5. Clicking the minimize button sends a window scurrying down to the Dock, collapsing in on itself as though being forced through a tiny, invisible funnel. If you collapse a document window in this way (as opposed to a desktop window), a tiny icon appears on the corner of its minimized image to identify the program it's running in.

TIP

Mac OS X's high-horsepower graphics engine can even change menu commands as you press modifier keys. For example, open a couple of Finder windows and then click the Window menu. Focus your eyes on the Minimize Window command. Now press Option and watch both the wording and the listed keyboard equivalent change instantly to Minimize All Windows (Option- [image] -M).

1.2.4 Zoom Button

A click on this green geltab (see Figure 1-4) makes a desktop window just large enough to show you all of the icons inside it. If your monitor isn't big enough to show all the icons in a window, the zoom box resizes the window to show as many as possible. In either case, a second click on the zoom button restores the window to its original size. (The Window [image] Zoom Window command does the same thing.)

TIP

Option-clicking the zoom button doesn't make a Finder window fill the entire screen, as it did in Mac OS 9. But Option-clicking it still works in many Mac OS X applications. (A few, such as OmniWeb, require Shift-clicking it instead.)

1.2.5 The Folder Proxy Icon

Each Finder-window title bar features a small icon next to the window's name (Figure 1-6), representing the open window's actual folder or disk icon. By dragging this tiny icon, you can move or copy the folder to a different folder or disk, to the Trash, or into the Dock without having to first close the window. (If this feature strikes you as unimpressive, you probably never witnessed a hapless Mac novice making repeated attempts to drag an open window into the Trash in, say, System 7.5.)

TIP

When clicking the folder proxy icon, hold down the mouse button for a half second, or until the icon darkens. Only then are you allowed to drag it.

When dragging this proxy icon to a different place on the same disk, the usual folder-dragging rules apply: Hold down the Option key if you want to copy the original disk or folder. Without the Option key, you move the original folder. (You'll find details on moving and copying icons in the next chapter.)

1.2.6 The Finder Toolbar

Chapter 3 describes this fascinating desktop-window element in great detail.

1.2.7 "Old Finder Mode" (Toolbar Disclosure) Button

In the old days, double-clicking any folder opened it into a new window. Double-click three folders, you get three windows. But Mac OS X doesn't work that way. As shown in Figure 1-7, double-clicking a folder makes the original window disappear.

TIP

If you Option-double-click a folder, you don't simply replace the contents of a fixed window that remains on the screen; you actually switch windows, as evidenced by their changing sizes and shapes.

Figure 1-6. When you find yourself confronting a Finder window that contains useful stuff, consider dragging its proxy icon to the Dock. You wind up installing its folder or disk icon there for future use. That's not the same as minimizing the window, which puts the window icon into the Dock, and only temporarily. Most Mac OS X document windows also offer a proxy-icon feature, but produce only an alias when you drag it to a different folder or disk.

So what if you've now opened inner folder B, and you want to backtrack to outer folder A? In that case, just click the tiny left-arrow button labeled Back, shown in Figure 1-7, or use one of these alternatives:

  • Choose Go [image] Back.

  • Press [image] -[ (left bracket).

  • Press [image] -up arrow.

None of that will help you, however, if you want to copy a file from one folder into another, or to compare the contents of two windows. In that case, you'll probably want to see both windows open at the same time.

In such situations, you can open a second window using any of these techniques:

  • Choose File [image] New Finder Window ( [image] -N).

    TIP

    The window that appears when you do this is the Computer window, which usually isn't where you find the folders you want to work with. Changing this setting should be one of your first bits of business in Mac OS X.

    To do so, choose Finder [image] Preferences and click the Home button instead. Now every new Finder window shows you your Home folder (Section 2.1), which contains all of your files—a much more useful arrangement.

  • -double-click a disk or folder icon.

  • Double-click a folder or disk icon on your desktop.

  • Choose Finder [image] Preferences and turn on "Always open folders in a new window." Now when double-clicked, all folders open into new windows. (This is the option for veteran Mac fans who don't care for the new behavior.)

  • Switch to Old Finder Mode, described next.

Figure 1-7. In an effort to help you avoid window clutter, Apple has designed Mac OS X windows so that double-clicking a folder in a window (top) doesn't actually open another window (bottom). Every time you double-click a folder in an open window, its contents replace whatever was previously in the window. If you double-click three folders in succession, you still wind up with just one open window.

"Old Finder Mode," of course, isn't the technical Apple term, but it should be. Here's how it works.

The upper-right corner of every Finder window contains a little button that looks like a half-inch squirt of Crest toothpaste. When you click it, you enter Old Finder Mode. (You can also enter Old Finder Mode by pressing [image] -B, the equivalent for the View [image] Hide Toolbar command.)

In this mode, the two biggest behavioral differences between Mac OS X and its predecessor disappear, to the relief of many Mac old-timers. First, the Finder-window toolbar, shown in Figure 1-4, slides out of sight.

The second big change in Old Finder Mode is that double-clicking a folder now works like it used to. Every time you double-click a folder, you open a new corresponding window.

When you've had enough of Old Finder Mode, you can return to regular Mac OS X mode by clicking the Toolbar Disclosure button again, by pressing [image] -B again, or by choosing View [image] Show Toolbar.

NOTE

You'll find this little white toolbar-control nubbin in a number of toolbar-endowed programs, including Mail, Internet Explorer, System Preferences, and others. Clicking it always makes the toolbar go away.

1.2.8 Scroll Bars

Scroll bars appear automatically in any window that isn't big enough to show all of its contents. Without scroll bars in word processors, for example, you'd never be able to write a letter that's taller than your screen. You can manipulate a scroll bar in three ways, as shown in Figure 1-8.

Multiple Views, Same Folder

If you've read this section carefully, you may have discovered a peculiar quirk of the Mac OS X Finder: By choosing File [image] New Finder Window (or [image] -double-clicking a disk or folder icon), you open a second, completely independent Finder window. If you stop to think about it, therefore, there's nothing to stop you from opening a second, third, or fourth copy of the same folder window. Once they're open, you can even switch them into different views.

Try this, for example: Choose Go [image] Applications. Choose File [image] New Finder Window ( [image] -N), and then choose Go [image] Applications again. Using the View menu or the controls in the toolbar, put one of these windows into list view, and the other into icon view.

This phenomenon has its advantages. For example, you might decide to open the same window twice while doing some hard-drive housekeeping. By keeping a list view open, you can check the Size column as you move your files into different folders (so you can make sure the folders fit onto a blank CD, for example)—but by keeping a column view open, you gain quicker navigational access to the stuff on your drive.

Mac OS X introduces a new scroll bar option called "Scroll to here." Ordinarily, when you click into scroll bar track above or below the gelatinous handle, the window scrolls by one screenful. But your other option is to turn on "Scroll to here" mode in the General panel of your System Preferences (see Section 8.11). Now when you click into scroll bar track, the Mac considers the entire scroll bar a proportional map of the document, and scrolls precisely to the spot you clicked. That is, if you click at the very bottom of the scroll bar track, you see the very last page.

TIP

No matter which scrolling option you choose in the General panel, you can always override your decision on a case-by-case basis by Option-clicking in the scroll bar track. In other words, if you've selected the "Scroll to here" option, you can produce a "jump to next page" scroll by Option-clicking in the scroll bar track.

Figure 1-8. Three ways to control a scroll. The scroll bar arrows (right side) appear nestled together when you first install Mac OS X, as shown here. If you, an old-time Windows or Mac OS 9 fan, prefer these arrows to appear on opposite ends of the scroll bar, visit the General panel of System Preferences, described in Section 8.11.

It's worth noting, however, that the true speed expert eschews scroll bars altogether. Your Page Up and Page Down keys let you scroll up and down, one screen at a time, without having to take your hands off the keyboard to grab the mouse. The Home and End keys, meanwhile, are generally useful for jumping directly to the top or bottom of your document (or Finder window). And if you bought a non-Apple mouse that has a scroll wheel on the top, you can use it to scroll windows, too, without pressing any keys at all.

Figure 1-9. Position your mouse inside a Finder window (list views not included) or even an Internet Explorer window. While pressing and Option, you can drag—and scroll—in any direction. As you drag, the cursor changes shape, becoming a white-gloved butler's hand. Where can you get that kind of service these days?

At first glance, you might assume that scroll bars are an extremely inefficient mechanism when you want to scroll a window diagonally—and you'd be right. Fortunately, Mac OS X includes an alternate scrolling system for such situations. Position your mouse inside a Finder window; while pressing [image] and Option, you can drag—and scroll—in any direction, as shown in Figure 1-9.

1.2.9 Resize Box

The lower-right corner of every standard Mac OS X window is ribbed, a design that's meant to imply that you can grip it by dragging. Doing so lets you resize and reshape the window (see Figure 1-4).

1.2.10 Status Bar

In the days of Mac OS 9, an information strip appeared in every Finder window, just beneath the title bar. It told you how many icons were in the window ("14 items," for example) and the amount of free space remaining on the disk.

When you first run Mac OS X, this information strip is missing. If you long for it, choose View [image] Show Status Bar. This strip now appears in every Finder window (see Figure 1-4)—at least until you hide it again by choosing View [image] Hide Status Bar.

TIP

If the window is very narrow, the status bar shows only the number of icons in the window (such as "1 item"). To see how much free space is on the disk, click the "1 item" text; Mac OS X changes it to show you the remaining free-space statistic. Click again to return to the item count.


1.3 The Three Window Views

You can view the files and folders in a desktop window in any of three ways: as icons, as a single, tidy list, or in a series of neat columns. Figure 1-10 shows the three different views.

How Much Is That Doggie in the Window?

The status bar shows you disk-space information for the entire disk, but not how much disk space this particular window's contents occupy.

To find out that piece of information, make sure that no icon in the window is highlighted. Then choose File [image] Show Info (or press [image] -I). The resulting Info window, which is described in more detail at the end of the next chapter, shows the size of the folder or disk whose window you're browsing, along with other useful statistics.

Every window remembers its view settings independently. You might prefer to look over your Applications folder in list view (because it's crammed with files and folders), but you may prefer to view the less populated Users folder in icon view, where the larger icons are easier to double-click.

To switch a window from one view to another, just click one of the three corresponding icons in the window's toolbar, as shown in Figure 1-10.

If you've hidden the toolbar, you can also switch views by choosing View [image] as Icons (or View [image] as Columns, or View [image] as List).

TIP

In any view (icon, list, or column), you can highlight an icon by typing the first couple letters of its name. In icon or list view, you can also press Tab to highlight the next icon (in alphabetical order), or Shift-Tab to highlight the previous one.

Figure 1-10. From top: The same window in icon view, list view, and column view. Very full folders are best navigated in list or column views, but you may prefer to view emptier folders in icon view, because larger icons are easier to click. Note to Mac OS 9 fans: Button view no longer exists in Mac OS X—or, rather, has turned into the Dock.
    [ Team LiB ]


1.4 Icon View

In an icon view, every file, folder, and disk is represented by a small picture—an icon. This humble image, a visual representation of electronic bits and bytes, is the cornerstone of the entire Macintosh religion. (Maybe that's why it's called an icon.)

1.4.1 Icon View Options

Mac OS X 10.2 introduced some of the most important icon-view options in Macintosh history. All of them are worth exploring. Start by opening any icon-view window, then choose View [image] Show View Options.

1.4.1.1 Choosing icon sizes

Mac OS X draws the little pictures that represent your icons using sophisticated graphics software. As a result, you (or the Mac) can scale them to almost any size without losing any quality or smoothness. You can specify a new icon size either for a single window or for every icon view window on your machine.

In the View [image] Show View Options window (Figure 1-12), complete with an Icon Size slider. Click one of the buttons at the top of the window, either "This window only" or "All windows," to indicate whether you want to change the icon sizes in just the frontmost window or everywhere on the Mac. Finally, drag the Icon Size slider back and forth until you find an icon size you like. (For added fun, make little cartoon sounds with your mouth.)

Figure 1-11. Mac OS X lets you choose an icon size to suit your personality. For picture folders, it can often be very handy to pick a jumbo size, in effect creating a slide-sorter "light table" effect. Just use the slider in the View Options dialog box, shown in Figure 1-12.
1.4.1.2 Text size

Ring the bells! Fire the cannons! At last, Mac OS X fans can control the type size of icon names in the Finder!

In fact, if you choose "This window only" at the top of the palette, you can actually specify a different type size for every window on your machine. Neither Windows nor the Mac OS has ever offered that level of control before. (Why would you want to adjust the point size independently in different windows? You might want smaller type to fit more into a crammed list view without scrolling. The type can afford to be larger in less densely populated windows.)

Your choices range only from 10 to 16 points, and you still can't choose a different font. But for people with especially big or especially small screens—or people with aging retinas—this new 10.2 feature is much better than nothing.

1.4.1.3 Windows XP-style labeling

In its own quiet way, this tiny, unheralded new 10.2 feature represents one of the most radical changes to the Finder since the invention of the Mac. As shown in Figure 1-12, it lets you create, in effect, a multiple-column list view in a single window.

1.4.1.4 "Show item info"

While you've got the View Options palette open, try turning on "Show item info." Suddenly you get a new line of information for each icon, in tiny blue type, saving you the effort of opening up the folder or file to find out what's in it. For example:

  • Folders. The info line lets you know how many icons are inside each one without having to open it up. Spot empties at a glance!

  • Graphics files. Certain other kinds of files may show a helpful info line, too—for example, graphics in most file formats display their dimensions, in pixels. (Alas, JPEG graphics are the exception; their dimensions don't appear, at least in Mac OS X 10.2.1.)

  • Sounds and QuickTime movies. The light-blue bonus line tells you how long the sound or movie takes to play. For example, "02' 49" means two minutes, 49 seconds.

Figure 1-12. Thanks to the beefed-up View Options palette (left), Mac OS X can now display icon names on the right, and even show a second line of file info, in any icon view. You now have all the handy, freely draggable convenience of an icon view, along with the compact spacing of a list view. This is nothing new to people who are used to Windows XP, where this attractive arrangement debuted, but it's a welcome addition to the Mac.

You can see these effects illustrated in Figure 1-12.

1.4.1.5 "Show icon preview"

This option pertains primarily to graphics, which Mac OS X often displays only with a generic icon (stamped JPEG, TIFF, or PDF). But if you turn on "Show icon preview," Mac OS X turns each icon into a miniature display of the image itself, as shown in Figure 1-12.

1.4.1.6 Window backgrounds

Here's another Mac OS X luxury that other operating-system fans can only dream about: You can fill the background of any icon-view window on your Mac with a certain color—or even a photo.

Color-coordinating or "wallpapering" certain windows is more than just a gimmick. On the contrary, it can serve as a time-saving psychological cue. Once you've gotten used to the fact that your main Documents folder has a sky-blue background, you can pick it out like a sharpshooter from a screen filled with open windows. Color-coded Finder windows are also especially easy to distinguish at a glance when you've minimized them to the Dock.

Figure 1-13. The View Options dialog box (left) for an icon view window offers the chance to create colored backgrounds for certain windows (top right) or even to use photos as window wallpaper (lower right). Using a photo may have a soothing, annoying, or comic effect.

NOTE

Background colors and pictures disappear in list or column view, and in windows that "belong" to Mac OS X itself, such as the hard drive window and the Users folder.

Once a window is open, choose View [image] View Options ( [image] -J). The bottom of the resulting dialog box (Figure 1-13) offers three choices:

  • White. This is the standard option.

  • Color. When you click this button, you see a small rectangular button beside the word Color. Click it to open the Color Picker (The Color Picker), which you can use to choose a new background color for the window. (Unless it's April Fool's day, pick a light color. If you choose a dark one—like black—you won't be able to make out the lettering of the icons' names.)

  • Picture. If you choose this option, a Select button appears. Click it to open the Select a Picture dialog box, already open to your Library [image] Desktop Pictures folder. Choose a graphics file (one of Apple's—in the Desktop Pictures folder—or one of your own). When you click Select, you'll see that Mac OS X has superimposed the window's icons on the photo. As you can see in Figure 1-20, low-contrast or light-background photos work best for legibility.

    TIP

    Because you can resize any Finder window at any time, the Mac has no idea what sizes and shapes your window may assume in its lifetime. Therefore, Mac OS X makes no attempt to scale down a selected photo to fit neatly into the window. If you have a high-res digital camera, therefore, you may see only the upper-left corner of a photo as the window background. Use a graphics program to scale the picture down to something smaller than your screen resolution for better results.

1.4.2 Keeping Icons Neat and Sorted

In general, you can drag icons anywhere within a window. For example, some people like to keep current project icons at the top of the window and move older stuff to the bottom.

If you'd like Mac OS X to impose a little discipline on you, however, it's easy enough to request a visit from an electronic housekeeper who tidies up your icons, aligning them neatly to an invisible grid.

NOTE

You can't specify how tight or loose this invisible grid is.

Mac OS X offers an enormous number of variations on the "snap icons to the underlying grid" theme:

  • Aligning individual icons to the grid. Press the [image] key while dragging an icon or several highlighted icons. (Don't press the key down until after you begin to drag.) When you release the mouse, the icons you've moved all jump into neatly aligned positions.

  • Aligning all icons to the grid. Choose View [image] Clean Up (if nothing is selected) or View [image] Clean Up Selection (if some icons are highlighted). Now all icons in the window (or those you've selected) jump to the closest positions on the invisible underlying grid.

    This is a temporary status, however—as soon as you drag icons around, or add more icons to the window, the newly moved icons wind up just as sloppily positioned as before you used the command.

    If you'd rather have icons snap to the nearest underlying grid positions whenever you move them, choose View [image] Show View Options. In the resulting dialog box, turn on "Snap to grid." Make sure the proper button is selected at the top of the window ("This window only" or "All windows"), and then close the window. If your status bar is showing in the window, as described earlier, a small, subtle grid icon appears at its left edge to remind you why your icons are all so neatly aligned.

    NOTE

    You can override the grid setting by pressing the [image] key when you drag. In other words, when grid-snapping is turned off, c makes your icons snap into position; when grid-snapping is turned on, [image] lets you drag an icon freely.

    Note, by the way, that neither of these grid-snapping commands—View [image] Clean Up and the "Snap to grid" option—moves icons into the most compact possible arrangement. If one or two icons have wandered off from the herd to a far corner of the window, they're merely nudged to the closest grid points to their present locations. They aren't moved all the way back to the group of icons elsewhere in the window.

    To make them jump back to the primary cluster, read on.

  • Sorting all icons for the moment. If you choose View [image] Arrange [image] by Name, all icons in the window snap to the invisible grid and sort themselves alphabetically. Use this method to place the icons as close as possible to each other within the window, rounding up any strays. The other subcommands in the View [image] Arrange menu, such as [image] by Size, [image] by Date Modified, and so on, work similarly, but sort the icons according to different criteria. (They're new in Mac OS X 10.2.)

    As with the Clean Up command, View [image] Arrange serves only to reorganize the icons in the window at this moment. Moving or adding icons in the window means you'll wind up with icons out of order. If you'd rather have all icons remain sorted and clustered, try this:

  • Sorting all icons permanently. This arrangement is the ideal solution for neat freaks who can't stand seeing icons out of place. It maintains sorting and alignment of all icons in the window, present and future—if you add more icons to the window, they jump into correct alphabetical position. If you remove icons, the remaining ones slide over to fill in the resulting gap.

    To make it happen, choose View [image] Show View Options. In the resulting dialog box, turn on the "Keep arranged by" checkbox. From the pop-up menu, specify what order you want your icons to snap into. Close the window. As shown at right in Figure 1-14, your icons are now locked into sorted position, as compactly as possible.

Figure 1-14. Use the View Options dialog box (left) to turn on permanent-cleanliness mode (right). A tiny four-square icon (circled) appears just below the window's close button. That symbol is supposed to remind you that you've turned on the Mac's spatial lockjaw feature, so that you don't get frustrated when you try to drag an icon into a new position and discover that it won't budge.

Although it doesn't occur to most Mac users, you can also apply any of the commands described in this section—Clean Up, Arrange, Keep Arranged, and so on—to icons lying loose on your desktop. Even though they're not technically in any window at all, you can specify small or large icons, automatic alphabetical arrangement, and so on. Just click the desktop before using the commands in the View menu.

NOTE

There's only one View Options dialog box. Once it's open on the screen, you can adjust the icon sizes or arrangement options of other windows just by clicking them. Each time you click inside a window, the View Options dialog box remains in front, changing to reflect the settings of the window you clicked. This handy feature may, at first, confuse diehard Mac OS 9 users, who are accustomed to opening a separate View Options dialog box for every Finder window.


1.5 List View

In windows that contain a lot of icons, the list view is a powerful weapon in the battle against chaos. It shows you a tidy table of your files' names, dates, sizes, and so on.

All of the usual file-manipulation tips apply in list view. For example, double- clicking a folder doesn't open a new window (unless you're also pressing the [image] key). Instead, the contents of the folder you double-clicked replace the contents of the window, as described in Section 1.2.7.

You have complete control over your columns. You get to decide how wide they should be, which of them should appear, and in which order (except that Name is always the first column). Here's how to master these columns:

1.5.1 Sorting the List

Most of the world's list view fans like their files listed alphabetically. It's occasionally useful, however, to view the newest files first, largest first, or whatever.

When a desktop window displays its icons in a list view, a convenient new strip of column headings appears (Figure 1-15). The column headings aren't just signposts; they're buttons, too. Click Name for alphabetical order, Date Modified to view newest first, Size to view largest files at the top, and so on. (You can no longer perform the same function using commands in the View menu or by Control-clicking inside a window, as you could in Mac OS 9.)

It's especially important to note the tiny, dark gray triangle that appears in the column you've most recently clicked (Figure 1-15). It shows you which way the list is being sorted.

Figure 1-15. You control the sorting order of a list view by clicking the column headings (left). Click a second time to reverse the sorting order (right). You'll find the identical triangle, indicating the identical information, in email programs, in Sherlock (Chapter 20), and anywhere else where reversing the sorting order of the list can be useful.

When the triangle points upward, oldest files, smallest files, or files beginning with numbers (or the letter A) appear at the top of the list, depending on which sorting criterion you have selected.

TIP

It may help you to remember that when the smallest portion of the triangle is at the top, the smallest files are listed first when viewed in size order. (That's a welcome change from the reversed logic of Mac OS 9 and earlier.)

To reverse the sorting order, just click the column heading a second time. Now newest files, largest files, or files beginning with the letter Z appear at the top of the list. The tiny triangle turns upside-down, as shown in Figure 1-15.

TIP

You can also change the sorting order from the keyboard. Just press Control-Tab to highlight each successive column heading, sorting the list by that criterion in the process. Add the Shift key to move leftward through the column headings.

1.5.2 Flippy Triangles

One of the Mac's most attractive features is the tiny triangle that appears to the left of a folder's name in a list view. In its official documents, Apple calls these buttons disclosure triangles; internally, the programmers call them flippy triangles.

Either way, these triangles are very useful: When you click one, you turn the list view into an outline, in which the contents of the folder are displayed in an indented list, as shown in Figure 1-16. Click the triangle again to collapse the folder listing. You're saved the trouble and clutter of having to open a new window just to view the folder's contents.

By selectively clicking flippy triangles, you can, in effect, peer inside two or more folders simultaneously, all within a single list view window. You can move files around by dragging them onto the tiny folder icons.

TIP

Once you've expanded a folder by clicking its flippy triangle, you can even drag a file icon out of its folder, so that it's loose in the list view window. To do so, drag it directly upward onto the column headings area (where it says Name, for example). When you release the mouse, you'll see that the file is no longer inside the expanded folder.

Figure 1-16. Click a "flippy triangle" (left) to see the list of the folders and files inside that folder (right). Or press the equivalent keystrokes: -right arrow (to open) and -left arrow (to close).

1.5.3 Which Columns Appear

Choose View [image] Show View Options. In the palette that appears, you're offered on/off checkboxes for the different columns of information Mac OS X can show you, as shown in Figure 1-17.

  • Date Modified. This date-and-time stamp indicates when a document was last saved. Its accuracy, of course, depends on the accuracy of your Mac's built-in clock (see Section 8.3).

Figure 1-17. The checkboxes you turn on in the View Options dialog box determine which columns of information appear in a list view window. Most people live full and satisfying lives with only the three default columns—Date Modified, Kind, and Size—turned on. But the other columns can be helpful in special circumstances; the trick is knowing what information appears there.

NOTE

Many an up-to-date file has been lost because a Mac user spotted a very old date on a folder and assumed that the files inside were equally old. That's because the modification date shown for a folder doesn't reflect the age of its contents. Instead, the date on a folder indicates only when items were last moved into or out of that folder. The actual files inside may be much older, or much more recent.

Flippy Triangle Keystrokes

The keystrokes that let you open and close flippy triangles in a list view are worth committing to memory.

First, pressing the Option key when you click a flippy triangle lets you view a folder's contents and the contents of any folders inside it. The result, in other words, is a longer list that may involve several levels of indentation.

If you prefer to use the keyboard, substitute the right- arrow key (to expand a selected folder's flippy triangle) or left-arrow key (to collapse the folder listing again). Here again, adding the Option key expands all levels of folders within the selected one.

Suppose, for example, that you want to find out how many files are in your Pictures folder. The trouble is, you have organized your graphics files within that folder in several category folders. And you realize that the "how many items" statistic in the status bar shows you how many icons are visible in the window. In other words, you won't know your total photo count until you've expanded all the folders within the Pictures folder.

You could perform the entire routine from the keyboard like this: Get to your own Home folder (see Section 2.1) by pressing Option- [image] -H. Select the Pictures folder by typing the letter P. Open it by pressing [image] -O (the shortcut for File [image] Open) or [image] -down arrow. Highlight the entire contents by pressing [image] -A (the shortcut for Edit [image] Select All).

Now that all folders are highlighted, press Option-right arrow. You may have to wait a moment for the Mac to open every subfolder of every subfolder. But eventually, the massive list appears, complete with many levels of indentation. At last, the "items" statistic in the status bar (see Section 1.2.10) gives you a complete, updated tally of how many files are in all of those folders added together.

  • Date Created. This date-and-time stamp shows you when a document was first saved.

  • Size. With a glance, you can tell from this column how much disk space each of your files and folders is taking up in kilobytes, megabytes, or gigabytes—whichever the Mac thinks you'll find most helpful. (There are 1,024 kilobytes in a megabyte.)

    TIP

    For disks and folders, you see only a dash—at first. You can, however, force the Mac to show you their sizes, as described on the facing page.

  • Kind. In this column, you can read what kind of icon each item represents. You may see, for example, Folder, JPEG document, Application, and so on.

  • Version. This column displays the version numbers of your programs. For folders and documents, you just see a dash.

  • Comments. This rarely seen column can actually be among the most useful. Suppose that you're a person who uses the Comments feature (highlight an icon, choose File [image] Get Info, type notes about that item into the Comments box). The option to view the first line of comments about each icon can be very helpful, especially when tracking multiple versions of your documents, as shown in Figure 1-18.

    NOTE

    Unfortunately, the systems for storing comments are different in Mac OS 9 and Mac OS X. When you run Mac OS X, you won't see the icon comments you added in Mac OS 9, and vice versa.

Figure 1-18. The Comments column is often worth turning on. If your monitor is big enough, you can make the Comments column wide enough to show several paragraphs of text, all in a single line—enough to reveal the full life history of each icon. Or you can simply use the Comments window as you once used Labels in Mac OS 9.

1.5.4 Other View Options

The View Options for a list view include several other useful settings (choose View [image] Show View Options, or press [image] -J). As always, be sure to click either "All windows" or "This window only" before closing the window, so that your changes will have the scope of effect that you intended.

  • Icon Size. These two buttons offer you a choice of standard icon size for the current window. You can choose standard size or tiny size; unlike icon view, list view doesn't give you a size slider.

    Even so, Mac OS X improves on Mac OS 9 in this regard: Thanks to the much more powerful graphics software, the tiny icons aren't so small that they show up blank. You still get a general idea of what they're supposed to look like.

  • Text size. As described in Section 1.4, you can change the type size for your icon labels, either globally or one window at a time.

  • Show columns. Turn on the columns you'd like to appear in the current window's list view, as described in the previous section.

  • Use relative dates. In a list view, the Date Modified and Date Created columns generally display information in a format like this: "Saturday, February 2, 2003." (As noted below, the Mac uses shorter date formats as the column gets narrower.) But when the "Use relative dates" option is turned on, the Mac substitutes the word "Yesterday" or "Today" where appropriate, making recent files easier to spot.

  • Calculate all sizes. See Calculate All Sizes.

Calculate All Sizes

When I sort my list view by size, I see only dashes for folder sizes. What am I doing wrong?

Nothing at all; that's normal. When viewing a Finder window, you see a Size statistic for each document. For folders and disks, however, you're shown only an uninformative dash.

Most Mac fans study this anomaly only momentarily, scratch their chins, and then get back to their work. Former Windows users don't even scratch their chins; Windows PCs never show folder-size or disk-size information in a list view.

Here's what's going on: It can take a computer a long time to add up the sizes of all files inside a folder. Your System [image] Library folder alone, for example, contains more than 1,500 files. Instead of making you wait while the Mac does all of this addition, Mac OS X simply shows you a dash in the Size column for a folder.

On occasion, however, you really do want to see how big your folders are. In such cases, choose View [image] Show View Options, turn on "Calculate all sizes," and close the palette. You'll see the folder sizes slowly begin to pop onto the screen, from the top of the window down, as the Mac crunches the numbers of the files within.

In fact, you can even turn on the "Calculate all sizes" option globally—that is, for all windows. In the Mac operating systems of days gone by, this act would have caused a massive slowdown of the entire computer. But remember that Mac OS X is multithreaded—that is, it has the opposite of a one-track mind. It's perfectly capable of devoting all of its attention to calculating your folder sizes and all of its attention to whatever work you're doing in the foreground.

But now consider this anomaly: Suppose you've opted to sort a particular window by folder size—in other words, you've clicked the word Size at the top of the column. Turning on "Calculate all sizes" bewilders the unprepared, as folders arbitrarily begin leaping out of order, forcing the list to rearrange itself a couple of times per second.

What's happening, of course, is that all folders begin at the bottom of the list, showing only dashes in the Size column. Then, as the Mac computes the size of your folders' contents, they jump into their correct sorted order at what may seem to be random intervals.

1.5.5 Rearranging Columns

You're stuck with the Name column at the far left of a window. But you can rearrange the other columns just by dragging their gray column headers horizontally. If the Mac thinks you intend to drop a column to, say, the left of the column it overlaps, you'll actually see an animated movement even before you release the mouse button, as the Mac reshuffles the columns.

1.5.6 Adjusting Column Widths

Place your cursor carefully on the dividing line between two column headings. When the cursor sprouts horizontal arrows from each side, you can drag horizontally. Doing so makes the column to the left of your cursor wider or narrower.

What's delightful about this activity is watching Mac OS X scramble to rewrite its information to fit the space you give it. For example, as you make the Date Modified (or Created) column narrower, "Sunday, February 2, 2003, 2:22 PM" shrinks first to "Sun, Feb 2, 2003, 2:22 PM," to "2/2/03, 2:22 PM," and finally to the terse "2/2/03."

Pop-Up Windows

Help! How do I make pop-up windows in Mac OS X? You know, those little folder tabs that peek up from the bottom of the screen?

Apple figured you wouldn't need them. After all, you can achieve much the same purpose by dragging folders into the Dock (Chapter 3); once there, you can click a folder icon to open it, or view a pop-up list of its contents by Control-clicking it, right-clicking it (if you have a two-button mouse), or just holding the mouse button down on it.

But that's not the real thing. If you do want the real thing, just drag any window to the bottom of the screen, so that only its title bar is showing. (First make the window narrow, if you like, so that its title bar turns into a little tab.) Put a whole row of window "tabs" down there, if you like.

Now you can make one of these tabs pop up in either of two ways. First, drag any file or folder icon off of your desktop, across the title bar, and down. Presto! The window pops open to receive your drag, just like the pop-up windows of Mac OS 9. (Unfortunately, it doesn't collapse again when you release the mouse.)

If you'd rather have it pop up and stay up unaided, just click its green zoom button. The window springs upward and open so you can get to its contents—and then collapses again when you click the green button a second time.

It's not real pop-up windows, but it's close.

If you make a column too narrow, Mac OS X shortens the file names, dates, or whatever by removing text from the middle. An ellipsis (...) appears to show you where the missing text would have appeared. (Apple reasoned that truncating the ends of file names, as in previous versions of the Mac OS, would hide useful information like the number at the end of "Letter to Marge 1," "Letter to Marge 2," and so on. It would also hide the three-letter extensions, such as Thesis.doc, that may appear on file names in Mac OS X.)

For example, suppose you've named a Word document "Madonna—A Major Force for Humanization and Cure for Depression, Acne, and Migraine Headache." (Yes, file names can really be that long.) If the Name column is too narrow, you might see only "Madonna—A Major...Migraine Headache."

TIP

You don't have to make the column mega-wide just to read the full text of a file whose name has been shortened. Just point to the icon's name without clicking. After a moment, a yellow, floating balloon appears—something like a tooltip in Microsoft programs—to identify the full name.

And if you don't feel like waiting, hold down the Option key. As you whip your mouse over truncated file names, their tooltip balloons appear instantaneously. (Both of these tricks work in any view—icon, list, or column.)


1.6 Column View

Icon view and list view should certainly be familiar to anyone who's used a personal computer before. But for most Mac fans, column view is something new—and welcome.

The goal is simple: To create a means of burrowing down through nested folders without leaving a trail of messy, overlapping windows in your wake.

The solution is shown in Figure 1-19. It's a list view that's divided into several vertical panes. The first pane shows all the icons of your disks, including your main hard drive. (The Network icon gives you access to other computers on your office network, if you have one.)

When you click a disk (once), the second pane shows a list of all the folders in it. Each time you click a folder in one pane, the pane to its right shows what's inside. The other panes slide to the left, sometimes out of view. (Use the horizontal scroll bar or the Shift-Tab keystroke to bring them back.) You can keep clicking until you're actually looking at the file icons inside the most deeply nested folder.

If you discover that your hunt for a particular file has taken you down a blind alley, it's not a big deal to backtrack, since the trail of folders you've followed to get here is still sitting there before you on the screen. As soon as you click a different folder in one of the earlier panes, the panes to its right suddenly change, so that you can burrow down a different rabbit hole.

The beauty of column view is, first of all, that it keeps your screen tidy. It effectively shows you several simultaneous folder levels, but contains them within a single window. With a quick [image] -W, you can close the entire window, panes and all. Second, column view provides an excellent sense of where you are. Because your trail is visible at all times, it's much harder to get lost, wondering what folder you're in and how you got there, than in any other window view.

NOTE

Column view is always alphabetical. There's no way to sort the lists by date, for example, as you can in list view.

Figure 1-19. If the rightmost folder contains pictures, sounds, or movies, Mac OS X even lets you look at them or play them, right there in the Finder. If it's a certain kind of text document (AppleWorks or PDF, for example), you actually see a tiny image of the first page. If it's any other kind of document, you see a blowup of its icon and a few file statistics. You can drag this jumbo icon anywhere—into another folder, for example.

Everything Old Is New Again

To many observers, Mac OS X's column view is one of the most radical new features of the operating system. The truth is, however, that it's not new at all.

In fact, column view's most recent ancestor appeared in the NeXT operating system, which Apple bought (along with Steve Jobs, its CEO) in 1997. But column view is even older than that.

As you can see in this sketch from May 1980, the idea of a single-window, multiple-column view has been kicking around at Apple long before the Macintosh debuted.

In the end, this view was deemed too complex for the original Mac, which finally appeared (with only list and icon views) in 1984. It took 17 more years to find its way into the standard Mac OS.

1.6.1 Column View by Keyboard

Efficiency fans can operate this entire process by keyboard alone. For example:

  • You can jump from one pane to the next by pressing the right or left arrow keys. Each press highlights the closest icon in the next or previous pane. (Pressing Tab and Shift-Tab don't work, as they did in 10.1.)

  • You can use any of the commands in the Go menu, or their keyboard equivalents (see Section 2.10.4), to fill your columns with the contents of the corresponding folder—Home, Favorites, Applications, and so on.

  • The Back command (clicking the Back button on the toolbar, pressing [image] -[, or choosing Go [image] Back) works as it does in a Web browser: it retraces your steps backward. You can repeat this command until you return to the column setup that first appeared when you switched to column view. Once you've gone back, in fact, you can then go forward again (choose Go [image] Forward, or press [image] -]).

  • Within a pane, press the up or down arrow keys to highlight successive icons in the list. Or type the first couple of letters of an icon's name to jump directly to it.

  • When you finally highlight the icon you've been looking for, press [image] -O or [image] -down arrow to open it (or double-click it, of course). You can open anything in any column; you don't have to wait until you've reached the rightmost column.

1.6.2 Manipulating the Columns

The number of columns you can see without scrolling depends on the width of the window. In no other view are the zoom and resize controls (Section 1.2) so important.

That's not to say, however, that you're limited to four columns (or whatever fits on your monitor). You can make the columns wider or narrower—either individually or all at once—to suit the situation. Figure 1-20 shows the details.

1.6.3 View Options

Just as in icon and list view, you can choose View [image] Show View Options to open a dialog box—a Spartan one, in this case—offering additional control over your column views.

NOTE

Oddly enough, there's no "This window only" or "All windows" option here. Any changes you make here affect all column views.

  • Text size. Whatever point size you choose here affects the type used for icons in all column views.

  • Show icon. For maximum speed, turn off this option. Now you'll see only file names, not the tiny icons next to them, in all column views.

  • Show preview column. The far-right Preview column (see Figure 1-19) can be handy when you're browsing graphics, sounds, or movie files. The rest of the time, it can get in the way, slightly slowing down the works and pushing other, more useful columns off to the left side of the window. If you turn off this checkbox, the Preview column doesn't appear.

    TIP

    No matter what view you're in, remember this if you ever start dragging an icon and then change your mind: Press the Esc key, even while the mouse button is still down. The icon flies back to its precise starting place. (Too bad real life doesn't have a similar feature.)

Figure 1-20. You can make all the columns wider or narrower simultaneously by dragging any of the small handles (circled) at the bottom of the columns. To make a single column wider or narrower, Option-drag the column handle at the bottom of its right edge.
    [ Team LiB ]


1.7 Logging Out, Shutting Down

If you're the only person who uses your Mac, finishing up a work session is simple. You can either turn off the machine or simply let it go to sleep, in any of several ways.

1.7.1 Sleep Mode

Apple clearly expects its customers not to shut down their machines between sessions; the company has gone to great lengths to make doing so inconvenient. (For example, pressing the Power button on most Mac models no longer offers you the option to shut down.)

That's OK. Sleep mode consumes very little power, keeps everything you were doing open and available, and wakes up almost immediately when you press a key or click the mouse. To make your machine sleep:

  • Choose [image] [image] Sleep.

  • Press Control-Eject (or Control-F12, if you don't have an Eject key). In the dialog box shown in Figure 1-21, click Sleep (or type S).

  • Press the Power button on your machine. On many current models, doing so makes it sleep immediately.

  • Just walk away, confident that the Energy Saver system preference described in Section 8.10 will send the machine off to dreamland automatically at the specified time.

The Go to Folder Command

Sometimes a Unix tentacle pokes through the user-friendly Aqua interface. Every now and then, you find a place where you can use Unix shortcuts instead of the mouse.

One classic example is the Go [image] Go to Folder command (Shift- [image] -G; the keystroke changed Mac in OS X 10.2). It brings up a box like the one shown here.

The purpose of this box is to let you jump to a certain folder on your Mac directly by typing its Unix folder path. Depending on your point of view, this special box is either a shortcut or a detour.

For example, if you want to see what's in the Documents folder of your Home folder, you could choose Go [image] Go to Folder, type this:

/Users/mjones/Documents

Then click Go or press Return. (In this example, of course, mjones is your short account name.)

In other words, you're telling the Mac to open the Users folder in your main hard drive window, then your Home folder inside that, and then the Documents folder inside that. Each slash means, "and then open." (Leaving off the name of your hard drive is optional.) When you press Enter, the folder you specified pops open immediately.

Of course, if you really wanted to jump to your Documents folder, you'd be wasting your time by typing all that. Unix (and therefore Mac OS X) offers a handy shortcut that means, "home folder." It's the tilde character (~) at the upper-left corner of your keyboard.

To see what's in your Home folder, then, you could type just that ~ symbol into the Go To box and then press Return. Or you could add some slashes to it to specify a folder inside your Home folder, like this:

~/Documents

You can even jump to someone else's Home folder by typing a name after the symbol, like this:

~chris

If you get into this sort of thing, here's another shortcut worth noting: If you type nothing but a slash (/) and then press Return, you jump immediately to the Computer window, which provides an overview of all your disks, plus a Network icon.

Note, too, that you don't have to type out the full path—only the part that drills down from the window you're in. If your Home folder window is already open, for example, you can open the Pictures folder just by typing Pictures.

But the Go to Folder trick really turns into a high-octane time-saver if you use tab completion. Here's how it works: After each slash, you can type only enough letters of a folder's name to give Mac OS X the idea—de instead of desktop, for example—and then press the Tab key. Mac OS X instantly and automatically fills in the rest of the folder's name.

For example, instead of typing /applications/Microsoft Office X/clipart/standard, you could type nothing more than /ap/mi/cl/st, remembering to press Tab after each pair of letters. Now that's a way to feel like a Unix programmer!

1.7.2 Restart

You shouldn't have to restart the Mac very often—only in times of severe troubleshooting mystification, in fact. Here are a few ways to do it:

  • Choose [image] [image] Restart. A confirmation dialog box appears; click Restart (or press Enter).

    TIP

    If you press Option as you release the mouse on the [image] [image] Restart command, you won't be bothered by an "Are you sure?" confirmation box.

  • Press Control- [image] -Eject. (If you don't have an Eject key, substitute F12.)

  • Press Control-Eject to summon the dialog box shown in Figure 1-21; click Restart (or type R).

Figure 1-21. Once the Shut Down dialog box appears, you can press the S key instead of clicking Sleep, R for Restart, Esc for Cancel, or Enter for Shut Down.

1.7.3 Shut Down

To shut down your machine completely (when you don't plan to use it for more than a couple of days, when you plan to transport it, and so on), do one of these:

  • Choose [image] [image] Shut Down. A simple confirmation dialog box appears; click Shut Down (or press Enter).

    TIP

    Once again, if you press Option as you release the mouse on the [image] [image] Shut Down command, no confirmation box will appear.

  • Press Control-Option- [image] -Eject. (It's not as complex as it looks—the first three keys are all in a tidy row to the left of the Space bar.)

  • Press Control-Eject (or Control-F12) to summon the dialog box shown in Figure 1-21. Click Shut Down (or press Enter).

1.7.4 Log Out

If you share your Mac, you should log out when you're done. Doing so ensures that your stuff is safe from the evil and the clueless even when you're out of the room. To do it, choose [image] [image] Log Out (or press Shift- [image] -Q). When the confirmation dialog box appears, click Log Out (or press Enter), or just wait for two minutes. The Mac hides your world from view and displays the Sign In dialog box, ready for the next victim.

TIP

Last time: If you press Option as you release the mouse on the [image] [image] Log Out command, you squelch the "Are you sure?" box.

Logging out is described in much more detail in Chapter 11.


1.8 Getting Help in Mac OS X

It's a good thing you've got a book about Mac OS X in your hands, because you certainly won't get much help from Apple.

Balloon Help is gone from Mac OS X. So is Apple Guide. What's left is the standard Help [image] Mac Help command, which you can also summon by pressing [image] -?. You get a Web browser-like program that reads help files in your System folder [image] Libraries folder (see Figure 1-22).

Figure 1-22. The "drawer" at the right side shows the master list of help topics—AirPort Help, AppleScript Help, and so on—of which Mac Help is only one category. In other words, you can actually read the help screens for a program that you haven't yet launched. (Click the Help Center icon to hide or show the "drawer.")

You're expected to find the topic you want in one of these two ways:

  • Use the Ask blank. Type the phrase you want, such as printing or switching applications, into the blank at the top of the window, and then press Return.

    The Mac responds by showing you a list of help-screen topics that may pertain to what you need (see Figure 1-23).

  • Drill down. The starting screen offers several "quick click" topics that may interest you. If so, keep clicking blue underlined links until you find a topic that you want to read.

    As with the Search method, you can backtrack by clicking the Back (left-arrow) button at the bottom of the "browser" window.

Unfortunately, not very many actual Help screens are stored on the Mac itself; often, you'll have to connect to the Internet just to read a help topic. It's not always worth doing, considering the sparse, unhelpful results.

Figure 1-23. The bars indicate the Mac's "relevance" rating—how well it thinks each help page matches your search. Click one to read a short description of the topic at the bottom of the window, or double-click to open the help page. If it isn't as helpful as you hoped, click the Back button (the left-pointing arrow) at the bottom of the window to return to the list of relevant topics. Click the little question-mark button to return to the master Help Center.

The Frozen Help Center

If you've got the initial release of Mac OS X 10.2, you may eventually develop Helpophobia. Not just because the help itself is incredibly sparse, but also because the Help program is crashy, buggy, and slow. Half the time you get nothing but the spinning Mac OS X disc cursor for hours, and then—nothing.

Part of the problem is that many of the Help pages aren't in Mac OS X at all, but are instead stored on the Internet. If it can't get online, the Help program goes frozen.

The other problems have to do with certain files on your Mac; most people manage to get the Help program over its cranky fit by deleting them.

Open your Home folder [image] Library [image] Preferences folder. Throw away anything with both the words apple and help in their names.

This time, opening the Help Center should make you feel much less...helpless.


Chapter 2. Organizing Your Stuff

    Section 2.1. The Mac OS X Folder Structure

    Section 2.2. Icon Names

    Section 2.3. Selecting Icons

    Section 2.4. Moving and Copying Icons

    Section 2.5. Aliases: Icons in Two Places at Once

    Section 2.6. Favorites

    Section 2.7. The Trash

    Section 2.8. Get Info

    Section 2.9. Finding Files 1: The Search Bar

    Section 2.10. Finding Files 2: The Find Program


2.1 The Mac OS X Folder Structure

If you're used to older versions of the Mac OS, switching to Mac OS X means having to unlearn one deeply ingrained habit right away: double-clicking your hard drive icon to get started for the day.

If you do double-click that icon, you'll find folders called Applications, Library, and Users—folders you didn't put there. (If you upgraded an existing Mac to Mac OS X, you'll also see all your original hard drive folders nestled among them.)

Most of these new folders aren't very useful to you, the Mac's human companion. They're there for Mac OS X's own use. Think of your main hard drive window as storage for the operating system itself, to be accessed only occasionally for administrative purposes. (No wonder that in early versions of Mac OS X, Apple didn't put your hard drive icon on the desktop at all. The truth is, double-clicking it gains you very little.)

2.1.1 Your Home Folder

Instead of setting up your nest—your files, folders, aliases, and so on—in the hard drive window, from now on you'll set it up in your Home folder. That's a folder bearing your name (or whatever name you typed when you installed Mac OS X).

One way to find it is to double-click the Users folder, and then double-click the folder inside it that bears your name and looks like a house (see Figure 2-1). Here, at last, is the window that you'll eventually fill with new folders, organize, back up, and so on.

Mac OS X is rife with shortcuts for opening this all-important folder.

  • Choose Go [image] Home.

  • Press Shift- [image] -H.

  • Click the Home icon (the little house) on the toolbar.

  • Click the Home icon on the Dock. (If you don't see one, consult Section 3.2 for instructions on how to put one there.)

All of these steps open your Home folder directly.

So why has Apple demoted your files to a folder three levels deep? The answer may send you through the five stages of grief—Denial, Anger, Bargaining, Depression, and finally Acceptance—but if you're willing to go through it, much of the mystery surrounding Mac OS X will fade away.

Mac OS X has been designed from the ground up for computer sharing. It's ideal for any situation where different family members, students, or workers share the same Mac.

In fact, in Mac OS X, each person who uses the computer will turn on the machine to find his own separate and secure desktop picture, set of files, Web bookmarks, font collection, and preference settings. (You'll find much more about this feature in Chapter 11.)

Like it or not, Mac OS X considers you one of these people. If you're the only one who uses this Mac, fine—simply ignore the sharing features. (You can also ignore all that business at the beginning of Chapter 1 about logging in.) But in its little software head, Mac OS X still considers you an account holder, and stands ready to accommodate any others who should come along.

NOTE

Some Mac fans have noted with dismay that Mac OS X lacks an Encrypt command for protecting individual files. In part, that's because the need for file-by-file privacy isn't quite as critical now that your entire machine environment is protected. Still, if you miss the ability to password-protect individual folders or files, you can use Mac OS X's Disk Copy to do it, as described in Section 9.2.12.

In any case, now you should see the importance of the Users folder in the main hard drive window. Inside are folders—the Home folders—named for the different people who use this Mac. In general, nobody is allowed to touch what's inside anybody else's folder.

If you're the sole proprietor of the machine, of course, there's only one Home folder in the Users folder—named for you. (You can ignore the Shared folder, which is described in Section 11.4.3.)

This is only the first of many examples in which Mac OS X imposes a fairly rigid folder structure. Still, the approach has its advantages. For example, you're not the only one who must live by its rules, as software installers are equally regulated. By keeping such tight control over which files go where, Mac OS X keeps itself pure—and very, very stable. (Other operating systems known for their stability, such as Windows 2000 and Windows XP, work the same way.)

Furthermore, keeping all of your stuff in a single folder makes it very easy for you to back up your work. It also makes life easier when you try to connect to your machine from elsewhere in the office (over the network) or elsewhere in the world (over the Internet), as described in Chapter 21.

Figure 2-1. This is it: the formerly bewildering folder structure of Mac OS X. It's not so bad, really. For the most part, what you care about is the Applications folder in the main hard drive window (top) and your own Home folder (middle and bottom). You're welcome to save your documents and park your icons almost anywhere on your Mac (except inside the System folder or other people's Home folders). But keeping your work in your Home folder makes backing up and file sharing easier.

2.1.2 What's in Your Hard Drive Window

When you first run Mac OS X, you'll find the following folders in the main hard drive window:

  • Applications. The Applications folder, of course, contains the complete collection of Mac OS X programs on your Mac. Even so, you'll rarely launch programs by opening this folder. (The Dock is a far more efficient launcher, as described in the next chapter.)

  • Developer. You'll find this folder only if you, a software programmer, bothered to install the Developer Tools CD. (To find out where you get it, see The Developer Tools CD Extras.)

  • Library. This folder bears more than a passing resemblance to the System Folder subfolders of Mac OSes gone by, or the Windows folder on PCs. It stores components for the operating system and your programs (sounds, fonts, preferences, help files, printer drivers, modem scripts, and so on).

  • System. This is Unix, baby. This is the actual code that turns on your Mac and controls its operations. You'll rarely have any business messing with this folder, which is why Apple made almost all of its contents invisible.

  • Users. As noted earlier, this folder stores the Home folders for everyone who uses this machine.

  • Your old junk. If you've upgraded your Mac from Mac OS 9, your main hard drive window also lists the folders that used to be there.

The Computer Window

As noted in this chapter, the hard drive icon in the upper right doesn't actually do you much good. Opening it reveals only a handful of folders that you can't do anything with.

Another dramatic change is the Computer window. Exactly as in Microsoft Windows, the Computer window holds the icons for all the disks connected to your machine—the hard drive, a CD that you've inserted, an iPod, another external hard drive, and so on—as well as an icon called Network. (The Network icon appears even if you're not, in fact, on a network.) You can open the Computer window either by clicking the Computer icon on the Finder toolbar or by choosing Go [image] Computer (Shift- [image] -C).

This is the topmost level of your Mac, the one Unix fiends call the root level. This is the stuff that can't be put into any folder at all.

So what's it for? In some ways, the Computer window is redundant. After all, Mac OS X automatically puts disk icons at the right side of your screen, just as in Mac OS 9.

But some people, particularly Windows refugees, don't care for that icons-on-the-desktop feature. In the interest of creating a neater, cleaner desktop, they turn it off (by choosing Finder [image] Preferences and turning off the three checkboxes under "Show these items on the Desktop"). In that case, the Computer window still provides access to all of your disks.

If you prefer the icons-on-the-desktop scheme (because you've been using a Mac for years, for example), you'll probably never need the Computer window. You've got your disks on the desktop, and you can access the network from the Go menu (see Section 12.2.2). In that case, you may as well remove the Computer icon from the Finder toolbar to save space and avoid confusion; see Section 3.4.2 for instructions.

2.1.3 What's in Your Home Folder

Within the folder that bears your name, you'll find another set of standard Mac OS X folders. Except as noted, you're free to rename or delete them; Mac OS X creates the following folders solely as a convenience:

  • Desktop. When you drag an icon out of a folder or disk window and onto your Mac OS X desktop, it may appear to show up on the desktop. But that's just an optical illusion, a visual convenience, like an alias; in truth, nothing in Mac OS X is ever really on the desktop. It's actually in this Desktop folder, and mirrored on the desktop area.

    The reason is simple enough: Remember that everyone who shares your machine will, upon logging in, see her own stuff sitting out on the desktop. Now you know how Mac OS X does it: There's a separate Desktop folder in every person's Home folder.

    You can entertain yourself for hours by proving this to yourself. If you drag something out of your Desktop folder, it also disappears from the actual desktop. And vice versa. (You're not allowed to delete or rename this folder.)

    TIP

    The desktop is actually a folder in your Home folder. That's handy, because it gives you a quick and sneaky way to jump to your Home folder from anywhere. Simply click the desktop (the colored one, not the folder) and then press the [image] -up arrow. Because that keystroke always means "open whatever folder contains the one I'm examining," it instantly opens your Home folder. (Your Home folder is, of course, the "parent" of your Desktop folder.)

  • Documents. Apple suggests that you keep your actual work files in this folder. Sure enough, whenever you save a new document (when you're working in AppleWorks or Word, for example), the Save As box proposes storing the new file in this folder, as described in Chapter 4.

    Your programs may also create folders of their own here. For example, you may find a Microsoft User Data folder for your Entourage email, a Palm folder for your palmtop's calendar and phone book data, and AppleWorks User Data folder for certain preferences, and so on.

  • Library. As noted above, the main Library folder (the one in your main hard drive window) contains folders for fonts, preferences, help files, and so on.

    But you have your own Library folder, too, right there in your Home folder. It stores exactly the same kinds of things—but they're your fonts, your preferences, and so on.

    Once again, this setup may seem redundant if you're the only person who uses your Mac. But it makes perfect sense in the context of families, schools, or offices where numerous people share a single machine. Because you have your own Library folder, you can have a font collection that's "installed" on the Mac only when you're using it. Each person's program preference files are stored independently, too (the files that determine where Photoshop's palettes appear, and so on). And each person, of course, sees his own email when launching Mac OS X's Mail program (Chapter 19)—because your mail, too, is stored in your own Library folder.

    Other Library folders store your Favorites (Section 2.6), Internet Search Sites, Web browser plug-ins and cached Web pages, keyboard layouts, sound files, and so on. (It's best not to move or rename this folder.)

  • Movies, Music, Pictures. These folders, of course, are designed to store multi-media files. The various Mac OS X programs that deal with movies, music, and pictures will propose these specialized folders as storage locations. For example, when you plug a digital camera into a Mac OS X computer, the iPhoto program automatically begins to download the photos on it—and stores them in the Pictures folder. Similarly, iMovie is programmed to look for the Movies folder when saving its files, and iTunes stores its MP3 files in the Music folder.

  • Public. If you're on a network, or if others use the same Mac when you're not around, this folder can be handy: It's the "Any of you guys can look at these files" folder. Other people on your network, as well as other people who sit down at this machine, are allowed to see whatever you've put in here, even if they don't have your password. (If your Mac isn't on an office network and isn't shared, you can throw away this folder.) Details on sharing the Mac are in Chapter 11, and those on networking are in Chapter 12.

  • Sites. Mac OS X has a built-in Web server—software that turns your Mac into an Internet Web site that people all over the world can connect to. (This feature is practical only if your Mac is connected to the Internet all the time, via cable modem or DSL, for example.) This Mac OS X feature relies on a program called the Apache Web server, which is so highly regarded in the Unix community that programmers lower their voices when they mention it.

    Details are in Chapter 21. For now, though, note that this is the folder where you will put the actual Web pages you want available to the Internet at large.


2.2 Icon Names

Every document, program, folder, and disk on your Mac is represented by an icon: a colorful little picture that you can move, copy, or double-click to open. In Mac OS X, icons look more like photos than cartoons, and you can scale them to any size (Section 1.4).

Printing a Window—or a List of Files

Hey, in Mac OS 9, I could print a Finder window. I'd get a neat list of the files, which I could use as a label for a CD I was going to burn, or something. How do I print a Finder window in Mac OS X?

You've heard the expression, "This dog don't hunt"? Well, this Finder don't print.

Still, it's easy enough to make a list of files for printing. Once the window is open on your screen, choose Edit [image] Select All. Choose Edit [image] Copy. Now switch to a word processor (or TextEdit) and paste. You get a tidy list of all the files in that window, ready to format and print.

This simple file name list still isn't the same as printing a window, that's true; you don't get the status bar showing how many items are on the disk, and how full the disk is. For that purpose, you can always make a screenshot of the window (Section 13.10), and print that.

Of course, that technique's no good if the list of files is taller than the window itself.

Really, what you want is Print Window, a handy shareware program dedicated to printing out your Finder windows, without any of these workarounds or limitations. You can download it from www.missingmanuals.com.

A Mac OS X icon's name can have up to 256 letters and spaces. If you're accustomed to the 31-character limit of Mac OS 9, that's quite a luxurious ceiling.

If you're used to Windows, you may be delighted to discover that in Mac OS X, you can name your files using letters, numbers, punctuation—in fact, any symbol you want except for the colon (:), which the Mac uses behind the scenes for its own folder-hierarchy designation purposes.

NOTE

Another naming restriction: You can't use a period or a slash to begin a file's name.

To rename a file, begin with one of these two methods:

  • Click once squarely on the icon's name.

  • Click once on the icon, and then press Return or Enter.

Either way, a rectangle now appears around the name (see Figure 2-2). At this point, the existing name is highlighted; just begin typing to replace it. If you type a very long name, the rectangle grows vertically to accommodate new lines of text.

TIP

If you simply want to add letters to the beginning or end of the file's existing name, press the left or right arrow key immediately after pressing Return or Enter. The insertion point jumps to the corresponding end of the file name.

When you're finished typing, press Return, Enter, or Tab—or just click somewhere else—to make the renaming rectangle disappear.

Figure 2-2. Click an icon's name (top left) to produce the renaming rectangle (top right), in which you can edit the file's name. At this point, the existing name is highlighted; just begin typing to replace it (bottom left). When you're finished typing, press Return, Enter, or Tab to seal the deal, or just click somewhere else.

You can give more than one file or folder the same name, as long as they're not in the same folder. For example, you can have as many files named "Chocolate Cake Recipe" as you like, provided each is in a different folder.

As you edit a file's name, remember that you can use the Cut, Copy, and Paste commands in the Edit menu to move selected bits of text around, exactly as though you were word processing. The Paste command can be useful when, for instance, you're renaming many icons in sequence (Quarterly Estimate 1, Quarterly Estimate 2, and so on).

Remember, too, that when the Finder sorts files, a space is considered alphabetically before the letter A. To force a particular folder to appear at the top of a list view window, insert a space before its name.

TIP

Older operating systems sort files so that 10 and 100 actually come before 2, the numbers 30 and 300 come before 4, and so on. You wind up with alphabetically sorted files like this: "1. Big Day," "10. Long Song," "2. Floppy Hat," "20. Dog Bone," "3. Weird Sort," and so on. Generations of computer users have learned to put zeros in front of their single-digit numbers just to make the sorting look right.

In Mac OS X, though, you get exactly the numerical list you'd hope for: "1. Big Day," "2. Floppy Hat," "3. Weird Sort," "10. Long Song," and "20. Dog Bone." At long last, you can get out of the habit of putting zeros in front of file names to make them sort properly.


2.3 Selecting Icons

To highlight a single icon in preparation for printing, opening, duplicating, or deleting, click the icon once with the mouse. (In a list or column view, as described in Chapter 1, you can also click on any visible piece of information about that file—its size, kind, date modified, and so on.) The icon darkens, and its name turns blue (or whichever color you've chosen, as described in Section 8.11).

Long and Short File Names

Hey, what's the deal with long file names? I thought this was the big deal in Mac OS X! But I tried saving an AppleWorks document, and it didn't let me use more than 31 letters!

It's true that you can assign a very long name to a file in the Finder. But you may soon discover that pre-Mac OS X programs, and even programs that have been rewritten (Carbonized) to run in Mac OS X, still limit you to 31 letters when naming a new document in the Save As dialog box.

Over time, software companies may get with the program and rejigger their software to overcome this anachronistic glitch. For now, though, all is not lost.

Even though you can use only 31 letters when saving a new document from, say, AppleWorks or Internet Explorer, you're welcome to rename the file in the Finder, using all 256 characters Mac OS X permits. When you reopen the document in the original program, you'll see an abbreviated name in the title bar (a file that, at the desktop, is called My Visit to Bill Gates's House, and Why I'll Take the Apple Bumper Sticker Off my Car Next Time opens into AppleWorks as something like My Visit to Bill Gates's H#B6C5).

The good news is that behind the scenes, Mac OS X still remembers its long name. Even if you edit and re-save the document, you'll still find its long file name intact when you view its icon on the desktop.

That much may seem obvious. But most first-time Mac users have no idea how to manipulate more than one icon at a time—an essential survival skill in a graphic interface like the Mac's.

To highlight multiple files in preparation for moving or copying, use one of these techniques:

  • To highlight all the icons. To select all the icons in a window, press [image] -A (the equivalent of the Edit [image] Select All command).

  • To highlight several icons by dragging. You can drag diagonally to highlight a group of nearby icons, as shown in Figure 2-3. In a list view, in fact, you don't even have to drag over the icons themselves—your cursor can touch any part of any file's row, such as its modification date or file size.

    TIP

    If you include a particular icon in your diagonally dragged group by mistake, [image] -click it to remove it from the selected cluster.

  • To highlight consecutive icons in a list. If you're looking at the contents of a window in list view or column view, you can drag vertically over the file and folder names to highlight a group of consecutive icons, as described above.

    Mac OS X, however, offers a faster way to do the same thing: Click the first icon you want to highlight, and then Shift-click the last file. All the files in between are automatically selected, along with the two icons you clicked. Figure 2-4 illustrates the idea.

    This technique is a change from the Mac operating system of years gone by, but it makes perfect sense. It mirrors the way Shift-clicking works in a word processor and in many other kinds of programs.

  • To highlight random icons. If you want to highlight only the first, third, and seventh icons in a window, for example, start by clicking icon No. 1. Then [image] -click each of the others (or [image] -drag new rectangles around them). Each icon darkens to show that you've selected it.

    If you're highlighting a long string of icons and then click one by mistake, you don't have to start over. Instead, just [image] -click it again, so that the dark highlighting disappears. (If you do want to start over from the beginning, you can deselect all selected icons by clicking any empty part of the window.)

    The [image] key trick is especially handy if you want to select almost all the icons in a window. Press [image] -A to select everything in the folder, then [image] -click any unwanted icons to deselect them.

Figure 2-3. You can highlight several icons simultaneously by dragging a box around them. To do so, drag from outside of the target icons (left) diagonally across them (right), creating a transparent gray rectangle as you go. Any icons touched by this rectangle are selected when you release the mouse. If you press the Shift or key as you do this, any previously highlighted icons remain selected.

TIP

In icon views, you can also Shift-click (rather than [image] -click) to select multiple individual icons. But because Shift-clicking has a different purpose in list and column views, as described above, you may as well just learn to use the [image] key when selecting individual icons. That way, you won't have to use a different key in each view.

Once you've highlighted multiple icons, you can manipulate them all at once. For example, you can drag them en masse to another folder or disk by dragging any one of the highlighted icons. All other highlighted icons go along for the ride. This technique is especially useful when you want to back up a bunch of files by dragging them onto a different disk, or when you want to delete them all by dragging them to the Trash.

Figure 2-4. Left: To select a block of files in list view, click the first one. Middle: While pressing Shift, click the last one; Mac OS X highlights all the files in between your clicks. Right: To remove one of the icons from your selection, -click it.

When multiple icons are selected, the commands in the File and Edit menus—such as Duplicate, Open, and Make Alias—apply to all of them simultaneously.

TIP

Don't forget that you can instantly highlight all the files in an open window by choosing Edit [image] Select All (or by pressing [image] -A)—no icon clicking required.


2.4 Moving and Copying Icons

In Mac OS X, there are two ways to move or copy icons from one place to another: by dragging them, or by using the Copy and Paste commands.

2.4.1 Copying by Dragging

You can drag icons from one folder to another, from one drive to another, from a drive to a folder on another drive, and so on. (When you've selected several icons, drag any one of them; the others tag along.) While the Mac is copying, you can tell that the process is still under way even if the progress bar is hidden behind a window, because the icon of the copied material shows up dimmed in its new home, darkening up only when the copying process is over. You can cancel the copying process by pressing either [image] -period or the Esc key.

TIP

If you're copying files into a disk or folder that already contains items with the same names, Mac OS X asks you individually about each one. ("An older item named "Fiddlesticks" with extension '.doc' already exists in this location.") Note that, thank heaven, Mac OS X 10.2 tells you whether or not the version you're replacing is older or newer than the one you're moving. (Versions 10.0 and 10.1 didn't.)

Click Replace or Don't Replace, as you see fit, or Stop to halt the whole copying business.

Selecting Icons from the Keyboard

For the speed fanatic, using the mouse to click an icon is a hopeless waste of time. Fortunately, you can also select an icon by typing the first couple letters of its name.

When looking at your home window, for example, you can type M to highlight the Movies folder. And if you actually intended to highlight the Music folder instead, press the Tab key to highlight the next icon in the window alphabetically. Shift-Tab highlights the previous icon alphabetically. Or use the arrow keys to highlight a neighboring icon.

(In Mac OS X 10.2, the Tab-key trick works only in icon and list views. It no longer works in column view, alas.)

After highlighting an icon in this way, you can manipulate it using the commands in the File menu or their keyboard equivalents: open ( [image] -O), put it into the Trash ( [image] -Delete), Get Information ( [image] -I), duplicate ( [image] -D), or make an alias, as described later in this chapter ( [image] -L). By turning on the special disability features described in Section 8.26.4, you can even move the highlighted icon using only the keyboard.

If you're a first-time Mac user, you may find it excessively nerdy to memorize keystrokes for functions the mouse performs perfectly well. If you make your living using the Mac, however, the speed and efficiency of these keystrokes will reward you immeasurably for memorizing them.

Understanding when the Mac copies a dragged icon and when it just moves the icon bewilders many a beginner. However, the scheme is fairly simple (see Figure 2-5) when considering the following:

  • Dragging from one folder to another on the same disk moves the icon.

  • Dragging from one disk (or disk partition) to another copies the folder or file.

    TIP

    You can drag icons either into an open window or directly onto a disk or folder icon.

  • Option-dragging it copies the icon instead of moving it. Doing so within a single folder produces a duplicate of the file called "[Whatever its name was] copy."

  • Dragging an icon from one disk to another while pressing [image] moves the file or folder, in the process deleting it from the original disk. (Press [image] just after you start to drag.)

    This last trick is a dramatic change from the Mac OS 9 era, where you could never move an icon to a different disk. You had no choice but to manually delete the original from your hard drive after dragging it to the second disk.

    Mac OS X frees you from this kind of housekeeping task forever.

Figure 2-5. Top: Dragging an icon to a different disk (or disk partition) produces a copy of that file. You wind up with two copies, one on each disk (unless you press c). Bottom: Dragging it to a different folder or window on the same disk just moves the icon. You wind up with a single copy in a new location.

Dragging to Copy a Disk

Help! I'm trying to copy a CD onto my hard drive. But when I drag it onto the hard drive icon, I get only an alias—not a copy of the CD. I used to do this all the time in Mac OS 9, but I can't make it work now.

Apple switched some things around in Mac OS X. Sure enough, dragging a disk onto a disk creates an alias now.

But producing a copy of the dragged icon is easy enough: Just press Option as you drag.

2.4.2 Copying by Using Copy and Paste

Dragging icons to copy or move them probably feels good because it's so direct: You actually see your arrow cursor pushing the icons into the new location.

But you pay a price for this satisfying illusion: You may have to spend a moment or two fiddling with your windows to create a clear "line of drag" between the icon to be moved and the destination folder.

There's a better way. Use the Copy and Paste commands to move icons from one window into another (just as you can in Windows, by the way—except you can only copy, not cut, Mac icons). The routine goes like this:

  1. Highlight the icon or icons you want to move.

    Use any of the techniques described in Section 2.3.

  2. Choose Edit [image] Copy.

    Or press the keyboard shortcut: -C.

    TIP

    You can combine steps 1 and 2 by Control-clicking an icon and choosing the Copy command from the contextual menu that appears. (If you've selected several icons, say five, the command will say "Copy 5 items.")

  3. Open the window where you want to put the icons. Choose Edit [image] Paste.

    Once again, you may prefer to use the keyboard equivalent: -V. And once again, you can also Control-click inside the window and then choose Paste from the contextual menu that appears.

A progress bar may appear as Mac OS X copies the files or folders; press Esc or [image] -period to interrupt the process. When the progress bar goes away, it means you've successfully transferred the icons, which now appear in the new window.

2.4.3 Spring-Loaded Folders: Dragging Icons into Closed Folders

In its never-ending quest to create the longest list of window-management tools on earth, Apple came up with a powerful one called spring-loaded folders. It was a great feature in Mac OS 9, it was sorely missed in Mac OS X 10.0 and 10.1, and it's very welcome back in 10.2.

Here's a common dilemma: you want to drag an icon not just into a folder, but into a folder nested inside that folder. This awkward challenge would ordinarily require you to open the folder, open the inner folder, drag the icon in, and then close both of the windows you had opened. As you can imagine, the process is even messier if you want to drag an icon into a sub-subfolder or even a sub-sub-subfolder.

Instead of fiddling around with all those windows, you can instead use the spring-loaded folders feature (see Figure 2-6). It works like this: With a single drag, drag the icon onto the first folder—but keep your mouse button pressed. After a few seconds, the folder window opens automatically, centered on your cursor. Still keeping the button down, drag onto the inner folder; its window opens, too. Now drag onto the inner inner folder—and so on. (If the inner folder you intend to open isn't visible in the window, you can scroll by dragging your cursor close to any edge of the window.)

Figure 2-6. Top: To make spring-loaded folders work, start by dragging an icon onto a folder or disk icon. Don't release the mouse button. Wait for the window to open automatically around your cursor. Bottom: Now you can either let go of the mouse button to release the file in its new window, or drag onto yet another, inner folder. It, too, will open. As long as you don't release the mouse button, you can continue until you've reached your folder-within-a-folder destination.

TIP

You can even drag icons onto disks or folders whose icons appear in the Finder toolbar (Chapter 3). They spring open just like regular folders, giving you a terrific drag-and-drop way to file a desktop icon without having to start your drag all the way out at, say, the Macintosh HD icon.

When you finally release the mouse, all the windows except the last one close automatically. You've neatly placed the icon into the core of the nested folders.

NOTE

Longtime Mac fans should note that the second half of the old spring-loaded folder feature, the click-and-a-half, still doesn't work in Mac OS X 10.2. That is, you can't open a folder within a folder by double-clicking and then holding down the button as you point to one folder after another, just to see what's inside. You must actually drag an icon.

2.4.4 Making Spring-Loaded Folders Work

That spring-loaded folder technique sounds good in theory, but can be disconcerting in practice. For most people, the long wait before the first folder opens is almost enough wasted time to negate the value of the feature altogether. Furthermore, when the first window finally does open, you're often caught by surprise. Suddenly your cursor—mouse button still down—is inside a window, sometimes directly on top of another folder you never intended to open. But before you can react, its window, too, has opened, and you find yourself out of control.

Fortunately, you can regain control of spring-loaded folders using these tricks:

  • Choose Finder [image] Preferences. Adjust the "Spring-loaded folders and windows" slider to a setting that drives you less crazy. For example, if you find yourself waiting too long before the first folder opens, drag the slider toward the Short setting.

  • You can turn off this feature entirely by choosing Finder [image] Preferences and turning off the "Spring-loaded folders and windows" checkbox.

  • Tap the Space bar to make the folder spring open at your command. That is, even with the Finder [image] Preferences slider set to the Long delay setting, you can force each folder to spring open when you are ready by tapping the Space bar as you hold down the mouse button. True, you need two hands to master this one, but the control you regain is immeasurable.

    TIP

    The Space bar trick works even when "Spring-loaded folders and windows" checkbox (in Finder [image] Preferences) is turned off. That's a handy arrangement, because it means that folder windows will never pop open accidentally.

  • Whenever a folder springs open into a window, twitch your mouse cursor up to the newly opened window's title bar or information strip. Doing so ensures that your cursor won't wind up hovering on, and accidentally opening up an inner folder. With the cursor parked on the info strip, you can take your time to survey the newly opened window's contents, and plunge into an inner folder only after gaining your bearings.

    TIP

    Mail programs like Entourage and Mail have spring-loaded folders, too! You can drag a message out of the list and onto one of your filing folders, wait for the folder to spring open and reveal its subfolders, and then drag directly into one of them.


2.5 Aliases: Icons in Two Places at Once

Highlighting an icon and then choosing File [image] Make Alias (or pressing [image] -L), generates an alias, a specially branded duplicate of the original icon (see Figure 2-7). It's not a duplicate of the file—just of the icon; therefore it requires negligible storage space. When you double-click the alias, the original file opens. Because you can create as many aliases as you want of a single file, aliases let you, in effect, stash that file in many different folder locations simultaneously. Double-click any one of them, and you open the original icon, wherever it may be on your system.

Designing Your Own Icons

You don't have to be content with the icons provided by Microsoft, Apple, and whoever else wrote your software. You can paste new icons onto your file, disk, and folder icons to help you pick them out at a glance.

The easiest way to replace an icon is to copy it from another icon. To do so, highlight the icon, choose File [image] Get Info, click the existing icon in the resulting window, and then choose Edit [image] Copy. (Close the Info window, if you like.)

Now click the icon to which you want the copied picture transferred. Once again, choose File [image] Get Info. Click the icon in the dialog box and this time choose Edit [image] Paste.

If you'd rather introduce all-new icons, you're welcome to steal some of the beautifully designed ones at www.iconfactory.com and the icon sites linked to it. Once you've downloaded these special icon files, you can copy their images from the Get Info window exactly as you would any icon.

To design a Mac OS X icon from scratch, you could, of course, use a graphics program like Photoshop, the painting module of AppleWorks, or shareware like GraphicConverter. (Remember to make your new icons 128 pixels square.) But sooner or later, you'll want to finish up in Iconographer (available at www.missingmanuals.com), which saves the result in the icns format required by Mac OS X.

Once you've saved your icon file, select it, choose File [image] Get Info, and then copy and paste its icon as described above.

Note that you can't change certain folder icons that Mac OS X considers important, such as Applications or System. (You can, however, change the special Mac OS X folder icons in your Home folder—Pictures, Documents, and so on, and even your hard drive icon.) You're also not allowed to change icons that belong to other people who share this Mac and sign in under a different name (Chapter 11).

TIP

You can also create an alias of an icon by Option- [image] -dragging it out of its window. (Aliases you create this way lack the word alias on the file name—a distinct delight to those who find the suffix redundant and annoying.) You can also create an alias by Control-clicking a normal icon and choosing Make Alias from the contextual menu that appears.

Figure 2-7. Top: You can identify an alias by the tiny arrow badge on the lower-left corner. (Longtime Mac fans should note that the name no longer appears in italics.) Bottom: If the alias can't find the original file, you're offered the chance to hook it up with a different file.

2.5.1 What's Good about Aliases

An alias takes up almost no disk space, even if the original file is enormous. Aliases are smart, too: Even if you rename the alias, rename the original file, move the alias, and move the original, double-clicking the alias still opens the original icon.

And that's just the beginning of alias intelligence. Suppose you make an alias of a file that's on a removable disk, such as a Zip disk. When you double-click the alias on your hard drive, the Mac requests that particular disk by name. And if you double-click the alias of a file on a different machine on the network, your Mac attempts to connect to the appropriate machine, prompting you for a password (see Chapter 12)—even if the other machine is thousands of miles away and your Mac must dial the modem to connect.

In Mac OS X, aliases aren't nearly as important as they once were. There's less call for creating aliases of programs you use frequently, for example, because now you can just drag those programs' icons onto your Dock or Finder toolbar, as described in the next chapter. The Mac OS X versions of the Recent Items, Recent Folders, and Startup Items features no longer depend on aliases, either.

Still, aliases can be handy in Mac OS X. For example:

  • You still may want to file a document you're working on in several different folders, or place a particular folder in several different locations.

  • The Favorites command (see Section 2.6) relies on aliases. By choosing Go [image] Favorites, you open a window that reveals the aliases of every icon you've ever designated as a Favorite, so that you can delete, move, or rename them.

  • You can use the alias feature to save you some of the steps required to access another hard drive on the network. (Details on this trick in Chapter 12.)

  • Put an alias of your Documents folder (which is inside your Home folder) on the Dock. After all, this is the folder where most people spend the majority of their time. It's very silly to have to burrow four folders deep every time you want to find it. (You may as well put your Home folder on the Dock, too.)

  • It's extremely useful to put aliases of your Mac OS 9 programs into the Applications folder, so that they appear listed among the Mac OS X programs. Otherwise, you'll have to maintain your programs in two separate folders, arbitrarily separated by whether they're old or new.

    TIP

    Mac OS X makes it easy to find the file to which an alias "points" without actually having to open it. Just highlight the alias and then choose File [image] Show Original ( [image] -R). Mac OS X immediately displays the actual, original file, sitting patiently in its folder, wherever that may be.

2.5.2 Broken Aliases

An alias doesn't contain any of the information you've typed or composed in the original. Don't burn an alias of your slide show onto a CD and then depart for the airport, hoping to give the presentation upon your arrival in Tokyo. When you double-click the alias, now separated from its original, you'll be shown the dialog box at bottom in Figure 2-7.

If you're on a plane 3,000 miles away from the hard drive on which the original file resides, click Delete Alias (to delete the orphan alias you just double-clicked) or OK (to do nothing, leaving the orphaned alias where it is).

In certain circumstances, however, the third button—Fix Alias—is the most useful of all. Click it to summon the Fix Alias dialog box, which you can use to navigate your entire Mac. When you click a new icon and then click Choose, you associate the orphaned alias with a different original icon.

Such techniques become handy when, for example, you click your book manuscript's alias on the desktop, forgetting that you recently saved it under a new name and deleted the older draft. Instead of simply showing you an error message that says "'Enron Corporate Ethics Handbook' can't be found," the Mac displays the box that contains the Fix Alias button. By clicking it, thus re-associating it with the new document, you can save yourself the trouble of creating a new alias. From now on, double-clicking your manuscript's alias on the desktop opens the new draft.

TIP

You don't have to wait until the original file no longer exists before choosing a new original for an alias. You can perform alias reassignment surgery any time you like. Just highlight the alias icon and then choose File [image] Get Info. In the Get Info dialog box, click Select New Original. In the resulting window, find and double-click the file you'd now like to open whenever you double-click the alias.


2.6 Favorites

After years of watching Microsoft pilfer great ideas from the Mac OS, Apple decided that two could play that game—and it stole a feature right back. The File [image] Add to Favorites command ( [image] -T) places the names of icons you've highlighted into the Go [image] Favorites command, as shown in Figure 2-8. The Favorites scheme, therefore, is yet another mechanism that lists your favorite files, folders, programs, disks, and even network-accessible folders for quick access—much like the Dock.

Figure 2-8. Suppose there's a program or document to which you'd like quick access. Highlight its icon (top) and choose File Add to Favorites (or press -T). From now on, that item will appear in your Go Favorites submenu (bottom).

Nor is the Go menu the only place Favorites are listed. You'll also see your personal Favorites list show up whenever you open or save a file, or click the Favorites icon on your Finder toolbar.

This feature relies on a special folder inside your Home [image] Library folder called, reasonably enough, Favorites. Every time you use the Add to Favorites command, the Mac puts an alias of the highlighted icon into this Favorites folder. (If you share your Mac, nobody else sees your Favorites. Mac OS X keeps track of each person's Favorites folder independently.)

This behind-the-scenes transaction is worth knowing about, if only because it offers the sole method of removing or renaming something from the Go [image] Favorites listing. That is, choose Go [image] Favorites [image] Go To Favorites (or press Shift- [image] -F) to open the Favorites window; throw away or rename any of the aliases in it; and then close the window. The Go [image] Favorites submenu updates itself instantly.


2.7 The Trash

No single element of the Macintosh interface is as recognizable or famous as the Trash can, which now appears at the end of the Dock.

You can discard almost any icon by dragging it onto the Trash icon (which looks more like a wastebasket than a trash can, but let's not quibble). When the tip of your arrow cursor touches the Trash icon, the little wastebasket turns black. When you release the mouse, you're well on your way to discarding whatever it was you dragged. As a convenience, Mac OS X even replaces the empty-wastebasket icon with a wastebasket-filled-with-crumpled-up-papers icon, to let you know there's something in there.

TIP

Learn the keyboard alternative to dragging something to the Trash: highlight the icon and then press [image] -Delete. This technique is not only far faster than dragging, but requires far less precision, especially if you have a large screen. Mac OS X does all the Trash-targeting for you.

2.7.1 Rescuing Files and Folders from the Trash

File and folder icons sit in the Trash forever—or until you choose Finder [image] Empty Trash, whichever comes first.

If you haven't yet emptied the Trash, you can open its window by clicking the wastebasket icon once. Now you can review its contents: icons that you've placed on the waiting list for extinction. If you change your mind, you can rescue any of these items by dragging them out of the Trash window.

TIP

If dragging something to the Trash was the last thing you did, you can press [image] -Z—the keyboard shortcut of the Edit [image] Undo command. This not only removes it from the Trash, but also returns it to the folder from whence it came. This trick works even if the Trash window isn't open.

2.7.2 Emptying the Trash

If you're confident that the items in the Trash window are worth deleting, use any of these three options:

  • Choose Finder [image] Empty Trash.

  • Press Shift- [image] -Delete. It's not as hard to remember as it looks, because it's the same keystroke you use to throw an icon into the Trash— [image] -Delete—with the Shift key added.

  • Control-click the wastebasket icon (or just click it and hold the mouse button down for a moment); choose Empty Trash from the contextual menu.

    TIP

    This last method has two advantages. First, it doesn't bother asking "Are you sure?" (If you're clicking right on the Trash and choosing Empty Trash from the pop-up menu, it's pretty darned obvious you are sure.) Second, this method nukes any locked files without making you unlock them first.

If you use either of the first two methods, the Macintosh asks you to confirm your decision (see Figure 2-9). Click OK.

Figure 2-9. Top: Your last warning. Mac OS X doesn't tell you how many items are in the Trash or how much disk space they take up. Bottom: The Get Info window for a locked file. Locking a file in this way isn't military-level security by any stretch—any passing evildoer can unlock the file in the same way. But it does trigger a "You do not have sufficient privileges" warning when you try to put it into the Trash, providing at least one layer of protection against mistakes.

Either way, Mac OS X now deletes those files from your hard drive. In cases of desperation, a program like Norton Utilities can resurrect deleted files, if used promptly after the deletion. In even more dire cases, DriveSavers (www.drivesavers.com) and similar companies can use sophisticated clean-room techniques to recover crucial information—for several hundred dollars, of course.

2.7.3 Locked Files: The Next Generation

By highlighting a file or folder, choosing File [image] Get Info, and turning on the Locked checkbox, you protect that file or folder from accidental deletion (see Figure 2-9). But that much is old news to Mac veterans.

What's new is that the Locked checkbox is smarter in Mac OS X than it once was. Mac OS X doesn't even let you put a locked icon into the Trash. (In the old days, it only objected if you tried to empty the Trash.) You can't put the icon of an open program into the Trash, either.

If something that's already in the Trash turns out to be locked, click and hold on the Trash itself. Now, when you choose Empty Trash from its contextual pop-up menu, Mac OS X empties the Trash without warnings, locked files and all.

Of course, the other alternative is to unlock what's in the Trash. Fortunately, there's a quick way to do so. Click the Trash icon to open its window, then highlight the icons you want to unlock (or choose Edit [image] Select All).

Now press [image] -I (or choose File [image] Get Info). Turn off the Locked checkbox in the resulting Info window. (Yes, you can lock or unlock a mass of files at once.) Now you can send the newly unprotected files to data heaven without any fancy tricks.

(If you're still having trouble emptying the Trash, see Chapter 16 for some helpful Unix commands.)


2.8 Get Info

By clicking an icon and then choosing File [image] Get Info, you open an important window like the one shown in Figure 2-10. It's a collapsible, multi-panel screen that provides a wealth of information about a highlighted icon. For example:

  • For a disk icon, you get statistics about its capacity and how much of it is full.

  • For a document icon, you see when it was created and modified, and what programs it "belongs" to.

  • For an alias, you learn the location of the actual icon it refers to.

  • If you open the Get Info window when nothing is selected, you get information about the desktop itself, including the amount of disk space consumed by everything sitting on it.

  • If you highlight a gaggle of icons all at once, the Get Info window shows you precisely how many you highlighted, breaks it down by type ("23 documents, 3 folders," for example), and adds up the total of their file sizes. This is a great opportunity to change certain file characteristics on numerous files simultaneously, such as locking or unlocking them, hiding or showing their file name extensions (Section 4.3.3), changing their ownership or permissions (Section 11.4), and so on.

2.8.1 Uni-window vs. Multi-window

In Mac OS X versions 10.0 and 10.1, a single Info window remained on the screen all the time as you clicked one icon after another. (Furthermore, the command was called Show Info instead of Get Info. Evidently "Show Info" sounded too much like it was the playbill for a Broadway musical.)

Figure 2-10. Top: The Get Info window appears at first like this, with the information panels "collapsed." Bottom: Click each flippy triangle to open its corresponding panel of information. The resulting dialog box can easily grow taller than your screen (it's shown here split in half because the book isn't tall enough). That's a good argument for either (a) closing the panels you don't need at any given moment or (b) running out to buy a really gigantic monitor.

The single info window was great for reducing clutter, but it didn't let you compare the statistics for the Get Info windows of two or three folders side by side.

In 10.2, Apple has returned to the old way of doing Get Info: A new dialog box appears each time you get info on an icon.

But the uni-window approach is still available for those occasions when you don't need side-by-side Get Info windows—if you know the secret. Highlight the icon and then press Option- [image] -I (or hold down Option and choose Show Inspector from the File menu). The Get Info window that appears looks normal, but changes to reflect whatever icon you now click, as it did in 10.1.

2.8.2 The Get Info Panels

Below the icon and basic statistics, the Get Info window generally offers a series of collapsed "flippy triangles," as shown in Figure 2-10. Click a triangle to expand a corresponding information panel.

Depending on whether you clicked a document, program, disk, alias, or whatever, this pop-up menu's commands may include the following:

  • General. Here's where you can view (and edit) the name of the icon, and also see its size, creation date, most recent change date, Locked status, and so on. If you click a disk, this info window shows you its capacity and how full it is. If you click the Trash, you see how much stuff is in it. This is the panel that's always open the first time you summon the Get Info window.

  • Name & Extension. On this screen, you can read and edit the name of the icon in question. The "Hide extension" checkbox refers to the suffix on Mac OS X file names (the last three letters of Letter to Congress.doc, for example).

    As described in Section 4.3.2, many Mac OS X documents, behind the scenes, have file name extensions of this kind—but Mac OS X comes factory set to hide them. By turning off this checkbox, you can make the suffix reappear for an individual file. (Conversely, if you've elected to have Mac OS X show all file name suffixes, this checkbox lets you hide file name extensions on individual icons.)

  • Content index. As noted at the end of this chapter, Mac OS X has a new Find program capable of locating files based on the words inside them, regardless of the actual names of the files. It can perform this magic only in folders that have been indexed (The Indexing Catch), however. This panel lets you know when a folder was last indexed, and allows you to index the folder manually or to delete the existing index file to save disk space.

  • Memory. You'll see this option only when showing info for Classic programs (those that haven't been updated for Mac OS X). There are three different memory statistics: Suggested Size (the software company's official recommendation), Minimum Size (below which the program won't even run—a number you shouldn't change), and Preferred Size. This final number is the one you should feel free to adjust, arming the program with more memory if it seems unstable in your Classic world (Chapter 5).

  • Open with. This is available for documents only. Use the controls on this screen to specify which program will open when you double-click this document, or all documents of this type. (Details in Section 4.3.4.1.)

  • Preview. On this panel, you see a handsome, very large thumbnail image. In the case of spreadsheets, word processing documents, HTML documents, and so on, this is nothing to write home about—you see only a magnified version of the generic document icon.

    But when you're examining pictures, text files, PDF files, sounds, clippings, and movies, this feature can be extremely useful. As you click each icon, you see a magnified thumbnail version of what's actually in that document. A controller lets you play sounds and movies, where appropriate.

  • Ownership & Permissions. This is available for all kinds of icons. If other people have access to your Mac (either from across the network or when logging in, in person), this panel lets you specify who is allowed to open or change this particular icon. See Chapter 12 for a complete discussion of this hairy topic.

  • Comments. Here, you can type in random comments for your own reference. Later, you can view these remarks in any list view, as illustrated in Section 1.5.2.

    TIP

    Although Mac OS X lacks the handy icon labels feature of Mac OS 9, you can simulate the same effect using Comments. Once again, the illustration in Section 1.5.2 clarifies this.

Here and there, you may even see other panels in the Get Info window, especially when you get info on application icons. For example, iPhoto offers a Plugins panel that lets you manage add-on software modules; some programs offer a Languages panel; and so on.


2.9 Finding Files 1: The Search Bar

In Mac OS X 10.2, Apple has radically redesigned the way you hunt down lost files and folders. In fact, you now have two different search tools—and neither one is Sherlock, the trusty file-finding tool of Mac OS 9.

The first one, the Search bar (Figure 2-11), is especially convenient because you can opt to have it appear at the top of every Finder window, all the time, ever ready to help you ferret out a stray icon. After 18 years, the Finder's name is finally justified.

If you don't see this little round-ended box at the top of every Find window, then check these conditions, all of which are described in the Finder toolbar discussion beginning in Section 3.4:

  • Your Finder toolbar must, in fact, be visible (see Section 3.4.1).

  • The window must be wide enough to reveal the Search bar.

  • The Search bar must be on the toolbar to begin with (Section 3.4.2).

If all is well, and the Search bar is staring you in the face, here's how to use it.

  1. Open the window you want to search. Click inside the Search bar.

    (Unfortunately, there's no keystroke to make your insertion point jump into the bar.)

    You're about to search in this window and all folders inside it. In other words, the window you open now will define the uncrossable borders for your little Jaguar search elves.

    TIP

    There's nothing to stop you from opening your Home folder, or even the hard drive window itself, and using the Search bar to search your entire Mac.

  2. Type a few letters of the file or folder name you're seeking.

    For example, if you're trying to find a file called Poké;mon Fantasy League.doc, typing just pok or leag would probably suffice.

  3. Press Return or Enter.

    A Search Results window opens, revealing, item by item, a list of the files and folders whose names contain what you typed in step 2 (see Figure 2-12).

    While the searching is going on, the "sprocket" icon whirls away in the upper-left corner. If a search is taking a long time, you're free to switch into another program. Meanwhile, the Find program keeps working in the background.

    Or, to pause or cancel the search in progress, click the [image] button above the right-side scroll bar. (The other X button, the one next to the search word you typed, means "clear this box so I can type a different word.")

    Once you've halted the search in this way, you can click the [image] icon above the scroll bar to resume the original search.
Figure 2-11. The Search bar is a kind of software sieve that lets you screen out the rabble in a folder window filled with files.

NOTE

If you share your Mac with other people, as described in Chapter 11, you'll generally see only the files that belong to you. The Find program mostly ignores the files and folders that other people have created.

There are exceptions, however. For instance, you'll be able to find files and folders that have been explicitly put into the Public or Shared folders, as described in Chapter 12. You may also be able to see icons that are sitting in other people's Home folders that haven't been further filed into inner folders (like the Documents folder).

2.9.1 What to Do With Search Results

You can manipulate the list of search results much the way you'd approach a list of files in a standard Finder list view window. You can move up or down the list by pressing the arrow keys, scroll a "page" at a time with the Page Up and Page Down keys, and so on. You can also highlight multiple icons simultaneously, exactly as you would in a Finder list view: Highlight all of them by choosing Edit [image] Select All, highlight individual items by [image] -clicking them, drag diagonally to enclose a cluster of found items, and so on.

Or you can proceed in any of these ways:

2.9.1.1 Find out where something is

If you click once on any item in the results list, the bottom half of the window becomes a folder map that shows you where that item is. Depending on how tall the window is, you may see either of the two notations illustrated in Figure 2-12 (a ladder-like display or an arrow notation like the one in this book, as in "Users [image] Chris").

Figure 2-12. Top: The upper half of the window lists the files that Mac OS X found. The lower part offers the path, or map, that shows you exactly where the highlighted found icon is filed. You can drag the horizontal divider between the halves of this window upward or downward to adjust the relative sizes of the panes. Bottom: If the bottom half of the window is tall enough, the folder-path notation takes this ladder-like, less compressed form.

For example, in Figure 2-12, the notation in the bottom half of the window (read from bottom to top) means: "The AppleWorks 6 icon you found is in the AppleWorks 6 folder, which is in the Applications folder, which is on the hard drive called Macintosh HD."

To get your hands on the actual icon, choose File [image] Open Enclosing Folder ( [image] -R). The Search Results window retreats to the background, as Mac OS X highlights the actual icon in question, sitting there in its window wherever it happens to be on your hard drive.

2.9.1.2 Open the file (or open one of the folders it's in)

If one of the found files is the one you were looking for, double-click it to open it (or highlight it and press [image] -O). In many cases, you'll never even know or care where the file was—you just want to get into it.

You can also double-click to open any of the folders that appear in the folder map in the bottom half of the window. For example, in Figure 2-12, you could double-click the AppleWorks 6 icon to open it, or the Applications folder to open it, and so on.

2.9.1.3 Move or delete the file

You can drag an item directly out of the found-files list and into a different folder, window, or disk—or straight to the Trash. The folder map at the bottom of the window updates itself to reflect the file's new location.

2.9.1.4 Rename the file

You can even rename a file in the Search Results window, just as though it's sitting in a Finder list view window. Click its name once, wait for the renaming rectangle to appear, and then type over the old name.

2.9.1.5 File-menu commands

After highlighting an icon (or icons) in the list of found files, you can use the commands in the File menu, including Get Info and Move to Trash.

2.9.1.6 Adjust the list

By clicking the column headings, you can sort the list of found files in various ways: by name, size, date, and so on. (You can reverse the order by clicking the same heading a second time.) You can also make the window bigger by dragging the lower-right corner handle, adjusting the relative widths of the columns by dragging the column-name dividers, or rearranging the columns horizontally by dragging their names. All of this works exactly as it does in a Finder list view window.

2.9.1.7 Copy a file

To copy a file, Option-drag it out of the Search Results window and onto the desktop, into a different window, or onto a disk or folder icon. Alternatively, highlight the file and then choose Edit [image] Copy "Bunion Treatments.doc" (or whatever the file's name is). Then click inside a folder window, or click a folder itself, before choosing Edit [image] Paste.

2.9.1.8 Make an alias

You can make an alias for one of the found items exactly the way you would in a Finder window: drag it out of the window while pressing [image] -Option. The alias appears wherever you release the mouse (on the desktop, for example).

2.9.1.9 Start over

If you'd like to repeat the search using a different search phrase, back out of your search results and return to the window where you began the search. Just click the Back button in the toolbar, or press [image] -[ (left bracket).

2.9.1.10 Give up

If none of these avenues suits your fancy, you can simply close the Search Results as you would any other window ( [image] -W).


2.10 Finding Files 2: The Find Program

The Search bar is simple, fast, and above all, convenient. It's always there, happy to serve you, no matter what Finder window you're in.

It's not, however, the most powerful search program on earth. It searches only for icons' names, not their sizes, dates, and so on. And it can't look for words inside your files.

There is a program that can perform these more complex searches, though; in fact, no modern self-respecting operating system would be without it. But here's a bit of news that may shock veteran Mac and Windows users: In Mac OS X 10.2, you don't search your own machine using the same program you use to search the Web. (Heresy! Scandal! Sacrilege!)

Actually, it's a move to be applauded. Over the years, be-all, end-all search programs like Apple's Sherlock and Microsoft's Search Assistant had become slow, sluggish, ungainly creatures that didn't do either job especially well. In Mac OS X 10.2, you use one program just for finding files on your Mac, and a different one (Sherlock 3) to search the Internet. (More on Sherlock in Chapter 21.)

To meet the new file-finding tool, choose File [image] Find (or press [image] -F). The shockingly simple dialog box shown in Figure 2-13 appears next.

As you'll soon discover, the Find program can hunt down icons using extremely specific criteria. If you spent enough time setting up the search, you could actually use this program to find a document whose name begins with the letters Cro, is over one megabyte in size, was created after 8/1/02 but before the end of the year, was changed within the last week, has the file name suffix .doc, and contains the phrase "attitude adjustment." (Of course, if you knew that much about a file, you'd probably know exactly where it is, too, without having to use the Find program. But you get the picture.)

To use the Find program, you need to feed it two pieces of information: where you want it to search, and what to look for. You can make both of these criteria as simple or complex as you like.

Figure 2-13. The first time you use it, the new Find program opens up ready to search by file name and file content, as shown here, because those are the most common kinds of search. But don't settle—Find has many more tricks up its software sleeve.

2.10.1 Where to Look

The pop-up menu at the top of the window lets you specify where you want Find to do its searching. Your choices are:

  • Everywhere. Not much ambiguity here. You want to round up every file with a certain name (or containing certain text), wherever it may be on your Mac, your iDisk (Section 18.9.3), or even on your network.

  • Local disks. You're saying, "I just want to search my own machine. I don't care about the network, Internet-based disks, or whatever."

  • Home. Home refers to your own Home folder (Section 2.1). Now you're rooting through only your own stuff. As a result, the search is much faster, since you're not wasting time searching through, for example, your software programs and Mac OS X's own system files.

  • Specific places. If you know that the file you're trying to find is in a certain folder, or on a certain disk, drag the folder or disk's icon directly into the "Specific places" list. Mac OS X will confine its search to these items, as shown in Figure 2-14.

Figure 2-14. To limit (and thereby speed up) a search, you can drag a folder, or set of folders, directly off the desktop and into the list of folders and disks. (Alternatively, click the Add button above the list.) The folder names appear there, marked with checkboxes that you can turn on or off. In fact, they'll still be listed here the next time, and every time, you open the Find program—until you drag them out of the window to the Trash can, or highlight them and then click the Remove button above the list.

2.10.2 What to Look For

The first time you open the Find program after turning on your Mac OS X 10.2 machine, two boxes appear that need filling in: "File name" and "content" (that is, words inside the files). It also offers little + buttons; more on these in a moment.

But those are only starting points. In all, Find lets you define a search using up to eight different criteria (date modified, file size, and so on). Figure 2-15 illustrates exactly how detailed this kind of search can be.

Figure 2-15. Using the "Add criteria" pop-up menu at the bottom of the Find window, you can limit your search to files that were created before or after a certain date, that are larger or smaller than a certain size, that were created by a specific program, and so forth. Turn on as many criteria as you'd like; each additional row further narrows the search. (The "Add criteria" pop-up menu gets shorter and shorter as you "use up" its options.)

To add one to the list, choose from the "Add criteria" pop-up menu at the bottom of the Find window. A new row appears in the Find window, where you can specify what date, what file size, and so on.

To delete a row from the Find window, click the - button at the right side of the window.

TIP

Sometimes, a bit of planning and maneuvering is required to make exactly the right criteria rows appear. Suppose, for example, that the standard "file name" row appears in the box, as shown in Figure 2-14, but you want to round up only files larger than about 50 megabytes.

First you would add the "size" row (by choosing "size" from the "Add criteria" pop-up menu), and type 50000 into its "KB" box. Then you'd delete the "file name" row by clicking its round - button. (Or you'd just leave the "file name" box blank.)

Here's a rundown of the eight kinds of information you can search for, as they appear in the "Add criteria" pop-up menu.

2.10.2.1 File name

To find a file whose name you know, just type a few letters of its name into the "file name" blank. (Capitalization doesn't matter.)

Of course, if all you want to do is find files whose names include Sales, you may as well save yourself all of this reading and use the Search bar described in the previous section. But using the Find program instead offers you far more control, thanks to the pop-up menu that offers you these options:

  • Contains. The position of the letters you type doesn't matter. If you type then, you'll find files with names like "Then and Now," "Authentic Cajun Recipes," and "Lovable Heathen."

  • Starts with. The Find program will find only files beginning with the letters you type. If you type then, you'll find "Then and Now," but not "Authentic Cajun Recipes" or "Lovable Heathen."

  • Ends with. If you type then, you'll find "Lovable Heathen," but not files called "Then and Now" or "Authentic Cajun Recipes."

    TIP

    This is one way to round up all files of a certain type, using their file name extensions as a "hook." For example, searching for .jpg would round up all your JPEG digital camera pictures. (Fortunately, the Find program will find them even if the suffixes are hidden as described in Section 4.3.3.)

  • Is. This option doesn't bother finding files whose names contain the phrase you type. It finds only files named precisely what you type. Typing then won't find any of the file names in the previous examples. It would unearth only a file called simply "Then." (In fact, a file with a file name suffix, like "Then.doc," doesn't even qualify.)

2.10.2.2 Content

Sooner or later, it happens to everyone: a file's name doesn't match what's inside it. Maybe a marauding toddler pressed the keys while playing KidPix, inadvertently renaming your doctoral thesis "xggrjpO#$5%////." Maybe, in a Saturday afternoon organizing binge, your spouse helpfully changed the name of your "ATM Instructions" document to "Cash Machine Info," little realizing that it was a help file for Adobe Type Manager. Or maybe you just can't remember what you called something.

For this purpose, Find can search for words inside your files, regardless of their names (see Figure 2-16). It performs this kind of search with amazing speed, and has saved thousands of Mac fans hours of frustrated searching by hand; just type the word or phrase you seek into the "content includes" box.

Figure 2-16. Searching for the words inside your files produces a column called Relevance to the found-files list. Longer bars indicate more relevance; relevance is defined as "how many times the search term appears relative to the whole document's length." In other words, a four-word file containing the search term "lizard" twice has higher relevance than one containing "lizard" three times in a 500-word essay.

TIP

If a Content search doesn't unearth a file you think it should have, consider the possibility that Mac OS X hasn't yet caught up indexing your files, as described in the box on the next page.

2.10.2.3 Date created, date modified

These options let you search for files according to when you first created them or when you last saved them.

Some of the fuzzy-logic commands on the pop-up menus are particularly useful. For example, setting up the pop-up menus so that they say, "is within" and "1 month" may be exactly what you need when you only vaguely remember when you last worked with the file.

2.10.2.4 Kind

These two pop-up menus let you search for everything that is, or isn't, a certain kind of file—an alias, folder, image, and so on. For example, when you're trying to free up some space on your drive, you could round up all your gigantic movie (.mov) files.

The Indexing Catch

The "content" search, which finds words inside your files, is a terrific help when you can't remember what you named a certain file. Left unaided, the Mac would take almost as long as you would to search your files for a particular phrase.

To eliminate that delay, Apple programmed the Find program to do something ingenious: Like a kid cramming for an exam, it reads, takes notes on, and memorizes the contents of all of your files. Once it has indexed your hard drive in this way, Find can produce search results in seconds.

In Mac OS X 10.2, the indexing process occurs automatically and continuously—in the background—in the microseconds between your keystrokes and clicks in other programs. Most people can ignore the whole concept.

Every now and then, however, you may find it useful to know more about the indexing process. For example:

Manual indexing. If a search doesn't unearth a file you're pretty sure exists, maybe Mac OS X hasn't yet gotten around to indexing the disk or folder that contains it. In that situation, you can index it manually: Just highlight the disk or folder, choose File [image] Get Info, expand the Content Index panel, and then click Index Now (shown here). Once the Status line says "Indexed," try the search again.

Deleting an index. The invisible index files (the card catalogs of your stuff) may be invisible, but they take up real disk space. If you're ever pinched for space, consider deleting the index files for folders you never search. To do so, highlight the disk or folder, choose File [image] Get Info, expand the Content Index panel, and then click Delete Index.

What the index includes. Mac OS X is smart enough to ignore files on your hard drive that don't actually contain words, such as applications, pictures, movies, system files, and so on. What it does index includes word processing files, text files, clipping files, HTML (Web page) documents, Acrobat (.pdf) files, and sometimes email, depending on the program you use.

Other disks. Mac OS X can't index CDs or other hard drives on the network.

Saving time and space. In an effort to be world-friendly and painfully complete, Apple wrote the Find program to index words in every possible language—Afrikaans, Norwegian, and so on. Chances are, this list is more inclusive than you actually need. By turning off the languages you don't speak, you can accelerate the indexing (and make the index files smaller).

To do so, in the Finder, choose Finder [image] Preferences. Click the Select button at the bottom of the dialog box. In the Languages dialog box, turn off the checkboxes of every language except the ones you use in your documents.

Where the index files are. Note to Mac veterans: In Mac OS X, there's no longer a central, massive, invisible index file on the hard drive. Now every folder has its own invisible index file called .FBCIndex. The beauty of this system is that folders remain indexed even when copied to other disks—because the invisible index travels along with them.

2.10.2.5 Size

Using this control, and its "is less than"/ "is greater than" pop-up menu, you can restrict your search to files of a certain size. (Remember that there are 1,024 K per megabyte; this field requires a number in KB, or kilobytes.)

2.10.2.6 Extension

Here's the option you need when rounding up all files of a certain type, using their file name extensions (Section 4.3.2) as a "handle." You'd type .doc here to find all Word files, .jpg to find all JPEG graphics, and so on.

2.10.2.7 Visibility

Your hard drive is absolutely teeming with invisible files, including the thousands of Unix files that make up Mac OS X. Using this command, you can take a look at them. (It's not wise to move or throw away invisible files, however. In fact, Apple made them invisible expressly so you wouldn't tamper with them.)

2.10.3 Duplicating Criteria Rows

If you listen closely, you can hear the cheers of propeller-heads worldwide over this development: Mac OS X 10.2 introduces "and" searches. That is, you can add a certain criterion row to your Find setup more than once, for even more specific searches.

To find files created between two dates, for example, you could set up two "date created" rows, as shown in Figure 2-17.

Figure 2-17. The first two lines ensure that you'll find only files whose names contain both "apple" and "plist," such as com.apple.finder.plist and com.apple.Preview.plist. The next two lines limit the roundup to files created between September 5 and November 5. As for the bizarre gap in the listing of search options between "size" and "extension" (still present in Mac OS X 10.2.2): Just think of it as white space. Designers love this stuff.

You start by adding one criterion row of the appropriate type—creation date, for example. Then click the + button at its right end. Now you get a second, duplicate row, complete with its own pop-up menus (Figure 2-17). In some cases, you can even click the + button in its row to produce a third one, and so on. (As always, click the - button next to a row to remove it from the lineup.)

Not all of the criteria can be duplicated in this way. In fact, you can create additional rows only for "file name," "date created," and "date modified" searches.

(It's easy to understand why only one criterion row is allowed for kind, extension, and visibility. After all, a file can't be more than one kind and can't have more than one extension. But it's too bad you can't set up two rows for "size" searches, to find files between, say, 500 and 900 K.)

2.10.4 Step 3: Find the Files, and Use Them

Once you've set up your search—a process that, in extreme cases, can take all afternoon—click the Search button, or press Return, to set the search in motion.

A new window, called Search Results, opens up immediately, although it may take some time for any files to appear in the list. If you let the search proceed, eventually you're shown a list of files whose names contain what you typed in the blank.

At this point, you should proceed exactly as described in Section 2.9; as it turns out, the Search bar and the Find program produce precisely the same Search Results window. Double-click a found file to open it, drag it to the desktop to move it, and so on.

TIP

Actually, there's one thing you can do after using the Find program that you can't do using the Search bar: leave the Search Results window open. Then start a new search by pressing [image] -F or choosing File [image] Find.

Adjust the search parameters and repeat the search. Now you've got two Search Results windows, each containing a different list of found files, which you're welcome to compare and study.

The Wacky New Keystrokes of Jaguar

Mac OS X offers a glorious assortment of predefined keystrokes for jumping to the most important locations on your Mac: your Home folder, the Applications folder, the Computer window, your iDisk, your Favorites folder, the Dock, and so on.

Better yet, the keystrokes are incredibly simple to memorize: Just press Shift- [image] and the first letter of the location you want. Shift- [image] -H opens your Home folder, Shift- [image] -A opens the Applications folder, and so on. You learn one, you've learned 'em all.

The only people who won't appreciate this consistency are those who had already gotten used to the keystroke scheme in Mac OS X versions 10.0 and 10.1—which was Option- [image], not Shift- [image]. Apple's thinking: The keystroke for folders (Shift- [image]) shouldn't be the same as the one for system features (Option-c).

Sure enough, in Mac OS X 10.2, Option- [image] -D hides or shows the Dock, Option- [image] -H is the Finder's Hide Others command, Option- [image] -+ magnifies the screen (if you've turned on this feature), and so on. Consistency is always nice.


Chapter 3. Dock, Desktop, and Toolbar

You can't help reacting, one way or another, to the futuristic, sleek, cool looks of Mac OS X the first time you arrive at its desktop. When you stop to think about it, though, the environment owes most of its different, photo-realistic looks to three key elements: the Dock at the bottom edge of the screen, the toolbar at the top of every Finder window, and the shimmering, sometimes animated backdrop of the desktop itself. This chapter shows you how to use and control these most dramatic elements of Mac OS X.


3.1 The Dock

In the old days, the optimists saw the doughnut, and the pessimists saw the hole.

If you're a Mac fan, the debate doesn't concern the doughnut so much as the Dock. This strip of icons at the bottom of the Mac OS X desktop combines the functions of what Mac fans once knew as the Application menu, [image] menu, Launcher, Control Strip, and pop-up windows—all in a single new onscreen gadget. (If you're a former Windows user, the Dock is less of a shock, because some of its functions resemble the Windows taskbar.)

The pessimist thinks that's ridiculous. "You've just combined the Launcher function, which stores unopened programs until you need them, with the Application menu function, which is supposed to show you which programs are currently running."

The optimist says, "Well, yeah—isn't that great?"

Apple's thinking goes like this: Why must you know whether or not a program is already running? That's the computer's problem, not yours. In an ideal world, this distinction should be irrelevant. A program should appear when you click its icon, whether it's open or not—just as on a PalmPilot, for example.

"Which programs are open" already approaches unimportance in Mac OS X, where sophisticated memory-management features make it hard to run out of memory. You can open dozens of programs at once in Mac OS X, since the limiting factor is no longer how much memory you have, but how much unused hard drive space there is.

And that's why the Dock combines the launcher and status functions of a modern operating system. Only a tiny triangle beneath a program's icon tells you that it's open. Icons no longer appear dark and hollow in Mac OS X when they're running, as they did in previous systems.

In any case, the Dock is a core element of Mac OS X, and it's here to stay. Whether or not you agree with Apple's philosophy, Apple has made it as easy as possible to learn to like the Dock. You can customize the thing to within an inch of its life, or even get rid of it completely. This section explains everything you need to know.


3.2 Setting Up the Dock

Apple starts the Dock off with a few icons it thinks you'll enjoy: QuickTime Player, iTunes, iChat, and so on. But using your Mac without putting your own favorite icons on the Dock is like buying an expensive suit and turning down the free alteration service. At the first opportunity, you should make the Dock your own.

The concept of the Dock is simple: Any icon you drag onto it (Figure 3-1) is installed there as a large, square button. A single click, not a double-click, opens the corresponding icon. In other words, the Dock is an ideal parking lot for the icons of disks, folders, documents, and programs that you access frequently.

TIP

You can install batches of icons onto the Dock all at once—just drag them as a group.

Figure 3-1. To add an icon to the Dock, just drag it there. You haven't actually moved the original file; when you release the mouse, it remains exactly where it was. You've just installed a pointer—like a Macintosh alias or Windows shortcut, you might say.

Here are a few aspects of the Dock that may throw you at first:

  • It has two sides. See the fine dark line running down the Dock in Figure 3-1? That's the divider. Everything on the left side is an application—a program. Everything else goes on the right side: files, documents, folders, and disks.

    It's important to understand this division. If you try to drag an application to the right of the black line, for example, Mac OS X will teasingly refuse to accept it. (Even aliases observe that distinction. Aliases of applications can go only on the left side, for example.)

  • Its icon names are hidden. To see the name of a Dock icon, just point to it without clicking. You'll see the name appear just above the icon.

    When you're trying to find a certain icon on the Dock, run your cursor slowly across the icons without clicking; the icon labels appear as you go. Better yet, you can sometimes tell documents apart by looking solely at their icons, as shown in Living Icons.

  • Folders and disks are hierarchical. If you retain nothing else in this chapter, remember this: If you click a folder or disk icon on the right side of the Dock and hold down the mouse button, a list of its contents sprouts from the icon. It's a hierarchical list, meaning that you can burrow into folders within folders this way. See Figure 3-2 for an illustration.

    TIP

    To make the pop-up menu appear instantly, just Control-click the Dock icon, or (if you have a two-button mouse) right-click it.

  • Programs appear there unsolicited. Nobody but you can put icons on the right side of the Dock. But program icons appear on the left side of the Dock automatically whenever you open a program (even one that's not listed in the Dock). Its icon remains there for as long as it's running.

    TIP

    The Dock is already extremely cool looking, but you haven't seen the end of its tricks. Using TinkerTool, you can make the Dock translucent (see-through) to a degree that you specify—a great way to show off at user-group meetings. See Section 17.1 for details.

Figure 3-2. As long as you keep the mouse button pressed, you can burrow into folders within folders—either with the intention of opening a file or folder (by releasing the mouse button as you point), or just to see what's inside.

3.2.1 Organizing and Removing Dock Icons

You can move the tiles of the Dock around just by dragging them horizontally. As you drag, the other icons scoot aside to make room. When you're satisfied with its new position, drop the icon you've just dragged.

To remove a Dock icon, just drag it away. Once your cursor has cleared the Dock, release the mouse button. The icon disappears, its passing marked by a charming little puff of animated cartoon smoke. The other Dock icons slide together to close the gap. (Mac OS X won't let you remove the Finder, the Trash, or the Dock icon of a program or document that's currently open.)

TIP

You can replace the "puff of smoke" animation with one of your own, as described in Section 17.3.2.

Weirdly enough, this technique (removing a Dock program's icon by dragging it away) works even while a program is still running. Granted, you won't see any change immediately, because the program is still open. But when you ultimately quit the program, you'll see that its previously installed icon is no longer on the Dock.

3.2.2 Three Ways to Get the Dock out of Your Hair

The bottom of the screen isn't necessarily the ideal location for the Dock. Because most screens are wider than they are tall, the Dock eats into your limited vertical screen space. Worse, a bottom-feeding Dock can actually overlap your document windows, interfering with your work.

In these situations, you have three ways out: Hide the Dock, shrink it, or rotate it 90 degrees.

3.2.2.1 Auto-hiding the Dock

To turn on the Dock's auto-hiding feature, choose [image] [image] Dock [image] Turn Hiding On (or press Option- [image] -D).

TIP

You can also find this on/off switch when you choose [image] [image] Dock [image] Dock Preferences (Figure 3-4), or when you click the System Preferences icon on the Dock, and then the Dock icon. (Chapter 8 contains much more about the System Preferences program.)

When the Dock is hidden, it doesn't slide into view until you move the cursor to the Dock's edge of the screen. When you move the cursor back to the middle of the screen, the Dock slithers out of view once again. (Individual Dock icons may occasionally shoot upward into Desktop territory when a program needs your attention—cute, very cute—but otherwise, the Dock lies low until you call for it.)

On paper, an auto-hiding Dock is ideal—it's there only when you summon it. In practice, however, you may find that the extra half-second the Dock takes to appear and disappear makes this feature slightly less appealing.

For many Mac fans, then, the solution is to hide and show the Dock at will by pressing the hide/show keystroke, Option- [image] -D. This method makes the Dock pop on and off the screen without requiring you to move the cursor.

3.2.2.2 Shrinking and enlarging the Dock

Depending on your screen's size, you may prefer smaller or larger Dock buttons. Fortunately, Mac OS X's sophisticated graphics technology, called Quartz, can display Mac OS X icons at almost any size, so you're not limited to a feeble choice of Small, Medium, or Large settings.

The official way to resize Dock icons goes like this: Choose [image] [image] Dock [image] Dock Preferences. In the resulting dialog box, drag the Dock Size slider, as shown in Figure 3-4.

Living Icons

Mac OS X brings to life a terrific idea, a new concept in mainstream operating systems: icons that tell you something. As shown here, for example, you can often tell documents apart just by looking at their icons.

Furthermore, some program icons actually change over time. The Clock program (in your Applications folder), for example, is a living icon that actually ticks away the time, right there in the Dock. The Mail icon (see Chapter 19) displays a live counter that indicates how many new email messages are waiting for you. (After all, why should you switch into the Mail program if you'll only be disappointed?) The America Online icon sprouts a flag to let you know if an instant message is waiting. You can make your CPU Monitor graph (Section 9.2.9) show up right on its icon. And if you minimize a QuickTime movie while it's playing, it shrinks down and continues playing right there in the Dock.

Think of the possibilities. At this rate, one day the Internet Explorer icon could change to let us know when interesting new Web pages have appeared, the Quicken icon could display your current bank balance, and the Microsoft Word icon could change every time Microsoft posts a bug fix.

There's a much faster way to resize the Dock, however: Just position your cursor carefully on the Dock's divider line, so that it turns into a double-headed arrow (shown in Figure 3-3). Now drag up or down to shrink or enlarge the Dock.

TIP

If you press Option as you drag, the Dock snaps to certain canned icon sizes—those that the programmer actually drew. (You won't see the in-between sizes that Mac OS X generally calculates on the fly.)

As noted in Figure 3-3, you may not be able to enlarge the Dock, especially if it contains a lot of icons. But you can make it almost infinitely smaller. Which makes you wonder: How can you distinguish between icons if they're the size of molecules?

Figure 3-3. Look closely—you can see the secret cursor that resizes the Dock. If you don't see any change in the Dock size as you drag upward, you've reached the size limit. The Dock's edges are already bumping your screen sides.

The answer lies in the [image] [image] Dock [image] Turn Magnification On command. What you've just done is trigger the swelling effect shown in Figure 3-4. Now your Dock icons balloon to a much larger size as your cursor passes over them. It's a weird, rippling, magnetic sort of animated effect that takes some getting used to. But it's yet another spectacular demonstration of the graphics technology in Mac OS X, and it can actually come in handy when you find your icons otherwise shrinking away to nothing.

Figure 3-4. To find a comfortable setting for the Magnification slider, choose Dock Dock Preferences. Leave the Dock Preferences window open on the screen, as shown here. After each adjustment of the Dock Size slider, try out the Dock (which still works when the Dock Preferences window is open) to test your new settings.
3.2.2.3 Moving the Dock to the sides of the screen

Yet another approach to getting the Dock out of your way is to rotate it, so that it sits vertically against a side of your screen. You can rotate it in either of two ways:

  • The menu way. From the [image] [image] Dock submenu, choose "Position on Left," "Position on Right," or "Position on Bottom," as you see fit.

  • The mouse way. While pressing Shift, drag the Dock's divider line, as though it's a handle, directly to the side of the screen you want.

You'll probably find that the right side of your screen works better than the left. Most Mac OS X programs put their document windows against the left edge of the screen, where the Dock and its labels might get in the way.

NOTE

When you position your Dock vertically, the "right" side of the Dock becomes the bottom. In other words, the Trash now appears at the bottom of the vertical Dock. So as you read references to the Dock in this book, mentally substitute the phrase "bottom part of the Dock" when you read references to the "right side of the Dock."


3.3 Using the Dock

Most of the time, you'll use the Dock as either a launcher (click an icon once to open the corresponding program, file, folder, or disk) or as a status indicator (the tiny black triangles, identified in Figure 3-1, indicate which programs are running).

But the Dock has more tricks than that up its sleeve. You can use it, for example, to pull off any of the following stunts.

3.3.1 Switch Applications

In some ways, the Dock is exactly like the torn-off Application menu of Mac OS 9. For example, it lets you:

  • Jump among your open programs by clicking their icons.

  • Jump among your open programs by pressing [image] -Tab. (That keystroke highlights successive icons on the Dock from left to right. Add the Shift key to move backwards—right to left—across the Dock.)

  • -drag a document (such as a text file) onto a Dock application button (such as the Microsoft Word icon) to open the former with the latter.

  • Hide all windows of the program you're in by Option-clicking another Dock icon.

This is just a quick summary of the Dock's application-management functions; you'll find the full details in Chapter 4.

3.3.2 Operate the Dock by Keyboard Control

If you turn on the amazing Mac OS X feature called full keyboard access, you can operate the Dock entirely from the keyboard; see Section 4.4.

3.3.3 Use Secret Menus

Don't get so enamored of single-clicking the Dock icons that you miss this one. It turns out that if you Control-click a Dock icon—or, if you're in no hurry, hold down the mouse button on it—a hidden menu sprouts out of it (Figure 3-5).

Figure 3-5. Control-click a Dock icon, or click and hold on it, to open the secret menu. The names at the top of this shortcut menu are the names of the windows currently open in that program. The checkmark next to a window's name indicates that it's the frontmost window of that program (even if that program is in the background).

If you've clicked a minimized window icon, this shortcut menu says only the name of the window. If you've clicked the icon of an application that's not running at the moment (or an alias), the menu says only Show In Finder.

But if you've clicked the icon of a running application, you get some incredibly useful commands that have never before been available in the Mac OS. For example:

  • [Window names.] At the top of the shortcut menus of most running-application Dock icons, you'll find at least one tiny, neatly labeled window icon, like those shown in Figure 3-5. This useful new Mac OS X feature means that you can jump directly not just to a certain program, but to a certain open window in that program.

    For example, suppose you've been using Word to edit three different chapters. You can use its Dock icon as a Window menu to pull forward one particular chapter—even from within a different program.

    TIP

    The Finder tile that's always at the beginning of the Dock is, in effect, its own Window menu. By holding the mouse down on this icon for a moment, you produce a menu that lists all open desktop windows. Of course, the Window menu at the top of the screen does the same thing. But it's often faster to use the Dock icon for switching windows because it doesn't list all the other Window-menu commands (Zoom Window, Minimize Window, and so on).

  • Keep In Dock. Whenever you launch a program, Mac OS X puts its icon in the Dock—marked with a little black triangle—even if you don't normally keep its icon there. As soon as you quit the program, its icon disappears again from the Dock.

    If you understand that much, then the Keep In Dock command makes a lot of sense. It means, "Hello, I'm this program's icon. I know you don't normally keep me on your Dock, but I'd be happy to stay here even after you quit my program. Just say the word." If you find that you've been using, for example, Terminal (Chapter 15) a lot more often than you thought you would, this command may be just the ticket.

    TIP

    Actually, there's a faster way to tell a running application to remain on the Dock from now on: Just drag its icon off the Dock and then right back onto it—yes, while the program is running. You have to try it to believe it.

  • Show In Finder. Choose this command to highlight the actual icon (in whatever folder window it happens to sit) of the application, alias, folder, or document you've clicked. You might want to do this when, for example, you're using a program that you can't quite figure out, and you want to jump to its desktop folder in hopes of finding a Read Me file there.

    TIP

    If you really want to reveal an icon in the Finder, there's a much faster way: -click its Dock icon. This takes you there instantly. (You can even [image] -click an item that's listed in one of the Dock's pop-up menus, illustrated in Figure 3-5, to highlight its icon.)

  • Quit. You can quit any program directly from its Dock shortcut menu. No longer must you actually switch into a program in order to access its Quit command.

    Of course, thanks to Mac OS X's state-of-the-art memory management features, there's less need these days to quit programs at all. Still, you might be thankful for this quick-quitting feature when your boss is coming down the hallway and the Dilbert Web site is on your screen where a spreadsheet is supposed to be.

    TIP

    If you hold down Option—even after you've opened the pop-up menu—the Quit command changes to say Force Quit. That's your emergency hatch for jettisoning a locked-up program.

  • Conduct speed tests. When you click an application icon on the Dock, its icon jumps up and down a few times as the program launches, as though with excitement at having been selected. The longer a program takes to start up, the more bounces you see. This has given birth to a hilarious phenomenon: the counting of these bounces as a casual speed benchmark for application-launching times. "Internet Explorer took twelve bouncemarks to open in Mac OS X 10.1.5," you might read online, "but only three bouncemarks in 10.2.1."

    TIP

    If you find the icon bouncing a bit over the top, try this: Choose [image] [image] Dock [image] Dock Preferences. In the Dock dialog box (shown in Figure 3-3), turn off "Animate opening applications." From now on, your icons won't actually bounce—instead, the little triangle underneath it will simply pulse as the application opens. (You can still see how long a program takes to open, but now you have to count the pulsemarks.)

  • Do your filing. Once you've tried stashing a few important folders on the right side of your Dock, there's no going back; you can mostly forget all the other navigation tricks you've learned in Mac OS X. After all, the folders you care about are always there, ready for opening with a single click.

    Better yet, they're easily accessible for putting away files; you can drag them directly into the Dock's folder icons as though they're regular folders. In fact, if you press [image] just before releasing the mouse, docked folder icons don't even scoot out of the way, as they usually do to accommodate something you're adding to the Dock. The folder icon you want just sits there—a sitting duck for the file you're filing.

3.3.4 Great Things to Put on Your Dock

Now that you know what the Dock's about, it's time to set up shop. Install the programs, folders, and disks you'll be using most often.

They can be whatever you want, of course, but don't miss these opportunities:

  • Your Home folder. Many Mac fans immediately drag their hard drive icons onto the right side of the Dock—or, perhaps more practically, their Home folders (see Section 2.1). Now they have quick access to every single file in every single folder they'll ever use.

  • The Applications folder. Here's a no-brainer: Stash the Applications folder here, so you'll have quick pop-up menu access to any program on your machine.

  • Your Applications folder. As an even more efficient corollary, create a new folder of your own. Fill it with the aliases of just the programs you use most often and park it on the Dock. Now you've got an even more useful Applications folder.

  • The Documents folder. The Documents folder in your Home folder is another primary center for your Mac activity. Stash it here for quick access.

  • The Shared folder. If you're using the Mac's accounts feature (Chapter 11), this is your wormhole between all accounts—the one place you can put files where everybody can access them (Section 11.4.3).

  • The System Preferences. Once you stash a folder full of the System Preferences (Chapter 8) onto your Dock, you'll never again waste time opening System Preferences, clicking the Show All button, and clicking the panel you want. Want to adjust one of your Mac's settings? Leap directly to it from your Dock. (Instructions in Section 8.26.4.)

    TIP

    Check out TransparentDock 2, a piece of shareware that lets you set a degree of transparency for the Dock. At its most transparent, the background disappears completely, leaving only your icons hovering in space at the bottom of the screen. You can download it from www.missingmanuals.com, among other places.


3.4 The Finder Toolbar

At the top of every Finder window is a row of navigation and function icons. One click on any of these icons takes you directly to the corresponding disk or folder, or triggers the corresponding command.

The first time you run Mac OS X, for example, you'll find these icons on the toolbar:

  • Back, Forward. As you've probably noticed, the Mac OS X Finder works something like a Web browser. Only a single window remains open as you navigate the various folders on your hard drive.

    The Back button returns you to whichever folder you were just looking at. (Instead of clicking Back, you can also press [image] -[, or choose Go [image] Back—particularly handy if the toolbar is hidden, as described on the next page.)

    The Forward button, new to 10.2, springs to life only after you've used the Back button. Clicking it (or pressing [image] -]) returns you to the window you just backed out of.

  • View controls. The three tiny buttons next to the Forward button switch the current window into icon, list, or column view, respectively (Section 1.3). And remember, if the toolbar is hidden, you can get by with the equivalent commands in the View menu at the top of the screen—or by pressing [image] -1, [image] -2, or [image] -3 (for Icon, List, and Columns view, respectively).

  • Computer. Click this button to open a window that contains icons for all your disks. The Computer Window has the details.

  • Home. As noted in Section 2.1, this may be the single most important button on your Mac in Mac OS X. It takes you to your folder, the one that contains all of your documents, preference files, personal programs, and so on.

  • Favorites. This folder contains aliases of the documents, files, disks, and folders you've designated as Favorites (Section 2.6).

  • Applications. This button takes you directly to the folder that contains most of the programs on your machine.

    TIP

    The Go menu lists the same folders itemized in Section 3.4 (among others), for use when you've hidden the toolbar. The Go menu also displays the keyboard equivalents for summoning these folders.

  • Search. This is your Find command. New to Mac OS X 10.2, it lets you pinpoint a certain icon within this window (or within any of its folders), as described in Section 2.9.

3.4.1 Removing or Shrinking the Toolbar

For many grizzled Mac veterans, the Finder toolbar is a disconcerting new element. Most people who dislike it cite two complaints. First, it takes up even more screen space; between the toolbar, the Dock, and the unusually large icons of Mac OS X, it almost seems like there's an Apple conspiracy to sell big screens. Second, Apple seems to presume it knows which folders you'll want frequent access to; if you like your disk icons on the desktop, for example, the Computer icon on the toolbar seems like a waste of space.

Never fear. There are simple solutions to both problems.

First of all, you can eliminate the toolbar with one click—on the white, oval "Old Finder Mode" button (see Section 1.2.7). You can also hide the toolbar by choosing View [image] Hide Toolbar or pressing [image] -B. (The same keystroke, or choosing View [image] Show Toolbar, brings it back.)

But you don't have to do without the toolbar altogether. If its consumption of screen space is your main concern, you may prefer to simply collapse it—to delete the pictures but preserve the text buttons.

Figure 3-6. While this window is open, you can add additional icons to the toolbar by dragging them into place from the gallery before you. You can also remove icons from the toolbar by dragging them up or down off the toolbar. Rearrange the icons by dragging them horizontally.

To make it so, choose View [image] Customize Toolbar. As shown in Figure 3-6, the dialog box that appears offers a Show pop-up menu at the bottom. It lets you choose picture-buttons, with Icon Only, or, for the greatest space conservation, Text Only. You can see the results without even closing the dialog box. (Figure 3-7 illustrates the three possible arrangements.)

Click Done or press Enter to make your changes stick.

NOTE

In Text Only mode, the three View buttons become a little pop-up menu. Furthermore, the Search bar (Section 2.9) turns into a one-word button called Search. Clicking it brings up the new Find dialog box (Section 2.10), which is actually much more powerful than the Search bar itself.

Figure 3-7. The Finder toolbar starts out with both picture and text buttons (top). But you may prefer to see only icons (middle) for greater horizontal compactness or only text (bottom) for greater vertical compactness. In that case, the trio of View icons turns into a single View pop-up menu, as shown here.

3.4.2 Adding Your Own Icons to the Toolbar

As it turns out, Apple doesn't presume to know which icons you want on your Finder toolbar. Mac OS X not only offers a collection of beautifully designed icons for alternate (or additional) toolbar buttons, but makes it easy for you to add anything to the toolbar, turning it into a supplementary Dock.

3.4.2.1 Apple's toolbar-icon collection

To see the optional toolbar icons that Apple has prepared for you, choose View [image] Customize Toolbar. The window shown in Figure 3-6 appears.

TIP

There's a great secret shortcut for opening the Customize Toolbar window: Shift-click the toolbar button (the white capsule in the upper-right corner of every Finder window).

This is your chance to rearrange the existing toolbar icons or delete the ones you don't use. You can also add any of Apple's buttons to the toolbar simply by dragging them from the "gallery" upward onto the toolbar itself. The existing icons scoot out of your cursor's way, if necessary.

Most of the options listed in the gallery represent shortcuts to certain folders, or duplicate the functions of menu commands. Here are a few of the options that don't appear on the standard toolbar:

  • Path. Most of the gallery elements are buttons, but this one creates a pop-up menu on the toolbar. When clicked, it reveals (and lets you navigate) the hierarchy—the path—of folders that you open to reach whichever window is open. (Equivalent: -clicking a window's title bar, as described in Section 1.2.1.)

  • Eject. This button ejects whichever disk or disk image is currently highlighted. (Equivalent: The File [image] Eject command, or the Eject key on your keyboard.)

  • Burn. If your Mac has a compatible CD burner (see Chapter 10), this button "burns" a blank CD with the folders and files you've dragged onto it. (Equivalent: The File [image] Burn CD command.)

  • Customize. This option opens this toolbar-customizing window. (Equivalent: The View [image] Customize Toolbar command.)

  • Separator. This is the only gallery icon that doesn't actually do anything when clicked. It's designed to set apart groups of toolbar icons. (For example, you might want to segregate your folder buttons, such as Documents and Applications, from your function buttons, such as Delete and Connect.) Drag this dotted line between two existing icons on the toolbar.

  • New Folder. Clicking this button creates a new folder in whichever window you're viewing. (Equivalent: the File [image] New Folder command, or the Shift- [image] -N keystroke. Millions of Mac fans, however, spend their first weeks with Mac OS X hitting the old keystroke, [image] -N, when they want a new folder, little realizing that [image] -N now triggers the New Finder Window command. Adding the New Folder "command" to the toolbar is a quick solution.)

  • Delete. This option puts the highlighted file or folder icons into the Trash. (Equivalent: the File [image] Move to Trash command, or the [image] -Delete keystroke.)

    TIP

    The New Folder and Delete icons are among the most valuable ones to put on your toolbar. They represent functions you'll probably use often.

  • Connect. If you're on an office network, this opens the Connect to Server dialog box (see Section 12.2.2) so that you can tap into another computer. (Equivalent: The Go [image] Connect to Server command, or the [image] -K keystroke.)

  • Find. This option opens the Find dialog box (Chapter 2), which you can use to search your hard drive for files or folders.

  • Get Info. This button opens the Get Info window (Section 2.7.3) for the icon you've highlighted.

  • iDisk. The iDisk is your own personal 100 MB virtual hard drive on the Internet. It's your private backup disk, stashed at Apple, safe from whatever fire, flood, or locusts may destroy your office. Of course, you already know this, because you're paying $100 per year for the privilege (see Section 18.8).

    In any case, you can connect to the Internet and bring your iDisk's icon onto the screen just by clicking this toolbar icon.

  • Documents, Movies, Music, Pictures, Public. These buttons open the corresponding folders in your Home folder, as described in Section 2.1.3.

  • Search. This item represents the Search bar described in Section 2.9.

  • Default set. If you've made a mess of your toolbar, you can always reinstate its original, factory-installed arrangement just by dragging this rectangular strip directly upward onto your toolbar.

    NOTE

    If a window is too narrow to show all the icons on the toolbar, you will see, at the right end of the toolbar, a >> symbol. Click it for a pop-up menu that names whichever icons don't fit at the moment. (You'll find this toolbar behavior in many Mac OS X programs—System Preferences, Mail, Address Book, and so on—not just the Finder.)

3.4.2.2 Adding your own stuff

As useful as some of Apple's toolbar-gallery icons may be, the toolbar really takes off only when you add your own icons. You can drag any icons at all onto the toolbar—files, folders, disks, programs, or whatever—to turn them into one-click buttons.

In short, think of the Finder toolbar as a secondary Dock. Together, the Dock and the toolbar offer so many parking places for icons, you may never pine for the old [image] menu or Start menu again.

NOTE

You don't need to choose View [image] Customize Toolbar to add your own icons to the toolbar. Just drag them from the desktop or any folder window directly onto the toolbar, at any time.

Here are a few possibilities:

  • Install toolbar icons of the three or four programs you use the most (or a few documents you work on every day). Sure, the Dock can also serve this purpose, but only the toolbar keeps their names in view.

  • Install toolbar icons for other Macs on the network, which saves you several steps when you want to connect to them (see Chapter 12).

  • Install toolbar icons of Web sites you visit often (see Section 18.10), so that you can jump directly to them when you sit down in front of your Mac each morning.

  • Use the toolbar as a temporary parking place. This is a sneaky but extremely useful trick when you're viewing a window in column view (Section 1.6), and you want to drag a file between two very distant folders. Figure 3-8 depicts the process.

Figure 3-8. Top: How are you supposed to drag the Cruise Ship file (in your Home Pictures folder) into a folder that's not visible at the moment—a folder that requires navigating down a totally different path? You could use spring-loaded folder-dragging (Section 2.4.3)—but if the two folders are distant, it's faster to use this trick. Middle: Start by dragging the destination folder onto the toolbar (in this case, the Public Drop Box folder in Pikup Andropof's home folder). Bottom: Drag the Cruise Ship file onto the toolbar folder to complete the transition. Drag the toolbar folder off the toolbar to get rid of it.

Remember that toolbar icons work exactly like Dock or desktop icons. You can even drag things onto them: For example, you can drag a document onto a folder icon to file it there, drag a downloaded .sit file onto the StuffIt Expander icon there, and so on.

TIP

Ordinarily, you can't edit a toolbar icon's name (or its icon, if you're into that). The sneaky workaround: Make an alias of whatever you'd like to put there, rename or change its icon, and then drag it aboard.

3.4.3 Rearranging Toolbar Icons

You can drag toolbar icons around, rearranging them horizontally, by pressing [image] as you drag. (You can also do so after choosing View [image] Customize Toolbar, of course.)

3.4.4 Removing Toolbar Icons

Taking an icon off the toolbar is almost as easy as putting it on. While the Customize window is open, just drag the icon clear away from the toolbar. If the Customize window isn't open, you can [image] -drag icons away from the toolbar at any time. (Watch your Trash on the Dock turn into a pair of snipping scissors as you do it. Cute!)

NOTE

Technically, you need to press [image] only to move or delete Apple's toolbar icons. You can drag your own icons around, or remove them from the toolbar, without pressing any keys at all.

Frankly, though, it's just as easy to hold the [image] key down to drag any of these icons, so you don't drive yourself crazy trying to remember when to press it and when it's unnecessary.


3.5 Designing Your Desktop

In some ways, just buying a Macintosh was a renegade act of self-expression. But that's only the beginning. Now it's time to fashion the computer screen itself according to your personal sense of design and fashion.

Desktop Fonts

How do I change the fonts used by the Mac OS X Finder?

In Mac OS versions gone by, you could choose any font you liked for your icon labels. You even had a choice of several fonts for use in your menus.

At least in Mac OS X 10.2, that flexibility is gone. You get Lucida Grande in your menus and as icon labels, love it or leave it. As noted in Section 1.4, you can change the type size—just not the font.

For now, Apple intends to remain conservative with the look of Mac OS X—both for "branding" reasons (to make Mac OS X instantly recognizable) and for technical ones (to make sure that it doesn't open a Pandora's box of interface hacks who wind up destabilizing the machine).

3.5.1 System Preferences

Cosmetically speaking, Mac OS X offers two dramatic full-screen features: desktop backgrounds and screen savers. (That's not counting the pictures and colors you can apply to individual folder windows, as described in Section 1.4.1.)

The command center for both of these functions is the System Preferences program (which longtime Mac and Windows fans may recognize as the former Control Panels). Open it by clicking the System Preferences icon on the Dock, or by choosing its name from the [image] menu.

When the System Preferences program opens, you can choose a desktop picture by clicking the Desktop button, or a screen saver by clicking the Screen Saver button. For further details on these System Preferences modules, see Chapter 8.

3.5.2 Graphic Designers' Corner: The Gray Look

One of the earliest objections to the lively, brightly colored look of Mac OS X came from Apple's core constituency: artists and graphic designers. Some complained that Mac OS X's bright blues (of scroll bar handles, progress bars, the [image] menu, pulsing OK buttons, highlighted menu names and commands), along with the red, green, and yellow window-corner buttons, threw off their color judgment.

Truth is, these features have been greatly toned down in Mac OS X 10.2. The pulsing effects are subtler, the three-dimensional effects are less drastic.

But just in case they still bother artists, Apple created what it calls the Graphite look for Mac OS X, which turns all of those interface elements gray instead of blue. To try out this look, click the System Preferences icon on the Dock (or choose System Preferences from the [image] menu); click Show All; click General; and then choose Graphite from the Appearance pop-up menu.

TIP

The Highlight Color pop-up menu does exactly what it did in previous versions of the Mac OS: it lets you choose a different accent color. You'll see this color in several very subtle spots. For example, this is the background color of highlighted text (and icon names). It's also the color that lines the inside of a window as you drag an icon into it.

Putting the Trash on the Finder Toolbar

I've got the mother of all Frequently Asked Questions for you. Can I put the Trash on my Finder toolbar? It would really be a lot handier to have it right there above the icons I'm trying to get rid of, instead of having to drag them all the way to the lower-right corner of the Dock.

You could in Mac OS X 10.1 (by opening the Trash window, and then dragging the window's title-bar Trash icon onto the toolbar). You can't in Mac OS X 10.2.

Calling all shareware hackers!

3.5.3 Desktop Sounds

Desktop sounds are tiny sound effects that accompany certain mouse drags in Mac OS X 10.2, which you can turn on to keep yourself awake.

To turn them on, open System Preferences, click the Sound icon, and turn on "Play user interface sound effects."

The result is so subdued and sparse, you might not even notice anything different. But you'll hear a little plink/crunch when you drop an icon onto the Trash, and a little whoof! when you drag something off the Dock and into oblivion.

This unobtrusive aural atmosphere is nothing like the carnival of squeaks, whooshes, and blurps that accompanied the same feature in Mac OS 9. Even so, use it with discretion when working in a library, neurosurgical operating room, or church.


3.6 Menulets: The Missing Manual

Apple calls them Menu Extras, but Mac fans on the Internet have named the little menu-bar icons shown in Figure 3-9 menulets. These menu-bar icons are the direct descendants of the controls once found on the Mac OS 9 Control Strip or the Windows system tray—that is, each is both an indicator and a menu that provides direct access to certain settings in System Preferences. One lets you adjust your Mac's speaker volume; another lets you change the screen resolution; another shows you the remaining power in your laptop battery; and so on.

Figure 3-9. In Mac OS X 10.2, Apple cracked down on the use of the right side of the menu bar. Only Apple is allowed to create menulets—much to the dismay of other software companies that once added handy icon/menus up here.

To summon the various menulets, you generally visit a certain pane of System Preferences (Chapter 8) and turn on a checkbox called, for example, "Show volume in menu bar." Here's where to find this magic on/off checkbox for each of the menulets, in the order shown in Figure 3-9:

  • Bluetooth status (for connecting to Bluetooth devices, "pairing" your Mac with a cellphone, and so on). To find the "Show" checkbox: Open System Preferences [image] Network. From the "Show:" pop-up menu, choose Bluetooth. (It's available only if you've installed Apple's Bluetooth software.)

  • Eject disc. This one's the oddball: There's no checkbox in System Preferences to make it appear. The fact that it even exists is something of a secret.

    To make it appear, open your System [image] Library [image] CoreServices [image] Menu Extras folder, and double-click the Eject.menu folder. That's it! The Eject menulet appears.

    You'll discover that its wording changes: "Open Combo Drive," "Close DVD-RAM Drive," "Eject [Name of Disc]," or whatever, to reflect your particular drive type and what's in it at the moment.

  • PPPoE status (PPP over Ethernet) lets you control certain kinds of DSL connection. To find the "Show" checkbox: Open System Preferences [image] Network [image] PPPoE.

  • Dial-up modem status lets you connect or disconnect from the Internet. To find the "Show" checkbox: Open System Preferences [image] Network. From the "Show:" pop-up menu, choose Internal Modem. Click the Modem tab.

  • Displays adjusts screen resolution. To find the "Show" checkbox: Open System Preferences [image] Displays.

  • AirPort status lets you turn your AirPort card on or off, and join existing AirPort wireless networks. To find the "Show" checkbox: Open System Preferences [image] Network. From the "Show:" pop-up menu, choose AirPort. (It's available only if you've installed Apple's AirPort software.)

  • Speaker volume, of course, adjusts your Mac's speaker volume. To find the "Show" checkbox: Open System Preferences [image] Sound.

  • Battery status shows how much power remains in your laptop's battery (laptops only). To find the "Show" checkbox: Open System Preferences [image] Energy Saver. (Two battery icons appear in Figure 3-9, because it's a PowerBook G3 with, of course, two batteries.)

  • Menu-bar clock tells the time, in analog or digital form (choose your preference from the menulet itself). To find the "Show" checkbox: Open System Preferences [image] Date & Time [image] Menu Bar Clock tab.

There's also a Script Menu menulet for AppleScript (see Chapter 7), an iChat menulet for instant messaging (Chapter 20), and a few others that you'll meet along the way.

To remove a menulet, just [image] -drag it off of your menu bar (or turn off the corresponding checkbox in System Preferences). You can also rearrange them by [image] -dragging them horizontally.

These little guys are useful, good-looking, and respectful of your screen space. The world could use more inventions like menulets.

TIP

As noted in Figure 3-9, Apple installed a block in 10.2 that prevents non-Apple menulets from appearing. Fortunately, the friendly hacker community is one step ahead. The free Menu Extra Enabler (available from www.missingmanuals.com) blocks the block, so that third-party menulets work once again.


Part II: Applications in Mac OS X

Chapter 4: Programs and Documents

Chapter 5: Back to Mac OS 9

Chapter 6: Moving Data

Chapter 7: An Introduction to AppleScript


Chapter 4. Programs and Documents

From the day Apple first announced Mac OS X, the company made clear that Mac OS X offered a lot of advantages, particularly in stability—but that you would need all-new versions of your programs to realize these benefits. Most software companies announced that they would get to work Mac OS X-izing their programs, but Mac fans still kept reading the same advice: Don't switch to Mac OS X until most or all of the programs you use every day have been adapted to run on it.

For most people, that time is here, or near. One by one, the Mac OS X versions of big-name programs became ready: Microsoft Office, AppleWorks, iMovie, iTunes, Photoshop, Illustrator, Freehand, Quicken, FileMaker, InDesign, Internet Explorer, America Online, and thousands of others.

The time has also come, therefore, to grow accustomed to the way programs and documents relate in Mac OS X—which, as this chapter makes clear, differs in several substantial ways from the Mac OS that preceded it.

NOTE

There are two kinds of Mac OS X-compatible programs, known by the geeks as Carbon and Cocoa programs (see Section 4.6). This chapter describes how Carbon and Cocoa programs work.

You can also run older, Mac OS 9-compatible programs that haven't yet been updated for Mac OS X—but when you launch one of these, your Mac automatically opens a Mac OS 9 simulator called Classic. For details on running the older, Mac OS 9-specific programs in this way, see Chapter 5.


4.1 Launching Mac OS X Programs

You can launch (open) a program in any of several ways.

  • Double-click an application's icon in the Finder.

  • Click a program's icon on the Dock or the Finder toolbar (Chapter 3).

  • Highlight an application icon and then press [image] -O (short for File [image] Open) or [image] -down arrow.

  • Use the submenus of the [image] menu's Recent [image] Applications command. (You control how many programs this feature tracks using the System Preferences panel described in Section 8.11.)

    NOTE

    Mac OS X stores a list of your recently used programs in a text file called com.apple.recentitems.plist, located in your Home folder [image] Library [image] Preferences folder. And with about $1.00, that information will buy you a cup of coffee in most restaurants.

  • Use your Go [image] Favorites command.

  • Open a document icon in any of these ways, or drag a document onto the icon of a program that can open it (whether in the Dock, the Finder toolbar, or in a folder window).

    TIP

    If you press Option as you open an application in the Finder, you automatically close the window that contains its icon. Later, when you return to the Finder, you'll find a neat, clean desktop—no loitering windows.

When you launch a program, the Mac reads its computer code, which lies on your hard drive's surface, and feeds it quickly into RAM (memory). During this brief interval, the icon of the opening program jumps up and down eagerly in your Dock. (You can turn off this bouncing, as noted in Section 3.3.4.)

TIP

Want to see multithreading in action? Launch a program that takes a long time to open—that is, whose icon on the Dock does a lot of bouncing.

You don't have to wait for the application to finish bouncing—you're wasting perfectly good computing time. Just switch to another program and get to work, as the newly opened program keeps right on launching in the background. Multithreading simply means that Mac OS X can crunch more than one process at a time.

What happens next depends on the program you're using. Most present you with a new, blank, untitled document. Some, like iMovie and iDVD, automatically open the last file you worked on. Some, like FileMaker and PowerPoint, ask you: Do you want to open an existing document or create a new one? In AppleWorks, the welcome screen generally asks you to specify what kind of new document you want to create. And a few oddball programs don't open any window at all when first launched.

4.1.1 The Application Menu

In each case, however, you'll notice a few changes to your menu bar. The File, Edit, and other application menus are still there—but they're no longer immediately to the right of the [image] menu. The very first menu appears with bold lettering and identifies the program you're using. It might say Internet Explorer, or Microsoft Word, or Stickies.

Virtual Memory and Memory Allotments

I'm completely at sea when it comes to using memory in Mac OS X. There's no Memory control panel. There's no box to set the memory allotment in the Get Info dialog box of any program. There's no on/off switch for virtual memory. There isn't even an About This Macintosh box that shows where all my RAM is going. What on earth is going on?

Mac OS X handles memory with light-years more sophistication and skill than anything Mac fans have used before—so much so, in fact, that these controls no longer even exist.

In the old days, each program claimed a fixed amount of RAM for itself as soon as you launched it. You could see this number—or even change it—in the program's Get Info box. When you launched a program, it instantly claimed 20 MB of memory (or whatever its programmers thought it might need).

But in Mac OS X, memory allotments are dynamic (changing). When you launch a program, it might not use very much RAM at all. But when you then use that program to open a huge, complex document, the system supplies more memory automatically. Then, when you close that document, Mac OS X automatically returns the RAM it was using to the "pot," so that it's available for use by other programs and functions.

It's true that the About This Mac command no longer opens a little graph depicting how much RAM each program is using. There's no longer much point. The answer is always, "exactly as much as it needs, and it's changing minute by minute."

Still, if you're desperate to know how much memory each of your running programs is using at this instant, open your Applications [image] Utilities folder. Open the program called Process Viewer. It presents a little table showing what percentage of your Mac's memory each running program is using (see Section 9.2.24).

Then there's the matter of virtual memory, which is a computer scheme that helps you open more programs simultaneously than should fit into the amount of RAM (electronic memory) your computer has. It works by using a chunk of hard drive space as temporary overflow RAM when necessary. Of course, real memory delivers information to your Mac's brain about 100 times faster than the hard drive, which is why virtual memory gained a reputation in the old Mac OS for slowing down your machine.

In Mac OS X, virtual memory is turned on all the time. But these days, virtual memory is far less likely to slow down your machine for a couple reasons: First, because each program uses only as much RAM as it needs to begin with, so far less is wasted; second, because virtual memory puts only pieces of your programs onto the hard drive. In any case, even if you have 50 programs open, Mac OS X devotes your Mac's actual RAM to whatever program is frontmost, so the active program doesn't grow sluggish. You'll notice the sluggishness kicking in only when switching programs or when working on an absolutely huge document that overwhelms your installed RAM. (Want to see how much virtual memory has kicked in? Mac OS X can show you. See Secrets of Virtual Memory for instructions.)

Therefore, if you find yourself receiving "out of memory" messages, which are otherwise unheard of in Mac OS X, it's probably because your hard drive is running out of space, thereby thwarting the efforts of Mac OS X's virtual memory scheme. Make more room—or install more RAM.

This Application menu (Figure 4-1) offers a number of commands pertaining to the entire program and its windows, including About, Quit, and Hide.

4.1.2 Quitting Programs

You quit a program in Mac OS X by pressing [image] -Q, which is the keyboard equivalent of choosing the Quit command. For Macintosh and Windows veterans, the only tricky part here is that the Quit command is no longer in the File menu—it's now at the bottom of the Application menu.

But Mac OS X offers two much more fun ways to quit a program:

  • Control-click a program's Dock icon and choose Quit from the pop-up menu.

  • When you've highlighted a Dock icon by pressing [image] -Tab to rotate through the running programs, type the letter Q without releasing the [image] key. The program quits instantly.

Figure 4-1. The first menu in every program lets you know, at a glance, which program you're actually in. One of the biggest changes veteran Mac users have to make in adopting Mac OS X is getting used to the fact that this new menu contains commands that, in Mac OS 9, were scattered among the File, , and right-side Application menus.

4.1.3 Force Quitting Programs

Everybody knows that Mac OS X is a rock-solid operating system, but that doesn't mean that programs never screw up. Individual programs are as likely as ever to freeze or lock up. In such cases, you have no choice but to force quit the program—to terminate it with a blunt instrument.

The big Mac OS X difference is that doing so doesn't destabilize your Mac, meaning you don't have to restart it. In fact, you can usually reopen the very same program and get on with your life.

You can force quit a stuck program in any of several ways. First, you can Control-click its Dock icon (or just hold your mouse down on it). Once the pop-up menu appears, press Option so that the Quit command now says Force Quit (see Figure 4-2). Bingo—that program is outta here.

Second, you can press Option- [image] -Esc, the traditional Mac force quit keystroke. Third, you can choose [image] [image] Force Quit. Either way, proceed as shown in Figure 4-2.

Again, force quitting is no longer bad for your Mac. Dire warnings no longer appear. The only downside to force quitting a program is that you lose any unsaved changes to your open documents.

Figure 4-2. Top: You can force quit a program from the Dock thanks to the Option key. Bottom: When you press Option- -Esc or choose Force Quit from the menu, a tidy box listing all open programs appears. Just click the one you want to abort, click Force Quit, and click Force Quit again in the confirmation box. (Using more technical tools like the Unix kill command, there are other ways to jettison programs. But this is often the most convenient.)
    [ Team LiB ]


4.2 Juggling Programs with the Dock

Mac OS X includes an elegant solution to tracking the programs you've opened: the Dock.

Chapter 3 describes the navigational features of this multi-purpose icon row—but once you've actually opened a program or two, it takes on a whole new purpose in life.

4.2.1 Switching Programs

The primary purpose of the Dock is simple: to let you know which programs are running. Only one can be in front, or active, at a time. (It's the program whose name appears at the upper-left corner of your screen, next to the [image] menu.)

To make a different program active, simply repeat the technique you used to launch the program initially. Click its Dock icon, double-click a document icon, or whatever.

Most people, however, switch to a different program by clicking its icon on the Dock. Doing so makes the program, along with any of its open windows and toolbars, pop to the front.

4.2.2 The New, Improved "Command-Tab"

Exactly as in older operating systems, you can also press [image] -Tab to switch between programs. But in Mac OS X 10.2, a single press of [image] -Tab takes you to the program you used most recently, and another press returns you to the program you started in.

In terms of productivity, this is an important change from previous versions of Mac OS X. Imagine that, for example, you're doing a lot of switching between two programs—your Web browser and your email program, for example. If you have five other programs open, you don't waste your time [image] -Tabbing your way through all open programs just to "get back" to your Web browser.

When Programs Are Actually Folders

You may have noticed that OS X programs don't seem to have 50,000 support files strewn across your hard drive. To open Internet Explorer, you no longer need to first open an Internet Explorer folder; you can just double-click the Internet Explorer icon itself. That's a much better arrangement than in Mac OS 9 or Windows, where many programs must remain in special folders, surrounded by libraries, dictionaries, foreign language components, and other support files and folders.

The question is: Where did all those support files go?

Mac OS X features something called packages or bundles, which are folders that behave like single files. Every properly written Mac OS X program looks like a single, double-clickable application icon. Yet to the Mac, it's actually a folder that contains both the actual application icon and all of its support files, which are hidden for your convenience. (In fact, even documents can be packages, including iDVD project files and TextEdit documents.)

If you'd like to prove this to yourself, try this experiment. Choose Go [image] Applications. See the Calculator program in the list? Control-click it. From the contextual menu, choose Show Package Contents. You're asking Mac OS X to show you what's inside the Calculator "application icon" folder.

The Calculator package window opens, revealing a Contents folder that you've never seen before. If you open this folder, you'll find a handful of strange-looking, Unix-named folders and files that are, behind the scenes, pieces of the Calculator program itself.

The application-as-folder trick is convenient for you, of course, because it means that you're free to move the application to a different window—or uninstall the program by dragging this single icon to the Trash—without worrying that you're leaving behind its entourage of support files. It's also convenient for programmers, because they can update certain aspects of their applications just by replacing one of these component files, without having to rewrite the entire program.

You can even try out this programmery benefit for yourself. In the case of the Calculator and many other Mac OS X programs, the Resources folder contains individual graphics file—PDF or TIFF files—that serve as the graphic elements that you see when using the program. For example, the file lcd.tif in the calculator's Resources folder contains the image of the calculator's screen (where the numbers appear as you punch the calculator number buttons). Using a graphics program, you can change the background of this light-yellow calculator screen to, say, light blue. The next time you double-click the Calculator—which you now realize is actually a folder behind the scenes—you'll see your modified calculator design.

Yet the older behavior (cycling through all programs) is still available. The trick here is to keep the [image] key pressed. Now, with each press of the Tab key, you highlight the Dock icon of another program, in left-to-right Dock order. Release both keys when you reach the one you want. Mac OS X brings the corresponding program to the front. (To move backward through the open programs, press Shift- [image] -Tab.)

4.2.3 Hiding Programs

If the open programs on your Mac are like overlapping sheets of paper on a messy desk, then hiding a program makes that individual sheet transparent. When a program is hidden, all of its windows, tool palettes, and button bars disappear. You can bring them back only by bringing the program to the front again (by clicking its Dock icon again, for example).

If your aim is to hide only the program you're currently using, Mac OS X offers a whole raft of approaches to the same problem. Many of them involve the Option key, as listed here:

  • Option-click any visible portion of the desktop. The program you were in vanishes.

  • Option-click any other program's icon on the Dock. You open that program (or bring all of its windows to the front) and hide all the windows of the one you were using.

  • Option-click any visible portion of another program's windows. Once again, you switch programs, hiding the one you were using at the time.

  • From the Application menu—the boldfaced menu that bears the program's name—choose Hide [Program Name].

  • When you've highlighted a Dock icon by pressing [image] -Tab to rotate through the running programs, press the letter H key. The program hides itself instantly. Leave the [image] key down the whole time, and after pressing the H, press Tab again to move on to the next program. If you release the keys while "stopped" on the program instead, you'll bring it forward rather than hiding it.

  • Press [image] -H. This may be the easiest and most useful trick of all (although it doesn't work in every program on earth). Doing so hides the program you're in; you then "fall down" into the next running program.

    TIP

    Consider this radical, timesaving proposal: Never quit the programs you use frequently. Instead, simply hit [image] -H whenever you're finished working in a program. That way, the next time you need it, the program launches with zero wait time. Because Mac OS X's virtual-memory scheme is so good, there's almost no downside to leaving your programs open all the time.

To un-hide a program and its windows, click its Dock icon again, or choose the Show All command in the Application menu.

TIP

The Dock continues to display the icons of all running programs without any indication that you've hidden them. Fortunately, that's easy enough to fix. All you need is the shareware program TinkerTool, which is described in Section 17.1. It offers a simple checkbox that makes hidden programs appear with transparent Dock icons.

4.2.4 Hiding All Other Programs

Choosing Hide Others from your program's Application menu means, of course, "hide the windows of every program but this one." It even hides your Finder (desktop) windows, although desktop icons remain visible.

Better yet, Mac OS X 10.2 adds a keystroke to this command: Option- [image] -H. That's one small step for keystrokes, one giant leap for productivity geeks.

If this trick interests you, you might also enjoy its Mac OS X-only corollary, described next.

4.2.5 The Bring-Forward, Hide-All-Others Trick

Here's a fantastic Mac OS X secret that has no precursor in Mac OS 9 or Windows. It's a terrific technique that lets you bring one program to the front (along with all of its open windows), and hide all other windows of all other open programs—all with one click. You might think of it as Hero mode, or Front-and-Center mode, or Clear My Calendar mode.

In any case, the trick is to Option- [image] -click the lucky program's icon on the Dock. As it jumps to the fore, all other windows on your Mac are instantly hidden. (You can bring them back, of course, by clicking the appropriate Dock icons.)

4.2.6 Hiding (Minimizing) Individual Windows

In Mac OS X, there's more to managing your window clutter than simply hiding entire programs. Now you can hide or show individual windows of a single program. In fact, Apple must believe that hiding a window will become one of your favorite activities, because it offers at least four ways to do so, including:

  • Click the Minimize button on the window's title bar, as shown in Figure 4-3.

  • Double-click the window's title bar.

  • Choose Window [image] Minimize Window, if your program offers such a command.

  • Press [image] -M.

TIP

If you press the Option key as you perform any of these techniques, you minimize all of your program's open windows to the Dock. (If you had several document windows open, they turn into side-by-side document icons on the Dock.) This isn't the same thing as hiding the entire program, as described previously—you remain in the same program, but now all of its windows are hidden.

Unfortunately, there's no way to bring them all back at once. You have to click their Dock icons one by one.

In any case, the affected window shrinks down until it becomes a new icon on the right side of the Dock. Click that icon to bring the window back.

Figure 4-3. When you click the center button on a window title bar, you minimize that window, getting it out of your way and off your screen. It's now represented by a window icon on your Dock—which you can click to reopen the window. (All of this should sound familiar if you've used Windows.)

4.2.7 Window Layering

Steel yourself for one big difference between Mac OS X and what came before. In Mac OS 9, bringing a program to the foreground also brought all of its windows to the foreground. If you were working in Internet Explorer, but Word was running in the background with six open documents, all six windows would pop to the front when you switched to Word.

As shown in Figure 4-4, however, Mac OS X takes a much more layered approach. It's entirely possible to wind up with the windows of different programs sandwiched and layered, front to back.

If you click a visible portion of a background program's window, or if you use the Dock's pop-up menus to choose a single document window (as shown in Figure 3-5), that layered, sandwiched effect is what you get.

Layered windows really shine when you're comparing two documents in two different programs, because it frees you of the window clutter of other open documents. But the time will come when you're ready to bring all of a background program's windows to the front. Get into the habit of clicking its Dock icon, rather than clicking inside one window. When you do that, all open windows in that application come forward, from wherever they may be.

Figure 4-4. Suppose you have Microsoft Excel in the foreground, but Word in the background. If you click within a visible portion of a background window, you bring only that window of Word to the front—a sandwiched effect that never would have been possible in Mac OS 9. The remedy for this situation, if it bothers you, is the Window Bring All to Front command, which appears in the Finder and many other programs. It brings all of a program's windows to the front. (You can do the same thing by simply clicking the program's Dock icon.)

4.2.8 Using the Dock for Drag-and-Drop

As described on the next page, the Mac is smart about the relationship between documents and applications. If you double-click an AppleWorks document icon, for example, the AppleWorks program launches automatically and shows you the document.

But these days, it's occasionally useful to open a document using a program other than the one that created it. Perhaps, as is often the case with downloaded Internet graphics, you don't have the program that created it, or you don't know which one was used.

In such cases, the Dock is handy: Just drag the mystery document onto one of the Dock's tiles, as shown in Figure 4-5. Doing so forces the program to open the document—if it can.

TIP

Only Dock icons of programs that can, in fact, open the file you're dragging become highlighted. The others just shrug indifferently or even scoot aside, thinking you're trying to drag the file into the dock.

Pressing Option- [image] as you drag forces them to be more tolerant. Now all Dock program icons "light up" as your document touches them, indicating that they'll try to open your file. Even so, a "could not be opened" error message may result. As they say in Cupertino, sometimes what a can really needs is a can opener.

Figure 4-5. To open a document using a program that didn't create it, drag the document icon onto the corresponding Dock tile. This technique is ideal for opening a downloaded graphics file into your favorite graphics program (such as AppleWorks or GraphicConverter). It's also useful when opening a Read Me file into your word processor, such as Word, instead of the usual TextEdit program.
    [ Team LiB ]


4.3 How Documents Know Their Parents

Every operating system needs a mechanism to associate documents with the applications that created them. When you double-click a Microsoft Word document icon, for example, it's clear that you want Microsoft Word to launch and open the document.

In Windows, every document bears a three-letter file name suffix. If you double-click something called memo.doc, it opens in Microsoft Word. If you double-click memo.wri, it opens in Microsoft Write, and so on.

Mac OS 9 uses a similar system, except that you never see the identifying codes. Instead, it relies on invisible, four-letter creator codes and type codes. Apple carefully monitors and tracks these four-letter codes, in conjunction with the various Mac software companies, so that no two codes are alike.

As a Macintosh/Unix hybrid, Mac OS X uses both creator codes (like Mac OS 9) and file name suffixes (like Windows).

It's possible to live a long and happy life without knowing anything about these codes and suffixes. Indeed, the vast majority of Mac fans may never even encounter them. But if you're prepared for a little bit of technical bushwhacking, you may discover that understanding creator/type codes and file name suffixes can be useful in troubleshooting, keeping your files private, and appreciating how Mac OS X works.

4.3.1 Type and Creator Codes

A Macintosh document's four-letter creator code identifies the program that will open it.

If you're feeling especially inquisitive, restart your Mac in Mac OS 9 and open Sherlock ( [image] -F). (Or, if you're running in Classic, choose [image] [image] Sherlock.) Click Edit, and then drag the icon in question anywhere onto the Sherlock screen, as shown in Figure 4-6. As a little experimentation will soon show you, the creator code for a program and the documents it creates are identical—MSWD for Microsoft Word, FMP3 for FileMaker Pro, and so on. That's the entire point: The creator code tells the Mac which program to open when you double-click a particular document.

Sherlock also reveals the second four-letter code in the DNA of most Macintosh icons: the type code. This code specifies the document's file format. Photoshop, for example, can create graphics in a multitude of different formats: GIF, JPEG, TIFF, and so on. If you inspect your Photoshop documents, you'll discover that they all share the same creator code, but have a wide variety of type codes.

TIP

If the type code is supposed to identify the file format of a document, does a standard application have a type code?

It does: APPL.

When you double-click a document, Mac OS X checks to see if it has a creator code. If so, it then consults an invisible database of icons and codes. This database is the master index that lists the correspondence between creator codes and the applications that generate them. Together, the type and creator codes also specify which picture appears on a particular icon.

If the desktop file discovers a match—if, say, you double-clicked a document with creator code BOBO, which corresponds to the AppleWorks entry in your desktop database—then the corresponding program opens the document, which now appears on your screen.

Figure 4-6. Drag any icon from the desktop directly into Sherlock's More Search Options screen to view the icon's creator code, highlighted here at lower right. (Unfortunately, this feature doesn't work in the Mac OS X version of Sherlock.) Capitalization and spaces count, so if you see a creator code that appears to have only three letters, then a space at the end is also part of the code.

4.3.2 File Name Extensions

In Mac OS 9, it was easy to spot a document whose type and creator codes had somehow become muddled. Its icon resembled a plain white piece of paper with a dog-eared corner. That was your cue that the Macintosh couldn't find an entry for its type and creator codes in your desktop database, or that your desktop database had become corrupted.

In Mac OS X, however, plenty of documents don't have type and creator codes. Documents created by Cocoa applications (Section 4.6), for example, generally don't.

That's because Mac OS X is a Unix operating system. In Unix, type and creator codes are unheard of. Instead, what determines which program opens when you double-click a document is its file name extension, just as in Windows. A file name extension is identifiable by a suffix following a period in the file's name, as in Letter to Mom.doc.

In Mac OS X, the file name extension can be much longer. It can even identify the name of the program that will open when you double-click something. The file called Registration.setup, when double-clicked, launches the Mac OS X Setup application.

The bottom line is that Mac OS X offers two different mechanisms that associate documents with the programs that created them. Mac OS X looks for type and creator codes first. Where they're absent, the file name suffixes kick in.

4.3.3 Hiding and Showing File Name Extensions

Mac OS X comes set to hide most file name extensions on the premise that they make the operating system look more technical and threatening. If you'd like to see them, however, choose Finder [image] Preferences and turn on "Always show file name extensions." Now examine a few of your documents; you'll see that their names now display the previously hidden suffixes.

You can hide or show these suffixes on an icon-at-a-time basis, too (or a clump-at-a-time basis). Just highlight the icon or icons you want to affect and then choose File [image] Get Info. In the resulting Info window, proceed as shown in Figure 4-7.

Figure 4-7. Top: In the Info window, open the Name & Extension panel. Now you can see what Mac OS X really thinks your file is called. Turn "Hide extension" on or off if you'd like to see the file name suffix in the Finder. Bottom: If you try to add a suffix of your own, Mac OS X objects, in effect saying, "Hey—I've already got a file name extension for this, even if you can't see it. Are you sure you know what you're doing?"

4.3.4 Reassigning Documents to Programs

Unfortunately, type and creator codes aren't of much use when you encounter a document created by a program that you don't have. If I email you a MIDI file (a file-exchange format for music) that I exported from my Finale sheet music program, you won't be able to open it simply by double-clicking, unless you, too, have Finale installed. Even if you have a different sheet music program on your hard drive, just double-clicking the MIDI file won't, by itself, open it.

The file name extension system, meanwhile, has problems of its own. File name extensions are even less likely to pinpoint which parent program should open a particular document. Suppose you've downloaded a graphic called Sunset.JPG. Well, almost any program these days can open a JPEG graphic—AppleWorks, Word, Preview, Internet Explorer, and so on. How does Mac OS X know which of these programs to open when you double-click the file?

The answer is simple. You can reassign a document to a specific program (or all documents of its kind). Here's the rundown:

4.3.4.1 Reassigning a certain document—just once

Double-clicking a graphics file generally opens it in Preview, the graphics viewer included with Mac OS X (see Section 9.1.16). Most of the time, that's a perfectly good arrangement. But Preview can only display graphics—it can't edit them. What if you decide to edit a graphics file? You'd want it to open, just this once, into a different program—GraphicConverter, for example.

To do so, you must access the Open With command. You can find it in two places:

  • Highlight the icon, and then choose File [image] Open With.

  • Control-click the file's icon (or right-click it, if your mouse has two buttons). From the contextual menu, choose Open With.

In any case, study the submenu for a moment (Figure 4-8, left). The program whose name says "(default)" indicates which program usually opens this kind of document. From this pop-up menu, choose the name of the program you'd rather open this particular file, right now, just this once.

4.3.4.2 Reassigning a certain document—permanently

After opening a TIFF file in, say, GraphicConverter for editing, you haven't really made any changes in the fabric of your Mac universe. The next time you double-click that file, it will open once again in Preview.

If you wish this particular file would always open in GraphicConverter, the steps are slightly different. In fact there are three different ways:

  • Extend the one-shot reassignment method illustrated in In the Choose an Application dialog box, turn on "Always Open With" (shown at right in Figure 4-8).

  • Start out with one of the techniques described above (highlight the icon, and then choose File [image] Open With, or Control-click the file's icon and choose Open With)—but after you see the menu, press the Option key, too. Before your very eyes, the Open With command changes to say Always Open With.

  • Highlight the icon, and then choose File [image] Get Info. Open the "Open with" panel. Choose a new "parent" program's name from the pop-up menu. You'll see that the word "(default)" changes position, now tacking itself onto the name of the new program you've chosen.

    TIP

    You can use the Get Info method to reassign the parenthood of a whole flock of selected icons at once. Once you've selected them, just choose File [image] Get Info, open the "Open with" panel, and choose a new program from the pop-up menu. The message at the top of the window—"22 items," for example—reminds you that you're changing the whole batch at once.

Figure 4-8. Left: The contextual menu offers a list of programs capable of opening an icon.. Right: If you choose Other, you'll be prompted to choose a different program. Turn on "Always Open With" if you'll always want this document to open in the new parent program; otherwise, this is a one-time reassignment.
4.3.4.3 Reassigning all documents of this type

So much for reassigning one document (or group of documents) at a time. What if you're writing, say, a book about Mac OS X, and you've been taking a lot of screenshots? Mac OS X saves each captured screen illustration as a graphics file in TIFF format. That's all fine, except that every time you double-click one of these, it opens into Preview, where you can't edit—you can only look.

Sure, you could reassign all of these files, one at a time, to a different program, but your grandchildren would be retired by the time you finish. In this case, you want to tell Mac OS X, "For heaven's sake, make all TIFF files open in Photoshop from now on!"

To make it happen, use the Get Info method described previously. (You can't do it using the File [image] Open With command, nor by Control-clicking the icon.)

Start by highlighting any TIFF file. Choose File [image] Get Info. Open the "Open with" panel.

From its pop-up menu, choose the program you want to open this kind of document from now on. (If the one you prefer isn't listed, use the Other option, which opens the Choose Application dialog box so that you can navigate to the one you want. Find, and double-click, the program.)

This time, however, follow up by clicking Change All beneath the pop-up menu. (This button is dimmed until you've actually selected a different program from the pop-up menu.) Mac OS X asks you to confirm by clicking Continue or pressing Enter.

From now on, double-clicking any similar kind of document opens it in the newly selected program.


4.4 Controlling Menus from the Keyboard

Mac OS X offers a fantastic feature for anyone who believes that life is too short: keyboard-controllable menus, dialog boxes, pop-up menus, and even Dock pop-up menus. You can operate every menu in every program without the mouse or add-on software.

4.4.1 What You Can Do with Keyboard Control

Once you've turned on Keyboard Access (see below for instructions), menus aren't the only thing you'll be able to control from the keyboard. As Figure 4-9 makes clear, the possibilities include:

  • Menu bar. Once Full Keyboard Access is turned on, the first menu on your screen drops down when you press a Control-key combination of your choice (such as Control-M). At this point, you can highlight individual commands on that menu by pressing the up or down arrow keys; open a different menu by pressing the right and left arrow keys (or Tab and Shift-Tab); and "click" a menu command by pressing Enter. You can also close the menu without making a selection by pressing Esc, [image] -., or the Space bar.

    Over time, as you learn precisely how many Tabs and arrow keys you need to trigger certain commands, you can master this technique.

  • Dock. Operate the Dock by keyboard alone? Sure, that's easy enough: Just press [image] -Tab to cycle through the open programs. Everybody knows that.

    But [image] -Tab just highlights successive icons of open programs on the Dock. It skips over the icons of folders, disks, documents, and programs that aren't yet open.

    If you turn on Full Keyboard Access, you get much more flexibility. For instance, once you've pressed the "highlight the Dock" Control-key stroke of your choice, you can highlight any icon on the Dock by pressing the right or left arrow keys (or, once again, Tab and Shift-Tab).

    Then, once you've highlighted a Dock icon, you "click it" by pressing Enter. Again, if you change your mind, press Esc, [image] -., or the Space bar.

    TIP

    Once you've highlighted a disk or folder icon, you can press the up arrow to make the list of its contents appear. Using the arrow keys, you can now highlight and open virtually anything in any disk or folder on the Dock. Similarly, once you've highlighted the icon of an application that has several windows open, you can press the up and down arrows to highlight the name of an individual window. When you press Enter, that window pops to the front.

  • Window (active) or next window behind it. This command lets you switch windows using keyboard control. Every time you press Control-F4, you bring the next window forward, eventually cycling through every window in every open program. Add the Shift key to cycle through them in the opposite order.

    TIP

    You may remember from Chapter 1 that Mac OS X offers a different keystroke for cycling through the different windows in your current program (it's [image] -~, the tilde symbol at the upper-left of your keyboard). Control-F4, on the other hand, tours all windows in all programs. Both keystrokes are useful in different situations.

  • Toolbar. This one works in most programs that display a Mac OS X-style toolbar: System Preferences, Sherlock, the iPhoto editing window, and so on. (Ironically, this one does not work in the Finder.) It also works only if you've turned on the "Any control" button at the bottom of the dialog box shown in Figure 4-9.

    When you press Control-F5, you highlight the first button on that toolbar. Move the "focus" by pressing the arrow keys or Tab and Shift-Tab. Then tap the Space bar to "click" the highlighted button.

  • Utility window (palette). In a few programs that feature floating tool palettes, Control-F6 highlights the frontmost palette. At this point, use the arrow keys to highlight the various buttons on the palette. You can see the effect when, for example, you're editing text in TextEdit and you've also opened the Font palette. Pressing Control-F6 highlights the Font palette, taking the "focus" off your document.

4.4.2 Turning on Full Keyboard Access

Apple made sure that this feature was turned off by default, to avoid freaking out people who sometimes set their sandwiches down on the keyboard between bites. But it's easy enough—and well worthwhile—to turn on.

Start by opening System Preferences (click its icon on the Dock, for example). Click Keyboard, and then click the Full Keyboard Access tab (see Figure 4-9). Turn on "Turn on full keyboard access."

You've just powered up one of Mac OS X's most useful timesavers.

TIP

In the future, you can skip all of these steps. Just turn keyboard control on or off by pressing Control-F1.

Using the "Press Control (Ctrl) with" pop-up menu, instruct the Mac how you'll be triggering commands. You have the following three choices:

  • Function keys. In any program, no matter what you're doing, you'll be able to seize control of the menus by pressing Control-F2 (that is, the F2 key at the top of your keyboard). Similarly, you'll activate the Dock, toolbars, palettes, and other elements by pressing Control-Fkey combinations, as illustrated in Figure 4-9.

  • Letter keys. This option will probably give you a lot less trouble remembering how to operate the various keyboard-controllable elements of your Mac. Just press Control-M to highlight the menu bar, Control-D to highlight the Dock, and so on.

  • Custom keys. This option lets you define your own keystrokes for operating the various keyboard-controllable elements. Just remember that the Control key is always required, along with any letter, number, or function key you want to trigger the five options displayed in the dialog box.

Figure 4-9. The Full Keyboard Access panel of the Keyboard control panel lets you specify how you'd like to control your menus and other Mac OS X interface elements without using the mouse.

NOTE

In Microsoft Office programs and several others, these key combinations may already come assigned to certain functions. Mac OS X will intercept these keystrokes.

Although you might not know it by studying the dialog box, Mac OS X also lets you navigate any dialog box from the keyboard. The choices at the bottom of the window specify how it works:

  • When "Text input fields" is turned on, the Tab key does what it's always done on the Mac: move your insertion point from one text box to the next within a dialog box.

  • When you turn on "Any control," pressing Tab highlights the next control of any type, whatever it may be—radio button, pop-up menu, and so on. Press the Space bar to "click" a button or open a pop-up menu. (Once a menu is open, use the arrow keys to highlight commands on it, and the Space bar to "click" your choice.)

Tab-key navigation doesn't work in every dialog box in every program. When it does work, though, it's extremely useful.


4.5 The Save and Open Dialog Boxes

For years, the least satisfying part of using a computer was saving a newly typed document. When you used File [image] Save, a dialog box appeared, in which you were supposed to type a name for, and specify the file format for, the new file you were saving.

To the beginner, these specifications are confusing and unnatural. They bear no resemblance to any real-world process. Nobody asks you to name cookies you've just baked, or what file format you'd like them to assume as they come out of the oven.

But it gets worse. In the Save dialog box, you're also asked where you want the new document stored on your hard drive. Filing a document away in a folder does have a real-world equivalent; that's why it's so easy to understand the folder icons on the Mac desktop. Unfortunately, compared with the Finder's self-explanatory folder display, the old Save dialog box's presentation of your hard drive's contents was about as friendly as a tax form, as Figure 4-10 illustrates. All of these factors conspired to make the old Save dialog box—and its sibling, the Open File dialog box—among the most challenging parts of the Mac operating system (and Windows, too).

All of this explanation is necessary to understand why Apple, and specifically Steve Jobs in his stage presentations, gets so excited about the way Mac OS X's Save and Open dialog boxes work.

To give it a try, launch any included Mac OS X program that has a Save or Export command—TextEdit, for example. (Not all programs from other software companies have yet updated their Save dialog boxes.) Type a couple of words and then choose File [image] Save. The Save sheet appears.

TIP

In Mac OS X, a quick glance at the Close button in the upper-left corner of a document window tells you whether it's been saved (see Figure 4-10). When a small dot appears in the red button, it means you've made changes to the document that you haven't yet saved (time to press [image] -S!). The dot disappears as soon as you save your work.

Figure 4-10. Top: The old Save dialog box, an inevitable part of computing, displays a list of the folders on your hard drive—but where are you? What folder is this one inside of? Bottom: In Mac OS X, you can see a familiar column display that matches the Finder, making it much easier to figure out what you're doing and how you got here.

4.5.1 Sheets

In the days of antique operating systems like Mac OS 9 and Windows, the Save dialog box appeared dead center on the screen, where it commandeered your entire operation. You weren't allowed to switch to any other program—or do anything else—until you clicked Save or Cancel to close the dialog box. Moreover, because it seemed stuck to your screen rather than to a particular document, you couldn't actually tell which document you were saving—a real problem when you quit out of a program that had three unsaved documents open. All of this struck Mac OS X's designers as user-hostile and unnecessarily rigid.

In most Mac OS X programs, there's no mystery regarding which document you're saving, because a little Save dialog box called a sheet slides directly out of the document's title bar (see Figure 4-11). Now there's no mistaking which document you're saving.

Better still, you can think of this little Save box as a sticky note attached to the document. It will stay there, neatly attached and waiting, even if you switch to another program, another document within the same program, the desktop, or wherever. When you finally return to the document, the Save sheet will still be there, waiting for you to type a file name and save the document.

Figure 4-11. Top: The new Save dialog box, or sheet, initially appears in a compact view. Inset: To spare you from navigating your hard drive every time you save a file, your most recently accessed folders are listed in the Where pop-up menu. Bottom: If you want to choose a different folder, create a new folder, or designate a Favorite folder, click the Column-view triangle to open this Finder-like navigation view.

4.5.2 Simplified Navigation

Of course, you, O savvy reader, have probably never saved a document into some deeply nested folder by accident, never to see it again. But millions of novices (and even a few experts) have fallen into this trap.

When the Save sheet appears, however, a pop-up menu shows you precisely where Mac OS X proposes putting your newly created document: in the Documents folder of your own Home folder. For many people, this is an excellent suggestion. If you keep everything in your Documents folder, it will be extremely easy to find, and you'll be able to back up your work just by dragging a single folder (the Documents folder) to a backup disk.

But the Where pop-up menu gives you direct access to some other places you might want to save a newly created file. They include:

  • Desktop. Just type a name for the file, choose Desktop from this pop-up menu, and then click Save. (You can also simply press [image] -D.)

    You've just ensured that your file won't fall accidentally into some random folder. Instead, the newly minted document will be waiting for you on the desktop when you quit your program or close its window. From there, you can drag it manually into any folder you like.

    TIP

    To open the Where pop-up menu—or any pop-up menu, for that matter—you don't have to click the tiny, blue, double-headed triangle button at the right end. You can click anywhere on the pop-up menu, such as where it says Documents.

  • Home. Choosing this item from the pop-up menu (or pressing Shift- [image] -H) takes you directly to your Home folder, which is described in Section 2.1.

  • iDisk. If you've signed up for Apple's .Mac service (Section 18.8), you can save documents directly onto your Internet-based iDisk hard drive just by choosing this command. (Actually, you can't save icons into your iDisk window—you must save them into a folder within your iDisk. That's why the submenu of this iDisk command lists the various folders on your iDisk, as described in Chapter 18.)

    When you do so, your Mac will dial and connect to the Internet (if you're not already online) and pull your iDisk onto the screen so that you can save your new document there. All of this takes a considerable amount of time, even if you have a high-speed connection like a cable modem or DSL.

  • Favorite Places. This part of the pop-up list is a duplicate of the Favorites menu in the Finder, which is described in Chapter 2. Its purpose is to list the disks, servers, folders, and other items you use frequently, so that you don't need to burrow through your folders every time you want access.

  • Recent Places. This part of the menu lists folders and disks you've accessed recently. Once again, the idea is to provide quick access to the folder locations on your hard drive that matter to you—without excessive navigation.

4.5.3 Column-View Navigation

When you save a file, the options in the Where pop-up menu have you covered 90 percent of the time. Most people work with a limited set of folders for active documents.

But when you want to save a new document into a new folder, or when you want to navigate to a folder that isn't listed in the Where pop-up menu, all is not lost. Click the large black triangle shown in Figure 4-11.

After a moment, a familiar scene appears: a compact version of a Finder-window column view, as described in Section 1.6.

TIP

Your first instinct should be to widen this window, making more columns available. Do so by carefully dragging the lower-right corner of the dialog box. Mac OS X will remember the size you like for this Save sheet independently in each program.

Now, using many of the same techniques described in Section 1.6, you can navigate your entire Mac system. For example, press the right and left arrow keys to navigate the columns, or the up and down arrow keys to highlight the disk and folder names within a column. Once you've highlighted a column, you can also type to select the first letters of disk or folder names.

Highlight the name of the folder in which you want to save your newly created document, or use these options:

  • New Folder. Click this button to create a new folder inside whatever folder is highlighted in the column view. You'll be asked to type the new name for the folder. After you've done so, click Create (or press Enter). The new folder appears in the rightmost panel of the column view. You can now proceed with saving your new document into it, if you like.

    NOTE

    The keystroke [image] -N no longer triggers the New Folder button. Remember that in Mac OS X, the Save sheet is nothing more than an attachment to your document window. Keystrokes like [image] -N go right "past" the sheet to the program you're using. In Microsoft Word or TextEdit, for example, pressing [image] -N produces a new, untitled Word or TextEdit document, which appears right in front of the Save sheet.

  • Add to Favorites. In addition to the methods described in Section 2.6, the Save sheet provides a quick way to add a particular folder to your list of Favorites. Just highlight the folder in the column view and then click Add to Favorites. The favorite folder appears instantly in the Where pop-up menu—in the Favorites section, of course.

    The point is that the next time you save a new document, you won't even have to bother with the column view. You'll be able to jump quickly to the favorite folder you've just specified.

The next time you save a new document, the Save sheet will reappear in whatever condition you left it. That is, if you used column view the last time, it will still be in column view. At any time, you can collapse it into simplified view, shown at top in Figure 4-11, by again clicking the fat black triangle to the right of the Where pop-up menu.

4.5.4 Insta-Jumping to a Folder Location

Whether you're using the mini-sheet or the column view, you can drag the icon of any folder or disk from your desktop directly into the Save or Open sheet, as shown in Figure 4-12. Mac OS X instantly displays the contents of that folder or disk.

This shortcut can save you time when you want to save a file into, or open a file from, a deeply nested folder that's already visible in the Finder. This feature is totally undocumented—but well worth learning.

Figure 4-12. The quickest way to specify a folder location when you're saving a file is to drag a folder or disk directly into the Save sheet. You'll see by the Where pop-up menu that Mac OS X has indeed understood your intention.

4.5.5 The File Format Pop-up Menu

Although it's by no means universal, the Save dialog box in many programs offers a pop-up menu of file formats below the Save As box. Use this menu when preparing a document for use by somebody else—somebody whose computer doesn't have the same software. For example, if you've used a graphics program to prepare a photograph for use on the Web, this menu is where you specify JPEG format (the standard Web format for photos).

4.5.6 The Open File Dialog Box

The dialog box that appears when you choose File [image] Open is almost identical to the Save File sheet, except that it offers both the pop-up menu of frequently used folders (now labeled From instead of Where) and the column view (see Figure 4-13). Because you encounter it only when you're opening an existing file, this dialog box lacks the New Folder button, Save button, file name field, and so on.

Most of the other Save File dialog box controls, however, are equally useful here. Once again, you can begin your navigation by seeing what's on the desktop (press [image] -D) or in your Home folder (press Shift- [image] -H). Once again, you can open a folder or disk by double-clicking its name in the column-view list, or navigate the list by pressing the arrow keys. (Unfortunately, typing to highlight folder and disk names in the columns doesn't work here.) And once again, you can drag a folder or disk off your desktop directly into the dialog box to specify where you want to look.

When you've finally located the file you want to open, do so by double-clicking it or highlighting it (which you can do from the keyboard), and then pressing Return, Enter, or [image] -O.

In general, most people don't encounter the Open File dialog box nearly as often as the Save File dialog box. That's because the Mac offers many more convenient ways to open a file—double-clicking its icon in the Finder, choosing its name from the [image] [image] Recent Items command, and so on—but only a single way to save a new file.

TIP

Instead of using the column view to specify a folder, you can also use the Go To box at the bottom of the Open sheet. That is, you can type a folder path (such as ~/pictures or ~/pi and a Tab) right into the blank. And if you have no idea what these codes refer to, see the box in The Go to Folder Command.

Figure 4-13. Mac OS X's Open dialog box shows you only icons for disks, folders, and documents that you can actually open at this moment. For example, when using Preview as shown here, Word and TextEdit documents appear dimmed and unavailable, while picture files show up fine.
    [ Team LiB ]


4.6 Three Kinds of Programs: Cocoa, Carbon, Classic

Mac OS X was supposed to make life simpler. It was supposed to eliminate the confusion and complexity that the old Mac OS had accumulated over the years—and replace it with a smooth, simple, solid system.

Five years from now, that's exactly what Mac OS X will be. For the moment, however, you're stuck with running three different kinds of programs, each with different characteristics: Cocoa, Carbon, and Classic.

The explanation involves a little bit of history and a little bit of logic. To take full advantage of Mac OS X's considerable technical benefits, software companies must write new programs for it from scratch. So what should Apple do—send out an email to the authors of the 18,000 existing Mac programs, suggesting that they throw out their programs and rewrite them from the bottom up?

At big companies like Microsoft and Adobe, such a suggestion would wind up on the Joke of the Week bulletin board.

Instead, Apple gave software companies a break. It wrote Mac OS X to let programmers and software companies choose precisely how much work they wanted to put into compatibility with the new system. The various levels include:

  • Do nothing at all (Classic). Let's face it: Software companies go out of business, unprofitable product lines are dropped, and shareware authors go off to law school. All of them leave behind orphaned programs that run only on the old Mac OS.

    Your Mac OS X machine can still run this entire library of older software. When you try to open one of these older programs, Mac OS X launches a Mac OS 9 simulator called the Classic environment. Suddenly your screen is taken over by the ghost of Mac OS 9. Sure, you leave behind all the trappings (and benefits) of Mac OS X—its new look, the Dock, crash protection, and so on—but at least you're still running your favorite programs.

    The point here is that Mac OS X doesn't relieve you of having to know Mac OS 9. Like it or not, until a huge library of Mac OS X programs is available, most people wind up having to master both Mac OS X and certain elements of Mac OS 9.

    See Chapter 5 for much more detail on the Classic environment.

  • Update the existing programs (Carbon). If software companies and programmers are willing to put some effort into getting with the Mac OS X program, they can simply adapt, or update, their existing software so that it works with Mac OS X. The resulting software looks and feels almost every bit like a true Mac OS X program—you get the crash protection, the good looks, the cool-looking graphics, the Save sheets, and so on—but behind the scenes, the bulk of the computer programming is the same as it was in Mac OS 9. These are what Apple calls Carbonized programs, named for the technology (Carbon) that permits them to run on Mac OS X.

    Most Carbonized programs don't offer all of the features available to Mac OS X, however. In the following pages, you'll discover which Mac OS X goodies you sacrifice when using programs adapted in this way.

    On the other hand, such software offers a spectacular feature that software companies like a lot: the ability of a single Carbonized program to run on both Mac OS 9 and Mac OS X. (Not all do—Microsoft Office X doesn't run on Mac OS 9—but they all can, if their programmers choose to make it so.) For the next few years, most of the big-name software companies will produce nothing but Carbonized programs.

    Other examples of Carbonized programs include AppleWorks, iMovie, iTunes, Photoshop, FileMaker, Internet Explorer, and, believe it or not, the Finder itself.

  • Write new programs from scratch (Cocoa). As Mac OS X becomes a bigger and bigger hit, more and more programmers and software companies create new programs exclusively for it. The geeks call such programs Cocoa applications—and they're the best of all. Although they look exactly like Carbonized programs, they feel a little bit more smooth and solid. More important, they offer a number of special features not offered by Carbonized programs.

    Many of the programs that come with Mac OS X are true Cocoa applications, including iChat, iPhoto, TextEdit, Stickies, Mail, Address Book, and so on.

    TIP

    Having trouble keeping the definitions of Carbon and Cocoa straight? You wouldn't be alone; it's like reading a novel where two characters' names start with the same letter. Here's one way to remember: Carbon programs are generally the older ones, those that might require carbon dating techniques to calculate their ages.


4.7 The Cocoa Difference

Here are some of the advantages offered by Cocoa programs. It's worth reading—not to make you drool about a future when all Mac programs will fall into this category, but to help clear up any confusion you may have about why certain features seem to be only occasionally present.

NOTE

The following features appear in almost all Cocoa programs. That's not to say that you'll never see these features in Carbonized programs; the occasional Carbon program may offer one of these features or another. That's because programmers have to do quite a bit of work to bring them into Carbon applications—and almost none to include them in Cocoa ones.

4.7.1 The Fonts Panel

The Mac has always been the designer's preferred computer, and Mac OS X only strengthens its position. For one thing, Mac OS X comes with about 100 absolutely beautiful fonts that Apple licensed from commercial type companies—about $1,000 worth, according to Apple.

When you use a Carbon program, you usually access these fonts the same way as always: using a Font menu. But when you use a Cocoa program, you get the Fonts panel, which makes it far easier to organize, search, and use your font collection (see Figure 4-14).

Figure 4-14. You'll find the Fonts panel only in Cocoa programs. As you adjust your font selections, you see the highlighted text in your program updated instantly.

See Chapter 13 for much more on fonts—and using the Fonts panel.

4.7.2 Title Bar Tricks

You may remember from Chapter 1 that the title bar of every Finder window harbors a secret pop-up menu. When you [image] -click it, you're shown a little folder ladder that delineates your current position in your folder hierarchy. You may also remember that the tiny icon just to the left of the window's name is actually a handle that you can drag to move a folder into a different window.

In Cocoa programs, you get the same features in document windows, as shown in Figure 4-15. (This feature is available in some Carbonized programs, but it isn't a sure thing.) By dragging the tiny document icon next to the document's name, you can perform these two interesting stunts:

  • Drag to the desktop. By dragging this icon to the desktop, or onto a folder or disk icon, you create an instant alias of the document you're working on. This is a useful feature when, for example, you're about to knock off for the night, and you want easy access to whatever you've been working on when you return the next day.

  • Drag to the Dock. By dragging this title-bar icon onto the Dock icon of an appropriate program, you open your document in that other program. For example, if you're in TextEdit working on a memo, and you decide that you'll need the full strength of Microsoft Word to dress it up, you can drag its title-bar icon directly onto the Word icon in the Dock. Word then launches and opens up the TextEdit document, ready for editing.

Unfortunately, you can't drag an open document directly into the Trash—a technique that could come in handy for writers who struggle with first drafts.

Figure 4-15. Top: By dragging the document-window proxy icon, you can create an alias of your document on the desktop or anywhere else. Bottom: If you -click the name of the document in its title bar, you get to see exactly where this document sits on your hard drive. (Choosing the name of one of these folders opens that folder and switches you to the Finder.)

4.7.3 Services

Apple has always dreamed of a software architecture that would let you mix and match features from different programs—using the AppleWorks spelling checker in Microsoft Word, the drawing tools of PowerPoint in your email program, and so on. (Remember Apple's OpenDoc software project? Neither does anybody else.)

In Mac OS X, Apple's dream has finally become a reality. Nestled in the Application menu of every Mac OS X program is a command called Services. Its submenu lists several functions that technically belong to other programs, as described below.

Unfortunately, these commands are dimmed when you use most Carbonized programs (like AppleWorks, Microsoft Office, and Internet Explorer). They become available only when you use Cocoa programs like iChat, TextEdit, Mail, OmniWeb—and, in Mac OS X 10.2, the Finder. (Yes, the Finder was a Carbon program up through 10.1.5. But remember that programmers can add Cocoa features to their older, Carbonized programs; it just takes a lot of work.)

Here's a rundown of what they do.

NOTE

Not all of these Services work in all programs—even Cocoa programs. Implementing them is left to programmers' discretion. In these early days of Mac OS X, a little unpredictability along these lines is par for the course.

4.7.3.1 Finder

The three commands listed in this submenu work only in one situation: When you've highlighted some text that precisely matches the name and folder path of any icon, such as ~/Documents/Marge.jpg). (Details on path notation in The Go to Folder Command.)

At that point, you can choose any of these commands from the Services [image] Finder submenu:

  • Open. Opens the icon. This is a mind-blowing possibility—in effect, it lets you open any file on your hard drive, from within any Cocoa program, without having to switch to the Finder. If you work in Microsoft Word all day, for example, you could keep a list of your favorite files and programs in a Word document, ready for opening without having to leave the program.

  • Reveal. Takes you to the Finder, where the specified icon is highlighted and its enclosing folder opened into a window.

  • Show Info. Switches to the Finder, where the Get Info window for the specified file opens, for your inspection pleasure.

If what you've highlighted isn't the name and path of a document, you'll get only an error message.

4.7.3.2 Grab

Grab is a screen-capture program in your Applications [image] Utilities folder. You use it to turn what you see onscreen into graphics files. This is especially handy when writing computer books or training manuals.

The point here is that you can take your software snapshot from within any Cocoa application, without having to go find and launch Grab separately. You'll find details on its submenu commands (Screen, Selection, Timed Screen) in Section 9.2.15.

4.7.3.3 Mail

This handy command springs to life only after you've highlighted some text in a Cocoa program—or a file in the Finder.

  • Send File. This option appears only if you've highlighted an icon in the Finder. It's a spectacular convenience: In one swift step this command opens the Mac OS X Mail program (Chapter 19), creates a new outgoing message, and attaches your highlighted file. All you have to do is address the message, send it, and exult in the tedium you've been spared.

  • Send Selection. In one step, the Mail Text command launches the Mail program and pastes the highlighted text into the body of a new, outgoing email message. You're saved the trouble of copying, launching Mail, creating a new message, and pasting. You might use this feature when, for example, you find something interesting on a Web page, and you'd like to email it to someone.

  • Send To. This command is useful only if you've highlighted an email address in a text document. This command, too, switches to Mail and creates a new, outgoing message—but this time, Mac OS X pastes the text you've highlighted into the "To" field.

4.7.3.4 Make New Sticky Note

This command copies whatever text you've got highlighted, switches to your Stickies program (Section 9.1.19), creates a new sticky note, and pastes your selected material in it. If you're the kind of person who keeps your life—lists, passwords, favorite URLs, to do list, notes, and so on—in Stickies, this one can save you considerable hassle. No wonder Apple endowed it with its own keyboard shortcut: Shift- [image] -Y.

4.7.3.5 Speech

As detailed in Chapter 14, Mac OS X doesn't just display text onscreen—it can actually read it out loud.

  • Start Speaking Text. Start by highlighting some text in a Cocoa program. Then choose this command, and presto: The Mac actually reads the text out loud, using the character voice you've chosen in System Preferences (Section 14.5).

  • Stop Speaking. This command makes the Mac shut up.

    TIP

    If you highlight an icon in the Finder, the Start Speaking Text command reads its path to you. For example, for a Flowers.tif file in your Home [image] Pictures folder, whose path is Users/chris/Pictures/Flowers.tiff, the Mac says, "Users, Chris, Pictures, Flowers dot TIFF."

4.7.3.6 Summarize

Talk about intriguing: When you choose this command after highlighting some text, the Mac analyzes the sentences you've highlighted and, after a moment, launches Summary Service. This little program, which you probably never even knew you had, displays a greatly shortened version of the original text. Bear in mind that Summary Service doesn't actually do any creative rewriting; instead, it chooses the most statistically significant sentences to include in the summary. Figure 4-16 offers details.

TIP

To save the summarized document as a TextEdit document, choose File [image] Save As.

Figure 4-16. Use the Summarize command to create a one-paragraph summary (right) of a longer passage (left). Once the summary appears in the Summary Service program, you can make the summary more or less concise by dragging the Summary Size slider. You can also ask it to display the most statistically relevant paragraphs instead of sentences, just by clicking the appropriate radio button at the lower left. (Note: Even Summary Services can't come up with something coherent if the original wasn't.)
4.7.3.7 TextEdit

This pair of commands also requires you to first highlight some text in the Cocoa application.

  • Open File. This command works only if you've highlighted some text that matches the name and folder path of a TextEdit document (including its folder path, like ~/Documents/essay.txt). If so, you can choose Services [image] TextEdit [image] Open File to find and open that document in TextEdit. (If what you've highlighted isn't the name of a document, you'll get only an error message.)

  • Open Selection. If you've highlighted any other blob of text, this command automatically launches TextEdit, creates a new untitled document, and pastes the highlighted text.

Although these are the commands that come built into a fresh installation of Mac OS X, that's not the end of the versatility. The real beauty of Services is that, as new, clever applications come along, they can add their own commands to this menu for your data-manipulation pleasure.

TIP

InstantLinks, a piece of $5 shareware from Subsume Technologies, offers a useful look ahead to the future of Services. It adds to your Services menu commands that send your highlighted text to various services on the Web.

For example, you can choose Dictionary Lookup (looks up the selected text in an online dictionary), Map Location (looks up the selected address at MapQuest.com—great when somebody emails you an invitation), Open URL, Search Web, and Thesaurus Lookup. You can download it from www.missingmanuals.com.

4.7.4 Toolbar Tricks

The toolbar is an increasingly common sight at the top of modern application windows. In any thoughtfully written program, the Preferences command lets you determine how you want this toolbar to show up—with icons, icons with text labels beneath them, with text labels alone to save window space, and so on.

But in many Cocoa programs—including OmniWeb, Mail, Address Book, and Project Builder—there's a much faster way to switch among these three toolbar styles: Just [image] -click the white button shown in Figure 4-17.

Figure 4-17. By -clicking this button repeatedly, you can cycle among the various toolbar styles shown here. This technique works in most toolbar-equipped Cocoa programs (but not the Finder, since it's actually a Carbonized program). In Mail, you can actually cycle between six different toolbar styles: with icons and labels (large and small); with icons only (large and small); and with text labels only (large and small—small version not shown).

4.7.5 Secret Keyboard Shortcuts

For the most part, it's possible to ignore the Unix that beats within the heart of Mac OS X. But every now and then, a refreshing reminder pokes its head up through the waves of Aqua—and here's one of them.

Although you'll never see it mentioned in the user manuals for Cocoa applications (if there even were such thing as user manuals anymore), all of them respond to certain keystrokes left over from the NeXT operating system (Mac OS X's ancestor). If you're a card-carrying number of KIAFTMA (the Keyboard Is Always Faster Than the Mouse Association), you'll love these additional keyboard navigation strokes:

  • Control-A. Moves your insertion point to the beginning of the paragraph. (Mnemonic: A = beginning of the alphabet.)

  • Control-E. Deposits your insertion point at the end of the paragraph. (Mnemonic: E = end.)

  • Control-D. Forward delete (deletes the letter to the right of the insertion point).

  • Control-K. Instantly deletes all text from the insertion point to the right end of the line. (Mnemonic: K = kills the rest of the line.)

  • Control-O. Inserts a paragraph break, much like Return, but leaves the insertion point where it was, above the break. This is the ideal trick for breaking a paragraph in half when you've just thought of a better ending for the first part.

  • Control-T. Moves the insertion point one letter to the right—and along with it, drags whichever letter was to its left. (Mnemonic: T = transpose letters.)

  • Option-Delete. Deletes the entire word to the left of the insertion point. When you're typing along in a hurry, and you discover that you've just made a typo, this is the keystroke you want. It's much faster to nuke the previous word and retype it than to fiddle around with the mouse and the insertion point just to fix one letter.

Four additional keystrokes duplicate the functions of the arrow keys. Still, as long as you've got your pinky on that Control key...

  • Control-B, Control-F. Moves the insertion point one character to the left or right, just like the left and right arrow keys. (Mnemonic: Back, Forward).

  • Control-N, Control-P. Moves the insertion point one row down or up, like the down and up arrow keys. (Mnemonic: Next, Previous).

4.7.6 Background Window Control

As hinted in Chapter 1, the [image] key unlocks a slick trick in Cocoa programs: It lets you operate the buttons and controls of an inactive, background window without bringing it to the front. You can operate a background window's resize box, buttons, pop-up menus, and scroll bars, all while another window is in front of it. In fact, you can even drag through text in a background window—and then drag-and-drop it into the foreground window. (Freaky!)

In every case, the secret is simply to keep [image] pressed as you click or drag.


4.8 Installing Mac OS X Programs

In general, new programs arrive on your Mac via one of two avenues: on a CD, or via an Internet download. The CD method is slightly simpler; see "Performing the Installation" later in this section.

For help installing downloaded programs, on the other hand, read on.

4.8.1 .sit, .tar, and .gz

Programs you download from the Internet generally arrive in a specially encoded, compressed form, as shown in Figure 14-18. Study the end of the downloaded file's name; it usually has one of these file name extensions:

  • .sit indicates a StuffIt file, the standard Macintosh file-compression format.

  • .tar is short for tape archive, an ancient Unix utility that combines (but doesn't compress) several files into a single icon, for simplicity in sending.

  • .gz is short for gzip, a standard Unix compression format.

  • .tar.gz or .tgz represents one compressed archive containing several files.

Figure 4-18. Downloading a new program from the Internet may strew your desktop with icons. After the installation is complete, you can delete all of them. (But keep the .dmg file if you think you might want to install the software again later.)

The only thing you need to know about these compression and archiving formats is that StuffIt Expander can turn all of them back into usable form. In fact, StuffIt Expander, a program in your Applications [image] Utilities folder, generally kicks in automatically when you download a file. (If it doesn't, double-click a downloaded compressed file to spur Expander into action.)

4.8.2 Disk Images (.dmg files)

Once you've unstuffed (or untarred) a downloaded program, it often takes the form of a disk-image file, whose name ends with the letters .dmg (see Section 4.8.2). Disk images have been around for years on the Mac, but they're extremely common in Mac OS X. All you have to do is double-click the .dmg icon. After a moment, it magically turns into a disk icon on your desktop, which you can work with just as though it's a real disk (Figure 4-18). For example:

  • Double-click it to open it. The software you downloaded is right inside.

  • Remove it from your desktop by dragging it to the Trash (whose icon turns into a big silver Eject key as you drag), highlighting it and pressing [image] -E (the shortcut for File [image] Eject), or Control-clicking it and choosing Eject from the contextual menu. (You've still got the original .dmg file you downloaded, so you're not really saying goodbye to the disk image forever.)

4.8.3 Cleaning Up after Decompression

When the StuffIt Expander progress-bar dialog box disappears, you may have several icons on your desktop. Some are useful, some you're free to trash.

  • The original compressed file. As illustrated in Figure 4-18, it's safe to throw away the .sit, .tar, .gz, or .tgz file you originally downloaded (after it's decompressed, of course).

    TIP

    If you get tired of cleaning up after your downloads this way, you can tell StuffIt Expander to delete the pieces automatically. To do so, double-click the StuffIt Expander icon (in Applications [image] Utilities). From the StuffIt Expander menu, choose Preferences. Turn on both "Delete after expanding" checkboxes, and then click OK.

  • The .dmg file. Once you've turned it into an actual disk-drive icon (Figure 4-18, bottom), installed the software from it, and "ejected" the disk-drive icon, you can delete the .dmg file. Keep it only if you think you might need to reinstall the software someday.

    NOTE

    If you try to trash the .dmg file before removing the disk-drive icon from the screen, you'll get a "file in use" error message when you try to empty the Trash.

  • The disk image itself. This final icon, the one that contains the actual software or its installer, doesn't exist as a file on your hard drive. It's a phantom drive, held in memory, that will go away by itself when you log out. So after installing its software, feel free to drag it to the Trash (or highlight it and press [image] -E to "eject" it)—or just let it sit there until it goes away.

4.8.4 Performing the Installation

Working with .tar, .gz, and .dmg files are all skills unique to downloading Mac OS X programs from the Internet. Installing software from a CD is much more straightforward.

In either case, once you've got a disk icon on your desktop (either a pseudo-disk from a disk image or a CD you've inserted), you're ready to install the software. You can install many Mac OS X programs just by dragging their icons or folders to your hard drive. Others offer a traditional installer program that requires you to double-click, read, and accept a license agreement, and so on.

The Color Picker

Here and there—in System Preferences, TextEdit, Microsoft Office, and many other programs—Mac OS X offers you the opportunity to choose a color for some element: for your desktop background, a window, and so on.

The dialog box that appears offers a miniature color lab that lets you dial in any color in the Mac's rainbow. Several color labs, actually, arrayed across the top, each designed to make color-choosing easier in certain circumstances:

Color Wheel. Drag the scroll bar vertically to adjust the brightness, and then drag your cursor around the ball to pick the shade.

Color Sliders. From the pop-up menu, choose the color-mixing method you prefer. CMYK stands for cyan, magenta, yellow, and black. People in the printing industry will feel immediately at home, because these four colors are the component inks for color printing. (These people may also be able to explain why K stands for black.)

RGB is how a TV or computer monitor thinks of colors: as proportions of red, green, and blue. And HSV stands for Hue, Saturation, and Value—a favorite color-specifying scheme in scientific circles.

In each case, just drag the sliders to mix up the color you want, or type in the percentages of each component.

Color Palettes presents canned sets of color swatches. They're primarily for programmers who want quick access to the standard colors in Mac OS X.

Image Palettes offers the visible rainbow arrayed yet another way: in cloudy, color-arranged streaks.

Crayons. Now this is a good user interface. You can click each crayon to see its color name: "Mocha," "Fern," "Cayenne," and so on. (Some interior decorator in Cupertino had a field day naming these crayons.)

In any of these color pickers, you can also "sample" a color that's outside the dialog box—a color you found on a Web page, for example. Just click the magnifying-glass icon and then move your cursor around the screen. You'll see the sliders and numbers change inside the dialog box automatically when you click.

Finally, note that you can store frequently used (or frequently admired) colors in the mini-palette squares at the bottom. To do that, drag the big rectangular color swatch (next to the magnifying glass) directly down into one of the little squares, where it will stay fresh for weeks.

In both cases, where you decide to install the new program is suddenly a big issue. You have the following two alternatives:

  • In the Applications folder. Most programs, of course, sit in your Applications folder. Most of the time, this is where you'll want to install new programs. Putting them in the Applications folder makes it available to anyone who uses the Mac.

    NOTE

    You can't put anything in your Applications folder unless you have an administrator account, as described on Section 11.2.

  • In your Home folder. This option is valuable only if you share your Mac with other people, as described in Chapter 11. If that's your situation, you may occasionally want to install a program privately, reserving it for your own use only. In that case, just install or drag it into your Home folder (see Section 2.1). When other people log onto the machine, they won't even know that you've installed that new program, since it doesn't show up in the Applications folder.

    If you don't have an administrator account, this is your only option.

4.8.5 Uninstalling Software

This is the part where you're so glad to be a Mac user. To uninstall a program, you just drag it (or its folder) from the Applications folder (or wherever it is), to the Trash. You might also check your Home [image] Preferences folder for the presence of a preference file, which you can also trash.

That's it. There's no Uninstall program, no Add/Remove Programs window, no left-behind pieces to worry about.


Chapter 5. Back to Mac OS 9

If only we could move into Mac OS X and live there! Unfortunately, software makes the world go 'round, and it'll be a long time before every program you'd ever want to use has been written or rewritten for Mac OS X.

That doesn't mean you can't use them at all, though. You can certainly run your old favorites within Mac OS X—by flipping back into Mac OS 9. There are two ways you can do that, as described in this chapter.

The bad news is that now you've got two different operating systems to learn. The landscape, features, and locations of favorite commands differ in each one.

If you've got the old Mac OS in your blood, you're way ahead of the game. But if you're new to the Mac, you can easily get confused. You may see a shiny blue [image] menu one moment, and a striped one with completely different commands the next, as the machine flips back and forth between the two OSes.

There's no solution to this dilemma except to wait until every program you'd ever want to use is available in a Mac OS X version. Fortunately, most of the biggies are already available for Mac OS X. The sooner you can stop using the Mac OS 9 tricks described in this chapter, the better.


5.1 Two Roads to Mac OS 9

You can return to Mac OS 9 in either of two ways. Here's a summary that outlines the pros and cons of each method:

  • Run Classic. The program called Classic is one of the crowning achievements of Mac OS X. You can think of it as a Mac OS 9 simulator or emulator. It runs automatically whenever you double-click the icon of a pre-Mac OS X program.

    At that point, the Classic (Mac OS 9) world takes over your screen, looking exactly as though the old Mac OS 9 you used to know (or not know) is starting up. There's the old startup logo, the parade of extensions across the screen, your old [image] menu, the non-striped menu bar, and so on. Once it's running, you can run almost all of your older Mac OS 9 programs without a hitch.

    Classic is the reason Apple recommends that you install Mac OS X only on Macs with at least 128 MB of memory. When you run it, your Mac is running two operating systems at once, which requires quite a bit of memory.

    For most people, most of the time, Classic is the easiest, quickest, and most effective way to run older Mac programs.

    NOTE

    Classic requires Mac OS 9.2 or later. The most recent version of Mac OS 9 is almost always the best.

  • Restart the Mac in Mac OS 9. Unfortunately, Classic is only a simulator. It isn't your operating system at the time—it isn't actually controlling your Mac. (Mac OS X continues to run beneath it.)

    Whenever a certain program "reaches for" a particular piece of circuitry on your Mac, such as the FireWire or USB jack, it comes up empty-handed. That's why many scanners, digitizing tablets, and even printers don't work when you run programs in the Classic mode.

    Fortunately, you can also restart your Mac in Mac OS 9, just as though you don't have Mac OS X installed at all. At this point, you've got just a regular Mac OS 9 machine, and all of that older gear works just as it always did. Of course, you don't get any of the benefits of Mac OS X, such as its stability and multitasking prowess.

    Note, too, that Macs made after January 2003 don't offer this feature at all. They can't be started up in Mac OS 9 (thanks, Apple). The description of this option in this chapter applies only to the earlier Macs that can.

Where to Get Mac OS 9

Hey, I just bought Mac OS X 10.2, and it doesn't come with a Mac OS 9 CD! Where am I supposed to get a copy of Mac OS 9?

It's a great question. Fortunately, very few people are asking it.

If you bought your Mac within the last several years, you already have a copy of Mac OS 9—and thanks to the software downloads page of Apple's Web site, you can update any version of Mac OS 9 to the very latest version (9.2.2 or whatever).

If you bought Mac OS X before version 10.2, you received a copy of Mac OS 9 with it, too.

Finally, all new Macs come with Mac OS 9 pre-installed on the hard drive, too.

In short, you're completely out of luck only if you have an old Mac that's still running Mac OS 8.5 or 8.6. And for you, Apple has a special offer: $20 buys you a copy of Mac OS 9. (You must prove your worthiness by sending Apple a copy of your Mac OS X receipt.) Details are on Apple's Web page.


5.2 Classic: Mac OS 9 on Mac OS X

If you still harbor the notion, propagated by certain old Mac books, that it's bad form to have two System folders on the same hard drive, welcome to the 21st century. When you use Mac OS X, it's not only a good idea to have two System folders, it's almost a requirement. You should have one copy of Mac OS X, and at least one copy of Mac OS 9. (Appendix A describes various ways to set all this up.)

It's easy to spot the Mac OS 9 System folder on your drive, as shown in Figure 5-1.

Figure 5-1. When you're running Mac OS X, the System Folder that contains Mac OS 9 is clearly marked by the golden 9. Only one System Folder per disk may bear this logo, which indicates that it's the only one officially recognized by the Mac. (As the programmers say, it's the "blessed" System Folder.)

5.2.1 How to Start Classic

You can start up your Classic program in any of several ways.

5.2.1.1 Double-click a Mac OS 9 program

The most common method of launching Classic is simply double-clicking the icon of a pre-Mac OS X program. Your Mac concludes: "Well, this program won't run in Mac OS X, so I'll just go ahead and launch your Mac OS 9 simulator."

At this point, several things happen. The very first time you ever run Classic, you may see a message that says, "Classic needs to update resources in your selected Classic system folder." Mac OS X is telling you that your Mac OS 9 System Folder requires a couple of extensions and other system files (listed later this chapter) in order to run within Mac OS X, and that it's offering to put them in the right place. Click OK.

Now a progress bar appears in a floating window, as shown in Figure 5-2. Although Classic starts up a lot faster in 10.2 than it did in 10.1, it still takes 30 seconds or so, depending on your machine. (You can even streamline it down to about 10 seconds using the tricks described in the following pages.)

Figure 5-2. Top: Starting up Classic involves waiting for the progress bar to fill up. Bottom: If you click the flippy triangle below the progress bar, you summon what looks like the full screen of a Macintosh floating within your own Mac's monitor, displaying the standard extensions and control panel icons, the Mac OS 9 logo, and other landmarks of the traditional Mac OS 9 startup process. (Note that in 10.2, the title bar identifies which Mac OS 9 System Folder you're starting up from.)

During the startup process, you'll see a little Classic (numeral 9) icon in your Dock, just to help you understand what's going on.

TIP

If you haven't got the time to wait, or you suddenly change your mind, you can cancel the Classic startup process by clicking the Stop button. In the confirmation box, click Stop Classic. You return to the desktop, no harm done.

And if you find Classic launching fairly often when you don't really want to bother, try this new 10.2 feature. Open System Preferences (Chapter 8), click the Classic icon, and turn on "Warn before starting Classic." Now, whenever you try to open a Mac OS 9 program, accidentally or not, Mac OS X will ask for your OK before firing up Classic.

When all the bouncing stops, you'll see a number of changes onscreen. Your Apple menu is now rainbow-striped, as it was in the days before Mac OS X, and it lists whatever programs, documents, and other icons you've put there. The menu bar is light gray, its fonts are smaller, and its menus and commands are different. In short, you've now gone back in time to Mac OS 9.

NOTE

As an entire operating system, Mac OS 9 could well be the subject of an entire book unto itself—like Mac OS 9: The Missing Manual. The rest of this book assumes that you either know Mac OS 9 already or have a good source of information to help you with it.

5.2.1.2 Launch it manually

You can also start up Classic manually, although you'll rarely have much need to do so. The master control panel for controlling Classic is in System Preferences, and it works like this:

  1. Open System Preferences.

    You can choose [image] [image] System Preferences, or click the System Preferences icon in the Dock. Either way, the System Preferences window appears (see Chapter 8).

  2. Click the Classic icon.

    Now the Classic preference panel appears, as shown in Figure 5-3.

    At this point, you'll see a list of every disk (or disk partition) that contains a Mac OS 9 System Folder, also shown in Figure 5-3. If you expand the flippy triangle next to a disk's name, you'll see a list of the Mac OS 9 System Folders. Any one of them can serve as the System Folder that runs when you enter the world of Classic. (The ability to choose which specific System Folder you want—instead of just which disk you want—is new in 10.2.)

    Make sure the right one is selected; more on this topic later in this chapter.

  3. To start Classic manually, click Start.

    Water appears to flow into the progress bar, exactly as shown in Figure 5-2. (If the Start button is dimmed, check the boldface message above the list of disks. It may be that Classic is already running.)
Figure 5-3. This preference panel lets you specify which Mac OS 9 System Folder takes over when you launch the Classic mode. If you point to a System Folder without clicking, a square balloon appears to identify its name, location, and system version.

TIP

You can also add the icon of Classic to your Dock, creating a quick and easy way to launch it without having to burrow into System Preferences. Open your System [image] Library [image] CoreServices folder. Inside this folder, you'll find an icon called Classic Startup. Drag it onto the Dock, where it will remain for easy access.

5.2.1.3 Start up Classic automatically

If you find yourself using Classic every day, you'll have by far the best time with Mac OS X if you instruct it to start up Classic automatically when the computer turns on (or, if you share your Mac with others, when you log in).

It's true that your Mac will now take 30 seconds or so to start up each day, as it loads first one operating system (Mac OS X), and then another (Mac OS 9). But you won't care. You'll be reading the paper and drinking coffee. And when you do need to run a Mac OS 9 program, you won't have to wait while Classic starts up; the environment will already be waiting for you.

Instructing Classic to start up automatically is extremely easy. Follow steps 1 and 2 in the preceding instructions—but at step 3, turn on "Start Classic when you log in." Close the System Preferences window.

From now on, Classic will automatically launch when you turn on, or log into, your Mac.

5.2.2 What to Expect from Classic

Once Classic is running, you're free to use the Mac OS 9 program you originally double-clicked—or any other Mac OS 9 programs, for that matter. You'll probably find, in fact, that Mac OS 9 programs launch even faster in Classic than they would on an actual Mac OS 9 computer.

TIP

The "soundtrack" feature of the Appearance control panel ( [image] menu [image] Control Panels) can slow down some Classic operations quite a bit, especially scrolling. Leave it off for best speed.

Remember, you're running two operating systems simultaneously. Yet you can freely flip back and forth between Mac OS 9 and Mac OS X: When you click a Mac OS X program's icon on the Dock (or click inside a Mac OS X program's window), you bring forward both that program and Mac OS X. When you double-click a Mac OS 9's Dock icon (or click inside a Mac OS 9 program's window), you bring forward both that program and Mac OS 9. You can copy and paste information between the programs running in these two worlds—or even drag-and-drop highlighted material, exactly as described in Chapter 6.

You'll soon discover that the icons of open Mac OS 9 programs appear on the Dock, just like Mac OS X programs. (Well, maybe not exactly like them: pre-Mac OS X programs generally appear with blotchy, ragged program icons on the Dock, as shown in Figure 5-4.)

Figure 5-4. Most pre-Mac OS X programs exhibit ragged icons on the Dock—a side effect of being enlarged to Mac OS X size. There are some exceptions: For example, Microsoft knew about Mac OS X in time to design Mac OS X-style icons for Office 2001.

It's important to note, however, that Mac OS 9 is no more stable now than it ever was. It doesn't offer Mac OS X's memory protection, multithreading, preemptive multitasking, and other goodies. One buggy program can still freeze or crash the entire Classic bubble. At that point, you may have to exit the entire Mac OS 9 portion of your machine, losing unsaved changes in any of your Mac OS 9 programs, just as though it were a Mac OS 9 machine that had locked up.

On the other hand, even when your Classic world goes down, you won't have to restart the actual computer. Mac OS X soldiers on, unaffected, and all your Mac OS X programs remain safe, open, and running.

5.2.3 Getting Out of Classic

There's really no good reason to quit the Classic simulator, ever. Because Classic is a genuine Mac OS X program, it doesn't consume any memory or horsepower to speak of when it's in the background. You may as well leave it open so that you won't have to wait for the startup process the next time you use a Mac OS 9 program.

In fact, Classic doesn't even distract you by putting its icon on the Dock. Apple hoped to make the Classic experience seamless by hiding its Dock icon once Classic is running. The idea was that you shouldn't really care whether one program or another is running in Mac OS 9 or Mac OS X. All application icons—whether in Classic or not—show up on the Dock, and clicking one switches to it, whether in Mac OS 9 or Mac OS X. (Of course, this theory falls apart somewhat when you consider the changes in the [image] menu, menu bar, window design, and so on...but let's not quibble.)

There are a few situations when you might want to quit Classic manually, however. For example, you might want to close it following a system crash or lockup within Classic; or you might want to restart Classic after making changes to its extensions, control panels, drivers, or other System Folder elements.

You can exit Classic in any of several ways:

  • In the System Preferences panel shown in Figure 5-3, click Stop or Restart. The Mac invites you to save the changes to any open documents, if necessary.

  • If your Classic environment has frozen or crashed, it may be too late for clicking the Stop button, saving your unsaved changes, and so on. In that case, you may have to force quit your Classic program—that is, shut it down with the subtlety of a sledgehammer. You lose any unsaved changes in any Classic programs, but at least you escape the freeze or crash.

    You can force quit Classic just as you would any program, by pressing Option- [image] -Esc and then proceeding as described in Section 4.1.2. (In the list that appears, click Classic Environment and then click Force Quit.) And if you can't remember that keystroke, remember that you can always accomplish the same thing by clicking Force Quit in the System Preferences window shown in Figure 5-3.

    TIP

    In some cases, force quitting a frozen Classic isn't enough. You may also need to quit TruBlue-Environment, an invisible program that also runs when Classic does. TruBlue doesn't show up in the Force Quit dialog box. It does, however, show up in Process Viewer (Section 9.2.24). If you double-click its name there, you can force quit it (if, indeed, it's still running).

Dr. Jekyll and Mr. Carbon

You may recall from the previous chapter that Mac OS X-compatible programs come in two flavors: Cocoa (that is, written expressly for Mac OS X) and Carbon (adapted for Mac OS X from a previous version). Carbonized programs generally offer a unique feature: the ability to run in either Mac OS 9 or Mac OS X, unmodified.

But you probably have both Mac OS 9 and Mac OS X installed on your Mac. Maybe you even have Classic running, ready to open any Mac OS 9 program you happen to double-click. What happens, then, when you click the icon of a Carbonized program, such as Internet Explorer? Will it open in Mac OS X or the Classic environment?

The answer is: It's generally up to you. You can specify whether a particular Carbon program will open in Mac OS 9 (Classic) or Mac OS X by highlighting its application icon and then choosing File [image] Get Info. In the Info window, you'll find the checkbox illustrated here: "Open in the Classic environment."

If you turn that box on, double-clicking that program's icon opens it in Classic instead of Mac OS X.

That's good to know for winning a bar bet or running an old AppleScript applet, perhaps. Otherwise, it's rarely useful, since almost every program runs better in Mac OS X than in Mac OS 9.

5.2.4 Specifying a Classic System Folder

Classic doesn't operate at all unless there's a Mac OS 9 System Folder somewhere on your Mac. (See Appendix A for instructions on installing Mac OS 9 and Mac OS X.)

On the other hand, it's perfectly legal, in the world of Mac OS X, to have more than one Mac OS 9 System Folder on board—and many people do. You may want to designate one of them exclusively for use in Classic. (You might want to use a second one for dual booting, as described at the end of this chapter.) Note, however, that for Classic purposes, each Mac OS 9 System Folder must sit on a different disk or disk partition (see Appendix A).

Preserving Bookmarks Across the Switch

If you browse the Web using Internet Explorer in both Mac OS X and in Classic, you may have cursed the inconvenience of having to maintain two separate lists of favorite Web sites—and of having to lose your history trail every time you switch from one browser to the other. Fortunately, you don't have to.

All you need to do is replace your Mac OS X Favorites and History files with aliases of your Mac OS 9 Favorites and History files.

That's the short version. Here's the full story.

Open your Mac OS 9 System Folder (the one you've selected for use in the Classic mode—see Figure 5-3). Open its Preferences [image] Explorer folder. Inside are two critical files: Favorites.html (your bookmarks) and History.html (the list of Web sites you've visited recently). Create aliases of them on the desktop; the easiest way is to Option- [image] -drag them there.

The next task is to put them in the right place in your Mac OS X world. Start by opening your own Home folder (choose Go [image] Home or press Shift- [image] -H). In it, open the Library [image] Preferences folder. Drag your two aliases, Favorites.html and History.html, onto the Explorer folder icon. Mac OS X asks if you're sure you want to replace the existing files of the same names. You are.

That's all there is to it. Whenever you use Internet Explorer, whether in Mac OS X or in Classic, you'll see the same, up-to-date set of favorites (bookmarks), and your history list will always be current.

When following the instructions on the previous page, therefore, choose carefully. The System Folder you select here affects how much time it takes Classic to start up, which extensions and control panels it has (and therefore how stable it is), what preference settings apply in various programs, what Web-browser bookmarks are available, and so on.

5.2.5 Controlling Classic Startup

If you're smart or lucky, you'll eventually eliminate the Classic startup delay altogether. For example, you can set up Classic so that it opens automatically at startup or login. Or maybe you'll get into the habit of never shutting down your computer at all, allowing it simply to sleep when not in use, so that Classic remains running essentially forever. Or you may eventually move almost all your operations into Mac OS X programs, rendering Classic obsolete—the dream of everyone who uses Mac OS X.

But if you open—and wait for—Classic every day, you might find it valuable to shave down the amount of time it takes to get going. The best way is to turn off as many extensions and control panels as possible. That's just one of the ways you can control the Classic startup process, as described in the following section.

5.2.5.1 Summoning Extensions Manager

By the time Mac OS X arrived on the scene, the System Folder of its predecessor, Mac OS 9, was caked solid with extensions and control panels (self-launching software that loads into memory at startup time). Each controls some function of the Mac, but taken together, they account for much of the standard Mac OS 9's propensity to freeze, crash, and otherwise act up.

Within the Classic world, you don't need many of these extensions anymore. Remember that Classic is a workaround, not your main operating system; Mac OS X now duplicates many of its functions (and in a much superior way). Turning off as many Mac OS 9 extensions as possible, therefore, makes using your Classic environment a much smoother and more stable experience—and accelerates Classic's startup process.

The key to controlling which extensions load is to press and hold the Space bar just after the progress bar begins filling up, as shown in Figure 5-5. Release the Space bar only after you see the appearance of the Extensions Manager window.

Extensions Manager, of course, is the Mac OS 9 program that lets you turn certain extensions or control panels on and off. One of its most useful features is its ability to create canned sets that permit you to switch among sets of preselected extension combinations with a single mouse click. Use the Selected Set pop-up menu at the top to switch among them.

To set up your winnowed-down extension set, click Duplicate Set in the lower-right corner of the window. In the dialog box that appears, type a name for the set you're about to create (such as Classic Speedy Startup), and then click OK.

Figure 5-5. Pressing the Space bar while Classic is starting up opens Extensions Manager, just as though you pressed Space while starting up a Mac OS 9 computer. (If you've bought Conflict Catcher 9—a commercial replacement for Extensions Manager with many more features—you'll see its screen appear here instead.)
5.2.5.2 Extensions and control panels to turn off

Now you're ready to start paring down the extensions and control panels that delay Classic's startup process (and make it so prone to crashes). Depending on what functions you need to use in Classic, you might consider turning off the extensions and control panels in these function categories (by clicking their checkboxes so that the X no longer appears):

  • Control Panels. Many of Mac OS 9's control panel functions are superseded by new panels in the Mac OS X System Preferences (see Chapter 8). Changing your mouse speed using Mac OS 9's Mouse control panel, for example, doesn't have much meaning if you've already set your mouse speed in Mac OS X.

    Therefore, you should turn off the following control panels immediately, since they don't work in Classic and gain you nothing: Control Strip, Energy Saver, File Sharing, Infrared, Location Manager, Modem, Monitors, Mouse, Multiple Users, Password Security, PowerBook SCSI Disk Mode, Remote Access, Software Update, TCP/IP, Trackpad, and Web Sharing.

    NOTE

    These Mac OS 9 control panels work, albeit with limited functions, within Classic: Appearance, AppleTalk, Date & Time (for menu-bar clock control only), General Controls (some commands, like Show Desktop, are dimmed), Keyboard (duplicated functions are dimmed), Memory (Disk Cache only), Monitors, and Sound (for alert sounds only).

  • Internet. If you've moved your Web-surfing, email, and remote dial-in operations over to Mac OS X, you may have little need for the equivalent functions in the Classic environment.

    If that's the case, you can safely turn off DialAssist, Internet, Location Manager Extension, Apple Modem Tool, Internet V.90 Modem (and other modem names, such as PowerBook Modem), the LDAP extensions, NBP Plugin, NetSprocketLib, Remote Only, and ShareWay IP Personal Bgnd, in addition to the control panels listed above. You may as well turn off the Software Update extensions, too, since they rely on Internet access.

  • Networking, Multi-User features. Most of Mac OS X's networking and Mac-sharing features far outshine those in Mac OS 9. So if you won't be connecting to other computers on your office network from within Classic, you may as well turn off AppleTalk, any AirPort extensions, Keychain Access, IrDA Tool and IrDALib, Apple Enet, Apple Enet DLPI Support, AppleShare, EnetShimLib, File Sharing Extension, File Sharing Library, Multi-User Startup, OpenTpt Remote Access, Network Setup Extension, and SLPPlugin.

  • Printing. If you don't plan to print from within Classic programs, you can turn off anything containing the words Print, Printer, Printing, or ColorSync, as well as the extensions bearing specific printer names (Color SW 1500, Color SW 2500, LaserWriter, and so on).

  • DVD. The old, Mac OS 9-style DVD Player program doesn't even work in Classic. Turn off everything containing DVD in its name.

  • CD burning. Here again, Mac OS X does a far better job of burning CDs than Mac OS 9 does. For example, Mac OS X can even burn data DVDs, which hold a delightful 4.7 GB per disc. By all means, turn off the Disc Burner Extension.

  • Video games. A few video games require the OpenGL, QuickDraw 3D, NVIDIA, and ATI extensions. If you're a gamer, you'll experience the best game play by restarting your Mac in Mac OS 9 (see Section 5.3), rather than trying to play Mac OS 9 games in the Classic mode. If you agree, turn off all extensions that contain the words QuickDraw 3D, OpenGL, NVIDIA, and ATI.

  • FireWire. Even if you have a digital camcorder for use with iMovie, you may as well turn off the FireWire extensions, as the Mac OS X version of iMovie is better than the Mac OS 9 version. Leave the FireWire extensions on only if you have FireWire gadgets like external hard drives that you want to access from within Mac OS 9.

Once your pruning session is complete, click Continue. You should find that the Classic mode now starts up dramatically faster than before.

NOTE

These are only suggestions. If, after turning off some of these extensions and control panels, you find that certain familiar Mac OS 9 functions are no longer available, exit Classic, restart it with the Space bar pressed again, and experiment with restoring some of the things you turned off. And if you don't have the time to fiddle with individual extension settings, you can always turn on the entire Apple-authorized original set by choosing Mac OS 9 All (or Mac OS 9.2.2 All, or whatever) from the Selected Set pop-up menu.

Similarly, note that the commercial program Conflict Catcher can switch extension sets automatically, depending on whether the System Folder is being used for Classic mode or an actual restart.

5.2.5.3 Extensions to leave on

You can't go totally hog-wild turning off System Folder elements. Classic expects to find certain System Folder items when it launches. If you turn them off, an error message will explain that "Some Classic-specific resources need to be added to or updated in your System Folder on [Disk Name]." If you click OK, Mac OS X copies them into the Mac OS 9 System Folder. Here's a list, current as of Mac OS 9.2.2:

  • Control Panels: General, Startup Disk

  • Extensions: Apple Guide, CarbonLib, Classic RAVE, Open Transport, Open Transport ASLM Modules

  • Loose in the System Folder: Classic Support, Classic Support UI, ProxyApp

5.2.5.4 "Holding down" keys during startup

On a Mac OS 9 machine, holding down certain keys during the startup process triggers certain utility functions. Pressing Shift, for example, turns off all extensions and control panels. Holding down Option and [image] eventually rebuilds the desktop database file, a Mac OS 9 troubleshooting technique that can cure general slowdowns as well as the "generic," blank-icon problem. If you've installed Conflict Catcher, a commercial extensions manager, a wide range of startup-process keystrokes is available: -P for pause, [image] -R for restart, and so on.

As Classic is starting up, these keystrokes work exactly as they do when a Mac OS 9 Mac is starting up. That is, if you press Shift immediately after the Classic progress bar appears onscreen, you'll see the usual "Extensions Off" message in the middle of the simulated Mac OS 9 startup screen. Similarly, if you hold down the Option and [image] keys as the extension-loading process comes to an end, you'll eventually be offered the opportunity to rebuild the desktop. (Well, sort of...after Classic has finished loading, click the blank-document icon that appears in your Dock with the name Classic Support UI, to bring forward the "Are you sure you want to rebuild the desktop?" dialog box.)

Still, Apple's engineers worried that you might find it difficult to gauge when the right moment is to hold down these various startup keys, so they offer you an alternative method of holding them down.

To see it, open the Advanced tab of the Classic preference panel (see Figure 5-6).

Figure 5-6. The Advanced tab of the Classic panel lets you specify which keys you want "held down" for you as Classic starts up. It also lets you specify when Classic can sleep—that is, to slip down into virtual memory, returning the RAM (and processor attention) it was claiming to the general pool. Once it's sleeping, Classic programs take slightly longer to open—but not nearly as much as when you start Classic for the first time.

On this tab, you'll find a pop-up menu that helps you control the startup process. The options are as follows:

  • Turn Off Extensions. If you choose this command and then click the Start Classic (or Restart Classic) button next to it, you'll launch the Classic emulator with all extensions turned off, just as though you had held down the Shift key during its startup.

  • Open Extensions Manager. If you choose this command and then click Start Classic (or Restart Classic), the Mac behaves as though you had pressed the Space bar while Classic was starting up. As a result, the Extensions Manager window opens, just as described in Section 5.2.5.

  • Use Key Combination. This option is designed to accommodate all other startup keys, such as those available in Conflict Catcher. Start by clicking in the <press up to five keys> box. Now you can press up to five different keys (one at a time, please) that the Mac will "hold down" when you start Classic by clicking the Start Classic (or Restart Classic) button in this dialog box. As you press the keys, you'll see them recorded in the text box.

Note that whatever option you choose from the pop-up menu will apply only to the next Classic startup you trigger from within this dialog box. These options don't affect Classic when you start it up in any of the usual ways.

TIP

There's no need to press Option- [image] when Classic is starting up if you want to rebuild the Desktop file. The Rebuild Desktop button in this dialog box does the trick automatically, without requiring that you launch Classic at all.


5.3 Restarting in Mac OS 9

Unfortunately, Classic can get you only so far. Sure enough, it fakes out your older software fairly well—but your Mac is not actually running Mac OS 9. Anytime a piece of software tries to communicate with some physical component of your Mac, such as the SCSI, USB, FireWire, or serial ports, it will bruise its knuckles on the stainless-steel dome of Mac OS X, which is really in charge of your ports. That's why a lot of add-on equipment, including USB-to-serial adapters, certain printers, SCSI cards, scanners, and so on may not run properly in the Classic environment.

What this kind of equipment really needs, of course, is Mac OS X-specific driver software. If drivers exist (check the manufacturer's Web site), you can once again use your gear.

Otherwise, you have only one alternative when you want your external gadgets to work properly with your Mac, just the way they did when it ran Mac OS 9: Restart the Mac in Mac OS 9. (That's the solution if your Mac can start up in Mac OS 9; as noted at the beginning of this chapter, Apple has slated this option for extinction in 2003 Mac models. That's Apple's way of encouraging hardware and software makers to hurry up and develop X-compatible gadgets.)

Two Systems, One Preference

Having to live in two worlds—Mac OS 9 and Mac OS X—is not an especially popular situation. In fact, it can be a real pain.

Fortunately, Mac OS X 10.2 takes a baby step toward simplifying things; now, at least, programs that run in both Mac OS X and Classic can maintain a single set of preference files. Now your serial numbers, window positions, palette setups, and other settings will be remembered as you move between worlds.

To view this option, open the Classic panel of System Preferences. Click the Advanced tab, and then turn on "Use preferences from home folder."

From now on, any programs that can run in either 9 or X will use a consistent set of preference files—the ones in your Home [image] Library [image] Preferences folder, rather than the Preferences folder in your Classic System Folder. (Such programs include Photoshop, Word 2001, AppleWorks, and so on, along with system-wide features like QuickTime preferences, Internet preferences, modem preferences, and so on.)

None of this means that these programs will use the same preference files when you restart in Mac OS 9—only when you run them in the Classic environment.

Anytime you like, you can flip back into Mac OS 9 and return to complete compatibility with all your old gadgets and all your old programs. When you're finished, you can restart the Mac again, this time with Mac OS X "in charge." This ability to switch back and forth between two radically different operating systems on the same computer is called dual booting.

5.3.1 Dual Booting the Long Way

The key to switching back and forth between Mac OS 9 and Mac OS X is the Startup Disk control panel (or System Preferences panel).

5.3.1.1 Switching from X to 9

Suppose you're running Mac OS X, and you need to duck back into Mac OS 9 to use, say, your scanner. The routine goes like this.

  1. Open System Preferences.

    As always, you can do it by clicking the System Preferences icon on the Dock or by choosing [image] menu [image] System Preferences. The System Preferences screen appears.

  2. Click Startup Disk.

    You now see the panel shown at top in Figure 5-7. The icons here represent the various System folders, both Mac OS 9 and Mac OS X flavors, that your Mac has found on all disks currently attached to your Mac.

    You may see several System Folders displayed here. If you're wise, you'll have deliberately set up at least two of them: one for use by Classic, and another more complete one for use when restarting the Mac. Details on this thinking are in Section 5.4.5.

  3. Click the Mac OS 9 System Folder you want to be in charge, and then click Restart.

    The Mac asks you: "Are you sure you want to set the Startup disk and restart the computer?"

  4. Click "Save and Restart" (or press Enter).

    When your Mac restarts, you'll feel like it's 1999 all over again. There go the parade of extension icons, the Mac OS 9 logo, and all the other trappings of the traditional, pre-Mac OS X startup process. You're now fully back in Mac OS 9, ready to use all your old add-on equipment and software (but without the benefit of Mac OS X's stability, good looks, and other features).
Figure 5-7. If you're running Mac OS X, you can indicate that you'd like Mac OS 9 to seize control at the next startup by using the Startup Disk system preference panel. If you're having trouble telling the System Folders apart (because, after all, System Preferences reveals only their System versions and disk names, not their folder names), point to the folder icon until the identifying yellow balloon appears. Bottom: If you're running Mac OS 9, use the Startup Disk control panel to specify that you want Mac OS X to be in charge at the next startup.
5.3.1.2 Switching from 9 to X: The Long Way

The officially prescribed method of returning to Mac OS X is very similar.

  1. Choose [image] [image] Control Panels [image] Startup Disk.

    The Startup Disk control panel appears, as shown in Figure 5-7. Click the flippy triangle next to a disk's name, if necessary, to see the list of System folders on it.

  2. Click the specific Mac OS X System folder you want to be in charge, and then click Restart.

    Mac OS X starts up.


5.4 Four Tricks for Faster Switching

It didn't take long for the masses of Mac fans to grow impatient with fiddling around with System Preferences and control panels just to go back and forth between 9 and X.

Fortunately, you don't actually have to do all of that. Here are four ways to reduce the number of steps.

5.4.1 The X Key Trick (From 9 to X)

If you have both Mac OS 9 and Mac OS X installed on the same hard drive or disk partition, use this sensational shortcut: Just hold down the letter X key while the Mac is starting up. (Hold it down until the Mac stops chiming.) You'll go straight to Mac OS X.

5.4.2 The D Key Trick (From X to 9)

The only downside to the X-key trick is that it's one-way. You can't, for example, hold down the 9 key to start up in Mac OS 9 again—at least not if 9 and X are on the same drive.

If you've installed 9 and X on two different drives or partitions, though, you can enjoy the D-key trick. It works in either of these two situations:

  • You have two hard drives. You've installed Mac OS 9 on the internal hard drive, and Mac OS X on an external.

  • You have one hard drive, but you've partitioned it (divided it into two or more "virtual disks," each with its own icon). You'll find instructions for setting up multiple partitions—and installing different operating system versions on them—in Appendix A.

But here's the key point: You've installed Mac OS 9 on the first partition.

Once you've arranged things like this, leave your System Preferences set so that Mac OS X is the startup disk, as described earlier. But on those occasions when you want to duck back into Mac OS 9, hold down the D key just after the startup chime (when turning on or restarting the machine). The Mac starts up in Mac OS 9.

To return to Mac OS X, just don't do anything. Restart the machine without holding down any keys at all.

As it turns out, the D key tells the Mac to start up from the first internal disk or partition that contains a working System Folder of any type. If it's a Mac OS 9 partition, that's what you get.

5.4.3 The AppleScript Trick

Using the free Change Startup Disk script (Figure 5-8), switching between systems requires nothing more than a couple of clicks.

Figure 5-8. With a couple of quick clicks, you can reset your Startup Disk settings without having to burrow into System Preferences.

To make it truly streamlined, a bit of setup is involved—you must download an AppleScript plug-in, for example—but instructions are provided with the software. You can download this System folder-switcher from www.missingmanuals.com, among other places.

5.4.4 The Option Key Trick

This trick may be the easiest and friendliest of all. It's a single keystroke that lets you decide, each time the computer turns on, which operating system version you want to run it. This method lets you postpone making the decision until the moment you actually turn the thing on, instead of having to make the switch after the computer has already started up.

This technique, too, works only if you've installed Mac OS 9 and Mac OS X on different disks or different partitions of a single disk.

Now you're ready. Turn on the Mac. Just as it's lighting up, hold down the Option key. Hold it down until you see the display illustrated in Figure 5-9.

Figure 5-9. This display, known as the Startup Manager, appears when you press Option during startup. It displays all the disk icons, or disk partitions, that contain working System folders. Just click the icon you want and then click the arrow button at the lower right.

This screen, known inside Apple as the Startup Manager, offers icons for every disk, CD, or partition containing a working System folder (either Mac OS 9 or Mac OS X). Just click the one you want to start up the Mac and then click the "continue" button. Without missing a beat, your Mac continues to start up using the operating system you selected.

Clearly, this technique requires a bit of preparation and planning—not just because it requires different disks or partitions, but also because it limits you to having one System folder on each. The display shown in Figure 5-9 offers a list of startup disks, not System folders. (The Startup Disk method described earlier, by contrast, lets you choose from among several System folders on the same disk.)

Still, if you find that switching between Mac OS 9 and Mac OS X is a daily feature of your work routine, you may decide to bite the bullet and partition your hard drive (or buy a second, external one) just to realize the convenience of this switching-at-startup feature.

5.4.5 Separate System Folders for Classic and Rebooting

If you've really thought this through, it may have dawned on you that the ideal Mac OS 9 System Folder for use in Classic makes a lousy System Folder for restarting your Mac, and vice versa.

The Mac OS 9 System Folder you want for Classic is a slimmed-down, streamlined System Folder with as few extensions and drivers as possible. Here, your aim is to make Mac OS 9 launch as quickly as possible. When you restart the Mac in Mac OS 9, on the other hand, you want maximum compatibility. You want all your Mac's features intact, especially the drivers that will operate your external equipment.

5.4.5.1 Maintaining a single Mac OS 9 System Folder

You can maintain a single Mac OS 9 System Folder on your Mac, of course. You can simply use Extensions Manager (or Conflict Catcher) to create two different sets of extensions: one for use in Classic and one for use when restarting the Mac. Use the Select Set pop-up menu (see Figure 5-5) to switch sets.

Obviously, this method presents one massive inconvenience: You have to remember to press the Space bar every time Mac OS 9 starts up (either in Classic or when dual booting) in order to summon Extensions Manager to make the switch. (All right, you wouldn't have to open Extensions Manager every time—only when switching the function of your Mac OS 9 System Folder [Classic or dual booting].)

This option can work just fine if:

  • you do most of your Mac OS 9 work in Classic, and you find yourself rebooting in Mac OS 9 only occasionally, or

  • you do most of your Mac OS 9 work by restarting into Mac OS 9, and you rely on Classic only occasionally.

In other words, the only inconvenient aspect of this setup is switching the function of your single Mac OS 9 System Folder.

TIP

If you have Conflict Catcher (www.casadyg.com), this single-System Folder business is much simpler. Its auto-detect feature can load one set of extensions when Classic is starting up, and a different set when you restart the Mac into Mac OS 9—all automatically.

5.4.5.2 Maintaining two different Mac OS 9 System Folders

Some people maintain two separate Mac OS 9 System Folders: one that's trimmed down for use in Classic (see Figure 5-3), and another that loads a complete set of extensions and drivers for use in restarting the Mac (Figure 5-9). This method doesn't require separate partitions or drives. Both System Folders—or all three, if you count the Mac OS X System folder—can sit on the same hard drive.

This arrangement frees you from the inconvenience of switching extension sets when switching a single System folder's function. But it does come with a hassle of its own: You're now maintaining duplicate sets of preference settings, Web bookmarks, and the like.

Suppose you bookmark a Web site when running a Classic Web browser. The next day, when you reboot into Mac OS 9, your Web browser no longer lists that bookmark. That's because Mac OS 9 stores its bookmark lists, like its preference files, inside the System Folder that's "in charge" at the time.

Fortunately, this inconvenience, too, may turn out to be a red herring, depending on your purpose in using Mac OS 9. The Web bookmark example really isn't a good one, because, for instance, you probably wouldn't want to use any version of Mac OS 9 for Web browsing. (Excellent Web browsers are available right in Mac OS X.) In real life, most people reboot into Mac OS 9 only for special purposes like scanning or using an old CD burner that doesn't work in Mac OS X or Classic. In these cases, the fact that each Mac OS 9 System Folder is maintaining a duplicate set of preference files will probably have little impact on your life, if you even notice it at all.


Chapter 6. Moving Data

The original 1984 Mac didn't make jaws drop because of its speed, price, or sleek looks. What amazed people most was the simplicity and elegance of the user interface. At some point in every Apple demo, the presenter copied a graphic drawn in a painting program (MacPaint) and pasted it directly into a word processor (MacWrite), where it appeared neatly nestled between typed paragraphs of text.

We take this example of data exchange for granted today. But in those days, that simple act struck people like a thunderbolt. After all, if this little computer let you copy and paste between different programs, it could probably do anything.

Today, the Mac is even more adept at helping you move and share your hard-won data. Mac OS X offers several different ways to move information within a single document, between documents, between different programs, and even between the Mac and Windows computers. This chapter leads you through this broad range of data-exchange mechanisms.


6.1 Moving Data Between Documents

You can't paste a picture into your Web browser, and you can't paste MIDI music information into your word processor. But you can put graphics into your word processor, paste movies into your database, insert text into GraphicConverter, and combine a surprising variety of seemingly dissimilar kinds of data.

6.1.1 Cut, Copy, and Paste

The original copy-and-paste procedure of 1984—putting a graphic into a word processor—has come a long way. Most experienced Mac users have learned to trigger the Cut, Copy, and Paste commands from the keyboard, quickly and without even thinking. Here's how the process works:

  1. Highlight some material in a document.

    In most cases, this means highlighting some text (by dragging through it, for example) in a word processor, layout program, Web-design program, or even a Web page in your browser. You can also highlight graphics, music, movie, database, and spreadsheet information, depending on the program you're using.

  2. Use the Cut or Copy command.

    You can either choose the Cut and Copy commands found in the Edit menu of almost every Mac program, or press the keyboard shortcuts [image] -X (for Cut—think of the X as representing a pair of scissors) or [image] -C (for Copy). When you do so, the Macintosh memorizes the highlighted material, socking it away on an invisible storage pad called the Clipboard. If you chose Copy, nothing visible happens. If you chose Cut, the highlighted material disappears from the original document.

    At this point, most Mac fans take it on faith that the Cut or Copy command actually worked. But if you're in doubt, switch to the Finder (by clicking its Dock icon, for example), and then choose Edit [image] Show Clipboard. The Clipboard window appears, showing whatever you've copied.

  3. Click the cursor to indicate where you want the material to reappear.

    This may entail switching to a different program, a different document in the same program, a program running in Classic mode, or simply a different place in the same document. (Rearranging sentences or paragraphs within a single document is probably the most popular use of these commands.)

  4. Choose the Paste command.

    Here again, you can do so either from a menu (choose Edit [image] Paste) or from the keyboard (press [image] -V)—and in many programs, even by clicking a toolbar button. The copy of the material you had originally highlighted now appears at your insertion point—that is, if you're pasting into a program that can accept that kind of information. (You won't have much luck pasting, say, a paragraph of text into Quicken.)

The most recently cut or copied material remains on your Clipboard even after you paste, making it possible to paste the same blob repeatedly. Such a trick can be useful when, for example, you've designed a business card in your drawing program and want to duplicate it enough times to fill a letter-sized printout. On the other hand, whenever you next copy or cut something, whatever was already on the Clipboard is lost forever.

Styled Text

When you copy text from, for example, Word X, and then paste it into another program, such as Mail, you may be pleasantly surprised to note that the formatting of that text—bold, italic, font, (size, color, and so on)—appears intact in Mail. You're witnessing one of the Mac's most useful but underpublicized features: its support for styled text on the Clipboard.

Not every Mac program on earth transfers the formatting along with the copied text, but almost all Mac OS X-compatible programs do. Every time you paste text copied from one of these programs, the pasted material appears with the same typographical characteristics it had in the original program. Over time, this tiny timesaver spares us years' worth of cumulative reformatting effort—yet another tiny favor the noble Macintosh does mankind.

6.1.2 Drag-and-Drop

As useful and popular as it is, the Copy/Paste routine doesn't win any awards for speed. After all, it requires four steps. In many cases, you can replace that routine with the far more direct (and enjoyable) drag-and-drop method. Figure 6-1 illustrates how this works.

NOTE

As noted in Chapter 4, some Mac OS X programs (Cocoa programs) require you to press the mouse button for half a second before beginning to drag.

Virtually every Mac OS X program works with the drag-and-drop technique, including TextEdit, Stickies, Mail, Sherlock, QuickTime Player, Preview, iMovie, iPhoto, and Apple System Profiler, not to mention commercial programs like Microsoft applications, America Online, and so on.

6.1.2.1 When to use drag-and-drop

As shown in Figure 6-1, drag-and-drop is ideal for transferring material between windows or between programs. It's especially useful when you've already copied something valuable to your Clipboard, since drag-and-drop doesn't involve (and doesn't erase) the Clipboard.

Figure 6-1. To use drag-and-drop, highlight some material. Click in the middle of the highlighted area; press the mouse button for about half a second. Now, with the button still pressed, drag to another place in the document, into a different window, or into a different application. As your cursor enters the target window, a shaded outline appears inside the window's boundaries—the Mac's way of letting you know that it understands your intention. When you release the mouse, the highlighted material appears instantly in its new location.

Its most popular use, however, is rearranging text within a single document. In Word or AppleWorks, for example, you can rearrange entire sections, paragraphs, sentences, or even individual letters, just by dragging them—a wonderfully efficient editing technique.

TIP

When you use drag-and-drop to move text within a document, the Mac moves the highlighted text, deleting the highlighted material from its original location. If you press Option as you drag, however, you make a copy of the highlighted text.

6.1.2.2 Using drag-and-drop to the desktop

You can also use drag-and-drop in the one program you use every single day: the Finder itself. As shown in Figure 6-2, you can drag text, graphics, sounds, and even movie clips out of your document windows and directly onto the desktop. Once there, your dragged material generally becomes an icon called a clipping file.

Figure 6-2. When you drag material out of the document window and onto the desktop, you get a clipping file. Its icon depends on the kind of material contained within: from top, a text clipping, picture clipping, and movie clipping. (For easy identification, Mac OS X conveniently titles text clippings by the first line of the text contained inside.) You can view a clipping just by double-clicking it, so that it opens into its own window (right).

NOTE

Internet Explorer and a few other programs create text files instead. Nobody's perfect.

When you drag a clipping from your desktop back into an application window, the material in that clipping reappears. Drag-and-drop, in other words, lets you treat your desktop itself as a giant, computer-wide pasteboard—an area where you can temporarily stash pieces of text or graphics as you work.

TIP

When the material you drag to the desktop contains nothing but an Internet address, such as an email address or Web page URL, Mac OS X gives it a special icon and a special function: an Internet location file. See Section 18.10 for details.

6.1.3 Export/Import

When it comes to transferring large chunks of information—especially address books, spreadsheet cells, and database records—from one program to another, none of the data-transfer methods described so far in this chapter do the trick. For these purposes, use the Export and Import commands found in the File menu of almost every database, spreadsheet, email, and address-book program.

These Export/Import commands aren't part of Mac OS X, so the manuals (if any) of the applications in question should be your source for instructions. For now, however, the power and convenience of this feature are worth noting—it means that your four years' worth of collected addresses in, say, your old email program can find its way into a newer program, like Palm Desktop, in a matter of minutes.


6.2 Exchanging Data with Other Macs

Considering how many ways there are to get files back and forth between Macs, it seems almost comical that anybody complained when Apple discontinued built-in floppy disk drives. For one thing, you can almost always email the file to someone—even to yourself! And there are plenty of other ways to move files around:

6.2.1 By Network

With about $50 worth of equipment (or $400, if you want to go wireless), you can connect your Macs together into a network. Once you've done so, you can keep an icon for each Mac's hard drive on your screen. You can open files from the other drives, copy stuff back and forth—anything you would do with your own disk.

Step-by-step instructions are in Chapter 12.

6.2.2 By CD or DVD

You can always burn your files onto a CD or DVD and then carry it to the other machine. You'd use this approach when, for example, you have a lot of data to copy, but the two Macs aren't within networking range: for example, they're not in the same room or the same city.

6.2.3 FireWire Disk Mode

FireWire Disk Mode is a brilliant but little-known feature that lets you turn one Mac into an external hard drive for another. This is by far the fastest method yet for transferring information—even faster than copying files over a network. It's extremely useful in any of these situations:

  • You're traveling with a laptop. You want to copy your life onto it from your main Mac, including your entire email folder and project files, before taking it on a trip, and then unload it when you return.

  • You have a new Mac. You want to copy everything off the old one, without having to wait all night.

  • You're off to a conference where other Mac folks might be in attendance with their laptops. You want to be ready for casual file transfers, so you pack the necessary FireWire cable in your laptop case.

  • One Mac won't start up. You want to repair it, using another Mac as a "front end."

In the following steps, suppose your main Mac is an iMac, and you want to use a PowerBook as an external hard drive for it.

  1. Shut down the PowerBook.

    Make sure it's plugged in, too. You wouldn't want the battery to die in the middle of this process. (Leave the iMac on.)

  2. Using a FireWire cable, connect the FireWire jacks of both computers.

    For this trick, you'll need a 6-pin FireWire cable—not the one that connects a camcorder to a Mac. The one you need has the same, large connector on both ends. (The one that comes with an iPod, incidentally, is exactly right.)

  3. Turn on the PowerBook. Hold down the T key immediately after the chime.

    You can release the key when you see a giant, yellow, Y-shaped FireWire icon bouncing around the laptop screen.

    Now take a look at the iMac's screen: Sure enough, there's the PowerBook's hard drive icon on the desktop. You're ready to copy files onto or off of it, and go on with your life.

  4. When you're finished working with the PowerBook, turn it off by pressing the power button.

    Disconnect the FireWire cable only when you're sure the laptop is off.

6.2.4 Via the iPod

As noted in Chapter 10, an Apple iPod is an extremely fine music player with enormous capacity. That's because it contains an actual hard drive that stores the songs.

But because the iPod has a FireWire connector, it makes a dandy portable hard drive for everyday files, too—not just music.

To set this up, proceed like this:

  1. Connect the iPod to your Mac with a FireWire cable.

    Use the white one that came with the iPod. It's got big FireWire connectors on each end, unlike the FireWire cable you'd use for a camcorder.

    (If this is the first time you've done this, the iTunes Setup Assistant may appear, offering you the chance to name your iPod.)

  2. Open iTunes. Click the iPod icon in the left-side Source list, and then click the iPod icon in the lower right-corner of the screen.

    The iPod Preferences window appears.

  3. Turn on "Enable FireWire disk use."

    A dialog box warns you that even when you're just syncing up your music collection (and not using the iPod as a hard drive for files), you'll have to manually eject the iPod after each use.

  4. Click OK, and then OK again.

    After a moment, you'll see the iPod's icon appear on your desktop.

Now you've got yourself a multi-gigabyte external hard drive. Just drag your files onto, or off of, the iPod icon, exactly as though it's a disk (which it is). The iPod automatically keeps your data files separate from your music files; your files won't be touched when you update your music collection from iTunes.

Whenever you're finished using the iPod as a hard drive, eject it in any of the usual ways. For example, drag its icon to the Trash, or Control-click it and choose Eject from the contextual menu.

6.2.5 Bluetooth

Bluetooth is a long-delayed, but promising, cable-elimination technology. It's designed to let Bluetooth-equipped gadgets communicate within about 30 feet, using radio signals.

Already you can buy Bluetooth adapters—little snap-on cartridges or slide-in cards—for computers, printers, Palm and PocketPC organizers, Sony camcorders, and so on. Even some phones have built-in Bluetooth transmitters.

Apple's Bluetooth adapter costs $50 and takes the form of a little nubbin that plugs into any Mac OS X Mac's USB port. Once you've installed its accompanying software (and, because Apple's early Bluetooth software is a bit iffy, made a couple of calls to Apple tech support), you'll be able sync with a Bluetooth-equipped Palm organizer, use a Bluetooth cell phone as a modem to get you online—and transfer files through the air to other Bluetooth Macs and PCs.

TIP

Using your Mac to go online with your cell phone requires a Bluetooth cell phone model (such as the Ericsson T68); a cell plan that permits Internet access (for an additional fee); and considerable technical fiddling. The PDF file that comes with Apple's Bluetooth adapter contains instructions.

To shoot a file or two across the airwaves to a fellow Bluetooth-equipped Mac fan, proceed like this:

  1. Open System Preferences. Click the Bluetooth icon.

    This panel appears in System Preferences only if you do, in fact, have a properly installed Bluetooth adapter.

  2. Click the Settings tab (Figure 6-3). Turn on Discoverable.

    Discoverable means, "Other Bluetooth gadgets can see me."

  3. Close System Preferences. Find Bluetooth File Exchange.

    You'll find it in your Applications [image] Extras [image] Bluetooth folder, assuming you installed the Bluetooth software that came with your adapter.

  4. Drag the files you want to send onto the Bluetooth File Exchange icon.

    A dialog box appears.

  5. Click Search.

    The Bluetooth software scans the airwaves in search of other Bluetooth-equipped computers. At least in the near term, as Bluetooth slowly catches on, you'll probably know perfectly well which ones are in range. (They, too, must be in Discoverable mode, by the way.)

  6. In the list of found machines, click the name of the one you want to send your files to, and then click Send.

    What happens now—on the receiving end—depends on how the receiving Mac has been set up; see Figure 6-4. In most cases, a dialog box tells the receiver that files are arriving; if he clicks Accept, the download proceeds.
Figure 6-3. If a device (like your Mac) isn't in "discoverable" mode, then no other Bluetooth gizmos can see it. You get plenty of privacy, but no productivity. While you're at it, by the way, you might want to turn on "Show Bluetooth status in the menu bar." This checkbox produces a menulet in the menu bar, which produces a menu of useful settings.
Figure 6-4. You can control what happens when someone sends you files via Bluetooth. Usually, you'll want your Mac to ask you whether or not to accept these files (that's what the option "Prompt for each file" means). You can also specify where you want received files to wind up. Here, they've been set to land in your Home Documents folder.

NOTE

When you send files to a Windows PC or some other gadget using this method, security may be tighter. You may be asked to make up a temporary, one-time password that must be typed into both your Mac and the receiving device within, say, one minute, to prove that this transfer is authorized.

Bluetooth isn't especially fast—in fact, it's pretty slow. (You'll get transfer speeds of 30 to 50 K per second, depending on the distance.) But when you consider the time you'd have taken for wiring, passwords, and configuration using any other connection method, you may find that Bluetooth wins, at least in casual, spur-of-the-moment, airport-seat situations.

When you consider that Bluetooth works no matter what the operating system—Mac, Windows, Palm, Pocket PC—you can see that it has great potential as a universal file-exchange translator, too.


6.3 Exchanging Data with Windows PCs

It's no surprise that the Mac is great at transferring information among Mac programs. The big news is how easy Mac OS X makes it to transfer files between Macs and Windows computers—especially in version 10.2.

Documents can take one of three roads between your Mac and a Windows machine: you can transfer it on a disk (such as a CD or Zip disk), via network, or as an attachment to an email message.

6.3.1 Preparing the Document for Transfer

Without special adapters, you can't plug an American appliance into a European power outlet, play a CD on a cassette deck, or open a Macintosh file in Windows. Therefore, before sending a document to a colleague who uses Windows, you must be able to answer "yes" to both of these questions:

6.3.1.1 Is the document in a file format Windows understands?

Most popular programs are sold in both Mac and Windows flavors, and the documents they create are freely interchangeable. For example, documents created by recent versions of Word, Excel, PowerPoint, FileMaker, FreeHand, Illustrator, AppleWorks, Photoshop, Dreamweaver, and many other Mac programs don't need any conversion. The corresponding Windows versions of those programs open such documents with nary a hiccup.

Files in one of the standard exchange formats don't need conversion, either. These formats include JPEG (the photo format used on Web pages), GIF (the cartoon/logo format used on Web pages), HTML (raw Web page documents before they're posted on the Internet), Rich Text Format (a word-processor exchange format that maintains bold, italic, and other formatting), plain text (no formatting at all), QIF (Quicken Interchange Format), MIDI files (for music), and so on.

But what about documents made by Mac programs that don't exist on the typical Windows PC hard drive, such as AppleWorks 6? It's available to educators in a Windows version, but you certainly can't count on your recipient having it.

Do your recipients the favor of first saving such documents into one of the formats listed in the previous paragraphs. In AppleWorks, for example, choose File [image] Save As; from the File Type pop-up menu, choose "Word Win 97, 2000"; name this special version of the document (remember the .doc suffix); and then click Save.

6.3.1.2 Does the file have the correct three-letter file name suffix?

As noted in Chapter 4, every document on your hard drive has some kind of tag to tell the computer what program is supposed to open it: either a pair of invisible four-letter codes or a file name suffix like .doc.

Microsoft Windows uses only the latter system for identifying documents. Here are some of the most common such codes:

Kind of document | Suffix | Example
Microsoft Word | .doc | Letter to Mom.doc
Excel | .xls | Profit Projection.xls
PowerPoint | .ppt | Slide Show.ppt
FileMaker Pro | .fp5 | Recipe file.fp5
JPEG photo | .jpg | Baby Portrait.jpg
GIF graphic | .gif | Logo.gif
Web page | .htm | Index.htm

The beauty of Mac OS X (starting in 10.1) is that your Mac adds these file name suffixes automatically and invisibly, every time you save a new document from a Mac OS X program. You and your Windows comrades can freely exchange documents without ever worrying about this former snag in the Macintosh/Windows relationship.

6.3.2 By Disk

Once you've created a document destined for a Windows machine, your next challenge is to get it onto that machine. One way is to put the file on a disk—a CD you've burned, a floppy, or a Zip disk, for example—which you then hand to the Windows user. (Modern Macs don't have built-in floppy drives, of course, but adding one costs only about $45. Most Windows PCs still have built-in floppy drives.)

In theory, this kind of exchange shouldn't be possible, because Macs and PCs format disks differently. When you insert a Mac floppy disk into a PC, for example, an error message declares it to be unreadable. Windows then offers to "correct" the problem by erasing the disk.

6.3.2.1 How the Mac reads Windows disks

Fortunately, although Windows can't read Mac disks, the Mac can read Windows disks. When you insert a Windows-formatted floppy, Zip, or CD into your Mac, its icon appears onscreen just like a Mac disk. You can drag files to and from this disk (or its window), rename files, delete files, and so on, exactly as though you're working with a Mac disk. (It doesn't operate nearly as quickly as a Mac disk, though.)

6.3.2.2 Creating a Windows disk on the Mac

You can even create a Windows disk on your Macintosh. CDs that you burn on the Mac, for example, are Windows compatible right out of the gate.

To share a floppy or Zip disk, you must first erase it using Disk Utility (in your Applications [image] Utilities folder). Click the Erase tab, and then insert the disk, so that its icon shows up in the list at the left side of the window. Click it, use the pop-up menu to specify MS-DOS File System format, and then click Erase. After the erasing process is over, you can insert the floppy into both Macs and PCs with equal success.

6.3.3 By Network

Here's one of the best features of Mac OS X: It can "see" shared disks and folders on Windows PCs that are on the same network. Seated at the Mac, you can open or copy files from a PC—or vice versa. Complete instructions are in Chapter 12.

6.3.4 Via the Internet

Chapter 21 offers details on FTP and Web sharing, two ways to make your Mac available to other computers—Windows PCs or not—on the Internet.

6.3.5 By Email Attachment

Among the most popular means of transferring files between Mac and Windows is plain old email. When using Mail, for example, you can drag any icon from your desktop directly into the email message window. The file you dragged will shortly arrive in the email box of your lucky recipient.

For some people, however, the email-attachment route is fraught with frustration. At times, it seems as though half of all attachment files arrive at the other end in unopenable condition.

In most cases, the problem is either that you're sending a document that Windows can't open, or your email program is making the attachment incompatible when it shrinks and encodes it for sending. Compression and encoding are necessary parts of the email process, as explained below; the idea is to use the proper settings so that as many people as possible can open your attachments.

6.3.5.1 File compression and encoding

The technology behind email attachments is somewhat technical, but extremely useful in understanding why some attachments don't make it through the Internet alive.

When you send an email attachment, your email program does two things. First, it may compress the attached file so that it takes less time to send and receive.

The second process is more technical. Surprising as it may seem, the Internet cannot, in fact, transmit files—only pure text. Your email program, therefore, takes an additional moment to encode your file attachment, converting it into a stream of text code to be reconstructed by your recipient's email program.

Each of these processes can foul up file attachments.

  • File compression problems: Some Mac email programs compress outgoing files using the StuffIt method—but Windows recipients can't open StuffIt files. When sending files to Windows computers, therefore, you should turn off the StuffIt compression option in your email program. (Alternatively, you can ask your recipient to download StuffIt Expander for Windows, available at www.aladdinsys.com, which can indeed open StuffIt attachments. Word of caution: Unless your correspondent is related to you by blood, don't expect a warm reception to this suggestion.)

    America Online is a particular problem. When you attach multiple files to a single email message, AOL uses StuffIt compression automatically—and you can't override this behavior. When sending files to Windows friends from AOL, therefore, attach only a single file per email message.

  • File encoding problems: Most email programs offer a choice of encoding schemes, which bear such unfriendly names as MIME/Base64 (the only option in the Mail program that comes with Mac OS X), UUEncode, and AppleDouble. If you have a choice in your particular email program, use MIME/Base 64 or AppleDouble. File attachments encoded this way arrive intact on both Mac and Windows machines.

6.3.5.2 Problems receiving Windows files

When your Mac receives Windows files by email, the problems aren't so severe. Most email programs, including Mail and Entourage, decompress and decode file attachments automatically. When they don't, you can drag the downloaded file onto the icon of the free utility program, StuffIt Expander (which comes with Mac OS X, in your Applications [image] Utilities folder). StuffIt Expander can convert almost any Internet file in existence back into human form.

It's worth noting once again, however, that not every file that came from Windows can be opened on a Macintosh, and vice versa. A file whose name ends in .exe, for example, is a double-clickable Windows application and doesn't run on the Mac (at least, not unless you've gone to the expense and trouble of installing a Windows emulator program like Virtual PC). See the table in Section 6.3 for some examples of files that transfer well from Windows to Mac and don't need converters or adapters of any kind.


Chapter 7. An Introduction to AppleScript

You can think of AppleScript programs (called scripts) as software robots. A simple AppleScript might perform some simple daily task for you: backing up your Documents folder, for example.

A more complex script can be pages long. In professional printing and publishing, where AppleScript enjoys its greatest popularity, a script might connect to a photographer's hard drive elsewhere on the Internet, download a photo from a predetermined folder, color-correct it in Photoshop, import it into a specified page-layout document, print a proof copy, and send a notification email to the editor—automatically.

Even if you're not aware of it, you use technology that underlies AppleScript all the time. Behind the scenes, numerous components of your Mac communicate with each other by sending Apple Events, which are messages bearing instructions or data that your programs send to each other. When you use the Show Original command for an alias, or the Get Info command for a file or folder, an Apple Event tells the Finder how to respond. Many of the files in the Speakable Items folder (Section 14.4.2), furthermore, are AppleScripts that quit your programs, open AppleWorks, switch a window into list view, and so on.


7.1 Running Ready-Made AppleScripts

You don't have to create AppleScripts to get mileage out of this technology. Mac OS X comes with several dozen prewritten scripts that are genuinely useful—and all you have to do is choose their names from a menu. "Playing back" an AppleScript in this way requires about as much technical skill as pressing an elevator button.

To sample some of these cool starter scripts, you must first bring the Script menu to your menu bar (a new feature in Mac OS X 10.2). To do so, open your Applications [image] AppleScript folder. Inside, you'll find an icon called Script Menu.menu (it may look like a folder). Install it on your menu bar either by double-clicking its icon or by dragging it to the menu bar.

Now open the newly installed Script menu, whose icon looks like a scroll, to see the list of prewritten scripts.

TIP

The Script menu reflects the contents of your Home [image] Library [image] Scripts folder, and the main Library [image] Scripts folder. These scripts aren't just for running like the little software slaves they are. They're also ideal for opening up in Script Editor (just by double-clicking each) and analyzing line by line, to learn how they work. (Script Editor is a program in your Applications [image] AppleScript folder, which you can use to type up your own scripts.) Once you understand the syntax, you can then copy bits of the code to modify and use in your own scripts.

Figure 7-1. Mac OS X comes with an assortment of useful scripts to try. The Script menu (which you install from your Applications AppleScript folder) lets you launch Perl, Shell, and AppleScript scripts, just by choosing their names, from within any application. To install it, just double-click it or drag it onto your menu bar.

Some of the scripts operate on familiar components of the Mac OS, like the Finder; others show off applications or features that are new in Mac OS X. Here's what they do:

7.1.1 Basics

In this folder, you'll find a few simple scripts:

  • AppleScript Help opens the Help Viewer, brings it to the front, and searches for the word AppleScript to bring up a list of links to the AppleScript topics available in Help.

  • AppleScript Website simply opens the AppleScript Web page in your Web browser.

  • Open Script Editor launches the Script Editor application, which you can use to edit and write your own AppleScript programs.

7.1.2 ColorSync

In this folder, you'll find eighteen ColorSync script droplets (scripts that run when you drop something on their icons), new in Mac OS X 10.2, that should be of interest to graphic artists, Web site designers, publishers, and so on.

If you choose a script's name from the menu, you'll get a terse help message and then an Open dialog box for choosing the graphics files you want to process. Alternatively, you can open the Library [image] Scripts [image] ColorSync folder and then drag the graphics files onto the script's icon.

7.1.3 Finder Scripts

All of these scripts have to do with work in the Finder: manipulating files and windows, for example. Several are designed to change file or folder names en masse, which can be a huge timesaver.

  • About Finder Scripts opens a dialog box that tells you how the other Finder scripts operate—that is, the scripts affect whatever is in the frontmost window.

  • Add to File Names, Add to Folder Names. These scripts tack on a prefix or suffix to the name of every file or folder in the frontmost Finder window (or, if no windows are open, on the desktop). Now you're starting to see the power of AppleScript: You could use this script to add the word draft or final or old to all of the files in a certain folder.

  • Change Case of Item Names offers to capitalize, or un-capitalize, all the letters of the file names in the window before you.

  • Finder Windows - Hide All minimizes all open Finder windows to the Dock. Finder Windows - Show All, of course, brings them back from the Dock.

  • Replace Text in Item Names lets you do a search-and-replace of text bits inside file names, folder names, or both. When one publisher rejects your 45-chapter book proposal, you can use this script to change all 45 chapter files from, for example, "A History of Mouse Pads—A Proposal for Random House, Chapter 1 to "A History of Mouse Pads—A Proposal for Simon & Schuster, Chapter 1.

  • Switch to Finder is a great one. It brings the Finder to the front and hides all of the other running applications.

  • Trim File Names, Trim Folder Names. If you made a mistake in using the Add to File Names script, you can always use Trim File Names script to undo the damage. This one removes file extensions, suffixes, or prefixes of your choosing.

    For example, suppose you've just made a lot of new folders at once. Mac OS X calls them "untitled folder," "untitled folder 2," and so on. But what if you'd rather have them just called "folder 1," "folder 2," and so on? Run the Trim Folder Names script; when the dialog box asks you what you want trimmed, type untitled and click OK.

7.1.4 Folder Actions

This folder contains the four vital scripts, new to 10.2, that make folder actions work (Section 7.2.2).

  • Attach Script to Folder attaches your own folder action scripts to a folder.

  • Disable Folder Actions and Enable Folder Actions turns folder actions off and on for your Mac.

  • Remove Folder Actions detaches a folder action from a folder.

7.1.5 Folder Action Scripts

The scripts in this folder, new in 10.2, don't actually show up in the Script Menu. They are, however, in your Library [image] AppleScript [image] Scripts folder. You need to attach them to folders in order to use them.

They're sample folder action scripts—designed to make folders behave the way you wish they would. These scripts are useful just as they are, but even more useful as examples to help you learn the syntax for writing folder action scripts (Section 7.2.2).

  • add - new item alert. When you drop icons into a folder (to which you've attached this script), the Mac will tell you how many icons were added, and offer you the chance to inspect the contents of the folder.

  • close - close sub-folders. When you close the folder to which this script is attached, all folders inside it also close.

  • open - show comments in dialog. Whenever you open the folder to which this script is attached, you'll be shown whatever's in its Comments box (that is, whatever you typed into the Comments area of its Get Info window). You'll be given the chance to open the Get Info window, clear the comments, or do nothing further.

7.1.6 FontSync Scripts

FontSync is a noble Apple attempt to solve an old problem for desktop publishers. You finish designing some beautiful newsletter, take it to the local printing shop for printing on a high-quality press, and then have to throw out the entire batch—all because the fonts didn't come out right. The printing shop didn't have exactly the same fonts you had when you prepared the document. Or, worse, it did have the same font—but from a different font company, with the same name but slightly different type characteristics.

FontSync is designed to give you early warning for such disasters. When you run the Create FontSync Profile script, several minutes elapse—and then the Mac generates a FontSync Profile document. This file contains staggering amounts of information about the design, spacing, and curlicues of every font installed in your system. When you hand that profile over to your print shop, they can drop it onto the accompanying script, called Match FontSync Profile. It will tell them precisely what fonts are different on their Macs and yours.

The wishful-thinking aspect of this technology is, of course, that it assumes a lot: that your print shop uses Mac OS 9 or Mac OS X, that the print shop knows how to use FontSync, and that you remember to create the profile and submit it.

7.1.7 Info Scripts

These two scripts offer minor usefulness:

  • Current Date & Time displays the current date and time in a dialog box, complete with a Clipboard button that copies the information, ready for pasting.

  • Font Sampler is designed to show you what all your fonts look like (see Figure 7-2).

Figure 7-2. The Font Sampler script launches TextEdit, opens a new TextEdit document, and fills it with dozens of copies of the classic "What does this font look like?" test sentence: The quick brown fox jumped over the lazy dog. Then, as you watch, it formats each line with a different font—a good page to print out and keep as a reference.

7.1.8 Internet Services

These scripts are designed to show off the power of XML-RPC and SOAP, two Internet-query technologies that debuted in Mac OS X 10.1.

  • About Internet Services Scripts tells you what the other two scripts in this folder are all about. The dialog box offers a "Visit Web site" button that takes you to www.xmethods.com, where you can find out more about creating Internet service scripts.

  • The Stock Quote and Current Temperature by Zipcode fetch those respective bits of information, popping them into a dialog box without having to use your Web browser, thanks to the power of SOAP (Simple Object Access Protocol).

7.1.9 Mail Scripts

This collection of scripts, newly expanded in Mac OS X 10.2, communicates with Mail (see Chapter 19).

  • Check My IMAP Quota creates a quota report that includes the total size of all of your IMAP mailboxes.

  • Count Messages in All Mailboxes counts all messages and unread messages in all of your mailboxes and displays the result.

  • Crazy Message Text is Apple at its wackiest. When you run it, a dialog box asks you what message you want to send ("Happy Birthday," for example). Mail then creates a colorful, zany, outgoing formatted message in which each letter has a random typeface, style, color, and size. It's ideal for making people think you spent a long time with your Format menu for their entertainment.

  • Create New LDAP Server walks you through the creation of a new LDAP server entry. (It's primarily of interest to people who know what LDAP servers are.)

  • Create New Mail Account walks you through the creation of a new POP, IMAP, or .Mac mail account, which can be convenient if you often set up new mail accounts.

  • Create New Message walks you through the creation of a new message including the recipient, sender, attachments, subject, and so on, saving you a step if the Mail program isn't already open and active.

  • Display All Accounts And Preferences prepares a new mail message that includes information about every account you have configured and the preference settings you have set in Mail, all ready to send to some troubleshooting expert who needs the details in order to help you.

  • Import Addresses grabs names from the address book from Entourage, Eudora, Outlook Express, or Palm Desktop. It's not actually a Mail script—it brings the addresses into Mac OS X's Address Book program—but it's still handy if you've decided to switch from one of those programs to Apple's Mail program.

  • Manage SMTP Servers checks all of your defined SMTP servers and allows you to remove any orphaned ones (that is, ones that none of your email accounts is using).

  • Quick Mail prompts you for an address and a subject line, launches the Mail application, and sets up a new message for you with those attributes. With a little analysis of this script, you should be able to see how it could save you time in generating canned, regularly scheduled outgoing mail messages.

The Mail Scripts [image] Helper Scripts folder contains code used by the Import Addresses script described above; there are no actual scripts in here.

7.1.10 Navigation Scripts

Four of these scripts—New Applications Window, New Home Window, New Documents Window, and New Favorites Window—all open the corresponding windows, just as though you'd used the Go menu to choose their names. (As for the word "New"—it's a red herring. These scripts do not, in fact, open a new window if one is already open.)

The Open Special Folder script presents a list of Mac OS X's special folders: Applications, Favorites, Movies, Sites, Utilities, and so on. Double-click the one you want to open—a straight shot to some of Mac OS X's most important folders.

TIP

If you're game to edit this script in Script Editor, you can modify the script so that it will let you choose and open more than one folder simultaneously (by [image] -clicking them, for example). Just type multiple selections allowed true right after the text Choose folder to open: (which appears at the end of a line about a third of the way down the script). Save your changes.

7.1.11 Script Editor Scripts

These are AppleScript tools for people who make AppleScripts.

  • About these scripts lets you know that these scripts put canned chunks of AppleScript code onto the Clipboard, ready for pasting into a program you're writing in Script Editor. If you begin scripting in earnest, these scripts-to-go can help you write faster and more accurate scripts, because the code chunks are free of typos and syntax errors.

  • Error Handlers are mini-routines that advanced scripters can use to handle situations when a script runs into trouble. One displays an error message with an OK button, another with a Cancel button, and so on.

  • Repeat Routines let you create loops within your script, so that, for example, you can process every file in a folder the same way.

7.1.12 Sherlock Scripts

The sole script here, Search Internet, prompts you for a search string (the words you want to search the Web for). When you click Search, the script opens Sherlock and proceeds to execute your search. All of this saves you a few mouse clicks, but this script was likely designed to serve primarily as an example for study by scripting hopefuls.

7.1.13 URLs

All of the scripts in this folder simply open your browser, connect to the Internet if necessary, and then open the specified Mac-fan Web pages (the stock quote for Apple on Yahoo, the Apple Store, CNN, MacWeek [now defunct], and Macintouch). The last script, Download Weather Map, is much cooler; in a flash, it downloads the current U.S. weather-map image and then opens the file in the Preview program for viewing.

The AppleScript Related Sites scripts in this folder open the most popular and useful AppleScript sites: Bill Cheeseman's AppleScript Sourcebook, MacScripter.net, and Apple's own AppleScript Web site. Each offers a wealth of information and links to even more great AppleScript sites.


7.2 Writing Your Own AppleScripts

If you ask a crowd of Mac users how many of them write AppleScripts, few hands are likely to go up. That's too bad, because as programming languages go, AppleScript is easy to understand. It takes only a few weeks, not years, to become comfortable with AppleScript. And the power AppleScript places in your hands is well worth the effort you'll expend learning it.

For example, here's a fragment of actual AppleScript code:

open folder "AppleScript" of folder "Applications" of startup disk

You probably don't need a manual to tell you what this line from an AppleScript program does. It opens the Applications [image] AppleScript folder on your hard drive. (That's the folder that contains Script Editor, the Mac OS X program that lets you write your own AppleScripts, and Script Menu.menu, described in Section 7.1.)

If you have no interest in learning to program, you're forgiven; you're not alone. But almost every Mac user can benefit by understanding what AppleScript can do, why it's important in certain industries, and how it may be useful in special situations. Even skimming this section will give you an appreciation of AppleScript's power—and yet another reason to relish being a Mac user: Windows has no equivalent of AppleScript. And with AppleScript's ability to tie into Terminal to run Unix commands, the power available to you has become even greater.

AppleScript in Mac OS X: Starting from Scratch

After years of refinement, the AppleScript of Mac OS 9 had become a solid tool with lots of features. Unfortunately, adapting AppleScript to Mac OS X wasn't completely painless.

A lot of the great old scripting tools (like scripting additions), Web sites, and Internet discussion lists apply only to AppleScript in Mac OS 9 and earlier. Thousands of scripts that require the old Finder flounder in the Mac OS X Finder, which works somewhat differently.

Nonetheless, Apple restores more AppleScript goodness to each successive version of Mac OS X. Folder actions, for example, reappeared in 10.2, as described in this chapter.

But many other features, including Finder recordability (the ability to write a script just by doing something as the Mac records your actions in "watch me" mode) may be gone forever. As a result, not everyone who depends on AppleScript has made the switch to Mac OS X.

Until the situation improves, people who want to learn scripting have to live in three worlds. You have to master AppleScript as it works in Mac OS 9, as it works in Classic (Chapter 5), and as it works in Mac OS X. AppleScript is slightly different in each of these three environments.

(Fortunately, scripts written in Mac OS X can control applications running in Classic, and vice versa. If you're still obligated to run certain programs in the Classic world, this feature may turn out to be very handy.)

This chapter covers AppleScript in all three worlds—Mac OS 9, Mac OS X, and Classic. You'll be a better-armed scripter for knowing all three systems during the migration period.

7.2.1 What's New in Mac OS X

Some of the new features in Mac OS X (10.1 and later) include:

  • Toolbar Scripts. In Mac OS X, you can turn scripts into standard, double-clickable programs that you can stash on your Dock, in a Finder-window toolbar, or anywhere else fine applications are stashed. Several dozen come with Mac OS X (see Section 7.1), and many more are available for downloading from www.apple.com/applescript/toolbar.

  • Script Menu adds a Scripts menu to your menu bar (Figure 7-1), offering a quick way to trigger your scripts. (Veteran scripters may recognize it as the Mac OS X equivalent of the venerable OSA Menu for pre-Mac OS X systems.) You can use Script Menu in Mac OS X 10.1, but you have to download it first Apple's Web site. At this writing, it's at www.apple.com/applescript/script_menu.

    NOTE

    if you put a new script into one of your Mac's two Scripts folders, it immediately shows up in the Scripts menu.

  • Unicode is a system designed to replace ASCII as the data format for representing text, and now Mac OS X understands it. (Unicode can describe a much larger "alphabet" than ASCII, making it possible to incorporate all the symbols of languages like Greek, Chinese, and Japanese into a single font file.)

  • Support for XML-RPC and SOAP. As noted earlier, these new protocols let certain Web sites serve up almost any kind of data imaginable to your script for further processing. Even at this early stage, you can write AppleScripts that pull down word definitions, jokes of the day, currency exchange rates, and so on, right to your Mac; a script query of a SOAP server is much faster than loading a Web page.

  • Scriptable Terminal. Not only can you run scripts from the command line in Terminal (Chapter 15), but now you can script the Terminal application itself so that it runs other scripts. All of this puts a lot of new power in the hands of scripters who are willing to embrace the intricacies of Unix.

  • Scriptable Digital Hub. In the CDs & DVDs panel of System Preferences, you can now designate a script to run automatically when you insert a CD or DVD (see Chapter 8). This option is new in Mac OS X 10.2.

  • Text to Audio File. Starting in 10.2, your Mac can perform an astonishing feat: It can convert a text file into a spoken digital recording in AIFF audio format.

    This is a twist with huge implications. If you transfer these files to your iPod, you can listen to your documents—email, Web pages, reports, e-books, or anything else you can type or download—as you commute, work out, or work outside.

    Of course, commuters and joggers have been listening to Books on Tape for years, and companies like Audible.com create what you might call Books on MP3. But those products are expensive, and you can't listen to your own stuff.

    To pull this off, just download the two sample scripts at www.apple.com/applescript/macosx/text2audio.html.

  • Scriptable Address Book. The enhanced address book program in Mac OS X 10.2 is now fully scriptable.

  • Finder-independent file management. In Mac OS X 10.2, you can manage files and folders by interacting directly with the faceless System Events application instead of the Finder. In some instances, advanced scripters can enjoy significant speed advantages when they bypass the Finder.

  • AppleScript Studio (ASS for short—how did this one get past marketing?). When you get really serious about creating AppleScripts, you'll want to check out this programming kit from Apple. Technically, it's an integrated development environment that combines Project Builder and Interface Builder, making AppleScript a peer language of Java and Objective C. In plain language, ASS lets you put a real Aqua user interface on your scripts, complete with dialog boxes, text boxes, buttons, slide controls, and much more. It also lets you combine multiple scripts into a single program.

    AppleScript Studio is free. It's part of the Developer Tools kit described in The Developer Tools CD Extras.

7.2.2 Folder Actions

A folder action is a script that the Mac triggers automatically whenever you do something specific to a particular folder: open it, close it, move it, resize it, or change its contents.

Folder actions, familiar to Mac OS 9 fans, weren't part of Mac OS X 10.0 or 10.1. But in 10.2, they're back, much to the delight of AppleScript aficionados. You no longer have to boot into Mac OS 9 to check out this powerful AppleScript function.

There's a major improvement in the way the scripts work, too. No longer do folders have to be already open in order for folder actions to work. You can now attach folder actions to any folder, closed or open—even invisible Unix folders—and they will do your bidding.

7.2.3 Attaching and Removing Folder Actions

If you've never before used folder actions, first run the Enable Folder Actions script from the Scripts Menu, which turns on the feature.

Then, to attach a script to a folder, see Figure 7-3. (It's perfectly OK to attach more than one script to a folder.)

TIP

A folder shows no indication that an action is attached; it doesn't display a little "badge," as it did in Mac OS 9. You can, however, change its icon to a badged one manually. The badged icon is available at www.apple.com/applescript/folder_actions, along with updated versions of the canned folder action scripts that come with your system.

To remove an attached script from its folder, run the Remove Folder Actions script from the Scripts menu. You're shown a list of folders that have folder actions attached; select the one you want to cleanse.

Figure 7-3. Top: From the Scripts menu, choose Folder Actions Attach Script to Folder, and then select the folder action script you want to run whenever somebody interacts with the specified folder. Bottom: You're now prompted to select the folder that will accept the folder action attachment.

7.2.4 What They're Good For

For a simple example of what folder actions can do, here's one that notifies you whenever somebody has put new files into a particular folder. Type this text into Script Editor, as described in Section 7.5.2, save it to your hard drive, and then attach it to a folder as described above:

on adding folder items to this_folder
        tell application "Finder"
        set the folder_name to the name of this_folder
        display dialog "Someone has put new files into the folder
called " & the folder_name giving up after 30
        end tell
end adding folder items to

This script incorporates several useful AppleScript techniques you haven't yet seen in this chapter. For example:

  • on adding folder items to. This phrase tells the Mac that the script should run when one or more items have been added to the folder.

  • this_folder. This term isn't a standard AppleScript term; it's a variable. You can substitute almost any word you like (it doesn't have to be this_folder). It's no secret to the Mac which folder "this folder" refers to, because you told it which folder when you attached the folder action script.

  • folder_name. This term is another variable. In order not to have to type the name of this_folder over and over again, the skilled scripter would use a new variable "folder_name" to hold the value that longer phrase represents—that is, the folder's name.

  • &. The & is the concatenation operator. It allows you to splice together, or concatenate, separate text chunks. When you're composing the message that you want to appear in a dialog box (as indicated by the "display dialog" command above), you can string together text you've written between quotes and text in any variables in your script. In this example, the fourth line of the script creates a dialog box that says, "Someone has put new files into the folder called Fish Heads" (or whatever the folder is called).

After you've attached this script to a folder, nothing happens until you drop a new file into the folder, at which time a message appears, saying, "Someone has put new files into the folder called 'Submissions.'" This way, you can keep tabs on what your network buddies are submitting while you work on other things.

TIP

You can find a powerful assortment of ready-made folder actions, in your Mac OS 9 System Folder [image] Scripts [image] Folder Action Scripts folder. (Many more of them are here than have been so far provided with Mac OS X.) Some will need to be adapted to run in OS X, but they're a good starting point for experimentation.

Keep an eye on Apple's AppleScript Web site for any updates that may include new folder action scripts. Useful things appear there frequently.


7.3 Recording Scripts in "Watch Me" Mode

You can, if you wish, create a script by typing out the computer commands one at a time, just as computer programmers do the world over. Details on this process later in the chapter.

But if the task you want it to handle isn't especially complex, you can create a script just by doing the job manually—using menu commands, dragging icons, opening windows, and so on—as Script Editor watches and writes out the necessary lines of code automatically. Recording an action and watching the Mac turn your movements into lines of AppleScript code is a fantastic way to learn how AppleScript works.

Unfortunately, as noted earlier, one of the biggest disappointments in Mac OS X is that the Finder is no longer recordable; that is, you can no longer create an AppleScript by performing certain actions as the Mac writes down what you're doing.

Apple may someday restore recordability to the Mac OS X Finder. But in the meantime, you can try out recordability either in a Mac OS X program that is recordable, such as AppleWorks, or by restarting your Mac in Mac OS 9, where the Finder is recordable. Because not everyone has AppleWorks, the following tutorial takes the second approach.

7.3.1 A Simple Auto-Recorded Script

Try this experiment in Mac OS 9. (Do so if your Mac can start up in Mac OS 9 at all, that is. If not, read along anyway; the following section still provides a useful glimpse into the structure of scripts.)

The script you'll build here creates a brightly colored, can't-miss-it folder into which you can stuff your newly created documents each day for backup. In the following section, you'll find a line-by-line analysis of the result.

  1. Open Script Editor.

    Script Editor is in your Apple Extras [image] AppleScript folder. It looks like Figure 7-4 (except that the window appears empty when it first opens). If you don't see an open window like the one illustrated, choose File [image] New Script.

  2. Click Record.

    Script Editor is about to write out the code that describes each mouse movement, click, and menu command from now on. In this experiment, you'll create a new folder, name it, label it, and then move it to a convenient position on the desktop.

  3. Click your desktop. Choose File [image] New Folder. Type Today's Backup and then press Return.

    You've just made a new folder on your desktop. If you sneak a peek at your Script Editor window, you'll see that it has begun to notate the computer commands that represent what you've done so far.

    So that you can't miss it when it's time to back up your work for the day, apply a label to your new folder:

  4. Choose File [image] Label [image] Essential (or whichever label you prefer).

    Finally, you should move this backup folder away from your hard drive, where it's too easy to get lost.

  5. Drag the Today's Backup folder to a new position on the screen—just above the Trash, for example.

    That's all this modest AppleScript will do: Create a new folder, name and label it, and then drag it to a new spot.

  6. Click in the Script Editor window, and then click Stop.

    Your newly created script is complete, as shown in Figure 7-4.
Figure 7-4. The Script Editor in action. Type a short description into the top window, if you like—or eliminate the top window by collapsing the "flippy triangle" button beside it. This script appears already formatted with boldface and indents since it was created using "watch-me" mode.

To try out this masterful automation sequence, click your desktop and then throw away the Today's Backup folder, so that you can start fresh. Once again, return to Script Editor—but this time, click Run.

In rapid, ghost-driven sequence, you'll see AppleScript create another Today's Backup folder, label it with a color, and drag it to precisely the spot on the screen where you dragged the first one by hand—all in a fraction of a second. The script you've created isn't the world's most useful, but it illustrates how powerful and fast AppleScript can be.

Boldface Words in Scripts

Why does Script Editor put random words in bold type?

They're not actually random.

The words in boldface type are AppleScript reserved words, terms that have a special meaning for AppleScript and therefore can't be used in your script for other purposes (like variable names).

Some reserved words are commands, like get, or set, and some define the beginning and the end of control statements like repeat...end repeat, or tell ... end tell. Others, like the, do nothing but improve the readability of the script commands.

Some reserved words always appear in pairs in commands. For example, a set command always has the reserved word to later in the same line (set myAge to 17, for example).

7.3.2 Understanding AppleScript Commands

Eventually, you'll discover that scripts you create in "watch me" mode are fairly limited. If you want to write scripts for non-recordable programs—like the Mac OS X Finder—you'll eventually have to learn to type out AppleScript code for yourself.

As a first step in understanding the AppleScript language, study the code written by Script Editor in the previous example. As it turns out, much of this script consists of standard AppleScript jargon that appears in almost every script. Here's a line-by-line analysis of the little folder-creating script you just made.

tell application "Finder"
        activate
        make new folder at desktop
        select folder "untitled folder"
        set name of selection to "Today's Backup"
        set label index of selection to 1
        set position of selection to {896, 573}
end tell
7.3.2.1 tell application "Finder"

Every recorded script begins with a line like this. It specifies which Mac program or window this section of your script will control. If you were writing a script for Mac OS X's Finder, you'd begin by typing this line.

Complex scripts can involve several programs—grabbing information from FileMaker and pasting it into QuarkXPress, for example. In those longer scripts, you'd see tell application "FileMaker Pro" at the beginning of the steps that involve the first program, and then tell application "QuarkXPress" later in the script, where the steps pertain to QuarkXPress.

7.3.2.2 activate

This command means, "Bring the abovementioned program to the front." Technically, you don't have to make the Finder the active program to perform the simple folder-creation steps in this script—AppleScript could create, name, label, and move your Today's Backup folder even while the Finder is in the background. But Script Editor inserted this step automatically because, when recording your actions, you made the Finder the active program (by clicking the desktop). You're welcome to delete this step from your Script Editor window. (The activate command works exactly the same way in Mac OS X, but isn't necessary if you're typing out this script by hand.)

This is only the first of many examples you'll find in which Script Editor records wordier scripts than necessary. Hand-typed scripts, like those described later in this chapter, are typically more compact and faster in execution.

TIP

A program you're controlling with a script doesn't have to be the frontmost program. Still, most scripts in Mac OS 9 or Classic work faster and better if their subjects are frontmost. But Mac OS X's superior multitasking eliminates that consideration. There's no longer any advantage to bringing an application to the front before controlling it.

7.3.2.3 make new folder at desktop

This command, of course, tells the Finder to create a new folder at the desktop level. If you had made the new folder in your hard drive window, this command would say, "make new folder at startup disk."

In Mac OS 9 or X, this command creates a new folder on your desktop called "untitled folder." If you have only one drive (or one partition), then there's only one place it can go: right there on the desktop.

7.3.2.4 select folder "untitled folder"

This step highlights the new folder, making it the selected item ("the selection"). (Script Editor leaves out words like "the," but if inserting such articles would make AppleScript easier for you to understand, you're welcome to use them.)

7.3.2.5 set name of selection to "Today's Backup"

This step renames the new folder.

7.3.2.6 set label index of selection to 1

The label index just refers to the label, as it appears in your File [image] Label menu. The Mac doesn't refer to these labels as Essential, Hot, In Progress, and so on, because you might change the names of these labels at any time. Instead, it refers to them by number, 1 through 7, as they're listed in the File [image] Label menu.

If you wanted your script to apply the second label (Hot, for example) to your icon instead, you could change the 1 in your script to a 2 (or some other number less than 8). Unfortunately, labels don't yet exist in Mac OS X, so this step would produce an error message if you tried it in X.

Rejiggering in Mac OS X

If you're following along by typing out the script in Mac OS X, you'll discover that a number of the commands in the "Today's Backup" script don't work in Mac OS X. The line set name of selection to "Today's Backup," for example, brings you smack into a bug: AppleScript in Mac OS X has problems manipulating selected objects, and this step produces only an error message.

Here's a prime example of the kind of script-rejiggering that people have to do to make Mac OS 9 scripts work in Mac OS X. To work around this limitation, for example, you can simply replace these three auto-generated commands—

make new folder at desktop
select folder "untitled folder"
set name of selection to "Today's Backup"

—with this single command:

set name of (select folder "untitled folder") to "Today's Backup"

AppleScript processes the expression in parentheses first, just as in mathematics, and uses its result to evaluate that part outside of the parentheses. Either way, the result is a renamed folder.

Better yet, now the same script works in both Mac OS 9 and Mac OS X. In other words, Mac OS X workarounds like this are not only easy, they're backward compatible.

7.3.2.7 set position of selection to {896, 573}

This script step actually moves your icon to the specified position. In Mac OS 9, the numbers represent coordinates as measured in pixels from the upper-left corner of your screen (horizontally and vertically, respectively). (The icon's position is measured from its own upper-left corner—the corner you'd see if the icon filled its entire imaginary 32 x 32-pixel square.)

NOTE

In Mac OS X, this command doesn't work as it did in Mac OS 9. Among other differences, the numbers in the brackets now represent coordinates from the upper-left corner of your desktop folder's window, not the desktop. Furthermore, because icons in Mac OS X can be almost any size, they specify the icon's position as measured from its center.

7.3.2.8 end tell

This command tells the Finder that it can stop paying attention to AppleScript, which is finished having its way. End tell always accompanies the tell application command that begins a script; they form the bookends that delineate the instructions to the program in question. (AppleScripters call the entire chunk, beginning with tell and ending with end tell, a tell block.) Tell blocks are the same in Mac OS 9 and X.

TIP

You can change the fonts and formatting Script Editor uses to write out your scripts. Choose Edit [image] AppleScript Formatting, click a category of formatting, and then use Script Editor's Font and Style menus to choose new type specs. Experienced scripters change the formatting to color code their scripts, making the scripts easier to read and debug. In fact, starting in Mac OS X 10.2, this color-coding comes already turned on, but you can change it to suit your own taste.


7.4 Saving a Script

Before you save a script, let Script Editor check its syntax. Do that by clicking the Check Syntax button at the right side of the window. If you don't perform a syntax check manually before trying to save, Script Editor will automatically do it for you as soon as you try to save.

NOTE

The Check Syntax button won't find any errors if you created a script using the "watch me" system; after all, Script Editor itself wrote the script, so of course it's perfect. But when you write scripts by hand, as described later in this chapter, you'll find the Check Syntax button a useful tool for cleaning stray errors out of your scripts.

If Script Editor finds the syntax of your script to be correct, you'll get no reaction from Script Editor except to see your script formatted, as shown in Figure 7-4. If it does find a problem with the syntax, you'll be limited to saving your script file in only one format: plain text.

At this point, you're ready to save your script. You start as you would in any Mac program, by choosing File [image] Save. Name your script and choose a location for it, by all means—but the important step to take here is to choose a format for your completed script (see Figure 7-5). Your choices depend on whether you're working in the Mac OS 9 or Mac OS X version of Script Editor:

  • Text. You can't actually run an AppleScript that's saved as a text file, but saving it this way provides a good way to exchange scripts with other people or to save an unfinished script you want to work on later. (Available in both Mac OS 9 and Mac OS X.)

  • Compiled script. You can't double-click a compiled script to run it. Nonetheless, compiled scripts are required by a number of programs that launch AppleScripts, including Script Runner and Script Menu (see Figure 7-1) or programs that themselves can run AppleScripts. These so-called attachable programs include FileMaker Pro, Outlook Express, Eudora, and Palm Desktop, among others. (Available in both Mac OS 9 and Mac OS X.)

  • Classic applet. Choose this option (available in Mac OS 9 only) if you want to create a stand-alone, double-clickable application script. You can put the resulting script into your a menu, for example, so that you can trigger it whenever you like, just by choosing its name. Or you can put the finished script into, say, your Startup Items folder to run automatically at startup (to search the Web for news of your industry and save the Web pages in a new folder, for example).

    When you choose this option, you're offered two additional checkboxes. If you choose Stay Open, the applet you've created remains running after it's launched—just what you'd want for scripts that monitor some activity on your computer and then act when some particular condition is satisfied.

    In general, you'll want to leave Never Show Startup Screen checked, so the start-up message never appears. If you turn this off, then whatever description you provided for your script appears whenever the script runs. You, or whoever is using your script, must then click either Run or Quit after the script launches.

  • Mac OS X applet. This option (Mac OS 9 only) creates a double-clickable, self-running script application that can run on Mac OS X machines or Mac OS 9 Macs that have the Carbon Lib system extension installed.

  • Application. This option (Mac OS X only) creates a double-clickable, self-running script application that can run on Macs in any system: Mac OS X, Mac OS 9, or the Classic environment. (You're offered the same two checkboxes described in the Classic Applet description above.)

  • Stationery Options. Use this option (Mac OS 9 only) if you plan to create several similar scripts, all of which are variations on a single script. Create your example script, then choose this command and click Stationery. Thereafter, you can open this template script and use it as a starting point for all the different variations.

    TIP

    You can create stationery scripts in Mac OS X, but it's a two-step process. First, save the script as described above. Then, at the desktop, highlight its icon, choose File [image] Get Info, and turn on the Stationery Pad checkbox.

Figure 7-5. If you type an AppleScript manually, it appears just as it would in a word processor (top left): in Courier type with no special formatting. When you click the Check Syntax button, however, Script Editor indents the tell block and changes all type to Geneva (bottom right), with AppleScript's reserved words in bold type and comments in italics (and in OS X 10.2, it's color coded). Congratulations: You've got the Script Editor seal of approval.
Figure 7-6. When you save a script, use the Format pop-up menu to specify its format, which will have a lot to do with determining how useful your script is. (In Mac OS 9, use one of the Applet choices to create a double-clickable application. In Mac OS X, the Application option creates AppleScripts that work in all systems: Mac OS X, Mac OS 9, and the Classic environment.)
    [ Team LiB ]


7.5 Writing Commands by Hand

Using the "watch me" mode described earlier in this chapter, you can create only very simple scripts. If you want to create anything more elaborate—or anything at all in the Mac OS X Finder—you must type out the script steps one by one, testing your work, debugging it, reworking it, and so on.

7.5.1 Scriptable Programs

Most of the introductory articles you'll read about AppleScript discuss scripts that perform useful tasks in the Finder—that is, scripts that manipulate your files, folders, disks, and so on. That's because the Finder is an extraordinarily scriptable program; AppleScript can control almost every element of it.

But AppleScript can also control and communicate with almost every popular Mac program: FileMaker, AppleWorks, Adobe and Microsoft applications, and so on. Sherlock, iTunes, QuickTime Player, Terminal, TextEdit, Print Center, Mail, Internet Connect, and Image Capture are among the built-in Mac OS X programs that you can control with AppleScript scripts, and the list will grow with subsequent Mac OS X updates.

Almost every Mac program understands four AppleScript commands: Open, Print, Quit, and Run. These commands constitute part of what Apple has designated the Required Suite of commands. Even so, some programs don't understand any of them, and some understand many other commands.

But before you can write a script that manipulates, say, Eudora, you need to learn which commands Eudora can understand. To do that, you need to look at the application's dictionary—the list of AppleScript commands a program understands.

To do so, open Script Editor. Choose File [image] Open Dictionary. You'll be offered a list of all scriptable applications available on your Mac (see Figure 7-7), including any Scripting Additions (Scripting Additions). Double-click the name of the program you want to check out.

Figure 7-7. The dictionary for a program lists the AppleScript commands and objects it knows about. If you click one of the commands on the left side of the window, you see an explanation of how to use it on the right. Unfortunately, you don't get any examples; it's up to you to try each command to see how it works. If you're having trouble making sense of the dictionary, contact the software company by phone or email and ask for a list of its AppleScript features.

TIP

You can also open a dictionary by dragging a program's icon onto the Script Editor icon—a good argument for parking Script Editor's icon on the Dock.

That's not to say, of course, that these commands make much sense to someone who's never written an AppleScript before. These commands, and scripts that incorporate them, still require study and experimentation. But a glance at a program's AppleScript dictionary is a good way to assess its scriptability—and therefore how much the software company has embraced the Macintosh Way.

7.5.2 Two Sample Scripts

In the following hand-typed examples, you'll encounter new kinds of tell blocks, scripts that control more than one program at a time, and scripts that do things you can't even do manually. If you look over these examples carefully—and type them up for yourself in Script Editor—you'll begin to see how similar to English AppleScript can be. You may also wind up with some useful scripts that can make your Macintosh life easier.

7.5.2.1 Auto-backup before shutting down

Suppose you'd like to use your new iPod (Apple's MP3 player/FireWire hard drive) as a backup disk. You want to be able to back up your Home [image] Documents folder each day without having to burrow through folders, drag and drop, click OK, and so on. AppleScript can do the job automatically.

In Script Editor, choose File [image] New Script, and then type this:

tell application "Finder"
duplicate folder "Documents" of folder "chris" of folder
"Users" of startup disk to disk "Ye Olde iPod" with replacing
end tell

Here's how the key command breaks down:

  • duplicate. AppleScript also offers commands called move and copy. So why duplicate?

    As it turns out, the copy command isn't smart enough to replace an existing folder of the same name. Because you probably plan to run this auto-backup script every day, you'll want it to wipe out yesterday's Documents backup each time you run it.

    The move command—in conjunction with its optional modifier phrase "with replacing"—is a better bet, in Mac OS 9, anyway. It makes the Mac copy the Documents folder to the iPod, replacing the Documents folder that's already there, without asking for confirmation or showing an error message.

    Fortunately, the duplicate command works smoothly and understands the with replacing modifier—and therefore does exactly what you want.

  • folder "Documents" of folder "chris" of folder "Users" of startup disk. All of that "folder of folder" business simply reflects the location of your Documents folder. It's in your Users [image] Home folder, of course, which bears your name. In this example, substitute your actual Home folder's name for "chris." (If you're one of those highly mobile people who put the Home folder on a different disk [see Moving Your Home Folder Between Computers], substitute its name for "startup disk." And change "Ye Olde iPod," of course, to the actual name of your backup disk.)

After you've run your script a couple times from within Script Editor (by clicking the Run button) and enjoyed the mad, brain-shocking power, add a little finesse by adding the new commands shown here in italics:

tell application "Finder"
duplicate folder "Documents" of folder "chris" of folder
"Users" of startup disk to disk "Ye Olde iPod" with replacing
 activate
 beep
 display dialog "Backup Successful!" buttons "Cool!"
end tell

The additional commands make the Mac beep and report, in a little dialog box, "Backup Successful!" after it makes the copy. It even gives you a button ("Cool!") with which to dismiss the dialog box; of course, you can make the button say anything you like ("OK," "Get on with it," "Good boy!" or whatever).

Once you've created this little script, save it as an application and put it in the Dock or on your Finder toolbar. Or save it as a compiled script and put it in your Home folder [image] Library [image] Scripts folder, so that you'll be able to trigger your backup from the Scripts Menu (Section 7.1).

7.5.3 Universal Shutdown

Every now and then, you might find it useful to quit all running programs except the Finder. Unfortunately, there's no one-step command that quits all of your open programs—but you can create one for yourself.

Nearly every Mac program on earth understands the Quit command when sent by AppleScript. All you have to do, then, is to send that command to each of the programs you're likely to have open. If you spend most of your time in AppleWorks, Mail, and Internet Explorer, for example, your script might look like this:

tell application "AppleWorks"
quit
end tell
tell application "Mail"
quit
end tell
tell application "Internet Explorer"
quit
end tell

In time, after hanging out on AppleScript mailing lists and studying a few other scripts, you'd realize that you could shorten those tell blocks like this:

tell application "AppleWorks" to quit
tell application "Mail" to quit
tell application "Internet Explorer" to quit

Even so, this script is doomed. If some of these programs aren't actually running, the script will dutifully launch each application and then quit it, which won't exactly make you the envy of your household. Fortunately, there's a better way.

What you really want is a script that briskly exits every running program, but is smart enough not to disturb the important system processes that run in the background. (Note that process, in computer-speak, refers to any running program, including both the applications you're using and the secret background ones that the Mac runs all the time.) So you'd want this:

tell application "Finder"
        set quitList to the name of every application process whose
file type is "APPL"
end tell
repeat with i from 1 to count of quitList
        tell application (item i of quitList) to quit
end repeat

Here's how some of these unfamiliar lines break down:

  • set quitList to the name of every application process whose file type is "APPL." You're defining a new variable, a stunt double, called quitList. It's a list of every program whose file type (Section 4.3) is APPL—that is, every double-clickable program. By limiting it to processes whose file type is APPL, you avoid quitting all of Mac OS X's important background programs (see Section 9.2.24).

  • repeat with i from 1 to count of quitList. This is a loop. You're saying, "run through the quitList list, exiting each program until you're at the end of the list."

If you actually try this script (hint: save it first), you'll discover that it's the neutron bomb of scripts: It quits everything in sight, including the Dock and Script Editor itself! Oops.

By adding a few more lines, however, you can specify a few process names that you want untouched:

set excludedOnes to {"Script Editor", "loginwindow", "Dock", "SystemUIServer"}

tell application "Finder"
        set quitList to the name of every application process whose
file type is "APPL"
end tell
repeat with i from 1 to count of quitList
set aProcess to item i of quitList
if aProcess is not in excludedOnes then
        tell application aProcess to quit
end if
end repeat

This script gives you an even greater degree of control, because you can add to the list of processes excluded from the execution. Just add them to the bracketed list in the first line, always in quotes and followed by a comma.

Scripting Additions

Much of AppleScript's power comes in the form of add-on files called scripting additions. You can think of them as plug-ins, each of which adds a particular new feature to AppleScript's repertoire. In Mac OS 9, they sit in your System Folder [image] Scripting Additions folder.

In Mac OS X, you may find scripting additions in any of three different places. The standard additions are in the System [image] Library [image] Scripting Additions folder of the Mac's hard drive. As with fonts, sounds, or other settings, you can also install scripting additions that only you can access by making a Scripting Additions folder in your Home [image] Library folder. Similarly, if you're an administrator, you can make a Scripting Additions folder in the main Library folder (in the hard drive window); everyone with an account will be able to use the scripting additions you file there.

Like a scriptable application, each of these scripting additions has its own dictionary—its own specialized AppleScript commands that you can use in your scripts. You view these new commands just as you would when studying the vocabulary of a program: by opening Script Editor, choosing File [image] Open Dictionary, and then navigating to and opening the scripting addition you want.

7.5.4 Advanced AppleScript

No single chapter—in fact, no entire book—can make you a master AppleScript programmer. Gaining that kind of skill requires weeks of experimentation and study, during which you'll gain a lot of appreciation for what full-time software programmers endure every day. AppleScript, despite its friendly appearance and abundance of normal English words, uses many of the same structures and conventions as more advanced programming languages.

By far the best way to learn AppleScript is to study existing scripts (like those in the Library [image] Scripts folder) and to take the free online training courses listed at the end of this chapter. And there are thousands of examples available all over the Web. Trying to figure out these scripts—running them after making small changes here and there, and emailing the authors when you get stuck—is one of the best ways to understand AppleScript.

Figure 7-8, for example, is a script called Add to File Names.scpt. It's one of the professional sample scripts that come with Mac OS X. To open it, navigate to your Library [image] Scripts [image] Finder Scripts folder and double-click Add to File Names.scpt. A quick glance can tell you a lot about the tricks of professional scripters:

Figure 7-8. The Add to File Names script is a classic AppleScript example. It contains variables, subroutines, nested "if" statements, and many other common elements of profes-sionally written scripts. (After typing a description into the box at the top of the window, you can click the flippy triangle to the left of the Description box to hide the entire thing, thus maximizing your script-writing space.)

  • Description. Careful script writers document their work. They add lots of notes and explanatory comments for the benefit of whoever might want to study or amend the script later (which is often themselves). Adding a description of the script's function in the Description box (at the top of the Script Editor window) is a good first step.

    (Whoever wrote this particular description didn't know the difference between effect and affect, but it's the thought that counts.)

  • Variables. A variable, in programming terms, is a placeholder for some information that may change from time to time. The President of the United States is a variable: there always is one, but his name changes every few years.

    As stand-ins for more complicated ideas, variables help simplify the script, clarify its purpose, and save typing. In AppleScript, as in other programming or scripting languages, you can define your own variables.

    In the one line of the Add to File Names script, for example, you can see the command set this_item to item i of the item_list. That common command tells AppleScript that you're defining your own variable called this_item, which will henceforth mean "a reference to the ith item in the list of items called item_list." In this case, "i" is a counter that refers to the item's position in the list.

    NOTE

    For some reason, AppleScripters tend to use variable names where the first letter is lowercase, but subsequent words appear with no spaces and capital letters, somethingLikeThis, or with underlines, like_this. Scripters typically use i, j, and k as counters, for example, to hold the number of times a loop has executed.

  • Subroutines. About a third of the way into the script shown in Figure 7-8, one line says, my set_item_name(this_item, the new_item_name). That step tells the script not to proceed through the commands in sequence, but instead to jump to a subroutine—a group of commands that's been separated from the first batch. Subroutines allow groups of commands to be more easily reused in different parts of the script. In this case, the subroutine begins four lines later ('my set_item_name(this_item, new_item_name)').

  • Nested "if" statements. You might tell an underling, "If you have time this afternoon, would you please run to the store? If the steaks are still on sale, buy three pounds; otherwise, buy just one pound." That, believe it or not, is a nested "if" statement. In other words, the steak-buying will take place only if the underling has time this afternoon.

    The Add to File Names script has a few nested "if" statements. For example, the sixth line says, in essence, "If this thing is neither a folder nor an alias"; the next line says, "...and if whoever's operating this thing clicks the Prefix button." The script proceeds only if both of those conditions are true.

  • Comments. The italicized comment, "—the suggested name is too long" is the programmer's note to anyone who studies the script. It's a comment, an annotation to make clear what the code is supposed to be doing. When the Mac runs AppleScript programs, it ignores the comments. You create one by typing two hyphens (--); when you click the Check Syntax button, Script Editor automatically sets what follows in italics.

    TIP

    If you want to type out a longer comment—a whole paragraph between commands in your script, for example—just precede and follow it with a parenthesis and asterisk (*like this*).

  • Looping. The paired commands repeat and end repeat create a loop—a set of commands that AppleScript repeats over and over again until something (which you've specified) interrupts it. In the case of the Add to File Names script, the script loops until it's added a prefix or suffix to all of the files in the specified folder—at which point it's supposed to beep twice. (It actually seems as though it beeps only once, thanks to a quirk of Mac OS X's sound software.)

  • Dialog boxes and buttons. If you ever want to play programmer for a day, open Script Editor and try creating dialog boxes and buttons of your own. The script command display dialog (followed, in quotes, by whatever message you want to appear on the screen) is all you need, as shown in Figure 7-9.

    In fact, you can even make the Mac speak. (See Chapter 14 for more on speech.) Just use the say command. If your AppleScript contains the line, say "Hey! Pay some attention to me!" using "Zarvox," then the Mac speaks that line using the voice called Zarvox. In addition to being fun, audio feedback can be useful for debugging scripts.

  • Line breaks. When a line of AppleScript code gets too long, it's hard to read—especially if it's wider than the Script Editor window itself. AppleScript pros, therefore, insert a special continuation symbol that makes the text wrap to the next line, which causes AppleScript to treat both lines as a single command. You create this line-break symbol by pressing Option-Return. (Some of these characters appear in the scripts shown in Figure 7-7 and Figure 7-8.)

    NOTE

    Don't use a line-break character in the middle of text that appears inside quotation marks; commands that you break up like this won't work. You can, however, put Returns in a text string.

  • Try...On error...End try. This suite of three commands appears frequently in polished AppleScript scripts—including the one shown in Figure 7-9. It tells the Mac: "Try this. If it doesn't work, show this error message." For example:

    tell application "Finder"
        try
        make new folder at startup disk with properties {name:"Backup Folder"}
        on error
        display dialog "A folder already has that name."
        end try
end tell

This script tries to make a new folder named Backup Folder on the startup disk. But if there's already a folder there by that name, then AppleScript generates an error—and shows the error message you specify.

Figure 7-9. The script shown here at top produces the dialog box shown at bottom. The buttons command lets you create your own buttons (up to three, punctuated exactly as shown here). The default button command tells the script which button should be the default, the pulsing or outlined one that you can "click" just by pressing the Return key. Default button 3 means that the third button is the default button.

7.5.5 What Else AppleScript Can Do

Mac OS X comes with only very general online help for AppleScript. It's pretty lame if you want to help writing scripts. But at www.apple.com/applescript/guidebook/sbrt/index.html, you'll find on-line AppleScript Guidebook modules with a lot of useful routines that you can use, borrow from, or dissect for the purposes of learning.

Or if you fire up Mac OS 9, you'll find that its AppleScript Help screens are full of useful examples—and copious enough to serve as a detailed overview of AppleScript's powers. There you'll find out, for example, that simple scripts can:

  • Manipulate specific files and folders (copy, delete, rename, or label them).

  • Read, copy, or insert text into the Comments field of a certain icon's Get Info window.

  • Use artificial intelligence to create a summarized version of a longer document.


7.6 Where to Learn More

As noted earlier, AppleScript isn't something you can master in a day or two. Fortunately, few Mac technologies have more ardent fans than AppleScript, and free beginners' (and experts') tutorials are available all over the Web. It may be a while before this material is updated for Mac OS X, but in the meantime, you can study the Mac OS 9 material; most of it is applicable in Mac OS X.

Begin your quest at Apple's AppleScript Web site, www.apple.com/applescript. There you'll find a link to an excellent, step-by-step tutorial in hand-coding scripts, as well as links to these outstanding online AppleScript guides:

  • Bill Briggs' AppleScript Primers. Read dozens of articulate, thoughtful tutorials for the beginning scripter. A good exercise might be to restart your Mac in Mac OS 9, work through the tutorials, then go back to Mac OS X and, as homework, try to figure out how to modify the featured scripts to run in Mac OS X.

  • AppleScript Guidebooks. Download and install these additions to the Help [image] Help Center menu (Mac OS 9 only). Each adds, to your built-in Mac help system, detailed instructions on various specialized AppleScript topics: Open Transport, subroutines, speech, program linking, and so on. Each includes several dozen sample scripts for you to dissect. It's worth booting into Mac OS 9 to study them.

  • AppleScript mailing lists. Sign up for one of these free, email-based discussion lists whose members are all AppleScript fans. Apple runs one; the MacScript list is independent. Given the shortage of specific tutorials based on Mac OS X, these lists are possibly the best source of solutions for the new scripter.

On Apple's own AppleScript page, click on the Resources link to take you to the page listing links to several other useful resources. Links on this page take you to commercial AppleScript training course offerings, technical encyclopedias that describe every single AppleScript command in detail, AppleScript news sites, and so on.


Part III: The Components of Mac OS X

Chapter 8: System Preferences

Chapter 9: The Free Programs

Chapter 10: CDs, DVDs, and iTunes


Chapter 8. System Preferences

The hub of Mac customization is System Preferences, the modern-day successor to the old Control Panels of Windows or the older Mac OS. Some of its panels are extremely important, as their settings determine whether or not you can connect to a network or go online to exchange email. Others handle the more cosmetic aspects of customizing Mac OS X. This chapter guides you through the entire System Preferences program, panel by panel.

TIP

Only a system administrator (see Section 11.2) can change settings that affect everyone who shares a certain machine: its Internet settings, Energy Saver settings, and so on.

The tiny padlock in the lower-left corner of a panel (see Figure 8-11, for example) is the telltale sign. If you, a nonadministrator, would like to edit some settings, call an administrator over to your Mac and ask him to click the lock, input his password, and supervise your tweaks.


8.1 The System Preferences Window

You can open System Preferences by choosing its name from the [image] menu, clicking its icon in the Dock, or double-clicking its icon in the Applications folder. At first, the rows of icons are grouped according to function: Personal, Hardware, and so on.

But in Mac OS X 10.2, you can also view them in tidy alphabetical order, as shown at bottom in Figure 8-1. That can spare you the ritual of hunting through various rows just to find a certain panel icon whose name you already know. (Quick, without looking: Which row is Date & Time in?) This alphabetical arrangement matches the way the various panels are organized in this chapter, too.

Either way, when you click one of the icons, the corresponding controls appear in the main System Preferences window, and the other icons vanish. To access a different preference pane, you have a number of options:

  • Fast: Click the Show All icon in the upper-left corner of the window (or press [image] -L, a shortcut worth learning). Then click the icon of the new panel you want.

  • Faster: Choose any panel's name from the View menu.

  • Fastest: Click the icon you want, if it's there, on the System Preferences toolbar. And why shouldn't it be there? By all means, stash the panels you use most frequently up there, as shown in Figure 8-1.

    TIP

    You can rearrange toolbar icons by dragging horizontally or remove one by dragging it directly away from the toolbar. On the other hand, you can hide the toolbar altogether (to maximize your screen space) by clicking the white oval button in the window's upper-right corner. At that point, you switch among different System Preferences panes by using the View menu.

Figure 8-1. Top: You can hide the toolbar by clicking the upper-right capsule-shaped button. You can also customize this toolbar—and you should—by dragging onto it the icons of the System Preferences panels you use the most. Bottom: For the first time in Mac OS X, you can view your System Preferences icons alphabetically, rather than in rows of categories; just choose View Show All Alphabetically. This approach not only saves space, but makes finding a certain panel much easier, because you don't need to worry about which category it's in.
    [ Team LiB ]


8.2 Accounts

This is the master list of people who are allowed to log into your Mac. It's where you can adjust their passwords, startup pictures, and permissions to use various features of the Mac. All of this is described in Chapter 11.


8.3 CDs & DVDs

This panel is new in Mac OS X 10.2—and it's rather handy (Figure 8-2). It lets you tell the Mac what it should do whenever it detects the insertion of a CD or DVD disc. For example, when you insert a music CD, you probably want the Mac to open the iTunes program (Chapter 10) automatically so that you can listen to the music, or convert it into MP3 files on your hard drive. Similarly, when you insert a picture CD (such as a Kodak Photo CD), you probably want iPhoto to open automatically, in readiness to import the pictures from the CD into your photo collection—and when you insert a DVD from Blockbuster, you want the Mac's DVD Player program to open automatically.

Figure 8-2. You can tell the Mac exactly which program to launch when you insert each kind of disc—or tell it to do nothing at all.

System Preferences: Under the Hood

The entire System Preferences program is nothing more than a series of graphical front ends for underlying Unix settings. (If you know Unix and feel so inclined, in fact, you can bypass the System Preferences panel completely. Using the defaults command, you can make any of the changes described in this chapter in Mac OS X's Terminal program.)

The individual preference panels are represented by "package" icons in your various Library folders. For example, icons in the basic Mac OS X set are in System [image] Library [image] PreferencePanes. Mac OS X also checks the Network [image] Library [image] PreferencePanes folder, if there is one, when it decides which icons it should show in System Preferences.

You can easily expand System Preferences, however, just by dropping new pane modules into your Home folder [image] Library [image] PreferencePanes folder. Or, if you're an administrator, you can create a PreferencePanes folder in the Mac's main Library folder, so that everyone with an account on the Mac (Chapter 11) will be able to access your newly added System Preferences panels. (TinkerTool 2, for example, described in Section 17.1, takes the form of one of these add-on control panels.)

Any new panes you add in this way appear in System Preferences in a new row of icons labeled Other. The beauty of this arrangement, of course, is that everyone who shares a Mac now can see a different assortment of customized preference panes.

For each kind of disk (blank CD, blank DVD, music CD, picture CD, or video DVD), the pop-up menu lets you choose options like these:

  • Ask what to do. When you insert a blank disc, a dialog box will appear that invites you to burn it with your own data.

  • Open (iDVD, iTunes, iPhoto, DVD Player...). The Mac can open a certain program automatically when you insert the disc. When the day comes that somebody writes a better music player than iTunes, or a better digital shoebox than iPhoto, you can use the "Open other application" option to select it instead.

  • Run script. If you've become handy writing mini programs with AppleScript (Chapter 7), you can schedule one of your own scripts to take over from here. For example, you can set things up so that inserting a blank CD automatically copies your Home folder onto it for backup purposes.

  • Ignore. The Mac won't do anything when you insert a disc.


8.4 Classic

Pre-Mac OS X programs can still run under Mac OS X, thanks to a program called Classic. This panel lets you start, stop, and restart Classic (see Chapter 5).


8.5 ColorSync

This control panel is part of the software suite that attempts to maintain color fidelity throughout the life of a scanned image or digital photo—from scanner or camera to monitor, and finally to color printout. For a full description, see Section 13.8.


8.6 Date & Time

Your Mac's conception of what time it is can be very important. Every file you create or save is stamped with this time, and every email you send or receive is marked with this time. As you might expect, setting your Mac's clock is what the Date & Time panel is all about.

Your Free Time-Difference Calculator

You can use the Time Zone pane of the Date &Time panel to calculate the exact time difference between any two points on earth. To do this, you must have the Time Zone pane open and your menu bar clock turned on—set to View as Text, with a digital readout (see the discussion of the menu bar clock in this chapter).

To calculate a time difference, make a note of the current time shown in the menu bar, with the Time Zone correctly set to your own zone. Now drag across the Time Zone map, moving the pointer to a different part of the world. As you drag, notice that the time in the menu bar changes, updating itself as you cross from time zone to time zone. By comparing the original time on your menu bar with the new time that appears when you've finished dragging, you can easily determine the time difference between any two locations.

8.6.1 Date & Time tab

Go to the Date & Time pane. Select the correct month and year under Today's Date by clicking the little arrow buttons next to the month and year labels. Then specify the day of the month by clicking a date on the mini calendar. Click Save.

TIP

There's no need to set the date, time, or time zone on your Mac manually if you use the Network Time option, described below.

To set your clock, start by clicking one of the numbers in the time field under the Current Time label. Then adjust the corresponding number, either by typing the numbers or by clicking the tiny up or down arrow buttons. To jump to the next number for setting, press the Tab key. Alternatively, you can set the time by dragging the hour, minute, or second hands on the analog clock. Finally, click Save. (If you get carried away with dragging the clock hands around and lose track of the real time, just click the Revert button to restore the panel settings.)

TIP

If you're frustrated that the Mac is showing you the 24-hour "military time" on your menu bar (that is, 17:30 instead of 5:30 PM)—or it isn't showing military time when you'd like it to—click the Menu Bar Clock tab and turn "Use the 24-hr. clock" on or off.

Note, however, that this affects only the Menu bar clock—not any other dates (like the ones that show when your files were modified in list views). To change that overarching setting, go to the International panel of System Preferences. Once there, click the Time tab. There you'll see the "24-Hour clock" and "12-Hour clock" options.

Figure 8-3. Setting the Time Zone is a two-step process. In the Time Zone pane, click on a section of the map to select a general region of the world, and then use the pop-up menu to specify your country within that region.

8.6.2 Time Zone tab

You'd be surprised how important it is to set the Time Zone for your Mac. If you don't do so, the email and documents you send out—and the Mac's conception of what documents are older and newer—could be hopelessly skewed. Teach your Mac where it lives using the Time Zone map, as shown in Figure 8-3.

8.6.3 Network Time tab

With the network time server option turned on, your Mac sets its own clock by consulting a highly accurate scientific clock on the Internet. Turn on the "Use a network time server" checkbox, select one of the time servers listed in the pop-up window, and then click Set Time Now. (No need to worry about Daylight Savings Time, either, as the time servers take that into account.) The Mac immediately connects to the Internet and sets its own clock.

TIP

If you have a full-time Internet connection (cable modem or DSL, for example), you can leave "Use a network time server" turned on, so that your Mac's clock is always correct. If you connect to the Internet by modem, however, turn off the checkbox, so that your Mac won't keep trying to dial spontaneously at all hours of the night.

8.6.4 Menu Bar Clock tab

In the Menu Bar Clock pane, you can specify whether or not you want the current time to appear, at all times, at the top of your screen. If you turn on the "Show the date and time in the menu bar" checkbox, you can choose between two different clock styles from the pop-up menu—digital (Text) or analog (Icon). If you go the View as Text route, you get several other options that govern this digital clock display: whether or not you want to include designations for AM and PM, the display of seconds, the day of the week, and a blinking colon.

And by the way, your menu bar clock always shows the current time. When you need to know today's date, just click the clock. A menu drops down revealing the complete date. The menu also lets you switch between digital and analog clock types and provides a shortcut to the Date & Time panel in System Preferences.

TIP

Attention Unix geeks: You can also set the date and time from within Terminal (Chapter 15). Use sudo (Section 16.1.4), type date yyyymmddhhmm.ss, and press Enter. (Of course, replace that code with the actual date and time you want, such as 200304051755.00 for April 5, 2003, 5:55 p.m.) You might find this method faster than the Date & Time System Preferences method.


8.7 Desktop

The Desktop panel lets you dress up your desktop with the background image of your choice. You can choose from one of the several dozen background pictures that come with Mac OS X or use your own pictures. In fact, starting in Mac OS X 10.2, you can even schedule these background pictures to change automatically at regular intervals—an essential feature for the easily bored.

8.7.1 Apple's canned picture collections

Mac OS X comes with four collections of desktop pictures, ranging from National Geographic-style nature photos to plain solid colors. To install a new background picture, first choose one of the four image categories from the Collections pop-up menu, as shown in Figure 8-4. Your choices include Apple Background Images (muted, soft-focused swishes and swirls), Nature (plants, bugs, water), Abstract (swishes and swirls with wild colors), or Solid Colors (boring grays, blues, and greens).

Now click the thumbnail of any available picture to apply it immediately to the desktop. (There's no need to remove the previously installed picture; picking a new picture automatically replaces the old one.)

Figure 8-4. Using the Collections pop-up menu, you can preview an entire folder of your own images before installing one specific image as your new desktop picture. Just use the Choose Folder command from the Collection pop-up menu to select a folder in order to view thumbnails of all the images it contains. (That's what was shown in this example.) Clicking one of the thumbnails installs the corresponding picture on the desktop.

NOTE

Several of Apple's ready-to-use desktop pictures come in two sizes. The elongated versions (with the flatter, squashed-down thumbnails) are designed to perfectly fill the extra-wide screens on Titanium PowerBooks, Apple Cinema Displays, and other unusually wide screens.

8.7.2 Your Own Pictures I: A Folder of Your Own

Decorating your Mac desktop is much more fun if you use one of your own pictures. You can use any digital photo, scanned image, or graphic you want in almost any graphics format (JPEG, PICT, GIF, TIFF, PDF, or Photoshop).

One way to find a suitable picture is to open the Collection pop-up menu, which lets you choose Pictures (meaning your Home [image] Pictures folder), Choose Folder (so you can choose any folder containing pictures). The menu also lists any picture folders you've recently chosen.

Once you've narrowed things down to a certain folder, you can browse and choose a picture within it, as shown in Figure 8-4.

8.7.3 Your Own Pictures II: Drag a Photo

If there's one certain picture you like, you can easily skip all that folder-choosing business. Just drag the image file itself onto the well (the mini desktop displayed in the Desktop panel). A thumbnail of your picture instantly appears in the well and, a moment later, your picture is plastered across your monitor.

8.7.4 Your Own Pictures III: Apply from Within iPhoto

If you organize your pictures in Apple's free iPhoto program (and you should), applying a photo to your desktop is as easy as clicking a thumbnail, clicking the Share button at the bottom of the iPhoto window, and then clicking the Desktop button.

The picture appears instantly on your desktop.

8.7.5 Making the Picture Fit

No matter which method you use to choose a photo of your own, you have one more issue to deal with. Unless you've gone to the trouble of editing your chosen photo so that it matches the precise dimensions of your screen (1024 x 768 pixels, for example), it probably isn't exactly the same size as your screen. Fortunately, Mac OS X 10.2 offers a number of solutions to this problem. Using the pop-up menu just to the right of the Current Desktop Picture preview (shown in Figure 8-4), you can choose any of these options:

  • Fill screen. This option enlarges or reduces the image so that it fills every inch of the desktop. If the image is small, the low-resolution stretching can look awful. Conversely, if the image is large and its dimensions don't precisely match your screen's, parts get chopped off. At least this option never distorts the picture, as the "Stretch" option does (below).

  • Stretch to fill screen. Use this option at your peril, since it makes your picture fit the screen exactly, come hell or high water. Unfortunately, larger pictures may be squished vertically or horizontally as necessary, and small pictures are drastically blown up and squished, usually with grisly-looking results.

  • Center. This command centers the photo neatly on the screen. If the picture is larger than the screen, you see only the middle; the edges of the picture are chopped off as they extend beyond your screen.

    But if the picture is smaller than the screen, it doesn't fill the entire background; instead it just sits right smack in the center of the monitor at actual size. Of course, this leaves a swath of empty border all the way around your screen. As a remedy, Apple provides a color-swatch button next to the pop-up menu (also shown in Figure 8-4). When you click it, the Color Picker appears (The Color Picker), so that you can specify the color in which to frame your little picture.

  • Tile. If your graphic is smaller than the screen, Mac OS X chooses this option automatically. It makes your picture repeat over and over until the multiple images fill the entire monitor. (If your picture is larger than the screen, no such tiling takes place. You see only the top center chunk of the image.)

8.7.6 Auto-Picture Changing

The novelty of any desktop picture, no matter how interesting, is likely to fade after several months of all-day viewing. That's why the randomizing function, new in Mac OS X 10.2, is so delightful.

Here's how it works: Create a folder filled with images you'd like to use as desktop pictures. (A group of digital photos works great.) Using the Collections pop-up menu, choose Choose Folder, and then, yes, choose the folder. (You can also choose Pictures Folder from this pop-up menu, which will access all the photos in your Home [image] Pictures folder.)

Now turn on "Change picture" at the bottom of the dialog box. From the pop-up menu, specify when you want your background picture to change: "every day," "every 15 minutes," or, if you're really having trouble staying awake at your Mac, "every 5 seconds." (The option called "when waking from sleep" refers to the Mac waking from sleep, not its owner.)

Finally, turn on "Random order," if you like. (If you leave it off, your desktop pictures will change in alphabetical order by file name.)

That's all there is to it. Now, at the intervals you specified, your desktop picture changes automatically, smoothly cross-fading between them like a slide show. You may never want to open another window.

All the Picture Folders You Want

This business of choosing a folder full of pictures for use by the self-changing desktop feature is all well and good, but it has one profound limitation: You can use only one folder of pictures as desktop fodder. Any folders inside of it don't count.

If, like many Mac fans, you use iPhoto to organize your pictures, forget it—iPhoto files your pictures in folders within folders within folders, scattering them to the four winds of your hard drive. Too bad if you want your whole picture collection to parade across your desktop, eh?

Not really. You can fake out Jaguar easily enough.

Open iPhoto. Create a new album (in the album list at the left side). Call it Desktop Backgrounds or something. Drag into it all the pictures you'll want to use as backdrop material—even your entire photo library, if you like.

Behind the scenes, iPhoto creates a corresponding folder in your Home [image] Pictures [image] iPhoto Library [image] Albums folder, which is filled with aliases of the selected pictures.


8.8 Displays

Displays is the center of operations for all your monitor settings. Here, you set your monitor's resolution, determine how many colors are displayed onscreen, and calibrate color balance and brightness. The specific controls you'll see here depend on the kind of monitor you're using, but here are the ones you'll most likely see:

8.8.1 Display Tab

This tab is the main headquarters for your screen controls. It governs these settings:

  • Resolution. All Mac desktop and laptop screens today can make the screen picture larger or smaller, thus accommodating different kinds of work. You perform this magnification or reduction by switching among different resolutions (measurements of the number of dots that compose the screen). The Resolutions list displays the various resolution settings your monitor can accommodate: 800 x 600, 1024 x 768, and so on.

    When you use a low resolution setting, such as 800 x 600, the dots that comprise your screen image get larger, thus enlarging (zooming in on) the picture—but showing a smaller slice of the page. Use this setting when playing a small QuickTime movie, for example, so that it fills more of the screen. At higher resolutions (such as 1024 x 768), the screen dots get smaller, making your windows and icons smaller, but showing more overall area. Use this kind of setting when you want to see as much screen area as possible—when working on two-page spreads in your page-layout program, for example.

  • Colors. Today's Mac monitors offer different color depth settings, each of which permits the screen to display a different number of colors simultaneously. The Colors pop-up menu generally offers only two choices: Thousands and Millions. (The 256-color choice is dimmed on most Macs unless you turn off the "Show modes recommended" checkbox, as described in Figure 8-5.)

    In the early days of Macintosh, higher color settings required a sacrifice in speed; the Mac took time to compute the color for each of thousands of individual dots that make up the screen image. Today, however, there's very little downside to leaving your screen at its maximum depth setting ("Millions" of colors). Photos, in particular, look best when your monitor is set to higher depth settings.

    TIP

    If Mac OS X doesn't seem to recognize a second monitor that you attached while the Mac was asleep, try switching this pop-up menu—to Thousands and then back to Millions, for example. That often forces the Mac to notice its new screen.

  • Refresh Rate. If you have a choice here at all, this pop-up menu lets you adjust how many times per second your screen image is repainted by your monitor's electron gun. (You don't see this pop-up menu if you have a flat-panel screen.) Choose a setting that minimizes flicker.

  • Brightness, Contrast. Use these sliders to make the screen look good in the prevailing lighting conditions. You'll usually want the Contrast control all the way up—if you have it at all (flat-panel screens usually don't)—and Brightness near the middle.

    Of course, all Mac laptops and most Apple monitors and keyboards have their own brightness controls, so these software controls are included just for completeness' sake. (Many current Apple keyboards have dedicated brightness controls. If you have an older keyboard, the F14 and F15 usually work as brightness controls.)

    TIP

    You can adjust the color depth and resolution of your monitor without having to open System Preferences. Just turn on "Show Displays in menu bar," which adds a Monitors pop-up menu (a menulet—Section 3.6) to the right end of your menu bar for quick adjustments.

8.8.2 Geometry Tab

This pane appears only on Macs with built-in, non-flat screens—for the most part, that means eMacs and the older, fruit-colored iMacs. It lets you adjust the position, size, and angle of the screen image on the glass itself—controls that can be useful in counteracting distortion in aging monitors.

TIP

Don't miss the opportunity to eliminate the black borders around your screen perimeter! That's just wasted space. Click the Height/Width button. Then click the "expand vertical" and "expand horizontal" buttons at the lower-right corner of the miniature monitor image until you've eliminated the black borders around the screen. (You'll probably have to re-center the whole picture, too.)

Figure 8-5. If some of these settings are dimmed, as shown here, turn off "Show modes recommended by display." These "unauthorized" settings now become available; when you choose one, the Mac may ask you to confirm that you can see the effect. If it does something wacky to your screen, on the other hand, the Mac restores the previous setting in 15 seconds.

Blurry Flat-Panel Screens

Yucko! I tried the 800 x 600 setting on my 2001 iBook, and everything got all blurry and fuzzy! How do I fix it?

On any flat-panel screen—not just laptop screens—only one resolution setting looks really great: the maximum one. That's what geeks call the native resolution of that screen.

That's because on flat-panel screens, every pixel is a fixed size. At lower resolutions, the Mac does what it can to blur together adjacent pixels, but the effect is fuzzy and unsatisfying. (On a traditional bulky monitor, the electron gun can actually make the pixels larger or smaller, so you don't have this problem.)

8.8.3 Arrange Tab

From the dawn of the color-monitor era, Macs have had a terrific feature: The ability to exploit multiple monitors all plugged into the computer at the same time. Some Macs can project the same thing on both screens (mirror mode), which is useful in a classroom. A few lucky models permit one monitor to act as an extension of the next. For example, you might have your Photoshop image window on your big monitor, but keep all the Photoshop controls and tool palettes on a smaller screen. Your cursor passes from one screen to another as it crosses the boundary.

To bring about this delicious arrangement, you need a Mac with a video output jack. (All current Mac laptops have one, as do iMacs and eMacs.) You don't have to shut down the Mac to hook up another monitor—just put it to sleep.

When you open System Preferences, you see a different Displays window on each screen, so that you can change the color and resolution settings independently for each. Your Displays menulet shows two sets of resolutions, too, one for each screen.

If your Mac can show different images on each screen, your Displays panel offers an Arrange tab, showing a miniature version of each monitor. By dragging these icons around relative to each other, you can specify how you want the second monitor's image "attached" to the first. Most people position the second monitor to the right of the first, but you're also free to position it on the left, above, below, or even directly on top of the first monitor's icon (the last of which produces a video-mirroring setup). For the least likelihood of going insane, consider placing the real-world monitor into the corresponding position—to the right of your first monitor, for example.

For committed multiple-monitor fanatics, the fun doesn't stop there. See the microscopic menu bar on the first-monitor icon? You can drag that tiny strip onto a different monitor icon, if you like, to tell Displays where you'd like your menu bar to appear. (And check out how most screen savers correctly show different stuff on each monitor!)

8.8.4 Color Tab

The Color pane lets you calibrate your monitor to create an accurate ColorSync profile for it. See Section 13.8 for details.


8.9 Dock

See Chapter 3 for details on the Dock and its System Preferences pane.


8.10 Energy Saver

The Energy Saver program helps you and your Mac in a number of ways. By blacking out the screen after a period of inactivity, it prolongs the life of your monitor. By putting the Mac to sleep half an hour after you've stopped using it, Energy Saver cuts down on electricity costs and pollution. And on a laptop, Energy Saver extends the length of the battery charge by controlling the activity of the hard drive and screen.

8.10.1 Sleep Settings

When you first open Energy Saver, you're shown a pair of sliders, one of which starts out dimmed.

NOTE

If you don't see the sliders, click the Show Details button. (You're probably using a laptop—and on laptops, the sliders are normally hidden.)

The top slider controls when the Mac will automatically go to sleep—anywhere from one minute after your last activity to Never. (Activity can be mouse movement, keyboard action, or Internet data transfer; Energy Saver never turns off your Mac in the middle of a download.)

At that time, the screen goes dark, the hard drive stops spinning, and your processor chip slows to a crawl. Your Mac is now in sleep mode, using only a fraction of its usual electricity consumption. To wake it up when you return to your desk, press any key; everything you were working on, including open programs and documents, is still onscreen, exactly as it was. (To turn off this automatic sleep feature entirely, drag the slider to Never.)

For more control over the sleeping process, activate the second slider by turning on "Use separate time to put the display to sleep," shown in Figure 8-6.

Figure 8-6. Top: Here's what Energy Saver looks like when you first open it on a laptop. (On a desktop machine, it's far simpler.) Bottom: Here's what it looks like when you expand the window by clicking the Show Details button. When you turn on the "Use separate time" option, you can specify an independent sleep time for the screen. You can also turn on "Put the hard disk to sleep when possible"—an option that no longer has a slider of its own, because the Mac's own housekeeping and network duties may prevent the drive from stopping its spinning altogether.

On Macs of old, the beauty of setting the monitor to sleep sooner than the Mac itself was that it put your Mac into light sleep. The screen would go dark after its specified period, but awaken instantly when you touched a key or clicked the mouse. This setup didn't save as much electricity as regular sleep, but protected the screen equally well and spared you those tedious ten-second wakeup periods.

In Mac OS X, the Mac always wakes almost instantly from sleep—one of the great payoffs of Mac OS X. In short, there's very little reason to set the screen to sleep independently of the Mac itself.

TIP

Energy Saver no longer offers automatic scheduled startup and shutdown; there is, however, a workaround. Start up the Mac in Mac OS 9. Use its Energy Saver control panel to schedule a startup. Open the Startup Disk control panel to select Mac OS X as the startup disk, and shut down the Mac. At the appointed time, the machine will start up automatically—in Mac OS X.

8.10.2 Laptop Options

When you open Energy Saver on a Macintosh laptop, it looks quite different, as shown in Figure 8-6. That's because power management is ten times more important on a laptop, where every drop of battery power counts.

The Optimize Energy Settings pop-up menu, for example, offers several canned Energy Saver settings, appropriate for several common laptop situations:

  • Automatic detects whether or not the laptop is plugged into a power outlet. If so, it switches you to Highest Performance mode, described next. But if you're running on battery power, it switches automatically to Longest Battery Life. Most of the time, this is exactly what you want: high-speed when you're safely plugged into the wall, and best battery life when you're working at 39,000 feet.

  • Highest Performance sets both sliders to Never, so that you won't be inconvenienced by the screen going dark. (Again, if you don't see the sliders, click Show Details.) It also turns off the "Put the hard disk to sleep" checkbox, so that you'll never need to wait while the hard drive spins up after going to sleep. (The settings also turn on all three checkboxes on the Options tab, as described below, so that the laptop will be turned on and awake whenever possible.)

  • Longest Battery Life puts the screen to sleep after one minute of inactivity, puts the laptop itself to sleep after five minutes, and puts the hard disk to sleep whenever possible. All of this is designed to ensure that the machine uses as little juice as possible whenever you wander away—even if it's only for a minute.

    Although there's no visual indication, this option also slows down your processor to save power.

  • DVD Playback keeps the screen on, keeps the laptop awake, and keeps the DVD drive going—but stops the hard drive from spinning whenever possible. After all, when you're watching a movie, the last thing you want is the screen blinking off just as Schwarzenegger reaches the top of the skyscraper. This is still a pretty power-hungry arrangement, but not quite as bad as Highest Performance. (Technically, it isn't needed when you're playing a DVD.)

  • Presentations is exactly the same as DVD Playback, except that it doesn't keep the DVD drive spinning. By keeping the laptop awake and the screen on at all costs, this option is a good career move. You don't want your laptop to go black in the middle of an important pitch to the board members.

  • Custom just means "none of the above." Whenever you adjust one of the sliders or checkboxes, Energy Saver automatically changes the pop-up menu to say Custom. (Your settings here aren't even saved. If you choose one of the presets and then choose Custom again, your hand-adjusted settings don't return.)

Note, by the way, that the expanded Energy Saver dialog box also offers a pop-up menu called "settings for," which lets you establish independent variations of the presets for the two times you'll be using your laptop: when plugged in and when running on battery. In other words, you really have two versions of each preset—one DVD Playback setting for battery, another for AC power; one Presentations setting for battery, another for AC power; and so on.

TIP

Don't miss the checkbox called "Show battery status in the menu bar"—another exclusive for laptops. It puts a handy status indicator in the menu bar—a menulet—that keeps you informed of your battery's life.

It's actually a menu that lets you choose between displaying the actual number of minutes left until a battery is depleted and the percentage of battery life that remains. (When the laptop is plugged in, these statistics are slightly different. Now you see the number of minutes left until the battery is fully recharged, or the percentage of full charge you've achieved so far.)

8.10.3 Waking and Other Options

Click the Options tab in the Energy Saver panel to summon a few more checkboxes:

  • Wake when the modem detects a ring. This checkbox can be useful in two circumstances: first, if you use your Mac as a fax machine that accepts incoming faxes, and second, if you dial into your Mac from the road. In either case, when a phone call reaches the laptop's modem, the computer wakes up and accepts the call—if this option is turned on.

  • Wake for network administrative access. This option exists exclusively for the purchasers of the software suite called Mac OS X Server, which lets the network guru in an office control (and, with this checkbox, even awaken) sleeping Macs on the network.

  • Restart automatically after a power failure. This is a good option to turn on if you leave your Mac unattended and access it remotely, or if you use it as a network file server or a Web server. It ensures that, if there's even a momentary blackout that shuts down your Mac, it will start itself right back up again when the juice returns.

    TIP

    All three of these checkboxes can be part of the presets for a laptop. In other words, the DVD Playback setting turns all of the checkboxes off, the Highest Performance setting turns them all on, and so on.


8.11 General

The General panel puts you in control of the look and behavior of windows, menus, buttons, scroll bars, and fonts in Mac OS X. Nothing you find here lets you perform any radical surgery on the Aqua interface—the overall Mac OS X look stays the same—but you can tweak several settings to match your personal style.

8.11.1 Changing Colors

Two pop-up menus let you crank up or tone down Mac OS X's overall colorfulness:

  • Appearance. Choose between Blue or Graphite. Blue refers to Mac OS X's default bright, candy-colored scroll-bar handles, progress bars, a menu, and pulsing OK buttons—and those shiny red, yellow, and green buttons in the corner of every window. If you, like some graphics professionals, find all of this circus-poster coloring a bit distracting, then choose Graphite, which renders all of those interface elements in various shades of gray.

  • Highlight color. When you drag your cursor across text, its background changes color to indicate that you've selected it. Exactly what color the background becomes is up to you—just choose the shade you want using the pop-up menu. (The Highlight color also affects such subtleties as the lines on the inside of a window as you drag an icon into it.)

    If you choose Other, the Color Picker palette appears, from which you can choose any color your Mac is capable of displaying (The Color Picker).

8.11.2 Tweaking the Scroll Bars

These radio buttons control the scroll-bar arrow buttons of all your windows. You can keep these arrows together at one end of the scroll bar, or you can split them up so that the "up" arrow sits at the top of the scroll bar, and the "down" arrow is at the bottom. (Horizontal scroll bars are similarly affected.) For details on the "Jump to the next page" and "Scroll to here" options, see Section 1.2.8.

TIP

Miss the days when one arrow appeared at each end of the scroll bar? You can make Mac OS X work that way, too. You just need a moment alone with TinkerTool, described in Section 17.1.

8.11.3 Number of Recent Items

Just how many of your recently opened documents and applications do you want the Mac to show using the Recent Items command in the [image] menu? Pick a number from the pop-up menus. (You'll probably find that 5 is too few; 30 is more practical.)

8.11.4 Font-Smoothing Style

The Mac's built in text-smoothing (antialiasing) feature is supposed to produce smoother, more commercial-looking text anywhere it appears on your Mac: in word processing documents, email messages, Web pages, and so on.

Beginning in Mac OS X 10.2, though, you can control how much smoothing is performed. Use the pop-up menu to choose a setting that suits your eyes—and your monitor. For example, Apple suggests Standard for CRT screens (that is, traditional, bulky, television-style screens), and Medium for flat-panel screens like laptops and the iMac.

Either way, the differences are fairly subtle (see Figure 8-7). Furthermore, unlike most System Preferences, this one has no effect until the next time you open the program in question. In the Finder, for example, you won't notice the difference until you log out and log back in again.

Figure 8-7. Top: The same 12-point type with text smoothing turned on (top) and off, shown magnified for your inspection pleasure. Bottom: Here's the widest difference in text-smoothing styles: Light smoothing vs. Strong. Standard and Medium, of course, are in between.

8.11.5 Turning Off Smoothing on Tiny Fonts

At smaller type sizes, such as 10-point and smaller, you might find that text is actually less readable with font smoothing turned on. (As shown in Figure 8-7, it all depends upon the font, the size, and your taste.) For that reason, the Size pop-up menu lets you choose a cutoff point for font smoothing. If you choose 12 from this pop-up menu, for example, then 12-point (and smaller) type still appears crisp and sharp; only larger type, such as headlines, displays the graceful edge smoothing. (These settings have no effect on your printouts—on screen display only.)


8.12 International

The International panel lets you set up your Mac to work in other languages. If you bought your Mac with a localized operating system—a version that already runs in your own language—and you're already using the only language, number format, and keyboard layout you'll ever need, then you can ignore most of this panel.

But at the very least, check it out. When it comes to showing off Mac OS X to your friends and loved ones, the "Wow" factor on the Mac's polyglot features is huge.

8.12.1 Another Language—Instantly

The Mac has always been able to run software in multiple languages—if you installed the correct fonts, keyboard layouts, and localized software (a French copy of the Mac OS, a French version of Outlook Express, and so on). But in Mac OS X, you can shift from language to language in certain programs on the fly, without reinstalling the operating system or even restarting the computer.

Open the International panel. On the Language tab, you see a listing of the fifteen different languages the Mac can switch into—French, German, Spanish, and so on. Just drag one of the languages to the top of the list to select it as the target language, as shown in Figure 8-8.

Figure 8-8. Feel like working in Dutch? Just drag Nederlands to the top of the Language list, log out and back in, and you're ready to start. Programs like TextEdit and Internet Explorer appear in Dutch. To switch back, simply return to System Preferences International, and drag your own language back up to the top of the list. (You have to relaunch any programs that are running to switch them to a different language.)

Now launch Internet Explorer, TextEdit, or Stickies. Every menu, button, and dialog box is now in the new language you selected! If you log out and back in (or restart) at this point, the entire Finder will be in the new language, too.

Of course, if you're really French (for example), you'll also want to make these changes:

  • Choose French from the Behaviors pop-up menu (also on the Language pane) so that sorting, capitalization, and word definitions also conform to French rules.

  • Choose the French keyboard layout from the Input Menu pane, as explained in Section 8.12.3.

  • Learn French. Sherlock 3 can translate simple sentences for you (Section 20.1.9), but it won't get you very far in the real world.

    NOTE

    Not all programs are language-switching aware. Also note that, while you can add other languages to the Language list using the Edit button, they don't actually work unless you install additional language kit software.

Figure 8-9. Here's TextEdit running in Dutch. Actually understanding Dutch would be useful at a time like this—but even if you don't, it can't help but brighten up your work day to choose commands like Spraakfunctie or Knip.

8.12.2 Dates, Times, Numbers, and Prices

The Date, Time, and Numbers tabs let you set up Mac OS X to display the date, time, currency, and other numbers in a format appropriate for the language:

  • Date tab. These controls govern how dates are displayed in list view Finder windows. If you think that 7/4 means July 4, skip this section. But if, as a European, you interpret it as April 7, you can use this pane to rearrange the sequence of date elements. The Region pop-up menu lists 20 ready-made settings for countries where the Mac is popular. If none of those suits your fancy, use the Long Date pop-up menus to specify a radical new order for your date elements.

  • Time tab. Some people prefer a 12-hour clock (3:05 PM), and others prefer a military or European-style, 24-hour clock (15:05). As with the Date pane, you can select a country from the Region pop-up menu to fill in the proper settings.

  • Numbers tab. You specify the decimal and thousands separator characters for displaying large numbers, because these, too, differ from country to country. (The number 25,600.99, for example, would be written as 25 600,99 in France, and as 25.600,99 in Spanish.) The Numbers pane also lets you pick an appropriate currency symbol ($, F, £, and so on) and your preference of metric system (standard or metric); it also has the same pop-up list of Regions.

8.12.3 Input Menu Tab

While the Mac can display many different languages at the same time, typing in those languages is another matter. The symbols you use when you're typing Swedish aren't the same as when you're typing English. Apple solved this problem by creating different keyboard layouts, one for each language. Each rearranges the letters that appear when you press the keys.

For example, when you use the Swedish layout and press the semicolon key, you don't get a semicolon (;)—you get an ö. (Apple even includes a Dvorak layout—a scientific rearrangement of the standard layout that puts the most common letters directly under your fingertips on the home row. Fans of the Dvorak layout claim greater accuracy, better speed, and less fatigue.)

Use the list in the Input Menu pane to indicate which keyboard layout you want. If you check off more than one keyboard layout, a tiny icon appears to the right of your Help menu—a keyboard menu that lets you switch from one layout to another just by choosing its name. (To preview a certain keyboard arrangement, launch the Key Caps program described in the next chapter.)

TIP

Instead of using the keyboard menu, you can rotate through the different keyboard layouts you've selected by pressing [image] -Space bar. If this keystroke conflicts with one of the programs you already use, there's not much you can do about it, other than turning off the keyboard layouts you don't use. Apple's [image] -Space bar keystroke always takes precedence over the same shortcut in your programs.

The Character Palette

There you are, two-thirds of the way through your local chess-club newsletter, when it hits you: You need an arrow symbol. Right now.

You know there's one in one of your symbol fonts, but you're not about to take two weeks off from work just to hunt through your fonts, typing every single combination of keys until you produce the arrow symbol. You can't help wishing there was an easier way to find those special symbols that hide among your fonts—fancy brackets, math symbols, special stars and asterisks, heart shapes, and so on.

The Key Caps program described in the next chapter is one solution. But in Mac OS X 10.2, you won't need it nearly as much, thanks to the new Character Palette.

To make it appear, open System Preferences, click the International icon, click the Input Menu tab, and turn on the Character Palette checkbox. Now inspect your menu bar: You've just added the keyboard menu.

Next time you're word processing or doing page layout, choose Show Character Palette from this menu. The resulting window rounds up all symbols from all your fonts at once. To find a particular symbol, click the "by Category" tab, and then click the various category headings: Arrows, Stars/Asterisks, Math, and so on. When you find the symbol you want, double-click it.

If you're using a Cocoa program, the correct symbol pops into your document. If not, you may get only the correct character, but not in the correct font. In that case, you'll have to change the font of the inserted character manually. To find out what font it came from, click the black, down-pointing triangle button; you'll see the font name in parentheses.


8.13 Internet

In the dark and time-consuming days of the early 1990s, the worst aspect of using the Internet was setting up Internet programs: your email program, Web browser, FTP client, and so on. Each required you to input several volumes of information about you, your Internet connection, and so on.

This panel neatly solves the problem, by providing a central location where you can record all of this information once. After you've done so, you don't need to type these settings into your Internet programs; most can retrieve the information they need from the Internet panel.

The Internet panel has four tabs. For most purposes, you don't need to fill in all of these fields, but filling in a few choice ones can save you a lot of time down the road:

  • .Mac. This is where you fill in your member name and password for your .Mac account, if you've subscribed. (See Chapter 18 for a full discussion of these accounts.) If you're not yet a member, you can click the Sign Up button to get started.

  • iDisk. Here's another set of controls that are of no value unless you've signed up for a .Mac account. (In fact, you shouldn't even bother visiting this tab if you don't have an account—it will seize control of your Mac for several minutes as it tries to connect to the Internet and download information from your nonexistent account.)

    The Disk Space graph indicates how full your electronic iDisk is. (And if it approaches your limit of 100 MB, a Buy More button lets you pay Apple for the privilege of gaining more storage.) The Public Folder Access controls let you specify whether or not other people are allowed to put new files into your Public folder (Section 11.4), and whether or not outsiders need a password to see what's in your Public folder. Much more detail on these topics in Chapter 18.

  • E-mail. Fill in all blanks. If you're not sure what to type, contact your Internet access company (or its Web page) for help. The most important setting is the Default Email Reader pop-up menu, which tells the Mac which email program you prefer to use (Mail, Entourage, or whatever). From now on, whenever you click a "Click here to send email" link on a Web page, that program opens automatically.

  • Web. All of the settings on this panel are important. Fill in the Home Page (the page you want to open when you first launch your Web browser). Next, click Select to specify a Downloads folder—files you download from the Internet will be stored here. (Mac OS X proposes the desktop itself, which is a good idea. The point is to eliminate the frustration of not being able to find something that you downloaded.)

    Use the Default Web Browser pop-up menu to indicate which browser you prefer—say, Internet Explorer or OmniWeb. This is the browser that will automatically open whenever you double-click an Internet location file or a Sherlock Internet-search result, for example.


8.14 Keyboard

The Keyboard panel lets you do some frivolous keyboard fine-tuning. It also unlocks Mac OS X's strange and remarkable Full Keyboard Access feature, which lets you control your Mac's menus, windows, dialog boxes, buttons, the Dock, and the toolbar—all from the keyboard.

8.14.1 Repeat Rate Tab

You're probably too young to remember the antique once known as the typewriter. On some electric versions of this machine, you could hold down the letter X key to type a series of XXXXXXXs—ideal for crossing something out in a contract, for example.

On the Mac, every key behaves this way. Hold down any key long enough, and it starts spitting out repetitions, making it easy to type, for example, "No WAAAAAAAY!" or "You go, girrrrrrrrrl!" The two sliders in the Repeat Rate pane of the Keyboard panel govern this behavior. On the right: a slider that determines how long you must hold down the key before it starts repeating (to prevent triggering repetitions accidentally, in other words). On the left: a slider that governs how fast each key spits out letters once the spitting has begun.

8.14.2 Full Keyboard Access Tab

For a full discussion of the options on this pane, see Section 4.4.


8.15 Login Items

This simple panel controls which programs launch automatically at startup time. Details are in Chapter 11.


8.16 Mouse

It may surprise you that the cursor on the screen doesn't move five inches when you move the mouse five inches on the desk. Instead, the cursor moves farther when you move the mouse faster.

How much farther depends on how you set the first slider in the Mouse panel. The Fast setting is nice if you have an enormous monitor, since you don't need an equally large mouse pad to get from one corner to another. The Very Slow setting, on the other hand, forces you to pick up and put down the mouse frequently as you scoot across the screen. It offers no acceleration at all, but it can be great for highly detailed work like pixel-by-pixel editing in Photoshop. Experimentation is the key.

The Double-Click Speed setting specifies how much time you have to complete a double-click. If you click too slowly—beyond the time you've allotted yourself with this slider—the Mac "hears" two single clicks instead.

8.16.1 Trackpad Options

On laptops, the bottom part of the Mouse panel offers some extra controls that affect the trackpad.

Under normal circumstances, you touch your laptop's trackpad exclusively to move the cursor. For clicking and dragging, you're supposed to use the clicking button beneath the trackpad.

Many people find, however, that it's more direct to tap and drag directly on the trackpad—using the same finger that's been moving the cursor. That's the purpose of these four checkboxes:

  • Clicking. When this box is turned on, you can tap the trackpad surface to register a mouse click at the location of the cursor. Double-tap to double-click.

  • Dragging. Turn on this option if you want to move icons, highlight text, or pull down menus—in other words, to drag, not just click—using the trackpad. Start by tapping twice on the trackpad, then immediately after the second tap, begin dragging your finger. (If you don't start moving promptly, the laptop assumes that you were double-clicking, which could wind up opening an icon you didn't intend to open.) You can stroke the trackpad repeatedly to continue your movement, as long as your finger never leaves the trackpad surface for more than about one second. When you finally stop touching the pad, you "let go," and the drag is considered complete. (All of this is much easier to do than to describe.)

  • Drag lock. If the dragging maneuver described above makes you too nervous that you're going to "drop" what you're dragging if you stop moving your finger for a fraction of a second, turn on this option instead. Once again, begin your drag by double-clicking, then move your finger immediately after the second click.

    When this option is on, however, you can take your sweet time in continuing the movement. In between strokes of the trackpad, you can take your finger off the laptop for as long as you like. You can take a phone call, a shower, or a vacation; the Mac still thinks that you're in the middle of a drag. Only when you tap again does the laptop consider the drag a done deal.

  • Ignore trackpad while typing. This option is a huge Mac OS X perk. It addresses a chronic syndrome of laptop owners who turn on the Clicking option of Apple trackpads: when you type along and a finger accidentally brushes the trackpad, sending the insertion point onto a different line of text. Before you even notice, you've typed over, or typed into, some random part of your document.

    This ingenious option locks out the click-and-drag trackpad functions when you're actually typing on the keyboard—a sweet and simple solution.

  • Ignore trackpad when mouse is present. Here's another ingenious advance in laptop technology: When you hook up a mouse to your laptop, the trackpad is deactivated. Obviously, if you're using a mouse, then you probably won't want to use the trackpad—and by turning on this checkbox, you're no longer susceptible to accidentally brushing it.


8.17 My Account

This panel, too, is described in Chapter 11. It's where you can change your password, Address Book card, and the picture next to your name on the Welcome screen.


8.18 Network

The Network panel is the brain of your Mac's Internet and local networking connections. See Chapter 12 and Chapter 18 for the settings you need to plug in.


8.19 QuickTime

The settings in the QuickTime panel affect the way movies are played back on your Mac, including movies that stream to you from a Web page and movies stored on your own system that you watch using QuickTime Player (Chapter 14).

You don't even have to touch most of these settings, but here are a few worth tweaking:

  • Plug-in. The settings in this pane control the way your Web browser's QuickTime plug-in works with streaming video. The "Play movies automatically" option, for example, tells the plug-in to start playing streaming movies as soon as they begin downloading (rather than waiting for an entire movie to download before starting).

  • Connection. The only important setting here is Connection Speed. Set it to match the actual speed and type of your Internet connection. (Some streaming QuickTime Web sites are set up with multiple versions of the same movie, each saved at a different size and frame rate. Based on your connection speed setting here, the QuickTime plug-in can automatically request the appropriately sized version of a movie for the best possible playback.)

  • Music. Nothing to see here, folks. You're supposed to choose a music synthesizer for playing back MIDI music files—but you have only one choice.

  • Media Keys. Media keys are supposed to be special passwords supported by QuickTime that unlock movies so you can watch them. As it turns out, nobody uses them.

  • Update. These controls provide an easy way to download the latest QuickTime software from Apple.


8.20 Screen Effects

In previous versions of Mac OS X, this panel was called Screen Saver. Why did Apple change the name? Very simple: This feature doesn't actually save your screen. In fact, flat-panel screens can't burn in at all, and even traditional CRT screens wouldn't burn an image into the screen unless you left them on continuously—unused, with the same image on the screen—for two straight years. It's just not going to happen.

No, screen savers are mostly about entertainment, pure and simple—and Mac OS X's built-in screen saver is certainly entertaining.

In the Screen Effects panel, you can choose from nine different screen saver modules—most of them beautifully designed. For example:

  • Computer Name. This display shows nothing more than the Apple logo and the computer's name, faintly displayed on the monitor. (These two elements do actually shift position every few minutes—it just isn't very fast.) Apple probably imagined that this feature would let corporate supervisors glance over at the screens of unattended Macs to find out exactly who is not at their desks.

  • Flurry. Here's another new one in 10.2—and it's a doozy. You get flaming, colorful, undulating arms of fire, which resemble a cross between an octopus and somebody arc welding in the dark. If you click the Configure button, you can even control how many streams of fire appear at once, the thickness of the arms, the speed of movement, and the colors.

  • Abstract, Beach, Cosmos, Forest. These are photographic screen savers, featuring gorgeous pictures that slowly zoom and softly crossfade into each other. Abstract features psychedelic swirls of modern art. In the Beach, Cosmos, and Forest screen savers, you see a series of tropical ocean scenes, deep space objects, and lush rain forests.

    Each creates an amazingly dramatic, almost cinematic experience, worthy of setting up to "play" during dinner parties like the lava lamps of the Seventies.

For any of these options, you can click the Configure button to see a dialog box like the one shown in Figure 8-10.

TIP

Don't forget that iPhoto (in your Applications folder) lets you organize your photos into albums (subfolders). You can turn any album into a custom screen saver with just one click (on the Screen Saver icon at the bottom of the Share panel).

Figure 8-10. Left: Create your own slide shows—an absolute must if you have a flat-panel iMac or an Apple Cinema Display, and a cool Manhattan loft apartment. Right: Setting up hot corners. Click once to put a checkmark in any one of the corners, designating it an instant-activation spot; sliding the mouse to that corner turns on your screen saver right away. To disable the screen saver, drag the mouse into a corner that you've marked with a minus sign (by clicking twice on the checkbox).

  • Pictures Folder. This is one of the coolest Screen Effects modules. It lets you transform your own collection of pictures into a self-playing slide show.

    If you just click Pictures Folder and walk away, the screen saver will display the digital photos in your Home [image] Pictures folder, complete with spectacular zooming and dissolving effects.

    But if you click Pictures Folder and then click Configure, you'll see the dialog box shown in Figure 8-11. Here, you can instruct Mac OS X to create a screen saver out of any folder full of pictures. Either drag the folder itself into the little Slide Folder well, or click Set Slide Folder and then navigate to it.

    While you're at it, you might want to look over the Display Options, which are fairly self-explanatory.

  • .Mac. As noted on Section 18.8, one of the perks for paying $100 per year for a .Mac membership is the ability to create slide shows online, which can play back either on your own Mac or (if you opted to make it public) on anybody else's. Click the Configure button to open the dialog box where you can specify which member's slide show collection you want to view, and how you want it to appear. (For example, you can turn off the crossfade between slides, crop the slides so that they fit on the screen, opt to present the slides in random order, and so on.)

  • Random. If you can't decide which one of the modules to use, click Random. The Mac will choose a different module each time your screen saver kicks in.

When you click a module's name in the Screen Savers list, you see a mini version of it playing back in the Preview screen. Click Test to give the module a dry run on your full screen.

Figure 8-11. In Mac OS X version 10.1, you had to be careful not to use high-resolution digital photos for your screen saver. Because the Mac didn't bother to shrink them to fit the screen, you saw only your grandfather's ear sliding across the screen. But the "Crop slides to fit on screen" checkbox eliminates the problem, ensuring that every photo will be nicely centered and sized. (Don't worry: Apple really means "shrink," not "crop.")

When you've had enough of the preview, just move the mouse or press any key. You return to the Screen Effects panel.

Secrets of the Screen Saver Modules

The canned screen saver modules are stored in your System [image] Library [image] Screen Savers folder. If you Control-click one of the icons inside and choose Show Package Contents from the contextual menu, you'll find a Contents [image] Resources folder that contains the individual JPEG files for each module (the outer space photos for the Cosmos screen saver, for example).

Why bother? Because some of these spectacular photos make really good desktop pictures. You're free to copy them out of the Resources folder for that purpose.

8.20.1 Activating the Screen Saver

You can control when your screen saver takes over your monitor in a couple of ways:

  • In the Activation pane, you can set the amount of time that has to pass without keyboard or mouse activity before the screen saver starts. The duration can be as short as five minutes or as long as an hour, or you can drag the slider to Never to prevent the screen saver from ever turning on by itself.

    TIP

    The Activation pane also gives you the option of requiring you to enter your user password (Section 11.2) in order to disengage the screen saver. If you turn this feature on, you can use the screen saver as a sort of lock for your Mac. You can walk away from your desk at work, knowing that once the screen saver takes over, no one will be able to read the email on your screen or rifle through your files.

  • On the Hot Corners pane, you can turn each corner of your monitor into a hot corner (Figure 8-10). Whenever you roll your cursor into that corner, the screen saver can either turn on instantly (great for those times when you happen to be shopping on eBay at the moment your boss walks by) or stay off permanently (for times when you're reading onscreen or watching a movie).

    TIP

    You can find dozens more screen saver modules at www.epicware.com.


8.21 Sharing

Details on how to use the Sharing panel are in Chapter 11 and Chapter 21.


8.22 Software Update

Few operating-system ideas are simpler or better than this one: Whenever Apple improves or fixes one of the innumerable software pieces that make up Mac OS X, the Software Update program can notify you, download the update, and install it into your System automatically.

Software Update doesn't run rampant through your system software, however; it's quietly respectful. For example, in the beginning, you must manually click the Update Now button when you want the program to dial the Internet for updates. Furthermore, Software Update doesn't actually download the new software without asking your permission first and explicitly telling you what it plans to install, as shown in Figure 8-12.

8.22.1 Update Software Tab

For maximum effortlessness, turn on the Automatically checkbox and then select a frequency from the pop-up menu—daily, weekly, or monthly.

8.22.2 Install Updates Tab

By popular demand, the 10.2 version of Software Update also keeps a meticulous log of everything it drops into your system. On this tab, you see them listed, for your reference pleasure.

TIP

In your hard drive [image] Library [image] Receipts folder, you'll find a liberal handful of .pkg files that have been downloaded by Software Update. In previous versions of Mac OS X, you could reinstall one simply by double-clicking.

In 10.2, most of these are just what they say: receipts that help Mac OS X understand which updaters you've already downloaded and installed. They make intriguing reading, but their primary practical use is finding whether or or not you've installed, for example, the 10.2.2 update.

Figure 8-12. Apple has always created updated and bug-fix versions of its software components, but they don't do you any good if you don't know about them. You no longer have to scour Mac news Web sites to discover that one of these components has been released and then hunt down the software itself. When Software Update finds an appropriate software morsel, it offers to install it automatically.
    [ Team LiB ]


8.23 Sound

Mac OS X's sound options are a little on the lean side, but a visit to the Sound panel is still worthwhile. Using the panes of the Sound panel, you can configure the sound system of your Mac in the following ways:

8.23.1 Sound Effects

"Sound effects" means error beeps—the sound you hear when the Mac wants your attention, or when you click someplace you shouldn't.

Mac OS X introduced a mostly new set of choices in the list of alert sounds. Only one of the classic old favorites remains—the famous Sosumi (named, as the legend goes, when Apple Records threatened to sue Apple Computer for adding sound-recording features to the Mac years ago). The newcomers, including Basso, Frog, Funk, Ping, Pop, and Tink, are funny and clever, yet subdued enough to be of practical value as alert sounds. Just click the sound of your choice to make it your default system beep.

As for the other controls on the Sound Effects panel, they include:

  • Alert Volume slider. Some Mac users are confused by the fact that even when they drag this slider all the way to the left, the sound from games and music CDs still plays at full volume.

    The actual main volume slider for your Mac is at the bottom of the Sound panel, called "Output volume." The slider on the Alert Sounds panel is just for error beeps; Apple was kind enough to let you adjust the volume of these error beeps independently.

  • Play user interface sound effects. This option produces a few subtle sound effects when you perform certain Finder operations: dragging something off of the Dock, for example, or dropping something into the Trash.

  • Play feedback when volume keys are pressed. Most Mac keyboards have little speaker icons that, when pressed, adjust the overall volume louder or softer. Each time you press one of these keys, the Mac beeps to help you gauge the current speaker level.

    That's all fine when you're working at home. But more than one person has been humiliated in an important meeting when the Mac made a sudden, inappropriately loud sonic outburst—and then amplified that embarrassment by furiously and repeatedly pressing the volume-down key, beeping all the way.

    If you turn off this checkbox, the Mac won't make any sound at all as you adjust its volume. Instead, you'll see only a visual representation of the steadily decreasing (or increasing) volume level.

    TIP

    This System Preferences panel is another one that offers a "Show in menu bar" option at the bottom. It installs a volume control right in your menu bar, making the volume control instantly accessible from any program.

8.23.2 Output Tab

"Output" means speakers. For 99 percent of the Mac-using community, this panel offers nothing useful except the Balance slider, with which you can set the balance between your Mac's left and right stereo speakers. The "Choose a device" wording seems to imply that you can choose which speakers you want to use for playback. But Built-in is generally the only choice, even if you have external speakers. (The Mac uses your external speakers automatically when they're plugged in.)

8.23.3 Input Tab

This panel, new in 10.2, lets you specify which microphone you want the Mac to "listen to," if indeed you have more than one connected. It also lets you adjust the sensitivity of that microphone—its "input volume"—by dragging the slider and watching the real-time Input Level meter above it change as you speak.


8.24 Speech

Your Mac's ability to speak—and be spoken to—is described starting in Section 14.4. Don't miss this, either: In Mac OS X 10.2, you can now control your Mac's menus and windows by voice, too.


8.25 Startup Disk

Use this panel to pick the System Folder your Mac will use the next time you start your Mac, swapping between Mac OS X and Mac OS 9.2, for example. Check out the details in Chapter 5.


8.26 Universal Access

The Universal Access panel is designed for people who type with one hand, find it difficult to use a mouse, or have trouble seeing or hearing. (These features can also be handy when the mouse is broken or missing.) It's been substantially beefed up in Mac OS X 10.2, as a quick inspection of the four tabs suggests.

NOTE

You'll quickly discover that your Mac actually speaks aloud the names of the Universal Access panel's various buttons and tabs, as you move your cursor over them. This, of course, is intended to help people who have trouble reading the screen. If it bothers you, turn off "Enable text-to-speech for Universal Access preferences" at the bottom of the window.

8.26.1 Seeing Tab (Magnifying the Screen)

If you have trouble seeing the screen, one quick solution is to reduce your monitor's resolution—thus magnifying the image—using the Displays panel of System Preferences, described earlier in this chapter. If you have a 17-inch or larger monitor set to, say, 640 x 480, the result is a crisp, high-contrast, greatly magnified picture.

That method doesn't give you much flexibility, however, and it's something of a hassle to adjust.

If you agree, then try out the features offered by the Seeing panel (called CloseView in earlier Mac OS versions). This feature lets you enlarge the area surrounding your cursor in any increment—and, if you like, also to invert the colors of the screen so that white is black, blue is yellow, and so on.

To make it work, press [image] -Option-* (use the asterisk on the numeric keypad, or add Shift-8 to invoke the asterisk on the main keyboard) as you're working. Or, if the Seeing panel is open in front of you, just click the gigantic Turn On Zoom button. That's the master switch.

No zooming actually takes place, however, until you press Option- [image] -plus sign (to zoom in) or Option- [image] -minus sign (to zoom out). Here, you can use either the numeric keypad or the top row of keys on the keyboard.

With each press, the entire screen image gets larger or smaller, creating a virtual monitor that follows your cursor around the screen.

You'll be amazed at just how much you can zoom in. In fact, there's nothing to stop you from zooming in so far, that a single pixel fills the entire monitor. (That may not be especially useful for people with limited vision, but it can be handy for graphic designers learning how to reproduce a certain icon, dot by dot.)

While you're at it, pressing Control-Option- [image] -* (asterisk) inverts the colors of the screen, so that text appears white on black—an effect that some people find easier to read.

NOTE

There's also a button called Set Display to Grayscale, which banishes all color from your screen—yet another feature designed to improve text clarity. Switch back to color by clicking the same button again, even though it still says Set Display to Grayscale.

8.26.2 Hearing Tab (Flashing the Screen)

If you have trouble hearing the Mac's sounds, the obvious solution is to increase the volume, which is why the Adjust Sound button on this panel offers a direct link to the Sound preferences panel. (If your Mac doesn't have external speakers, consider getting some.)

Fortunately, hearing your computer usually isn't critical (except when working in music and audio, of course). The only time audio is especially important is when the Mac tries to get your attention by beeping, as described a few pages back. For those situations, turn on "Flash the screen whenever an alert sound occurs" (an effect you can try out by clicking Flash Screen). Now you'll see a white flash across the entire monitor whenever the Mac would otherwise beep.

8.26.3 Keyboard Tab (Typing Assistance)

This panel offers two clever features designed to help people who have trouble using the keyboard.

  • Sticky Keys lets you press multiple-key shortcuts (involving keys like Shift, Option, Control, and [image]) one at a time instead of all together.

    To make Sticky Keys work, first turn on the master switch at the top of the dialog box. Then go to work on the Mac, triggering keyboard commands as shown in Figure 8-13.

    If you press a modifier key twice, meanwhile, you lock it down. (Its onscreen symbol gets brighter to let you know.) When a key is locked, you can use it for several commands in a row. For example, if a folder icon is highlighted, you could double-press [image] to lock it down—and then type O (to open the folder), look around, and then press W (to close the window). Press the [image] key a third time to "un-press" it.

    TIP

    If you turn on Allow Universal Access Shortcuts at the bottom of the dialog box, you give yourself an easier way to turn on Sticky Keys—one that gives you the flexibility of turning Sticky Keys on and off at will, without even taking a trip to System Preferences. Whenever you want to turn on Sticky Keys, press the Shift key five times in succession. You'll hear a special clacking sound effect alerting you that you just turned on Sticky Keys. (Repeat the five presses to turn Sticky Keys off again.)

  • Slow Keys, on the other hand, doesn't register a key press at all until you've held down the key for more than a second or so—a feature designed to screen out accidental key presses.

    If "Use click key sounds" is turned on, you'll hear a little typing sound each time you press a key—but none of these key presses registers unless you hold the key down for a moment. (Use the Acceptance Delay slider to govern this threshold.) You hear a different sound when the Mac actually accepts the key press—and, of course, you'll see the letter you typed appear onscreen.

Figure 8-13. Whenever you want to press a multiple-key keystroke like Shift-Option- -D, press them one at a time. You'll see ghost images of these keys superimposed on your screen, as though to show you which keystrokes you've added to your temporary collection. To "un-press" a key you've already pressed, press it again.

8.26.4 Mouse Tab (Cursor Control from the Keyboard)

This feature, called Mouse Keys, is designed to help people who can't use the mouse—or who want more precision when working in graphics programs. It lets you click, drag, and otherwise manipulate the cursor by pressing the keys on your numeric keypad.

When Mouse Keys is turned on, the 5 key acts as the clicker—hold it down for a moment to "click the mouse," do that twice to double-click, and so on. Hold down the 0 key to lock down the mouse button, and the period key to unlock it. (The amount of time you have to hold them down depends on how you've set the Initial Display slider.)

Move the cursor around the screen by pressing the eight keys that surround the 5 key. (For example, hold down the 9 key to move the cursor diagonally up and to the right.) If you hold one of these keys down continuously, the cursor, after a pause, begins to move smoothly in that direction—according to the way you have adjusted the sliders called Initial Delay and Maximum Speed.

TIP

If Allow Universal Access Shortcuts is turned on at the bottom of the dialog box, you can turn Mouse Keys on or off by pressing the Option key five times in succession. Doing so saves you the trouble of opening System Preferences.

Direct System Preferences Access from the Dock

Pining for the days of Mac OS 9 or Windows, when all control panels were only a click away (in the [image] menu or Start [image] Control Panel menu)? Pine no more. Within one minute, you can have yourself a tidy pop-up menu of System Preferences panels right there in your Dock.

Make a new folder (in your Home folder, for example). Name it whatever you'll want the Dock icon to say—SysPrefs or Control Panels, for example.

Now open your System [image] Library [image] PreferencePanes folder, which contains the icons for the various System Preferences panes. Select all of them—or only the ones you actually use.

Drag them into your SysPrefs folder, taking care to press Option- [image] as you release the mouse. (Option- [image] -dragging makes aliases of them.) If the .prefPane suffix on the aliases bugs you, select all of the aliases, press [image] -I, open the Name & Extension panel in the Get Info window, and turn on "Hide extension."

Finally, drag the SysPrefs folder onto the right side of your Dock. Now, whenever you want to open a particular panel, just Control-click (or hold the mouse button down on) this SysPrefs Dock icon. You get a handy pop-up list, as shown here. (The icons may look like folders, but they're standard, double-clickable icons that take you directly to the corresponding panel of System Preferences.)


Chapter 9. The Free Programs

If you write it, they will come. That's the theory, anyway—that the success of the Mac (or any computer, really) depends on the quality and quantity of the applications available for it. Where there's a broad software selection, there's an audience. That, no doubt, is why Apple has been busily writing its own cool new programs (iTunes, iPhoto, and so on).

Right out of the box, Mac OS X comes with a healthy assortment of over 30 freebies: programs for sending email, writing documents, doing math, even playing games. Some are dressed-up versions of Mac programs that have been around for years. Others, though, are new programs that not only show off some of Mac OS X's most dramatic new technologies, but let you get real work done without having to invest in additional software.


9.1 Your Free Mac OS X Programs

You've got a broad assortment of programs in the Applications folder in the main hard drive window. The Applications [image] Utilities folder holds another couple dozen mini-programs that handle such workaday jobs as setting up printers and network connections, fixing problems on your hard disk, and monitoring the behind-the-scenes processing performed by your Mac whenever you launch and run programs.

All of these programs have been either written expressly for Mac OS X (Cocoa applications) or adapted for it ("Carbonized"—see Section 4.6). This chapter guides you through every item in your new software library, one program at a time. (Depending on your Mac model, you may find other programs in your Applications folder; Apple occasionally licenses software from other companies to spice up the collection for, say, iMacs or Power Macs.)

TIP

A reminder: You can jump straight to the Applications folder in the Finder by pressing Shift- [image] -A, or by clicking the Applications button in the Finder window toolbar (it's the button that looks like an A). You might consider adding the Application folder's icon to the right side of your Dock, too, so that you can access it no matter what program you're in.

9.1.1 Acrobat Reader 5.0

Just about every computer on earth comes with a copy of the free Adobe program, Acrobat Reader. As its name implies, Acrobat Reader lets you open and read PDF (Portable Document Files) files (see Section 13.5). This is quite a useful task since, as you've probably noticed, software manuals, product brochures, tax forms, and many other documents are distributed as PDFs these days.

TIP

Here's the most important thing to remember about reading PDF files in Acrobat: press Enter. With each press, you "turn the page." If the screen shows only part of a page, the Enter key brings the next portion into view. Press Shift-Enter to go up the page (or back a page).

At first glance, the inclusion of Acrobat Reader with Mac OS X may seem a little redundant. After all, Mac OS X comes with its own free PDF-reading utility: Preview (described later in this section). Why do you need Acrobat Reader if you already have Preview?

Don't be fooled. Preview can open and display PDFs, but that's about it. Here are some of the features in Acrobat Reader that are missing in Preview:

  • Full screen mode. With Reader, you can fill the entire screen with the contents of a PDF, turning it into a cheapo alternative to PowerPoint for making presentations. (To see the effect, press [image] -L, or choose View [image] Full Screen.)

  • Zoom tool. This lets you zero in on one specific portion of a document. Just click the magnifying glass tool and then drag diagonally across the section of the page you want to fill your screen.

  • Search tools. Only Acrobat lets you search for text within a PDF, as shown in Figure 9-1.

  • Copy tool. Acrobat also lets you drag across a chunk of text and copy it to the Clipboard, using the special T tool on the toolbar.

  • Interactivity. A PDF can contain form fields that you fill in, or bookmarks and hyperlinks that allow you to jump quickly to various parts of the document, or even to other documents or a Web site. But a PDF's interactive features are lost in Preview, which displays a PDF as if it were merely a static picture.

Adobe has done a surprisingly good job of documenting its additional features within the program itself. Just choose Help [image] Reader Help in Acrobat (or press [image] -?) for the details.

Figure 9-1. Preview does an admirable job of displaying PDF files, but only Acrobat Reader can let you search for text within a document—a valuable feature considering the vast number of user guides, instruction manuals, product brochures, and business forms that come in PDF nowadays.

9.1.2 Address Book

The Address Book is a database that stores names, addresses, email addresses, phone numbers, and other contact information. The dramatically rewritten version in Mac OS X 10.2 works seamlessly with iChat and Mail. Chapter 19 covers Address Book in detail.

9.1.3 AppleScript

This folder contains all of the scripts and tools described in Chapter 7.

9.1.4 Calculator

Over the years, just about every Mac program and feature evolved, matured, and grew. Over time, such traditional accessories as the Puzzle, the Scrapbook, and the Chooser went on to the great R&D lab in the sky. For seventeen years, however, one program chugged along, essentially untouched: the simple, four-function Calculator. As late as 2002, this Calculator still lacked memory keys, a percentage key, or a CE (clear error) key, let alone any advanced functions. By the time Mac OS X 10.1 was introduced, it was the very last piece of original Mac OS software still standing.

In Mac OS X 10.2, that relic is finally gone. The new Calculator is far more potent than the humble four-function program that preceded it. It's still useful for performing quick arithmetic without having to open a spreadsheet, but now it's far more functional. It can act as a scientific calculator for students and scientists, a conversion calculator for metric and U.S. measures, and even a currency calculator for world travelers.

NOTE

If Mac OS X came preinstalled on your new Mac, you might not have the Calculator program. In its place, Apple offers the equally delightful PCalc 2, a popular shareware scientific calculator.

Here's everything you need to know for basic math:

  • The calculator has two modes: Basic and Advanced (see Figure 9-2). Switch between them by clicking the appropriate button just underneath the calculator readout.

  • You can operate the calculator by clicking the onscreen buttons, but it's much easier to press the corresponding number and symbol keys on your keyboard.

    TIP

    If you have a recent Mac laptop, don't miss the embedded numeric keypad, superimposed on the right side of the keyboard and labeled on the keys in a different color ink. When you press the Fn key in the lower-left corner of the keyboard, typing these keys produces the numbers instead of the letters.

  • As you go, you can make your calculator speak each key you press. This is a sensational feature; the Mac's voice ensures that you don't mistype as you keep your eyes on the receipts in front of you, typing by touch.

    Just choose Speech [image] Speak Button Pressed to turn this feature on or off. (You choose the voice in the Speech panel of System Preferences.)

  • A new "paper tape" option shows a scrolling list of your calculations. Amazingly, you can actually edit these numbers, even long after a calculation is over. You can also print or save the paper tape; see Figure 9-2.

  • Press the C key to clear the calculator display.

  • Once you've calculated a result, you can copy it (using File [image] Copy, or [image] -C) and paste it directly into another program.

Figure 9-2. The new Calculator program offers both a four-function Basic mode and a full-blown scientific calculator mode (shown here). Each one offers a "paper tape" feature that lets you correct errors made way back in a calculation. To edit one of these numbers, drag through it, retype, and then press Enter. (You can also print the tape; choose File Save Tape As, or File Print Tape.)
9.1.4.1 Conversions

Calculator is more than a calculator; it's also a conversion program. No matter what units you're trying to convert—meters, grams, inches, miles per hour—the Calculator is ready. Proceed like this:

  1. Clear the calculator. Type in the starting measurement.

    To convert 48 degrees Celsius to Fahrenheit, for example, type 48.

  2. From the Convert menu, choose the kind of conversion you want.

    In this case, choose Temperature. When you're done choosing, a little dialog box appears.

  3. Use the pop-up menus to specify which units you want to convert to and from.

    To convert Celsius to Fahrenheit, choose Celsius from the first pop-up menu, and Fahrenheit from the second.

  4. Click OK.

    That's it. The calculator displays the result—in degrees Fahrenheit, in this example.

The next time you want to make this kind of calculation, you can skip steps 2, 3, and 4. Instead, just choose your desired conversion from the Convert [image] Recent Conversions submenu.

Calculator is especially amazing when it comes to currency conversions—from pesos to American dollars, for example—because it actually does its homework. It goes online to download up-to-the-minute currency rates to ensure that the conversion is accurate.

All you have to do is choose Convert [image] Update Currency Exchange Rates. Then, when you use the Convert [image] Currency command, your numbers will be the very latest.

TIP

If you Control-click the Calculator's results display, the contextual menu offers an option called Large Type—a great way to make sure the peons in the back row can see the answer.

9.1.5 Chess

Mac OS X comes with only one game, but it's a beauty (Figure 9-3). Chess is a traditional chess game played on a gorgeously rendered board with a set of realistic 3-D pieces. The program is actually a 15-year-old Unix-based chess program, Gnu Chess, that Apple packaged up in a new wrapper.

9.1.5.1 Playing a game of Chess

When you launch Chess, you're presented with a fresh, new game that's set up in Human vs. Computer mode—meaning that you (the Human, with the white pieces) get to play against the Computer (your Mac, on the black side). Drag the chess piece of your choice into position on the board, and the game is afoot.

Choose Chess [image] Preferences to find some useful controls like these:

  • Level. Use this slider to determine how frustrated you want to get when trying to win at Chess. The further you drag the slider toward the Hard side, the more calculations the computer runs before making its next move (and, thus, the harder it gets for you to outthink it). At the easiest setting, Chess won't spend more than five seconds ruminating over possible moves. Drag the slider all the way to the left, however, and the program may analyze each move for as long as ten fun-filled hours. This hardest setting, of course, makes it all but impossible to win a game (which may stretch on for a week or more anyway).

    Choosing the Easy setting makes it only mildly impossible.

  • Game. When you switch the pop-up menu to Computer vs. Human, you and your Mac trade places; the Mac takes the white side of the board and opens the game with the first move, and you play the black side.

    On some night when the video store is closed and you're desperate for entertainment, you might also want to try the Computer vs. Computer option, which pits your Mac against itself. To kick off a Computer vs. Computer game, you first must choose the appropriate Game option in the Preferences dialog box, and then open Game [image] Controls and click the Start Computer vs. Computer Game button. Pour yourself a beer, open a bag of chips, and settle in to watch until someone—either the Mac or the Mac—gains victory.

  • Speech. This checkbox lets you play Chess using the Mac's built-in voice-recognition features, telling your chess pieces where to go instead of dragging them. Talking to Chess has the details.

    TIP

    If your Chess-playing skills are less than optimal, the Move menu will become your fast friend. The three commands tucked away there let you undo your last move (great for recovering from a stupid mistake), display your opponent's previous move (in case you failed to notice what the computer just did), and reveal helpful hints (when you don't have a clue what to do next).

Figure 9-3. Chess isn't just another computerized chess game; it's also one of the more visually striking programs you get with Mac OS X. You don't have to be terribly exact about grabbing the chess pieces when it's time to make your move. Just click anywhere within a piece's current square to drag it into a new position on the board.

Human vs. Human

In the Chess [image] Preferences dialog box, Chess offers a Computer vs. Human option, a Human vs. Computer option, and even a Computer vs. Computer option. What happened to Human vs. Human? Can't two people play a round of chess on that cool 3-D game board?

Surprisingly, there is no such option. The circa-1986 chess-playing engine on which Apple's Chess game is built was originally developed to demonstrate a computer's remarkable ability to crunch through massive amounts of data when analyzing possible chess moves—not to simply provide a virtual game board. So there's no provision for running a game in which the computer isn't at least one of the players.

If you and a friend want to play chess, break out a real chess set and play in three dimensions. And don't complain...it's good for you.

9.1.5.2 Saving your games

If you want to save your chess games for posterity, Chess offers three different ways to do so. First, as you might expect, you can choose Game [image] Save (or Save As) to save a game in progress, so that you can resume it later.

To archive the moves making up an entire game instead, use the List command, which creates a TextEdit file documenting every move in your game. It lists the moves according to the board coordinates displayed on the game board at that time. A typical move would be recorded as "f8b4," meaning that a piece was moved from the f8 square to the b4 square. Equipped with a Chess list document, you could re-create an entire game, move by move.

Finally, the Print command lets you print full-color "snapshots" of your game-in-progress at any point.

Pink Knight Takes Mauve Bishop

There isn't much you can do to customize the appearance of Chess—at least not without hacking the chess board and game pieces as described in Chapter 17.

You can, however, easily change the colors of the chess pieces. What better way to have, say, Pink vs. Green battle it out instead of the usual White and Black?

To colorize, choose Game [image] Controls. Click one of the rectangular color swatches that appear next to each of the chess pieces to open the standard Mac OS X color picker.

Choose a color using any of the Color Picker options (see The Color Picker). Click the Set Piece Color button to apply the color to the selected chess pieces.

These colors don't appear, by the way, when you pop Chess into ugly, boring two-dimensional mode (View [image] 2 Dimensional), which displays an unimpressively flat, 1985-ish 2-D version of the game board.

9.1.6 Clock

Launching Clock puts a digital or analog clock in a floating window right on your desktop or in the Dock. This was a big deal in the Public Beta version of Mac OS X, which lacked a menu-bar clock. Today, of course, you can use the Date & Time pane in System Preferences to plant a clock (digital or analog) right in your menu bar, just as in earlier versions of the Mac OS.

Still, a visit to Clock [image] Preferences gives you all sorts of options regarding how you want this clock to look and act.

  • Analog vs. digital. You can choose between two different formats for the clock: either traditional analog (with or without a second hand) or digital, which also displays the month, day, and day of the week. The analog version is more elegant, but the digital display is more informative.

  • Location. You can put the clock in its own free-floating window on the desktop or permanently park it in the Dock as a living icon that ticks away right there in its docked location.

  • Transparency. Transparency effects—made possible by the powerful Quartz graphics engine—look dazzling in the Clock program. The Transparency slider has six settings that control the degree to which you can see through the clock face itself when displayed in its own window (see Figure 9-4).

    TIP

    Why order custom-made clocks (logo clocks, comedy clocks, and so on) from cheap mail-order catalogs? Deface your own clock! Section 17.3 explains how to make Clock display a face design of your very own.

Figure 9-4. The ghosted, semi-transparent image of the clock can float over the desktop, hover above Finder windows, or even superimpose itself over open documents windows, as shown here. If it gets in your way, you can always banish the clock to the Dock. Open Clock Preferences and change the Display setting from "In a floating window" to "In the Dock."

9.1.7 DVD Player

DVD Player, your Mac's built-in movie projector, is described in Chapter 10.

9.1.8 iCal, iSync

For details on Apple's calendar program and its syncing utility, see Chapter 20.

9.1.9 iChat

This instant-messaging program, new in 10.2, is described in Chapter 20.

9.1.10 Image Capture

This unsung little program is something of an orphan. It was designed to download pictures from a USB digital camera and then process them automatically (turning them into a Web page, scaling them to emailable size, and so on). Of course, since Image Capture's birth, iPhoto came along, generally blowing its predecessor out of the water.

Even so, Apple still includes Image Capture with Mac OS X for these reasons:

  • Image Capture makes it easy to download only some pictures from your camera. iPhoto, by contrast, always downloads the entire contents of your camera's memory card. (Figure 9-5 shows how to choose individual pictures.)

  • iPhoto is great, but it can't hold more than about 2,000 pictures before it starts to feel like quicksand. At that point, most Mac fans shop for a more powerful digital-shoebox program—thus losing iPhoto's photo-downloading features. In those situations, Image Capture is a handy auto-downloading tool. Once it has grabbed your shots from the camera, you (or your beefier photo-management program) can take over from there.

  • Starting in Mac OS X 10.2, Image Capture can grab images from Mac OS X-compatible scanners, too, not just digital cameras.

Image Capture works only with USB cameras that are designed to be auto-recognized in this way. Most recent Canon, HP, Olympus, Epson, Nikon, Sony, Kodak, and Fuji cameras work this way. (Check Apple's Web site for a partial list of compatible models.)

If you have one of the lucky cameras, you can open Image Capture in either of two ways. You can simply double-click its icon in your Applications folder, of course, or you can set it up to open automatically whenever you connect the camera and turn it on. (To set up that arrangement, open Image Capture manually. Choose Image Capture [image] Preferences, and choose Image Capture from the "When a camera is connected, open:" pop-up menu.)

In any case, once Image Capture is open, it looks like Figure 9-5.

TIP

Sure, Image Capture opens automatically when you plug in your camera. But you still have to click the Download button to transfer the pictures. You call that automatic?

Yes—if you visit Image Capture [image] Preferences and turn on "Automatically download all items." From now on, just plugging in the camera both opens Image Capture and downloads its photos.

Figure 9-5. Top: You can set up Image Capture to open automatically when you attach a USB camera to your Mac. One click (on Download All) transfers its pictures to your hard drive. Bottom: If you click Download Some, you get this "slide-sorter" window, where you can choose the individual pictures you want to download, use the buttons at the top to rotate selected shots, or delete shots from the camera. In slide-sorter view, Shift-click or -click the thumbnails of the pictures you want. In list view, Shift-click or -click as though they're Finder list-view files (see Section 2.3 for details).

In Image Capture, you can use these pop-up menus:

9.1.10.1 Download To

Use this pop-up menu to choose a destination folder for the pictures. Image Capture proposes putting them into your Home folder's Pictures folder. (Most cameras these days can also record sound and short video clips, which Image Capture proposes storing in your Music and Movies folders.) When the downloading process is complete, Mac OS X opens the Pictures folder automatically, saving you the trouble of finding it.

9.1.10.2 Automatic Task

Download, schmownload—Image Capture is just warming up. It comes equipped to process the downloaded photos in several useful ways. For example:

  • None. Translation: "Just download the pictures, please."

  • Build slide show. After the download is complete, your screen goes black, and a smooth full-screen slide show begins, featuring the newly downloaded pictures gracefully cross-fading one to the next. If you've grown used to the musical accompaniment in iPhoto's slide shows, the stark silence may feel a bit eerie—but otherwise it's a nice, quick way to look over the new pictures.

  • Build web page. Creates an actual, and very attractive, Web page of your downloaded shots. Against a black background, you get thumbnail images of the pictures in a Web page document called index.html. (You'll find it in your Home folder [image] Pictures [image] Index folder, which also contains the graphics files incorporated into this HTML document.) Image Capture automatically opens up this page in your Web browser, proud of its work.

    Just click one of the small images to view it at full size, exactly as your Web site visitors will be able to do once this page is actually on the Web. (Getting it online is up to you, although Apple's HomePage feature—part of the .Mac subscription program described on Section 18.8—is one of the easiest methods.)

    The truth is, iPhoto offers more Web-page options and better-looking results, but Image Capture is handy when you just need something quick and dirty.

  • Format 3 x 5, Format 8 x 10.... These options also create Web-page photo galleries, but not for displaying on the Web. Instead, they're designed for printing out. Each offers neatly arranged photos in the dimensions you've selected—3 x 5, 4 x 6, and so on—ready to print out (and then, presumably, to cut apart with scissors or a paper cutter).

    Again, the printing options in iPhoto are far superior. But if you're stranded on a desert island with only Image Capture, here's how to prepare for printing:

    After the download, the first of these pages opens automatically in your Web browser. The page itself is called 5x7index01.html (for example), and it sits in your designated Pictures folder along with the downloaded pictures themselves. (If you downloaded too many pictures to fit on one sheet, you'll also find Web page documents called 5x7index02.html, 5x7index03.html, and so on.)

    Alongside these HTML documents, however, you'll find an important file called 5x7tips.html. It's a half-page instruction sheet that explains how to set up your Web browser to correctly print these photo sheets (turn off headers and footers, turn on "Print Wide Pages," and so on).

    Once you've read these instructions and turned on your printer, you're ready to choose File [image] Print and pretend you're a one-hour photo shop.

    NOTE

    These "Format" commands never touch the actual downloaded photos. The downloaded image files themselves retain their full size and resolution.

  • Preview. As noted later in this chapter, the Preview picture-viewing program is now capable of displaying a group of pictures all at once, using a side-mounted "drawer" to display their thumbnails for easy navigation. This option opens the fresh pictures in Preview, so that you can get a better (and bigger) look at them.

  • Other. The beauty of the Image Capture system is that these post-processing commands are ordinary AppleScripts (Chapter 7). People can, in theory, write additional processing scripts. Once you've written or downloaded them, drop them into your Library [image] Image Capture [image] Scripts folder, and then enjoy their presence in the newly enhanced Automatic Task pop-up menu.

9.1.10.3 Download All, Download Some

Clicking Download All, of course, begins the process of downloading the photos to the folder you've selected. A progress dialog box appears, showing you thumbnail images of each picture that flies down the wire.

Clicking Download Some, however, opens the picture browser shown at bottom in Figure 9-5. In either a list view or a slide-sorter view, you can Shift- or [image] -click the photos you want to download, rotate, or delete from the camera.

9.1.11 Internet Connect

If you have a full-time Internet connection (cable modem, DSL, or corporate network, for example), skip this section.

Internet Connect is just for dial-up modems. It shows your current dial-up status and settings (as configured in the Network pane of your System Preferences), and provides a Connect/Disconnect button for opening or closing a connection. Here's what you can accomplish with Internet Connect:

  • Click Connect to dial out using your current modem settings.

  • Once you're hooked up, check the status display to confirm whether or not your modem successfully connected to your ISP—or if you've been disconnected.

  • You can also see your connection speed, to find out if you really connected up at 56 K (ha!), or if your modem was only able to negotiate a 28 K connection.

  • A timer shows how long you've been connected.

  • Internet Connect keeps a neat log of your connection activity (choose Window [image] Connection Log). Reading this log is about as exciting as reading random entries from the White Pages. Nonetheless, if you're having serious connection problems, it can be a useful troubleshooting tool.

  • The "Show modem status in menu bar" checkbox lets you use a menu-bar icon to dial and observe your connections—without using Internet Connect at all.

  • Internet Connect is also your gateway to the new Virtual Private Networking feature that debuts in Mac OS X 10.2, a feature that lets you tunnel into corporate networks from the road. Details are in Section 21.5.

Of course, even then, you don't really need Internet Connect to get online. If your dial-up settings are configured correctly (see Section 18.2), your Mac will automatically dial whenever you launch a program that requires one (such as Internet Explorer).

Image Capture Super-Prefs

Apple spared no expense on this baby. Lurking in the dialog box that appears when you click the Options button (shown in Figure 9-5) are some very powerful options. They're well worth exploring.

The Download Options tab, for example, is where you can set Image Capture to grab pictures automatically when you plug in the camera, saving you a click on the Download button. Here's where you specify, too, that you want to delete the photos from the camera after they've been downloaded to the Mac—another step-saving option that makes your memory card ready for more pictures. To access these settings, click the Options button shown in Figure 9-5.

The View Options tab controls the displays shown at bottom in Figure 9-5: the size of the icons in "slide-sorter" view, and which columns of information appear in the list view—date, height and width, resolution (DPI), aperture, and so on.

9.1.12 Internet Explorer

The OS X version of Microsoft's Web browser is almost identical to its predecessor, except for the new window style, buttons, and other Aqua interface features.

9.1.13 iPhoto

This remarkable (and free) new "i" program debuted in January 2002 as a worthy member of Apple's "i-apps" collection (iDVD, iMovie, iTunes, and so on). When you connect a recent-model USB camera and click Import, the program automatically sucks the pictures into your Mac, where you can rotate, crop, organize, sort, and print them. The best part may be the Share mode, where a few quick clicks turn selected photos into a Web page, printout, slide show, screen saver, desktop picture, or book. (iPhoto's book feature lets you design and order a hardbound, linen-covered, professionally printed picture book for as little as $30. It comes to you by mail in about a week.)

iPhoto is a rich, flexible program that could be the topic of its own book. In fact, it is—iPhoto: The Missing Manual.

9.1.14 iTunes

iTunes is Apple's beloved digital music-library program. (Chapter 10 tells all.)

9.1.15 Mail

Mail, the Mac OS X email program, has received a significant upgrade in version 10.2. See Chapter 19 for the whole story.

9.1.16 Preview

Preview is Mac OS X's built-in graphics viewer. When you double-click the icon of a graphics file whose "parent" the Mac can't identify (maybe something you grabbed from a Web page or imported with your digital camera), Preview takes over. It does the work of opening and displaying the image onscreen.

Preview's hallmark is its surprising versatility. It works with pictures saved in a wide variety of formats, including less commonly used formats like BMP, PNG, SGI, TGA, and MacPaint, as well as the typical JPEG, TIFF, GIF, and PICT images. Preview can even open Photoshop files and multipage PDF documents.

9.1.16.1 Converting images with Preview

Preview doesn't just open all these file formats—it can also convert between most of them. You can pop open some old Mac PICT files and turn them into BMP files for a Windows user, pry open some SGI files created on a Silicon Graphics workstation and turn them into JPEGs for use on your Web site, and so on.

All you have to do is open the file you want to convert and choose File [image] Export. In the Save As dialog box that appears, choose the new format for the image using the Format pop-up menu. (For each format, the Options button may be available. When exporting to JPEG, for example, you can choose a Quality setting. When saving TIFF files, you can turn built-in compression on or off. If the Options button is active, click it and choose the settings you want.)

Finally, click OK to dismiss the Options dialog box, and then click Save to export the file.

NOTE

While Preview understands many of the most common formats, there are a few notable exceptions. You can't open, save, or export EPS files using Preview. And while you can open GIFs, Preview can't convert files in other formats into GIF (you can thank the lawyers for that; see Section 13.9.1).

9.1.16.2 Flipping your view with Preview

Preview isn't Photoshop. It's not even AppleWorks; you won't find a single drawing or painting tool. But the toolbar (new in 10.2) and Display menu do let you perform image manipulation of the most basic kind. You can rotate an image—even a PDF document—in 90-degree increments and then flip it vertically or horizontally.

9.1.16.3 The toolbar

In Mac OS X 10.2, Preview sports its own toolbar, much like the one in the Finder, System Preferences, or Mail. Its buttons (Zoom, Rotate, and so on) duplicate the functions of the Display menu, but leave them out in the open where they're easier to find (shown in Figure 9-6).

You can have hours of fun with the new toolbar. Exactly as with the Finder toolbar, you can customize it (by choosing View [image] Customize Toolbar), rearrange its icons (by [image] -dragging them sideways), and remove icons (by [image] -dragging them downward).

TIP

Unhappy about the full inch of screen space consumed by the toolbar? No problem: You can choose from any of six different toolbar heights. The trick is to [image] -click the toolbar button (the white capsule in the upper-right corner). With each click, you cycle to the next toolbar style: large icons, small icons, no text labels, only text labels, and so on.

9.1.16.4 The Thumbnails panel

One welcome enhancement in the 10.2 version of Preview is its Thumbnails "drawer." This panel slides out from the side of the main Preview window whenever (a) you open a multipage PDF or TIFF file, or (b) you highlight a bunch of graphics files in the Finder and open them all at once. The idea is that these thumbnails (miniatures) let you navigate pages or graphics without having to open a rat's nest of individual windows. Figure 9-6 expands on the idea.

TIP

You can change the size of these miniatures by choosing Preview [image] Preferences and adjusting the slider. In the same dialog box, you'll find buttons that govern whether the Thumbnails drawer shows icons, text labels, or both.

Figure 9-6. To open or close the new Thumbnails drawer (right), click the Thumbnails icon at the left end of the toolbar. Once you've clicked a thumbnail, you can move to the next or previous one by pressing the up or down arrow keys.
9.1.16.5 Preview and PDF

You can open and read PDF files with Preview, but you won't be able to use any of the interactive features built into some PDF files—bookmarks, hyperlinks, forms, and so on. For those functions, you need to use Acrobat Reader, described earlier in this chapter.

Here's what you can do with a PDF file using Preview:

  • Save out a single page from a PDF as a TIFF file, so that you can use it in other graphics, word processing, or page layout programs—some of which might not directly support PDF. (Microsoft Word, for example, can accept TIFF graphics, but not PDFs.)

    To extract a page, use the usual File [image] Export command, making sure to choose the new file format from the pop-up menu. (If you choose a format like Photoshop or JPEG, you'll be warned that only the currently selected page of your PDF document will be converted. That's because there's no such thing as a multipage Photoshop or JPEG graphic. But you already knew that.)

  • Use [image] -left arrow and [image] -right arrow to page through a document. (Page Up and Page Down also work.) You can use the up-arrow and down-arrow keys alone to walk through the miniature images in the Thumbnails drawer, too.

  • Zoom in and out using [image] -up arrow and [image] -down arrow. You can also fit a page to the size of the window ( [image] -=), and display the PDF at actual size (Option- [image] -=).

  • Turn antialiasing (font smoothing) on or off to improve readability; just choose Preview [image] Preferences. (Though antialiased text generally looks great, it's sometimes easier to read very small type with antialiasing turned off. It's a little jaggy, but clearer nonetheless.)

  • Turn on Continuous Scrolling to scroll through multipage PDF documents in one long continuous stream, instead of jumping from page to page when you use the scroll bars.

    TIP

    Preview can even open multipage TIFF files, which is a big deal for anyone who's signed up for the free eFax service (www.efax.com). (Efax is a sensational service that provides you with a private fax number. Whenever a fax is sent to that number, you get the fax by email. As a result, you can get faxes without owning a fax machine or having a fax line, and you can get faxes even when you're traveling.)

    Either save your eFax attachments with the .tif extension, or send an email to eFax customer support with a request to have your incoming faxes tagged with the .tif extension automatically.

9.1.17 QuickTime Player

There's a lot to say about Apple's new QuickTime player, but it's all in Chapter 14.

9.1.18 Sherlock

"Sherlock" may seem like a familiar term to veteran Mac fans; for years, it's been a search program designed to help you track down files on your own system and on the Internet. In Mac OS X Jaguar, though, it's a different animal (or a different detective). Chapter 20 has the details.

9.1.19 Stickies

Stickies lets you create virtual Post-it notes that you can stick anywhere on your screen—a triumphant software answer to the thousands of people who stick notes on the edges of their actual monitors.

You can use Stickies to type quick notes and to-do items, paste in Web addresses or phone numbers you need to remember, or store any other little scraps and snippets of text you come across. Your electronic Post-its show up whenever the Stickies program is running.

These sticky notes have been a feature of the Mac OS since the days of System 7—but they've taken a quantum leap forward in Mac OS X. In the old days, the notes you created with Stickies were text-only, single-font deals (which, when you think about it, was all you really needed to type effective little notes like "don't forget to buy cabbage" or "acupuncturist @ 3 pm").

With the Mac OS X version of Stickies, however, you can use a mix of fonts, text colors, and styles within each note. You can even copy and paste pictures, movies, and sounds into your notes. By dropping PICT, GIF, JPEG, QuickTime, AIFF, whole PDF files, and other files into your notes, you can create the world's most elaborate reminders and to-do lists (Figure 9-7).

Figure 9-7. Stickies never looked like this before. Thanks to full-text formatting features and support for graphics and multimedia, even the humble to-do item can display a certain graphic sophistication in Mac OS X. No wonder Apple killed off the Scrapbook—who needs it anymore?

In a more practical vein, you can now spell-check your notes. And the Find command can search and replace text across multiple notes—ideal for tracking down stray morsels of information—without having to scan through your notes one at a time.

9.1.19.1 Creating sticky notes

The first time you launch Stickies, a few sample notes appear automatically, describing some of the program's features. You can quickly dispose of each sample by clicking the close button in the upper-left corner of each note or by choosing File [image] Close ( [image] -W). Each time you close a note, a dialog box asks if you want to save the note. If you click Don't Save, the note disappears permanently.

To create a new note, choose File [image] New Note ( [image] -N) and start typing. Besides the obvious click-and-type method, there are several other interesting ways you can add information to a note.

  • Drag text in from any other program, such as TextEdit, AppleWorks, or Microsoft Word.

  • Drag text clippings from the desktop directly into notes.

  • Drag the icon of a single-page PDF file into a note. (Stickies can't accept multipage PDF files.)

  • Choose File [image] Import and select any plain text file or RTF (Rich Text Format) document to bring them into a note.

  • Drag a PICT, GIF, JPEG, or TIFF file into a note to add a picture. Or drag a sound or movie in. (A message will ask if you're sure you want to copy the whole whomping QuickTime movie into a little Stickies note.)

  • Drag URLs into a note directly from Internet Explorer's Address Bar.

  • In TextEdit, Mail, or other Carbon applications, select a chunk of text and then choose TextEdit [image] Services [image] Make Sticky. This command launches Stickies, creates a new note, and fills it with your selected text—all in one step.

    TIP

    Have a favorite style for your sticky notes? First create a new note, choosing the color and text style that you like and setting it to the size you prefer. Then choose Note [image] Use as Default. All new notes you create will now appear in the size, font, and color of your choice.

9.1.19.2 Growing and shrinking notes

Once you start plastering your Mac with notes, it doesn't take long to find yourself plagued with desktop clutter. Fortunately, Stickies includes a few built-in tricks for managing a deskful of notes:

  • There's a small resize handle on the lower-right corner of each note. Drag it to make notes larger or smaller on screen.

  • Use the small triangle in the upper-right corner of each note to zoom and shrink note windows with a single click. The first click collapses a note down to a more compact size. Another click pops the note back open to normal size.

  • The best option: Double-click anywhere along the dark strip at the top of each note to miniaturize it into a compact one-line mini note, as shown in Figure 9-8. You also can miniaturize a selected note by choosing Window [image] Miniaturize Window ( [image] -M).

  • If your notes are scattered randomly across the desktop, you can line them all up in a neatly ordered cascading stack by choosing Window [image] Arrange in Front. This works especially well if you keep your notes minimized, as suggested in the previous paragraph. The Arrange in Front command gathers up the minimized notes and stacks them at the center of the screen.

    TIP

    The most efficient way to use Stickies is to keep the notes in their miniaturized state, as shown in Figure 9-8. When a note is miniaturized, the first line of text shows up in tiny type right in the collapsed title bar of the note, so you don't have to expand the note to remember what's in it. And since many—if not most—of your notes can probably be summed up in a couple of words ("pick up dry cleaning," "call Mom"), it's perfectly possible to keep your sticky notes in their miniaturized state permanently.

Figure 9-8. If the first line of text gets truncated, as in the third note shown here, you can tug the right corner of the note and drag it wider without de-miniaturizing it.
9.1.19.3 Formatting notes

Stickies has several word processor-like commands for creating designer sticky notes, with any combination of fonts, colors, and styles. (You can also choose from six background colors from the Color menu.) For the full scoop on Mac OS X's Font panel, choosing colors, and using the Copy Font command, see Section 13.6.3.

9.1.19.4 Saving sticky notes

The notes you create in Stickies last only as long as you keep them open. If you close a note to get it out of the way, it vanishes permanently.

TIP

If you accidentally close a note that contains information you need, you have one chance to recover it: promptly choose Edit [image] Undo Close Window. It brings the recently closed note back from oblivion.

If you want to preserve the information you've stuffed into your notes in a more permanent form, use File [image] Export Text to save each note as a stand-alone TextEdit document. When you use the Export Text command, you have the following options:

  • Plain Text. This option saves the contents of your note as a plain text file, with neither formatting nor pictures.

  • RTF stands for Rich Text Format, a special format recognized by most word processors (including AppleWorks and Microsoft Word) that preserves most formatting, including font, style, and color choices. You can open the resulting RTF file in just about any word processor with all of your formatting still intact.

  • RTFD. RTFD, a strange and powerful variant of RTF, is a Rich Text Format document with attachments. How do you "attach" items to an RTFD file? Drag the icon of an actual application (Clock, Calculator, or whatever) or a multipage PDF file, into a sticky note. The icon for the program or document appears in the note, but double-clicking the icon doesn't do anything. When you export the note as an RTFD file, the result is a TextEdit document that has embedded within it the entire program or document that you dragged in. The program icon appears just as it did in the sticky note, but if you double-click it, the program now actually launches. (For more about RTFD files, see Plain Text vs. Rich Text.)

    You can also paste a graphic into your sticky note. When you export the note, the resulting package file will include a graphics file of the format that you pasted.

    If you don't have embedded programs or documents in your notes, then exported RTFD files are exactly the same as their RTF counterparts.

  • Save as Stationery. This checkbox, available whenever you export a note, lets you save a note that can serve as a template (complete with formatting and even text or graphics) for new notes in the future. So, for example, if you wanted to regularly post a note that had the heading "This Week's Shopping List," you could create a stationery sticky and thus avoid typing those words into a new note each week.

    Mac OS X saves Stickies stationery with a .tpl file name extension. To use the template, choose File [image] Import Text, and then choose the .tpl file. (You can't double-click on a Stickies stationery document to create a new note.) You get a fresh, new note containing whatever was in the template. (Unfortunately, a Stickies stationery document stores a note's text and font style, but not its color, size, or shape.)

    TIP

    You can import the Stickies file from your old Mac OS 9 System Folder. Just choose File [image] Import Classic Stickies. In the Open File dialog box, navigate to the old System Folder [image] Preferences [image] Stickies File document and open it.

Kenneth, Where Are the Stickies?

In the days of Mac OS 9, it was easy to find the file that actually stored the text of your Stickies. It was called Stickies File, and it sat right there in your System Folder [image] Preferences folder. Because you could see it, you could back it up, copy it when you bought a new Mac, email it to other people, or whatever.

In Mac OS X through version 10.1.5, the Stickies note database was in your Home [image] Library folder, but it wasn't worth looking for. The Stickies file was invisible, thanks to the period that began its name (.StickiesDatabase). If you wanted to see it, you had to resort to tricks like turning on the "Show hidden and system files" checkbox of TinkerTool 2, a free program described in Section 17.1. Only then could you see your .StickiesDatabase file—and copy it anywhere you like.

Fortunately, 10.2 makes all of that unnecessary. The Stickies file is still in your Home folder [image] Library folder, but it's no longer invisible (and it no longer starts with a period). It's just sitting there out in the open. You're free to copy it, pass it along, and so on, just as you would any old file.

Make that 151 new features in Jaguar, Apple!

9.1.19.5 Stickies Services

Several of Mac OS X's Services—basic features that can be shared by any Mac OS X program, as described in Section 4.7.3—have special relevance in Stickies. To see the options (described below), open the Stickies [image] Services submenu.

  • Grab. Using the various Grab commands, you can capture a screenshot (either the whole screen, or a selected portion of it) and plug it directly into a note in one step. (For details on creating these screenshots, see Section 9.2.15.)

  • Mail. The Send Selection command launches the Mail program, creates a new email message, and then pastes whatever text you had selected in a sticky note directly into the Message box.

    Or, if you've highlighted an email address in a sticky note, use the Mail To command. Watch as your Mac automatically creates a new email message in Mail and fills in the "To" field with the selected address.

    NOTE

    You must have some sticky-note text selected to use the Mail, Summarize, and TextEdit services listed in the Stickies menu. Otherwise, those commands are dimmed out.

  • Speech. How nice to have somebody read out loud to you—especially when it's your own Sticky! (Choose the voice in the Speech panel of System Preferences.)

  • Summarize. Select text in a note and choose Summarize. You get a new text document containing a condensed, summarized version of your note, created by a program called Summary Service (see Section 4.7.3).

  • TextEdit. Here's the easiest way to turn a sticky note into a real double-clickable document. Select the contents of the note and then choose Stickies [image] Services [image] TextEdit [image] Open Selection. Mac OS X instantly turns your selection into a new TextEdit document ready to be saved.

The Hidden Stickies Commands

The casual Stickies user may miss some of the program's more interesting commands, which are accessible only through the contextual menus that pop up when you Control-click a sticky note. Here's what you'll find only in the contextual pop-up menus:

Check Spelling As You Type. Turning on this spell-check option flags misspelled words the moment you type them. You must turn this option on or off for each individual note—not for the Stickies program in general.

Font underlining. For some reason, you can format text with underlining using only the contextual pop-up menu, not the regular Note menu. (Bold and italic, however, are available from both menus.)

Speech. Don't just read your notes—listen to them. You can use the Mac's Text-to-Speech feature to hear your notes read aloud. Choose Speech [image] Start Speaking to hear the Mac read a selected portion of a note, or use the command with nothing selected to hear the entire contents of a note. The only way to stop the speech is to Control-click again and choose Speech [image] Stop Speaking.

(To pick the voice and speed of the reader, go to the Speech pane of System Preferences, as described in Section 14.5).

The Speech commands are available in the Stickies [image] Services [image] Speech submenu, too, but the contextual-menu route is far more direct than opening a sub-sub-submenu.

9.1.20 System Preferences

This program opens the door to the very nerve center of Mac OS X's various user preferences, settings, and options. Chapter 8 covers every option in detail.

9.1.21 TextEdit

TextEdit is a word processor—a basic one, to be sure, but capable of creating real documents with real formatting. (There's even a multiple-level Undo command.) If you had to, you could write a novel in TextEdit and it would look pretty decent.

TextEdit also has some surprising hidden power. For example, you can open up HTML documents with TextEdit in two different modes. In one mode, TextEdit interprets the HTML and displays it just like a Web browser; in the other, it opens the file as plain text so that you can edit the source code.

TIP

TextEdit recognizes some of the very same keyboard shortcuts found in Microsoft Word. For example, you can advance through documents one word at a time by pressing Option-left arrow or Option-right arrow. Adding the Shift key to those key combinations lets you select one whole word at a time. You can also use the Control or [image] key in conjunction with the right and left arrow keys to jump to the beginning or end of a line.

Plain Text vs. Rich Text

TextEdit can create documents of two types: rich text and plain text. It's important to understand the difference.

Plain text is just what it sounds like: plain, unformatted text. In a plain text document, there are no font attributes, no bold or italic styles, no margins, no hanging indents, no formatting of any kind—just plain text. A text file usually has a three-letter .txt file name extension.

In rich text mode, TextEdit saves documents as RTF (Rich Text Format) files, complete with font, style, color, paragraph alignment, and other formatting, or—if you've pasted in graphics—RTFD files. Any word processor can open the resulting files (which are saved with an extension of .rtf or .rtfd at the end of their names).

9.1.21.1 Setting up TextEdit

When you first launch TextEdit, it's not very impressive. You see a blank, untitled document with neither a toolbar nor margins. It looks like a nearly useless text editor.

To unleash the program's full potential as a word processor, set things up like this:

  • Choose Format [image] Wrap to Page. Now you'll see the actual width of your page, with visible margins—just as in a real word processor. (The default Wrap to Window mode is a marginless view in which your text reflows to fill the width of the window.) Wrap to Page view also produces a Zoom menu in the lower-right corner of each window with ten different levels of magnification.

  • Turn on the text ruler. If you don't see a ruler at the top of the window, choose Format [image] Text [image] Show Ruler ( [image] -R). Now the ruler appears, complete with all the standard tools for setting margins, indents, tabs, line spacing, and paragraph alignment. It works almost exactly like the rulers you'd find in Microsoft Word or AppleWorks (Figure 9-9).

  • Fire up the spell-checker. Check to make sure that the Edit [image] Spelling [image] Check Spelling As You Type command is turned on, if you like. This is interactive spell-checking. It works just as it does in Microsoft Word and other word processors; that is, misspelled words get flagged with a dashed red line the moment you type them.

Now you've got something that's starting to look and act like a real word processor. But before you start typing away, pay a visit to TextEdit [image] Preferences to set up some other important TextEdit options.

TIP

To open and work with a Microsoft Word or AppleWorks document in TextEdit, with formatting intact, export it from Word or AppleWorks as a Rich Text Format file.

Figure 9-9. The text ruler gives you control over tab stops, line spacing, paragraph justification, and so on. Pressing -R makes it appear and disappear. The two little padlock icons lock or unlock fixed line spacing, which controls whether or not a pasted graphic or a super-big typed character will be allowed to spread the paragraph lines farther apart.
9.1.21.2 The TextEdit Preferences

Most of the settings in the TextEdit Preferences window have no effect on documents that are already open—only on documents you open or create from now on. Most of the settings are self-explanatory; nonetheless, handy explanatory balloons appear if you point to an option without clicking. Here are a few settings that may not be immediately clear:

  • New Document Font. If Helvetica 12 doesn't especially float your boat, you can change TextEdit's starting font. Note that you can set two default fonts—one for Rich Text documents and another one for Plain Text files.

    NOTE

    By definition, plain text files don't have any formatting. So whatever font you choose here for Plain Text files is for your editing pleasure only. If you plan to send the file to anyone else, remember that the font choice won't be saved with the document.

  • New Document Format. Change this to Rich Text, with the Wrap to Page checkbox turned on, so that any new documents you create will appear in page-layout view.

  • New Window Size. These settings have no effect unless you're in Wrap to Window mode. If you are in Wrap to Window mode, then these dimensions determine the size of the window that appears each time you create a new TextEdit document.

  • Saving. Most of these preferences affect what happens when you open a read-only file (such as a Read Me file), make changes, and then save it again. It's a good idea to keep the last option turned on, so that text files you create with TextEdit are automatically saved with a .txt extension, which makes it easier to exchange files with Windows users.

  • Plain Text Encoding. These settings reconcile the slightly different character sets (alphabets) that may be used by different operating systems to represent plain text. Keep these settings on Automatic and forget about them. In almost every case, TextEdit will select the right encoding system based on the contents of the file.

  • Rich Text Processing. When you keep these settings turned off, TextEdit opens and displays HTML documents as though it's a Web browser, interpreting the tags to render a fully formatted page. It handles RTF documents the same way, interpreting the behind-the-scenes tags that indicate the font faces, colors, styles, and so on. But if you turn on the Ignore checkboxes, TextEdit doesn't interpret the HTML or RTF tags. Instead, it opens these files as plain text, so that you can view the raw "source" inside them (see Figure 9-10).

Figure 9-10. Here's the same Web page as seen by TextEdit in its default mode (left), and in its "Ignore rich text commands" mode, which lets you edit the raw source code. You can choose the mode you want on the fly each time you open a file: Just turn on or off the "Ignore rich text commands" option right in the Open dialog box.

Case of the Disappearing Ruler

It could happen to you. All of a sudden, your whole document switches to an ugly font, you can't change any of the formatting, and the Show Ruler command is dimmed out. What's gone wrong?

You've accidentally thrown yourself into Plain Text mode, which ignores all that formatting stuff. Font styles, paragraph attributes, and the text ruler are only available when you create a rich text document. In all likelihood, you inadvertently hit Shift- [image] -T, the keystroke that toggles between Plain Text and Rich Text modes.

You can remedy the situation by pressing Shift- [image] -T again, or by choosing Format [image] Make Rich Text. You might also want to double-check the TextEdit Preferences to make sure the New Document Format is set to Rich Text, too.

9.1.21.3 Formatting documents in TextEdit

Considering it's a free program that Apple tossed in primarily for opening Read Me files, TextEdit has a surprisingly good selection of real formatting tools:

  • In the Format [image] Font submenu are the standard commands for applying Bold, Italic, and Underline styles to selected text.

  • To change a font, or font size, press [image] -T or choose Format [image] Font [image] Font Panel to open up the standard Mac OS X Font panel (Section 13.6.3).

  • Common paragraph-alignment options—Align Left, Align Right, Center, Justify—are all available in Format [image] Text submenu.

  • You can easily add graphics to a TextEdit file by dragging or pasting pictures directly into a document. The program understands TIFF, PICT, JPG, and GIF formats.

9.1.21.4 TextEdit's other writing tools

TextEdit includes a couple of other very useful document-editing tools:

  • Allow Hyphenation. When you select this command from the Format menu, TextEdit breaks up words by syllable and inserts hyphens when necessary in order to create more visually pleasing line breaks.

    TIP

    It's especially important to turn this feature on if your paragraph alignment is set to Justify, or if you create narrow columns of text. If hyphenation is turned off, TextEdit won't break up whole words at the end of a line—even if it leaves big, ugly white gaps between words.

  • Make Read Only. When you turn this option on (again, in the Format menu), you're locked out. You can select and copy text to your heart's content, but you can't change anything. Read Only mode can be useful if you want to prevent yourself from making accidental changes to a file, but it's not much of a security feature. (All anyone has to do is choose Format [image] Make Editable to regain full editing privileges.)

  • Spell Checking. As mentioned earlier, TextEdit can check spelling as you type, flagging questionable words with red underlining. To open the full Spelling panel at any time, choose Edit [image] Spelling [image] Spelling (or press Shift- [image] -;). Using the panel, you can correct errors (choosing from the suggestions generated by Apple's built-in spelling dictionary) or tell TextEdit to learn or ignore other suspected misspellings.

    However, the quickest way to handle spelling corrections is shown in Figure 9-11.

  • Find and Replace. No self-respecting word processor would be complete without a good find-and-replace command. Choose Edit [image] Find [image] Find Panel ( [image] -F) to search for and replace text in TextEdit documents.

    TIP

    One command worth learning is Edit [image] Find [image] Use Selection for Find (or [image] -E). Instead of having to type words into the Find field, this command searches for the next occurrence of whatever text you've already selected in your document, without even opening the Find Panel. Select one occurrence of the word you want to look for, press [image] -E, and then press [image] -G to jump to each new occurrence of that word.

Figure 9-11. You're never more than a Control-click away from more accurate spelling in TextEdit. Control-click on a questionable word; the suggestions of Apple's built-in dictionary appear right in the contextual pop-up menu, along with the Learn and Ignore commands.

Advanced Typography in TextEdit

If you just sprayed your coffee upon reading the heading of this sidebar, you're forgiven. Advanced typography in TextEdit? Isn't that a little bit like saying, "page layout in SimpleText or Note Pad"?

Not at all. Apple designed humble TextEdit to be more than a Read Me file-opening machine. It's also a showcase for Mac OS X's typographical smarts.

Most of the commands in the Format [image] Font submenu should be familiar to you: Bold, Italic, Underline, and so on. But a few were once found only in expensive page-layout programs like PageMaker and QuarkXPress. For example:

Kern. Use these commands, such as Tighten and Loosen, to nudge the letters of the selected text closer together or farther apart—an especially useful feature when you're fiddling with headlines and headings.

There are no controls to set how much you want to kern the text, but you can apply these commands repeatedly to the same text selection to intensify them. If you want your text to be very tight, for example, just keep choosing the Tighten command. The characters will creep closer and closer together until they crash into each other.

Ligature. Ligatures are letter pairs, such as fl and ff, that, in fancy typesetting, are often conjoined into special combination characters, as shown here. If you choose Format [image] Font [image] Ligature [image] Use Default (or Use All) TextEdit will display these letter pairs with the appropriate ligatures. (This works only if the font you're using has those ligatures built into it. New York, Charcoal, Apple Chancery, and Adobe Expert fonts do, for example, but many other fonts don't.)

Baseline. The baseline is the imaginary "floor" for text characters in a line of type. You can push text above this line or sink it below the baseline using the Raise and Lower commands in the Baseline submenu. The Superscript and Subscript commands, meanwhile, shift characters far above or below the baseline, so you can write stuff like H203.

Character Shape. In a few fonts, such as Adobe Expert fonts, this submenu offers a choice between Traditional Form and specialized type treatments like Small Caps.

Copy Font/Paste Font. Once you've formatted some text using all these elaborate formatting controls, it would be a shame to have to spend time formatting another passage the same way. Fortunately, these commands let you copy and paste just the font formatting to other text in your document—the font, color, style, and size, but none of the actual text or paragraph attributes, such as alignment. This process is especially quick and easy if you use the keyboard shortcuts: -3 to copy selected font attributes and [image] -4 to paste them.

Copy Ruler/Paste Ruler. Just like Copy Font and Paste Font, these commands transfer attributes from one paragraph to the next. But the attributes they transfer are the margins, indents, tab stops, and line-spacing settings indicated on TextEdit's text ruler. Font, color, and style settings are unaffected. (To speed things up, you can press [image] -1 to copy ruler settings and [image] -2 to paste them.)


9.2 Utilities: Your Mac OS X Toolbox

The Utilities folder (inside your Applications folder) is home to another batch of freebies: another couple dozen tools for monitoring, tuning, tweaking, and troubleshooting your Mac.

The truth is, though, that you're likely to use only about six of these utilities. The rest are very specialized gizmos primarily of interest only to network administrators or Unix geeks who are obsessed with knowing what kind of computer-code gibberish is going on behind the scenes.

9.2.1 AirPort Admin Utility

Don't even think about this program unless you've equipped your Mac with the hardware necessary for Apple's wireless AirPort networking technology. (That entails installing a $100 AirPort card in your Mac and attaching a base station, as described in Chapter 12.)

Even then, you don't use the AirPort Admin Utility to set up AirPort connections for the first time. For that task, use the AirPort Setup Assistant (described below), which takes you gently by the hand and guides you through the steps involved in hooking up a wireless network connection.

After you're set up, you can use AirPort Admin Utility to monitor the connections in an existing AirPort network. (You can also use this utility to set up new connections manually, rather than using the step-by-step approach offered by the Assistant.)

Files within Files within Files

It's no surprise that you can include formatted text and pictures in a TextEdit document, but here's a shocker: You can also embed an entire program or document within a TextEdit file.

Try this experiment: Create a new TextEdit document in Rich Text mode. Drag the icons from a couple of programs into the TextEdit document. Do the same with some documents that were created using native Mac OS X programs (another TextEdit document, for example).

When you save the file, Mac OS X saves embedded copies of the applications and documents you dragged into the TextEdit document itself. (The TextEdit file is saved in a format called RTFD, which is a Rich Text Format document with attachments.)

Once you've saved the file, you can double-click any of the icons in the file to launch the embedded items. In the TextEdit document shown here, you could launch the Clock, Chess, DVD Player, and Mail programs—all right from within the file.

To make things even wilder, it's possible to drag a TextEdit file containing embedded items into another TextEdit file, saving a file within a file within a file.

One important point to keep in mind: The double-clickable icons you create in TextEdit using this method are not aliases or links to your original documents and programs. They're actual, full copies. If you make changes in the original document, they won't be reflected in the copies embedded in the TextEdit file. And if you embed a 10 MB program into a TextEdit document, you'll end up with a 10 MB TextEdit file!

9.2.2 AirPort Setup Assistant

An Assistant, in Apple-ese, is an interview program. It presents a series of screens, posing one question at a time; after answering each question, you're supposed to click the right-arrow (or Next) button. At the end of the interview, the Assistant program incorporates your answers into a finished product—such as configuring numerous System Preferences all at once.

The AirPort Setup Assistant is the screen-by-screen guide that walks you through the steps needed to set up and use AirPort wireless networking. You'll be asked to name your network, provide a password for accessing it, and so on. When you've followed the steps and answered the questions, your AirPort hardware will be properly configured and ready to use.

9.2.3 Apple System Profiler

Apple System Profiler is a great tool for learning exactly what's installed on your Mac and what's not—in terms of both hardware and software. Does your PowerBook's chip run at 700 MHz or 866 MHz? Does your G4 tower have any open slots for extra RAM? What percentage of your external hard drive is filled up? Want a comprehensive list of every program installed on your Mac, with version numbers?

The Apple System Profiler (ASP) answers all those questions. It combs through your system software, performing a quick analysis of every piece of hardware plugged into your machine and every program installed, and produces a neat, printable report on what it finds. The people who answer the phones on Apple's tech-support line are particularly fond of Apple System Profiler, since the detailed information it reports can be very useful for troubleshooting nasty problems. If you call for tech support, be ready to run it.

TIP

Instead of burrowing into your Applications [image] Utilities folder to open System Profiler, it's usually faster to use this trick: Choose [image] [image] About This Mac. In the resulting dialog box, click the More Info button. Boom—Apple System Profiler opens.

When you launch Apple System Profiler, it reports information about your Mac on a series of tabbed panels (Figure 9-12).

  • The System Profile panel is divided into four sections. First, you get to see precisely which version of Mac OS X you have. Next, you see the exact specs of your Mac model: its serial number, how much RAM it has, and its processor chip(s) and speed. The third section reports which memory slots are filled and the size of the memory module in each slot—details that save you from having to stick your fingers into your Mac's case to find out what's in there.

    Finally, the Network section reveals which kind of network your Mac is on and, if you have a networkable printer, which printer is selected.

  • The Devices and Volumes panel shows every disk (including every partition of each disk) attached to your Mac: hard drive, CD-ROM, Zip drive, and so on, along with its SCSI, USB, FireWire, or ATA connection, size, and other specs.

  • The next panel, Frameworks, reveals the version numbers of the core software chunks that drive your Mac and that are shared by the various programs you run. (The software chunks that actually provide these services are stored on your hard drive in System [image] Library [image] Frameworks. They resemble the interchangeable software parts known as shared libraries in the old Mac OS.)

    For example, you see frameworks listed here for AudioToolbox, Speech Recognition, Navigation Services, CoreGraphics, and other software modules that your applications may need.

  • Similar information shows up in the Extensions panel. In this sense, "extensions" doesn't mean system extensions like those that made life a living hell in Mac OS 9 and earlier. In Mac OS X, the term extensions refers to a different kind of add-on component to the core system software: generally, drivers for the Mac's various components, which sit in the System [image] Library [image] Extensions folder. The contents of the Extensions folder is what you see listed in this panel.

  • The Applications screen displays a list of every program on your system, with version information—a quick inventory of what you've installed on your Mac. It's great for spotting duplicate copies of programs.

  • Finally, the Logs panel reveals your Mac's secret diary: a record of the traumatic events that it experiences from day to day. Most of the flippy triangles open to reveal crash logs, which are detailed technical descriptions of what went wrong when various programs crashed, and what was stored in memory at the time.

    Unfortunately, there's not much plain English here to help you understand the crash, or how to avoid it in the future. Most of it runs along the lines of "Exception: EXC_BAD_ACCESS (0x0001); Codes: KERN_INVALID_ADDRESS (0x0001) at 0x2f6b657d." In other words, it's primarily for the benefit of programmers. Still, tech-support staff may occasionally ask to see the information in one of these logs, as described next.

Figure 9-12. ASP is listed hierarchically. You can click the flippy triangles to reveal more or less detail. When the triangle is "closed," you see only the name of a device. Flip it down to see the manufacturer, version number, and other details.
9.2.3.1 Saving a report

To create a report that you can print or save, choose File [image] Save As. Then choose the file format you want for it: native ASP document (openable only with Apple System Profiler), Rich Text document (which technically can contain formatting, although ASP doesn't generate any), or Plain Text document (which any word processor or text editor can open).

Note, however, that the resulting report can be well over 100 pages long. In many cases, you're better off simply dragging through some information on one of the ASP screens, and then dragging (or copying and pasting) the selection into a waiting word processor.

9.2.4 Asia Text Extras

Talk about niche markets: The tools in this folder are exclusively for designers of Asian fonts. The Chinese Text Converter utility, for example, converts documents between Simplified Chinese and Traditional Chinese character sets.

These tools aren't of any value to you unless (a) you've turned on the Chinese input method on the International panel of System Preferences, and (b) you have a clue what you're doing.

9.2.5 Audio MIDI Setup

Maybe you've heard that Mac OS X comes with spectacular internal wiring for music, sound, and MIDI (Musical Instrument Digital Interface, a standard "language" for inter-synthesizer communication). Or maybe not, given that even as late as the fall of 2002, only one music software company had rewritten its wares to capitalize on these new tools.

But even if the wheels of progress spin slowly for Mac musicians, at least they're starting to turn. This little configuration program is proof.

It offers two tabs. The first, Audio Setup, Audio Devices, is the master control panel for all your various sound inputs and outputs: microphones, line inputs, external speakers, and so on. Of course, for most people, this is all meaningless, because most Macs have only one input (the microphone) and one output (the speakers). But if you're sitting even now in your darkened music studio, humming with high-tech audio gear whose software has been designed to work with this little program, you're smiling.

The second tab, MIDI Devices, should look familiar to synthesizer fans who have used software like OMS or FreeMIDI to teach the Mac about their studio configurations. By clicking Add Device, you create a new icon that represents one of your pieces of gear. Double-click the icon to specify its make and model. Finally, by dragging lines from the "in" and "out" arrows, you teach your Mac (and its MIDI software) how the various components are wired together.

At least that's what you'll do someday, once you've found, and bought, music software that understands Apple's new protocols.

9.2.6 Bluetooth File Exchange

One of the luxuries of equipping your Mac with Apple's $50 Bluetooth adapter is the ability to shoot files (to similarly forward-thinking colleagues) through the air, up to 30 feet away. Bluetooth File Exchange makes it possible, as described in Section 6.2.5.

9.2.7 ColorSync Utility

This "bet-you'll-never-touch-it" utility performs a fairly esoteric task: repairing ColorSync profiles that may be "broken" because they don't strictly conform to the ICC profile specifications. (ICC [International Color Consortium] profiles are part of Apple's ColorSync color management system, as described in Section 13.8.)

If you happen to use ColorSync (because you're in the high-end color printing business, for example), and a profile for your specific monitor or printer doesn't appear in the ColorSync panel of System Preferences when it should, this is the tool you need to fix it.

You can also use the ColorSync Utility to see and review all the ColorSync profiles installed on your system. In the main ColorSync Utility window, click the Profiles icon at the top of the window to see a list of all available profiles, or the Devices icon for profiles associated with specific printers, scanners, and so on. The area on the right side of the window displays information about each ColorSync profile you select from the list on the left.

9.2.8 Console

Console is a magic window that peels back the layers of the Mac OS X interface and shows you what's happening under the hood of your Mac as you go about your business. Its function is to record a text log of all the internal status messages being passed between the Mac OS X and other applications as they interact with each other.

Opening the Console log is a bit like stepping into an operating room during a complex surgery; you're exposed to stuff the average person just isn't supposed to see. (Typical Console entries: "kCGErrorCannotComplete" or "doGetDisplay TransferByTable.") You can adjust the font and word wrapping using Console's Format menu, but the truth is that the phrase "CGXGetWindowType: Invalid window -1" looks ugly in just about any font.

Console isn't useless, however. These messages can be of great value to programmers who are debugging software or troubleshooting a messy problem.

9.2.9 CPU Monitor

CPU Monitor, another techie tool, lets you see how much of your Mac's available processing power is being tapped at any given moment. Think of it as an electrocardiogram for your Mac.

Launch CPU Monitor so that the thermometer-like Monitor window is open. Then go about your usual Mac business: Launch a few programs, drag a playing QuickTime movie across the screen, or play a game. You'll see the level on the monitor rise and fall, depending on how busy you're keeping the CPU. On multiple-processor Macs, you see a different bar for each chip, enabling you to see how efficiently Mac OS X is distributing the work among them.

CPU Monitor actually offers three different ways of displaying the monitor readout, as explained in Figure 9-13. If you choose CPU Monitor [image] Preferences, you can customize the various monitor panels in a number of ways, changing the colors and other attributes.

TIP

To keep your eye on your Mac's activity without taking up additional space onscreen, open CPU Monitor [image] Preferences [image] Application Icon, and turn on one of the first two radio buttons. This replaces the icon that appears in the Dock when CPU Monitor is running with a live readout showing the CPU load as you work.

Figure 9-13. Top: The three faces of CPU Monitor. The unobtrusive floating view (left) hovers over your desktop and can be turned semi-transparent in the Preferences window. The Standard view (middle) provides a single level indicator. The Extended view (right) uses different colors to represent different processes and can be stretched to any size. Bottom: The CPU Monitor icon can be set to display moment-by-moment CPU activity right in the Dock.

9.2.10 DigitalColor Meter

With the DigitalColor Meter, you can grab the exact color value of any pixel on your screen, which can be helpful when matching colors in Web-page construction or other design work. After launching the DigitalColor Meter, just point to whichever pixel you want to measure, anywhere on your screen; a magnified view appears in the meter window, and the RGB color value of the pixels appears in the meter window. You can display the color values as RGB percentages or absolute values, or in Hex form (which is how colors are defined in HTML; white is represented as #FFFFFF, for example).

Here are some tips for using the DigitalColor Meter to capture color information from your screen:

  • To home in on the exact pixel (and color) you want to measure, drag the Aperture Size slider to the smallest size—one pixel. Then use the arrow keys to move the aperture to the precise location you want.

  • Press Shift- [image] -C (Color [image] Copy Color) to put on the Clipboard the numeric value of the color you're pointing to.

  • Press Shift- [image] -H (Color [image] Hold Color) to "freeze" the color meter on the color you're pointing to—a handy stunt when you're comparing two colors onscreen. You can point to one color, hold it using Shift- [image] -H, and then move your mouse to the second color. Pressing Shift- [image] -H again releases the hold on the color.

  • When the Aperture Size slider is set to view more than one pixel, DigitalColor Meter measures the average value of the pixels being examined.

9.2.11 Directory Access

If you use your Mac at home, or if it's not connected to a network, you'll never have to touch Directory Access. Even if you are connected to a network, there's only a remote chance you'll ever have to open Directory Access—unless you happen to be a network administrator, that is.

This administrative utility controls the access that each individual Mac on a network has to Mac OS X's directory services—special databases that store information about users and servers. Directory Access also governs access to LDAP directories (Internet- or intranet-based "white pages" for Internet addresses).

A network administrator can use Directory Access to do things like select NetInfo domains, set up search policies, and define attribute mappings. If those terms don't mean anything to you, just pretend you never read this paragraph and get on with your life.

9.2.12 Disk Copy

This program creates and manages disk images, electronic versions of disks or folders that you can send electronically to somebody else.

The world's largest disk-image fan is Apple itself; the company often releases new software in disk-image form. A lot of Mac OS X add-on software arrives from your Web download in disk-image form, too, as described in Section 4.8.2. Disk images are popular for software distribution for a simple reason: Each file precisely duplicates the original master disk, complete with all the necessary files in all the right places. When a software company sends you a disk image, it ensures that you'll install the software from a disk that exactly matches the master disk.

It's important to understand the difference between a disk-image file and the mounted disk (the one that appears when you double-click the disk image). Figure 9-14 makes the distinction clear.

TIP

After you double-click a disk image, go ahead and click Skip in the verification box that appears. If something truly got scrambled during the download, you'll know about it right away—your file won't decompress correctly, or it'll display the wrong icon, for example.

In fact, you can make Disk Copy always skip that verification business, which is a relic from the floppy-disk days. To do so, choose Disk Copy [image] Preferences, click the Verifying tab, and turn off Verify Checksums.

Figure 9-14. The usual life cycle of a disk-image file: First, you download it from the Internet. The result is an icon whose name usually ends in .img or .dmg (upper left). (Files that end with .smi are also disk images, but self-mounting ones that don't require Disk Copy.) Second, when you double-click this icon, Disk Copy creates an icon that simulates a new disk (upper right). Finally, when you double-click this icon, you see exactly what the original creator of the image wanted you to see (bottom).
9.2.12.1 Fun with Disk Copy

You may not even be aware that Disk Copy is involved when you double-click a disk image to open it. You may be even less aware that you can create disk images, too. Doing so can be very handy in situations like these:

  • You want to create a backup of an important CD. By turning it into a disk-image file on your hard drive, you'll always have a safety copy, ready to burn back onto a new CD. (This is an essential practice for educational CDs to be handled by children.) The procedure for doing this appears below.

  • You bought a game that requires its CD to be in the drive at all times. Most programs like these run equally well off of a mounted disk image that you made from the original CD.

  • You want to send somebody else a copy of a CD via the Internet. You simply create a disk image, and then send that—preferably in compressed form.

To make a disk image, proceed as follows:

  1. Choose File [image] New [image] Image from Device.

    That's how you'd start if you wanted to turn a disk into an image—a CD or Zip, for example. To make an image from a folder or a disk partition instead, choose File [image] New [image] Image from Folder or Volume.

    TIP

    Control-click the Dock icon for Disk Copy (or just hold your mouse down on it and wait) to open a handy pop-up menu of shortcut commands. Choosing New Image from Device this way requires less mouse-gymnastic ability than choosing File [image] New [image] Image from Device in this step.

    Either way, the Device Selector dialog box appears. It lists the disks currently in, or attached to, your Mac. Unfortunately, they're listed a tad cryptically. You don't get to see their names—only their Unix ID numbers and types ("hard drive," "CD-ROM," or whatever). Still, you should be able to figure out which one is the disk you want by examining their descriptions and capacity listings ("250 MB" is probably a Zip disk, for example).

  2. Click the disk you want to copy. Click the Image button (or press Enter).

    In the next dialog box, you're offered some fascinating options.

  3. From the Image Format pop-up menu, choose the format you want to use for your disk image.

    If you choose "read/write," your disk image file, when double-clicked, will turn into a superb imitation of a hard drive. You'll be able to drag files and folders onto it, drag them off of it, change icons' names on it, and so on.

    If you choose "read/only," however, the result will behave more like a CD. You'll be able to copy things off of it, but not make any changes to it.

    The "compressed" option is best if you intend to send the resulting file by email, for example, or if you'd like to preserve the disk image on some backup disk for a rainy day. It takes a little longer to create a simulated disk when you double-click the disk image file, but it takes up a lot less disk space than an uncompressed version.

    Finally, choose "DVD/CD master" if you're copying a CD or a DVD. The resulting file is a perfect mirror of the original disc, ready for copying onto a blank CD or DVD when the time comes.

  4. If privacy is important, open the Encryption pop-up menu and choose "AES-128 (recommended)."

    Here's a great way to lock private files away into a vault that nobody else can open. In one of the next steps, you'll be asked to assign a password to your new image file. Nobody will be able to open it without the password—not even you. Furthermore, if you save it into your Keychain (Section 12.6), it won't be such a disaster if you forget the password.

  5. Choose a name and location for your new image file.

    The name you choose here doesn't need to match the original disk or folder name.

  6. Click Save (or press Enter).

    If you opted to create an encrypted image, you'll be asked to make up a password at this point.

    When you press Enter, Disk Copy creates the image and then mounts it—that is, turns the image file into a simulated, yet fully functional, disk icon on your desktop.

When you're finished working with the disk, eject it as you would any disk (Control-click it and choose Eject, for example). Hang onto the .dmg disk image file itself, however. This is the file you'll need to double-click if you ever want to re-create your "simulated disk."

9.2.12.2 Turning an image into a CD

One of the other most common disk-image tasks is turning an image back into a CD or DVD—provided you have a CD or DVD burner on your Mac, of course.

All you have to do is choose File [image] Burn Image (or choose Burn Image from Disk Copy's Dock icon). In the resulting dialog box, locate the disk-image (.dmg) file you want to turn into a CD or DVD. Insert a blank CD or DVD, and then click Burn.

9.2.13 Disk Utility

Disk Utility is Mac OS X's own little Norton Utilities: a powerful hard-drive administration tool that lets you repair, erase, format, and partition disks. If you make the proper sacrifices to the Technology Gods, you'll rarely need to run Disk Utility. But keep it in mind, just in case you ever find yourself facing a serious disk problem.

Here are some of the tasks you can perform with Disk Utility:

  • Get size and type information about any disks attached to your Mac (but with less detail than you get with Apple System Profiler).

  • Fix disks that won't mount on your desktop or behave properly.

  • Repair folders and files that don't work because you supposedly don't have enough "access privileges."

  • Completely erase disks—including rewritable CDs (CD-RW).

  • Partition a disk into multiple volumes (that is, subdivide a drive so that its segments appear on the desktop with separate disk icons).

  • Set up a RAID array (a cluster of separate disks that acts as a single volume).

    NOTE

    Disk Utility can't verify, repair, erase, or partition your startup disk—the disk on which your system software is currently running. That would be like a surgeon performing an appendectomy on himself—not a great idea.

    If you want to use Disk Utility to fix or reformat your startup disk, you must start up your Mac from a different system disk, such as the Mac OS X Install CD.

The left Disk Utility panel lists your hard drive and any other disks in your Mac at the moment. On the right is a panel with five tabs, one for each of the main Disk Utility functions:

  • Information. Click the icon of a disk to read size, type, and partition information.

  • First Aid. This is the disk-repair part of Disk Utility. You're supposed to click the icon of a disk and then click either Verify (to get a report on the disk's health) or Repair (which fixes whatever problems the program finds). In other words, First Aid attempts to perform the same healing effects on a sick hard drive as, say, a program like Norton Utilities. It does a great job at fixing many disk problems; when you're troubleshooting, Disk Utility should always be your first resort.

    If Disk First Aid reports that it's unable to fix the problem, then it's time to invest in Norton Utilities (if a Mac OS X version is available) or its rival, Drive 10 (www.micromat.com).

    TIP

    If Disk First Aid finds nothing wrong with a disk, it reports, "The volume appears to be OK." Don't be alarmed at the wishy-washy, not-very-confident wording of that message—that's the strongest vote of confidence Disk First Aid can give. Even a brand-new, perfectly healthy hard drive only appears to be OK to Disk First Aid.

    The Verify and Repair Disk Permissions buttons are new in 10.2; their function is to straighten out problems with the invisible Unix file permissions that keep you from moving, changing, or deleting files or folders. (The occasional software installer can create problems like this.)

    Chapter 12 has a much more detailed discussion of permissions.

  • Erase. Select a disk, choose a format (always Mac OS Extended, unless you're formatting a disk for use on an ancient Mac running Mac OS 8.1 or earlier), give it a name, and click Erase to wipe a disk clean.

  • Partition. With the Partition tools, you can erase a hard drive in such a way that you subdivide its surface. Each chunk is represented on your screen by two (or more) different hard drive icons. (See Figure 9-15.)

    There are some very good reasons not to partition a drive these days: A partitioned hard drive is more difficult to resurrect after a serious crash, requires more navigation when you want to open a particular file, and offers no speed or safety benefits.

    But there's one very good reason to do it, too: to keep Mac OS 9 and Mac OS X on different "disks," as described in Section 5.4.

  • RAID. RAID stands for Redundant Array of Independent Disks, and refers to a special formatting scheme in which a group of separate disks are configured to work together as one very large, very fast drive. In a RAID array, multiple disks share the job of storing data—a setup that can improve speed and reliability.

    Most Mac users don't use or set up RAID arrays, probably because most Mac users only have one hard drive (and Disk Utility can't make your startup disk part of a RAID array).

    If you're using multiple external hard disks (SCSI or IDE format), though, you can use Apple RAID to merge them into one giant disk. Just drag the icons of the relevant disks (or disk partitions) from the left-side list of disks into the main list (where it says, "Drag disks here to add to set"). Use the RAID Scheme pop-up menu to specify the RAID format you want to use (Stripe is the most common), name your new mega-disk, and then click Create. The result is a single "disk" icon on your desktop that actually represents the combined capacity of all the RAID disks.

Figure 9-15. To partition your drive—which involves erasing it completely—launch Disk Utility, switch to the Partition pane, and select the hard drive you want to partition from the list on the left. From the Volume Scheme pop-up menu, choose the number of partitions you want, as shown here. Now drag the horizontal lines in the Volumes map to specify the relative sizes of the partitions you want to create. Assign a name and format for each partition in the Volume Information area, and then click OK.

Where's My Erase Disk Command?

Erasing a disk on a Mac used to be easy. All you had to do was select the disk in the Finder and choose Special [image] Erase Disk. But in Mac OS X, there's no Special menu, and the Erase Disk command is nowhere to be found.

That's because the Disk Utility program now handles your disk-erasing needs. Launch it, click the Erase tab, and blow away the data on the disk of your choice, whether it's a floppy, hard drive, CD-RW, or (new in Mac OS X 10.2) a DVD-RW.

9.2.14 Display Calibrator

The Display Calibrator is another of the Mac's Assistant programs, designed to help you adjust your monitor's color settings. It walks you through a series of six screens, presenting various brightness and color-balance settings in each screen. You pick the settings that look best to you; at the end of the process, you save your monitor tweaks as a ColorSync profile (Section 13.8) that ColorSync-savvy programs can use to adjust your display for improved color accuracy.

NOTE

You don't need Display Calibrator to adjust your monitor's brightness and contrast. Instead, just use the hardware controls on your monitor or the Displays panel in System Preferences.

Without realizing it, you may end up launching the Display Calibrator when you use the Displays panel in System Preferences. Clicking the Calibrate button in the Color pane of the Displays panel automatically turns on Display Calibrator. (For more on the Displays panel in System Preferences, see Section 8.8.)

9.2.15 Grab

Grab takes pictures of your Mac's screen, for use when you're writing up instructions, illustrating a computer book, or collecting proof of some secret screen you found buried in a game. You can take pictures of the entire screen (press [image] -Z, which for once in its life does not mean Undo) or capture only the contents of a rectangular selection (press Shift- [image] -A). When you're finished, Grab displays your snapshot in a new window, which you can print, close without saving, or save as a TIFF file, ready for emailing, posting on a Web page, or inserting into a manuscript.

Now, as experienced Mac users already know, the Mac OS has long had its own built-in shortcuts for capturing screenshots: Press Shift- [image] -3 to take a picture of the whole screen, and Shift- [image] -4 to capture a rectangular selection. These shortcuts have been around for years—and they still work in 10.2 and later.

So why use Grab instead? In many cases, you shouldn't. The Shift- [image] -3 and Shift- [image] -4 shortcuts work like a dream. But there are some cases in which it might make more sense to opt for Grab. Here are three:

  • Grab can make a timed screen capture (choose Capture [image] Timed Screen, or press Shift- [image] -Z), which lets you enjoy a ten-second delay before the screenshot is actually taken. After you click the Start Timer button, you have an opportunity to activate windows, pull down menus, drag items around, and otherwise set up the shot before Grab shoots the picture.

    NOTE

    As of Mac OS X 10.2, the Capture [image] Window command in Grab still doesn't work. To neatly capture a Mac OS X window without having to crop out the rest of the screen, use Snapz Pro X, as described in the next tip, or the secret Mac OS X keystrokes described in Section 13.10.

  • When you capture a screenshot using Grab's Selection command, the size of your selection is displayed, in pixels, right under the pointer as you drag. If you need to capture a 256-pixel-wide square, for example, you can do so with pinpoint accuracy. (The Image Inspector window, which you can open by choosing Edit [image] Inspector or by pressing [image] -1, displays the dimensions of each screenshot after you capture it.)

  • With Grab, you have the option of including the cursor in the picture, which is extremely useful when you're showing a menu being pulled down or a button being clicked. (Mac OS X's screenshot keystrokes, by contrast, always eliminate the pointer.) Use the technique described in Figure 9-16 to add the pointer style of your choice to a Grab screenshot.

    TIP

    Actually, if you're going to write a book or manual about Mac OS X, the program you really need is Snapz Pro X (available for download from www.missingmanuals.com, among other places). It offers far more flexibility than any of Mac OS X's own screenshot features. For example, you have a choice of file format, you can neatly snip out just one dialog box or window with a single click, and you can even capture movies of screen activity.

Figure 9-16. One of the advantages Grab offers over simply snapping screenshots with Shift- -3 or Shift- -4 is that it lets you include the pointer/cursor in the picture—or hide it. Choose Capture Preferences and pick one of the nine different pointer styles, or choose to keep the pointer hidden by activating the blank button in the upper-left corner.

9.2.16 Installer

You'll never launch this. It's the engine that drives the Mac OS X installer program and other software installers. There's nothing for you to double-click, configure, or set up.

9.2.17 Java Folder

Programmers generally use the Java programming language to create small programs that they then embed into Web pages—animated effects, clocks, calculators, stock tickers, and so on. Your browser automatically downloads and runs such applets (assuming that you have "Enable Java" turned on in your browser).

Your Java folder contains three Java-related tools: Applet Launcher, Java Plugin Settings, and Web Start.

9.2.17.1 Applet Launcher

These so-called applets are really just programs. So what if you want to run one without going through a Web site and launching your Web browser? Applet Launcher lets you open and launch Java applets without relying on a Web browser.

The Applet Launcher window contains only two buttons: Open and Launch. To run an applet, first select it using the Open command, then click Launch. Now you're in business: An Applet Viewer window opens containing the applet. The pop-up menu in the Applet Launcher window remembers the applets you've opened most recently, so that you can run them later by choosing them from the menu. (To erase the list of remembered applets, choose Edit [image] Preferences and click the Clear History button.)

TIP

You might wonder—where do you find Java applets to run with Applet Launcher? Just launch your browser and type free Java applets into any search engine. You'll find Web sites galore containing hundreds of applets—games, utilities, animations, and more—that you can download immediately. Once you've downloaded them, use Applet Launcher to open the .html file associated with each applet (see Figure 9-18).

Once you're running an applet in the Applet Viewer, an Applet menu appears in the menu bar, containing a few useful (and mostly self-explanatory) commands, such as Stop, Start, Restart, and Reload. If an applet locks up, the Restart command can generally revive it.

Figure 9-17. Thanks to the Applet Viewer, you can use your Mac to run hundreds of free Java applets available for download over the Internet, such as this vintage Commodore 64 era game.
9.2.17.2 Java Plugin Settings

This tiny configuration program offers a few random settings that pertain to the Mac's Java Virtual Machine (the "engine" that runs Java applets). The average person will never need to adjust these settings. But if you're the kind of person who knows what to do with options like "Recycle Classloader," go wild.

9.2.17.3 Web Start

Java Web Start isn't an Apple product—it's a free program from Sun Microsystems designed to streamline the process of downloading and running Java-based programs on your Mac.

If you want to see what this is all about, launch Internet Explorer and go to http://java.sun.com/products/javawebstart/demos.html to access a page of demo programs. When you click one of the demo Launch buttons, Java Web Start (JWS) kicks in to do its thing, as shown in Figure 9-18.

JWS downloads all the necessary files and starts running the program you select—all with one click, and without relying on the Web browser. In fact, JWS doesn't just run Java programs; it also stores them on your system so you can launch them again later. To launch a Java-based program, double-click its icon, or choose View [image] Downloaded Applications in JWS . You don't have to use a Web browser or reconnect to a Web site.

The catch is that Java Web Start is a fledgling technology and only a handful of (mostly lame) demo programs are available that actually make use of JWS.

Ultimately, Sun hopes that JWS will become an important software distribution tool, enabling people to connect to a Web site, click a button, and start using whatever program they need. It's a great concept—but still mostly just a concept.

Figure 9-18. This is Java Web Start in the process of downloading and activating a Java program from the Sun Microsystems Web site. To poke around on Java Web Start without downloading the demo programs from Sun, launch JWS and go to the Application Manager window. Click Welcome to Java Web Start, and then click the Start button on the right side of the screen. A small Java program from Apple starts running. It briefly describes this technology and includes some meaningless demos.

9.2.18 Key Caps

Key Caps, a part of the Mac since its earliest days, consists of a single window containing a tiny onscreen keyboard (Figure 9-19). When you hold down any of the various modifier keys on your keyboard (such as c, Option, Shift, or Control), you can see exactly which keys produce which characters. The point, of course, is to help you learn which keys to press when you need special symbols or non-English characters, such as © or ¢, in each font.

Figure 9-19. How do you make a p symbol? Key Caps reveals the answer. When you press the Option key, the Key Caps keyboard shows that the pi character (p) is mapped to the P key. Once you've found and typed the character in Key Caps, you can copy and paste it into any other program.

NOTE

Key Caps shows only the symbols you can produce by typing keystrokes. A font may contain thousands of other characters that can't actually be typed; The Character Palette is the only way to access these other symbols.

If you want to see the effect of typing while pressing the modifier keys, either click the onscreen keys or type on your actual keyboard. The corresponding keys on the onscreen keyboard light up as they're pressed.

TIP

If the A key on your PowerBook stops working, or you accidentally spill an entire Snapple onto your keyboard and the whole thing gives out, remember this: You can type using Key Caps. Use the mouse to click the onscreen keyboard characters, typing into the one-line display in the Key Caps window. Then copy what you've typed into your other documents. Slow? Yes—but it's always good to have a Plan B.

9.2.18.1 Change the Key Caps font

Different fonts contain different hidden characters. For example, Palatino contains a [image] character (produced by pressing Shift-Option-K), yet Adobe Garamond does not.

Fortunately, Key Caps lets you see the characters lurking within any installed font; just choose a font's name from the Font menu to see all of its modifier-key characters. (You may have to change the keyboard layout to see all symbols in some fonts.)

TIP

You're not stuck viewing all characters in 12-point size—a good thing, because some of them are hard to read when displayed that small. Just "zoom" the Key Caps window (by clicking the green gel-button near the top-left corner) to magnify the Key Caps window and its font, as shown in Figure 9-19.

9.2.19 Keychain Access

Keychain Access manages all your secret information—passwords for network access, file servers, FTP sites, Web pages, and other secure items. For instructions on using Keychain Access, see Chapter 12.

9.2.20 NetInfo Manager

NetInfo is the central Mac OS X database that keeps track of user and group accounts, passwords, access privileges, email configurations, printers, computers, and just about anything else network related. NetInfo Manager is where a network administrator (or a technically inclined Mac guru) can go to view and edit these various settings.

You can find more information about NetInfo in these places:

  • The tutorials in the relevant sections of this book, such as in Sleuthing Around with NetInfo Manager and Section 12.4.

  • Article #106416 ("NetInfo: What is it? How to Set Up NetInfo") at http://kbase.info.apple.com.

Bringing Dead Keys to Life

If you press Option while the Key Caps window is open, you see little white outlines around certain keys (shown in Figure 9-19, for example). These rectangles identify the Mac's five dead keys—keys that, when pressed once, type nothing onscreen. However, when you type another key—a normal letter, for example—it appears with the dead key's displayed marking over it. To type the ñ in jalapeño, you must first press Option-N and then type an n. This same two-step approach lets you type characters like ö and é;.

9.2.21 Network Utility

The Network Utility gathers information about Web sites and network users. It offers a suite of industry standard Internet tools such as NetStat, Ping, Traceroute, Finger, and WhoIs—advanced tools, to be sure, but ones that even novice Mac users may be asked to fire up when calling a technician for Internet help.

Otherwise, you probably won't need to use Network Utility to get your work done. However, Network Utility can be useful when you're performing Internet detective work:

  • Use WhoIs to gather an amazing amount of information about the owners of any particular domain (such as www.apple.com)—including name and address info, telephone numbers, and administrative contacts—using the technique shown in Figure 9-20.

  • Use Ping to enter a Web address (such as www.google.com), and then "ping" (send out a "sonar" signal to) the server to see how long it takes for it to respond to your request. Network Utility reports the response time in milliseconds—a useful test when you're trying to see if a remote server (a Web site, for example) is up and running.

  • Traceroute lets you track how many "hops" are required for your Mac to communicate with a certain Web server. Just type in the network address, and then click Trace. You'll see that your request actually jumps from one trunk of the Internet to another, from router to router, as it makes its way to its destination. You'll find that a message sometimes crisscrosses the entire country before it arrives at its destination. You can also see how long each leg of the journey took, in milliseconds.

Sleuthing Around with NetInfo Manager

While most of NetInfo Manager is of little use to a typical Mac user, a few parts of this utility can be valuable even to a non-system administrator.

To dive into NetInfo Manager, start by clicking the padlock button at the bottom of the main window and enter an administrator's password. Then examine the various parameters in the top-left Directory Browser list. As you'll quickly discover, most of these settings are written in Unix techno-speak.

A few, however, are easy enough to figure out. If you click users in the left-side list, you'll see, in the next column, a list of accounts you've created. Click one of the user names there, and you'll see, in the properties pane at the bottom of the screen, some parameters that may come in handy-such as each person's name, password, and password hint. By double-clicking one of these info items, you can edit it, which can come in genuinely handy if someone on your school or office network forgets their password.

Figure 9-20. The WhoIs ("who is") tool is a powerful part of Network Utility. First enter a domain that you want information about, then choose a WhoIs server from the pop-up menu (you might try whois. networksolutions.com). When you click the WhoIs button, you'll get a surprisingly revealing report about the owner of the domain, including phone numbers, fax numbers, contact names, and so on.

The Developer Tools CD Extras

Starting with the Jaguar 10.2 version, the Mac OS comes on two CDs for the first time. Not everyone gives more than a second glance to the third Mac OS X CD, though, the one called Developer. (It's a physical CD in the boxed, store-bought version of Mac OS X. If Mac OS X came with your Mac, the Developer CD may be a disk image on one of your Software Restore discs. Use Disk Copy to burn this image onto a real CD, as described in Section 9.2.12.)

The Developer CD is intended, of course, for developers (programmers) who write Mac OS X software. But it offers some interesting extra programs that aren't included with the regular Mac OS X installation. (After you install the developer tools—by double-clicking Developer.pkg in the CD window—you'll find a new folder called Developer on your hard drive. The goodies are in the Developer [image] Applications [image] Extras folder.)

For example, Sketch is a simple drawing program. If you're a Mac old-timer, you might describe it as something along the lines of the old MacDraw. It makes smooth lines, circles, and text boxes.

The Extras folder also includes Bomb.app, the program Steve Jobs used in his earliest Macworld Expo presentations of Mac OS X. When you click its Light It button, shown here, the program does nothing but crash—literally. That's all it's designed to do, as a demonstration of the way Mac OS X programs can bomb without requiring you to restart the whole Mac.

Finally, there's WorldText.app, which is a lot like TextEdit but with more features, including proper Font, Size, and Style menus, a Sound menu whose Speak command can read your text back to you, and more.

9.2.22 ODBC Administrator

This new Mac OS X 10.2 program is designed to arbitrate of ODBC access requests. Any questions?

If you have no idea what that means, and no corporate system administrator has sat down with you to explain it to you, then your daily work probably doesn't involve working with corporate ODBC (Open Database Connectivity) databases. You can ignore this program or throw it away.

9.2.23 Print Center

This is the hub of your Mac's printing operations. You can use the Print Center to set up and configure new printers, and to check on the status of print jobs, as described in Chapter 13.

9.2.24 Process Viewer

Even when you're only running a program or two on your Mac, dozens of computational tasks (processes) are going on in the background. Process Viewer lets you see all the different processes—foreground and background—that your Mac is handling at the moment.

If you want to get a peek at just how busy your Mac is, even when you're just staring at the desktop, launch the Process Viewer. Check out how many items appear in the Process Listing Window. Some are easily recognizable programs (such as Finder), while others are background system-level operations you don't normally see. For each item, you can see the percentage of CPU being used, who's using it (either your account name or root, meaning the Mac itself), and the percentage of memory it's using.

TIP

When one of your programs freezes or crashes, double-click its name in Process Viewer. You'll be offered the Quit Process dialog box, which you can use to exit the stuck program as safely as possible. This technique often works to jettison the troublemaker when all else fails.

9.2.25 StuffIt Expander

StuffIt Expander, a free program from Aladdin Systems, is an indispensable utility for decompressing and decoding files, especially those that you download from the Internet or receive as email attachments. It automatically restores all kinds of compressed files into usable form, including StuffIt files (whose names end with .sit), Zip files (.zip), BinHex files (.hqx), UUEncoded files (.uu), MIME or Base64 files (.mime), and—especially important in Mac OS X—.tar and .gzip files, which were once found only on Unix machines. (Now your Mac is a Unix machine.)

Usually, you needn't do anything with StuffIt Expander. It just does its thing, automatically and unbidden, whenever you download a compressed file. That's because most Web browsers come configured to treat StuffIt Expander as a helper application; the browsers summon Expander the moment they recognize that you've downloaded a compressed file (see Figure 9-21).

Figure 9-21. One of the best things about StuffIt Expander is that you almost never have to touch it; your Web browser launches it for you as needed. Internet Explorer's preferences, shown here, designate Expander as a File Helper that handles any downloaded .sit files.

If you end up with a .sit or .zip file on your Mac that needs decompressing—and StuffIt Expander hasn't been launched automatically—just drag the file onto the StuffIt Expander icon to expand it.

9.2.26 Terminal

Terminal opens a terminal window with a command line interface, taking you deep into the world of Unix, the operating system on which Mac OS X is based. Chapter 15 and Chapter 16 offer a crash course on this powerful window into the Mac's shadow operating system.


Chapter 10. CDs, DVDs, and iTunes

    Section 10.1. How the Mac Does Disks

    Section 10.2. Burning CDs and DVDs

    Section 10.3. iTunes 3: The CD and MP3 Jukebox

    Section 10.4. Playing DVD Movies


10.1 How the Mac Does Disks

Apple shocked the world when, in 1997, it introduced the iMac without a floppy disk drive—and proceeded to eliminate the floppy drive from all subsequent Mac models in the following years. Apple argues that the floppy disk is dead—it's too small to serve as a backup disk, and, in this day of the Internet, it's a redundant method of exchanging files with other computers.

10.1.1 Disks Today

But the floppy disk didn't disappear entirely. Millions of older Macs still have floppy drives, and many owners of modern Macs buy add-on floppy drives. In fact, you can introduce all kinds of disks to a Mac these days (see Figure 10-1). Here are the most popular examples:

10.1.1.1 Hard drives and the iPod

Thanks to the Mac's FireWire jack, it's easier than ever to attach an external hard drive for extra storage. In Mac OS X, having such a spare disk around is especially useful for dual-booting purposes: you can keep Mac OS X on one hard drive, and Mac OS 9 on another (Section 5.4).

It would be hard to imagine a more convenient second hard drive than, for example, Apple's iPod, which is not only an outstanding MP3 music player but also doubles as a self-powered, extremely compact, bootable hard drive.

10.1.1.2 Zip disks, Peerless drives

Whether your Zip drive is built into the front panel of your Power Mac or attached via the USB or FireWire port, you wind up with an inexpensive system for backing up and transferring files. (Each $10 Zip disk holds 100, 250, or 750 megabytes, depending on the model you buy.)

For some people, the Iomega Peerless drive is a better value. You buy a single drive, which you leave connected to your Mac, and then as many interchangeable hard drive cartridges—holding 10 or 20 GB apiece—as you need.

Fortunately, the necessary driver software for both of these drive systems is built into Mac OS X.

Figure 10-1. You may see all kinds of disks on the Mac OS X desktop—or none at all, if you've chosen to hide them using the Finder Preferences command. But chances are pretty good you won't be seeing many floppy disk icons.
10.1.1.3 SuperDisks

A SuperDisk drive, another gadget you can plug into your Mac's USB connector (not to be confused with Apple's SuperDrive, a DVD burner), poses a fascinating alternative to the Zip drive. Its disks look exactly like floppies, but hold about 85 times as much. The real advantage of a SuperDisk drive, though, is that it also accepts standard floppy disks. The downsides: (1) SuperDisk drives are slow, and (2) it's up to you to figure out how to tell a SuperDisk disk apart from a floppy disk.

The driver software for this kind of drive, too, is built right into Mac OS X.

10.1.1.4 Floppy drives

Despite Apple's conviction that the era of floppy disks is over, millions of floppies continue to populate the earth. You can either connect Macs by network wires (Chapter 12), or you can always transmit your files by the world's best file transfer system: the Internet. But if you still crave the hands-on, in-your-pocket solidity of the good old floppy disk, about $80 buys an external floppy disk drive for your floppy-less Mac. (This device, too, connects to your USB jack, and once again exploits the built-in Mac OS X drivers.)

10.1.1.5 CD-ROMs

You wouldn't get far in today's computer world without a CD-ROM drive. Most commercial software comes on CD—not to mention the music CDs that the Mac can play so expertly (see Section 10.3).

10.1.1.6 DVDs

Many Mac laptops and desktops include a built-in DVD drive. You use it primarily for playing back DVD movies that you've rented or bought, but you may also occasionally use it for data DVDs—that is, DVDs that contain Mac files or software installers.

10.1.1.7 Recordable CDs and DVDs

CD-ROM stands for "compact disc, read-only memory"—in other words, you can't ever put your own files on them. Read-only means you can't write (save files) onto them.

Yet some of the most popular Mac add-ons these days are various kinds of CD burners—special CD drives that can record onto special blank discs. Although these discs look like normal CDs, they (and the drives that accommodate them) may fall into any of these more specific categories:

  • CD-R. You can fill this type of disc with your own files—once. The disc can't be changed thereafter. CD-R burners are quickly going out of fashion, thanks to the flexibility of CD-RW, described next.

  • CD-RW. The initials stand for rewritable; you can record such discs over and over again. Of course, both the recorders that do this and the blank discs are somewhat more expensive than the one-shot kind. (CD-RW drives can read and record both CD-R and CD-RW discs.)

  • DVD-RAM. This is just like a CD-rewritable, but holds eight times as much, thanks to the DVD format. Note, however, that this format is incompatible with regular DVDs, and is quickly dying out. (At one time, Apple offered a built-in DVD-RAM drive in some Power Macs sold on its Web site.)

  • DVD-RW. The latest—and definitely the greatest—is the Apple SuperDrive, which can play and record CDs and DVDs. If your Mac came with a SuperDrive built in, you can take advantage of a Mac OS X feature that neither Windows nor any previous version of the Mac OS offers: the ability to use blank DVDs as massive backup disks that hold 4.7 GB each. (Technically, these are called DVD-R discs, and Apple sells them for about $5 each.)

    If you've used iMovie to edit your home camcorder footage, you can also save them onto one of these DVDs for playback in standard home DVD players—the perfect way to distribute your masterpiece to friends and family without sacrificing the pristine video quality. (Both editing movies and saving them onto a DVD using Apple's iDVD software are described in iMovie 2: The Missing Manual.)

10.1.2 Disks In, Disks Out

Yes, you can insert all kinds of different disks into a Mac. But as far as the Mac is concerned, they're all just disks. (Actually, the Mac thinks of them as volumes—you can tell because that's how your Apple System Profiler describes them, for example.)

When you insert a disk, its icon shows up on the right side of the screen. If you've used only Windows computers, this behavior may throw you at first. You no longer have to go hunting for the inserted disk's icon in some My Computer icon, as you do on a PC. To see what's on a disk you've inserted, just double-click its icon.

NOTE

You can use Mac OS X like Windows if you choose. To open a single window containing icons of all currently inserted disks, choose Go [image] Computer. To complete the illusion that you're running Windows, you can even tell Mac OS X not to put disk icons on the desktop at all. Just choose Finder [image] Preferences and turn off the three top checkboxes—"Hard disks," "Removable media (such as CDs)," and "Connected servers." They'll no longer appear on the desktop—only in your Computer window.

To remove a disk from your Mac, use one of these methods:

  • Drag its icon onto the Trash icon. For years, this technique has confused and frightened first-time Mac users. Their typical reaction: Doesn't the Trash mean delete? Yes, but only when you drag document or folder icons there—not disk icons. Dragging disk icons onto the Trash (at the right end of the Dock) makes the Mac spit them out.

    Actually, all you can really do is intend to drag it onto the Trash can. The instant you begin dragging a disk icon, the Trash icon on the Dock changes form, as though to reassure the novice that dragging a disk icon there will only eject, not erase it. As you drag, the wastebasket icon turns into a giant-sized Eject logo (which matches the symbol on the upper-right key of current Mac keyboards).

  • Press the Eject key on your keyboard. Recent Mac keyboards, both on laptops and desktops, have a special Eject key in the upper-right corner. Hold it down for a moment to make a CD or DVD pop out. (If it's any other kind of disk, highlight the icon first.)

  • Highlight the disk icon, and then choose File [image] Eject ( [image] -E). The disk now pops out. (Alternatively, you can Control-click the disk's icon and then choose Eject from the pop-up menu that appears.)

  • Control-click the disk icon. Choose Eject from the contextual menu.

When Good Disks Go Bad

Any disk can go bad. When this happens, you may get an error message that reports the disk as being "damaged" or "unusable."

If it happens to you, run the Disk Utility program in your Applications [image] Utilities folder. Use its First Aid tab. Click the broken disk, and then click Repair. Sometimes running the Repair function several times in a row can correct a disk problem that's too stubborn for a single pass.

Note that unlike its predecessor Disk First Aid, Disk Utility can't repair the disk it's on. To repair your main, internal hard drive, therefore, you must either restart the Mac from the Mac OS X CD or use the built-in Unix version of Disk Utility, which is called fsck (see Section B.11).

And, if after several times you don't succeed, try running a program like Alsoft's DiskWarrior (which is sort of a more powerful, commercial version of Disk Utility).

10.1.3 Startup Disks

When you turn the Mac on, it hunts for a startup disk—that is, a disk containing a System folder. If you've ever seen the dispiriting blinking-question-mark icon on a Mac's screen, you know what happens when the Mac can't find a startup disk. It blinks like that forever, or until you find and insert a disk with a viable System folder on it.

10.1.3.1 Creating a startup disk

By installing the Mac OS onto a disk—be it a hard drive or rewritable CD or DVD—you can create a startup disk. Not all disks are capable of starting up the Mac, however. RAM disks an older external FireWire disks don't work, and not all older Macs can start up from external FireWire drives.

10.1.3.2 Selecting a startup disk

It's perfectly possible to have more than one startup disk simultaneously attached to your Mac. That's the deal, for example, whenever you've inserted the Mac OS X CD into your Mac—now you've got both it and your hard drive. Each contains a System folder, and each is a startup disk. Some veteran Mac fans deliberately create other startup disks—on burnable CDs, for example—so that they can easily start the Mac up from a backup startup disk, or a different version of the OS.

Only one System folder can be operational at a time. So how does the Mac know which to use as its startup disk? You make your selection in the Startup Disk panel of System Preferences (Figure 10-2). Use it to specify which disk you want the Mac to start up from the next time it starts up.

Figure 10-2. In the Startup Disk panel of System Preferences, the currently selected disk—the one that will be "in force" the next time the machine starts up—is always highlighted. You see the System folder's version and the name of the drive it's on, but not its actual name—until you point to an icon without clicking.

TIP

If you're in a hurry to start the machine up from a different disk, just click the disk icon and then click Restart in the System Preferences window. You don't have to close the window first.

The Eject Button That Doesn't

When I push the Eject button on my keyboard (or on my CD-ROM drawer), why doesn't the CD come out?

There might be two things going on. First of all, to prevent accidental pushings, the Eject key on the modern Mac keyboard is designed to work only when you hold it down steadily for a second or two. Just tapping it doesn't work.

Second, remember that once you've inserted a CD, DVD, or Zip disk, the Mac won't let go unless you eject it in one of the official ways. On Mac models with a CD tray, pushing the button on the CD-ROM door opens the drawer only when it's empty. If there's a disc in it, you can push that button till doomsday, but the Mac will simply ignore you.

That behavior especially confuses people who are used to working with Windows. (On a Windows PC, pushing the CD button does indeed eject the disc.) But on the Mac, pushing the CD-door button ejects an inserted disc only when the disc wasn't seated properly (or when the disk drive's driver software isn't installed), and the disc's icon never did appear onscreen.

The Eject key on the modern Mac keyboard, however, isn't so fussy. It pops out whatever CD or DVD is in the drive.

Oh—and if a CD or DVD won't come out at all (and its icon doesn't show up on the desktop), restart the Mac. When it "comes to," it will either recognize the disc now or generate an error message containing an Eject button. (Most drives also feature a tiny pinhole in or around the slot. Inserting a straightened paper clip, slowly and firmly, will also make the disc pop out. Or, you can keep the mouse button pressed as the Mac restarts; that, too, makes the disc pop out.)

10.1.4 Erasing, Formatting, and Initializing

Mac OS X no longer includes an Erase Disk command. When you want to erase a disk (such as a CD-RW disc), therefore, you have to use Disk Utility, which is located in your Applications [image] Utilities folder.

You can use this program to erase, repair, or subdivide (partition) a hard drive. You can also use it to lock a hard drive or cartridge so that it behaves like a CD-ROM. In other words, people can look at what's on it, but they can't store anything new on it.

To erase a CD, launch Disk Utility, click the Erase tab, click the name of the CD (in the left-side list), and click the Erase button.

You won't be able to do so, though, if:

  • The disk is a standard CD-ROM, DVD, or previously recorded CD-R (CD-recordable) disc, which can't be erased. (The only shiny silver discs you can rerecord are CD-RW [rewritable] discs, which are slightly more expensive than standard blank CD-R discs.)

  • You're trying to erase the startup disk. You can't wipe out the disk that contains the currently running System folder any more than you can paint the floor directly beneath your feet. You can only erase a disk that's not the one you started up from. (To erase your built-in hard drive, for example, you must start up from the Mac OS X CD-ROM.)


10.2 Burning CDs and DVDs

If your Mac has a CD-RW drive or an Apple SuperDrive in it, you've got yourself the world's most convenient and elegant backup system. It's just like having a floppy disk drive, really—except that a blank CD holds at least 450 times as many files, and a blank DVD holds about 3,350 times as many!

You can buy blank CDs very inexpensively in bulk ($30 for 100 discs, for example) via the Web. (To find the best prices, visit www.shopper.com or www.buy.com and search for blank CD-R.) Blank DVDs are much more expensive, but not ridiculously so, considering their capacity. At this writing, the Apple Web site, for example, sells them at $30 for five—and prices are sure to come down.

To use one for backup, transporting files, or mailing files, insert a blank CD-R, CD-RW, or DVD-R disc into your Mac. (If you have a slot-loading Mac, simply slip the disc into the slot. If your Mac has a sliding CD/DVD tray instead, open it first by pressing the button on the tray, or—if you have an Eject key in the upper-right corner of your keyboard—pressing it for about one second.)

Mac OS Extended Formatting

When you use Disk Utility to erase a disk (or when you first install Mac OS X and elect to erase the hard drive in the process), you'll be confronted with a choice between formatting options called Mac OS Extended and UNIX File System (UFS). (When you erase a floppy disk, you also get an option to create a DOS-formatted disk for use in Windows machines.)

Mac OS Extended refers to the HFS Plus filing system, a disk format that has been proudly maximizing disk space for Mac fans since Mac OS 8.1.

Mac OS X still accepts disks that were prepared using the older, Mac OS Standard formatting—the ancient HFS (hierarchical filing system) format—but you can't use one as your startup disk.

As for the UNIX File System option, it's exclusively for use on computers that run Unix (the pure variety, not the dressed-up version that is Mac OS X).

TIP

Once you've inserted a CD or DVD into your tray, you can close it either by pushing gently on the tray or—if your keyboard has an Eject key—by pressing the key again.

After a moment, the Mac notices the blank disc and displays a dialog box asking, in effect, what you want to do with this blank CD. See Figure 10-3 for instructions.

Figure 10-3. Top left: Choose Open Finder if you plan to copy regular Mac files onto the CD; Open iTunes if you plan to burn a music CD; or Open Disk Copy if you intend to turn a disk image (Section 4.8.2) into a new CD. If this is what you always want to do with blank CDs, turn on "Make this action the default." Then click OK. Right: Drag the "loaded" CD or DVD onto the Burn icon on the Dock. Lower left: Confirm your choice in this box.

If you choose Open Finder, you'll see the disc's icon appear on the desktop after a moment. At this point, you can begin dragging files and folders onto it, exactly as though it were a particularly well-endowed floppy disk. You can add, remove, reorganize, and rename the files on it just as you would in any standard Finder window. You can even rename the CD or DVD itself just as you would a file or folder.

TIP

Behind the scenes, the Mac is creating a disk image of the CD (or DVD)-to-be, as described in Section 4.8.2. If your hard drive is very full—too full to set aside a 650-megabyte, 700-megabyte, or 4.7-gigabyte loading area for your files, that is—you'll get an error message.

When the disk contains the files and folders you want to immortalize, do one of these things:

  • Choose File [image] Burn Disc.

  • Drag the disc's icon toward the Trash icon on the Dock. As soon as you begin to drag, the Trash icon turns into what looks like a bright yellow fallout-shelter logo (also shown in Figure 10-3). Drop the disc's icon onto it.

  • Control-click the disc's icon on the Dock and choose Burn Disc from the contextual menu that appears.

    TIP

    If you do a lot of CD burning, consider adding a Burn button to your Finder toolbar. It's one of the canned options described in Section 3.4.2.

In any case, the dialog box shown at bottom left in Figure 10-3 now appears. Click Burn. The Mac's laser proceeds to record the CD or DVD, which can take some time. Fortunately, because this is Mac OS X, you're free to switch into another program and continue using your Mac.

When the recording process is over, you'll have yourself a newly minted DVD or CD that you can insert into any other Mac (or PC, for that matter). It will show up on that computer complete with all the files and folders you put onto it.

Here are a few final notes on burning CDs and DVDs at the desktop:

  • Not sure whether your Mac even has a CD-burning drive? Launch Apple System Profiler (located in your Applications [image] Utilities folder). Click the Devices and Volumes tab. Near the bottom of the display—next to a gray "Bus" triangle—you'll see an indication of the kind of drive your Mac has. It might say "DVD," for example (meaning you can't record anything), or "CD-RW/DVD-R" (meaning you can burn CDs and DVDs—therefore, you have a SuperDrive).

  • The procedure described above works very well if your recordable CD or DVD drive came built into your Mac. It also works on many external USB or FireWire CD burners. It may not work, however, on older burners that connect to the Mac using the SCSI port.

  • You can only do the most basic recording right in the Finder—convenient as all get-out, but very basic. For example, you can only record an entire CD at once. You can't add any more files or folders to it once it's been burned (unless it's a CD-RW, in which case you must erase the entire disc and then rerecord the whole thing).

    If you'd like to add more to a previously recorded CD-R or CD-RW (technically, to create a multisession disc), to make a video CD, and so on, you'll need a full-fledged CD-burning program like Toast Titanium (www.roxio.com).

  • When you insert a CD-RW disc that you've previously recorded, the box shown at top left in Figure 10-3 doesn't appear. Instead, the disc's icon simply appears on the desktop as though it's an ordinary CD. Before you can copy new files onto it, you must erase it using Disk Utility as described in the previous section.

  • The CDs that the Mac burns work equally well on Macs and Windows (or Linux) PCs. If you plan to insert a CD into a PC, however, remember that Windows doesn't permit any of these symbols in a Windows file name—\ / : * ? " < > |—and you'll run into trouble if any of your files contain these symbols. In fact, you won't be able to open any folders on your CD that contain illegally named files.


10.3 iTunes 3: The CD and MP3 Jukebox

iTunes, in your Applications folder, is the ultimate software jukebox (Figure 10-4). It can play music CDs, tune in to Internet radio stations, load up your iPod music player, and play back MP3 files (sound files in a popular format that stores CD-quality music in remarkably small files) and other popular audio formats. It can also turn selected tracks from your music CDs into MP3 files, so that you can store favorite songs on your hard drive to play back anytime—without having to dig up the original CDs. In fact, iTunes can even load your MP3 files onto certain portable MP3 players. And if your Mac can burn CDs, iTunes even lets you burn your own custom audio CDs that contain only the good songs.

Figure 10-4. The Shuffle button plays the selected songs in a random order, so that you don't have to listen to them in the same order every time. The Loop button behaves like the one on a CD player: When you click it, your playlist plays to the end and then repeats. If you see a tiny digit 1 superimposed on this button, the current song, not the whole playlist, will loop.

iTunes can also burn MP3 CDs: music CDs that fit much more than the usual 74 minutes of music onto a disc (because they store songs in MP3 format instead of AIFF). Not all CD players can play MP3 discs, however, and the sound quality is slightly lower than that of standard CDs.

The first time you run iTunes, you're treated to the appearance of the iTunes Setup Assistant: a series of interview screens that lets you specify (a) whether you want iTunes to be the program your Mac uses for playing MP3 files from the Internet, (b) whether you want it to ask your permission every time it connects to the Internet, and (c) whether you want the program to scan your hard drive for all MP3 files already on it. (If you decline to have your hard drive scanned at this time, you can always do so later by dragging your hard drive icon directly into the iTunes window.)

TIP

If you don't have any MP3 files to work with, consider visiting a Web site like www.mp3.com, where you can download a few free MP3 music files. Or, you can turn some of your own CDs into MP3 files, following the instructions later in this chapter.

10.3.1 MP3 Files and Company

The iTunes screen itself is set up to be a list—a database—of every song you've got in MP3, AIFF, WAV, or AC3 format. iTunes automatically finds, recognizes, and lists all such files in your Home folder [image] Documents [image] iTunes Music folder.

TIP

You can instruct iTunes to display the contents of other folders, too, by choosing File [image] Add to Library. It promptly copies any sound files from the folder you "show" it into your Home folder [image] Music [image] iTunes folder.

10.3.2 Audio CDs

If you're not into collecting MP3 files, you can also populate the main list here simply by inserting a music CD. The songs on it immediately show up in the list.

At first, they may appear with the exciting names "Track 01," "Track 02," and so on. Similarly, the CD itself shows up in the list at the left side of the window with the uninspiring name "Audio CD."

Fortunately, iTunes immediately attempts to connect to the Internet and compare your CD with the listings at www.cddb.com, a global database of music CDs and their contents. If it finds a match among the thousands of CDs there, it copies the album and song names right into iTunes, where they reappear every time you use this particular music CD.

TIP

If you connect an iTunes-compatible portable MP3 player to your Mac, its name, too, shows up in the left-side Source list. This is your opportunity to make your Mac the "hub for the digital lifestyle," exactly as Apple advertises: You can add or remove songs on your player (by dragging them onto its icon), rename or reorder them, and so on.

Mac OS 9 and Mac OS X in Glorious iTunes Harmony

Is there any way to synchronize my music libraries between the Mac OS 9 and Mac OS X copies of iTunes?

Here's another one of these situations where you may get a headache when you switch between Mac OS 9 and Mac OS X. Fortunately, it's easy to solve.

The Mac OS X version of iTunes tracks the MP3 files in your Home folder [image] Music [image] iTunes [image] iTunes Music folder. But by choosing iTunes [image] Preferences and clicking the Advanced icon, you'll see that you can change the Music Folder Location.

If you change it to the same folder that contains your Mac OS 9 iTunes files (usually Documents [image] iTunes [image] iTunes Music folder), you'll be able to keep a single iTunes music folder no matter which operating system you're using at the moment.

10.3.3 The iPod

The iPod is a beautiful, tiny, white-and-chrome Apple MP3 player containing a hard drive that can hold thousands of songs. (You can buy five-, ten-, or twenty-gigabyte models—this week, anyway.) It's designed to integrate seamlessly with iTunes 3.

All you have to do is connect the iPod to the Mac via its FireWire cable. You'll see the iPod's icon show up on your desktop as though it's a hard drive (which it is). You'll also see an iPod icon show up in the iTunes "folder list." Click its icon to view its contents.

10.3.4 Playing Music

To turn your Mac into a music player, click iTunes' triangular Play button (or press the Space bar). The Mac immediately begins to play the songs whose names have checkmarks in the main list. See Figure 10-4 to learn what the various onscreen buttons do.

TIP

The central display of the top of the window shows not only the name of the song and album, but also where you are in the song, as represented by the diamond in the horizontal strip. Drag this diamond, or click elsewhere in the strip, to jump around in the song.

Click the tiny triangle at the left side of this display to see a pulsing VU meter, indicating the current music's sound levels at various frequencies.

10.3.5 Fun Things to Do During Playback

As music plays, you can control and manipulate the music and the visuals of your Mac in all kinds of interesting ways. As a result, some people don't move from their Macs for months at a time.

10.3.5.1 Turning on visuals

Visuals is the iTunes term for an onscreen laser-light show that pulses, beats, and dances in perfect sync to the music you're listening to. The effect is hypnotic and wild. (For real party fun, invite some people who grew up in the Sixties to your house to watch.)

Auto-Playing Music CDs

In Mac OS 9, you can set the QuickTime Settings control panel to play music CDs automatically when they're inserted into the Mac. Can Mac OS X do that?

Naturally!

First, make sure iTunes is slated to open automatically when you insert a music CD. You do that on the CDs & DVDs panel of System Preferences (use the "When you insert a music CD" pop-up menu).

Then all you have to do is make sure iTunes knows to begin playing automatically once it launches. Choose iTunes [image] Preferences, click the General icon, and from the On CD Insert pop-up menu, choose Begin Playing, and click OK.

From now on, whenever you insert a music CD, iTunes will launch automatically and begin playing.

To summon this psychedelic display, click the flower-power icon in the lower-right corner of the window (see Figure 10-4). The show begins immediately—although it's much more fun if you choose Visuals [image] Full Screen so that the movie takes over your whole monitor. True, you won't get a lot of work done, but when it comes to stress relief, visuals are a lot cheaper than a hot tub.

Once the screen is alive with visuals, you can turn it into your personal biofeedback screen by experimenting with these keys:

Key | Function
? | Displays a cheat sheet of secret keystrokes. (Press it repeatedly to see the other shortcut keys.)
F | Displays, in the upper-left corner of your screen, how many frames per second iTunes' animation is managing—a quick, easy way to test the power of your graphics circuitry.
T | Turns frame rate capping on or off—a feature that limits the frame rate to 30 frames per second, to avoid sapping your Mac's horsepower when you're working in other programs (not really much of an issue in Mac OS X, of course).
I | Shows/hides info about the current song.
C | Shows/hides the current Visuals configuration (the name of the current waveform, style, and color scheme) in the upper-right corner of the screen.
M | Turns slideshow mode on or off. In slideshow mode, the visuals keep changing color and waveform as they play. (Otherwise, the visuals stick with one style and color.)
B | Turns on an Apple logo in the center of the Visuals screen.
R | Chooses a new waveform/style/color at random.
Q or W | Cycles through the various waveform styles stored in iTunes.
A or S | Cycles though variations on the currently selected waveform.
Z or X | Cycles through color schemes.
Number keys | Cycle through the ten different preset, preprogrammed waveform/color/style configurations.
D | Restores the default waveform settings.

TIP

These are the secret keystrokes for the built-in visuals. The Web is crawling with add-on modules that have secret keystrokes of their own.

10.3.5.2 Keyboard control

You can control iTunes' music playback using its menus, of course, but the keyboard can be far more efficient. Here are a few of the control keystrokes worth noting:

Function | Keystroke
Play, Pause | Space bar
next song/previous song | right arrow, left arrow
next source/previous source | down arrow, up arrow
louder | -up arrow
quieter | -down arrow
mute | -M
fast-forward, rewind | Option- [image] -right arrow, -left arrow
eject | -E
Turn Visuals on | -T
Turn Visuals off | -T or mouse click
Full-screen visuals | -F
Exit full-screen visuals | -T, [image] -F, or mouse click

TIP

You can also control CD playback from the Dock. Just Control-click the iTunes icon (or click and hold on it) to produce a pop-up menu offering playback commands like Pause, Next Song, and Previous Song, along with a display that identifies the song currently being played.

10.3.5.3 Playing with the graphic equalizer

If you click the Graphic Equalizer button (identified in Figure 10-4), you get a handsome control console that lets you adjust the strength of each musical frequency independently (see Figure 10-5).

Figure 10-5. Drag the sliders (bass on the left, treble on the right) to accommodate the strengths and weaknesses of your speakers or headphones (and listening tastes). Or save yourself the trouble—use the pop-up menu above the sliders to choose a canned set of slider positions for Classical, Dance, Jazz, Latin, and so on. In iTunes 3, these settings even transfer to the iPod.
10.3.5.4 Preventing ear-blast syndrome

Here's a clever touch: In the iTunes [image] Preferences dialog box, if you click the Effects icon, you see a new checkbox called Sound Check. Its function is to keep the playback volume of all songs within the same basic level, so that you don't have to adjust the volume to compensate for different recorded levels. (This setting, too, gets transferred to your iPod.)

10.3.6 Copying (Ripping) CD Songs to Your Hard Drive

iTunes lets you convert your favorite songs from audio CDs into MP3 files on your hard drive. Once they've been transferred to your Mac, you can play them whenever you like, without even requiring the original CD.

To rip a CD in this way (as aficionados would say), make sure that only the songs you want to capture have checkmarks in the main list. (The bottom of the window shows you how many songs are on the CD, their total playback time, and how many megabytes of disk space it would take to copy them to your hard drive.) Then click the Import button at the upper-right corner of the window (see Figure 10-6).

Figure 10-6. Watch the display at the top of the window to see how long the conversion is going to take, and which song iTunes is working on. (You can click the tiny X in this display window to cancel the importing.) As iTunes finishes processing each song, you see a small, circled checkmark next to its name in the main list to remind you that you've got it on board and no longer need the CD in your machine.

When it's all over, you'll find the imported songs listed in your Library (click the Library icon in the left-side Source list). From there, you can drag them into any other "folder" (playlist), as described next.

iPod Independence

Out of the box, the iPod and iTunes come set for automatic synchronization. That is, as soon as you hook them together, iTunes sends your complete music library (the contents of your Library "folder" in iTunes) to the iPod. The iPod's songs and playlists always match the Mac's.

Apple's idea here was to ensure that you don't use the iPod as a glorified piracy machine. Your iPod gets its music from your Mac, but can't put its songs onto a Mac.

At least that's the theory. It didn't take long, however, for shareware programmers to create ways to transfer music from the iPod to your Mac. These programs are called things like XPod and PodMaster 1000, and most are free. You can find them by visiting www.versiontracker.com and searching for iPod.

10.3.7 Playlists—and Smart Playlists

When you click the Library icon in the left-side Source list, the main part of the screen displays every MP3 file iTunes knows about. It's organized much like a Finder window, with columns indicating the song length, singer or band, album, and so on. As always, you can rearrange these columns by dragging their headings, sort your list by one of these criteria by clicking its heading, reverse the sorting order by clicking the heading a second time, and so on. And here's the best part: To find a particular song, just type a few letters into the Search blank above the list. iTunes hides all but the ones that match.

TIP

If you click the Browse eyeball icon in the upper right (if you don't see it, click Library in the Source list), the iTunes window changes to show you three panes. At the upper left, you see a list of the singers or bands. Click one to see, in the upper-right panel, a list of the albums by that group. Either way, you see a list of the matching songs in the bottom half of the window. The point of all this is to give you a quick way to narrow down your database when you want to see only the songs on one album, or from one artist.

Apple recognizes that you may not want to listen to all your songs every time you need some tunes. That's why iTunes lets you create playlists—folders in the Source list that contain only certain songs, like albums of your own devising. You might create one called Party Tunes, another called Blind Date Music, and so on.

10.3.7.1 Creating playlists

To create a new playlist, click the New Playlist button in the lower-left corner of the window, or choose File [image] New Playlist ( [image] -N). (Alternatively, if you've already highlighted certain songs—by [image] -clicking them or Shift-clicking them as though they were files in a Finder list—you can choose File [image] New Playlist From Selection. iTunes creates a new playlist that contains only the songs you highlighted.)

A new playlist appears as an icon in the list at the left side of the screen. You can rename it by clicking, and add songs to it by dragging them out of the main list.

TIP

Songs in the Playlist are like aliases to the contents of your Library. That is, deleting a song from a playlist doesn't delete it from the Library (or your hard drive). Similarly, it's fine to add the same song to as many different playlists as you like, as you're not actually increasing the size of your Library.

10.3.7.2 Playing with criteria

iTunes 3's Smart Playlists are lists that constantly rebuild themselves according to criteria you specify. You might tell one Smart Playlist to assemble 45 minutes' worth of songs that you've rated higher than four stars but rarely listen to, and another to play your most-often-played songs from the Eighties. Later, you can listen to these playlists with a turn of the iPod's control dial, uninterrupted and commercial-free.

TIP

iTunes automatically tracks how many times you've played each song, the band name, and other criteria. The rating is one Smart Playlist criterion you have to input yourself.

To rate a song, make the window wide enough that you can see the My Rating column. Then just click in the My Rating column for a selected song. The appropriate number of stars appears—one, two, three, four, or five—depending on the position of your click. You can change a song's rating as many times as you like—a good thing, considering the short shelf life of many a pop hit these days.

To make a smart playlist, choose File [image] New Smart Playlist (Option- [image] -N). The dialog box shown in Figure 10-6 appears. The controls here are something like a music-only version of the Find command in the Finder; in essence, they're designed to set up a search of your music database. Figure 10-7, for example, illustrates how you'd find 74 minutes' worth of Beatles tunes released between 1965 and 1968—that you've rated three stars or higher and haven't listened to more than a couple of times.

When you click OK, your Smart Playlist is ready to show off. When you click its name in the Source list, the main song list updates itself according to your criteria and any changes in your music collection. (Smart Playlists get transferred to your iPod, but don't continue to update themselves there.)

Figure 10-7. The Smart Playlist dialog box is really a powerful search command (because iTunes is really a powerful database). You can set up criteria like the hunt for particular Beatles tunes illustrated here. Then, thanks to the "Live updating" checkbox, iTunes will keep this playlist updated as your collection changes, as you change your ratings, and as your Play Count changes.

10.3.8 iTunes: Burning Music CDs

If your Mac has a CD burner, Mac OS X can serve as your own private record label. iTunes can record selected sets of songs, no matter what the original sources, onto a blank CD. When it's all over, you can play the burned CD on any standard CD player, just like the ones from Tower Records—but this time, you hear only the songs you like, in the order you like, with all of the annoying ones eliminated.

TIP

Use CD-R discs. CD-RW discs are not only more expensive, but may not work in standard CD players. (Not all players recognize CD-R discs either, but the odds are better.)

Start by creating a playlist for the CD you're about to make. Drag the songs you want onto its "folder icon" (out of your Library list, for example). Click its icon in the left-side Source list to see the list you've built. Take a moment to drag them up or down in the list to reflect their playback order. Keep an eye on the readout at the bottom of the list, which tells you how much time the songs will take. (About 74 minutes of AIFF audio files fit on one CD. But if you make an MP3 CD instead, as described in the following tip, you can hold ten times as much, or more. Note, though, that MP3 CDs don't play on all CD players—only those advertised with this feature.)

TIP

You can control how many seconds of silence iTunes leaves between tracks on your custom CD. Choose iTunes [image] Preferences, click the Burn icon, and make a selection from the Gap Between Tracks pop-up menu. This is also where you specify whether you want to make a standard audio CD or a CD in the newer, less compatible MP3 CD format (which holds much more music per disc).

When everything is set up, click the Burn CD button in the playlist window. Insert a blank CD into the Mac and then click Burn CD again.

The burning process takes some time. You can always cancel by clicking the tiny X button in the progress bar, but feel free to work in other programs while iTunes chugs away.

TIP

iTunes can burn CDs using any built-in CD burner or those from most major manufacturers. If your drive isn't on Apple's list, you'll need the help of a program like Toast Titanium (www.roxio.com). Launch Toast and prepare to burn a new CD, choosing Audio CD as the Format. Then drag and drop selections from an iTunes playlist directly to the Toast window and click Burn. Toast burns your custom CD using the files you encoded, organized, and ordered in iTunes.

Internet Radio

Audio CDs and MP3 files aren't the only sources of musical and spoken sound you can listen to as you work. iTunes also lets you tune in to hundreds of Internet-based radio stations, which may turn out to be the most convenient music source of all. They're free, they play 24 hours a day, and their music collections make yours look like a drop in the bucket.

Click Radio in the left-side Source list. In the main list, you'll see categories like Blues, Classic Rock, Classical, and so on, as shown here. Click the flippy triangle to see a list of Internet radio stations in that category.

When you see one that looks interesting, click it and then click the Play button. (The higher the number in the Bit Rate column, the better the sound quality. Note, though, that 128 Kbps is generally too rich for dial-up modems, and may sputter or fail to connect.) Wait a moment for your Mac to connect to the appropriate Internet site, and then let the music begin!

Unfortunately, there's no easy way to capture Internet broadcasts or save them onto your hard drive. You can, however, drag the name of one into the Source list to make it easier to access later on.

If you discover other Internet radio stations that sound interesting, choose Advanced [image] Open Stream, type in the station's Web address (URL), and press Return.


10.4 Playing DVD Movies

If your Mac has a DVD drive (or a combo DVD/CD-RW drive or SuperDrive), you're in for a treat. Your Mac can play rented or purchased Hollywood movies on DVD as though it was born to do so.

Watching movies on your Mac screen couldn't be simpler: Just insert the DVD. The Mac automatically detects that it's a video DVD—as opposed to, say, one that's just filled with files—and launches the DVD Player program (Figure 10-8).

Figure 10-8. Top: DVDs on your screen! Bottom: You can orient this controller either horizontally or vertically on your screen by choosing one of the commands in the Controls Select Controller Type submenu. You can also do without this remote control altogether, since all of its buttons have keyboard equivalents.

NOTE

DVD Player doesn't work (and doesn't even get installed) on certain older Macs, including bronze-keyboard PowerBook G3 (Lombard) laptops and early blue-and-white Power Macs.

If DVD Player doesn't start up automatically when you insert a DVD movie, you can open it yourself. It's sitting there in your Applications folder. (Then fix the problem as described in Section 8.3.)

If DVD Player starts out playing your movie in a window, your first act should be to choose one of the commands from the Video menu to enlarge the picture. Maximum Size is better, except that it leaves the Dock and the menu bar exposed.

For best results, choose Video [image] Enter Full Screen ( [image] -0). At this point, the movie screen fills your entire monitor—even the menu bar disappears. (To make it reappear, just move your cursor near the top of the screen.)

At this point, you're ready to play the movie. By far the easiest way is to just press the Space bar—once to start, again to pause, again to start again.

You can also use the "remote control," which is deconstructed in Figure 10-8. Its buttons include:

  • Menu. Most DVD movies offer a main-menu screen that lists its various segments, extra features, setup screen, and so on. Click this button to summon the menu. (You must click Play before you can use this button or the next.)

  • Title. Takes you directly to the feature presentation: the movie itself.

    NOTE

    Not all DVDs have been programmed to respond to these buttons. If it's any consolation, these DVDs wouldn't respond to the Menu and Title buttons on a physical DVD player's remote control, either.

  • Eject. Ejects the DVD.

  • Play/Pause, Stop, Rewind, Fast Forward. These controls do just what you'd expect. Only the Rewind and Fast Forward buttons need explanation: You must hold the mouse button down on one of these buttons to scan forward or backward through the movie. You control the speed of this rewinding or fast-forwarding by choosing from the Controls [image] Scan Rate submenu.

    TIP

    For maximum control, don't even bother with the Rewind and Fast Forward buttons. Instead, control these functions from the keyboard. Press [image] -right arrow to fast-forward; press that combination repeatedly to cycle from twice to either four or eight times normal speed. Similarly, press [image] -left arrow to scan backwards, rewinding at two, four, or eight times normal speed by pressing it repeatedly. Click Play (or press the Space bar) to resume normal playback.

  • [Arrow buttons], Enter. Use these control keys to choose the various menu options and buttons on your movie DVD's screens. (Clicking the red pills on the credits screens of The Matrix, for example, unlocks secret extra features—DVD Easter eggs.)

  • Volume slider. You can make the movie louder or quieter either by dragging the slider or by repeatedly tapping [image] -up or -down arrow. That's a good keystroke to remember when you've hidden the remote control itself.

If you click the tiny handle identified in Figure 10-8 while the movie is playing, the remote control sprouts an added bank of controls. They include:

  • Slow motion. Click this button three times to slow down the movie more, more, and more. One more click restores original speed.

  • Frame advance. Plays one frame of the movie at a time, of course. Ideal for spotting the director's foot in a shot, the piece of spinach in Julia Roberts's teeth, the "hanging Munchkin" in The Wizard of Oz, and so on.

  • Return. If you leave the movie to visit the DVD's menu, this button returns you to the spot in the movie where you stopped.

  • Subtitle. Most Hollywood DVDs have been programmed with onscreen subtitles to help those with hearing impairments and people sitting in noisy bars. Click this button to turn on the subtitles, again to hide them. (You can specify the language you want—English subtitles, Spanish subtitles, or whatever the DVD offers—by choosing DVD Player [image] Preferences, clicking the Disc tab, and choosing a language from the Subtitle pop-up menu.)

  • Language. Each time you click this button, the movie's soundtrack will switch to a different language (if, in fact, alternate soundtrack languages have been provided). You'll see the name of each language appear briefly onscreen.

    TIP

    For real fun, turn on English subtitles but switch the soundtrack to a foreign language. No matter how trashy the movie you're watching, you'll gain much more respect from your friends and family when you tell them that you're watching a foreign film.

  • Angle. Technically, movie companies can program a DVD so that you can switch camera angles during certain scenes. You'll probably go for years without ever seeing a movie that's been programmed this way. But if you get lucky, this is the button to click to switch from one camera angle to another.

10.4.1 Ditching the Remote Control

There's really no reason to leave the remote control onscreen. When you're playing the movie in full-screen mode, as you should be, the remote control blocks your view every bit as effectively as a lady in the movie theater who refuses to take off her flower hat.

Choose DVD Player [image] Preferences. In the Preferences dialog box shown in Figure 10-9, "Hide Controller If Inactive For __ Seconds" should be turned on. Change the number of seconds before the remote disappears automatically according to your tolerance.

Figure 10-9. If you turn on Enable Viewer Resizing In Full Screen, you'll be able to use the Video menu to change the size of the "screen" on your screen even while you're in full-screen mode. (Remember to move the mouse near the top of the monitor to make the menu bar reappear.)

Once the remote control is hidden, you can always bring it back onscreen just by moving your mouse around. But the true DVD master would never bother with such a sissy technique. The secret keystrokes of DVD Player—some of which, mercifully, are the same as in iTunes—are all you really need to know:

Function | Keystroke
Play, Pause | Space bar
fast-forward | -right arrow
rewind | -left arrow
louder | -up arrow
quieter | -down arrow
mute | -K
next/previous "chapter" | right arrow, left arrow
main menu | -~ (upper left of your keyboard)
full-screen mode | -0
half, normal, maximum size | -1, -2, -3
eject | -E
show/hide remote control | Control-C
remote control orientation | Shift- [image] -H (horizontal), Shift- [image] -V (vertical)
show/hide "movie screen" | Control-V
show movie Info | -I

TIP

Watching a movie while sitting in front of your iMac or Power Mac is not exactly the great American movie-watching dream. But remember that you can connect the video-output jacks of your Mac (most models) to your TV for a much more comfortable movie-watching experience.

Just be sure to connect the cables from the Mac's video-output jacks directly to the TV. If you connect them to your VCR instead, you'll get a horrible, murky, color-shifting picture—the result of the built-in copy-protection circuitry of every VCR.

Region Changing

The first time I tried to play a DVD, I got this weird message about initializing the region code. What's up with that?

Hollywood generally releases each movie in each part of the world at different times; a movie may come out on video in the U.S. when it's just hitting screens in Europe. We certainly can't have people watching a DVD before the movie studio says it's OK! That's why many discs are region-locked, so that they play back only on players in certain geographical regions.

As a DVD player in disguise, your Mac is just doing its duty. You can change its region (you'll be offered the chance to do so when you insert a region-locked DVD from another region), but only five times—and then it's frozen forever in the fifth version, or at least until you erase your hard drive and start over.

As shown here, the dialog box shows you which region your DVD is designed for: 1 for the U.S. and Canada; 2 for Japan, Europe, South Africa, and the Middle East; 3 for Southeast and East Asia; 4 for Australia, New Zealand, Pacific Islands, Central America, Mexico, South America, and the Caribbean; 5 for Eastern Europe, Africa, and North Korea; 6 for China; and 8 for airplanes, cruise ships, and so on. (There is no Region 7. Maybe it's reserved for the empty spot in movie executives' hearts.)


Part IV: The Technologies of Mac OS X

Chapter 11: One Mac, Many Users

Chapter 12: Networking

Chapter 13: Graphics, Fonts, and Printing

Chapter 14: Sound, Movies, Speech, and Handwriting

Chapter 15: Terminal: Doorway to Unix

Chapter 16: Fun with Unix

Chapter 17: Hacking Mac OS X


Chapter 11. One Mac, Many Users

For years, teachers, parents, and computer lab instructors have struggled to answer a difficult question: How do you rig one computer so that several different people can use it throughout the day, without disrupting each others' files and settings? And how do you protect a computer from getting fouled up by mischievous (or bumbling) students and employees?

Mac OS X solves the problem swiftly and thoroughly. Like the Unix under its skin (and also like Windows XP and Windows 2000), Mac OS X is designed from the ground up to be a multiple-user operating system. A Mac OS X machine can be configured so that everyone must log in. If it is, you have to click or type your name and type in a password when the computer turns on. And upon doing so, you discover the Macintosh universe just as you left it, including these elements:

  • Your icons on the desktop and in the Dock

  • Your desktop picture, screen saver, and language settings

  • Your Dock settings (small or large icons, bottom or side of the screen, and so on)

  • Your Web browser bookmarks, Web browser preferred home page, and email account

  • Your personally installed programs and even fonts

  • Your choice of programs that launch automatically at startup

If you're the only person who uses your Mac, you can safely skip this chapter. You will be using one of these accounts, whether you realize it or not—it's just that there won't be any other accounts on your Mac, so it'll appear as though you're using a Mac just as you always have. The Mac will never ask you for the name and password you made up when you installed Mac OS X, because Apple's installer automatically turns on something called automatic login (Section 11.3).

Even so, when you're stuck in line at the Department of Motor Vehicles, you may find the concepts presented here worth skimming, as certain elements of this multiple-user operating system may intrude upon your solo activities—and the discussions in this book—from time to time.

TIP

Even if you don't share your Mac with anyone and don't create any other accounts, you might still be tempted to learn about this feature because of its ability to password-protect the entire computer. All you have to do is to turn off the automatic login feature described in Section 11.3. Thereafter, your Mac is protected from unauthorized fiddling when you're away from your desk or when your laptop is stolen. (There is a backdoor or two—pre-2003 Macs can be started up from a Mac OS 9 disk, for example—but this step is better than nothing. And The Open Firmware Password tells you how to close the backdoors.)


11.1 Introducing User Accounts

When you first installed Mac OS X, as described in Appendix A, you were asked for a name and password. You may not have realized it at the time, but you were creating the first user account on your Macintosh. Since that fateful day, you may have made a number of changes to your desktop—adjusted the Dock settings, set up your folders and desktop the way you like them, added some favorites to your Web browser, and so on—without realizing that you were actually making these changes only to your account.

Figure 11-1. When you set up several accounts, you don't turn on the Mac so much as sign into it. A command in the menu called Log Out also summons this sign-in screen. Click your own name, and type your password, to get past this box and into your own stuff.

As noted in Chapter 2, you've probably been saving your documents into your own Home folder, which is the cornerstone of your own account. This folder, named after you and stashed in the Users folder on your hard drive, stores not only your own work, but also your preference settings for all the programs you use, special fonts that you've installed, programs you've installed for your own use, and so on.

Now then: If you create an account for a second person, when she turns on the computer and signs in, she'll find the desktop exactly the way it was factory-installed by Apple—blue swirling desktop picture, Dock along the bottom, the default Web browser home page, and so on. She can make the same kinds of changes to the Mac that you've made, but nothing she does will affect your environment the next time you log in. You'll still find the Mac desktop the way you left it: Your desktop picture fills the screen, the Web browser lists your bookmarks, the Dock lists your favorite documents, and so on.

In other words, the multiple-accounts feature has two components: first, a convenience element that hides everyone else's junk; and second, a security element that protects both the Mac's system software and other people's work.


11.2 Setting Up Accounts

If you like the idea of this multiple-accounts business, begin by opening System Preferences. In the System Preferences window, click Accounts.

The screen shown in Figure 11-2 appears, showing the list of everyone who has an account. If you're new at this, there's probably just one account listed here—yours. This is the account that Mac OS X created when you first installed it.

11.2.1 Administrator Accounts

It's important to understand the phrase you see in the Kind column. On your own personal Mac, it probably says Admin next to your name. This, as you could probably guess, stands for Administrator.

Because you're the person who installed Mac OS X to begin with, the Mac assumes that you are its administrator—the technical wizard who's in charge of it. You're the teacher, the parent, the resident guru. You're the one who will maintain this Mac. Only an administrator is allowed to:

  • Install new programs into the Applications folder.

  • Add fonts (to the Library folder) that everybody can use.

  • Make changes to certain System Preferences panels (including Network, Date & Time, Energy Saver, Login, and Startup Disk).

  • Use the NetInfo Manager and Disk Utility programs.

  • Create new folders outside of your Home folder.

  • Decide who gets to have accounts on the Mac.

  • Open, change, or delete anyone else's files (Section 11.4).

In the olden days, there may have been a few Mac-heads who took charge of maintaining the computers, but there was no such thing as an Administrator account. This is unfamiliar terrain for most Mac fans.

But the notion of administrators is an important pill to swallow. For one thing, you'll find certain settings all over Mac OS X that you can change only if you're an administrator—including those in the Accounts panel itself (see Figure 11-2). For another thing, whether or not you're an administrator plays an enormous role when you want to network your Mac to other kinds of computers, as described in the next chapter. And finally, in the bigger picture, the fact that the Mac has an industrial-strength accounts system, just like traditional Unix and Windows 2000 operating systems, gives it a fighting chance in the corporations of America.

As you create accounts for other people who'll use this Mac, you'll be offered the opportunity to make each one an administrator just like you. Needless to say, use discretion. Bestow these powers only upon people as responsible and technically masterful as you.

11.2.2 Normal Accounts

Anyone who isn't an administrator will probably just be an ordinary, everyday Normal account holder. In Figure 11-2, that includes anyone whose account doesn't say Admin.

Figure 11-2. The screen lists everyone for whom you've created an account. From here, you can create new accounts or change people's passwords. Notice the padlock icon at the bottom: Whenever you see it, you're looking at settings that only administrators are allowed to change.

These people will have everyday access to their own Home folders and to some of the System Preferences, but most other areas of the Mac will be off-limits. Mac OS X won't even let them create new folders on the main hard drive, except inside their own Home folders (or in the Shared folder described later).

A few of the System Preferences panels contain a padlock icon like the one in Figure 11-2. If you're a Normal account holder, you can't make changes to these settings without the assistance of an administrator. Fortunately, you aren't required to log out so that an administrator can log in and make changes. You can just call the administrator over, click the padlock icon, and let him type in his name and password—if, indeed, he feels comfortable with you making the changes you're about to make.

11.2.3 Adding an Account

To create a new account, click New User. The dialog box shown in Figure 11-3 appears. This is where you fill in certain information about the new account holder.

  • Name. If it's just the family, this could be Chris or Robin. If it's a corporation or school, you'll probably want to use both first and last names.

  • Short Name. Particularly if your name is, say, Alexandra Stephanopoulos, you'll quickly discover the value of having a short name—an abbreviation of your actual name. When you sign into your Mac in person, you can use either your long or short name. But when you access this Mac by dialing into it or connecting from across the network (as described in the next chapter), the short variation is all you need.

    As soon as you tab into this field, the Mac proposes a short name for you. You can replace the suggestion with whatever you like, as long as it's fewer than eight characters and all lowercase letters.

  • Password, Verify. If you click the Password tab of the dialog box, you'll see where you're supposed to type this new user's password (Figure 11-3, bottom). In fact, you're supposed to type it twice, to make sure you didn't introduce a typo the first time. The Mac displays only dots as you type, to guard against the possibility that somebody is watching over your shoulder.

    TIP

    The password must be at least four characters long; capitalization counts. As for the maximum length: Mac OS X 10.2 no longer limits your password length to eight characters long. Oddly, though, only the first eight characters matter—Mac OS X ignores whatever you type after that.

    The usual computer book takes this opportunity to stress the importance of a long, complex password—a phrase that isn't in the dictionary, something made up of mixed letters and numbers. This is excellent advice if you create sensitive documents and work in a big corporation.

    But if you share the Mac only with a spouse or a few trusted colleagues in a small office, for example, you may have nothing to hide. You may see the multiple-users feature more as a convenience (keeping your settings and files separate) than a protector of secrecy and security. In these situations, there's no particular urgency to the mission of thwarting the world's hackers with a convoluted password. In fact, you may want to consider setting up no password—leaving both password blanks empty. Later, whenever you're asked for your password, just leave the Password box blank. You'll be able to log in that much faster each day.

    NOTE

    In previous versions of Mac OS X, only Normal account holders could have blank passwords. Mac OS X forced you to assign a password for any new Administrator accounts you created here.

    In 10.2, you can also create Administrator accounts with no password. No matter what kind of account you create, however, a dialog box will scold you if you fail to provide a password. Just click Ignore.

  • Password Hint. If you gave yourself a password, you can leave yourself a hint in this box. If your password is the middle name of the first person who ever kissed you, for example, your hint might be "middle name of the first person who ever kissed me."

    Later, if you ever forget your password, the Mac will show you this cue to jog your memory (if you've left this option turned on, as described in Section 11.3).

  • Login Picture. The usual Mac OS X sign-in screen (Figure 11-1) displays each account holder's name, accompanied by a little picture.

    You can choose a little graphic for yourself using any of several methods. If you like the selections that Apple has provided along the bottom of the window (drag the horizontal scroll bar to see them all), just click one to select it. If there's another graphics file somewhere on the hard drive that you prefer—a digital photo of your own head, for example—you can click the Choose Another button. You'll be shown a list of what's on your hard drive so that you can select it.

    TIP

    You can also click out of this window, find the graphics file you want (in almost any conceivable graphics format) in whatever window contains it, and drag the graphic itself onto the Login Picture box, as shown in Figure 11-3.

  • Allow user to administer this computer. This is the big one: the master switch that turns this ordinary, unsuspecting computer user into an administrator, as described previously.

  • Allow user to log in from Windows. Here's one of the most important new features in Mac OS X 10.2: the option that lets you connect to your Mac from across a network while seated at a Windows PC. Step-by-step instructions begin in Section 12.3. For now, it's enough to know that anyone who tries to connect to this Mac from a PC must (a) have an account on the Mac and (b) have this checkbox turned on.

When you're finished with the settings, click Save (or press Enter). After a moment, you return to the Users list, where the new person's name joins the names that were already there. You can continue adding new accounts forever or until your hard drive is full, whichever comes first.

Figure 11-3. You can drag a graphic out of a Finder window right onto the Login Picture. This is also where you specify a password for your new user, designate whether or not this lucky individual will be an administrator, and say whether or not he can connect via a Windows PC from the network.

11.2.4 The Capabilities Screen

Once you're back at the list of accounts, a new Mac OS X 10.2 feature (or rather, a reincarnated Mac OS 9 feature) affords you the opportunity to shield your Mac—or its very young, very fearful, or very mischievous operator—from confusion and harm. This is a great feature to remember when you're setting up accounts for students, young children, or easily intimidated adults.

Clicking the name of any Normal account and then clicking Capabilities reveals a broad array of muzzles you can place over the usual Mac OS X design:

  • Simple Finder. This is a new spin on a little-used Mac OS 9 feature that strips away most of the menus and icons from the Finder, presenting only a bare, goof-proof screen.

  • Limited access. By tinkering with the checkboxes here, you can declare certain programs off-limits to this account holder, or turn off his ability to remove Dock icons, burn CDs, and so on.

Details on Simple Finder and the other limits on the Capabilities screen are in Section 11.5.

11.2.5 Editing Name, Password, and Picture

Administrators have all the fun, but even peon Normal users are permitted to change their passwords and startup pictures. In fact, Mac OS X 10.2 provides two different paths to these controls: one that lets you change your own account settings, and another that lets administrators change anyone's settings.

  • To change your own account. Open System Preferences. Click the My Account icon.

  • To change someone else's account. Be an administrator. Open System Preferences. Click the Accounts icon. Changing the settings is very easy: just double-click somebody's name in the Users list. (Or, if it's a slow day at work, click the name and then click Edit User.)

Either way, a variation of the dialog box shown in Figure 11-3 appears; this is where you can change whatever settings you like. (Well, almost any settings: Only administrators can change an account's name—and even they can't change an account's short name once the account has been created.)

11.2.6 Setting Up Your Startup Items

There's one additional System Preferences setting pertaining to accounts, one that the account holders can take care of themselves. Each user can decide which programs or documents open automatically upon login.

To choose your own crew of self-starters, open System Preferences and click the Login Items icon. As shown in Figure 11-4, you can now build a list of programs, documents, networked disks, and other goodies that will auto-launch each time you log in. You can even turn on the Hide checkbox for each one, so that the program is running in the background at login time, waiting to be called into service with a quick click, rather than constantly being in your face.

Figure 11-4. You can add any icon to the list of things you want to start up automatically. Click Add to summon the Open dialog box where you can find the icon, select it, and then click Choose. Better yet, if you can see the icon of whatever-it-is in a folder or disk window (or on the desktop), just drag it directly into this list. You can specify the order in which your startup items auto-open just by dragging them up or down in the list. To remove an item, click it in the list and then click Remove.

TIP

Don't bother trying to add Classic to this list. As noted in Chapter 5, it is a great idea to have Classic start up automatically upon login. However, you set it up using a checkbox on the Classic pane of System Preferences, not on the Login pane.

Don't feel obligated to limit this list to programs and documents, by the way. Thanks to a little-heralded Mac OS X 10.2 enhancement, you can now make startup items out of disks, folders, servers on the network, and other fun icons. Used judiciously, this feature can save you a huge amount of time each morning.

11.2.7 Deleting User Accounts

Hey, it happens: Somebody graduates, somebody gets fired, somebody dumps you. Sooner or later, you may need to delete a user account from your Mac.

Deleting somebody's account doesn't delete all of the corresponding documents, settings, and so on. All of the dearly departed's folders remain on the Mac—but in a tidy digital envelope that doesn't clutter your hard drive, and can be reopened in case of emergency.

NOTE

The whole business of deleting an account and resurrecting its contents, if necessary, is drastically simplified in Mac OS X 10.2. If you're used to the hassles of doing so in previous Mac OS X versions, you'll enjoy reading this far shorter writeup.

To delete a user account, click the appropriate name in the Accounts list (Figure 11-2) and then click Delete User. As shown in Figure 11-5, Mac OS X now provides a capsule summary of what's about to happen, as described in the following paragraphs. Click OK, and then read on.

Figure 11-5. Top: This dialog box lets you know where to find the deleted account's material, should the need arise. Bottom: The files and settings of accounts you deleted live on, in the Users Deleted Users [name] folder.

Once you, an administrator, have deleted somebody's account, its name no longer appears in the Accounts list. Yet its files and settings live on—in the Users [image] Deleted Users folder. Inside is a folder named for the dearly departed, and inside that is a disk image file (.dmg) like the ones described in Section 4.8.2. If you double-click it, you'll find a new, virtual disk icon on your desktop named for the deleted account. As shown in Figure 11-5, you can open folders and root through the stuff in this "disk," just as if it were a living, working Home folder.

If fate ever brings that person back into your life, you can use this disk-image business to reinstate the deleted account. Start by creating a brand-new account. Then copy the contents of the folders in the mounted disk image (Documents, Pictures, Desktop, and so on) into the corresponding folders of the new Home folder.

Moving Your Home Folder Between Computers

Mac OS X proposes putting all of the account holders' Home folders in one special folder (Users) on the main hard drive. But being able to put somebody's Home folder—such as your own—on a different disk can have its advantages, too. If you travel back and forth between home and work, for example, you might find it convenient to keep your entire life on an iPod, Zip, or some other portable disk.

You can do it, but you'll have to exploit the sometimes intimidating power of NetInfo Manager, a program included with Mac OS X that's designed to let you perform just such technical tasks.

You'll find this program in your Applications [image] Utilities folder. Open the program, click the lower-left padlock, and then enter an administrator's name and password.

In the second column, click users. In the column to its right, click the name of the account whose Home folder you want to move—let's say it's chris.

In the bottom half of the window, scroll down until you see an entry called home. In the next column, you'll see its current location: /Users/chris (that is, the Home folder is called chris, and it's in the Users folder).

Double-click this notation (/Users/chris) to edit it. Change this text to /Volumes/diskname, where diskname is the name of your removable disk. ("Volumes" is the name of an invisible folder on your Mac OS X machine that lists the names of all disks present.) Press Enter, and then choose Domain [image] Save (and click "Update this copy" in the confirmation box).

Log out and then log back in again—as Chris. You should see by the house-shaped icon on your desktop that the Zip disk is now, in effect, your Home folder, complete with all the usual Home-folder subfolders (Desktop, Documents, Library, and so on).

You're not allowed to remove the disk from the Mac until you've logged out and logged back in under a different account. Once you've done so, eject the disk and take it to work (or wherever the other Mac OS X machine is). Insert the disk and then repeat all of these steps so far.

From now on, both Macs will expect to find your Home folder on that removable disk. (Make sure that you've inserted it and given it time to "spin up" before you log in.)

And by the way, the procedure described here will leave the original Chris folder on the primary hard drive—an orphaned duplicate. It's not doing any harm, but if you find its presence confusing, you can always delete it by restarting your Mac in Mac OS 9, thereby bypassing Mac OS X's stringent permissions system.


11.3 Setting Up the Login/Logout Process

Once you've set up more than one account, the dialog box shown in Figure 11-1 appears whenever you turn on the Mac (or whenever you relinquish your turn at the Mac by choosing [image] [image] Log Out). But a few extra controls let you, an administrator, set up either more or less security at the login screen—or, put another way, build in less or more convenience.

11.3.1 Login Options

Open System Preferences, click Accounts, and then click the Login Options tab (see Figure 11-6). Here are some of the ways you can shape the login experience:

  • Display Login Window as. Under normal circumstances, the login screen presents a list of account holders when you power up the Mac, as shown in Figure 11-1. That's the "List of users" option in action.

    If you're especially worried about security, however, you might not even want that list to appear. If you turn on "Name and password," each person who signs in must type in both his name and his password—a very inconvenient, but secure, arrangement. (The "List of users" screen is also the only way to log in as >console, a troubleshooting technique described in Section B.11. It's also one way to sign in with the root account [Section 11.7] once you've activated it.)

    TIP

    You don't have to visit System Preferences just to turn on the "Name and password" screen; you can also do it on the fly, when you're signing in.

    When the usual "List of users" screen appears at sign-in time, complete with pictures of flowers and kitties, press the down-arrow key to highlight one name. Then press Option-Return. Like magic, the "List of users" screen changes to the "Name and password" screen, so you can go about your business without wasting any more time.

  • Hide the Restart and Shut Down buttons. The dirty little secret of the Mac OS X security system is that it's incredibly easy to bypass. Truly devoted evildoers can dodge the standard login screen in a number of different ways: restart in Mac OS 9, restart in FireWire Disk Mode, restart at the Unix Terminal, and so on. Suddenly, these no-goodniks have full access to every document on the machine, blowing right past all of the safeguards you've so carefully established.

    One way to thwart them is to turn on this checkbox. Now nobody can restart the Mac, period. That's plenty of protection in most homes, schools, and workplaces; after all, Mac people tend to be nice people.

    But if you worry that somebody with a pronounced mean streak might restart simply by pulling the plug, then set the Open Firmware password, as described in the box on the facing page.

  • Show password hint after 3 attempts to enter a password. Remember the password hint you created in Section 11.2.3? If you're fumbling to sign in, unable to remember your password, you'll be glad you left this option turned on. It reveals your hint after three attempts to sign in with the wrong password.

Figure 11-6. These options make it easier or harder for people to sign in, offering various degrees of security.

11.3.2 Automatic Login

You can tailor the login process in one final way: by eliminating the need to sign in at all. It's a timesaving, hassle-free arrangement if only one person uses the Mac, or if one person uses it most of the time.

This option moved in Mac OS X 10.2; it's now on the Users tab (of the Accounts panel of System Preferences). If you click Set Auto Login button, as shown in Figure 11-2, you're prompted for the name and password of the lucky person who's receiving this express ticket. Click OK. From now on, the dialog box shown in Figure 11-1 won't appear at all at startup time. After turning on the machine, you, the specified account holder, will zoom straight to your desktop.

Of course, only one lucky person can enjoy this streamlined entrance experience. Everybody else must still enter their names and passwords.

NOTE

Automatic login can be extremely frustrating to the people who don't have the magic ticket. If you think about it, they can restart the Mac for hours, trying and trying to sign into their own accounts—but can't, because you, Mr. or Ms. Bigshot, have set up the Mac so that your account signs on automatically.

The solution is to remember that automatic login kicks in only when you turn on or restart the Mac. When you choose [image] [image] Log Out, the usual login screen appears.

The Open Firmware Password

After all this discussion of security and passwords, it may come as a bit of a shock to learn that enterprising villains can bypass all of Mac OS X's security features in 10 seconds. All they have to do is restart the Mac with a Mac OS 9 CD in the drive, using the Unix console described in Appendix B, using FireWire disk mode (Section 6.2.4), and so on.

But there is one way to secure your Mac completely: by using the Open Firmware Password program. (It's on your original Mac OS X Install CD, Disc 1, in the Applications [image] Utilities folder. You can also download it from the Apple Web site.)

Once you've turned on Open Firmware Password protection, none of the usual startup-key tricks work. Holding down the C key to start up from a CD, holding down N to start up from a NetBoot server, pressing T to start up in Target Disk Mode, [image] -V to start up in Verbose mode, [image] -S to start up in Single-user mode, [image] -Option-P-R key to reset the parameter RAM, pressing Option to start up from a different system disk—none of it works without the master Open Firmware Password.

When you run this little utility, you turn on a checkbox called "Require password to change Open Firmware settings," as shown here. Then you make up a master password that's required even to turn the Mac on.

This password is deadly serious and un-hackable, and there's no backdoor. If you forget the Open Firmware password, you can't change the startup disk ever again. Even Apple can't help you out of that situation.

Once you've entered a password into both boxes, you're asked for an administrator's password. Finally, a message tells you that, "The settings were successfully saved." Restart the Mac.

From now on, whenever you attempt to start up in anything but the usual way (primary hard drive, standard login screen), you'll be asked to type in the Open Firmware password. For example, you'll see it when you press the C key to start up from a CD, or when you press Option to choose a different startup disk or partition.

No amount of clever restarting or inserting of disks can get past this heavily armed gatekeeper.

11.3.3 Logout Options

As you'll read later in this chapter, the usual procedure for finishing up a work session is for each person to choose [image] [image] Log Out. After you confirm your intention to log out, the sign-in screen appears, ready for the next victim.

But sometimes people forget. You might wander off to the bathroom for a minute, run into a colleague there who breathlessly begins describing last night's date and proposes finishing the conversation over pizza. The next thing you know, you've left your Mac unattended but logged in, with all your life's secrets accessible to anyone who walks by your desk.

Fortunately, Mac OS X offers a simple but effective form of protection against this phenomenon: a password-protected screen saver that locks your Mac after a few minutes of inactivity.

In System Preferences, click Screen Effects (described more completely in Section 8.20). Click the Activation tab. Here you'll find a slider that lets you control how much time the Mac waits before password-protecting your screen. Turn on "Use my user account password" to seal the deal. Now, whenever somebody tries to wake up your Mac after the screen saver has appeared, the "Enter your password" dialog box will appear. No password? No access.


11.4 Signing In

Once somebody has set up your account, here's what it's like getting into, and out of, a Mac OS X machine. (For the purposes of this discussion, "you" are no longer the administrator—you're one of the students, employees, or family members for whom an account has been set up.)

11.4.1 Identifying Yourself

When you first turn on the Mac—or when the person who last used this computer chooses [image] [image] Log Out—the login screen shown in Figure 11-1 appears. At this point, you can proceed in any of several ways:

  • Restart. Click if you need to restart the Mac for some reason. (The Restart and Shut Down buttons don't appear here if the administrator has chosen to hide them as a security precaution; see Section 11.3.)

  • Shut Down. Click if you're done for the day, or if sudden panic about the complexity of user accounts makes you want to run away. The computer turns off.

  • Log in. To sign in, click your account name in the list. If you're a keyboard speed freak, you can also type the first letter or two—or press the up or down arrow keys—until your name is highlighted. Then press Return or Enter.

    Either way, the password box appears now (if a password is required). If you accidentally click the wrong person's name on the first screen, you can click Go Back. Otherwise, type your password and then press Enter (or click Log In; see Figure 11-7).

Figure 11-7. If your account was set up with a password, you now encounter the Password box. You can try as many times as you want to type the password in; with each incorrect guess, the entire dialog box shudders violently from side to side, as though shaking its head "No." If you try unsuccessfully three times, your hint appears—if you've set one up.

The Case of the Forgotten Password

Help—I forgot my password! And I never told it to anybody, so even the administrator can't help me!

No problem. Your administrator can simply open up System Preferences, click Users, click the name of the person who forgot the password, and then click Edit to re-establish the password.

But you don't understand. I am the administrator! And I'm the only account!

Aha—that's a different story. Insert the Mac OS X CD. Restart the Mac while pressing down the letter C key, which starts up the Mac from the CD and launches the Mac OS X installer.

On the first installer screen, choose Installer [image] Reset Password. When the Reset Password screen appears, click the hard drive that contains Mac OS X. From the first pop-up menu, choose the name of your account. Now make up a new password and type it into both boxes. Click Save, close the window, click the installer, and restart.

And next time, be more careful! Write down your password on a Post-it note and affix it to your monitor. (Joke—that's a joke!)

11.4.2 Your World

Once you're in, the world of the Mac looks just the way you left it (or the way an administrator set it up for you). As noted in Chapter 2, most of the action revolves around the Applications folder, the Dock, and your own Home folder (press Option- [image] -H to open it).

Mac OS X keeps almost everything in your Mac world separate from anybody else who uses this Mac. A few examples are especially worth noting:

  • Fonts. You can install your own preferred fonts into your Home folder [image] Library [image] Fonts folder. Only you will be able to see them and use them in your programs.

  • Programs. Unless you're an administrator, you'll quickly discover that you're not allowed to install any new programs (or indeed, to put anything at all) into the Applications folder. That folder, after all, is a central software repository for everybody who uses the Mac, and all such universally shared folders are off-limits to everyday account holders. (You can drag things out of the Applications folder, but doing so doesn't actually move them—it just copies them.)

    That's not to say that you can't install new programs of your own. You can—but you must put them somewhere in your own Home folder (where you'll be the only person with access to such programs) or in the Shared folder (if you want other people to be able to use them). You may want to create a Programs folder there just for this purpose.

  • Bookmarks. When you browse the Web, you can freely "bookmark" your favorite Web pages, confident that nobody else who uses your Mac will be able to see where you've been or what you consider your favorite sites.

  • Mail. Your email collection is yours and yours alone. When your sister tries to run the same email program, she'll find her email there.

11.4.3 The Shared Folder

Every Mac OS X machine has a Users folder in the main hard drive window. It contains the individual Home folders of everybody with an account on this machine.

If you try to open anybody else's Home folder, you'll see a tiny red "no go here" icon superimposed on almost every folder inside, telling you: "Look, but don't touch." There are exceptions though. As shown in Figure 11-8, two folders are designed to be distribution points for files your co-workers want you to see: Public and Sites.

Figure 11-8. Top: In other people's Home folders, the Public and Sites folders are available for your inspection. These two folders contain stuff that other people have "published" for the benefit of their co-workers. Middle: In the Public folder is the Drop Box, which serves the opposite purpose. It lets anyone else who uses this Mac hand in files to you. Bottom: Inside the Users folder (to get there from a Home folder, press -up arrow) is the Shared folder, a wormhole between all accounts. Everybody has full access to everything inside.

You, too, have Public and Sites folders in your own Home folder, of course. Here again, anything you put into these folders is available for inspection—although not for changing—by anyone else who uses this Mac.

Sitting in the Users folder is one folder that doesn't correspond to any particular person: Shared. This is the one and only folder that everybody can access, freely inserting and extracting files. It's the common ground among all the account holders. It's Central Park, the farmer's market, and the grocery store bulletin board.

Shared Data Files

My wife and my 8-year-old kid share my Mac. Over the years, we've amassed a fabulous collection of MP3 files, but at the moment, I'm the only one who sees them in iTunes. This business of separate environments for every account holder is all well and good, but what about when we want to access the same files—like our iTunes library?

The problem is that the iTunes library is stored in the Music folder of just one person. Fortunately, the solution is easy enough.

Whoever is the administrator—probably your 8-year-old—should move the iTunes folder (currently in somebody's Music folder) to the Users [image] Shared folder. Now it's available to everybody.

At this point, each account holder can log in, fire up iTunes, choose iTunes [image] Preferences [image] Advanced, and click the Change button to choose the relocated iTunes Music Folder in the Shared folder.

From now on, each person will be able to see and access the entire library of iTunes tunes, but will still enjoy the flexibility to build individual playlists.

11.4.4 Changing Permissions

A factory-fresh installation of Mac OS X offers one way for you to submit files to somebody else (that person's Public folder), one way to accept files from other people (your Drop Box folder), and one community folder (the Shared folder).

This arrangement is relatively secure and relatively easy to understand. But maybe you'd like even more security; you'd rather seal off your Public folder so that people can't see what's inside. Or maybe you'd like greater convenience; you'd like to set up some additional drop box folders, or other "public" folders, for co-workers' use.

The business of changing the permissions, or access privileges, for certain folders can be complex and brain-bending. A full discussion begins in Chapter 16. In the meantime, here's a quick summary of some typical setups.

In each case, you can't make changes unless either (a) you have an Administrator account or (b) it's a folder that you own (it's in your Home folder, or you created it). Begin by highlighting the folder in question, choosing File [image] Get Info, and then expanding the Ownership & Permissions section (see Figure 11-9):

  • Full access by everybody. If you want to turn one of your folders into one that resembles the Shared folder (full free access by anyone with an account), set up its Get Info window like the one shown at left in Figure 11-9.

  • Give, but don't take. To make another folder work like your Drop Box folder (people can put things in, but can't actually open the folder), set things up as shown at middle in Figure 11-9.

    TIP

    Remember that people can't put anything into a new Drop Box-type folder if they can't get to it. That is, make sure you've turned on "Read" access for whatever folder it's in. (Making a Drop Box folder in your Documents folder, for example, won't work—because nobody is allowed to open your Documents folder to begin with.)

  • Look, but don't touch. You can also turn any of your folders into another Public-type, "bulletin-board" folder—that is, people can open or copy files from inside, but they can't put anything in or save any changes they make.

You'll realize the importance of mastering these various access permissions when you get a load of this startling fact: Unless you intervene, everybody else who uses this Mac will be able to peek into everything in every new folder you create (unless it's inside a folder that is, itself, off-limits). Technically speaking, every new folder springs into existence with Read-only permissions for Everyone. They're allowed to open or copy anything inside.

The bottom line: As you type the title of a new folder that you suspect might be best kept private (My Spicy Dreams Journal, let's say), remember to use the File [image] Get Info routine to change the new folder's Everyone and Group settings to None.

(Even so, remember that anyone with an Administrator account can blow your intentions to smithereens. Such people can, at any time, override your ownership and permission settings, even making your folders off-limits to you, if they so desire. That's what you get for using a Mac that you've allowed somebody else to set up for you.)

Figure 11-9. Three typical configurations for folders you've created in your Home folder. Highlight the folder and then choose File Get Info; open the Ownership & Permissions section. Then set the three pop-up menus as shown for a Shared-type folder (left), a drop-box folder (middle), and the "bulletin board" folder (right). Click the "Apply to enclosed items" button if you want the same settings to apply to all the folders inside this one. Finally, close the Get Info window.
    [ Team LiB ]


11.5 Simple Finder and Other "Rubber Walls"

As noted earlier in this chapter, Mac OS 9 offered a clever but little-known feature called Simple Finder. It was designed to protect the Mac from—and make it easier for—the young or easily overwhelmed.

Mac OS X 10.2 has a new version of Simple Finder. It's certainly not a feature you'd ever use, of course, but you might find it extremely useful for someone you love (or at least worry about).

11.5.1 Edit the Account

After creating a Normal account for your lucky friend as described earlier in this chapter, you should wind up on the Accounts panel of System Preferences. Click the account on the Users tab, and then click Capabilities.

Take a break while your Mac scans its hard drive for information about all the programs you've got installed—it can take a minute or two. Eventually, a sheet slides out of the top of the Accounts window, as shown in Figure 11-10.

From here, you can restrict this person's access to the Mac in three different ways, described next.

11.5.2 Limit the Programs

At the bottom of the dialog box shown in Figure 11-10, you see a list of all the programs in your Applications folder (an interesting read in its own right). If you turn on "Use only these applications," you can then turn the programs' checkboxes on or off. Only checked items will show up in the account holder's Applications folder.

TIP

If you don't see a program listed, click the Locate button and find it, or drag its icon from the Finder into the window. You'll have to do that when, for example, a program is inside a folder in the Applications folder, rather than sitting loose as a solo icon there.

If you're setting up an account for use in the classroom, say, you might well want to turn off access to programs like Disk Utility, iChat, and Tomb Raider.

11.5.3 Limit the Features

When you first create a Normal account, all of the checkboxes above the master list of programs are turned on. That is, Normal account holders are free to burn CDs or DVDs, change the icons on the Dock, change their passwords, and view the settings of all System Preferences panels (although they can't change all of these settings).

Depending on your situation, you may find it useful to turn off some of these options. In a school lab, for example, you might want to turn off the ability to burn discs (to block software piracy); if you're setting up a Mac for a technophobe, you might want to turn off the ability to change the Dock (so your colleague won't accidentally lose access to his own programs and work).

11.5.4 Limit the Interface (Simple Finder)

If you're really concerned about somebody's ability to survive the Mac—or the Mac's ability to survive them—then turn on the Use Simple Finder checkbox (Figure 11-10). Also turn on the checkboxes of the programs that person is allowed to use.

Figure 11-10. From the Capabilities window, you can control the capabilities of any user of your system. Turn on Use Simple Finder to limit somebody to an extremely streamlined version of the Finder. Then choose one or more applications from the lower half of the window by turning on the boxes next to their names. Only checked items will show up in the My Applications folder.

11.5.5 Using Simple Finder

Suppose you're the lucky Mac fan who's been given a Simple Finder account. When you log in, you'll discover the barren world shown in Figure 11-11. There are only three menus ( [image], Finder, and File), a single onscreen window, no hard drive icon, and a bare-bones Dock. The only folders you can see are in the Dock. They include:

  • My Applications. These are aliases of the applications the administrator approved. They appear on a strange, fixed, icon view "pages" (list and column views don't exist). You can't move these icons, delete them, or rename them. If you have too many to fit on one screen, you get numbered page buttons beneath them, which you can click to move from one set to another.

  • Documents. Behind the scenes, this is your Home [image] Documents folder. Of course, as a Simple Finder kind of soul, you don't have a Home folder. All your stuff goes in here.

  • Shared. This is the same Shared folder described in Section 11.4.3. It's provided so that you and other account holders can exchange documents; however, you can't open any of the folders here, only the documents.

  • Trash. The Trash is here, but you won't use it much. Selecting or dragging any icon is against the rules, so you're left with no obvious means of putting anything into your Trash.

    Truth is, you can put something into the Trash by Control-clicking it and choosing Move to Trash from the contextual menu. But as you'll be told, the item "will be deleted immediately." In Simple Finder, there's no mercy for files you've slated for execution.

Otherwise, you can essentially forget everything else you've read in this book. You can't create folders, move icons, or do much of anything beyond clicking the icons that your benevolent administrator has provided. It's as though Mac OS X moved away and left you the empty house.

If you click a folder, it opens—but only if something's actually inside; if it's empty, nothing happens at all. To keep things extra-simple, Mac OS X permits only one window at a time to be open. It's easy to open icons, too, because one click opens it, not two.

The File menu is stunted, offering only a Close Window command. The Finder menu only gives you two options: About Finder and Run Full Finder. (The latter command prompts you for an administrator's user name and password, and then turns back into the regular Finder—a handy escape hatch. To return to Simple Finder, just choose Finder [image] Return to Simple Finder.)

the [image] menu is really bare-bones: You can Log Out and go to Sleep. That's it.

11.5.5.1 Simple Applications

Although the Simple Finder is simple, the programs you run in it don't have to be. Any program (at least, any that you, the administrator, have permitted) can run from Simple Finder. You could, for example, use Simple Finder to make a basic Photoshop workstation. A program running inside the Simple Finder still has all of its features and complexities—only the Finder itself has been whittled down.

This, of course, is one of the downfalls of the Simple Finder concept: It's great for streamlining the Finder, but novices won't get far swallowing their techno-fear until the world presents us with Simple AppleWorks, Simple Mail, and Simple Microsoft Word. Still, it's better than nothing.

In any case, as shown in Figure 11-11, the available programs' icons appear, sixteen on a "page," with page buttons and previous/next buttons at the bottom of the screen. The Simple person can't move, rename, delete, sort, or change the display of them—merely click them.

Figure 11-11. The Simple Finder doesn't feel like home—unless you've got one of those Spartan, space-age, Dr. Evil-style pads. But it can be just the ticket for less-skilled Mac users, with few options and a basic one-click interface. Every program in your My Applications folder is actually only an alias to the real program, which is safely ensconced in the off-limits Applications folder.
11.5.5.2 Simple Bugs

In theory, Simple Finder people can save their documents only into the Documents folder. But thanks to a bug, the initial release of Mac OS X 10.2 (and even the 10.2.1 update) permits saving into other places, like the Desktop and the Home folder. Trouble is, in Simple Finder, there is no desktop or Home folder. These folders are hidden—therefore, saving files there makes them seem to vanish. You, the administrator, can recover these documents from oblivion only by switching into Full Finder mode, and opening up the Home (or Home [image] Desktop) folder.

Then instruct your Simple colleagues to save documents only into the Documents folder from now on.


11.6 Logging Out

When you're finished using the Mac, choose [image] [image] Log Out (or press Shift- [image] -Q). A confirmation message appears; if you click Cancel or press Esc, you return to whatever you were doing. If you click Log Out, or press Return, you return to the screen shown in Figure 11-1, and the entire sign-in cycle begins again.


11.7 The Root Account

An administrator's account isn't exactly a skeleton key that gives unfettered access to every corner of the Mac. Even an administrator isn't allowed to remove files from the System folder or other files whose removal could hobble the machine.

It turns out that Normal and Administrator aren't the only kinds of accounts. There's one account that wields ultimate power, one person who can do anything to any file anywhere. This person is called the superuser.

Unix fans speak of the superuser account—also called the root account—in hushed tones, because it offers absolutely unrestricted power. The root account holder can move, delete, rename, or otherwise mangle any file on the machine, no matter what folder it's in. One wrong move—or one Internet hacker who manages to seize the root account—and you've got yourself a $2,500 doorstop. That's why Mac OS X's root account is completely hidden and, in fact, deactivated.

There's another reason this account comes turned off: You can enjoy most root-like powers without actually turning on the root account. Here, for example, are some of the things the root account holder can do—and the ways you can do them without ducking into a phone booth to become the superuser:

  • See the thousands of crucial system files that Mac OS X ordinarily renders invisible. Of course, you can also see them extremely easily just by using the shareware program TinkerTool (see Section 17.1) or even Terminal (Chapter 15).

  • Manipulate the files within the System folder's Library folder. First of all, you'd be nuts to try. The prime virtue of Mac OS X is its stability—its System folder's invulnerability to change. Sure, you can mess around with its contents, but if you really wanted a crash-prone machine, you could have stuck with Mac OS 9.

    Anyway, even if you did want to fool around with these files, there's a much easier way: Restart the Mac in Mac OS 9. You'll have full access to all Mac OS X files and folders.

  • Peek into other account holders' folders (or even trash them). You don't have to be the superuser to do this—you just have to be an administrator who's smart enough to use the Get Info command, as described in Section 2.7.3.

  • Use powerful Unix system commands. Some of the Unix commands you can issue in Mac OS X require superuser powers (see Chapter 16). As you'll also find out in that chapter, however, there's a simple command—the sudo command—that simulates root powers without you actually having them; see Section 16.1.4.

Treat the root account, in other words, as you would one of those "Break glass in case of fire" boxes. If you know what you're doing, and you see no alternative, you might be glad the root account is available. Programmers who compile source code, for example, may need to enable the root account.

You can turn on the root account in any of several ways. One of them involves typing a Unix command or two (they're in Section 16.3), but the technique most people use goes like this:

  1. In your Applications [image] Utilities folder, open the NetInfo Manager program. Click the tiny padlock in the lower-left corner of its screen.

    A dialog box asks you for an administrator's name and password.

  2. Type your name and password, and then click OK.

    You're in.

  3. Choose Security [image] Enable Root User.

    If this is the first time you've performed this particular surgery, you'll be told, "The root password is currently blank." You're asked to make up a "non-trivial" (meaning virtually impossible for anyone to guess) password for the newly created root account.

  4. Click OK and then type the password in both of the bottom Password boxes. Click OK two more times.

    The second dialog box simply tells you that if you intend to make any more changes in NetInfo Manager, you'll have to sign in as an administrator again. But your work is done here.

  5. Quit NetInfo Manager.

    You've just brought the dormant root account to life.

  6. Log out. Log back in again as root.

    That is, when the login screen appears, click Other User (a choice that magically appears once you've turned on the root account). In the first text box, type root. In the second, type the password you made up in step 4. Click Log In.

You arrive at the desktop, where no error messages regarding access privileges or ownership will ever interrupt the proceedings. Be careful out there.

When you're finished going about your business as a root user, immediately log out again. It's important to rule out the possibility that some clueless or malicious person might wander up to the Mac while you're still logged in as the superuser.

In fact, if you don't anticipate needing your superuser powers again soon, consider turning off the root account altogether. (Just repeat steps 1 and 2 above. In step 3, choose Security [image] Disable Root User.)


Chapter 12. Networking

Just about every Mac ever built is network-ready. Buy a few cables and adapters, and you can connect all the Macs in your office together, with or without wires. The process of rigging the hardware and software for a network isn't exactly rocket science, but it's somewhat more technical than, say, emptying the Trash.

Once it's done, you can copy files from one machine to another just as you'd drag files between folders on your own Mac. You can send little messages to each other's screens. Everyone on the network can consult the same database or calendar. You can play games over the network. You can share a single printer, cable modem, or fax modem among all the Macs in the office. You can connect to this network from wherever you are in the world, using the Internet as the world's longest extension cord back to your office. And in Mac OS X, you can even connect to Windows machines without having to buy any additional software.

Best of all, all the software you need to create such a network is built right into Mac OS X.

As you read this chapter, remember the difficulty Apple faces: It must design a networking system simple enough for the laptop owner who just wants to copy things to a desktop Mac when returning from a trip—and yet secure and flexible enough for the network designer at a large corporation. In general, you'll probably find that Apple has done an excellent job of balancing these two warring motivations.

TIP

You don't necessarily need any network at all to exchange files between Macs (and even PCs). If each computer is equipped with a Bluetooth card, they can shoot files back and forth wirelessly, exactly as described in Section 6.2.5.


12.1 Wiring the Network

Most people connect the Macs (and other computers) in their offices using either of two connection systems: Ethernet or AirPort.

12.1.1 Ethernet Networks

These days, every Mac and every network-ready laser printer has an Ethernet jack on the back panel (see Figure 12-1). If you connect all of the Macs and Ethernet printers in your small office to a central Ethernet hub—a compact $25 box with jacks for five, ten, or even more computers and printers—you've got yourself a very fast, very reliable network. (Most people wind up trying to hide the Ethernet hub in the closet, and running the wiring either along the edges of the room or inside the walls.) You can buy Ethernet cables, plus the Ethernet hub, in any computer store or, less expensively, from an Internet-based mail-order house; hubs aren't Mac-specific.

TIP

If you want to connect only two Macs—say, your laptop and your desktop machine—you don't need an Ethernet hub at all. Instead, you just need an Ethernet crossover cable—about $8 from a computer store or online mail-order supplier. Run it directly between the Ethernet jacks of the two computers. (Better yet, if you have a PowerBook Titanium G4 or a white iBook, either a crossover cable or traditional Ethernet cable will do.)

Ethernet is the best networking system for many offices. It's fast, easy, and cheap.

Figure 12-1. Every Mac OS X-compatible Mac has an Ethernet jack (left). It looks like an overweight telephone jack. It connects to an Ethernet hub (right) via Ethernet cable (also known as RJ-45), which looks like an overweight telephone wire.

12.1.2 AirPort Networks

Of course, the Mac wouldn't be the Mac if it couldn't connect to other Macs using the most exciting kind of networking connection: radio waves. You can install a $100 metal AirPort card, about the size of a Visa card, into almost any Mac OS X-compatible Mac. This card lets your machine connect to your network without any wires at all—as long as they're within about 150 feet of a base station, which must in turn be physically connected to your network. (If you think about it, the AirPort system is a lot like a cordless phone; the Mac is the handset.)

The base station can take any of these forms:

  • AirPort Base Station. This $300 Apple product looks like a small white or silver flying saucer.

  • A wireless broadband router. These gadgets are, in essence, AirPort Base Station clones from other companies (like MaxGate, www.maxgate.net, or Macsense, www.xsense.com). You can plug the base station into an Ethernet hub, thus permitting 10 or 20 AirPort-equipped Macs to join an existing Ethernet network without wiring. (You may also hear the term 802.11, the much less fun "official" name of the AirPort technology.)

  • Another Mac. Any computer running Mac OS 9 or Mac OS X 10.2 (or later) can impersonate an AirPort base station. In effect, the Mac becomes a software-based base station.

    The Mac itself must have an AirPort card inside—but it's often better to pay $100 for an AirPort card than $300 for an AirPort base station. (Much more on AirPort network setups in Chapter 18.)

After having wired your network (or unwired it, as the case may be), your network is ready. Your Mac should "see" any Ethernet or shared USB printers, in readiness to print (see Chapter 13). You can now play network games or use a network calendar. And you can now turn on File Sharing, one of the most useful and sophisticated features of the Mac OS.

12.1.3 Mac, Meet Network

You won't get far connecting your Macs unless each one has an IP address, a string of four numbers separated by periods, such as 192.168.1.43.

To see whether your Mac OS X machine has one, choose [image] [image] System Preferences; click the Network icon; and, from the Show pop-up menu, choose the appropriate connection: Built-in Ethernet or AirPort.

You may have established these numbers when installing Mac OS X to begin with, as described in Appendix A. If you connect to the Internet using a high-speed connection like a cable modem or DSL, you may also find a string of numbers already in the IP Address box.

If you connect to the Internet via standard dial-up modem, however, choose Using DHCP from the Configure pop-up menu and then click Apply Now. (DHCP stands for dynamic host control protocol, and means "issue me a new IP address every time I connect." You'll find much more information on setting up these controls in Chapter 18. )

NOTE

You can change these settings only if you're an administrator, as described in Chapter 11.

Quit the System Preferences program, if you like.

How to Skip Ten Pages

Much of this chapter assumes that you are your own system administrator, the unlucky geek who has to set up your office network. Nobody pretends that this stuff is simple.

If somebody else sets up your network, fortunately, there's a lot less to learn—in fact, everything you need to know can fit inside this sidebar box. (These instructions assume that your network has been set up as described in these pages, and that File Sharing has been turned on.)

To make one of your files available to everybody on the network: Copy the file into the Public folder in your own Home folder.

To "hand off" one of your files directly to a co-worker: Bring that person's hard drive onto your screen, as described in Section 12.2.2. Open your co-worker's Home folder [image] Public [image] Drop Box folder. (You might want to let that person know, by email or by yelling across the office, that you've done so.)

To grab a copy of a file that someone else on the network wants you to have: If they haven't put it into your Drop Box, then you'll probably find it inside that person's Home folder [image] Public folder. (Of course, you have to connect to that person's machine, as directed in Section 12.2.2.)


12.2 File Sharing

In File Sharing, you can summon the icon for a folder or disk attached to another computer on the network, whether it's a Mac or a Windows PC.) It shows up on your screen underneath your own hard drive, as shown in Figure 12-2. At this point, you can drag files back and forth, exactly as though the other computer's folder or disk is a gigantic CD you've inserted into your own machine.

Figure 12-2. The whole point of file sharing: to bring icons for the hard drives or folders from other Macs and PCs onto your own screen—like the Jenn's iMac HD icon shown here. By dragging icons back and forth, you can transfer your work from your main Mac to your laptop; give copies of your documents to other people; create a "drop box" that collects submissions from various authors for a publication; and so on.

12.2.1 Phase 1: Setting up the Computers

These instructions assume that you've already wired the network together, as described at the beginning of this chapter.

12.2.1.1 Setting up a Mac OS X machine

The first thing you have to do when preparing a Mac OS X computer for invasion over the network is to set up an account—a name, password, and Home folder—for each person who might want to visit. See Chapter 11.

The name and password you use to log in when you sit down in front of the computer—as described in the previous chapter—are the same name and password you need to connect over the network. In other words, Mac OS X doesn't care how you try to get into your own stuff, just as long as it's sure that you're you.

Once you've established accounts for everybody who might want to access your Mac OS X computer—even if it's only you—you're ready to proceed with preparing the machine for access from elsewhere on the network.

  1. Open System Preferences.

    You can click its icon on the Dock, for example, or choose [image] [image] System Preferences. Either way, the System Preferences program (Chapter 8) opens.

  2. Click the Sharing icon.

    The Sharing panel appears, as shown at top in Figure 12-3.

    NOTE

    Only administrators (Section 11.2) are allowed to fool around with the settings you're about to change. If the little padlock icon in the lower-left corner of the dialog box looks locked, call an administrator over, click the lock, and prove that you have permission to do what you're doing by entering (or asking the administrator to enter) the administrator's name and password.

  3. In the Computer Name blank, type a name for the computer, if necessary.

    Your Mac will appear on the network with this name. Make it nice and descriptive, such as Front Desk iMac. If other Macs on your network run Mac OS X 10.2, you can also edit its Rendezvous name (Rendezvous), providing you don't use any spaces or punctuation (except hyphens).

  4. In the list of checkboxes, turn on Personal File Sharing (Figure 12-3, top).

    If you want Windows PCs on your network to be able to connect to your Mac too, turn on Windows File Sharing as well.

    These features takes a moment to warm up; when File Sharing is finally on, the button says Stop. Close the window, if you like.

    TIP

    If you work alone, or with only a few trusted others, you can make life easier for yourself in a couple of ways. First, give yourself no password at all. Second, give yourself a very short, easy-to-type name—just your initials, for example.

Repeat this process on each Mac OS X machine in your office, giving each one a different computer name.

NOTE

If any Macs on your network run some version of the Mac OS before 9.0, reopen System Preferences. Click Network, choose the kind of network connection you have from the pop-up menu (like Ethernet or AirPort), click the AppleTalk tab, turn on "Make AppleTalk active," and then click Apply Now. (The technical reason: All modern Macs communicate using the TCP/IP language, just like the Internet. Older Macs spoke only the Apple-only AppleTalk protocol.)

12.2.1.2 Setting up a pre-Mac OS X machine

Setting up a Mac that's running Mac OS 8.5 through Mac OS 9-point-whatever, if there is one on your network, follows almost the same steps as outlined above—but the locations of the controls are different. Here's a summary:

  • Setting up user accounts. Use the Users & Groups tab of the File Sharing control panel.

  • Naming the computer. Use the File Sharing control panel.

  • Clicking Start. You do this in the File Sharing control panel, as well. But there's one additional step: Turn on the checkbox called "Enable File Sharing clients to connect over TCP/IP," if you have it (shown at the very bottom of Figure 12-3).

    This TCP/IP option is available in Mac OS 9 and later. If your Mac runs Mac OS 8.5 or 8.6, be sure to turn on AppleTalk on the Mac OS X machine (see the top of the facing page). Without either TCP/IP or AppleTalk, you won't be able to access the files or folders on your older computer from a Mac OS X machine. (You will, however, be able to go the other direction: you'll be able to access a Mac OS X machine on the network from your older machine.)

Figure 12-3. Top: Here's the master on/off switch for file sharing over the network in Mac OS X—the Sharing panel of System Preferences. (The toolbar has been hidden in this illustration.) See how many other ways your Mac can share? You'll get to these other checkboxes later in this book. Bottom: In Mac OS 9, this is the setup for a security-free, high-convenience file-sharing arrangement. You'll be able to access any Mac on the network without having to type in anything—no name, no password. If you work alone with a couple of Macs, or with co-workers you trust, this is the most efficient arrangement.
12.2.1.3 Setting up a Windows machine

For instructions on setting up a Windows PC for file sharing, see Section 12.3.

12.2.2 Phase 2: Connecting to Another Mac from Mac OS X

Suppose you're seated at your Power Mac, but you need a file that's on the 17-inch iMac down the hall. The steps are the same, no matter which version of the Mac operating system the other machine's running (as long as it's later than Mac OS 8.5).

To bring its hard drive icon (or a shared folder's icon) onto your screen, follow these steps on the Mac OS X machine:

  1. Choose Go [image] Connect to Server (or press [image] -K).

    The Connect to Server command opens up the window shown in Figure 12-4.

    Figure 12-4. You may see the names of individual machines in the leftmost column, or on bigger networks, you may see globe icons that indicate further network structures or protocols. These may represent AppleTalk zones, Windows workgroups, or other Mac OS X machines. In any case, click the network cluster (globe) you want, if necessary, and then double-click the name of the actual machine you want in the second column. (Don't be freaked out by the appearance of your own Mac's name. That's all normal.)

    If you've done this before, don't miss the "At" pop-up menu at the top of the dialog box. Its commands include a list of Recent Servers—computers you've accessed recently over the network. If you choose one of them from this pop-up menu, you can skip the next two steps.

    TIP

    If you know the IP address of the Mac you're trying to access—you geek!—you've just found another way to skip steps 2 and 3. Just type the IP address into the Address field at the bottom of the dialog box. You can also precede it with afp:// (like this: afp://192.168.1.2), but that's not necessary).

    The next time you open the Connect To dialog box, Mac OS X will remember that address, as a courtesy to you, and show it pre-entered in the Address field.

  2. In the left-side list, click the correct "limb" of your network tree, if necessary.

    What you see in this list depends on the complexity of your network. For example, if your network is just your Mac and a couple of laptops, you'll see their names listed here, ready for double-clicking. You won't see the globe icons shown in Figure 12-4.

    If you do see globe icons, however, then your Mac is seeing different network types at once. You could have Macs speaking the AppleTalk networking language, perhaps a couple of Mac OS X computers, and maybe some Windows PCs for good measure—all on the same network. Here's how to find your way around:

    To see a list of pre-Mac OS X machines on the network: As noted earlier, older Macs used a networking communications "language" called AppleTalk (Mac OS X Macs may have AppleTalk turned on, too). If your Mac OS X machine sees them on your network, you'll see either an asterisk (*) in the left-side list (meaning, "here's an unnamed AppleTalk zone") or the actual names of AppleTalk zones (clusters of machines, as found in big companies and universities). Click either the asterisk or the appropriate zone name.

    (Of course, you won't see any AppleTalk computers at all unless you've turned on AppleTalk on your Mac OS X machine, as described in Section 12.2.1.)

    To see a list of Mac OS X machines on the network: Click the Local icon.

    To see a list of Windows machines on the network: Click the name of the workgroup (computer cluster) that contains the machine you want. In small office networks, it's usually called MSHOME or WORKGROUP. (In big corporations, these workgroups can be called almost anything—as long as it's no more than twelve letters long with no punctuation. Thanks, Microsoft.)

    TIP

    In Mac OS X 10.2, you no longer see duplicates or triplicates of your own machine within a single network "limb," as you did in previous versions of Mac OS X. You do, however, still see your own machine listed among the others on the network; just ignore it.

    In the second column, you should now see a list of every Mac for which you turned on File Sharing. (If not, then something's wrong with your network wiring, or you haven't prepared those Macs as described in "Phase 1: Setting up the Computers," in Section 12.2.1.)

    TIP

    You can also access other Macs on your network directly from within the Open File dialog box described in Chapter 4. This box, too, contains a Network icon (scroll all the way to the leftmost column of the Open File box). Click it, then click Servers, and then continue with the steps outlined here.

  3. In the second column, double-click the name of the computer you want to access.

    Alternatively, press the right-arrow key to highlight the second column, press the up or down arrow keys to highlight the Mac you want, and then press Enter or Return to "click" the Connect button.

    TIP

    If your network is a real bear to navigate, consider taking this opportunity to click the name of a Mac you plan to access frequently, and then click Add to Favorites at the bottom of the window. For now on, you'll be able to skip steps 2 and 3 by choosing the Mac's name from the At pop-up menu at the top of the window.

    Now the "Connect to the file server" box appears (Figure 12-5, top). You're supposed to specify your account name and password, so that you can sign in and access your own files on that other Mac.

    Figure 12-5. The sequence of connecting to another disk on the network continues. First choose Go Connect to Server, double-click Local Network, and then double-click the name of the Mac you want (Figure 12-4). Top: Now you specify your password, or if you didn't require one, leave the password box blank. Click Connect. Middle: Double-click the name of the shared folder or disk you actually want to open. Bottom: At long last, you're in. The other Mac's shared disk or folder appears on your desktop just as though it's another hard drive.

    Although it may hurt your brain to contemplate, you can even do so while somebody else is actually using the Mac in person. The Mac can actually process the work of many people simultaneously. In fact, you, Chris, and Robin can each log into Ellen's Mac from across the network—each of you using your own files on that same machine—even while is Ellen using her own account!

  4. Type your short user name (Figure 12-5, top).

    Type precisely what you would use to log into the networked computer if you were sitting in front of it.

    If nobody has set up an account for you on that machine, on the other hand, all you can do is click the Guest button, to gain some very limited access to what's on the other Mac. And if the Guest button is dimmed, then someone has turned off Guest access altogether. You're completely out of luck.

    (Not sure what your short user name is? Open System Preferences on your home-base Mac, and then click My Account. Your short name appears at the top of the dialog box.)

  5. Press Tab, and then type your password.

    If you work alone or with a small group of trusted people, and you've left your password blank, just skip the password box here.

    This, by the way, is your opportunity to perform several administrative functions that relate to accessing other Macs on the network. If you click the Options button, you get the dialog box shown and described in Figure 12-6. For example, the Add Password to Keychain option saves you even more of these steps the next time you connect. Read the discussion of the Keychain later in this chapter.

    Figure 12-6. If you click Change Password as you connect to another computer, you'll be given the opportunity to change your account password on that machine. A clear text password is one that isn't encrypted—a less secure, but more compatible, method of transmitting your password over the network.

  6. Click Connect, or press the Return or Enter key.

    Now a list of disks and folders on that Mac that have been shared for network access appears (Figure 12-5, middle).

  7. Double-click the name of the disk or folder you want to open.

    Or, if you see several disks or folders listed here that you'd like to open all at once, you can [image] -click them to highlight several—and then click OK to bring all of their icons onto your desktop.

    At last, the disk or folder you've connected to appears on the right side of your screen, illustrated with what looks like a tiny hard drive with a globe balanced on it. It usually appears just below your built-in hard drive icon. (You'll also see these mounted hard drive icons listed in the window that appears when you choose Go [image] Computer, or in the far left pane of any column-view window.)

    Because Apple discovered that so many novices didn't even notice the quiet appearance of this icon, it wired Mac OS X 10.2 to do something much splashier at the same time. A new window called Volumes opens, listing each partition, shared disk, or shared folder that's accessible to your Mac—including the one you just brought online from across the network (Figure 12-5, bottom).

    You can open its icon (either on your desktop or in the Volumes window) to open, copy, move, rename, or delete the files on it, exactly as though the files were on your own computer—with certain limitations, which are described next.

    TIP

    If you access a certain disk frequently, you can bypass the connection steps described on the previous pages. If you drag the networked disk onto your Dock, you'll be able to bring it back to your screen later just by clicking its icon. Better yet, drag it into the Login Items window illustrated on Section 11.2.6; now the disk will appear on your desktop automatically each time you log in—the most effortless arrangement of all.

12.2.3 Phase 3: What You Can Do Once You're In

When you tap into a Mac OS 9 machine over the network, you're allowed complete freedom. Once you've brought its hard drive onto your screen, you can trash, rename, move around, or otherwise wreak havoc with the files and folders you find there.

But when you tap into a Mac OS X machine, you can access only what's in certain designated folders. Precisely which folders are available depends on whether you're a guest, a normal user, or an administrator (see the previous chapter).

12.2.4 If You're a Guest

If you're just a guest—somebody for whom an account hasn't already been set up—you'll be able to:

  • Put things into anyone's Drop Box folder. Connecting to a Mac OS X machine as Guest offers you a list of everyone who has an account on it. (This list looks like the center illustration in Figure 12-5.)

    When you double-click someone's name, you'll discover that there's nothing inside that folder except a Drop Box folder and sometimes a Public folder, as shown in Figure 12-7. (The Drop Box folder is actually inside each person's Home [image] Public folder.)

    You can copy files into a Drop Box, but you can't open it. Yes, Mac OS X is very secure, but even a high-security prison has a mailbox.

  • Open anything that people have put into their Public folders. (If you don't see any Public folders, then nobody has put anything into them for you to see.) Figure 12-8 has the details.

The rest of the Mac is invisible and off-limits to you.

Figure 12-7. If you connect as a guest, there's not much to see. You can deposit files into the Drop Box folder of any account holder, but not into the window that holds it—the little slashed-pencil icon in the upper-left corner tells you that it's off-limits.
Figure 12-8. Suppose that Frank has put three files into his Public folder. (Every person's Home folder contains a Public folder.) When you connect to his Mac, you'll see whatever is in his Public folder—in this case, his Drop Box plus those three files. You can't put anything in Frank's window (except in the Drop Box), but you can open the three files he's left there for you to see.

12.2.5 If You're a Normal Account Holder

If you have a Normal account, you'll enjoy Drop Box access, Public-folder access, and the ability to see and manipulate what's inside your own Home folder. You can do anything you like with the files and folders you find there, just as though you're actually seated in front of that Mac.

All other disks and folders on the Mac, including the System and Application folders, are invisible to you.

12.2.6 If You're an Administrator

When you connect to a Mac OS X machine as a guest or normal user, you never even see the name of the hard drive on that machine. As illustrated at center in Figure 12-5, you see only the names of the users who have accounts on that machine (so that you can get access to their Drop Boxes and Public folders).

But if you're an administrator, you get to see both those user folders as well as the hard drive itself to which you're connecting. In fact, you even get to see the names of any other disks connected to that Mac.

If you, O lucky administrator, open the hard drive, you'll discover that you not only have the same freedoms as a Normal account holder (described above), but also the freedom to see and manipulate the contents of these folders:

  • Applications

  • Desktop folder

  • Library (and the System [image] Library folder, but nothing else in the System folder)

  • Users [image] Shared folder (Section 11.4.3)

  • The other disks connected to the Mac OS X machine

    NOTE

    There's actually one more kind of account, of course, as described in the previous chapter—the root user. Whoever holds this account has complete freedom to move or delete any file or folder anywhere, including critical system files that could disable your Mac. Section 11.7 has details.

Why aren't Normal and Administrator account holders allowed to see what's in the System folder? Because Mac OS X is extremely protective of its System folder. To make Mac OS X remain as solid and stable as the day you installed it, human beings are not allowed to play with it, whether they're visiting over the network or not.

Normal and Administrator account holders aren't allowed to see what's in other users' Home folders, either. That's part of Mac OS X's security feature. Each person who uses a Mac OS X machine has an individual account to which she alone has access. (Even though administrators can seize control over other people's stuff in person by using the Get Info command [Section 2.8], they can't do so from across the network.)

Other Kinds of Servers

A Mac for which you've turned on File Sharing is known in the business as a file server—a computer designed to "serve up" files to other computers over the network. But Macs aren't the only file servers you may encounter.

If your network includes other computers running Unix, whatever smart person set up the network may have set up NFS (network file system) servers: folders or disks that have been set up so that you can see them from across the network. You don't even use the Connect To command to bring these folders and disks onto your screen; instead, you choose Go [image] Computer and double-click the Network icon you find there. In the resulting window, you'll see the icons of the shared Unix disks and folders, which you can double-click just as though they're sitting right there on your hard drive.

The iDisk, a 100-megabyte Internet-based disk available to .Mac members (Section 18.9.3), is also a file server. The easiest way to bring its icon to the screen is, of course, to choose Go [image] iDisk. But you could also type, into the Connect to Server dialog box shown here, afp://idisk.mac.com (or use any of the other techniques described in Chapter 17).

If your Mac has a permanent (static) IP address, the computer itself can be a server, to which you can connect from anywhere in the world via the Internet. Details on this procedure begin in Section 21.2.

Finally, Mac OS X 10.2 makes it simple to bring FTP servers onto your screen. (These are the drives, out there on the Internet, that store the files used by Web sites.) You begin by choosing Go [image] Connect to Server, just as though you're connecting to another Mac on your office network.

But at the bottom of the Connect to Server dialog box, type the FTP address (such as ftp://www.apple.com) of the server to which you want to connect. After you click OK and enter your password, if necessary, the FTP server appears as a disk icon at the right side of your desktop, ready to open and copy from.

(At least that's how it's supposed to work. Your success may vary, depending on how the FTP server was set up and whether or not you've sacrificed a young male goat during the full moon.)

12.2.7 Disconnecting Yourself

When you're finished using a shared disk or folder, drag its icon to the Trash (whose icon changes as you drag), highlight its icon and choose File [image] Eject, or Control-click its icon and choose Eject from the contextual menu. You also disconnect from a shared folder or disk when you shut down your Mac, or if it's a laptop, when you put it to sleep.

12.2.8 Disconnecting Others

In Mac OS X, there's no visual clue to alert you that other people on the network are accessing your Mac.

Maybe that's because there's nothing to worry about. You certainly have nothing to fear from a security standpoint, since, as you'll recall, people from across the network are allowed to access only their own folders. Nor will you experience much computer slowdown as you work (another traditional drawback of having people access your hard drive from across the network), thanks to Mac OS X's prodigious multitasking features.

Still, if you're feeling particularly antisocial, you can slam shut the door to your Mac just by turning off the File Sharing feature. (Click System Preferences on the Dock, click the Sharing icon, and turn off the Personal File Sharing or Windows File Sharing checkbox.)

If anybody is, in fact, connected to your Mac at the time (from a Mac), you see the dialog box shown in Figure 12-9. If not, your Mac instantly becomes an island once again.

Figure 12-9. This dialog box asks you how much notice you want to give your co-workers that they're about to be disconnected—10 minutes to finish up what they're doing, for example. If you're feeling rushed or rude, type a zero. Doing so disconnects that person instantly, without warning. Then click OK. (When you disconnect people by closing your laptop lid, having a system crash, or unplugging the network wires, your co-workers get no notice at all. A message appears on their screens that says, "The server has unexpectedly shut down.")

12.2.9 Advanced Control

You may have noticed that Mac OS X adopts a fairly rigid scheme of permissions (access privileges). Most people on the network are allowed to see only their own folders (and what's in other people's Public folders) when they connect to a Mac OS X machine.

But what if:

  • You want your co-workers to be able to access other folders.

  • You'd rather not have your Public folder be quite that public.

  • You work in a corporation where every machine has a full-time, high-speed connection to the Internet, which makes you worry even about that Drop Box. If somebody figures out your Mac's IP address, it's conceivable that they could dump unsavory files into your Drop Box anonymously over the Internet.

  • You find it annoying that Normal account holders can't access the other disks attached to your Mac from across the network.

Fortunately, Mac OS X's very restrictive folder-permission scheme is just a suggestion. It's perfectly possible to make individual folders either more protected or less protected, as you see fit—a bit technically hairy, but possible.

TIP

In Mac OS X, you can even control how much access people have to an individual file—not just an entire folder, as in Mac OS 9 and Windows XP. Keep that useful fact in mind as you read the following discussion.

Instant Network Messaging

As figure 12-9 makes clear, turning off File Sharing gives you the opportunity to send a little message to everyone who is currently connected to your Mac via network. But you don't have to turn off File Sharing just to gain the opportunity to send little instant messages to your buddies. The dialog box shown in Figure 12-9 is suitable for warning your network buddies that the boss is coming, for example, or to request that they get you a beverage.

To do so, open System Preferences, click Sharing, and turn off the File Personal File Sharing checkbox. Type your message into the box that appears, and click OK. Your message pops up on the screens of everyone who's connected to you.

Technically, you also just began the File Sharing shutdown process—now you should cancel that. After sending a message, you'll find that you're now staring straight at the Cancel button on the Sharing panel. Clicking it cancels the shutdown of File Sharing. (It also sends yet another message to your network comrades' screens, to the effect that File Sharing is no longer going to be cut off—a small price to pay for learning about the secret Mac OS X instant-messaging system.)

Yes, of course, iChat is a far better instant-messaging system—but this cheapie one lets you send little messages even to Macs running systems before Mac OS X 10.2.

12.2.9.1 Changing access permissions for a file or folder

To begin, highlight a file or folder on your hard drive. Unless you're an administrator, it must be a file or folder that you own (because it's in your Home folder or because you've created it yourself). (Normal account holders are never allowed to mess with other people's folders.)

Choose File [image] Get Info (or press [image] -I). When the Info dialog box appears, expand the Ownership & Permissions panel (see Figure 12-10).

Figure 12-10. Left: This window lets you establish who's allowed to see or use the contents of a particular folder or disk. Right: Using the pop-up menus, you can specify how much access you, the Owner, a selected group, and everyone else has.

TIP

You can also change the permissions for many folders at once. Just highlight all of them before choosing File [image] Get Info.

Now you see three pop-up menus: Owner, Group, and Others. (Each of the first two also offers an Access pop-up menu.) More on these designations in a moment.

For now, note that the Owner Access, Group Access, and Others pop-up menus contain identical commands. They let you specify what you, the other people in your work group, and the entire network community can do with this document or folder:

  • If you choose No Access, then you're a network tease—your co-workers may be able to see the folder, but its name and icon will be dimmed and unavailable.

  • The Read only option lets visitors open the folder, open the files inside, or copy the files inside to their own hard drives; however, they can't put anything new into the folder, nor save changes to files they find there. Set up a folder like this as a distribution point for newsletters, standard logos, or other company information. Or turn this on for a document that you want people to be able to read but not edit.

  • The Write only (Drop box) option is available only for folders. Turn it on if you want your network co-workers to be able to see the folder, but not open it. All they can do is copy files into it. Your own Drop Box—which Mac OS X creates automatically in your Home [image] Public folder—works this way, too. It's great for setting up a place where people can put documents that are intended for your eyes only. Think students turning in homework, underlings turning in quarterly reports, and so on.

    Of course, you should make sure that your students and underlings can get to your drop-box folder—that is, make sure they also have access to whatever folder it's in.

  • Finally, choose Read & Write if you'd like your networked colleagues to have full access to the folder. They can do anything they want with the files inside, including trashing them.

    NOTE

    Whenever you adjust the permissions for a folder like this, remember to take into account the permissions of the folder it's in (that is, its parent folder). No matter how exquisitely you set up a drop box folder, for example, nobody will even know it's there unless it's inside a folder for which you've turned on at least "Read only" access.

But wait. Just when you thought this permissions business might be easy enough for you to grasp without that long-postponed PhD in astrophysics, it gets more complicated.

It turns out that you can assign these different levels of freedom to different subsets of people on your network. That's why there are three different categories of pop-up menu:

  • Owner. That's you. If you've forgotten who you are, just look for the "(me)" designation after the appropriate name in this pop-up menu.

    Of course, ordinarily, you have full access (Read & Write) to all of your folders. You can put anything into them, take anything out of them, and do whatever you like with them. But if you feel the need to protect yourself from your own destructive instincts, or if you have a habit of leaving your Mac unattended when you wander away without logging out first, you can actually limit your own access to certain folders. For example, you can turn one into a drop box using this pop-up menu, as described below.

    If you're an administrator, in fact, you can do more than specify how much access you have. You can actually change the owner, so that somebody else has control over this icon.

    To make this change, click the padlock icon, and then choose a new owner from the Owner pop-up menu. This is an unbelievably sweeping power. It means that you can trod, roughshod, over everyone else's stuff, blowing away all of the usual Mac OS X account-security mechanisms. If you feel like trashing all the files of everyone else who uses this Mac, you can do it. You, after all, are Administrator, God of the Mac. (This is a good argument for limiting the number of people who have Administrator accounts, by the way. Remember, they can do the same thing to you.)

    In any case, as soon as you choose a new owner from the pop-up menu, you'll be asked for your account password, just to prove that you're really an administrator. Type it, and then click OK.

    Now you can not only change who the owner is, but you can also use the Owner Access pop-up menu to specify how much access that person has to the selected file or folder.

  • Group. In most networking systems, you can put every person in your office into certain groups, such as Marketing, Accounting, or Temps. Mac OS X itself, however, offers no easy mechanism for setting up such groups. (There is a complicated way, however, which is described beginning in Section 12.4.)

    But Mac OS X does come with a whole bunch of canned, prefab groups, to which it automatically assigns everyone on the network. If you're an administrator, for example, you belong to the admin group, among others; if you're a mere peon, a Normal account holder, you're part of the staff group. Once again, you can find out which group you belong to by opening the Group pop-up menu and looking for the word "(me)." (The other group names here—dialer, guest, mail, and such—exist for the benefit of network administrators and for Mac OS X itself.)

    If you have a Normal account, you can't change the Group pop-up menu, but using the lower pop-up menu, you can change how much access everyone in your group has to the file or folder.

    If you're an administrator, on the other hand, you can do more than just change the access privileges for your own stuff. By clicking the padlock and then using first the Group pop-up menu, then the Access pop-up menu beneath it, you can change every group's degree of access independently. Once again, you'll be asked to prove your worthiness by entering your administrator password when the job is done.

  • Others. This pop-up menu specifies how much freedom everybody else in the network will have to the selected file or folder, including guests. Needless to say, if security is an issue where you work, you may not want to set the Everyone pop-up menu to permit full access.

    You can't give "Everyone" more access to the folder than you gave the Group people—only the same degree of freedom, or less. For example, you can't give Read & Write access to a folder to Everyone, but give your own administrator group only drop-box access.

If you want the change to affect all the folders inside the selected disk or folder in the same way, click "Apply to enclosed items." In the confirmation box, click OK.

In any case, just close the Info window when you're finished. You've just fooled around with some high-powered Unix mojo—without even knowing it.

12.2.9.2 Making other disks available over the network

Ordinarily, you can only see the primary hard drive of the Mac OS X machine from across the network. Only administrators are allowed to access other disks connected to it. But if you (or your Normal account holders) work on a small, informal network like a home network, that extra security precaution can seem like so much red tape.

You can give Normal account holders access to secondary hard drives or other disks associated with your Mac, but it's not a simple process. You have to create a new group, add to it the names of people you want to be able to access these disks, and finally assign that group to the disk in question. This routine isn't as easy as flipping a switch, by any means, but it's not as hard as brain surgery, either. Instructions begin in Section 12.4.

TIP

This chapter describes the visual way to connect from across the network—a system of dialog boxes, menus, and nice clickable buttons.

If you're willing to forego all of that Mac-like stuff, a second, highly regarded system of connecting to your Mac from across the network—or from across the Internet—awaits: a Unix program called SSH (Secure Shell). If you're still game, Connecting Through a Router offers the details.


12.3 Networking with Windows

Microsoft Windows may dominate the corporate market, but there are Macs in the offices of America. Mac OS X 10.2 represents a historic moment in Mac-Windows relations: It lets Macs and Windows PCs see each other on the network, with no special software (or talent) required.

In fact, you can go in either direction: Your Mac can see shared folders on the Windows PCs, and a Windows PC can see shared folders on your Mac. The following pages take you through both situations.

12.3.1 Seated at the Mac: Seeing the PC

Suppose you have a Windows XP machine on the network (although the same feature works in Windows Me, Windows 2000, and other recent editions). Here's how you get the Mac and PC chatting:

  1. On your Windows PC, share a folder.

    You have to specify which folders you want to make available on the network, if some administrator hasn't already done so. In Windows XP, for example, you right-click a folder, choose Properties from the shortcut menu, click the Sharing tab, and turn on "Share this folder on the network" (Figure 12-11, top left). In the "Share name" box, type a name for the folder as it will appear on the network (no spaces are allowed).

    Repeat for any other folders you want to make available to your Mac.
Figure 12-11. Top: To share a folder in Windows, right-click it, choose Properties, and turn on "Share this folder on the network." Bottom: Back in the safety of Mac OS X, open the Connect to Server dialog box. What you see here depends on the complexity and structure of your network. You may see individual computers listed here, network "clusters" as shown here, or a mix of the two.

NOTE

If you've never shared a folder on this PC before, you won't see the "Share this folder" option. In its place, you'll see a link that runs the Network Setup Wizard. Go ahead and run that, supplying a computer and workgroup name when prompted, and then restart the PC to turn on sharing. Then start over with step 1.

  2. On the Mac, choose Go [image] Connect to Server ( [image] -K).

    The Connect to Server dialog box appears, as shown at bottom in Figure 12-11. Any PCs on your network should show up automatically in the list. (Before Mac OS X 10.2, you had to know the actual IP addresses of the PCs, which was about as user-friendly as poison ivy.)

    They may appear as individual computer names, or—if you've used Microsoft's Network Setup Assistant—you may see only the icon of their workgroup (network cluster). Unless you (or a network administrator) changed it, the workgroup name is probably MSHOME or WORKGROUP.

    TIP

    If you don't see any sign of your PCs, read the troubleshooting box below.

  3. Click the Windows workgroup name, if necessary.

    Now the names of the individual PCs on the network appear on the right side of the dialog box (Figure 12-11, bottom).

  4. Double-click the name of the computer you want.

    The Authentication dialog box appears, as shown at top in Figure 12-12.

  5. Type your name and password, if necessary, and then click OK.

    If you have an account on the Windows PC, great—use that name and password. If the PC isn't in a corporation where somebody administers access to each machine, you may be able to leave the password field blank.

    TIP

    If you do have to enter a password, consider turning on "Add to keychain," so that you won't need to type the password again the next time.

    The SMB Mount dialog box now appears. Its pop-up menu lists the shares (that is, shared folders and disks) on the selected PC.

  6. From the pop-up menu, choose the name of the shared folder that you want to bring to your desktop (Figure 12-12, bottom left). Click OK.

    At long last, the shared folder on the Windows machine appears on your desktop with a network-drive icon (Figure 12-12, lower right), just as though you've tapped into another Mac. From here, it's a simple matter to drag files from one machine's icon to another, open Word documents on the PC using Word for the Mac, and so on, exactly as though you're hooked into another Mac, as described earlier in this chapter.
Figure 12-12. Top: The PC wants to make sure that you're authorized to visit it. If the terminology here seems a bit geeky by Apple standards, no wonder—this is Microsoft Windows' lingo you're seeing, not Apple's. Bottom left: Here, you see a list of shared folders on the PC. Choose the one you want to connect to, and then click OK. Bottom right: Like magic, the Windows folder shows up on your Mac screen, ready to use!

When Your Mac Can't See the PC

For most people, the magic of Mac OS X 10.2's "Macs and PCs can see each other on the network" feature works automatically, the first time, every time.

But if the Connect to Server box doesn't show the PCs on the network, it may be that you need to introduce your Mac to the Windows workgroup.

Open the Directory Access program in your Applications [image] Utilities folder. Click the padlock, sign in as an administrator, and then double-click the SMB item in the list.

When you get the dialog box shown here, type (or choose) the precise name of the Windows workgroup you'd like your Mac to "belong" to, and then click OK. Quit Directory Access and choose Go [image] Connect to Server once again. This time, your Mac should see the PCs.

12.3.2 Seated at the PC: Seeing the Mac

Here's another welcome feature in Mac OS X 10.2: Now you can share files in both directions. Not only can your Mac see other PCs on the network, but they can see the Mac, too.

Here's how you prepare the Mac for visitation from a PC.

  1. On the Mac, open System Preferences. Click the Sharing icon.

    Now you see a list of the different ways your Mac can share its goodies with the outside world via network.

  2. Turn on Windows File Sharing (Figure 12-13, top).

    As a security precaution, nobody can tap into your machine unless you've first given them a name and password—that is, an account.

  3. Click Show All, and then click Accounts. Create an account, if necessary.

    Chapter 11 describes this process in detail. If the person who'll be using the Windows machine already has an account on the Mac, no problem—his existing account will work just fine. You just have to tell the Mac that he's allowed to visit, like this:

  4. Click the account name, and then click Edit User. In the resulting dialog box, turn on "Allow user to log in from Windows" (Figure 12-13, second from top).

    A "Password reset required" message appears. As it points out, you have to change this person's password (although there's nothing to stop you from putting in precisely the same password as before).

  5. Enter the new password (twice), and then click OK. Click OK to get past the Keychain notice, and then click Save.

    That's it: Your Mac is ready for invasion. Quit System Preferences, if you like.

  6. On the Windows machine, open the My Network Places or Network Neighborhood icon.

    Your Mac's icon should appear here, bearing a name like "Samba 2.2.3a (Robins-computer)." (No, Microsoft isn't trying to give you dance lessons. Samba is the Mac's version of the SMB file sharing protocol that Windows uses.)

  7. Double-click the icon's name, sign in (Figure 12-13, bottom), and then go to town.

    In the final window, you see your actual Home folder—on a Windows PC! You're ready to open its files, copy them back and forth, or whatever.
Figure 12-13. Top: Two magic Mac checkboxes in System Preferences make it all possible. One's a system-wide On switch for invasion from Windows, another is an individual On switch for a particular account. Lower left: Sign in, using the same name and password you'd use to log into your Mac (Chapter 11). Lower right: Here's your Mac's icon—in Windows! Open it up to find your Home folder, complete with all your stuff.

When Your PC Can't See the Mac

If your Mac doesn't show up in the My Network Places (or Network Neighborhood) window of the PC, you may have to knock it into submission.

If this is your first attempt at Mac-PC communication, try restarting the PC. The My Network Places window updates itself only once per session.

If that doesn't work, on the PC, click the "View workgroup computers" link in the left-side task pane. In the next window, click the "Microsoft Windows Network" link.

Finally, you arrive at the Microsoft Windows Network window, which contains icons for the various workgroups on the network. Double-click the icons until you find your Mac. Log in as described in Figure 12-14; thereafter, your Home folder will show up like any other folder in the My Network Places window, saving you the trouble of going through all this again.

If your PC sees the Mac but doesn't let you sign in, on the other hand, the troubleshooting tactic is slightly different. Go to the Mac and open System Preferences. Open the My Account panel and change your password to something else. Click OK—and then change the password back again, if you like. The point is that changing your password (even if you change it right back) shocks both the Mac and PC into re-memorizing it.

Now when you sign in from the PC, the Mac should recognize you—and let you in.

12.3.3 More Mac-Windows Connections

The direct Mac-to-Windows file sharing feature of Mac OS X 10.2 is by far the easiest way to access each other's files. But it's not the only way. Here are a few more possibilities.

  • Dave. Dave (www.thursby.com) is a Mac-Windows file sharing program that's more powerful, more flexible, and more complex than the procedure described in the previous pages.

  • Web Serving. As described in Chapter 21, Mac OS X's Apache software turns your Mac into a living Web site. And the beauty of the Web, of course, is that it doesn't care what kind of computer you're using. The contents of the Web site are dished up exactly the same way to Macs, Windows machines, Unix machines, and so on.

    All of this gives you a great way to distribute files to other people on the network—even people who are using less enlightened operating systems. You can simply list files for distribution on a simple Web page, to which other people on the network can connect.

    Chapter 21 offers the full details of setting up such a system—but in the context of making your Mac available to anyone on the Internet. The point to note here is that other people on your office network can access your Mac in exactly the same way, just by typing http://192.168.1.5/~shortname/, or whatever, into the address bar of their Web browsers.

  • Via FTP. Think of an FTP server as something like a Web site designed specifically as a holding tank for files that you want to distribute or accept. Here again, though, it's worth remembering that you can use the Mac OS X built-in FTP server to distribute and accept files on your local network, not just over the Internet. The Windows PC user, using only a Web browser, will be able to download any files in the folder that you've set up for such transactions. Chapter 21 has complete details. (And using an FTP client program—the Windows equivalent of Fetch, for example—that person can copy files to and from the folder.)

  • Via Bluetooth. As noted in Section 6.2.5, Bluetooth isn't really a networking technology; it's designed to eliminate cables between various modern-day gadgets. But if your Mac and a PC each have Bluetooth adapters, you can share files between them as though there's no language barrier at all.

    Apple's Bluetooth adapter comes with a nondenominational file-exchange program called Bluetooth File Exchange; not all Windows Bluetooth adapters come with such a program. But if yours does (3Com's adapters do, for example), you should be able to shoot files between the machines with the greatest of ease—and no setup whatsoever.


12.4 Managing Groups

As noted earlier in this chapter, the circuitry of Mac OS X's file-sharing software seems to lack one feature that was present in earlier versions of the Mac OS: the ability to create and manipulate groups. As your networking setup becomes more complex, being able to work with subsets of the people on your network can be a great timesaver.

For example, you might create groups called Marketing, Temps, and Executives. Later, you can permit an entire group of these people access to a particular file, folder, or disk in one fell swoop. (And, as noted earlier in the chapter, groups are also the key to letting Normal account holders on your network see and access secondary drives on your Mac OS X computer.)

Phase 1 involves creating and naming the groups you want. It requires NetInfo Manager, an advanced utility program that comes with Mac OS X. Phase 2 involves assigning those groups to individual disks, files, or folders on your system. The following pages walk you through both procedures.

12.4.1 Phase 1: Creating Groups

To set up groups, start by opening NetInfo Manager, which is in your Applications [image] Utilities folder (Figure 12-14).

Figure 12-14. Consider yourself warned: NetInfo is an extremely technical program designed for network administrators with years of training and full employee benefits somewhere in corporate America. Not only do you need an administrator's account to play with it, but veering off the instructional path specified in the following pages could, in theory, get your Mac in trouble.
12.4.1.1 Defining and naming the group

Here's how you might go about creating a new group called Executives and then adding the names of three employees to it. (These steps assume that you've already created accounts for these people, as described in Chapter 11.)

  1. In NetInfo Manager, click the tiny padlock in the lower-left corner.

    A dialog box appears, prompting you for an administrator's name and password. The Mac is just checking to make sure that somebody with a clue is at the helm. This is just the kind of surgical activity you don't want most high school students, 10-year-olds in your family, or other Normal account holders performing.

  2. Type the name and password of an administrator (Section 11.2). Click OK.

    Now you get to see a staggering array of network-related variables. In the second column, you'll see that one of them is called groups.

  3. Click groups.

    In the next column to the right, you'll see a list of all the canned groups that come installed with Mac OS X: admin, bin, daemon, kmem, and so on. These terms aren't especially closely related to English, but then again, Unix was designed primarily for efficiency in typing.

    You're ready to add a new group to this list. The easiest way is to duplicate one of the existing groups.

  4. Click admin in the list of groups, and then click the Duplicate button at the top of the window. Click Duplicate in the confirmation message.

    You wind up with a new group in the list, called admin copy. Note that it's highlighted, and a few morsels of information about it appear at the bottom of the window. One of them—in the Property column—says name (see Figure 12-14).

  5. Double-click admin copy at the bottom of the window (in the Value(s) column, as shown in Figure 12-14). Type the new name for your group, and then press Enter.

    You've just created and named a new group. To help Mac OS X keep this one separate from the others, you'll also need to give it a new group ID number, abbreviated gid in Unix-ese:

  6. If the gid value (in the third row at the bottom of the window) isn't already highlighted, double-click it. Then type 200 and press Enter.

    The ID number doesn't especially matter except that it can't be the same as any the other folders' group IDs. The existing ones are all under 100, so you should be in good shape.

At the moment, your new group lists the names of all administrator accounts (because you began this process by duplicating the admin group). Now you need to make sure that the right people belong to this group.

12.4.1.2 Adding people to the new group

The adding-people-to-group process takes place in the bottom half of the window.

  1. Click the users row at the bottom of the window. Choose Directory [image] Insert Value (or press Option- [image] -I).

    As shown in Figure 12-12, the users row now expands, revealing individual rows for each account holder that already belongs to this group. A new_value box waits for you to type in the name of somebody you've created an account for. (Sorry, efficiency fans, there's no simple pop-up list of the accounts on your Mac; NetInfo Manager assumes that you can remember the precise name and capitalization of every account.)

  2. Type the short account name (Section 11.2) of the person you want to add to this group, and then press Enter.

    If you want to add another person, choose Directory [image] Insert Value again, and then type in another name. (You can also delete someone from this group by highlighting the appropriate row and then choosing Directory [image] Delete Value.)

  3. When you're finished adding people, save your changes (Domain [image] Save), and click "Update this copy" in the confirmation dialog box.

    If you have more groups to create, you can start over at step 4 on the previous page. Otherwise, quit NetInfo Manager.

At the moment, you've got yourself a properly defined group, but this information is just kicking around in Mac OS X's head without any practical value. The next step is to tell Mac OS X which folders are the private stomping grounds of this group.

12.4.2 Assigning Groups

It's easy for an administrator to assign groups to files, folders, or disks. Just highlight the icon in question; choose File [image] Get Info; expand the Ownership & Permissions panel (Figure 12-10); click the padlock icon; and use the Group pop-up menu to specify a group. Then use the Access pop-up menu below it to determine how much access this group should enjoy.

You can do exactly the same thing using Terminal, Mac OS X's rabbit hole into the world of Unix commands. The average Macintosh fan will certainly consider this method insanely opaque, user-hostile, and counterintuitive. The average Unix fan will love it. You'll find an overview beginning in Chapter 16.


12.5 Dialing in from the Road

If you're one of the several million lucky people who have full-time Internet connections—in other words, cable modem or DSL accounts—a special thrill awaits. You can connect to your Mac from anywhere in the world via the Internet. If you have a laptop, you don't need to worry when you discover you've left a critical file on your desktop Mac at home.

Mac OS X offers several ways to connect to your Mac from a distant location, including File Sharing over the Internet, virtual private networking, FTP, and SSH (secure shell). Chapter 21 has the details.


12.6 Forgettable Passwords: The Keychain

The information explosion of the computer age may translate into bargains, power, and efficiency, but it carries with it a colossal annoyance: the proliferation of passwords we have to memorize. Shared folders on the network, Web sites, your iDisk, FTP sites—each requires another password to remember. We're not even allowed to use the same password over and over again, because each Web page, file server, FTP site, or protected file requires a different form of password—"five to seven digits, which must include both letters and numbers"; "six characters or more, beginning with a letter"; and so on.

Apple has done the world a mighty favor by inventing the Keychain. The concept is brilliant: Whenever you log into Mac OS X and type in your password, you've typed the master code that tells the computer, "It's really me. I'm at my computer now." The Mac responds by automatically filling in every password blank you encounter in your networking exploits. You can safely forget all of the passwords required for accessing the various other Macs on your network.

Because it's on all the time and memorizes most passwords automatically, the Keychain winds up being invisible for many people. Just go about your business, tapping into other computers on the network as described earlier in this chapter, connecting to your iDisk, and so on. Behind the scenes, the Mac quietly collects the various passwords so that you don't need to enter them again.

TIP

In Mac OS X 10.2, the Keychain Access program described below has a toolbar, just like so many other Mac OS X programs. Also like them, it features a white, oval toolbar button in the upper-right corner. Each time you [image] -click it, you change the look of the toolbar: with or without text labels, with or without icons, large or small, and so on.

When Keychains Don't Unlock the Web

Unfortunately, when it comes to password proliferation, we're not out of the woods yet. The Keychain can't store passwords in programs that haven't been rewritten to be Keychain-aware. Notable among programs that ignore the Keychain is Internet Explorer (version 5.2). In other words, the Keychain doesn't store passwords for secure Web pages, such as those for your bank and online-brokerage accounts, that you type into Internet Explorer. (On the other hand, Internet Explorer has its own built-in password-memorizing feature. It's not as convenient as the master Keychain password, but it's better than nothing.)

The highly regarded Web browser called OmniWeb, however, is Keychain-aware, and does memorize many kinds of Web site passwords. This Web browser is available from the software page of www.missingmanuals.com, for example.

12.6.1 Locking and Unlocking the Keychain

When your Keychain is unlocked, you can open your password-protected FTP sites, iDisk, network servers, and so on, without ever having to enter a password. Technically, you're supposed to enter a name and master password to "unlock" the Keychain every time you sit down in front of your Mac, thereby turning on this automatic-password feature. But Apple figured: "Hey, you've already entered a name and master password—when you logged into the Mac. That's good enough for us."

If you work alone, the Keychain therefore becomes automatic, invisible, and generally wonderful.

But if you work in an office where someone else might sit down at your Mac while you're getting a candy bar, you might want to lock the Keychain when you wander away. (Locking it requires no password.) Mac OS X will no longer fill in your passwords—until you return to your desk and unlock the Keychain again.

You can lock the Keychain in any of several ways, each of which involves the Keychain Access program (in your Applications [image] Utilities folder):

  • Lock the Keychain manually. Click the Lock button in the toolbar of the Keychain Access window (see Figure 12-15).

  • Lock the Keychain automatically. In the Keychain Access program, choose Edit [image] [your name] Settings. As shown in Figure 12-15 at bottom, you can set up the Keychain to lock itself, say, five minutes after the last time you used your Mac, or whenever the Mac goes to sleep. When you return to the Mac, you'll be asked to re-enter your account password in order to unlock the Keychain, restoring your automatic-password feature.

    NOTE

    As noted above, you unlock your Keychain using the same password you used to log into Mac OS X. But that's just a convenience. If you're really worried about security, you can click Change Passphrase (see Figure 12-15) thereby establishing a different password for your Keychain. Of course, doing so also turns off the automatic-Keychain-unlocking-when-you-log-in feature.

Figure 12-15. Top: You can use this program to examine the passwords that Keychain Access is storing for you. (Click one of these rows to see more information about that password in the Attributes window.) Bottom: The Settings dialog box lets you set up auto-locking, and also lets you change your Keychain password so that it no longer matches your login password.

12.6.2 Managing Keychains

To take a look at your Keychain, open the Keychain Access program. By clicking one of the password rows, you get to see its attributes—name, kind, account, and so on (Figure 12-15). At this point, you can turn on "Show Passphrase" to see the actual password it's storing.

You can also click the Access Control tab, which gives you even more control over the security settings (see Figure 12-16).

TIP

The primary purpose of the Keychain is, of course, to type in passwords for you automatically. But it's also an excellent place to record all kinds of private information just for your own reference: credit card numbers, ATM numbers, and so on. Just click the Add button shown in Figure 12-16, and proceed as illustrated there.

No, the Mac won't type them in for you automatically anywhere. But it does maintain them in one central location that is, itself, password-protected.

Figure 12-16. Top: This panel lists the programs that are allowed to "see" this password—yet another degree of security. Still another level of protection comes in the form of the "Confirm before allowing access" checkbox. If you turn it on, Mac OS X will ask you for permission before filling in a password for you automatically. Bottom: You can also store credit card numbers and other secret information in the Keychain Access program.

12.6.3 Multiple Keychains

By choosing File [image] New [image] New Keychain, you can create more than one Keychain, each with its own master password. On one hand, this might defeat the simplicity goal of the Keychain. On the other hand, it's (faintly) conceivable that you might want to encrypt all of your business documents with one master password, and all of your personal stuff with another, for example.

TIP

If you do have more than one keychain, click the Keychains toolbar icon to make a "drawer," which lists all keychains, slide out of the side of the main window. Double-click their names to switch among them.

12.6.4 Keychain Files

Keychains are represented by separate files in your Home folder [image] Library [image] Keychains folder. Knowing that can be handy in several circumstances:

  • Deleting a Keychain. You can delete a Keychain easily enough—just drag a Keychain file out of this folder and into the Trash.

  • Copying a Keychain. You can copy one of your keychain files into the corresponding location on another computer, such as your laptop. It carries with it all the password information for the networks and Web sites of your life.

Rendezvous

Of all the features that make Apple so excited about Mac OS X 10.2, Rendezvous is certainly the most baffling. There's almost no visible trace of it—no Rendezvous folder, not even an icon.

Rendezvous is an underlying technology that lets networked gadgets detect each other and recognize each other's capabilities. (In that regard, it's something like a modern version of the old AppleTalk or NetBIOS networking protocols.)

Out of the box, Rendezvous offers you only a few small benefits so far: For instance, if you've bought one of the new Rendezvous networkable printers from HP, Epson, or Lexmark, you can save a few configuration steps. If you're on the same network with other iChat pals, you can conduct instant-message chats without actually being on the Internet (see Chapter 20), without even having to know their screen names ahead of time. But that's about it—for now.

It's far more tantalizing to contemplate the future of Rendezvous. To quote www.zeroconf.org, whose underlying technology forms the basis of Rendezvous:

"The long-term goal of Zeroconf is to enable the creation of entirely new kinds of networked products, products that today would simply not be commercially viable because of the inconvenience and support costs involved in setting up, configuring, and maintaining a network to allow them to operate."

Apple has shown a prototype version of iTunes, for example, whose song library automatically detects and plays music files from other Macs on the network. There's no reason iPhoto couldn't work the same way, showing you the pictures that reside on Macs all over the network—all one one screen.

But that's just the beginning. If the electronics companies show interest (and some have already), you may someday be able to connect the TV, stereo, and DVD player with just a couple of Ethernet cables, instead a rat's nest of audio and video cables.

The bottom line is that Rendezvous has the potential to make it very easy for all sorts of different gadgets to interact on the same network, but it's still a technology for the future.


Chapter 13. Graphics, Fonts, and Printing

The Macintosh may be only the five-percent solution in the mainstream business world, but in the graphics and printing industries, it's the 800-pound gorilla. You'd better believe that when Apple designed Mac OS X, it worked very hard to keep its graphics and printing fans happy.

This chapter tackles printing, faxing, fonts, graphics, and ColorSync. It also covers PDF (Acrobat) files, which Mac OS X uses as an everyday exchange format—one of the biggest perks in Mac OS X.


13.1 Mac Meets Printer

One of the biggest complaints about the original Mac OS X was that at the outset, not many printer companies had rewritten their printer drivers—the software that controls various printer models—for Mac OS X.

Fortunately, the situation has improved: Today's Mac OS X comes preinstalled with hundreds of printer drivers. All the major printer companies—Epson, HP, Canon, and so on—are on the case, working to develop drivers for current and future printer models. Even so, millions of older printers are incompatible with Mac OS X. The moral: Investigate the situation before you buy the printer (or before you upgrade to Mac OS X).

When you're ready to hook up your printer, follow this guide:

  1. Connect the printer to the Mac, and then turn the printer on.

    Inkjet printers usually connect to your USB jack. Laser printers generally hook up to your Ethernet connector. (If you're on an office network, the laser printer may already be connected somewhere else on the network, saving you this step. If you're hooking the printer straight into your Mac's Ethernet jack, you'll need an Ethernet crossover cable to connect it, rather than a standard Ethernet cable.)

    NOTE

    Most Ethernet- or network-connected laser printers communicate with your Mac using a language called AppleTalk. If you have such a printer, here is step 1.5: Open the Network pane of System Preferences. Click the AppleTalk tab. Turn on Make AppleTalk Active, and then click Apply Now. (If you omit this step, Print Center will nag you about it in step 5.)

  2. Open Print Center.

    Print Center is Mac OS X's printing program. This single program incorporates the functions of a broad array of software you may have known in Mac OS 9, including the Chooser, desktop printer icons, and PrintMonitor.

    You'll find it in your Applications [image] Utilities folder. (You might want to drag Print Center onto your Dock for quicker access the next time.)

    TIP

    You can also open Print Center at the actual moment of printing. In the Print dialog box illustrated in Figure 13-3, you'll see a pop-up menu called Printer. If you choose Edit Printer List from this menu, Print Center opens automatically.

    If you haven't already set up a printer, you see the box shown in Figure 13-1.

  3. Click Add.

    Now a strange little window called Directory Services appears. If you have one of the many inkjet printers that Mac OS X recognizes, and it's turned on and connected to your USB port, you see its name here. Skip to step 5.

    If you work in a corporation where a highly paid network expert has already configured some network printers (using technical tools like NetInfo or LDAP databases), you'll see these printers listed here. Similarly, if you work on a network that's been equipped with one of the very new Rendezvous printers (Rendezvous), they, too, appear here automatically. In either case, skip to step 5.

    But if you find the Directory Services window empty, you need to tell Print Center where to look to find its new printer.

  4. From the upper pop-up menu, choose the kind of printer you intend to use: USB, AppleTalk, or whatever.

    In other words, tell Print Center how the printer is connected to the Mac. Your selection here should mirror your actions in step 2. For example, choose USB if you've connected an inkjet printer to your USB port (or EPSON USB if it's an Epson printer). Choose AppleTalk if you've hooked up a laser printer through your Ethernet jack.

    Most Mac fans are unfamiliar with LPR (Line Printer) printers, which are most often found on corporate networks (and, therefore, connected to your Mac's Ethernet jack). If you and your company's network nerd determine that the printer you want to use is, in fact, an LPR printer, choose IP Printing from the pop-up menu and fill in the appropriate IP address and other settings, as directed by your cheerful network administrator.

    After a moment, the names of any printers that are turned on and connected appear in the printer list (Figure 13-1, middle). For most people, that means just one printer—but one's enough.

    If you're having trouble, see the box on the next page.

  5. Click the name of the printer you want to use, and then click Add.

    After a moment, you return to the main printer list window, where your printer now appears (Figure 13-1, bottom). You're ready to print.

If you're lucky enough to own several printers, you'll have to repeat the steps above for each one. Eventually, you'll have introduced the Mac to all the printers available to it, and all of their names will show up in the printer list.

Whenever you want to switch from one printer to the other, you can return to Print Center and click the new printer's name. There's a much easier way, however: Use the Printer pop-up menu that appears in the Print dialog box (Figure 13-3).

TIP

The printer listed in bold denotes the default printer—the one that the Mac will use unless you explicitly choose a different one for a particular printout. To specify a different default printer, click its name in Print Center and then choose Printers [image] Make Default ( [image] -D).

Figure 13-1. Top: If you've never before hooked up a printer to your Mac, Print Center shows you this message. (If you're trying to hook up an additional printer, on the other hand, begin by choosing Printers Add Printer.) Middle: If you choose the right connection method from the pop-up menu, your Mac should automatically "see" any printers that are hooked up and turned on. If you have some oddball printer whose driver doesn't come built into Mac OS X, this is where you find out (see the "Driver not installed" message). Find the driver, if it exists, on the printer's CD or Web site. Bottom: If you've set up more than one printer in this way, you'll see all of them listed in the Printer List. The one whose name appears in bold is the one currently selected—the one destined to produce your next printout. Bonus tip: If the maker of your printer steadfastly refuses to cough up a Mac OS X driver for it, hie thee to http://gimp-print.sourceforge.net/MacOSX.php3. That's where you'll find the strangely named but wonderful GIMP-Print, a package of high quality printer drivers for Mac OS X 10.2. These drivers give new life to hundreds of current and older Epson, Canon, HP, and Lexmark printers. Read the site for details on remaining glitches in this bold, open-source project.
    [ Team LiB ]


13.2 Making the Printout

You print documents from within the programs you used to create them, exactly as in previous versions of the Mac OS. The options for printing should feel distinctly familiar.

Three Detours

You may need to take one of three detours when introducing your Mac to its printer.

First, if you're on a really huge corporate network, the printer list may show you the names of several different network zones (network subdivisions). You may need to choose the appropriate zone, using the pop-up menu that miraculously appears, before you see the names of the printers in it.

Second, you may occasionally need to use the Printer Model pop-up menu. Most of the time, the Auto Select setting works just fine. If you experience trouble printing, however, consider choosing a specific printer model from this pop-up menu. (And if you don't see it listed, then something might have gone wrong with your software installation. Call the printer company for help.)

Finally, if you see your printer's name here but the words "Driver not installed" appear next to it, well, then, the driver isn't installed (Figure 13-1, middle). Mac OS X comes with the drivers for most recent printer models from Canon, Epson, Lexmark, and HP, but older models may not be included. Back out of this whole operation, install the Mac OS X driver software (which you've dutifully downloaded from the printer company's Web site), and then repeat the setup process.

So how do you know if Mac OS X has your driver already? If you're trying to hook up a PostScript laser printer, its installer puts something called a PPD (PostScript Printer Description) file into your Library [image] Printers [image] PPDs folder. And if you're hooking up any other kind of printer, such as a color inkjet, its driver software winds up in the Library [image] Printers folder, usually in a folder named for the company (like Epson or Canon).

Meanwhile, here's a related tip. Open your hard drive [image] Library [image] Printers folder. Examine the printer-manufacturer folders inside. These are the drivers that come with Mac OS X—all 490 megabytes of them. You can save a lot of disk space by throwing away the folders for printer models you don't own (Administrator account required).

13.2.1 Page Setup

The experience of printing depends on the printer you're using—laser printer, color inkjet, or whatever. In every case, however, all the printing options hide behind two commands: File [image] Page Setup, which you need to adjust only occasionally, and File [image] Print, which you generally use every time you print. You'll find these two commands in the File menu of almost every Macintosh program.

The pop-up menu at the top of the Page Setup dialog box offers a command called Summary, which simply displays a textual description of the document you're about to print (orientation, paper dimensions, and so on). It sometimes offers a command specific to the program you're using. For example, in Microsoft Word, the Settings [image] Microsoft Word command offers a screenful of custom page-size and margin settings.

The real action, though, is in the dialog box that appears when you choose Page Attributes from this pop-up menu. Here, for example, are the controls you need to print a document rotated sideways on the page, so that it prints "the long way." The Scale control, which lets you reduce or enlarge your document, can be handy if the program you're using doesn't offer such a control. And the Paper pop-up menu, of course, specifies the size of the paper you're printing on—US Letter, US Legal, or one of the standard European paper sizes (A4 and B5).

The remaining choices vary. The Page Setup options for an Epson inkjet, for example, differ dramatically from those for a laser printer. Only your printer's user manual can tell you exactly what these choices do.

TIP

You can (and must) configure the Page Setup settings independently in each program you use. And by the way: To change the default paper size for all new documents, choose Print Center [image] Preferences and simply choose the paper size you want to use. (Mac fans in the UK: You're welcome.)

Figure 13-2. The options included in this dialog box depend on the printer model you're using. Sometimes, as when printing on a laser printer, the pop-up menu at the top lets you switch among different screens full of choices. Unfortunately for whimsy fans, the little animal known as the Dogcow no longer illustrates the effect of each printing option.

13.2.2 The Print Command

Although you can grow to a ripe old age without ever seeing the Page Setup dialog box, you can't miss the Print dialog box. It appears, like it or not, whenever you choose File [image] Print in one of your programs.

Once again, the options you encounter depend on the printer you're using. But here's what you may find on the main screen—that is, when the pop-up menu says Copies & Pages:

  • Printer. One cool thing about Mac OS X is that if you have more than one printer connected to your Mac, you can indicate which you want to use for a particular printout just by choosing its name from this pop-up menu.

  • Presets. Here's a way to preserve—and call up again with one click—your favorite print settings. Once you've proceeded through this dialog box, specifying the number of copies, which printer trays you want the paper taken from, and so on, you can choose Save As from the pop-up menu shown in Figure 13-3, and then assign your settings set a name (like "Borderless, 2 copies"). Thereafter, you'll be able to re-create that elaborate suite of settings just by choosing its name from this pop-up menu. (The ability to save different print settings under different names is new in Mac OS X 10.2.)

  • Copies. Type the number of copies you want printed. The Collated checkbox controls the printing order for the various pages. For example, if you print two copies of a three-page document, the Mac will generally print the pages in this order: 1, 2, 3, 1, 2, 3. If you turn off Collated, on the other hand, it'll print in this order: 1, 1, 2, 2, 3, 3.

  • Pages. You don't have to print an entire document—you can print, say, only pages 2 through 15. Use commas and hyphens to spell out exactly the pages you want. Typing 1, 3-6, 9 will produce pages 1, 3, 4, 5, 6, and 9.

    TIP

    You don't have to type numbers into both the From and to boxes. If you leave the first box blank, the Mac assumes that you mean "from page 1." If you leave the second box blank, the Mac understands you to mean "to the end." To print only the first three pages, in other words, leave the first box blank, and type 3 into the second box. (These page numbers refer to the physical pages you're printing, not to any fancy numbering you've set up in your word processor. As far as the Print dialog box is concerned, the first printed page is page 1, even if you've told your word processor to label it page 455.)

  • Preview. This button provides a print-preview function to every Mac OS X program on earth, which, in the course of your life, could save huge swaths of the Brazilian rain forest and a swimming pool's worth of ink in wasted printouts.

    Technically, the Preview button sends your printout to the Mac OS X program called Preview (which sits in your Applications folder). As described in Section 9.1.16, Preview lets you zoom in or zoom out, rotate, or otherwise process your preview. When you're satisfied with how it looks, you can either print it (File [image] Print), cancel it (File [image] Close), or turn it into an Acrobat file (File [image] Save as PDF). This final option, which is a very big deal, is described next.

  • Save As PDF. Clicking this delightful button, of course, turns your document into a PDF file instead of printing it. PDF means an Adobe Acrobat document—a file that any Mac, Windows, Linux, or Unix user can view, read, and print using the free Acrobat Reader program included with every Mac and PC. (Much more on PDF files in Section 13.5.)

If you examine the unnamed pop-up menu just below the Presets pop-up menu, you'll find dozens of additional options. They depend on your printer model and the program you're using at the moment, but here are some typical choices:

  • Layout. As shown in Figure 13-3, you can save paper and ink or toner cartridges by printing several miniature "pages" on a single sheet of paper.

  • Output Options. Turning on "Save as File," choosing PDF from the Format pop-up menu, and then clicking Print saves your document as a PDF file, exactly like the Save As PDF button described above. (The Save As PDF button is new in 10.2; this more labor-intensive panel is what preceded it.)

  • Paper Feed. If you chose the correct PPD file for your printer, then this screen "knows about" your printer's various paper trays. Here's where you specify which pages you want to come from which paper tray. (By far the most popular use for this feature is printing the first page of a letter on company letterhead, and the following pages on regular blank paper from a second tray.)

  • Mode/quality settings or Print Settings (inkjet printers only). Here's where you specify the print quality you want, the kind of paper you're printing on, and so on.

  • Color Management. Some color inkjet printers offer this panel, where you can adjust the color settings—a little more red, perhaps. This is also where you indicate whose color-matching system you want to use: Apple's ColorSync, your printer manufacturer's, or none at all.

  • Error Handling. Using these controls, you can specify that you want a technical message to print out when the laser printer reports a PostScript error (when your document is too complex for the printer's memory, for example). Depending on your printer, you may also be able to specify what should happen if your specified paper tray runs out of paper.

  • [Program Name]. Whichever program you're using—Internet Explorer, Word, AppleWorks, or anything else—may offer its own special printing options on this screen.

  • Summary. This command summons a text summary of all your settings so far.

    TIP

    Here's one for the technically inclined. If you have a networked printer, open your Web browser and enter this address: http://127.0.0.1:631. You find yourself at a secret "front end" for CUPS (Common Unix Printing System), the new underlying printing technology for Mac OS X 10.2—and one that lets your Mac communicate with a huge array of older printers that don't yet have Mac OS X drivers. Using this administration screen, you can manage your networked printers and print jobs—a very slick trick.

Figure 13-3. By asking the Mac to print several pages per sheet of paper, you can compare various designs, preview an overall newsletter layout, and so on. Using the Border pop-up menu, you can also request a fine border around each miniature page. Some printers even offer a Print on Both Sides option here, ideal for printing little booklets.

13.2.3 Printing

When all of your settings look good, click Print (or press Enter) to send your printout to the printer.

Background Printing

Where's the Background Printing control? I used to like turning background printing off when I was in a hurry, or leaving it on if I wanted to keep working while printing.

In the beginning, the Mac simply locked you out whenever it was printing. You couldn't do anything with the Mac except stare at the "now printing" message.

With the invention of background printing, your options became more interesting. Background printing lets you use your Mac while the printing takes place. As a result, the printout takes longer than it would in the foreground—but you can keep working in the meantime.

There's no longer a background printing control in Mac OS X, for one very good reason: It would be completely unnecessary. Background printing is turned on all the time in Mac OS X—you can't turn it off.

As you may have realized by now, Mac OS X is the king of multitasking. Managing printouts in the background is a trivial task for this mighty beast. It spends about as much of its attention thinking about printing as you do thinking about what you'll have for breakfast next Wednesday.


13.3 Managing Printouts

The real fun of printing begins only after you've used the Print command. Once you've done so, the Mac hands off the printing tasks to the Print Center program.

At this point, you can manage the printouts-in-waiting in a number of ways—ways that are useful primarily for people who do a lot of printing, have connections to a lot of printers, or share printers with many other people.

Start by opening Print Center. In the list of printers, the Status column shows you which printers are busy. Double-click a printer's name to see something like Figure 13-4; namely, the printouts that will soon be sliding out of your printer appear in a tidy list.

Figure 13-4. Waiting printouts appear in this Print Center window. You can manipulate this window exactly as you would any Finder list view. For example, you can sort the list by clicking the column headings Name, Status, and so on; make the columns wider or narrower by dragging the column-heading dividers horizontally; or reverse the sorting order by clicking the column name a second time.

Here are some of the ways in which you can control these waiting printouts, which Apple collectively calls the print queue:

  • Delete them. By clicking an icon, or [image] -clicking several and then clicking the Delete toolbar button, you remove items from the list of waiting printouts. Now they won't print.

  • Pause them. By highlighting a printout and then clicking the Hold button, you pause that printout. It won't print out until you highlight it again and click the Resume button. This pausing business could be useful when, for example, you need time to check or refill the printer, or when you're just about to print your resignation as your boss drops by to offer you a promotion.

  • Halt them all. You can stop all printouts from a specific printer by clicking the Stop Jobs button. (They resume when you click the button again, which now says Start Jobs.)

    NOTE

    You can't rearrange printouts by dragging them up or down in the queue lists, nor drag printouts between these lists.


13.4 Printer Sharing

Mac OS X 10.2 restores a beloved Mac OS 9 feature that disappeared during the dark and stormy 10.0 and 10.1 era: USB printer sharing. It's for people (or offices) with more than one Mac, connected as a network (Chapter 12), who'd rather not buy a separate printer for each machine. Instead, you connect the printer to one main Mac, flip a couple of software switches, and then boom: The other Macs on the network can send their printouts to the printer without actually being attached to it—even wirelessly, if they're on an AirPort network.

Setting up printer sharing is easy. On the Mac with the printer, open the Sharing panel of System Preferences. Turn on Printer Sharing.

Now, on each of the other Macs, open the Print Center program (in your Applications [image] Utilities folder). Click Add. When the printer list appears, choose Directory Services from the top pop-up menu, and make sure that Rendezvous is selected in the bottom one. Presto: The name of the USB printer, elsewhere on the network, appears in the list. You're ready to share.

Alas, Mac OS X's version of printer sharing can't communicate with Mac OS 9's version—with one exception. A Mac OS 9 machine can use a Mac OS X machine's attached printer if the latter is running Classic, with USB Printer Sharing turned on.

Printing from Classic Programs

If you imagine Mac OS X as an intervening layer between the Classic programs (see Chapter 5) and Macintosh circuitry itself, you won't find it so surprising that printing documents from within Classic programs isn't, shall we say, one of the highlights of the Mac OS X experience.

Many older printers (those that use the so-called QuickDraw technology), including the ImageWriter, StyleWriter, and many in the Personal LaserWriter line, can't print at all from within Classic programs. If you want to use these printers, you must restart in Mac OS 9, as described in Section 5.3.

Some USB inkjet printers work within Classic, and some don't. (Most PostScript laser printers, fortunately, work fine.)

In any case, you need to treat Classic as though it were a separate Macintosh. That is, even if you've already installed your printer's software under Mac OS X, you must install it again while running Classic.


13.5 PDF Files

Sooner or later, almost everyone with a personal computer encounters PDF (portable document format) files. Many a software manual, Read Me file, and downloadable "white paper" comes in this format. Until recently, you needed the free program called Acrobat Reader (Section 9.1.1) if you hoped to open or print these files. In fact, Windows users still do.

But PDF files are one of Mac OS X's common forms of currency. In fact, you can turn any document (in any program with a Print command) into a PDF file—a trick that once required the $250 program called Adobe Acrobat Distiller. (Maybe Apple should advertise: "Buy Acrobat Distiller for $250, get Mac OS X free—and $120 cash back!")

And why would you want to do so? What's the big deal about PDF in Mac OS X? Consider these advantages:

  • Other people see your layout. When you distribute PDF files to other people, they see precisely the same fonts, colors, page design, and other elements that you did in your original document. And here's the kicker: They get to see all of this even if they don't have the fonts or the software you used to create the document. (Contrast with the alternative: Sending somebody a Microsoft Word document, for example. If your correspondents don't have precisely the same fonts you have, then they'll see a screwy layout. And if they don't have Microsoft Word, they'll see nothing at all.)

  • It's universal. PDF files are very common in the Macintosh, Windows, and even Unix/Linux worlds. When you create a PDF file, you can distribute it (by email, for example) without even thinking about the kinds of computers your correspondents are using.

  • It has very high resolution. PDF files print at the maximum quality of any printer. A single PDF file prints great both on cheapo inkjets and on high-quality image-setting gear at professional print shops. (You're looking at a PDF file right now, in fact, which was later printed at a publishing plant.)

  • You can search it. Although you may be tempted to think of a PDF file as something like a captured graphic of the original document, it has several key differences. Behind the scenes, its text is still text. Furthermore, you can search this text using a Find command—an especially handy feature when you work with electronic software manuals in PDF format.

What About My Scanner?

I hear that pretty soon, new Macs won't be able to restart in Mac OS 9. How am I supposed to use my scanner?

No doubt about it: Scanning is still a sore spot for Mac OS X fans (and Mac OS X foes). Precious few scanners work with Mac OS X, even a year after its release.

Mac OS X drivers are available for only a few scanners from a few companies. If your scanner model isn't one of the lucky ones, run, don't walk, to www.hamrick.com to download VueScan. It's a $40 shareware program that makes dozens of scanners work with Mac OS X, including:

SCSI models including all SCSI scanners from Apple, Epson, Canon, HP, Microtek, UMAX, LinoType-Hell, Acer, and Agfa.

USB models including all scanners from Epson and many from Canon, HP, Microtek, Umax, and others.

FireWire models including all scanners from Epson, Microtek, UMAX, and LinoType-Hell.

Don't waste any more time pondering the irony that Apple, a company that counts graphics professionals among its core audiences, has ignored the scanning problem for so long; just download VueScan and rejoice.

13.5.1 Opening PDF Files

There's nothing to opening up a PDF file: Just double-click it. Either Preview or Acrobat Reader takes over from there, and opens the PDF file on your screen.

13.5.2 Creating PDF Files

Opening, schmopening—what's really exciting in Mac OS X is the ability to create your own PDF files. You can do so in any of several ways.

  • The File [image] Save as PDF method. Not all programs offer a File [image] Save as PDF command. But the ones that do provide by far the easiest method of creating a PDF file. A Save dialog box appears. All you have to do is type a name for the file and save it. It's then ready for distribution, backing up, or whatever.

  • The Save As PDF button. The standard Print dialog box offers a Save As PDF button (Figure 13-3). When you click it, Mac OS X saves your printout-to-be to the disk instead of printing it.

  • The Save as File method. If that business of clicking a simple Save As PDF button strikes you as too straightforward, you can also choose File [image] Print. In the Print dialog box (Figure 13-3), choose Output Options from the unnamed pop-up menu. Turn on Save as File, and choose PDF from the Format menu. Finally, click Save.

    NOTE

    All right, that joke about a free copy of Acrobat Distiller is an exaggeration. Mac OS X alone creates screen-optimized PDF files: compact, easy-to-email files that look good on the screen but don't have the high resolution for professional printing. For high-end purposes and more optimization for specific uses (Web, fancy press machines, and so on), you still need a program like Adobe Acrobat Distiller.

When PDF Doesn't Match the Original

Once you've created a PDF file, you can email it to someone, back it up, or print it (after opening it in Preview or Acrobat Reader).

But in certain situations, the document another person sees and prints may not always be 100 percent identical to the original. One key reason: The characteristics of the printer currently selected affect things like letter spacing and margins (of any document, not just PDF files).

For example, if an inkjet printer was selected in Print Center when you created the PDF file, the layout may be slightly out of whack when printed on a laser printer.

There's not much you can do to prevent this problem except to try to anticipate the kind of printer that your audience will use when printing. Select the appropriate kind of printer in Print Center before you create the PDF file, even if you have no intention of printing it.


13.6 Fonts in Mac OS X

Over the years, Macintosh fonts have improved considerably. No longer must you pray to the printer gods that your beautiful flyer won't come out with jagged-looking type because you chose the wrong font type, one that doesn't have smooth edges.

Up through Mac OS 9, a family of typefaces called bitmapped fonts was still kicking around, a holdover from the jagged-printing days of the original 1984 Macintosh. But Mac OS X can't even use such fonts. Only always-smooth font formats work in Mac OS X: namely, TrueType, PostScript Type 1, and OpenType. (OpenType is a font format developed by Microsoft and Adobe that's already common on Windows machines.)

In short, Mac OS X delivers us fully into the era of type that is all smooth, all the time. Fonts always look smooth onscreen, no matter what the point size, and always look smooth in printouts, no matter what kind of printer you use. Never again will you spend money on programs like Adobe Type Manager just to make your type look smooth.

Figure 13-5. Apple giveth, and Apple taketh away. In Mac OS X, all kinds of fonts are represented by a single icon apiece—a single font suitcase. PostScript fonts no longer require separate files for printer display and screen display. On the other hand, you can no longer double-click a font suitcase to see a preview of what its characters look like, as you could in Mac OS 9.

13.6.1 Where Fonts Live

If you're used to Mac OS 9 or Windows, one of the most confusing changes is that there is no longer one single Fonts folder for your computer. There are now five Fonts folders. The fonts you actually see listed in the Fonts menus of your programs are combinations of these Fonts folders' contents. They include:

  • Your private fonts (your Home folder [image] Library [image] Fonts). This Fonts folder sits right inside your own Home folder. You're free to add your own custom fonts to this folder. Go wild—it's your font collection and yours alone. Nobody else who uses the Mac will be able to use these fonts, and will never even know that you have them.

  • Main font collection (Library [image] Fonts). This, for all intents and purposes, is the equivalent of the traditional Fonts folder. Any fonts in this folder are available to everyone to use in every program. (As with most features that affect everybody who shares your Macintosh, however, only people with Administrator accounts are allowed to change the contents of this folder.)

  • Network fonts (Network [image] Library [image] Fonts). In certain corporations, a network administrator may have set up a central font collection on another computer on the network, to which your Mac and others can "subscribe." The beauty of this system, of course, is that everybody on the network will be able to rely on a consistent set of fonts. (In this case, the Network "folder" is represented by the Network icon in your Go [image] Computer window.)

  • Essential system fonts (System [image] Library [image] Fonts). This folder contains the fonts that the Mac itself needs: the typefaces you see in your menus, dialog boxes, icons, and so on. You can open this folder to see these font suitcases, but you can't do anything with them, such as opening, moving, or adding to them. Remember that, for stability reasons, the System folder is sealed under glass forever. Only the superuser (Section 11.7) can touch these files—and even that person would be foolish to do so.

  • Classic fonts (Mac OS 9 System Folder [image] Fonts). Mac OS X automatically notices and incorporates any fonts in the System Folder that you've designated for use by the Classic environment (Chapter 5). This folder is also, of course, the source of fonts that appear in the Font menus of your Classic programs.

    NOTE

    With up to five folders containing fonts, you might wonder what happens in the case of conflicts. For example, suppose you have two slightly different fonts, both called Optima, which came from different type companies, and are housed in different Fonts folders on your system. Which font will you actually get when you use it in your documents?

    The scheme is actually fairly simple: Mac OS X proceeds down the list of Fonts folders in the order shown above, beginning with your own home Fonts folder. It only acknowledges the existence of the first duplicated font it finds.

13.6.2 Installing Fonts

One of the biggest perks of Mac OS X is its preinstalled collection of over 50 great-looking fonts—"over $1000 worth," according to Apple, which licensed many of them from type companies. In short, fewer Mac users than ever will wind up buying and installing new fonts.

But when you do buy or download new fonts, you're in luck. There's no limit to the number of fonts you can install. Furthermore, installing them is a simple matter of dragging the new font files into the appropriate Fonts folder. (Newly installed fonts don't appear in the Font menus of programs that are already open. You have to quit and reopen them.)

NOTE

When you install new fonts in Classic, not only must you quit your open Classic programs—you must actually restart Classic itself to make the new fonts show up in your menus.

To remove a certain font, you (or an administrator) must drag its corresponding icon out of all five Fonts folders. You don't have to quit your open programs first, although you may find it confusing that the font's name remains, now orphaned, in their Font menus.

13.6.3 The Fonts Panel

As noted in Chapter 4, some existing Mac programs have simply been touched up—Carbonized, in the lingo—to be Mac OS X-compatible. Choosing fonts in these programs works exactly as it always has on the Mac: You choose a typeface name from the Font menu or a formatting palette.

Things get much more interesting when you use programs that have been written from scratch expressly for Mac OS X. These so-called Cocoa programs, which include TextEdit and Mail, offer a new, standard Mac OS X feature called the Fonts panel. If you're seated in front of your Mac OS X machine now, fire up TextEdit and follow along.

13.6.3.1 Choosing fonts from the Fonts panel

Suppose you've just highlighted a headline in TextEdit, and now you want to choose an appropriate typeface for it.

In TextEdit, you open the Fonts panel (Figure 13-6) by choosing Format [image] Font [image] Show Fonts ( [image] -T). See how the Fonts panel is divided into columns (if the window is wide enough)? The first column, Collections, contains the names of font-list subsets, such as Fun or Modern; this makes it easier to locate the kind of font you're looking for. (PDF represents a set of standard fonts used in PDF files. Web lists fonts you're safe using on Web pages—that is, fonts that are very likely to be installed on the Macs or Windows PCs of your Web visitors.)

Figure 13-6. The Fonts panel, generally available only in Cocoa programs, contains some of the genetic material of old-style programs like Suitcase and Font Juggler. By clicking the name of a collection in the far left column, you can summon subsets of your fonts that make it much easier to home in on what you're looking for. See the handy font sample shown here above the font lists? To get it, choose Show Preview from the Extras pop-up menu. Or use the mousy way : Place your cursor just above the headings (Collections, Family, and so on) and drag downward. You can even edit the sample text. Make it say, "The quick brown fox jumps over the slow lazy dog," if you like. The point is that font previews are back in 10.2.

The second column, Family, shows the names of the actual fonts in your system. The third, Typeface, shows the various style variations—Bold, Italic, Condensed, and so on—available in that type family. (Oblique and Italic are roughly the same thing; so are Bold and Black.)

NOTE

Unfortunately, not all fonts offer the full range of styles. Some, in fact, offer no style variations at all.

The silver lining here is that these are "real" styles. Desktop publishers will never again deal with a phony, onscreen bold effect that winds up printing out standard non-bold characters—an expensive and wasteful discovery.

The last column lists a sampling of point sizes. Of course, you can actually use any point size you want by typing any number into the box at the top of the Sizes list; these common sizes are just listed to save you a little typing.

13.6.3.2 Designing collections and favorites

At the bottom of the Fonts panel is a small pop-up menu labeled Extras. It offers a few useful tools for customizing the standard Fonts panel.

  • Add to Favorites. In the first column of the Fonts panel, the category called Favorites represents the first of several tools Apple provides to manage unwieldy font collections. Figure 13-7 shows how to designate a font as a favorite.

    From now on, whenever you click Favorites in the Collections column, you'll see a list of the typefaces you've specified (Figure 13-7, right).

Figure 13-7. Left: To designate a font as one of your favorites, specify a font, style, and size by clicking in the appropriate columns of the Fonts panel. Then, from the Extras pop-up menu, choose Add to Favorites. Right: Thereafter, the specified typefaces are easily available—and, incidentally, displayed in their own font faces for easy reference.

  • Edit Collections. This command lets you add to the Collections column. Maybe you want to put certain fonts in groups called Headline or Sans Serif, creating smaller groupings of fonts for easier selection in your everyday work. Either way, the instructions in Figure 13-8 show how you do it.

    TIP

    Each time you create a new font collection, Mac OS X records its name and contents in a little file in your Home folder [image] Library [image] FontCollections folder. (A font collection called Fun, for example, shows up as an icon named Fun.fcache.)

    By copying these files into the Shared folder (see Section 11.4.3), you can make them available to anyone who uses the Mac. If your sister, for example, copies one of these files into her own Home folder [image] Library [image] FontCollections folder, she'll see the name of your collection in her own Fonts panel. This way, she can reap the benefits of the effort and care you put into its creation.

Figure 13-8. When you choose Edit Collections from the Extras pop-up menu, you get this display. Click the + button to create a new entry in the Collections column, whose name you can edit. Click the name of a font in the Family column, and then click the << button, to add this font's name to your collection. (To remove it from your collection, click its name and then click >>.) Each font can be in as many different collections as you want. When you're finished, click Done.

  • Edit Sizes. As noted above, the point sizes listed in the Fonts panel are just suggestions. You can actually type in any point size you want.

    By choosing this command, in fact, you can edit this list so that the sizes you use most often are only a click away. As shown in Figure 13-9, you can even replace the entire column of numbers with a point-size slider that makes your highlighted text grow or shrink in real time as you drag it—a spectacular effect that almost single-handedly justifies your installation of Mac OS X.

Figure 13-9. Top right: To remove a point size from the list, click it and then click the - button. To add a new point size, type it into the New Size box and click +. Bottom left: If you think it might be handier to replace the list of numbers with a slider, click Adjustable Slider. You can also opt to have both the list and the slider (choose List & Slider). It's fun to drag the slider and watch highlighted text grow and shrink in real time.

  • Show Preview. The Fonts panel is great and all that, but you may have noticed that it doesn't actually show you the fonts you're working with—something of an oversight in a window designed to help you find your fonts. This command, new in 10.2, adds a display section to the top of the Fonts panel, where you can at least see the font's name displayed in its own font. (Choose this command again—now called Hide Preview—to get rid of this preview.)

    TIP

    Once you've opened the Preview pane, feel free to click the different sizes, typeface names, and family names to see the various effects.

  • Show Characters. Opens the new Character Palette described in The Character Palette.

  • Color. Opens the Color Picker dialog box (The Color Picker).

  • Get Fonts. Opens your browser to an Apple Web page that sells new fonts.


13.7 Font Fuzziness on the Screen

As noted earlier in this chapter, printed type generated by Mac OS X always looks smooth and terrific, at all sizes and on any printer.

On the screen, however, some people describe the type in Mac OS X as remarkably smooth—while others describe it as fuzzy. There's a lot of confusion regarding Mac OS X's jaggies-eliminating technology, which is technically referred to as antialiasing.

Mac OS X's success in enhancing screen type depends primarily on the size of the type. If you find that very small type is too fuzzy for comfort, open System Preferences, click the General icon, and choose a higher number from the "Turn off text smoothing for font sizes __ and smaller" pop-up menu. The setting you assign here affects type in every program, including the Finder.

Furthermore, a new 10.2 feature lets you change the style of this font smoothing; see Section 8.11 for details and illustrations.

TIP

You can't make Mac OS X apply antialiasing to eight-point type or smaller—at least not without the help of TinkerTool 2, which you can download from the software page at www.missingmanuals.com.


13.8 ColorSync

As you may have read elsewhere in this book—or discovered through painful experience—computers aren't great with color. Each device you use to create and print digital images "sees" color a little bit differently, which explains why the deep amber captured by your scanner may be rendered as chalky brown on your monitor, yet come out as a fiery orange on your Epson inkjet printer. Since every gadget defines and renders color in its own way, colors are often inconsistent as a print job moves from design to proof to press.

ColorSync attempts to sort out this mess, serving as a translator between all the different pieces of hardware in your workflow. For this to work, each device (scanner, monitor, printer, digital camera, copier, proofer, and so on) has to be calibrated with a unique ColorSync profile—a file that tells your Mac exactly how your particular monitor (or scanner, or printer, or digital camera) defines colors. Armed with the knowledge contained in the profiles, the ColorSync software can make on-the-fly color corrections, compensating for the various quirks of the different devices.

Most of the people who lose sleep over color fidelity are those who do commercial color scanning and printing, where "off" colors are a big deal—after all, a customer might return a product after discovering, for example, that the actual product color doesn't match the photo on a company's Web site.

13.8.1 Getting ColorSync Profiles

ColorSync profiles for most Apple color printers, scanners, and monitors come built into Mac OS X. When you buy equipment or software from, say, Kodak, Agfa, or Pantone, you may get additional profiles. If your equipment didn't come with a ColorSync profile, visit Profile Central (www.chromix.com), where hundreds of model-specific profiles are available for downloading. Put new profiles into the Library [image] ColorSync [image] Profiles folder.

13.8.2 Choosing Default Profiles

In professional graphics work, a ColorSync profile is often embedded right in the photo, making all of this automatic. Using the ColorSync panel of System Preferences, you can specify standard ColorSync profiles that Mac OS X should use whenever it encounters an image that doesn't include one (see Figure 13-10).

TIP

In your Applications [image] Utilities folder, you'll find a program called Display Calibrator. It's designed to create a profile for your particular monitor in your particular office lighting—all you have to do is answer a few fun questions onscreen and drag a few sliders.

13.8.3 More on ColorSync

If you ache to learn more about ColorSync, you won't find much in Mac OS X's Help system. Instead, search the Web. At www.apple.com/colorsync, for example, you'll find articles, tutorials, and—perhaps most important—a link to an email discussion group where you can pose questions and read other people's answers. Going to a site like www.google.com and searching for ColorSync is also a fruitful exercise.

Figure 13-10. Some programs embed ColorSync profiles right into the documents themselves. If your program doesn't, use the Default Profiles tab of the ColorSync System Preferences panel to specify which color settings your documents should use by default. Clearly, knowing which settings to apply here requires a certain understanding of color spaces (color-description algorithms like RGB and CMYK).

AppleScript and ColorSync

Using AppleScript, described in Chapter 7, you can harness ColorSync in elaborate ways. Just by dragging document icons onto AppleScript icons, for example, you can embed ColorSync profiles, modify the profiles already incorporated, remove profiles, review the profile information embedded in a graphic, and much more. Better yet, you don't even have to know AppleScript to perform these functions—just use the built-in AppleScripts that come with Mac OS X.

To find them, open the Library [image] ColorSync [image] Scripts folder. Unfortunately, there aren't any instructions for using these eighteen ready-made AppleScripts. Nonetheless, Apple's real hope is that these example scripts will give you a leg up on creating your own AppleScripts. Apple hopes that one day, you, the print shop operator, will be able to automate your entire color processing routine using AppleScript and ColorSync.


13.9 Graphics in Mac OS X

Now you're talking. If you want to see dilated pupils and sweaty palms, just say "graphics" to any Mac OS X junkie.

Yes, graphics is one of the big deals with Mac OS X, thanks to its sophisticated Quartz graphics-processing technology. Everywhere you look in Mac OS X, you'll find visual effects that would make any other operating system think about early retirement. For example, how many of these effects have you noticed?

  • Menus don't roll up when you release them—they fade away.

  • Menus are slightly transparent.

  • You can set the bars in Excel graphs to be slightly transparent, so that they don't block other bars in 3-D graphs.

  • When you paste files into windows in icon view, their icons fade into view.

  • When you open an especially long message in Mail, its text fades in from white.

13.9.1 Graphics Formats in Mac OS X

Mac OS X understands dozens of Mac and Windows graphics file formats. Better yet, its Preview program (Section 9.1.16) can open such graphics and then export them in a different format, making Preview an excellent file-conversion program.

You can confidently double-click graphics files—from a digital camera, scanner, or a Web download, for example—in any of these formats:

  • PICT files. For almost 20 years, the PICT file was the graphics format Mac fans were most familiar with. It was the graphics format used by the Macintosh Clipboard, and it was the format created by the Shift- [image] -3 keystroke (see Section 13.10).

    Unfortunately, no other kinds of computers could open these files, therefore PICT files gave conniptions to the equipment at printing shops. Mac OS X acknowledges the existence of PICT files, and can open them just fine; the Preview program can even export them. Otherwise, however, Mac OS X dramatically underplays the importance of PICT files, which will soon ride into the sunset.

  • TIFF files. The TIFF file format is a high-density bitmap—that is, the Mac has memorized the color of each tiny dot in the file. Trying to enlarge one is like enlarging a fax: Make it too big, and the image breaks down into visible dots.

    Nonetheless, TIFF files are very popular in the printing industry—all the graphics in this book, for example, were stored as TIFF files. They print beautifully, work nicely in page-layout programs, and are understood by both Macs and PCs.

  • JPEG files. This format is one of the most popular on the Web, particularly for photos or other high-quality, full-color artwork. You'll also see JPEG files by the thousands online—including America Online—ready for downloading.

    What makes JPEG files ideal for online use is that they've been compressed (using a program like Photoshop); just enough of the color data has been thrown out from the original file to make the image a quick download. (Just be careful not to open a JPEG file, edit it, and then save it again as a JPEG file. In effect, you'll be throwing away another half of the color data, sometimes making the resulting photo look blotchy.)

  • GIF files. GIF stands for graphics interchange format. Today, GIF files are used almost exclusively on the Web, usually for solid-colored graphics like cartoons, headlines, and logos. (A GIF file can have a maximum of 256 colors, which is not even close to the photorealism of, say, JPEG. That's what makes GIF files inappropriate for photographs.)

  • PNG files. As it turns out, one of the algorithms used by GIF files is, technically speaking, the property of a company called Unisys, which threatened to sue everybody who was creating GIF files. No problem, said the World Wide Web Consortium, we'll just come up with our own replacement—a file format that has no legal strings attached. What they created was PNG (for Portable Network Graphics). You can already save AppleWorks and Preview documents in PNG format, and every modern Web browser understands it.

    PNG files aren't limited to 256 colors, as GIF files are, and they don't lose quality when compressed, as JPEG files do. On the other hand, PNG files don't accommodate animation, as GIF files do. And when it comes to photos, they don't offer as impressive a size/quality balance as JPEG.

  • PDF (Acrobat) files. You can read all about these files in Section 13.5. That's where you can read about how PDF files offer some spectacular features, especially when it comes to distributing documents built of both text and graphics. You'll also be delighted to find out that Mac OS X traffics effortlessly in PDF files, meaning that you can distribute documents you create to almost anyone, confident that they'll be able to open and print your stuff regardless of what kind of computer, fonts, and programs they have.

  • Photoshop files. If you're a graphic designer or Webmeister, this one is kind of neat: Mac OS X can open (and its Preview program can even export) actual Photoshop files, the kind that you could once create only by using Adobe Photoshop. In practical terms, the fact that Mac OS X can open and display these files means that you could use a Photoshop masterpiece, complete with layers and transparency, as, for example, a Mac OS X desktop background.

  • BMP. You can think of this graphics format as the PICT files of the Windows world. It's nice that Mac OS X can open (and Preview can export) them, especially because you may occasionally find .bmp files on the Web or attached to email messages.

  • Silicon Graphics, MacPaint, Targ. Talk about obscure—you could go through your whole life without ever seeing a graphic in one of these formats. Silicon Graphics is, of course, the format created by Silicon Graphics computers. MacPaint is a black-and-white only, 8-by-10-inch maximum, ancient Macintosh graphics format that disappeared from the scene in about 1987. And Targ (Targa) is the file format once used by products from the Truevision Corporation.

The Faxing Situation

Hey, how do I send faxes out of Mac OS X?

You're onto something. Using the Mac as a fax machine is a terrific idea, for a lot of reasons. For one thing, it eliminates the silly and costly ritual of printing out something just so that you can feed it into a fax machine. For another, because your fax originates directly from the heart of Mac OS X instead of being scanned by a crummy 200-dpi fax-machine scanner, it blesses your recipient with a spectacular-looking document.

Apple does not, itself, make fax software. But it does provide the bizarrely named FaxSTF, a basic fax sending-and-receiving program included with certain Mac models.

If an inspection of your Applications folder reveals that you, yourself, don't have FaxSTF, you can always install Page-Sender, Cocoa eFax, or any of the other shareware faxing programs listed at www.versiontracker.com that come up when you do a search (on the Mac OS X tab) for faxing.


13.10 Screen-Capture Keystrokes

If you're reading a chapter about printing and graphics, you may someday be interested in creating screenshots—printable illustrations of the Mac screen.

Screenshots are a staple of articles, tutorials, and books about the Mac (including this one). Mac OS X has a secret built-in feature that lets you make them—and version 10.2 adds some very cool convenience features.

Here's how to capture:

  • The whole screen. Press Shift- [image] -3 to create a picture file on your desktop, in PDF (Acrobat) format, that depicts the entire screen image. A satisfying camera-shutter sound tells you that you were successful.

    The file is called Picture 1 (or Picture 1.pdf., if you've chosen to reveal file name extensions as described in Section 4.3.3). Each time you press Shift- [image] -3, you get another file, called Picture 2, Picture 3, and so on. You can open these files into Preview, AppleWorks, or another graphics program, in readiness for editing or printing.

  • One section of the screen. As reflected in Figure 13-11, you can capture only a rectangular region of the screen by pressing Shift- [image] -4. When you drag and release the mouse, you hear the camera-click sound, and the Picture 1 file appears on your desktop as usual.

  • One menu, window, icon (with its name), or dialog box. Here's a great trick, new in 10.2. Once you've got your menu or window open onscreen, or the icon visible (even if it's on the Dock), press Shift- [image] -4. But instead of dragging diagonally, press the Space bar.

    Now your cursor turns into a tiny camera (Figure 13-11, bottom). Move it so that the misty highlighting fills the window or menu you want to capture—and then click. The resulting Picture file snips the window or menu neatly from its background. (Press the Space bar a second time to exit "snip one screen element" mode and return to "drag across an area" mode.)

  • The Dock. That business of pressing Shift- [image] -4 and then the Space bar also lets you capture the Dock in one quick snip. Once you've got the camera cursor, just click any blank spot on the Dock (between icons).

    TIP

    If you hold down the Control key as you click or drag (using any of the techniques described above), you copy the screenshot to your clipboard, ready for pasting, rather than saving it as a new graphics file on your desktop.

As noted in Chapter 9, by the way, Mac OS X also offers another way to create screenshots: Grab, which offers a timer option that lets you set up the screen before it takes the shot. But if you're really serious about capturing screenshots, you should opt instead for Snapz Pro X (www.ambrosiasw.com), which can capture virtually anything on the screen—even movies of onscreen procedures, along with your narration—and save it in your choice of graphics format.

Figure 13-11. Top: If you're interested in capturing only part of the screen, press Shift- -4 to turn your cursor into a tiny + symbol. Now drag diagonally across the screen to capture only a rectangular chunk of it, as illustrated here. Bottom: To capture just one dialog box, use the old Camera Cursor trick.
    [ Team LiB ]


Chapter 14. Sound, Movies, Speech, and Handwriting

For years, as other computer companies whipped themselves into a frenzy trying to market one multimedia computer or another, Mac fans just smiled. Macs have been capable of displaying sound and graphics—no add-on sound, graphics, or video boards required—from day one, years before the word multimedia was even coined.

The Mac's superiority at handling sound and video continues in Mac OS X. QuickTime, for example, is software that lets you play digital movies on your screen and watch live "streaming" broadcasts from the Internet. This chapter covers both creative pursuits: creating and using sound, and playing and editing movies.

As a bonus, this chapter also covers Mac OS X's speech features: how to command your Mac by voice, as well as making your Mac talk back.


14.1 Playing Sounds

You can have a lot of fun with digital sounds—if you know where to find them, where to put them, and how to edit them. You can play almost any kind of digitized sound files, even MP3 files, right in the Finder—if you put its window into column view (Section 1.6). But that's just the beginning.

14.1.1 Controlling the Volume

Adjusting the volume of your Mac's speakers couldn't be easier: Just add the speaker menulet to your menu bar, as directed in Figure 14-1. That illustration also shows the Sound panel of System Preferences, which offers another way to go about it.

TIP

Actually, all current Macs offer an even more direct way to control the speaker volume: speaker-control keys right on the keyboard. (The key next to them is the Mute button, which instantaneously cuts off all the Mac's sound—a wonderful feature when you find yourself trying to use the Mac surreptitiously in a library or church.)

The Output tab of this panel, by the way, is designed to let you adjust the left-to-right balance of your stereo speakers, if you have them. The stereo speakers on most Macs that have them (iMac, PowerBook) are already perfectly centered, so there's little need to adjust this slider unless you generally list to one side in your chair. (You may find additional controls here if you have extra audio gear—an iSub subwoofer system, for example.)

Figure 14-1. The tiny speaker silhouette in the upper-right corner of your screen turns into a volume slider when you click it. To make this sound menulet appear, open the Sound pane of System Preferences and turn on "Show volume in menu bar" (bottom). (Of course, another way to adjust the overall speaker volume is to drag the "Main volume" slider in System Preferences.)

14.1.2 Alert Beeps and You

In the first decades of the Macintosh experience, everybody knew what an error beep was: the little quack, simple beep, or trumpet blast that said, "You can't click here."

In Mac OS X, a lot of the beeping is gone. Dialog boxes very rarely commandeer your screen as they do in Mac OS 9 or Windows. These days, if you try to click outside the Print dialog box, you just switch into whichever window or program you clicked.

Nonetheless, you still hear error beeps occasionally. (Try typing letters into a dialog box where a program expects numbers, for example.)

14.1.2.1 Choosing an alert beep

To choose one that suits your own personal taste, open the Sound panel of System Preferences (Figure 14-1, bottom). The Sound Effects screen offers a canned choice of fourteen witty and interesting sound snippets for use as error beeps. Press the up and down arrow keys to "walk" through them, listening to each. The one that's highlighted when you close the window becomes the new error beep.

You can also drag the "Alert volume" slider to adjust the error beep volume relative to your Mac's overall speaker setting.

14.1.2.2 Adding new alert beeps

Mac OS X's error beeps are actually AIFF sound files (see the box below). As with fonts, Mac OS X builds the list of error beeps that you see in the Sound panel of System Preferences from several folder sources:

  • System [image] Library [image] Sounds folder. This folder contains the basic Mac OS X set. Because it's in the System folder, it's off-limits to manipulation by us meddlesome human beings. You can't delete one of the original Mac OS X error beeps, nor add to this collection (unless you take the drastic step of logging in as the root account holder [Section 11.7] or restarting the computer in Mac OS 9).

  • Home folder [image] Library [image] Sounds folder. Fortunately, it's easy enough to add sounds for your own use—just add them to this folder.

  • Library [image] Sounds folder. If you, an administrator, want to make a sound file available to all account holders (if, in fact, there's more than one) on your Mac, create a new Sounds folder in the main hard drive window's Library folder. Any sound files you put there now appear in every account holder's list of alert sounds.

The sound files you put into these folders must be in AIFF format. Stranger yet, their names must end with the extension .aiff. If the file's name ends with a simple .aif, which is the usual extension on Windows computers, System Preferences won't recognize it. This is all the more confusing because when you export a sound file from Apple's own QuickTime Player Pro, it insists that .aif is the correct extension!

NOTE

Any changes you make to these Sounds folders don't show up in System Preferences until you've quit and reopened System Preferences.

AIFF Files

Until the dawn of Mac OS X, the standard sound-file format for the Macintosh was something called System 7 format. All error beeps were stored in this format.

What made these files especially wonderful was that you didn't need any particular program to play them. Just double-clicking a System 7 file made it play, right there on the desktop. Millions of Mac fans delighted in putting System 7 files into the System [image] Startup Items folder ("Kirk to Enterprise!") or in the Shutdown Items folder ("He's dead, Jim").

As part of its trend to abandon Macintosh-only file formats like PICT files (Chapter 13), however, Apple has now left behind System 7 sound files. The standard sound format in Mac OS X is the AIFF file, a popular Mac/Windows/Internet sound format. (The abbreviation stands for audio interchange file format.)

The bad news is that you can no longer double-click one of these files to play it. Instead, double-clicking one opens it up in QuickTime Player (described later in this chapter), where you must press the Space bar to begin or end playback. (You can also play it right in the Finder, of course, in the far right pane of a column-view window.)

The good news is that you can exchange these files with both Mac and Windows fans, download them from Web sites without worrying that your Mac won't be able to play them, and so on.


14.2 Recording Sound

If you hope to record new sounds, you'll need a microphone. Your microphone situation depends on the kind of Mac you have:

  • iMac, eMac, PowerBook, white iBook. You have a built-in microphone, usually a tiny hole just above or below the screen. This microphone couldn't be more convenient: it's always with you, and always turned on.

  • Original iBook, Cube, recent Power Macs. You can plug in an external USB microphone (the Apple Products Guide at www.guide.apple.com offers a list) or use an adapter (such as the iMic, www.griffintechnology.com) that accommodates a standard microphone.

  • Older Power Macs. These models came with a gray, half-cone-shaped microphone called the PlainTalk microphone. You'll find a corresponding miniplug jack for it on the back. Note, however, that the PlainTalk mike's pin is slightly longer than a standard miniplug. Standard microphones don't work in a Mac without an adapter like the NE Mic from www.griffintechnology.com.

In Mac OS X 10.2, for the first time, the Sound panel of System Preferences lets you choose which sound source you want the Mac to listen to. Click the Input tab, and then click the sound source you want: external USB microphone, external analog microphone (that is, something plugged into the microphone or Line In jacks of Macs that have them), built-in microphone, or whatever.

14.2.1 Making the Recording

Once you've got your microphone situation taken care of, you need to get your hands on some sound-recording software.

14.2.1.1 The iMovie method

There is, in fact, one piece of sound-recording software that comes with Mac OS X, although you might never suspect it: iMovie 2, which lurks in your Applications folder. iMovie's primary purpose, of course, is to let you edit your own camcorder footage. But as it turns out, iMovie's voice-over narration feature makes a convenient sound-recording studio.

In a new, arbitrarily named movie file, click the Audio button shown in Figure 14-2. Click Record Voice and begin to speak. Click Stop to complete the recording.

Figure 14-2. Top: To summon the Record Voice controls, click the Audio button. If your microphone is correctly hooked up, the Record Voice button is available. (Otherwise, it's dimmed.) Just above the button is a live "VU" level meter. Test your setup by speaking into the microphone. If this meter twitches in response, you're ready to record. Bottom: Your recording takes the form of an orange bar at the bottom of the screen. (Click the clock icon tab if you don't see it.)

Now a new stripe appears in the upper soundtrack, orange and highlighted, like the one shown in Figure 14-2. Drag the playhead to the left—to the beginning of the new recording—and then press the Space bar to listen to your voice-over work. If the narration wasn't everything you hoped for, it's easy enough to record another "take." Just click the stripe representing your recording and then press Delete to get rid of it. Then repeat the process.

When you're satisfied with the recording, save the file and quit iMovie. Inside the movie project folder, you'll find a folder called Media. Inside it, there's a file called, for example, Voice 02. That's the sound file you just made.

Add .aiff to its name, confirming your decision when the Mac asks you, and then drag the file into the appropriate Library [image] Sounds folder, as described on the previous page. (It's fine to create a Sounds folder if there isn't one there already.)

Presto: You've just created a new alert sound!

14.2.1.2 The shareware method

If you're willing to spend a few dollars, you can buy a shareware program that puts iMovie, as a sound studio, to shame. Some of the most useful, economical, and powerful include Sound Studio for OS X ($35) and Amadeus II ($25). You can download trial versions of both programs from www.missingmanuals.com, among other places.

These programs make terrific sound recorders. Better yet, they make great editors, too. If there's excess silence at one end of the clip, or a few too many "uh"s and "um"s in the middle, you can edit them out just by dragging through the appropriate section of the scrolling sound-wave map (Figure 14-3) and pressing Delete.

These programs can open almost any kind of sound files, including tracks from your music CDs, and convert them to any other kind of format, including AIFF.

Figure 14-3. In Sound Studio, you can see the entire sound file in one window. Drag across a section of sound waves to highlight it, in preparation for deleting, copying, or applying one of the many special effects. The program is shareware; it's fully functional for two weeks, whereupon you're supposed to send the programmer $35 for his efforts.
    [ Team LiB ]


14.3 QuickTime Movies

A QuickTime movie is a digital movie—a file on your hard drive, a CD-ROM, or the Internet—that flashes many individual frames (photos) per second before your eyes, while also playing a synchronized soundtrack.

14.3.1 Movies on the Desktop

As noted in Section 1.6, you don't need any special software to play QuickTime movies. Just view their windows in column view, and then proceed as shown in Figure 14-4.

14.3.2 QuickTime Player

Dozens of Mac OS X programs can open QuickTime movies, play them back, and sometimes even incorporate them into documents: Word, FileMaker, AppleWorks, PowerPoint, Internet Explorer, America Online, and so on.

But the cornerstone of Mac OS X's movie-playback software is QuickTime Player, which sits in your Applications [image] QuickTime folder (and even comes factory-installed on the Dock). It does exactly what it's designed to do: show pictures, play movies, and play sounds.

TIP

Like Preview, another basic Mac OS X utility program, QuickTime Player can also open many graphics files—such as JPEG, GIF, TIFF, PICT, and even native Photoshop documents. You can either drag these graphics files onto the QuickTime Player icon, or—from within QuickTime Player—choose File [image] Open Movie in New Player.

Figure 14-4. You can preview a selected QuickTime movie, in miniature, right in column view. Click the Play triangle to play; click it again to stop. The two buttons on the right end are frame-advance buttons. But if you Control-click one of these buttons, they turn into a "jog shuttle" slider that lets you fast-forward (or fast-reverse) through your movie, complete with sound. Who said Alvin and the Chipmunks were dead?
14.3.2.1 Playing movies with QuickTime Player

You can open a movie file by double-clicking it, dragging it onto the QuickTime Player icon, or launching QuickTime Player and then choosing File [image] Open Movie in New Player ( [image] -N). As shown in Figure 14-5, a number of controls help you govern the movie's playback:

  • Audio level meters. This tiny graph dances to indicate the relative strength of various frequencies in the soundtrack, like the VU meters on a stereo. If you don't see any dancing going on, then you've opened a movie that doesn't have a soundtrack.

  • Q button. Click this peculiar, spherical button to summon "QuickTime TV"—the icons of Web sites that provide video feeds, as described below.

  • Resize handle. Drag diagonally to make the window bigger or smaller.

    TIP

    When you drag the resize handle, QuickTime Player strives to maintain the same aspect ratio (relative dimensions) of the original movie, so that you don't accidentally squish it. If you want to squish it, however—perhaps for the special effect of seeing your loved ones as they would look with different sets of horizontal and vertical genes—press Shift as you drag.

    If you press Option while dragging, meanwhile, you'll discover that the movie frame grows or shrinks in sudden jumping factors of two—twice as big, four times as big, and so on. On slower Macs, keeping a movie at an even multiple of its original size in this way ensures smoother playback.

  • Scroll bar. Drag the diamond (or, in the Pro version, the black triangle) to jump to a different spot in the movie.

    TIP

    You can also press the right and left arrow keys to step through the movie one frame at a time. If you press Option-right or -left arrow, you jump to the beginning or end of the movie. In the Pro version, Option-arrow also jumps to the beginning or ending of a selected stretch of the movie.

  • Play/Stop button. Click once to start, and again to stop. You can also press the Space bar, Return key, or [image] -right arrow for this purpose. (Or avoid the buttons altogether and double-click the movie itself to start or stop playback.)

    TIP

    You can make any movie automatically play when opened, so that you avoid clicking the Play button. To do so, choose QuickTime Player [image] Preferences [image] Player Preferences, and turn on "Automatically play movies when opened."

  • Selection handles. These tiny black triangles appear only in the $30 Pro version. You use them to select, or highlight, stretches of footage.

  • Volume. If you like, you can make the soundtrack louder or softer by dragging this slider with your mouse or clicking in its "track." You may find it easier, however, to press the up or down arrow keys.

    TIP

    To mute the sound, click the little speaker icon, or press Option-down arrow. Press Option-up arrow to make the volume slider jump to full-blast position.

  • Counter. In "hours: minutes: seconds" format, this display shows how far your diamond cursor has moved into the movie.

    If you have QuickTime Pro, the counter reveals the position of the selection handle you've most recently clicked (if any).

  • Rewind, Fast Forward. By clicking one of these buttons and keeping the mouse button pressed, you get to speed through your movie, backward and forward, respectively, complete with sound. This is a terrific way to navigate your movie quickly, regardless of whether you're using QuickTime Player or QuickTime Player Pro.

  • Jump to Start, Jump to End. These buttons do exactly what they say: scroll to the beginning or end of your movie. In the Pro version, they can also jump to the beginning and ending of the selected portion of the movie (if any). All of this, in other words, is exactly the same as pressing the Option-left arrow or -right arrow keys.

    TIP

    Try minimizing a QuickTime Player window while a movie is playing. It shrinks to the Dock—and keeps on playing. Do this enough times, and you'll know what it's like to be Steve Jobs on stage.

Figure 14-5. Some of the controls you see here are available only in the Pro version of QuickTime Player—they appear as soon as you type in your registration code (which you get when you pay $30).

QuickTime Player vs. QuickTime Player Pro

Every time I launch QuickTime Player, I get this stupid ad about upgrading to QuickTime Pro. How can I get rid of it?

Easy one. Click Later, and then Quit QuickTime Player. Open System Preferences; click Date & Time. Reset your Mac to a date far beyond its obsolescence point—the year 2020, for example. (If necessary, turn off "Use a network time server" on the Network Time tab first.) Close the window.

The next time QuickTime Player shows its ad (which it does only once a day), click the Later button for the very last time. Quit the program, reset your clock to the correct date, and enjoy the fact that you've played a little trick on the program's calendar-watching feature. You'll never see the ad again—at least not until 2020.

All of these shenanigans are only necessary, of course, if you've decided not to upgrade to QuickTime Player Pro, whose additional editing playback and exporting features are documented in this chapter.

For $30, Apple will sell you a password that turns your copy of QuickTime Player into something called QuickTime Player Pro. (To obtain this password, call 888-295-0648, or click the Upgrade Now button to go online to www.apple.com/quicktime/buy.)

To record your password, choose QuickTime Player [image] Preferences [image] Registration. Your password gets stored in your Home folder [image] Library [image] Preferences folder, in a file called QuickTime Preferences. (Remember that when you upgrade to a new Mac.)

Once you've upgraded, you gain several immediate benefits—not the least of which is the permanent disappearance of the "upgrade now" advertisement. Now QuickTime Player is QuickTime Player Pro, and is capable of editing your movies, as described later in this chapter. It can also import many more sound and graphics formats, and—via the File [image] Export command—convert sounds, movies, and graphics into other formats.

14.3.2.2 Hidden controls

Don't miss the Movie [image] Show Video Controls and Movie [image] Show Sound Controls commands. As shown in Figure 14-6, they let you fine-tune the video and audio you're experiencing.

TIP

Clicking the tiny, grayed-out grid to the right of the scroll bar is a quicker alternative to choosing Movie [image] Show Audio Controls.

Figure 14-6. Click the word Brightness to summon the Contrast or Tint slider; drag your mouse across the vertical bars to adjust the picture accordingly. The Sound controls replace the scroll bar. When you're finished adjusting the balance, bass, and treble, click the light gray grid at the right edge to bring the scroll bar back.
14.3.2.3 Fancy playback tricks

Nobody knows for sure what Apple was thinking when it created some of these additional features—exactly how often do you want your movie to play backward?—but here they are. Some of these features are available only in the unlocked Pro version of the QuickTime Player, as indicated below.

  • Change the screen size. Using the Movie menu commands, such as Double Size and Fill Screen, you can enlarge or reduce the actual "movie screen" window. Making the window larger also makes the movie coarser, because QuickTime Player simply doubles the size of every dot that was present in the original. Still, when you want to show a movie to a group of people more than a few feet back from the screen, these larger sizes are perfectly effective.

  • Play more than one movie. You can open several movies at once and then run them simultaneously. (Of course, the more movies you try to play at once, the jerkier the playback gets.)

    As a sanity preserver, QuickTime Player plays only one soundtrack—that of the movie you most currently clicked. If you really want to hear the cacophony of all the soundtracks being played simultaneously, choose QuickTime Player [image] Preferences [image] Player Preferences, and turn off "Play sound in frontmost player only." (The related checkbox here, "Play sound when application is in background," controls what happens when you switch out of QuickTime Player and into another program.)

    TIP

    If you have Player Pro, you can use the Movie [image] Play All Movies command to begin playback of all open movies at the same instant.

  • Play the movie backward. You can play the movie backward—but not always smoothly—by pressing [image] -left arrow, or by Shift-double-clicking the movie itself. (You must keep the Shift button pressed to make the backward playback continue.) There's no better way to listen for secret subliminal messages.

  • Loop the movie. When you choose Movie [image] Loop and then click Play, the movie plays endlessly from beginning to end, repeating until you make it stop.

  • Play a selection (Pro only). When you choose Movie [image] Loop Back and Forth and then click Play, the movie plays to the end—and then plays backward, from end to beginning. It also repeats this cycle until you make it stop.

  • Play every frame (Pro only). If you try to play a very large movie that incorporates a high frame rate (many frames per second) on a slow Mac, QuickTime Player skips individual frames of the movie. In other words, it sacrifices smooth motion in order to maintain synchronization with the soundtrack.

    But if you choose Movie [image] Play All Frames and then play the movie, QuickTime Player says, "OK, forget the soundtrack—I'll show you every single frame of the movie, even if it isn't at full speed." You get no sound at all, but you do get to see each frame of the movie.

14.3.3 QuickTime TV (Internet Streaming)

QuickTime TV generated a few raised eyebrows when Steve Jobs announced it in 1998, but few Mac fans have even noticed it since. That's too bad: It's a clever and well-implemented feature that lets you watch "Internet slide shows," watch a couple of live TV stations, or listen to the radio—all as you work on your Mac, and all at no charge.

14.3.3.1 Streaming video from your browser

With ever-increasing frequency, modern Web sites advertise streaming video events, such as Steve Jobs keynote speeches and the occasional live rock concert. You'll find a note on a Web page, for example, that says, "Watch the live debate by clicking here on October 15 at 9:00 p.m. EST."

If you do so, you'll find yourself transported once again into QuickTime Player, which connects to the appropriate Internet "station" and plays the video in its window. (You can also choose File [image] Open URL in New Player from within QuickTime Player to type in the Web address.)

NOTE

You don't have much control when watching a live broadcast. You generally can't rewind, and you certainly can't fast-forward. You may be able to pause the broadcast, but when you un-pause, you wind up at the current broadcast moment—not where you stopped.

14.3.3.2 Streaming video in QuickTime Player

Fortunately, if you're eager to experience the early-technology thrill of watching live Internet video, you don't have to wait until you stumble onto a broadcast advertised on a Web page. Thanks to Apple's QuickTime TV initiative, a number of TV and radio broadcasts are going on at this very moment—24 hours a day. A list of them is built right into QuickTime Player.

To access these "channels," click the little Q button. Icons for the installed channels replace the video image, as shown in Figure 14-7.

Figure 14-7. Apple has toned down its QuickTime TV feature quite a bit recently. Now it's little more than a window of category links, each of which takes you online to look or listen. Moreover, a movie-trailer feature is now built into Sherlock 3 (Section 20.1.4), making the QuickTime approach even less relevant.

To find the goodies, click one of these channel buttons. One "pick of the day" is highlighted to their right (see Figure 14-7). At this point, you can:

  • Click the featured ad. Your browser opens, and you go online to that movie's Web page.

  • Click the "More" triangle underneath it. You go to an Apple Web page that lists many more music stations, educational clips, movie or game trailers, and so on.

    TIP

    You can find a list of additional QuickTime TV channels at www.apple.com/quicktime/qtv.

14.3.3.3 Manipulating your Favorites

When you choose Favorites [image] Show Favorites, you see a list of items you've put there for quick access.

Although few people have use for this feature, it's possible to add the icons of your own QuickTime movies to the Favorites panel—not QuickTime TV channels, but actual movies on your hard drive. To do so, you can use any of these methods:

  • Drag the icon of a QuickTime movie, picture file, or sound clipping directly off of your desktop and into QuickTime Player's Favorites window.

  • Open a movie, picture, or sound, and then choose Favorites [image] Add Movie As Favorite.

You can also reorganize the locations of the Favorites icons just by dragging them up or down in the list. To delete one of your "favorites," just click its name and then press Delete (and click Delete in the confirmation box).

14.3.4 QuickTime Player Pro

If you've spent the $30 to upgrade your free copy of QuickTime Player to the Pro version, you've unlocked a number of useful features. For example:

  • Your Movie menu contains additional playback options, such as those described in "Fancy playback tricks," above.

  • When you find a QuickTime movie on a Web page, you can usually save it to your hard drive. (Click on the movie; hold down the mouse button until a pop-up menu appears; choose Save Movie to Disk, or the equivalent in your browser.)

  • Using the commands in the Edit menu, you can view, turn on and off, add, or delete the individual tracks in a particular movie. (Most movies have nothing but a video track and a soundtrack. But a few specialized movies may also contain a text track, an animation track, alternate soundtracks, and so on.)

  • The Movie [image] Full Screen ( [image] -F) command is extremely useful. It's the best possible way to view a QuickTime movie on your screen, in fact. When you use this command, a Full Screen dialog box appears. Use its Movie Size pop-up menu to choose a playback size for the movie. (You may be tempted to choose Full Screen. That's terrific when you want to play a movie for a large group of people, but remember that an enlarged QuickTime movie is also a jerkier and grainier one.) Now QuickTime Player blacks out the screen and devotes all the Mac's processing power to playing the movie smoothly. (To interrupt the movie, press Esc or [image] -period.)

By far the most powerful feature you gain in the Pro version, however, is its ability to edit QuickTime movies. You can rearrange scenes, eliminate others, and save the result as a new movie with its own name. (Even QuickTime Player Pro doesn't let you create live-action QuickTime movies with your camcorder. For that, you need iMovie or a more complex editing program like Final Cut. QuickTime Player Pro simply lets you edit existing movies.)

14.3.4.1 Selecting footage

Before you can cut, copy, or paste footage, QuickTime Player needs to provide a way for you to specify which footage you want to manipulate. Its solution: the two tiny black triangles that start out at the left end of the horizontal scroll bar, as shown in Figure 14-5. These are the "in" and "out" points; by dragging these triangles, you can isolate the scene you want to cut or copy.

TIP

You can gain more precise control over the selection procedure by clicking one of the black triangles and then pressing the right- or left-arrow key. Doing so expands or contracts the selected chunk of footage by one frame at a time.

You may also prefer to select a piece of footage by Shift-clicking the Play button. As long as you hold down the Shift key, you continue to select footage. When you release the Shift key, you stop the playback, and the selected passage appears in gray on the scroll bar.

Once you've highlighted a passage of footage, you can proceed as follows:

  • Jump to the beginning or end of the selected footage by pressing Option-right arrow or -left arrow key.

  • Deselect the footage by dragging the two triangles together again.

  • Play only the selected passage by choosing Movie [image] Play Selection Only ( [image] -T). (The other Movie menu commands, including Loop, apply only to the selection at this point.)

  • Drag the movie picture out of the Player window and onto the desktop, where the selected portion becomes a movie clipping that you can double-click to view.

  • Cut, copy, or clear the highlighted material using the commands in the Edit menu.

    TIP

    If you paste some text directly into QuickTime Player Pro, you get a two-frame title—like an opening credit—at the location of the scroll-bar playhead. (If you need it to be longer, paste it repeatedly.) QuickTime Player automatically uses the font, size, and style of the text that was in the text clipping. You can paste a graphic image, too, which gets you a two-frame "slide" of that still image.

    If you find it easier, you can also drag a text or picture clipping file directly from the desktop into the QuickTime Player window; once again, you get a two-frame insert.

14.3.4.2 Pasting footage

After cutting or copying footage, you can move it elsewhere in the movie. Specify where you want the pasted material to go by first clicking or dragging in the horizontal scroll bar, so that the black diamond marks the spot; then choose Edit [image] Paste. The selection triangles (and their accompanying gray scroll-bar section) appear to show you where the new footage has appeared. (That makes it easy for you to promptly choose Edit [image] Cut, for example, if you change your mind.)

But in QuickTime Player Pro, Cut and Paste are just the beginning of your options. For example:

  • If you choose Edit [image] Replace, any footage that's on your Clipboard now replaces the selected stretch of movie.

  • Edit [image] Trim eliminates the outer parts of the movie—the pieces that aren't selected. All that remains is the part you first highlighted.

  • Edit [image] Add adds whatever's on the Clipboard so that it plays simultaneously with the selected footage—a feature that's especially useful when you're adding a different kind of material to the movie (see Figure 14-8).

  • If you choose Edit [image] Add Scaled, whatever you're pasting gets stretched or compressed in time so that it fits the highlighted region, speeding up or slowing down both the audio and video. The effect can be powerful, comical, or just weird.

    TIP

    You can edit sounds exactly as you edit movies, using the same commands and shortcuts. Use the File [image] Open Movie in New Player command in QuickTime Player Pro to locate a sound file to open. It opens exactly like a QuickTime movie, except with only a scroll bar, no picture.

Figure 14-8. QuickTime Player Pro has a little-known subtitling feature, complete with freedom of type style. Copy some formatted text from a word processor; highlight a slice of footage in QuickTime Player; and choose Edit Add. The copied text appears as a subtitle on a black band, beneath the picture, as shown here.
14.3.4.3 Saving the finished movie

After you've finished working on your sound or movie, you can send it back out into the world in any of several ways. If you choose Edit [image] Save As, for example, you can specify a new name for your edited masterpiece. You must also choose one of these two options:

  • Save normally. The term "normally" in this case is a red herring. In fact, you'll almost never want to use this option, which produces a very tiny QuickTime file that contains no footage at all. Instead, it's something like an alias of the movie that works only as long as the original, unedited movie remains on your hard drive. If you try to email the newly saved file, your unhappy recipient won't see anything at all.

  • Make movie self-contained. This option produces a new QuickTime movie—the one you've just finished editing. Although it consumes more disk space, it has none of the drawbacks of the "save normally" file described above.

QuickTime Virtual Reality

If they live to be 100, most Mac users will probably never encounter a QuickTime VR movie. Yet this kind of "panorama movie" technology is built into every Mac.

The trick is finding a QuickTime VR movie; your safest bet is, as usual, the Web. (The best starting point is Apple's own QuickTime VR page, www.apple.com/quicktime/qtvr.)

When you open a QuickTime VR movie, you might think at first that you've simply opened a still photo (there's no scroll bar, for example). The trick is to drag your cursor around inside the photo. Doing so rotates the "camera," enabling you to look around you in all directions.

Then try pressing the Shift key, to zoom in (move forward) as much as you like. If you go too far, the image becomes too grainy. Press the Control key to zoom out (move backward).

And if you really want to blow your mind, try one of the cubic VR movies posted on that Web page. It lets you rotate your view not just side to side, but also up to the sky and down to your feet.

Using the free and commercial tools listed on the Apple Web site, you can even make your own QuickTime VR movies—provided you've got a camera, a tripod, and a good deal of patience.

14.3.4.4 Exporting the finished work

Instead of using the File [image] Save As command, you can also use the File [image] Export command. The resulting dialog box offers two pop-up menus that can be very useful in tailoring your finished work for specific purposes:

  • Export. Using this pop-up menu, you can convert your movie to AVI (Windows movie) format, DV Stream (for use as a clip in digital-video editing programs like iMovie and Final Cut), Image Sequence (which produces a very large collection of individual still frames), and so on. This pop-up menu also lets you convert a sound you've been working on to AIFF, System 7, Wave (Windows), and other formats.

    TIP

    Among these options, you'll find "Movie to MPEG-4." MPEG4, of course, is the big news in QuickTime 6, which comes with Mac OS X 10.2 and later. The movies it produces achieve very high quality and compact size—but they play back only on machines that have QuickTime 6 installed.

  • Use. This pop-up menu lets you establish your preferences for the export format you've just specified above. For example, if you're exporting your movie as individual still frames, use this pop-up menu to specify the format for those individual still frames—BMP (Windows format), JPEG, and so on. If you're exporting your work as a QuickTime movie, you can specify how much QuickTime Player should compress it. (Compression makes a file much smaller, but decreases the video quality.) For example, if you intend to let people watch this movie over the Internet, you should use one of the Streaming options, which makes the movie extremely small and extremely cruddy-looking. If you plan to burn your movie onto a CD-ROM, use one of the "CD-ROM" options at the bottom of the pop-up menu.

14.3.4.5 Compression and special effects

One of QuickTime Player's most powerful features is hidden in the Export dialog box, in a place where you might never find it. If none of the canned compression settings appeals to you, you can click the Options button. In the Settings dialog box that appears (see Figure 14-9), QuickTime Player Pro offers a staggering degree of control over the movie you're exporting. (The resulting dialog box varies according to the compression method you've selected.)

When exporting a movie as a QuickTime Movie, for example, here's where you can specify the compression format, the frames per second, and (by clicking Size) the dimensions of the finished movie. As a bonus, you even get a Filter button that offers fourteen special video effects. They let you blur or sharpen your movie, adjust the brightness or contrast, fiddle with the color balance, and so on.

Similarly, when you're exporting a sound file, the Options button lets you specify the sound quality you want, the compression method, and so on—all various ways of manipulating the trade-off between file size and sound quality.

Figure 14-9. If you're used to standard moviemaking software, such as Adobe Premiere or Final Cut, you may wonder where QuickTime Player hides its compression settings. They're here, in the Options dialog box (left) and the Settings boxes that spring from within it (right). Hint: For smooth playback, use 15 frames per second or above; for best quality but small file size, use the Sorenson 3 Video Compressor (or MPEG4, if you're sure your audience has QuickTime 6 or later). For the smallest possible file size—at more picture-quality sacrifice—use the H.263 compressor.
    [ Team LiB ]


14.4 Speech Recognition

Although it may surprise many Mac users, the Mac is quite talented when it comes to speech. Its abilities fall into two categories: reading text aloud, using a synthesized voice; and taking commands from your voice.

The Apple marketing machine may have been working too hard when it called this feature "speech recognition"—the Mac OS feature called PlainTalk doesn't take dictation, typing out what you say. (For that, you need a program like IBM ViaVoice for Mac OS X, www.ibm.com.)

Instead, PlainTalk is what's known as a command-and-control program. It lets you open programs, trigger AppleScripts, choose menu commands, trigger keystrokes, and click dialog box buttons and tabs—just by speaking their names.

Few people use PlainTalk speech recognition. But if your Mac has a microphone, PlainTalk is worth at least a 15-minute test drive. It may become a part of your work routine forever.

14.4.1 Your First Conversation with the Mac

The on/off switch for speech recognition in Mac OS X is the Speech panel of System Preferences (Figure 14-11). Where you see "Apple Speakable Items is," click On. (The first time you do this, a small instructions window appears. Read it if you like, and then click Continue. If you ever want to see these tips again, click the Helpful Tips button on this pane.)

14.4.1.1 The Feedback window

Check out the right side of your screen: A small, horizontal, microphone-ish floating window now appears (Figure 14-10). The word Esc in its center indicates the "listen" key—the key you're supposed to hold down when you want the Mac to respond to your voice. (You wouldn't want the Mac listening all the time—even when you said, for example, "Hey, it's cold in here. Close the window." Therefore, the Mac comes ready to listen only when you're pressing that key.)

You can specify a different key, if you wish, or eliminate the requirement to press a key altogether, as described in the next section.

When you start talking, you'll also see the Mac's interpretation of what you said written out in a yellow balloon just over the Feedback window.

TIP

The Feedback window lacks the standard Close and Minimize buttons. If it's in your way, just double-click it (or say "minimize speech window") to shrink it onto your Dock.

Figure 14-10. Left: The Feedback window. If you choose Speech Preferences from its bottom-edge triangle, you open the Speech preferences window. Right: Choosing Open Speech Commands window, of course, opens the list of things you can say.
14.4.1.2 The Speakable Commands window

Here's the most important single fact to understand about PlainTalk speech recognition: The only commands it understands are those listed in the Speakable Commands window, which generally appears automatically when you turn on speech recognition.

Keeping your eye on the Speakable Commands window is absolutely essential, because it offers a complete list of everything your Mac understands. As you can see, some of them represent shortcuts that would take several steps if you had to perform them manually.

To open this list if it's not open, click the tiny arrow at the bottom of the Feedback window and choose Open Speech Commands Window from the commands that appear. Here are a few examples of what you'll find in the list at first:

  • Open Sherlock. Launches the Sherlock file-finding program, as described in Chapter 20, saving you the trouble of using a menu or keystroke to open it.

  • Close this window. Closes the frontmost window instantly.

  • Empty the trash. Works only when you're in the Finder.

  • Switch to AppleWorks. Brings AppleWorks to the front. (Of course, you can say "switch to" and then the name of any running or recently used program.)

  • Quit all applications. Saves you the trouble of switching into each program and choosing Quit.

  • Open the Speech Commands window or Show me what to say. Opens the Speech Commands window, of course.

  • What day is it? Tells you the date.

  • Tell me a joke. Begins a pathetic/funny knock-knock joke. You've got to play along, providing the "who's there?" and "so-and-so who?" answers.

Mac OS X updates the listing in the Speech Commands window in real time, according to the context. When you switch from one program to another, you see a list of the local commands that work in the new program. You'll discover that when you use the "Tell me a joke" command, for example, you don't necessarily have to say, "Who's there?" You can also say "Stop," "Go away," or "Stop with the jokes!" (It must really be fun to work at Apple.)

The commands listed in this window aren't the only ones you can speak, of course. You'll find out how to create new commands of your own later in this section.

14.4.1.3 Speaking to the Mac

When you're ready to talk to your computer, position the microphone between one and three feet from your mouth. If it's a headset, make sure it's plugged in. If it's built-in, speech recognition may not be as accurate.

In any case, finish up by opening the Speech panel of System Preferences. Click the Listening tab, and use the Microphone pop-up menu to specify which microphone you'll be using (if you have a choice).

Now you're ready to begin. While pressing the Esc key (if that's still the one identified in the Feedback window), begin speaking. Speak normally; don't exaggerate or shout. Try one of the commands in the Speakable Commands list—perhaps "What time is it?" If the Feedback window doesn't display animated sound waves, indicating that the Mac is hearing you, something's wrong with your microphone setup. Open the Speech panel again, and confirm that the correct microphone is selected.

You'll probably find that speech recognition has come a long way in Mac OS X. Even on slower machines, recognition is snappy, and commands are executed faster.

14.4.2 Customizing Speech Recognition

You can tailor the speech recognition feature in two ways: by adjusting the way it looks and operates, and by adding new commands to its vocabulary.

14.4.2.1 Changing when the Mac listens

Early experimentation quickly showed Apple's speech engineers that having the microphone "open," listening full-time, was an invitation for disaster. Everyday phone conversations, office chatter, and throat clearings completely bewildered the software, triggering random commands.

Therefore, you must explicitly tell the Mac when you're addressing it. When you first turn on the speech recognition feature, the Mac expects you to alert it by pressing a key when you speak, such as the Esc key.

TIP

To change the key you hold down when you want the Mac to listen, visit the Speech panel of System Preferences; click the Listening tab, and then click Change Key. A little message prompts you to press the keyboard key you'd prefer to use. Your choices are Esc, tilde (~), Delete, F5 through F15 (not including the Eject key), or the keys on your numeric keypad—with or without the Shift, Control, or Option keys.

If you'd rather not have to press some key whenever you want the computer's attention, click the other option in this box, "Key toggles listening on and off." Now to get the computer's attention you must speak its name—which you type into the Name box—before each command. For example, you might say, "Computer, open AppleWorks," or "Hal, what day is it?"

The name you specify appears in the middle of the round Feedback window.

NOTE

This method of getting the computer's attention is less reliable than the push-a-key-to-talk system. Especially if you name the computer Hal; although that's hilarious in theory, polysyllablic names work better in practice.

By using the "Name is" pop-up menu, meanwhile, you can specify how big your window of opportunity is:

  • Optional before each command. If you work alone in a quiet room, this is the choice for you. It means that you don't have to press a key or say the Mac's name when issuing a voice command. Everything you say is considered a command.

  • Required before each command. When this option is selected, nothing you say is interpreted as a command unless you say the computer's name first, as in, "Macintosh, switch to Microsoft Word."

  • Required 15 seconds after last command, Required 30 seconds after last command. Sometimes you want to issue several commands in a row, and would feel foolish saying, "Computer, close all windows. Computer, empty the trash. Computer, switch to AppleWorks." When you turn on this option, you can say the computer's name just once; all commands that you issue in the next 15 or 30 seconds "belong to" that first salutation. The push-to-talk key and the spoken name, in this case, serve as a master on/off switch for the Mac's listening mode.

    TIP

    If you're not using the push-to-talk method, you can still turn speech recognition off temporarily by saying, "Turn on push to talk." (Now the Mac listens to you only when you're pressing the designated key.) When you want to return to listening-all-the-time mode, say, "Listen continuously."

Finally, note that the Speech pane also lets you turn off recognition completely. On the On/Off tab, click Off (see Figure 14-11). On the other hand, if you really love the speech feature, you can save yourself the trouble of visiting this control panel each morning by turning on "Start Speakable Items at log in." Speech recognition will be turned on and "listening" as soon as you log in.

Figure 14-11. Top: Turn off listening altogether using the On/Off tab. Bottom: If you turn on "Key toggles listening on and off," then you don't have to press a key to make the Mac listen. (Instead, pressing the designated key turns the speech recognition feature on or off completely.) In the Name blank, type the name you want the Mac to listen for as it monitors the sound from your mike.
14.4.2.2 Changing the feedback

Another set of options in the Speech panel governs what the Mac does when it understands something that you've said. For example:

  • Play sound when recognized. The Mac generally makes a sound whenever it recognizes something you've said. Use this pop-up menu to control which of your built-in beeps you want it to use—or choose None.

  • Speak confirmation. Sometimes the Speech Feedback window shows you a message of its own—when you use the "Empty the trash" command, for example, text in the Feedback window may inform you that a locked item prevents the emptying. The Mac generally reads this text aloud to you; turn this checkbox off if you'd rather have the Mac be silent.

    NOTE

    Looking for the cute little cartoon characters in the Feedback window that, in Mac OS 9, reacted to the things you said? Forget about it—Apple got much more serious in Mac OS X.

14.4.2.3 Triggering menus by voice

In Mac OS X 10.2, Apple gave the usefulness of speech recognition a dramatic boost. On the Speech panel of System Preferences, click the Speech Recognition tab, and then click the Commands mini-tab on that window. Here you'll find a list of the command categories that Speakable Items can understand. As you turn each checkbox on or off, watch the Speech Commands window. Giant swaths of commands appear or disappear as you fool with these checkboxes, giving you a good indication as to their function. Here's a rundown:

  • General Speakable Items commands. This is the master list of Speakable Items shown in Figure 14-12.

  • Specific application commands. Certain Mac OS X programs come with preset lists of commands that work only when you're in the relevant program. For example, whenever you're in the Finder, you can say, "Empty the trash," "Go to my home directory," "Hide the dock," "Minimize all windows," "Make a new folder," and so on. When this checkbox is off, the Mac no longer recognizes any of these handy commands. (See Section 14.4.2 for more on application-specific commands—and how to create your own.)

  • Application switching commands. This is the command category at the bottom half of the Speech Commands list—"Switch to Address Book," "Switch to AOL," and so on.

  • Front Window commands. When you turn on this option, new in Mac OS X 10.2, a small window may appear, letting you know that you must turn on the master "assistive features" switch on the Universal Access panel of System Preferences. Click the Universal Access button, which takes you to the Universal Access panel described in Section 8.26. Turn on the checkbox called "Enable access for assistive devices." You've just thrown the master switch for Front Window and Menu Bar commands. (Apple's implication is that these command sets are useful only for the disabled, but that's not true at all.)

    Right away, in your Speech Commands window, you'll note the appearance of a new category of commands, called Front Window. The idea here is to provide you with quick speech-recognition access to the most prominent buttons, tabs, and icons in whichever window is before you. Figure 14-12 elaborates on the idea.

  • Menu Bar commands. This command lets you open menus (in the menu bar) by speaking their names. You need to turn on the "assistive devices" checkbox (see above) for this to work.

    Once you say its name ("File menu," for example), the menu opens. Now you can say any command in the open menu ("New Playlist," "Save," or whatever). The Menu Bar category of the Speech Commands window changes to remind you of what you can say at any given moment.

You can probably see that the combination of Front Window and Menu Bar commands lets you do quite a bit of work on your Mac without ever needing the mouse or keyboard.

Figure 14-12. The Front Window commands change automatically to reflect the controls that are in the frontmost window. For example, in the Date & Time panel of System Preferences, you can say anything in the circled area of the Speech Commands window: the name of any tab, toolbar icon, or window control (indicated by the arrows). Whenever you say an item, the Mac "clicks" it for you. You can also speak the menus' names to open them.
14.4.2.4 Improving the PlainTalk vocabulary

By putting an alias of a favorite document, folder, disk, or program into the Home [image] Library [image] Speakable Items folder, you can teach PlainTalk to recognize its name and open it for you on command. You can name these icons anything you want. You can also rename the starter set that Apple provides. You'll have the best luck with multi-word or polysyllabic names—"Microsoft Word," not just "Word."

But one kind of icon PlainTalk can open is an AppleScript icon, the kind you create by following the instructions in Chapter 7. If you open your Home folder [image] Library [image] Speech [image] Speakable Items, you'll discover that most of the built-in speakable-item icons are, in fact, AppleScript icons. The point is that you can make PlainTalk do almost anything you want, especially in the Finder, simply by creating AppleScripts and putting them into the Speakable Items folder.

TIP

You can trigger any menu command in any program by voice—as long as it has a keyboard equivalent listed in the menu. To set this up, just say, "Define a keyboard command." When the "Press the keys" dialog box appears, press the keyboard combination you want ( [image] -S, for example). Click OK; in the next dialog box, type the phrase you want to trigger that command (and use the "Use command in" controls to specify whether it should be a global command or one that works only in the current program). Click Save. Your new "spoken keystroke" is ready to use.

14.4.2.5 Application-specific commands

Most of the preinstalled PlainTalk commands work in any program. You can say, for example, "Open Sherlock" to launch Sherlock from within any program.

However, you can also create commands that work only in a specific program. They sit in your Speakable Items [image] Application Speakable Items folder, inside individual application-name folders. For example, Mac OS X comes with commands for Internet Explorer that include Go Back, Go Forward, and Page Down.

If you get good at AppleScript, you can create your own application-command folders in the Speakable Items [image] Application Speakable Items folder. Follow these steps:

  1. Launch the program for which you want to create special commands.

    Make sure PlainTalk is on and listening.

  2. Say, "Make this application speakable."

    The Mac creates a folder for the program in the Speakable Items folder.

  3. Drag the AppleScripts you've created into the newly created Speakable Items [image] [application name] folder.

Of course, not every program is equally suitable to being voice-controlled—since PlainTalk is based on AppleScript, only programs that are AppleScriptable (Chapter 7) thrive with this treatment.

TIP

If you give an application-specific icon the exact same name as one of the global commands, the Mac executes the application-specific one—if that program is running.

14.4.2.6 PlainTalk tips, tricks, and troubleshooting

When you're creating new commands, keep this advice in mind:

  • Favor longer icon names. "Save the file" works better than "Save."

  • If the name of an icon includes an acronym (such as FTP), put spaces between the letters (F T P), if you'll be pronouncing them as individual letters.

  • You can precede the name of something in your Speakable Items folder with the word "Open." PlainTalk doesn't care—"open Excel" and "Excel" do the same thing.

If you can't seem to make the speech recognition feature work, consider this checklist:

  • If the stripes on the bottom half of the Feedback window don't change color when you're speaking, something's wrong with your microphone arrangement. Revisit the Speech panel of System Preferences, and make sure you've selected the correct microphone. Also make sure you've plugged the microphone into the correct jack on the back or side of the computer.

  • Make sure you're pressing the correct key (if you're using the push-to-talk method), or speaking the name of the computer before each command (if not).

  • Make sure you're saying the name of the working command, as listed in either the Speakable Commands window (which appears when you say "Show me what to say") or the Speech Commands list.


14.5 The Mac Talks Back

So far in this chapter, you've read about the Mac's listening ability. But the conversation doesn't have to be one-way; it's even easier to make the Mac talk.

In fact, thanks to the beefed-up talking features of 10.2, the Mac can read almost anything you like: text that you pass your cursor over, alert messages, menus, and any text document in any program. It can speak in your choice of 22 synthesizer voices, ages eight to fifty. The Mac's voice comes out of its speakers, reading with a twangy, charmingly Norwegian accent.

14.5.1 Setting Up the Mac's Voice

To configure the way the Mac talks, revisit the Speech panel of System Preferences. Click the Default Voice tab at the top of the window. As you can see in Figure 14-13, you can control which of the Mac's voices you want your computer to use, as well as how fast it should speak.

As with the other aspects of Mac OS speech, this one is filled with whimsical touches. Four of the voices, as it turns out, sing rather than speak.They are: Good News, which sings to the tune of "Pomp and Circumstance," otherwise known as the Graduation March; Bad News, which sings to the tune of the Chopin Prelude in C minor, better known as the Funeral March; Cellos, which sings to the tune of Grieg's "Peer Gynt" suite; and Pipe Organ, which sings to the tune of the Alfred Hitchcock TV theme.

In other words, these voices sing whatever words you type to those melodies. (To hear the melody in its entirety, don't use any punctuation.)

Figure 14-13. For 15 minutes of hilarious fun, try clicking the Mac's voices in turn (or press the up and down arrow keys) to hear a sample sentence spoken in that voice. Drag the slider to affect how fast he or she speaks. (Clearly, Apple's programmers had some fun with this assignment.)

14.5.2 Programs That Already Talk

Some Mac OS X programs come with built-in speaking features. For example:

14.5.2.1 Mail

It's easy to make Mac OS X's email program (Chapter 19) read your messages aloud. Just Control-click inside a message window. From the pop-up menu, choose Speech [image] Start Speaking. (Choose Speech [image] Stop Speaking when you've heard enough.)

14.5.2.2 AppleWorks 6

To add the Speak Text button to your button bar, choose Edit [image] Preferences [image] Button Bar. In the Customize Button Bars dialog box, scroll down to the Word Processing triangle; click it. Scroll down even more, until you see the Speak Text button. Drag it out of the dialog box and onto the button bar. Click Done.

The icon you clicked now appears on the button bar whenever a word processing document is open. Click it to hear your Mac speak any highlighted piece of text, once again using the voice you've selected in the Speech preference panel.

14.5.2.3 FileMaker Pro

You can use the Speak script command to build speech features into a FileMaker database. For more about this script command, see FileMaker's built-in help; it's worth noting, however, that you can have it speak either a canned phrase or the contents of a database field. You can also specify which voice you want to use.

Talking to Chess

If your friends and co-workers are, for some reason, still unimpressed by Mac OS X and your mastery of it, invite them over to watch you play a game of chess with your Mac—by talking to it.

Open the Chess program, which is described in Section 9.1.5. Unless you've turned it off (in Chess [image] Preferences), the game's speech-recognition feature is already turned on. When it's on, the round Feedback window should be visible onscreen.

To learn how to speak commands in a way that Chess will understand, click the small gray triangle at the bottom of the Speech Feedback panel to open the Speech Commands window. As usual, it lists all the commands that Chess can comprehend.

You specify the location of pieces using the grid of numbers and letters that appears along the edges of the chessboard. The White King, for example, starts on square e1 because he's in the first row (1) and the fifth column (e). To move the King forward by one square, you'd say: "King e1 to e2."

Although it doesn't seem quite as satisfying (for some reason), you can actually skip the name of the piece you want to move (Pawn, Knight, and so on). It's perfectly OK to call out the square locations only ("g3 to f5").

As the Speech Commands window should make clear, a few other commands are at your disposal. "Take back move" is one of the most useful. When you're ready to close in for the kill, the syntax is: "Pawn e5 takes f6."

And smile when you say that.

14.5.3 The Chatty Mac

As noted earlier, the Mac is prepared to read to you any text in any program.

Before you begin these experiments, however, visit the Universal Access panel of System Preferences. Make sure that "Enable access for assistive devices" is turned on; if it isn't, your efforts to turn on any of several of the new speech features will be interrupted with a request to turn it on.

Now visit the Speech panel of System Preferences. Click the Spoken User Interface tab (Figure 14-14).

Here are all the different occasions when the Mac can talk to you:

Figure 14-14. Here's where you tell the Mac just how chatty you want it to be. You can also control which voice it uses, and even how fast it talks—a slider, by the way, you won't find on many of your human companions.
14.5.3.1 When an alert message appears onscreen

You can make the Mac read aloud error messages and alert messages that may appear on your screen. Here are the controls available to you:

  • Speak the phrase. Use this pop-up menu to specify which utterance the Mac speaks before the actual error message—for example, "Excuse me! The Trash could not be emptied" or "Attention! The document could not be printed." If you don't want any such preamble, turn off the checkbox.

    If you choose "Next in the list" or "Random from the list" from this pop-up menu, you'll never hear the same expletive twice. Better yet, choose Edit Phrase List to open a dialog box where you can specify your own words of frustration. (Apple Computer, Inc. is not liable for any trouble you may get into with people in neighboring cubicles.)

  • Speak the alert text. If you turn off this checkbox, the Mac won't read the actual error message at all. That is, if you turn on "Speak the phrase" but leave this checkbox off, the Mac will shout, for example, "Oh dear!" to get your attention, but will leave it up to you to read the onscreen message.

  • Talking Alerts voice. Use this pop-up menu to specify the voice you want reading your error messages. (It doesn't have to be the same as the standard Mac default voice that's used for other purposes.)

  • Wait before speaking. The entire purpose of the Talking Alerts feature is ostensibly to get your attention if you've wandered away—mentally or physically—from your Mac. The chances are slim, but an urgent problem might occur that, if left undetected, could land you in trouble. (A 500-page printout brought to its knees by a paper jam comes to mind.)

    In other words, if you're still sitting in front of your Mac, you may not need the Mac to speak to get your attention; you'll simply read the onscreen message. That's why you can set this slider to make the Mac wait, after the error message appears, for up to a minute before trying to flag you with its voice, so that it won't harangue you unnecessarily. (Click Demonstrate Settings for a sense of how long the Mac will delay before speaking.)

14.5.3.2 When an application requires your attention

A jumping dock icon means that the program is trying to get your attention. It might be Print Center (because your printer is out of paper), or it might be Entourage (because new email has come in). In any case, now the Mac can tell you, in so many words, which program needs some loving care.

14.5.3.3 When your cursor passes over some text

This feature is, obviously, a spectacular help for anyone who has trouble seeing. Now your cursor can "read" buttons, tabs, dialog box options, desktop icons, the subject lines of messages in your email inbox, and so on.

14.5.3.4 When a key is pressed

In its own humble way, this option offers the most dramatic possibilities of all. It means that the Mac can read any text in any program. Now you can hear any Web page read to you, any email message, any sticky note—in many cases, this can be a welcome break for sore eyes. Furthermore, if you do any kind of writing at all, you'll discover the value of having your material read back to you out loud; it's a proofreading technique that reveals all kinds of typos and wordos that you wouldn't catch just by reading, even if you read it 50 times.

The very first time you turn on this checkbox, the Mac prompts you to specify a keystroke. (Later, you can always change the keystroke by clicking the Change Key button.) Choose a keystroke that doesn't conflict with the program you're using—Shift-Option-Z, for example.

Now go to the program where you'd like the reading to happen. Highlight some text (or just press [image] -A to select all of it). Then press the keystroke you specified. The Mac begins reading it aloud immediately. To interrupt the playback, press the same keystroke again, or press [image] -period.

And be glad you were alive to see the day.

TIP

If you have an iPod, don't forget that your Mac can convert any text or word processing document into a spoken recording, so that you can listen to it when you're on the go. Details in Section 7.2.1.


14.6 Inkwell: Handwriting Recognition

Apple spent a lot of money on the Newton, its mid-'90s handheld computer that never really took off. Bigger, heavier, and much more expensive than the Palm (which followed soon after), the Newton was a case of good technology, bad timing.

Never let it be said that Steve Jobs doesn't know how to hunt for bargains. In the same way that your grandmother turned yesterday's dinner into today's sandwich (and tomorrow's soup), Apple has recycled the Newton handwriting technology and added it to Mac OS X 10.2. It's now called Inkwell, and it does exactly what it used to: turns your handwriting into "typed" text in any program.

You can't very well write directly on your Apple Cinema Display (although that would be cool—Apple, are you listening?). That's why Inkwell appears in Mac OS X only if you have a Wacom graphics tablet, one of those stylus-and-pad devices found generally only on the desks of graphic artists.

But Who's Got a Graphics Tablet?

Um, I hate to be a party pooper, but really: Why did Apple go to the expense and effort of adding handwriting recognition to Mac OS X? I mean, not one Mac user in 1,000 has a graphics tablet.

Apple weakly answers this question by citing Photoshop jockeys who can't be bothered to take their hands off the pen just to type a couple of words on the keyboard. They want to be able to draw, then "type" a couple of words without moving their hands.

Yeah, right.

It's much more likely that Apple is laying the groundwork for some future, touch-screen computers. Computers based on Microsoft's Tablet PC design are already available, in the form of laptops or tablet-shaped computers that let you write directly on the screen. There's gossip that Apple wants to be ready with a counterstrike.

Can Inkwell really replace the keyboard? Not for anything more than quick notes, that's for sure. But it could enable you to use a tablet computer for Web surfing, sketching, filling in database forms, and so on.

14.6.1 Getting Set With Inkwell

If you don't have a Wacom graphics tablet, don't bother looking for Inkwell—you'll never find it. Its controls appear only after you've installed a tablet and its software driver.

Once you've done so, open System Preferences and click the new Ink icon. You turn on handwriting recognition by setting the "Handwriting Recognition is" button to On (Figure 14-15, top). Right away, you'll see a change on your screen: the InkBar toolbar appears.

Figure 14-15. Top: Most people never see the Ink panel of System Preferences, since it appears only when you install a Wacom graphics tablet. Bottom: You can shrink the InkBar palette down to a small square by clicking on the zoom button (Section 1.2), or expand it to include InkPad by clicking on the notepad icon at the palette's right.

Now visit a program that accepts typing—TextEdit, for example. Click into anyplace where you can type. A translucent, yellow, lined overlap appears as you start writing. Print neatly on the overlay (you don't have to stick within the bounds of the text area in the program you're using. Avoid connecting the letters; Inkwell can't read cursive script. Stay on the lines, if you can, and make capital letters distinctly larger than lowercase letters.

A moment after you stop writing, the Mac turns your writing into text and "types" it into the current document.

TIP

Considering using The Character Palette to insert awkward punctuation marks and unusual symbols.

14.6.2 Two Ways to Write

Inkwell can detect what you write in either of two places:

  • Anywhere on the screen.

  • Only in a floating "note pad" window called InkPad.

You can switch back and forth anytime, using the "Allow me to write" pop-up menu on the Ink panel of System Preferences. Either way, you can control how Inkwell works using the InkBar palette, which appears when you turn on handwriting recognition (Figure 14-15, bottom).

14.6.2.1 The InkBar Palette

Inkwell's floating palette lets you "press" the keys for menu commands: , Shift, Option, or Control. For example, to trigger the Shift- [image] -H keystroke (for Replace) in Microsoft Word, you'd tap the [image] button, tap Shift, and then write the letter H.

The icon at the far left of the palette is the on/off switch for handwriting recognition—a handy feature as you move from Photoshop to your email program, for example. When the icon shows an arrow cursor, your pen is just a pointing device, not a writing device. (However, you can always write in the InkPad window even when you're in pointing-only mode.)

14.6.2.2 Writing Everywhere

When the pen icon is showing in the InkBar palette, you can write anywhere on your Mac's screen, as shown in Figure 14-16.

Figure 14-16. As you begin writing, Inkwell lays a partially transparent window—which looks like paper from a legal pad—over whatever is on your screen. As you write, your penstrokes appear on screen. They disappear as the Mac recognizes your writing and inserts it at the insertion point.
14.6.2.3 Using InkPad

If you don't want your pen to transform handwriting into text everywhere on your screen, you can limit the writing area to the built-in InkPad application. That's a useful arrangement when you're working in a graphics program and want the Mac to distinguish between penstrokes that draw and penstrokes that write.

To summon InkPad, click the notepad icon at the far right of the InkBar palette, which expands to become a window that looks remarkably like a lined sheet of paper. When you move your stylus over that area, your cursor turns into a pen. You're ready to write.

At the bottom of the InkPad window, you see two buttons, labeled with the letter A and a star. Their functions are described in Figure 14-17.

Figure 14-17. When the is highlighted, Mac OS X expects you to write. After you write something, click the Send button to have it "typed" into your document. (You can even perform simple edits before you click Send.) If you click the star, on the other hand, the InkPad window turns into a sheet of graph paper. At this point, you can draw or write anything you want, but the Mac doesn't recognize it as text; it just remains in graphic form. Click Clear to completely erase the Inkpad. When you click Send, whatever you sketched drops into whatever program you're currently running (assuming it's a program that accepts graphics).

14.6.3 Improving InkWell

If you find that Inkwell doesn't translate your handwriting well (you write Millennium and Inkwell thinks you wanted Mill E Numb, for example), return to the Ink panel of System Preferences.

Take a look at the "My handwriting style is" slider (Figure 14-15, top). If your printing tends to be tight or cramped, you may need to move the slider toward "Closely spaced." If your writing is loose and airy, sliding toward "Widely spaced" can dramatically improve Inkwell's recognition of your chicken scratch.

If you click Options at the bottom of this tab, you'll find even more ways to tweak the way Inkwell processes your handwriting. For example, you can use the sliders here to govern how quickly your writing pen cursor turns back into a pointing-and-clicking device after you stop writing.

In other words, don't give up if Inkwell doesn't perfectly recognize your handwriting right away. There are plenty of settings you can modify to improve its chances. After working with it for a little while, you'll get the hang of using Inkwell—and it'll get the hang of understanding you.

Another way you can help is to teach Inkwell terms it may not know, such as your friends' names and any professional jargon you use. To do so, click the Word List tab (of the Ink panel of System Preferences). Click Add, type the word you want Inkwell to consider legitimate, and click OK.

If your writing is fairly clear, Inkwell does a pretty good job of interpreting even words it doesn't know. But adding them to the Word List tab dramatically improves recognition of uncommon words.

14.6.4 Friendly Gestures

Inkwell recognizes more than words. It also recognizes gestures, just as the Newton did. It's a strange but logical concept: When you draw certain shapes on the tablet, Inkwell performs commands like Undo, Copy, Paste, and Select All. There are also written characters for keys like Delete, Space, Tab, and Return.

To view the list of gestures that Inkwell knows, click the Gestures tab of the Ink panel of System Preferences, as shown in Figure 14-18. By learning these characters, you can maximize the time you spend using your pen, and minimize the effort of pressing keys and pulling down menus.

Figure 14-18. Do these gestures look more like hieroglyphics? No problem. When you click a gesture, the large box at the right of the screen displays a small animation, showing you how to properly write the gesture. Most of them are pretty easy to remember: Undo is a U with an extra leg, Paste is a modified P, and Clear—as all Newton users will remember—is a zigzag line, as if you were crossing something out on a pad of paper.

Unfortunately, you can't add new gestures to Inkwell, which means you can't come up with your own private set of pen strokes to correspond to your favorite commands and macros. Maybe in Inkwell 2.0.

TIP

Write Rosetta! Rosetta! Rosetta! You've just written down the original code name for Apple's handwriting recognition project. As proof, the Mac will type out, "Hey, that's me!" Never let it be said that the Newton's engineers didn't have a sense of humor.


Chapter 15. Terminal: Doorway to Unix

As you're certainly aware by now, Mac OS X's resemblance to the traditional Mac operating system is only superficial. The engine underneath the pretty skin is utterly different. In fact, it's Unix, one of the oldest and most respected operating systems in use today.

The first time you see it, you'd swear that Unix has about as much in common with the traditional Mac OS as a Jeep does with a melon (see Figure 15-1).

Figure 15-1. Top: What most people think of when they think "Macintosh" is a graphic interface—one that you control with a mouse, using menus and icons to represent files and commands. Bottom: Terminal offers a second way to control Mac OS X: a command line interface, meaning you operate it by typing out programming codes.

What the illustration at the bottom of Figure 15-1 shows, of course, is a command line interface: a place where you can type out instructions to the computer itself. This is a world without icons, menus, or dialog boxes; even the mouse is almost useless.

Surely you can appreciate the irony: The brilliance of the original 1984 Macintosh was that it eliminated the command line interface that was still the ruling party on the computers of the day (like Apple II and DOS machines). Most non-geeks sighed with relief, delighted that they'd never have to memorize commands again. Yet here's Mac OS X, Apple's supposedly ultramodern operating system, complete with a command line! What's going on?

Actually, the command line never went away. At universities and corporations worldwide, professional computer nerds kept right on pounding away at the little C: or % prompts, appreciating the efficiency and power such direct computer control afforded them.

You're to be forgiven if your reaction to learning Unix is, "For goodness' sake—can't I finish learning one way to control my new operating system before I have to learn yet another one?"

Absolutely. You never have to use Mac OS X's command line. In fact, Apple has swept it far under the rug, obviously expecting that most people will use the beautiful icons and menus of the regular desktop. In earlier versions of Mac OS X, there were a few tasks you could perform only at the command line; in 10.2, there are even fewer of these.

For intermediate or advanced Mac fans with a little time and curiosity, however, the command line opens up a world of possibilities. It lets you access corners of Mac OS X that you can't get to from the regular desktop. It lets you perform certain tasks with much greater speed and efficiency than you'd get by clicking and dragging icons. And it gives you a fascinating glimpse into the minds and moods of people who live and breathe computers.

If you've ever fooled around with ResEdit, experimented with AppleScript, or set up a Mac on a network, you already know the technical level of the material you're about to read. The Unix command line may be unfamiliar, but it doesn't have to be especially technical, particularly if you have some "recipes" to follow like the ones in this chapter and the next.

NOTE

Unix is, of course, an entire operating system unto itself. This chapter is designed to help you find your footing and decide whether or not you like the feel of Unix. If you get bit by the bug, see Appendix E for some sources of additional Unix info.

Mac OS X's Unix Roots

In 1969, Bell Labs programmer Ken Thompson found himself with some spare time after his main project, an operating system called Multics, was canceled. Bell Labs had withdrawn from the expensive project, disappointed with the results after four years of work.

But Thompson still thought the project—an operating system that worked well as a cooperative software-development environment—was a promising idea. Eventually, he and colleague Dennis Ritchie came up with the OS that would soon be called Unix (a pun on Multics). Bell Labs saw the value of Unix, agreed to support further development, and became its first corporate user.

In the age when Thompson and Ritchie started their work on Unix, most programmers wrote code that would work on only one kind of computer (or even one computer model). Unix, however, was one of the first portable operating systems: its programs could run on different kinds of computers without being rewritten. That's because Thompson and Ritchie wrote Unix using a new programming language of their own invention called C.

Programmers need only write their code once, in a language like C. After that, a software Cuisinart called a compiler can convert the newly hatched software into the form a particular computer model can understand.

Unix soon found its way into labs and, thanks to AT&T's low academic licensing fees, universities around the world. Programmers all over the world added to the source code, fixed bugs, and then passed those modifications around.

In the mid-1970s, the University of California at Berkeley became the site of especially intense Unix development. Students and faculty there improved the Unix kernel (the central, essential part of the OS), added features to the OS, and wrote new Unix applications. By 1977, they had enough additional software to release their own version of Unix, the first of several Berkeley Software Distribution (BSD) versions.

As it happened, the government's Defense Advanced Research Projects Agency (DARPA) was seeking a uniform, portable OS to use for their growing wide-area network, originally called ARPAnet (and now called the Internet).

DARPA liked Unix and agreed to sponsor further research at Berkeley. In January 1983, DARPA changed ARPAnet's networking protocol to TCP/IP—and the Internet was born, running mostly on Unix machines.

In 1985, Steve Jobs left Apple to start NeXT Computer, whose NextStep operating system was based on BSD Unix. When Apple bought NeXT in 1996, Jobs, NextStep (eventually renamed OpenStep), and its Terminal program came along with it. The Unix that beats within Mac OS X's heart is just the latest resting place for the OS that Jobs's team developed at NeXT.

So the next time you hear Apple talk about its "new" operating system, remember that its underlying technology is actually over 30 years old.


15.1 Terminal

The keyhole into Mac OS X's Unix innards is a program called Terminal, which sits in your Applications [image] Utilities folder (see Figure 15-2). Terminal is named after the terminals (computers that consist of only a monitor and keyboard) that tap into the mainframe computers at universities and corporations. Similarly, Terminal is just a window that passes along messages to and from the Mac's brain.

The first time you open Terminal, you'll notice that there's not much in its window except the date and time of your last login, a welcome message, and the command line prompt (Figure 15-2).

For user-friendliness fans, Terminal doesn't get off to a very good start—this prompt looks about as technical as computers get. It breaks down like this:

  • office-mac: is the name of your Mac (at least, as Unix thinks of it). It's usually the Mac's Rendezvous name (as it appears in the Sharing panel of System Preferences), but it's occasionally the name your Mac goes by on the Internet.

  • ~. The next part of the prompt indicates what folder you're "in" (see Figure 15-2). It denotes the working directory—that is, the current folder. (Remember, there are no icons in Unix.) Essentially, this notation tells you where you are as you navigate your machine.

    The very first time you try out Terminal, the working directory is set to the symbol ~. In the language of Unix, the tilde symbol (~) is shorthand for "your own Home folder." It's what you see the first time you start up Terminal, but you'll soon be seeing the names of other folders here—[office-mac: /Users] or [office-mac: /System/Library], for example. (More on this slash notation in The Go to Folder Command.)

    NOTE

    Before Apple came up with the user-friendly term folder to represent an electronic holding tank for files, folders were called directories. (Yes, they mean the same thing.) But in this chapter and the next, you'll encounter the term directory almost exclusively. In any discussion of Unix, "directory" is simply the correct term.

    Besides, using a term like "working folder" within earshot of Unix geeks is likely to get you lynched.

  • chris% begins with your short user name. It reflects whoever's logged into the shell (see the box on the facing page), which is usually whoever's logged into the Mac at the moment. As for the % sign: think of it as a colon. In fact, think of the whole prompt shown in Figure 15-2 as Unix's way of asking, "OK, Chris, I'm listening. What's your pleasure?"

Unless you've fiddled with Terminal's preferences, the insertion point looks like a tall rectangle at the end of the command line. It trots along to the right as you type.

Figure 15-2. On the Web, Mac OS X's Terminal is one of the most often discussed elements of Mac OS X. Dozens of step-by-step tutorials for performing certain tasks circulate online, usually without much annotation as to why you're typing what you're typing. As you read this chapter, remember that capitalization matters in Terminal, even though it doesn't in the Finder. As far as Unix commands are concerned, Hello and hello are two very different things.

15.1.1 Unix Programs

An enormous number of programs have been written for Unix. And thanks to thousands of open-source developers—programmers all over the world who collaborate and make their work available for the next round of modification—much of this software is freely available to all, including Mac OS X users.

Each Unix command generally calls up a single application (or process, as geeks call it) that launches, performs a task, and closes. Many of the best-known of these applications come with Mac OS X.

Here's a fun one: Just type uptime and press Enter or Return. (That's how you run a Unix program: just type its name and press Enter). On the next line, Terminal shows you how long your Mac has been turned on continuously. It shows you something like: "6:00PM up 8 days, 15:04, 1 user, load averages: 1.24, 1.37, 1.45"—meaning your Mac has been running for 8 days and 15 hours nonstop.

You're finished running the uptime program. The % prompt returns, suggesting that Terminal is ready for whatever you throw at it next.

Try this one: Type cal at the prompt, and then press Enter. Unix promptly spits out a calendar of the current month.

[office-mac:~] chris% cal
     June 2003
 S  M Tu  W Th  F  S
 1  2  3  4  5  6  7
 8  9 10 11 12 13 14
15 16 17 18 19 20 21
22 23 24 25 26 27 28
29 30
[office-mac:~] chris%

This time, try typing cal 11 2003, cal -y, or cal -yj. These three commands make Unix generate a calendar of November 2003, a calendar of the current year, and a Julian calendar of the current year, respectively.

TIP

The mouse isn't very useful at the command line. You generally move the cursor only with the left and right arrow keys. (The Delete key works as it always does.)

You can use the mouse, however, to select text from anywhere in the window (or other programs) and paste it in at the prompt. You can also use the mouse to drag an icon off your desktop into the Terminal window, as shown in Figure 15-3. And in the Terminal [image] Window Settings [image] Emulation dialog box, you'll find an option that lets you Option-click in a command line to plant the insertion point there.

Of Terminal and Shells

One Unix program runs automatically when you open a Terminal window: tcsh (pronounced "T.C. Shell").

Technically, a shell is a Unix program that interprets the commands you've typed, passes them to the kernel (the operating system's brain), and then shows you the kernel's response.

But more practically, the shell is the Unix Finder. It's the program that lets you navigate the contents of your hard drive, see what's inside certain folders, launch programs and documents, and so on. There are actually several different shells available in Unix, each with slightly different command syntax. A few others—like sh, the Bourne shell; bash, the Bourne Again Shell (hey, that's good!); zsh; and csh—come with Mac OS X. But Terminal comes set to use tcsh.

You can open additional Terminal windows by choosing Shell [image] New. Each window runs independently of any others. For proof, try opening several windows and then running the cal command in each.


15.2 Navigating in Unix

If you can't see any icons for your files and folders, how are you supposed to work with them?

You have no choice but to ask Unix to tell you what folder you're looking at (using the pwd command), what's in it (using the ls command), and what folder you want to switch to (using the cd command), as described in the following pages.

15.2.1 pwd (print working directory, or "Where am I?")

Here's one of the most basic navigation commands: pwd, which stands for print working directory. The pwd command doesn't actually print anything on your printer; instead, the pwd command types out, on the screen, the path Unix thinks you're in (the working directory).

Try typing pwd and pressing Enter. On the next line, Terminal may show you something like this:

/Users/chris/Movies

Terminal is revealing the working directory's path—a list of folders-in-folders, separated by slashes, that specifies a folder's location on your hard drive. /Users/chris/Movies pinpoints the Movies folder in Chris's Home folder (which, like all Home folders, is in the Users directory).

TIP

Capitalization counts in Unix. Command names are almost always all lowercase (like cal and pwd). But when you type the names of folders, be sure to capitalize correctly.

Pathnames 101

In many ways, browsing the contents of your hard drive using Terminal is just like doing so with the Finder. You start with a folder, and move down into its subfolders, or up into its parent folders.

In this chapter and the next, you'll be asked to specify a certain file or folder in this tree of folders. But you can't see their icons from the command line. So how are you supposed to identify the file or folder you want?

By typing its pathname. The pathname is a string of folder names, something like a map, that takes you from the root level to the next nested folder, to the next, and so on. (The root level is, for learning-Unix purposes, the equivalent of your main hard drive window. It's represented in Unix by a single slash. The phrase /Users, in other words, means "the Users folder in my hard drive window"—or, in other terms, "the Users directory at the root level.")

To refer to the Documents folder in your own Home folder, for example, you could type /Users/chris/Documents (if your name is Chris, that is).

15.2.2 ls (list, or "What's in here?")

The ls command, short for list, makes Terminal type out the names of all the files and folders in the folder you're in (that is, your working directory). You can try it right now: just type ls and then press Enter. Terminal responds by showing you the names of the files and folders inside in a horizontal list, like this:

Desktop Documents Library Movies Music Pictures Public Sites

In other words, you see a list of the files and folders that, in the Finder, you'd see as icons in your Home folder.

NOTE

Terminal respects the limits of the various Mac OS X accounts (Chapter 11). In other words, a Normal or Administrator account holder isn't generally allowed to peek into someone else's Home folder. If you try, you'll be told, "Permission denied."

You can also make Terminal list what's in any other directory (one that's not the working directory) just by adding its pathname as an argument. An argument tells the command what to work on. (Remember the Calendar example? When you wanted the November 2003 calendar, you typed cal 11 2003. The "11 2003" part was the argument.)

To see a list of the files in your Documents directory, then, you could just type ls /Users/chris/Documents. Better yet, because the ~ symbol is short for "my home directory," you could save typing with ls ~/Documents. The pathname "~/Documents" is an argument that you've fed the ls command.

15.2.2.1 About flags

Between a command and its arguments, you can sometimes insert option flags (also called switches)—short modifying phrases that affect how the command works. In the Calendar example, you can type cal -y to see a full-year calendar; the -y part is an option flag.

Option flags are almost always preceded by a hyphen (-), although you can usually run several flags together following just one hyphen, like this: ls -ai (that is, both the -a and -i flags are in effect).

Here are some useful options for the ls command:

  • -a. The ls command even displays the names of files and folders that are invisible by the Finder's definition. The Unix shell uses its own system of denoting invisible files and folders, and ignores the Finder's. That doesn't mean you're seeing everything; files that are invisible by the Unix definition still don't show up.

    You can use one of the ls command's flags, however, to force even Unix-invisible files to appear. Just add the -a flag. In other words, type this: ls -a. Now when you press Enter, you might see something like this:

    .     Desktop          Movies       Public
..    Documents        Music        Sites
.     CFUserTextEncoding Library    Pictures

  • -F. As you see, the names of invisible Unix files all begin with a period (Unix folk call them dot files). But are these files or folders? To find out, use ls with the -F option (capitalization counts), like this: ls -aF Movies. You're shown something like this:

    ./        Picnic Movie 1 Yosemite/        Reviews.doc
../        Picnic Movie 2 Tahoe/

    The names of the items themselves haven't changed, but the -F flag makes slashes appear on directory (folder) names. This example shows that there are four directories and one file in ~/Movies (that is, the Movies folder in your home directory).

  • -R. The -R flag produces a recursive listing—one that shows you the directories within the directories in the list. If you type ls -R, for example, you might get something resembling this:

    Bad Reviews.doc  Old Tahoe Footage 2 Picnic Movie 2  Reviews.doc
./Old Tahoe Footage 2:
Tahoe 1.mov   Tahoe 3.mov   Tahoe Project File
Tahoe 2.mov   Tahoe 4.mov
./Picnic Movie 2:
Icon?      Media      Picnic Movie 2 Project
./Picnic Movie 2/Media:
Picnic Movie 1 Picnic Movie 3 Picnic Movie 5
Picnic Movie 2 Picnic Movie 4 Picnic Movie 6

    TIP

    As you can tell by the cal and ls examples, Unix commands are very short. They're often just two-letter commands, and an impressive number of those use alternate hands (ls, cp, rm, and so on).

    The reason has partly to do with conserving the limited memory of early computers and partly to do with efficiency: most programmers would just as soon type as little as possible to get things done. User-friendly it ain't, but as you type these commands repeatedly over the months, you'll eventually be grateful for the keystroke savings.

15.2.3 cd (change directory, or "Let me see another folder")

Now you know how to find out what directory you're in, and how to see what's in it, all without double-clicking any icons. That's great information, but it's just information. How do you do something in your command-line Finder—like switching to a different directory?

To change your working directory, use the cd command, followed by the path of the directory you want to switch to. Want to see what's in the Movies directory of your home directory? Type cd /Users/chris/Movies and press Enter. The % prompt shows you what it considers to be the directory you're in now (the new working directory). If you perform an ls command at this point, Terminal will show you the contents of your Movies directory.

That's a lot of typing, of course. Fortunately, instead of typing out that whole path (the absolute path, as it's called), you can simply specify which directory you want to see relative to the directory you're already in.

For example, if your Home folder is the working directory, the relative pathname of the Trailers directory inside the Movies directory would be Movies/Trailers. That's a lot shorter than typing out the full, absolute pathname (/Users/chris/Movies/Trailers).

If your brain isn't already leaking from the stress, here's a summary of the three different ways you could switch from ~/(your home directory) to ~/Movies:

  • cd /Users/chris/Movies. That's the long way—the absolute pathname. It works no matter what your working directory is.

  • cd ~/Movies. This, too, is an absolute pathname that you could type from anywhere. It relies on the ~ shorthand (which always means "my home directory").

  • cd Movies. This streamlined relative path capitalizes on the fact that you're already in your home directory.

    TIP

    Actually, there's a fourth way to specify a directory that involves no typing at all: dragging the icon of the directory you want to specify directly into the Terminal window. Figure 15-3 should make this clear.

Figure 15-3. When you drag icons directly from the desktop into a terminal window, the icon's pathname appears automatically at the insertion point. Terminal even adds backslashes to any special characters in these pathnames for you (a necessary step known as escaping the special characters).

15.2.4 . and .. (dot and dot-dot, or "Back me out")

So now you've burrowed into your Movies directory. How do you back out?

Sure, you could type out the full pathname of the directory that encloses Movies—if you had all afternoon. But there's a shortcut: you can type a period (.) or a double period (..) in any pathname. These shortcuts represent the current directory and its parent directory (the directory that contains it), respectively.

To go from your home directory up to /Users, for example, you could just type cd .. (that is, cd followed by a space and two periods).

You can also use the dot-dot shortcut repeatedly to climb multiple directories at once, like this: cd ../.., which would mean "switch the working directory to the directory two layers out." If you were in your Movies directory, ../.. would change the working directory to the Users directory.

Another trick: You can mix the .. shortcut with actual directory names. For example, suppose your Movies directory contains two directories: Trailers and Shorts. Trailers is the current directory, but you want to switch to the Shorts directory. All you'd have to do is type cd ../Shorts, as illustrated in Figure 15-4.

Figure 15-4. The double dot tells Unix to switch its attention to the Movies directory (walking upward through the directory tree); the rest tells it to walk down the Movies directory into the Shorts directory. Note that the prompt always identifies the current working directory.

15.2.5 Keystroke-Saving Features

By now, you might be thinking that clicking icons would still be faster than doing all this typing. Here's where the typing shortcuts of the tcsh shell come in.

15.2.5.1 Tab completion

You know how you can highlight a file in a Finder window by typing the first few characters of its name? The tab-completion feature works much the same way. Over time, it can save you miles of finger movement.

It kicks in whenever you're about to type a pathname. Start by typing the first letter or two of the path you want, and then press Tab; Terminal instantly fleshes out the rest of the directory's name. As shown in Figure 15-5, you can repeat this process to specify the next directory-name chunk of the path.

Figure 15-5. Top: You type cd /U and then press Tab. Second from top: Terminal finishes the directory name Users for you. Third from top: You type and then press Tab. Bottom: Terminal finishes the home-directory name, chris. You can also use tab completion to specify file names, as when you type ls -l Movies/R and then press Tab; Terminal finishes the name Reviews.doc.

Here are some tips for tab completion:

  • Capitalization counts.

  • Terminal will add backslashes automatically if your directory names include spaces, $ signs, or other special characters. But you still have to insert your own backslashes when you type the "hint" characters that tip off tab completion.

  • If it can't find a match for what you typed, Terminal beeps.

    If it finds several files or directories that match what you typed, Terminal beeps and shows you a list of them. To specify the one you really wanted, type the next letter or two and then press Tab again.

15.2.5.2 Using the history

You may find yourself at some point needing to run a previously entered command, but dreading the prospect of re-entering the whole command. Retyping a command, however, is never necessary. Terminal (or, rather, the shell it's running) remembers the last 150 commands you entered. At any prompt, instead of typing, just press the up or down arrow keys to walk through the various commands in the shell's memory. They flicker by, one at a time, at the % prompt—right there on the same line.

15.2.5.3 Wildcards

Wildcards are special characters that represent other characters—and they're huge timesavers.

The most popular wildcard is the asterisk (*), which means "any text can go here." For example, to see a list of the files in the working directory that end with the letters te, you could type ls *te. Terminal would show you files named Yosemite, BudLite, Brigitte, and so on—and hide all other files in the list.

Likewise, to see which files and directories begin with "Old," you could type ls Old* and press Enter. You'd be shown only the names of icons in the working directory called Old Yeller, Old Tahoe Footage, Olduvai Software, and so on.

If you add the asterisk before and after the search phrase, you'd find items with that phrase anywhere in their names. Typing ls *jo* will show you the files named Johnson, Mojo, Major Disaster, and so on.

TIP

Using * by itself means "show me everything." To see a list of what's in a directory and in the directories inside it (as though you'd highlighted all the folders in a Finder list view and then pressed [image] -right arrow), just type ls *.

15.2.5.4 Directory switching

A hyphen (-) after the cd command means, "take me back to the previous working directory." For example, if you changed your working directory from ~/Movies/Movie 1 to ~/Documents/Letters, simply enter cd - to change back to ~/Movies/Movie 1. Use cd - a second time to return to ~/Documents/Letters. (Note the space between cd and the hyphen.)

TIP

On the other hand, if you're doing a lot of switching between directories, you should probably just open and switch between two Terminal windows, each with a different working directory.

15.2.5.5 The ~ shortcut

You already know that the tilde (~) character is a shortcut to your home directory. But you can also use it as a shortcut to somebody else's home directory simply by tacking on that person's account name. For example, to change to Miho's home directory, use cd ~Miho.

15.2.5.6 Special keys

The tcsh shell offers dozens of special keystroke shortcuts for navigation. You may recognize many of them as useful undocumented shortcuts that work in any Cocoa application; but even more are available (and useful) in Terminal:

Keystroke | Effect
Ctrl-U | Erases the entire command line you're working on.
Ctrl-A | Moves the insertion point to the beginning of the line.
Ctrl-E | Moves the insertion point to the end of the line.
Ctrl-T | Transposes the previous two characters.
Esc-F | Moves the insertion point to the beginning of the next word.
Esc-B | Moves the insertion point to the beginning of the previous word.
Esc-Delete | Erases the previous word (defined as "anything that ends with a space, slash, or most other punctuation marks; periods and asterisks not included"). You have to press and release the Esc key and then the Delete key; repeat for each word.
Esc-D | Erases the word following the insertion point.
Esc-C | Capitalizes the word following the insertion point.
Esc-U | Changes the next word to all uppercase letters.
Esc-L | Changes the next word to all lowercase letters.

No Spaces Allowed

Terminal doesn't see a space as a space. It thinks that a space means, for example, "I've just typed a command, and what follows is an argument." If you want to see what's in your Short Films directory, therefore, don't bother typing ls ~/Movies/Short Films. You'll only get a "No such file or directory" error message. (See the space in the Short Films directory name?)

Similarly, $ signs have a special meaning in Unix. If you try to type one in a pathname (because a directory name contains $, for example), you'll have nothing but trouble.

Fortunately, you can work around this quirk by using a third reserved, or special, character: the backslash (\). It says, "Ignore the special meaning of the next character—a space, for example. I'm not using it for some special Unix meaning. I'm using the following space as, well, a space." (And if it's at a Unix user-group meeting, it might also say, "I'm escaping the space character.")

The correct way to see what's in your Short Films directory, then, would be ls ~/Movies /Short\ Films. (Note how the backslash just before the space means, "This is just a space—keep it moving, folks")

Of course, if you have to enter a lot of text with spaces, it'd be a real pain to type the backslash before every single one. Fortunately, instead of using backslashes, you can enclose the whole mess within single quotation marks. That is, instead of typing this:

cd /Users/chris/My\ Documents/Letters\ to\ finish/Letter\ to\ Craig.doc

...you could just type this:

cd '/Users/chris/My Documents/Letters to finish/Letter to Craig.doc'.

It can get even more complicated. For example, what if there's a single quote in the path? (Answer: Protect it with double quotes.) Ah, but you have years of study ahead of you, grasshoppa.


15.3 Working with Files and Directories

The previous pages show you how to navigate your directories using Unix commands. Just perusing your directories isn't particularly productive, however. Fortunately, this section shows you how to do something with the files you see listed: how to copy, move, create, and delete directories and files.

TIP

You're entering Serious Power territory, where it's theoretically possible to delete a whole directory of stuff with a single typo. As a precaution, consider working through this section with administrator privileges turned off for your account, so that you won't be able to change anything outside your home directory.

To do so, quit Terminal. Open the Accounts pane of System Preferences. Select your account name, click Edit, enter your password in the Current Password box, and press Enter. Turn off the "Allow user to administer this machine" checkbox. Finally, click OK. (One Mac OS X account, on the other hand, must always have administrator privileges, so you first may need to create another Administrator account, as described in Section 11.2.)

15.3.1 cp (copy)

Using the Unix command cp, you can copy and rename a file in one move. (Try that in the Finder!)

The basic command goes like this: cp path1 path2, where the path placeholders represent the original file and the copy, respectively.

15.3.1.1 Copying in place

To duplicate a file called Thesis.doc, you would type cp Thesis.doc Thesis2.doc. (That's just a space between the names.) You don't have to call the copy Thesis2—you could call it anything you like; the point is that you wind up with two identical files in the same directory. Just remember to add a backslash before a space if you want to name the copy with two words (Thesis\ Backup, for example).

TIP

If this command doesn't seem to work, remember that you must type the full names of the files you're moving—including their file name suffixes like .doc or .gif, which Mac OS X usually hides. Using the ls command before a copy may help you find out what the correct, full file names should be. Or you may just want to use the tab-completion feature, making Terminal type the whole name for you.

15.3.1.2 Copying and renaming

To copy the same file into, say, your Documents folder at the same time, just change the last phrase so that it specifies the path, like this: cp Reviews.doc ~/Documents/ Reviews2.doc.

TIP

Note that cp replaces identically named files without warning. Use the -i flag (that is, cp -i) if you want to be warned before cp replaces a file in this way.

15.3.1.3 Copying without renaming

To copy something into another directory without changing its name, just use a pathname (without a file name) as the final phrase. So, to copy Reviews.doc into your Documents folder, for example, you would type cp Reviews.doc ~/Documents.

TIP

You can use the "." directory shortcut (which stands for the current working directory) to copy files from another directory into the working directory, like this: % cp ~/Documents/Reviews.doc . (notice the space and the period after Reviews.doc).

The Slash and the Colon

OK, I'm so confused. You say that slashes denote nested directories. But in Mac OS 9, I always read that colons (:) denote the Mac's internal folder notation, and that's why I can't use colons in the names of my icons. What's the story?

At the desktop, the Mac still uses colons as path separators instead of the slash. Therefore, you are allowed to use slashes in file names in the Finder, but not a colon. Conversely, in Terminal, you can use colons in file names but not slashes!

Behind the scenes, Mac OS X automatically converts one form of punctuation to the other, as necessary. For example, a file named Letter 6/21/2002 in the Finder shows up as Letter 6:21:2002 in Terminal. Likewise, a directory named Attn: Jon in Terminal appears with the name Attn/ Jon in the Finder. Weird—and fun!

15.3.1.4 Multiple files

You can even move several files or directories at once. Where you'd normally specify the source file, just list their pathnames separated by spaces, as shown in Figure 15-6.

Figure 15-6. The first argument of this command lists two different files. The final clause always specifies where you want all of these files moved to (in this case, the FinishedMovies directory).

You can also use the * wildcard to copy several files at once. For example, suppose you've got these files in your iMovie Projects directory: Tahoe 1.mov, Tahoe 2.mov, Tahoe 3.mov, Tahoe 4.mov, Script.doc, and Tahoe Project File. Now suppose you want to copy only the QuickTime movies into a directory called FinishedMovies. All you'd have to do is type cp *mov ../FinishedMovies and press Enter; Mac OS X instantly performs the copy.

If you wanted to copy all of those files (not just the movies) to another directory, you'd use the * by itself, like this: cp * ../FinishedMovies.

Unfortunately, if the iMovie Projects directory contained other directories and not just files, that command would produce an error message; the Unix cp command doesn't copy directories within directories unless you explicitly tell it to, using the -R option flag. Here's the finished command that copies everything in the current directory—both files and directories—into FinishedMovies: cp -R * ../FinishedMovies.

Here's one more example: a command that copies everything (files and directories) with Tahoe in its name into someone else's Drop Box directory: cp -R *Tahoe* ~miho/Public/Drop\ Box.

15.3.2 mv: Moving and Renaming Files and Directories

Now that you know how to copy files, you may want to move or rename them. To do so, you use the Unix command mv—almost exactly the same way you'd use cp (except that it always moves directories inside of directories you're moving, so you don't have to type -R).

The syntax looks like this: mv oldname newname. For example, to change your Movies directory's name to Films, you'd type mv Movies Films. You can rename both files and directories this way.

15.3.2.1 Moving files and directories

To rename a file and move it to a different directory simultaneously, just replace the last portion of the command with a pathname. To move the Tahoe1 movie file into your Documents directory—and rename it LakeTahoe at the same time—type this: mv Tahoe1.mov ~/Documents/LakeTahoe.mov.

All the usual shortcuts apply, including the wildcard. Here's how you'd move everything containing the word Tahoe in your working directory (files and directories) into your Documents directory: mv *Tahoe* ~/Documents.

15.3.2.2 Option flags

You can follow the mv command with either of these two options:

  • -i. Makes Terminal ask your permission before replacing a file with one of the same name.

  • -f. Overwrites like-named files without asking you first. (Actually, this is how mv works if you don't specify otherwise.)

    NOTE

    The mv command never replaces one directory with an identically named one (or an identically named file). If there is such an item among multiple source items, only those named differently from any subdirectories in the target directory will be moved.

When Forks Collide: Copying Applications with CpMac and MvMac

If you could inspect certain traditional Macintosh files with the software equivalent of a CAT scanner, you'd see that its single icon might actually house two chunks of computer code, which the geeks call the data fork and the resource fork. (Data refers to, well, data—stuff you type, or the programming code that makes up an application. Resources are programming components like icons, windows, toolbars, and other pieces of your applications.)

This fork business is news to Unix, however. When you use the cp command (or mv, described later in this chapter), Unix copies or moves only the data fork—the one it knows about. The effect on the copied or moved file could be minor or disastrous, depending on the type of file. Most non-Cocoa programs (AppleWorks, Word, and so on), for example, will be rendered useless, having lost many of their essential resources. Many will also be given blank icons, having lost their type and creator codes (Section 4.3).

To address this problem, Apple created command line applications called CpMac and MvMac, which are just like cp and mv except that they copy or move all forks of any file they copy. The standard Mac OS X installation doesn't include these commands, however; they're available only if you install the Developer Tools (see The Developer Tools CD Extras).

Once you've done that, you can run either CpMac or MvMac by invoking it at the % prompt. Unfortunately, because these are add-on Unix programs, you have to refer to them using their entire path notations. A typical command might therefore look like this: /Developer/Tools/CpMac -r MacWrite\ Folder ~/Applications. (You can set things up so that typing the pathname isn't necessary, but that's another book.)

You can replace cp with CpMac (and mv with MvMac) in any of the examples in this chapter. There are only two minor differences. First, CpMac uses a lowercase r for its recursive copying option instead of a capital R. (MvMac doesn't require any flag; it always moves everything inside a folder.) Second, whereas you can specify that cp and mv warn you before overwriting files, CpMac and MvMac provide no warnings before overwriting existing files of the same name.

15.3.3 mkdir: Creating New Directories

In the Finder, you make a new folder by choosing File [image] New Folder. In Terminal, you create one using the mkdir command (for make directory).

Follow the command with the name you want to give the new directory, like this: mkdir 'Early iMovie Attempts' (the single quotes in this example let you avoid having to precede each space with a backslash).

The mkdir command creates the new directory in the current working directory, although you can just as easily create it anywhere else. Just add the pathname to your argument. To make a new directory in your Documents [image] Finished directory, for example, type mkdir '~/Documents/Finished/Early iMovie Attempts'.

TIP

If there is no directory called Finished in your Documents directory, you'll just get an error message—unless you use the -p option, which creates as many new directories as necessary to match your command. For example, mkdir -p '~/Documents/Finished/Early iMovie Attempts' would create both a Finished directory and an Early iMovie Attempts directory inside of it.

15.3.4 touch: Creating Empty Files

To create a new, empty file, type touch filename. For example, to create the file practice.txt in your working directory, use touch practice.txt.

And why would you bother? For the moment, you'd use such new, empty files primarily as targets for practicing the next command.

15.3.5 rm: Removing Files and Directories

Unix provides an extremely efficient way to trash files and directories. With a single command, rm, you can delete any file or directory—or all of those that you're allowed to access with your account type.

The dangers of this setup should be obvious, especially in light of the fact that deletions are immediate in Unix. There is no Undo, no Empty Trash command, no "Are you sure?" dialog box. In Unix, all sales are final.

The command rm stands for "remove," but could also stand for "respect me." Pause for a moment whenever you're about to invoke it. For the purpose of this introduction to rm, double-check that administration privileges are indeed turned off for your account.

To use this command, just type rm, a space, and the exact name of the file you want to delete from the working directory. To remove the file practice.txt you created with the touch command, for example, you'd just type rm practice.txt.

To remove a directory and everything in it, add the -r flag, like this: rm -r PracticeFolder.

If you're feeling particularly powerful (and you like taking risks), you can even use wildcards with the rm command. Now, many experienced Unix users make it a rule to never use rm with wildcards while logged in as an administrator, because one false keystroke can wipe out everything in a directory. But here, for study purposes only, is the atomic bomb of command lines, the one that deletes everything in the working directory: rm -r *.

TIP

Be doubly cautious when using wildcards in rm command lines, and triply cautious when using them while logged in as an administrator.

Just after the letters rm, you can insert options like these:

  • -d deletes any empty directories it finds, in addition to files. (Otherwise, empty directories will trigger an error message.)

  • -i (for interactive) makes the Mac ask you for confirmation before nuking each file or directory.

    TIP

    If you use both the -f (see Section 15.3) and -i options, which appear to contradict each other, the last command (farthest to the right) wins.

  • -P performs a "secure delete," scrubbing the file's location on the hard drive three times so that nothing, not even Norton Utilities or the CIA, will know what was there.

15.3.5.1 echo: The Safety Net

You can make the rm less risky by prefacing it with the echo command. It makes Terminal type out the command a second time, this time with a handy list of exactly what you're about to obliterate. If you've used wildcards, you'll see the names of the files that will be affected by the * character. If you type echo rm -r *, for example (which, without the echo part, would normally mean "delete everything in this directory"), you might see a list like this:

rm -r Reviews.doc  Tahoe Footage  Picnic Movie  Contract.doc

Once you've reviewed the list and approved what Terminal is about to do, then you can retype the command without the echo portion.

NOTE

The rm doesn't work on file or directory names that begin with a hyphen (-). To delete these items from your working directory, preface their names with a dot slash (./), like this: rm ./-Recipes.doc.


15.4 Online Help

Mac OS X comes with nearly 900 Unix programs like the ones described in this chapter. How are you supposed to learn what they all do? Fortunately, almost every Unix program comes with its own little help file. It may not appear within an elegant Aqua window—in fact, it's pretty darned plain—but it offers much more material than the regular Mac Help Center.

These help files are called user-manual pages, or manpages, which hold descriptions of virtually every command and program available. Mac OS X, in fact, comes with manpages on about 4,000 topics—about 9,000 printed pages' worth. Unfortunately, manpages rarely have the clarity of writing or the learner-focused approach you'll find in the Mac Help Center. They're generally terse, just-the-facts descriptions. In fact, you'll probably find yourself needing to reread certain sections again and again. The information they contain, however, is invaluable to new and experienced users alike, and the effort spent mining them is usually worthwhile.

15.4.1 Using man

To access the manpage for a given command, type man followed by the name of the command you're researching. For example, to view the manpage for the ls command, enter: man ls.

TIP

The -k option flag lets you search by keyword. For example, man -k appletalk produces a list of all manpages that refer to AppleTalk, whereupon you can pick one of the names in the list and man that page name.

Now the manual appears, one screen at a time, as shown in Figure 15-7.

Figure 15-7. To move on to the next man screen, press the Space bar. To go back, you can either use the Terminal window's scroll bar or press B. To close the manual and return to a prompt, press Q.

A typical manpage begins with these sections:

  • Name. The name and a brief definition of the command.

  • Synopsis. Presents the syntax of the command, including all possible options and arguments, in a concise formula. For example, the synopsis for du (disk usage) is as follows: du [-H | -L | -P] [-a | -s] [-ckrx] [file ...].

    This shows all the flags available for the du command and how to use them.

    Brackets ([ ]) surround the optional arguments. (All of the arguments for du are optional.)

    Vertical bars called pipes (|) indicate that you can use only one item (of the group separated by pipes) at a time. For example, when choosing options to use with du, you can use either -H, -L, or -P—not two or all three at once.

    The word file in the synopsis means "type a pathname here." The ellipsis (...) following it indicates that you're allowed to type more than one pathname.

  • Description. Explains in more detail what the command does and how it works. Also included in the description is the complete list of that command's option flags.

For more information on using man, view its own manpage by entering—what else?—man man.

TIP

The free program ManOpen, available for download at www.missingmanuals.com, is a Cocoa manual-pages reader that provides a nice looking, easier-to-control window for reading man pages.

15.4.2 Other Online Help

Sometimes Terminal shoves a little bit of user-manual right under your nose—when it thinks you're having trouble. For example, if you use the mkdir command without specifying a pathname, mkdir interrupts the proceedings by displaying its own synopsis as a friendly reminder (subtext: "Um, this is how you're supposed to use me"), like this: usage: mkdir [-p] [-m mode] dirname ...


15.5 Terminal Preferences

Like most applications, Terminal has a Preferences command. However, you'll access most of Terminal's settings from the Window Settings command (just below Preferences in the menu). If you spend endless hours staring at the Terminal screen, as most Unix junkies do, you'll eventually be grateful for the preference settings that let you control how Terminal looks and acts.

Most of the options here are self-explanatory, but here are a few worth noting.

15.5.1 Terminal Preferences

This dialog box offers a couple of advanced features:

  • When creating a new Terminal window. As noted in Section 15.1, the default shell for Mac OS X is tcsh, as indicated by /bin/tcsh in the Preferences dialog box. If you, a newly skilled Unix hound, feel ready to switch to a different shell (with the understanding that many of the examples in these chapters work only in tcsh), you can specify its path here. (Don't forget to click the lower radio button, too.)

  • Open a saved .term file. If you choose to use a .term file (see Section 15.6), enter its full path here.

15.5.2 Window Settings

When you choose Terminal [image] Window Settings, the new Terminal Inspector window appears (Figure 15-8).

Figure 15-8. To access the Terminal Inspector, choose Terminal Window Settings (or -I). This window is like a preferences dialog box with many tabs, which you navigate by choosing from the unlabeled pop-up menu at the top. Two of its panels are shown here.

TIP

Changes you make in the Terminal Inspector window affect only the active window, so that you can change each open window independently. Clicking Use Settings as Default, on the other hand, applies the changes to the active window and all subsequent Terminal windows you open.

Using the pop-up menu at the top, you can choose any of the following panels:

15.5.2.1 Shell

  • When Shell Exits. When you're finished fooling around in Terminal, you end your session either by closing the window, or more properly, by typing exit (or pressing Control-D) at the prompt. This setting determines what happens when you do that.

15.5.2.2 Processes

Shell commands can take some time to complete. If you close a Terminal window before its work is finished, you cancel the process and lose your work. The options here let you configure Terminal to monitor such active processes, and warn you if closing the window or quitting will sacrifice any work.

15.5.2.3 Emulation

These options pertain to Terminal's impersonation of a traditional, metal-and-silicon terminal.

  • Option click to position cursor. This selection lets you move your insertion point on the command line by Option-clicking.

  • Output Options. By default, Terminal beeps to let you know when you've typed something it can't understand. If you're keeping your roommates awake with constant beeping, then select Visual Bell here, which quietly flashes the Terminal window instead.

15.5.2.4 Buffer

  • Scrollback Buffer. As your command line activity fills the terminal window with text, older lines at top disappear from view. So that you can get back to these previous lines for viewing, copying, or printing, Terminal offers this Scrollback Buffer, which sets aside a certain amount of memory—and adds a scroll bar—so that you can do so.

    TIP

    Although it may be tempting to set the buffer to Unlimited, restrain yourself; you'll only increase Terminal's memory use. Ten thousand lines should be plenty.

15.5.2.5 Display

Here's where you control what the insertion point looks like, along with settings like these:

  • Text. No matter what font you choose for your future Terminal sessions, note that characters in successive rows of text will line up with each other, monospaced as though they're all Monaco or Courier.

  • Anti-Aliasing. Select here to turn on font smoothing if you find that easier to read.

15.5.2.6 Color (and Transparency)

People who spend long hours in Terminal revel in its ability to serve as a software chameleon, changing its look to suit offbeat tastes (and sore eyes). For example, you can specify the colors of the type and background just by clicking one of the color swatches and making a selection from the Color Picker.

TIP

You can change the Terminal window's background by using the Terminal Inspector, but there's a more entertaining way. Choose Fonts [image] Show Colors; in the Colors dialog box, choose the color you want. Finally, drag the color rectangle at top into any empty area of the Terminal window. Boom! It changes color to match. (You can even drag the color swatch onto some text in the Terminal window to change your font color.)

You can also make your Terminal windows translucent, a sure way to make novices fall to their knees in awe. Just drag the slider to the right and watch the background of the active window nearly disappear, like the Cheshire Cat, leaving only text. (In the 10.2 version of Terminal, you no longer need a shareware hack or a secret Unix command to make this happen.)

Is this really useful? You'd have to do quite a bit of stretching to imagine how. Still, the effect is really neat, especially when you consider the drop shadows and other lighting effects that are still visible at the window edges. (Note that you can't see Classic programs through your translucent window.)

TIP

This effect looks especially cool if you make the Terminal window black with white or yellow writing.

15.5.2.7 Window

The Dimensions boxes affect the width in characters (columns) and height in lines (rows) of new Terminal windows. (Of course, you can always resize an existing window by dragging its lower-right corner. As you drag, the title bar displays the window's current dimensions.)

In the Title section, turn on the elements that you'd like Terminal to display in each window's title bar. Remember, your preferences can be different for each Terminal window; you might therefore want the windows' title bars to identify the differences.


15.6 Terminal Tips and Tricks

After you've used Terminal awhile, you may feel ready for a few of these power tips.

15.6.1 Switching Windows

You can switch among your various Terminal windows by pressing [image] -1, [image] -2, and so on (up to [image] -9). You'll be able to identify the windows easily if you choose to include the Command key in the title bars (use the Window section of the Terminal Inspector).

15.6.2 Default .term File

After you've changed Terminal's preferences, it's not easy to get the default settings back—unless you first save them in a .term file.

If you've already made changes to your Terminal's preferences, quit Terminal and temporarily remove its property list (preferences) file, called com.apple.Terminal.plist, from your Home folder [image] Library [image] Preferences folder. Drag it out of the Finder window to the desktop, for example.

Next, reopen the Terminal, where you'll find that all original settings have been restored. Save this window as a .term file named Default. Finally, quit Terminal and replace the newly created property list file (com.apple.Terminal.plist) with the one you removed initially. When you next open Terminal, you'll have your old preferences back—and a new Default item in your Library menu that will always open a factory-fresh Terminal window. (You may even consider locking the Default startup file, by opening its Get Info dialog box in the Finder and turning on the Locked checkbox.)

.term Files

Once you've got a few windows open—your main Terminal window, a couple of man (user-manual) windows, a top window showing all the running programs (Section 16.3.7), and so on—you may get dizzy just looking at the seas of black-on-white type. One easy solution is to customize the colors, fonts, and positions of your favorite windows, and then make Terminal take a snapshot of that configuration.

A Terminal .term file stores the size, location, and visible/invisible status of all windows that are open when you create the .term file. It also stores each window's preference settings, including its Font, Title Bar, and Colors settings. (It doesn't store any text in these windows.) Once you've saved a startup file, you can open it again anytime to replicate your saved window layout in Terminal.

To create a .term file, first set up the Terminal Inspector the way you like it, and then choose File [image] Use Settings as Defaults. Then open and arrange Terminal windows the way you like them, using the Terminal Inspector, if you like, to make different settings for different windows.

Next, choose File [image] Save. Use the pop-up menu in the Save dialog box to choose whether you want to save the settings for only the Main window (the active window) or for all windows. In this same dialog box, you can also choose to have the saved .term file opened when Terminal launches. (If so, the settings stored with the .term file override any settings you've made in the Terminal Inspector.)

The best place to store .term files is in your home directory's Library/Application Support/Terminal folder. (You may have to create the Terminal directory yourself.) Files saved there appear automatically in the File [image] Library menu for quick access.


Chapter 16. Fun with Unix

Chapter 15 shows you the basics of using the command line instead of the Finder for getting around and manipulating files and directories. But nobody would use Terminal if all it could do was move files around. Terminal, like Unix, is much more powerful than that.

This chapter, which assumes that you're already familiar with the Unix commands introduced in Chapter 15, offers guided tutorials for performing more specialized tasks—some of which you can't do in the Finder. These procedures, and the commands you need to perform them, are also starting points for further learning.


16.1 Moving Unmovable Files and Directories

Sooner or later, it happens to almost everyone who uses Mac OS X: The system tells you that you're not allowed to trash or even move certain files or directories. As you'll find out in this section, any of several problems may be responsible—and Terminal can help you circumvent all of them.

16.1.1 Permissions Errors

If you get the dialog box shown in Figure 16-1, you've got yourself a permissions error. Maybe you have a Normal account, but you're trying to trash something that only administrators are allowed to manipulate. Or maybe you are an administrator, and that's still not enough clearance to delete a certain directory.

Figure 16-1. If you don't own a folder (or belong to the group that does), Mac OS X steadfastly refuses to let you move or delete icons inside it—especially system files.

Suppose, for example, that you're the head of a household. You've wisely given yourself an Administrator account, and your kids have Normal accounts (Chapter 11).

As you settle down to watch your favorite reality show, you hear digitized shrieks and explosions coming from the family room. It hits you: Your kids, who should be doing their homework, are playing Backyard Stunts III again. Since this is the third time this week you've caught them goofing off, you intend to make good on your threat to remove the game from the Mac once and for all.

You have two options:

  • Barge into the family room, open the Applications folder, and try to throw away the Backyard Stunts III icon, only to realize that you're still logged in with the kids' Normal account and therefore can't trash anything in Applications. Choose [image] [image] Log Out, sign in as yourself, type your password, wait for the Finder to load, open the Applications folder, and drag the game's icon to the Trash. Log out so the kids can log back in under their own account. Effective, but unimpressive and way too time-consuming.

  • Fire up Terminal, type a quick command, and vaporize Backyard Stunts III instantly, content that you've demonstrated not only your parental authority but also your technical prowess.

(In fact, imagine that you were out of town when the issue arose. With knowledge of Terminal, you could even dial in using the ssh technique described in Chapter 21 to trash the game remotely.)

It'll take several pages to work through this example. But in the process, you'll learn an amazing amount about Terminal and the Unix underpinnings of Mac OS X.

16.1.2 The Permissions Problem

Suppose you've stormed into the family room, opened the Applications folder, and tried to throw away the Backyard Stunts III folder. As shown in Figure 16-1, you'd get nothing but an error message saying that the folder is "owned by root," a dead giveaway that you're dealing with an ownership or permissions problem.

Time to investigate the Application folder's permissions situation. One way to do that is to highlight the folder's icon and then choose File [image] Get Info (see Figure 16-2). You see that the "person" who owns the game folder is system.

Now try the same test the Unix way. To view the ownership and permissions information within Terminal, use the ls command like this: ls -al /Applications.

The -l flag gives you a long list—an expanded display. The -a flag tells the Unix shell to list invisible files, too (those whose names begin with a period). That's handy in this example, since the invisible "." directory refers to the directory you want to examine (Applications), and the ". ." directory indicates its parent directory (in this case, the root directory [Section 15.2], which is represented by a simple slash).

Figure 16-2. Suppose you're logged in with a Normal account, and you're trying to trash a folder called Backyard Stunts III. Start by examining the Applications folder, which contains it. Highlight the folder's icon and choose File Get Info. In this dialog box, expand the Ownership & Permissions section. As you can see, only the user named System—and members of the admin group—can modify ("Write") the contents of the Applications folder.

Now you see something like this at the beginning of Terminal's response:

total 0
drwxrwxr-x  27 root  admin   918 Aug 25 20:39 .
drwxrwxr-t  44 root  admin  1496 Aug 25 20:39 ..
drwxrwxr-x   4 root  admin   136 Aug 17 09:46 Acrobat Reader 5.0
drwxrwxr-x   3 root  admin   102 Jul 29 01:23 Address Book.app
drwxrwxr-x   6 root  admin   204 Aug 18 10:38 AppleScript
drwxrwxr-x   7 root  admin   238 Aug 25 20:40 Backyard Stunts III

Thanks to the -l option, the first line displays the grand total size of all the loose files in the directory. Since there are no loose files in Applications—only more directories—the total size is 0. (Remember that Mac OS X applications are packages—that is, folders disguised to look like single files.)

Next you see the names of everything in the Applications directory, each item on its own line. Not counting the dot directories (Section 15.2), you see four of the directories in Applications: Acrobat Reader 5.0, Address Book.app, AppleScript, and Backyard Stunts III. But what on earth is drwxrwxr-x? Is Terminal having a meltdown?

Not at all; you're just seeing more Unix shorthand, listed in what are supposed to be helpful columns. Figure 16-3 breaks down the meaning of each clump of text.

  • Type. The first character of the line indicates the file type—usually d (a directory), a hyphen (a file), or l (a symbolic link—the Unix version of an alias).

  • File Mode. Rammed together with the type is a string of nine characters. They indicate, in a coded format, the actual access permissions for that item, as described in the next section.

  • Owner. Next comes the account name of whoever owns this file or directory, which is usually whoever created it. Remember that root means that Mac OS X itself owns it. That's why even administrators aren't allowed to delete directories that bear "root" ownership (unless they belong to the group that owns it).

    NOTE

    In the Finder's Get Info windows, you may see ownership listed as System. That's Apple's kinder, gentler term for root.

  • Group. After the owner comes the name of the group that owns this file or directory. "Wheel," as in "big wheel," indicates the group with the highest powers (administrators are not part of this group); the "admin" group contains all administrators; "staff" is usually everybody else. (See Section 12.4 for more on groups.)

  • Pathname. The path of this file or directory.

Figure 16-3. Here's one magnified line of what the ls -al command produces. The parts you care about are in gray.

16.1.3 File-Mode Code

To understand the coded nine-character file mode section, you need a good grasp of the topics covered in Chapter 11. There you'll find out that the whole business of access privileges should interest anyone who shares a Mac, either over a network or over time (by sharing a Mac with other citizens of a family, school, or workplace).

You'll also find out that as you create new files and directories, you can specify who else is allowed to see or make changes to them. In fact, you can specify these permissions for three different categories of people: the owner (usually yourself), your group (Section 12.4), and everyone else.

The file mode column is made of three subcolumns (Figure 16-4), which correspond to those same three categories of people: owner, group, and everybody else.

Within each sequence, three characters describe the read (r), write (w), and execute (x) permissions that this person has to this file or directory. A hyphen (-) means, "Nope, this person isn't allowed this kind of access." In Figure 16-4, you can see that you, the owner of this file, can do everything you want to it—no hyphens!

Figure 16-4. If you look very closely and move your nose right up against the screen, you'll see that the file-mode column isn't just a string of random letters—it's four distinct sets of information that tell you who's allowed to do what.

There's a w in the Group column too, meaning that anyone in your group can also fool with this folder. But because there's no w in the final ("everyone else") column, the directory can't be modified by any other users.

The three forms of access—read, write, and execute—have slightly different meanings when applied to files and directories:

  • Read access to a file means that someone can open and read it. Read access to a directory (folder), on the other hand, just means that someone using Terminal can see a list of its contents using a command like ls.

  • Write access to a file means that someone can modify and save changes to it. Write access to a directory means that someone can add, remove, and rename any item the folder contains (but not necessarily the items within its subdirectories).

    NOTE

    Turning off write access to a certain file doesn't protect it from deletion. As long as write access is turned on for the folder it's in, the file is still trashable.

    To protect a certain file from deletion, in other words, worry about the access settings of the folder that encloses it.

  • Execute access, when applied to applications, means that people can run that particular program. (In fact, Unix distinguishes applications from ordinary files by checking the status of this setting.)

    Of course, you can't very well "run" a directory. If this x bit is turned on for a directory, it's called the searchable bit (as opposed to the execute access bit), and it means that you can make it the working directory, using the cd command. You still can't see what's in the folder, but you're welcome to read or copy a file in it as long as you know its full pathname.

16.1.4 Solving Permissions Problems

Back to the "can't delete this directory" problem: Its parent folder, Applications, is evidently owned by root (see Figure 16-3). Ah! There's one reason you're not allowed to trash Backyard Stunts III—you don't have the root account.

Now check the group for the Applications directory: It's admin. That's another reason why you can't trash Backyard Stunts III while still logged in with your kids' Normal account. The w in the group permissions code of the Applications folder means that the owner's group can fiddle with it. But your kids aren't members of that group.

Or are they? To find out, type groups and press Enter. On the next line, Terminal types out a list of the groups to which the account belongs. If you're logged in as a Normal account holder, it's probably just staff.

For still more clues, look at the Applications folder again and check its permissions for everyone else. There's a hyphen in the write column. Normal account holders aren't allowed to modify its contents at all.

Now you know why Normal users aren't allowed to move directories out of Applications. Only root and members of the admin group can do that. Since Normal users are neither, they're not allowed to touch that directory.

So how do you solve the problem? The most obvious approach would simply be to change the permissions of the Applications directory—but only the owner of the item can do that, and you're not the owner. Even if you were, it's not a great idea to fool around with permissions that Mac OS X itself has set up.

Another possibility: You could turn on the root account as described in Section 11.7, and then log on as root, thereby obtaining the permission you need. But that's a lot of time and hassle. And besides, turning on the root account is always an extreme step.

Thanks to Mac OS X 10.2's new Get Info dialog box, there's even another way to work around this permissions problem. You could open the Get Info window for Applications, make yourself the owner, type in your name and password to prove you're an administrator, trash the game folder, Get Info again, and change the Applications folder's permissions back again.

But for the Unix guru, that's an awful lot of steps for something that should take only a few keystrokes. As it turns out, the final possibility is quick and easy, which explains its popularity in Unix circles. It's the sudo command.

16.1.5 sudo

sudo is a great command name. Technically, it's short for superuser do, which means that you're allowed to execute any command as though you had logged in with the root (superuser) account—but without actually having to turn on the root account, log out, log back in again, and so on. (See Section 11.7 for more on the root account.)

It's also a great command name because it looks as though it would be pronounced "pseudo," as in, "I'm just pretending to be the root user for a moment. I'm here under a pseudonym." (In fact, you pronounce it "SOO-doo," because it comes from superuser do. In the privacy of your own brain, though, you can pronounce it however you like.)

NOTE

Only people with Administrator accounts can use the sudo command.

If you have the root account—or can simulate having it using sudo—you can override any permissions settings, including the ones that prevent you from moving items out of the Applications directory.

Finally, you're ready to remove that recalcitrant Backyard Stunts III directory. To use sudo, you must preface an entire command line with sudo and a space. Type this:

sudo rm -r /Applications/Backyard\ Stunts\ III/

Taken slowly, this command breaks down as follows:

  • sudo. "Give me the power to do whatever I want."

  • rm. "Trash the directory name I'm about to give you..."

  • -r. "...and all the directories inside it..."

  • /Applications/Backyard\ Stunts\ III/. "The directory I want to delete is "Backyard Stunts III," inside Applications." (Why are there backslashes before each space in the directory's name? See No Spaces Allowed.)

The first time you run sudo, you're treated to the characteristic deadpan humor of programmers worldwide: "We trust you have received the usual lecture from the local System Administrator. It usually boils down to these two things: 1) Respect the privacy of others. 2) Think before you type."

In other words, sudo is a powerful tool that lets you tromp unfettered across delicate parts of Mac OS X, and you should proceed with caution. At the outset, at least, you should use it only when you've been given specific steps to follow, as in this chapter.

Now sudo asks you for your usual login password, just to confirm that you're not some seventh-grader up to no good. If you are indeed an administrator, and your password checks out, sudo gives you a five-minute window in which, by prefacing each command with sudo, you can tromp around as though you're the all-high, master root account holder. (If you don't use sudo again within a five-minute span, you have to input your password again.)

TIP

Mac OS X comes with dozens of printer drivers—most of which are just taking up space. (After all, you probably own only one or two printers.) Since the root account technically owns them, you can use sudo to delete them.

Start by making the Printers directory the working directory (cd /Library/Printers). Now type sudo rm -r EPSON, or sudo rm -r Canon, or whatever. When you press Enter, those useless drivers are gone.

16.1.6 The Sticky Bit Error

Suppose your Mac has a handful of administrators, you and your incompetent boss Jim among them. Want to know how annoying he is? He creates a folder called Jim's Digipix right there in the hard drive window.

A few weeks later, Jim leaves the company "to pursue other interests."

After he's gone, you, with relief, decide to get rid of his silly pictures folder. But when you try to delete it, boom: "The operation cannot be completed because this item is owned by Jim." Uh-oh.

You, a shrewd Mac OS X guru, immediately question the access privileges—not of the Jim's Digipix folder, but of its parent, the folder that contains it. In this case, its parent is the hard drive window itself—the root directory (see Figure 16-5).

Figure 16-5. It doesn't make any difference who owns a folder (top and left). If your group has been given Read & Write access for the folder that contains it (right), then anyone in your group should be allowed to delete it (provided, of course, that there are no more protected directories inside). In this case, anyone in the admin group (circled at right) should be able to move anything in this folder. Clearly, there's another force at work.

You perform a File [image] Get Info [image] Ownership & Permissions directive on the hard drive icon. Sure enough, Read & Write is turned on for your group (since you're part of the Admin group). According to this dialog box, administrators should be allowed to trash anything in the main hard drive window.

"Maybe Jim protected the Jim's Digipix folder itself," somebody suggests. But lo and behold, Jim had even turned on Read & Write privileges for that folder, perhaps hoping that other administrators would put their own digital photos inside. If both a folder and its parent have given you Write privileges, you should be able to trash it, no matter who owns it.

Clearly, there's some other factor at play here.

Off you go into Terminal to check out the permissions for the relevant directories. You switch to the root directory (by typing cd /) and call up a list of what's at the root level by typing ls -al (Section 15.2). You see these entries, among many others:

drwxrwxr-t 41 root admin   1350 Jun 25 20:41 .
drwxrwxrwx  2 jim admin      24 Jun 25 20:26 Jim's Digipix

Look at the permissions in the first line, which refers to the root directory itself. Sure enough, according to the access codes (rwxrwxr-t), you and your fellow group members enjoy full access to do whatever you want to the Jim's Digipix directory inside it.

Beware the Dread Typo

Use sudo with caution, especially with the rm command. Even a single typing error in a sudo rm command can be disastrous.

Suppose, for example, that you intended to type this:

sudo rm -ri /Users/Jim/Pictures

...but you accidentally inserted a space after the first slash, like this:

sudo rm -ri / Users/Jim/Pictures

You've just told Terminal to delete all data on all drives!

Because of the extra space, the rm command sees its first pathname argument as being only /, the root directory (Section 15.3). The -r flag means "and all directories inside it."

Good thing you added the -i flag, which instructs Mac OS X to ask you for confirmation before deleting each directory. It's almost always a good idea to include -i whenever you use sudo with rm.

History buffs (and Unix fans) may remember that Apple's first iTunes 2 installer, released in October 2001, contained a tiny bug: the tendency to erase people's hard drives. (Oops!) Apple hastily withdrew the installer and replaced it with a fixed one. But behind the scenes, an improperly formed rm command was the culprit.

But look more closely at those permissions. See the -t? This t sits where the execute file mode for "everyone else" normally belongs. It tells you that this directory's sticky bit is turned on.

The sticky bit means: "I don't care what the group permissions say; only my owner (and the superuser) can mess with me." A directory whose sticky bit is set is therefore something like a drop box. In other words, anyone with write access can put icons into that directory, but only its owner can remove items from inside it, regardless of the group settings.

So who owns the root directory? Why, Mac OS X itself (or root, as circled in Figure 16-5).

As a precautionary measure, the Mac OS X installer turns on the sticky bit for the root directory (and, by the way, the Users and Users/Shared directories). That's why administrators can put things into folders like Applications and Users. However, even they aren't allowed to drag these folders out of the hard drive window.

When Jim created the Jim's Digipix folder, he wound up creating, in effect, a new member of this protected directory class. Mac OS X is treating Jim's Digipix as though it's every bit as important as System, Users, or Applications.

You could, of course, just turn off the root directory's sticky bit. Here again, though, it's not nice to go changing permissions set by Mac OS X.

Instead, the best solution would be to make yourself the owner of the Jim's Digipix directory. At that point, the sticky bit won't affect you. The sticky bit never blocks a file or folder's owner.

Once again, you could make yourself the owner in the Finder, using the File [image] Get Info command. But to do it in Terminal, you would use the chown (for "change owner") command followed by its two arguments: the new owner's account name and the pathname of the directory you want to reassign. Since Jim currently "owns" Jim's Digipix, you'll have to use sudo with chown, like this:

sudo chown -R chris /jim's\ Digipix/

(The -R flag means recursive; that is, "make all folders inside this folder mine, too." Oh, and substitute your own account name for chris.)

That's all there is to it. Jim's Digipix now belongs to you. Once you're back in the Finder, you're free to drag it wherever you please—like into the Trash.

TIP

There's also a command called chgrp that lets you change an icon's group owner. For example, to change the Library [image] Fonts directory's group owner from admin to staff, you would type sudo chgrp staff /Library/Fonts.

16.1.7 Protecting Files En Masse

It could happen to you. You've got yourself a folder filled with hundreds of files—downloaded photos from your digital camera, for example. Most are pretty crummy, but the ones you took in Tahoe (and therefore have Tahoe in their file names) are spectacular. You want to protect those files from deletion without having to turn on the Locked checkbox (Section 2.7.3) of every file individually.

Here again, you could operate in the Finder, just like ordinary mortals. You could use the Find command to round up all files with Tahoe in their names, highlight all of them in the search-results window, choose File [image] Get Info, and turn on Locked, thus protecting all of them at once. But doing it the Unix way builds character.

When you turn on a file's Locked checkbox, Mac OS X turns on an invisible switch known to Unix veterans as the user immutable flag. Not even the superuser is allowed to change, move, or delete a file whose user immutable flag is turned on.

The command you need to change such flags is chflags—short for change flags, of course. You can always read its man manual (see Section 15.4.1) to find out all the different flags it can change; for now, though, all you care about is the user immutable flag.

You can follow the chflags command with three arguments: its own option flags, the file flags, and the pathname of the file whose flags are being changed. In this case, the flag you care about is called uchg (short for user changeable; in other words, this is the immutable flag).

To protect all of the Tahoe shots in one fell swoop, then, here's what you'd type at the prompt:

chflags uchg ~/Pictures/*Tahoe*

The asterisks are wild cards that mean, "all files containing the word Tahoe in their names." So in English, you've just said, "Change the immutable flag (the Locked checkbox setting) for all the Tahoe files in my Pictures folder to 'locked.'"

TIP

To unlock a file, thus turning off its uchg flag, just add the word "no," like this: chflags nouchg ~/Pictures/*Tahoe*.

To see the results of your handiwork, you can always switch to the Finder, where you'll see that the Tahoe files now have their Locked checkboxes turned on. Or, to confirm your work right in Terminal, issue this command: ls -lo ~/Pictures (or any other path to a folder containing locked items).

That's the familiar ls (list) command that shows you what's in a certain directory, followed by an -l flag for a more complete listing, and an -o flag that produces a "flags" column in the resulting table.

In any case, Terminal might spit out something like this:

total 830064
-rw-r—r—1 chris  staff  -    158280000  Jun 16 20:05 Sunset.jpg
-rw-r—r—1 chris  staff  uchg  58560000  Jun 16 20:05 NewMoon.jpg
-rw-r—r—1 chris  staff  uchg 107520000  Jun 16 20:05 Tahoe.jpg
-rw-r—r—1 chris  staff  uchg 100560000  Jun 16 20:05 Buddy.jpg

The fifth column, the product of the -o flag, lists any file flags that have been set for each file. In this case, three of the files are listed with uchg, which represents the user immutable (locked) flag. (The hyphen for the first listed file means "no flags"—that is, not locked.)


16.2 Enabling the Root Account

Only one person is allowed to clomp through any Mac OS X directory, unfettered and unrestricted: whoever holds the root (superuser) account. There are two ways to turn on this usually hidden account: the NetInfo way (see pag349) and the Unix way.

To enable the root account in Terminal, all you have to do is make up a password for the dormant account using the passwd command.

Normal account holders can use passwd to change their own passwords (although the My Account pane of System Preferences strikes most people as a more direct way to do so). To change your own password, for example, just type passwd and press Enter. You'll be asked to type your old password, and then the new one twice.

NOTE

As you type your old and new password, no typing appears onscreen. That's a safeguard against people peeking over your shoulder as you type.

The superuser, on the other hand, can change anyone's password—including the root account's password. Fortunately, so can an administrator using sudo, like this:

sudo passwd root

At this point, sudo will prompt you for your password to confirm that you're actually an administrator. After you've entered it, the passwd utility will prompt you to enter a new password for the root account. Make it a good one: no spaces, four to eight letters and numbers long.

TIP

If you ever lose the root-account password, you can set up a new one by starting up the Mac from the Mac OS X installer CD. From the Installer menu, choose Reset Password.

Once the root account has a password, you can use it to log in with the user name root, exactly as described in Section 11.7. When you do, you'll find that the root account's Home folder isn't in the Users folder like everyone else's; instead, it's in the private [image] var folder. You'll also find, of course, that you have complete freedom to modify, move, or change access privileges for any file and folder on your system.

NOTE

Not only is your system at risk of inadvertent damage when you log in as root, but some applications may behave oddly when run by the root account. Therefore, you should log in to Mac OS X as the superuser only when you have a specific job to do, and log out as soon as you've completed the task.


16.3 Eight Useful Unix Utilities

So far, you've read about only a handful of the hundreds of Unix programs that are built into Mac OS X and ready to run. Yes, ls and sudo are very useful tools, but they're only the beginning. Here's a rundown of some more cool (and very safe) programs that await your experimentation.

TIP

If you don't return to the % prompt after using one of these commands, type q or, in some cases, quit; then hit Enter.

16.3.1 bc

Mac OS 9, Mac OS X, and Windows aren't the only operating systems that come with a basic calculator accessory; Unix is well equipped in this regard, too.

When you type bc and hit Enter, you get a copyright notice and then...nothing. Just type the equation you want to solve, such as 2+2, or 95+97+456+2-65, or (2*3)+165-95*(2.5*2.5), and then press Enter. On the next line, bc instantly displays the result of your calculation.

(In computer land, * designates multiplication and / represents division. Note, too, that bc solves equations correctly: multiplication and division before addition and subtraction, inner parentheses working toward the outer ones. For more bc tricks and tips, type man bc at the prompt.)

16.3.2 kill

Mac OS X offers no shortage of ways to cut the cord on a program that seems to be locked up. You can force quit it (Section 4.1.2), use Process Viewer (Section 9.2.24), or use kill.

The kill program in Terminal simply force quits a program, as though by remote control. (It even works when you telnet or SSH into your Mac from a remote location, as described in Chapter 21.) All you have to do is follow the kill command with the ID number of the program you want to terminate.

And how do you know its ID number? You start by running top—described in a moment—whose first column shows the PID (process ID) of every running program.

TIP

Unless you also use sudo, you can kill only programs that you "own"—those that are running under your account. (The operating system itself—root—is always running programs of its own, and it's technically possible that other people, dialing in from the road, are running programs of their own even while you're using the Mac!)

When you hear Unix fans talk about kill online, they often indicate a number flag after the command, like this: kill -9. This flag is a "non-catchable, non-ignorable kill." In other words, it's an industrial-strength assassin that accepts no pleas for mercy from the program you're killing.

If you check top and find out that BeeKeeper Pro's process ID is 753, you'd abort it by typing kill -9 753 and then pressing Enter.

TIP

Try this one when you need a laugh: At the prompt, simply type bill gates and press Enter. Also try entering just bill clinton and pressing Enter.

Does the Galactic Unix Oversight committee know about this?

16.3.3 open

What operating system would be complete without a way to launch programs? In Mac OS X's version of Unix, the command is easy enough: open -a, as in open -a Chess. The -a flag allows you to specify an application by name, regardless of where it is on your hard drive. You can even specify which document you want to open into that program by adding a space and then the document's name, like this: open -a Preview MyGraphic.tif.

TIP

The -e flag opens any text document in TextEdit, like this: open -e Diary.txt. This shortcut saves you from having to specify TextEdit itself.

The real utility of this command might not be apparent at first, but imagine doing something like this in the Finder: Select from a folder of hundreds of HTML files those that contain the word "Sequoia" in their file names and preview them all with the OmniWeb browser, regardless of what application they're actually associated with. You could do it with the help of the Finder's Find command, but that would take quite a few steps. In Terminal, though, you just switch to that directory (using the cd command) and type: open -a OmniWeb *Sequoia*. Done!

Of course, you may not often find use in simply launching programs and documents this way. But you can see how useful open can be when you're writing automated scripts for your Mac, like those used by the cron command scheduler program.

16.3.4 ps

The ps (process status) command is another way to get a quick look at all the programs running on your Mac, even the usually invisible ones, complete with their ID numbers. (For the most helpful results, use the -a, -u, -x, and -w flags like this: ps -auxw. For a complete description of these and other flags, type man ps and hit Enter.)

16.3.5 shutdown

It's perfectly easy to shut down your Mac from the [image] menu. But using shutdown in Terminal has its advantages. For one thing, you can control when the shutdown occurs, using one of these three flags:

  • Now. You can safely shut down by typing shutdown now. (Actually, only the root user is allowed to use shutdown, so you'd really type sudo shutdown now and then type in your administrator's password when asked.)

  • Later today. The -h flag means, "shut down at the time I specify." Typing sudo shutdown -h 2330, for example, shuts down your machine at 11:30 p.m. today (2330 is military-time notation for 11:30 p.m.).

  • Any time in the next 100 years. To make the machine shut down at 5:00 p.m. on November 5, 2003, for example, you could type sudo shutdown 0311051700. (That number code is in year [last two digits]:month:date:hour:minute format. So 0204051700 means 2004, April 5, 5:00 p.m.)

    TIP

    Once you set the auto-shutdown robot in motion, you can't stop it easily. You must use the kill command described above to terminate the shutdown process itself. To find out shutdown's ID number in order to terminate it, use the top or ps command.

Nor are those the only useful flags. For example:

  • The -r flag means "restart instead of just shutting down," as in sudo shutdown -r now.

  • You can use shutdown to knock all connected network users off your machine without actually shutting down. Use the -k flag, like this: sudo shutdown -k now.

One of the most powerful uses of shutdown is turning off Macs by remote control, either from across the network or across the world via Internet. That is, you can use telnet or SSH (both described in Chapter 21) to issue this command.

16.3.6 gnutar, gzip

You don't encounter StuffIt files much in the Unix world, since they're a Macintosh convention. You're much more likely to run across tar (for combining) and gzip (for compression) files. (StuffIt Expander can still expand both of these file types, however.)

Terminal lets you stuff and combine files in these formats with the greatest of ease. To compress a file, just type gzip, a space, and then the pathname of the file you want to compress (or drag the file or folder directly from the desktop into the Terminal window). When you press Enter, Mac OS X compresses the file.

Tarring a folder (combining its contents into a single file) is only slightly more complicated; you have to specify both the resulting file's name, followed by the actual directory pathname, like this: gnutar -cf Memos.tar /Users/chris/Memos. Add the -z flag to tar and compress the folder: gnutar -czf Memos.tar.gz /Users/chris/Memos.

Either way, if you switch to the Finder, you'll see that the file or folder you specified is now compressed (with the suffix .gz) or combined (with the suffix .tar), or both (with the suffix tar.gz).

Unfortunately, neither of these utilities handles resource forks properly (Section 15.3); you need to compress those files with DropStuff. Or, if you can't bear to be away from Terminal, you can use hfspax, a Unix utility that properly combines files with resource forks. (You can download it from http://homepage.mac.com/howardoakley.)

You can also use these utilities to open combined and compressed files, but they can easily overwrite existing items of the same name if you're not careful. Use StuffIt Expander to eliminate that worry.

TIP

The gzip command deletes the original file after gzipping it. The gnutar command, on the other hand, "stuffs" the folder but leaves the original alone.

16.3.7 top

When you type top and press Enter, you get a handy table that lists every program that's currently running on your Mac, including the obscure background ones you may not even know exist (Figure 16-6). (To be more specific, you get the top 20; make the window taller to see the rest.)

Figure 16-6. The top display remains onscreen, automatically updating itself as you work, until you type q to quit the program. The plain-English program names are in there somewhere...

You also get statistics that tell you how much memory and speed (CPU power) they're sucking down. In this regard, top is similar to Process Viewer, described in Section 9.2.24.

TIP

If you type top -u, you get a list sorted by CPU usage, meaning the power-hungry programs are listed first. If your Mac ever seems to act sluggish, checking top -u to see what's tying things up is a good instinct.


16.4 Where to Go from Here

This crash course in Unix should give you a first helping of guidance—enough to perform some genuinely useful tasks in Mac OS X, and to acquire a feeling for how Unix commands work.

There's a lot more to learn, however. As you peruse beginner-level Unix books and Web sites (see Appendix E), for example, you'll gradually become familiar with a variety of important terms and tools.

16.4.1 Aliases

Don't be confused: Aliases in Unix have nothing to do with traditional Macintosh icon aliases. Instead, Unix aliases are more like text macros: longish commands that you can trigger by typing a much shorter abbreviation.

For example, remember the command for unlocking all the files in a folder? (It was sudo chflags -R nouchg [pathname]. To unlock everything in your account's Trash, for example, you'd type sudo chflags -R nouchg ~/.trash.)

Using the alias command, however, you can create a much shorter command (unlock, for example) that has the same effect. (The alias command takes two arguments: the alias name you want, and the command it's supposed to type out, like this: alias unlock sudo chflags -R nouchg ~/.trash.)

On the down side, aliases you create this way linger in Terminal's memory only while you're still in the original Terminal window. As soon as you close it, you lose your aliases. When you get better at Unix, therefore, you can learn to create an aliases.mine file that permanently stores all your command aliases.

Secrets of Virtual Memory

The top command's table offers a fascinating look at the way Mac OS X manages memory. At the end of the "Processes" section above the table, for example, you'll see current statistics for pageins and pageouts—that is, how many times the virtual-memory system has had to "set down" software code for a moment as it juggles your open programs in actual memory. (These numbers are pointed out in Figure 16-6.)

The pageins and pageouts statistics are made of two different numbers, like this: 45451(0) pageins, 42946(0) pageouts. The big number tells you how many times your Mac has had to shuffle data in and out of memory since the Mac started up. The number in parentheses indicates how much of this shuffling it's done within the last second.

This is the number to worry about. If it stays above zero for a while, your Mac is gasping for RAM (as the hard-drive thrashing sounds and program-switching delays are probably also telling you).

In the listing of individual programs, the last four columns provide details about the memory usage of each listed program. The one you care about is the RPRVT (Resident Private) column, which shows how much memory each program is actually using at the moment. (If you remember the About This Macintosh memory graph of Mac OS 9, then you probably remember the filled portion of the memory bars. That's what this number tells you: how much memory each program is actually using.) This number goes up and down as you work, and that's the miracle of Mac OS X: Programs don't just grab a chunk of memory and sit with it; they put RAM back in the pot when they don't need it.

16.4.2 pico, emacs, vi

One way to edit text files containing aliases (and to perform other command-related tasks) is to use pico, one of the most popular text processors (see Figure 16-7).

As you'll discover just by typing pico and pressing Enter, pico is a full-screen Unix application. You enter text in pico much as you do in TextEdit or SimpleText, yet pico is filled with features that are especially tailored to working with Unix tasks and commands.

Nor is that the only text editor that's built into the Unix under Mac OS X. Some Unix fans prefer the more powerful and complex vi or emacs, in the same way that some people prefer Microsoft Word to AppleWorks.

Figure 16-7. A new pico session. One key difference between pico and, say, TextEdit: To scroll, you must use the up and down arrow keys, or the Prev Pg and Next Pg commands—not the Terminal scroll bar.

Eliza, I Have Issues With My Mother

Therapy, whether it's about your frustrations with your Mac or any other subject, is expensive. Still, it feels good to talk to someone about whatever's bothering you—and Mac OS X is ready to listen.

Hidden in the emacs text- editing program is a fully unlicensed automated psychoanalyst named Eliza. To enter her office, open Terminal, type emacs, and press Enter. After the introductory screen has appeared, press Shift-Esc, type xdoctor, and press Enter.

"I am the psychotherapist," Eliza begins. "Please, describe your problems. Each time you are finished talking, type RET twice." (She means, "Press the Return key twice.")

As you can see from this illustration, she isn't exactly Sigmund Freud. But she's very entertaining, and surprisingly responsive.

When your session is finished, press Control-X and then Control-C to quit both Eliza and emacs.

16.4.3 date

Used all by itself, the date command simply displays the current date and time. However, you can use its long list of date "conversion specifications" (if you've installed the Developer Tools as described in The Developer Tools CD Extras, enter man strftime to see all of them) to format the date string in any conceivable way. Begin the string with a + and then enter the formatting you like, mixing in any regular text as well, like this:

[office-mac:~] chris% date +"I can't believe it's already week
%V of %Y, here in the %Z time zone. But what do you expect on a
%A at%l:%M %p?"

I can't believe it's already week 25 of 2003, here in the PDT
time zone. But what do you expect on a Monday at 4:55 PM?

NOTE

Be careful about using date with sudo. If you do, and accidentally forget the leading +, you'll reset your Mac's built-in clock.

16.4.4 grep

The grep program is a filter, a powerful program designed to search data fed to it on a quest for text that matches a specified pattern. It can pass on the processed result to another program, file, or the command line itself.

You specify the text pattern you want grep to search using a notation called regular expressions. For example, the regular expression dis[ck] will search for either disk or disc. Another example: To search for lines containing the file names Yosemite1.mov, Yosemite2.mov, and Yosemite3.mov, you could tell grep that you're looking for Yosemite[1-3]\.mov.

But grep can search much more than just file and directory names. Its search material can be part of any file, especially plain text files. The text files on your Mac include HTML files, log files, and—possibly juiciest of all—your email mailbox files. Using grep, for example, you could search all your Mail mail for messages matching certain criteria with great efficiency.

16.4.5 find

Now that the Finder can actually find files again, you might wonder why you would need to use the Unix find command. Well, for one, find takes file searching to a whole new level. For example, you can find files based on their permissions, owner name, flag settings, and of course any kind of name pattern you can think of using regular expressions.

Also, like most other Unix commands, you can "pipe" the find command's list of found files straight into another program for further processing. You might do this to change their names, convert them to other formats, or even upload them to a network server.

Perhaps best of all, since you can run find with sudo, you can look for files existing anywhere on your hard disk, regardless of directory permission settings.

To find all files in your Home directory with "Bolinas" in their names, for example, you would use this command:

find ~/ -name "*Bolinas*"

Or, to ignore capitalization:

find ~/ -iname "*Bolinas*"

And this command will search for all the locked files in your Home directory:

find ~/ -flags uchg

16.4.6 cron

This little Unix program can trigger certain commands according to a specified schedule, even when you're not logged in. People use cron to trigger daily backups or monthly maintenance, for example. You program your unattended software robot in simple text files called crontabs.

Mac OS X comes set up to run cron automatically. (If you open the Process Viewer program in your Applications [image] Utilities folder, you'll see it listed among the programs that your Mac is running all the time.)

In fact, it comes with three under-the-hood Unix maintenance tasks already scheduled; there's a daily cron, a weekly cron, and a monthly cron. They come set to run at 3:15 a.m., 4:30 a.m., and 5:30 a.m., however. If your Mac isn't generally turned on in the middle of the night, these healthy cron jobs may never run.

You can either leave your Mac on overnight every now and then or, if you're feeling ambitious, change the time for them to be run. A glance at man 5 crontab shows you how. (Hint: It involves using sudo pico and editing the crontab file.)

16.4.7 curl

With curl, all you need is a file's URL and you can download it from an FTP site, Web server, or even an iDisk, without launching an FTP program or enduring a single pop-up ad. To download the entire "missing CD" for the first edition of this book (see the inside back cover), say, you could just type this:

curl -O http://examples.oreilly.com/macosxmm/macosxmm_all.zip

When the download is complete, you see a note in the Terminal window and the downloaded file appears right there in your working directory.

You can also this command to upload a file, using the -T flag. To add something to your iDisk's Documents folder, for example, use this command line:

curl -T BigBasin.sit http://coast_photo@idisk.mac.com/coast_photo/Documents

In this example, the name of the file you're uploading is BigBasin.sit, and the iDisk's name is coast_photo.

You'll be asked for your .mac password, and then the upload begins.

NOTE

If you get a "malloc" error message, ignore it. That's just a bug in older versions of curl, and it doesn't affect the upload.

16.4.8 telnet, ftp

Telnet and FTP aren't exclusively Unix programs, of course; techies from all walks of operating-system life have used telnet for years whenever they want to tap into another computer from afar, and FTP to deliver and download software files. Details on both are in Chapter 21.


16.5 Putting It Together

Suppose you want to round up all the recently modified files related to your Yosemite project, compress them into a single archive, and copy them to your iDisk. How would you go about it?

You could, of course, use the Finder's Find command to search for all files modified today that have "Yosemite" in their names. Next, you would select the found files from the search results window and drag them onto the icon of DropStuff icon—which (oh, right!) you had the foresight to add to your Dock or desktop from the Applications (Mac OS 9) [image] Internet Utilities [image] Aladdin folder. You would then need to go online and choose Go [image] iDisk to bring your iDisk's icon to the desktop. Finally, you would drag your newly created Yosemite.sit file into the iDisk's Documents folder.

If you were especially clever, you might remember that the Backup program that came with your .Mac account could automate the uploading part of this ritual—but not the finding part.

But if you'd gained some mastery of Unix, you could shave 12 minutes off of your workday just by typing this:

set f = 'date +%m%d.tar.gz' ; find ~ -type f -iname '*yosemite*'
-mtime 1 -print0 | xargs -0 gnutar -czf $f ; curl -T $f http://
idisk.mac.com/coast_photo/Public/

Even after two chapters of Unix basics, that mass of commands probably looks a tad intimidating. And, indeed, if you've never programmed before, even the following breakdown may make your eyes glaze over. But even so, pieces of it should now look familiar.

  • set f = 'date +%m%d.tar.gz' ; . Well, you've seen the date command before; tar.gz suggests that something is about to be compressed into an archive file. But what are those single quotes?

    Commands placed within backward single quotes (back ticks) will be replaced by the result of the command between the quotes. Between the back ticks in this example is a date command that produces a string of text starting with the month number and day, plus ".tar.gz" (the file extension for tarred and zipped archive files). This piece of the command line will produce a file named with today's date (and the tar.gz suffix)—a file name you want the command to remember, for the moment, by memorizing it in a shell variable (temporary memory bank) called f. (You could call it anything. The set command is what tells Terminal to sock the following stuff away in f.)

    The semicolon at the end of this fragment tells the shell to run the next command when it's finished with the previous one.

  • find ~ -type f -iname '*yosemite*' -mtime 1 -print0 |. This segment searches your Home directory (~) for files (-type f) whose names contain the word Yosemite—and that were modified (-mtime) within one 24-hour period.

    The -print0 command formats the list of found files' pathnames, separating them with the null character (a special character that programmers use to indicate where one string of text ends and another begins) instead of the usual spaces. It lets the command work with pathnames that contain spaces, something common on Macs. You'll see how it does this shortly.

    Then comes the pipe (the vertical bar), which you can use to direct the results (output) of one command into the input of another. In this case, it sends the list of found pathnames on to the next command.

  • xargs -0 gnutar -czf $f ;. xargs is an argument builder. In this case, it builds an argument from the list of files it received from the find command and provides it to gnutar, a Unix program that does the hard work of tarring and zipping the files. The -0 flag tells xargs that the pathnames are separated by the null character (otherwise, xargs would separate pathnames at each space character, which would choke gnutar).

    Gnutar's flags tells it to create an archive file in the working directory (using list of pathnames provided by xargs), compress it, and use, as the new file's name, the text string stored earlier in the f variable. (Preface a variable name with a dollar sign when you're referring to it rather than defining it.)

  • curl -T $f http://idisk.mac.com/coast_photo/Public/. This curl command uploads the file referred to by the f variable, now in the working directory, to a Public iDisk folder of the coast_photo .Mac account. (This is all you would need if you've allowed guests to read, and write to, files in your Public folder, as described in Section 11.4.)

When you press Return or Enter after this gigantic command, Mac OS X scans all the directories inside your Home directory, rounds up all the Yosemite-related files you worked on today, combines them, zips them, and then uploads the archive.

Once you've gained some experience with Unix commands and programs like these, you'll find it fairly easy to adapt them to your own tasks. For example, here's a command that searchers the entire Users directory for file names containing "final exam" that aren't owned by "scott," combines and zips them, and then uploads the resulting archive to a school teacher's FTP directory:

sudo set f = tests'date +%m%d.tar.gz' ; find /Users -type f -
iname '*final exam*' \! -user scott -print0 | xargs -0 gnutar -
czf $f ; curl -T $f ftp://scott@ftp.lincoln-hi.edu/scott/tests/

With just a few more keystrokes, you could modify that command to collect some files, lock them, and place copies of each in every user's Home directory, as well as several different iDisks at the same time, emailing you a report when it's done. Using the cron command, you could even configure this routine to trigger itself automatically every day at 11:00 pm. Between the hundreds of Unix programs included with Mac OS X and the thousands of others available on the Internet, the possibilities are limitless.

For some guidance in picking up your Unix career from here, see Appendix E.

TIP

Many a programming toolkit helps you spot missing parentheses and quotes. For example, if you enclose a word in a command with only an open quote, but forget to add the close quote, the error message might read, "Unmatched."

However, that message takes on a whole new meaning when, at the % prompt, you type, What's my skill at chess?

The Famous Animated-Desktop Trick

It was one of the first great Mac OS X 10.2 hacks to be passed around the Internet: the classic "screen-saver-on-the-desktop" trick. In this scheme, your desktop shows more than some wussy, motionless desktop picture. It actually displays one of the Screen Effects animation modules.

Start by choosing the screen saver module you prefer, using the Screen Effects panel of System Preferences. (The one called "flurry" makes a good choice.)

Then, in Terminal, type: /System/Library/Frameworks/ScreenSaver.framework/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine-background &

...and then press Enter. (Note that there are no spaces or returns in the command, even though it appears broken onto more than one line here.)

Presto: The active screen saver becomes your desktop picture! Fall back into your chair in astonishment.

Once you've regained your composure, look in the Terminal window again. The number that follows the [1] in the following line is the process ID of your background desktop program (see Section 16.3.7).

You'll need that number when it comes time to turn off the effect, which is a good idea; the desktop/screen saver business drains a massive amount of your Mac's processing power. The whole thing is a gimmicky showoff stunt you'll generally want to turn off before conducting any meaningful work.

To turn off this effect, type kill 496 (or whatever the process ID is) and then press Enter.

And if you get tired of typing out that long command, download xBack from www.gideonsoftworks.com/xback.html. It's a simple piece of shareware that lets you turn this effect, plus many additional options, on and off with the click of a mouse.


Chapter 17. Hacking Mac OS X

Chapter 8 shows you how to customize your desktop picture, error beep, and screen saver. But beyond those simple modifications, Mac OS X offers only a subset of the tweakable features found in other operating systems. You can no longer record sounds, change the fonts used in the Finder, adjust the colors of your scroll bars, and so on.

If you're sneaky, creative, or just different, however, you can indeed perform more dramatic visual and behavioral surgery on your copy of Mac OS X—from changing the startup screen image to replacing the "poof" that appears when you drag something off the Dock with a new animation of your own. All you need is a few of Mac OS X's less obvious tools, or even free downloadable customizing software, and a few recipes like the ones in this chapter.

Some of these tricks are frivolous. Some are actually functional and useful. And although Apple sanctions not a one, all are perfectly safe.

NOTE

History has shown that Apple considers Mac OS X a work in progress. A huge number of the fun little hacks that worked in Mac OS X 10.1 stopped working in 10.2. All of the tricks in this chapter work in 10.2, but may well "break" in subsequent versions of Mac OS X. The Errata page for this book at www.missingmanuals.com will keep you up to date.


17.1 TinkerTool: Customization 101

If you poke around the Mac OS X Web sites and newsgroups long enough, you'll find little bits of Unix code being passed around. One of them purports to let you change the genie animation that you see when you minimize a window to the Dock. Another eliminates the drop shadow behind icon names on your desktop. Yet another lets you change the transparency of the Terminal window (Chapter 15)—a cool, although not especially practical, effect.

If you really want to fool around with these bits of Unix code, go for it. You'll find most of these tidbits at Web sites like www.macosxhints.com.

The truth, however, is that there's no good reason for you to subject yourself to the painstaking effort of typing out Unix commands when easy-to-use, push-button programs are available to do the same thing.

TinkerTool 2, for example, is a free utility that shows up as a new icon in System Preferences (Figure 17-1). It offers an amazing degree of control over the fonts, desktop, Dock, scroll bar arrows, and other aspects of the Mac OS X environment. (You can download it from the software page of www.missingmanuals.com, among other places.)

Figure 17-1. TinkerTool takes the form of a new System Preferences panel, which sits in a new Other category. Whenever you see dimmed controls (like the "Desktop background" pop-up menu), you're seeing an option that's available only for Mac OS X 10.1. These are unnecessary, or "broken," in 10.2.

Here are some of the highlights:

  • Zooming rectangles. When you open any icon, you see an animated expanding-rectangle effect to simulate the expansion of that icon into a window. It's nice, but it takes time. Using TinkerTool, you can turn off this effect.

  • Dock. TinkerTool enables you to make hidden programs appear with transparent icons on the Dock and specify the Dock's position on the screen—left, right, bottom, or top—and even whether it's centered or flush against one side of the screen. TinkerTool even unlocks a third option for the animation of windows collapsing onto the Dock; in addition to the standard Mac OS X choices (Genie and Scale), you also get something called Suck In (no comment).

  • Scroll bars. TinkerTool gives you greater control over the placement of Mac OS X's scroll-bar arrows—together at one end of the scroll bar, duplicated at both ends of the scroll bar, and so on.

  • Language. A pop-up menu lets you specify which language Mac OS X starts up in.

  • Fonts. TinkerTool lets you change the default fonts that show up in the dialog boxes of your programs, such as the names of the icons in System Preferences. (Even TinkerTool doesn't let you change the menu bar font or the fonts used by desktop icons, however.)

What's great about TinkerTool is that it's completely safe. It's nothing more than a front end for a number of perfectly legitimate Unix settings that Apple simply opted not to make available in the regular Finder. Furthermore, the changes you make using TinkerTool are stored in your own Home folder [image] Library folder—that is, they affect only your account. Whatever changes you make don't affect the Mac experience for anyone else using your machine.


17.2 Redefining Keystrokes

If [image] -S has never made sense to you as the keystroke for Save, or if some program you use has a menu command that lacks a keyboard equivalent altogether, this one is for you. Using the defaults command in Terminal (Chapter 15), you can easily massage whichever keystrokes you like—at least in any Cocoa program (Section 4.6).

Launch Terminal and type this command carefully, including the punctuation, precisely as shown here, taking care to substitute appropriate commands for those shown here in bold:

defaults write com.apple.Mail NSUserKeyEquivalents '{"Activity Viewer"="*a";}'

Here's what to put in place of the bold elements above:

  • Mail. Type the name of the Cocoa program containing the menu command you want to change. (Mac OS X's Cocoa programs include Stickies, Mail, Address Book, and TextEdit.)

  • Activity Viewer. Replace this with the wording of the command as it appears in the program's menus.

  • *A. Replace these two characters with the keystroke you want to trigger the menu command from now on. Instead of the asterisk (*), however, type @ for the [image] key, $ for the Shift key, ~ for the Option key, and ^ for the Control key. Follow these modifier stand-ins with the letter key you want. In other words, if you type $~D, you've just changed the keyboard equivalent of the menu command to Shift-Option-D.

Assuming you've typed the command correctly, when you press Enter you'll get no reaction from Terminal except another % prompt. Launch the program you modified and check out the results for yourself.

What's impressive about this procedure is that it affects only your own Library folder, which means that the keyboard equivalent has changed only for your account. When other people log in and use the same program, they'll see it the way it was before you went to work changing keystrokes.

TIP

You use this same procedure both when changing an existing keystroke assignment and when assigning a new one.


17.3 Redoing Mac OS X's Graphics

The professional interface artists at Apple use Photoshop, just like professional artists everywhere else. But in Mac OS X, they've made very little effort to cover their tracks. In Cocoa programs and even a few Carbonized ones, every element of the famous Aqua interface is nothing more than a Photoshop-generated graphics file.

The great thing about graphics files, of course, is that you can edit them. Maybe you just want to adjust the colors. Maybe you found a replacement graphic online. Or maybe you actually want to draw a new graphic from scratch. In each of these cases, using a program like Photoshop, Photoshop Elements, or GraphicConverter, you can dress up your own desktop in your own way.

In addition to a little artistic talent, all you need to know is how to open the graphics that constitute the interface of each program. The routine generally goes like this:

  1. In the Finder, open the Applications folder. Control-click the icon of the ".app" program you want to edit; choose Show Package Contents from the contextual menu.

    You may remember from Chapter 4 that most Mac OS X programs may look like single icons, but are actually disguised folders containing all of their own support files.

    You can choose almost any Cocoa program to edit in this way: Address Book, Chess, Clock, iChat, Mail, iPhoto, whatever.

  2. Open the Contents [image] Resources folder.

    Inside are the objects of your search: the TIFF or PDF files that constitute the "face" of the program you're editing. (Sometimes they're one more folder down, in a folder representing your language—English.lproj, for example.)

    When you're editing the Mac OS X Chess game, for example, you'll find a file called 3D_board.tiff, which represents the game board, as well as individual graphics representing all the pieces. There's nothing to stop you from swapping in photos of your friends' heads in their places.

    When you're editing the Clock program, you can edit the Clock02.tif file to stamp your logo right onto the face of the analog Clock! (Why should you send away $20 apiece for cheapo company-logo watches for your employees?) To change the digital clock/calendar, on the other hand, operate on the file called background.tif. Figure 17-2 shows the result.

    While you're at it, you may also want to open up Mac OS X's Mail program and redesign its toolbar icons. The sky's the limit!

    TIP

    If you think you may want to go back to the program's original look after your experiment, make a safety copy of these files before proceeding.

  3. Open the TIFF files in Photoshop.

    Edit them brilliantly.

  4. Save your changes.

    The deed is done. You now have Cocoa programs that you can decidedly call your own.
Figure 17-2. Cocoa programs are nothing more than a bunch of artistically done Photoshop TIFF files. When you feel the need for change, go ahead and edit them—hey, it's your computer. To see the results of your editing (right), be sure to choose Clock Preferences and turn on "Display in a floating window" (left). If the new clock face isn't dark enough, drag the Transparency slider to the right.

17.3.1 Editing the Trash and Finder Icons

You can edit the Finder dock icon and the Trash icons (empty and full) exactly as described above—but you have to peek into a different corner to find them. The Dock program, after all, isn't in your Applications folder; they're in your System folder. And in Mac OS X, the System folder is sacred territory, forbidden to humans.

That's why editing the graphics files that make up Mac OS X itself (rather than its applications) involves restarting in Mac OS 9. Doing so bypasses the objections you'll get from Mac OS X itself as you try to hack the system. (There is an alternative, however: logging into Mac OS X as the root user, as described in Section 11.7. For many people, though, simply restarting in Mac OS 9 is a less intimidating routine.)

Once you've done so, open the System [image] Library [image] CoreServices folder. Control-click Dock.app and choose Show Package Contents from the contextual menu. Surprise! You can even open Mac OS X-style "packages" (When Programs Are Actually Folders) in Mac OS 9.

In any case, the Dock.app window opens. Open the Contents [image] Resources folder. These are the graphics you want to edit (as PNG graphics instead of TIFF): finder.png, trashempty.png, and trashfull.png.

17.3.2 Replacing the Poof

When you drag an icon off the Dock or toolbar, it disappears with a literal puff of smoke—a cute, cartoon-like animation that Apple's been trying to work into its operating systems ever since the days of the Newton palmtop. Most people find this tiny, one-second display of interface magic charming and witty, but others argue that it demeans the dignity of the otherwise professional-looking Mac OS X.

If you follow that latter camp, you can replace the animation just by editing Apple's own five-frame "poof" animation. You'll find it sitting inside the Dock.app package, as described in the previous paragraphs, alongside the finder.png and trash files. Figure 17-3 shows the procedure.

Figure 17-3. The "poof" animation is nothing more than five individual frames of cartoon smoke, 128 pixels square. As shown here in Photoshop Elements, you can substitute any graphics you want, as long as you fit them evenly on this 640-pixel-tall "film strip" (that is, 128 pixels times 5). Save, quit, and then restart in Mac OS X.

17.3.3 The Startup and Login Screens

Yeah, yeah, sure, Mac OS X makes it easy to change the desktop picture. But what about the boring Mac OS X, blue-Apple-logo picture that appears while the startup progress bar is chugging across the screen? And what about the default swirling blue desktop picture that appears behind the sign-in screen?

Don't despair—you can make these look like anything you want. Restart in Mac OS 9 and then proceed like this:

  • The background behind the "Welcome to Mac OS X" sign is a JPEG graphic, called Aqua Blue.jpg, located in the Library [image] Desktop Pictures folder. (Classic Aqua Blue.jpg was the standard desktop picture in Mac OS X 10.1.) You can just edit this file—or replace it with another graphic having the same name and file format. At the next startup, you'll enjoy your new background.

  • The sign-in screen graphic is only slightly harder to change. Using Photoshop, choose File [image] Open. Navigate to and open System [image] Library [image] CoreServices [image] SystemStarter [image] QuartzDisplay.bundle [image] Resources [image] BootPanel.pdf. As always, you can edit this file to your heart's content. After you save changes and then restart, you'll find your new graphic in place (Figure 17-4).

Figure 17-4. Photoshop can directly edit the PDF files that constitute certain Mac OS X interface elements—like the graphic behind the login screen.

17.3.4 Editing Your Menulets

You can colorize the little menu-bar symbols fondly called menulets (see Section 3.6), or even completely redesign their graphics. Like many other Mac OS X screen elements, these are nothing more than little tiny graphics saved in PDF format.

You can edit them, as usual, by restarting the Mac in Mac OS 9 and launching Photoshop. Choose File [image] Open and navigate to the System [image] Library [image] Core Services [image] Menu Extras.

You'll find that the Menu Extras folder contains individual "folders" (actually packages) for every possible menulet: Battery, Clock, Displays, and so on. Open whichever one you want to customize (Airport.menu, for example) by Control-clicking it and choosing Show Package Contents. As usual, open the Contents [image] Resources folder.

Inside are a number of TIFF files that represent the various forms your menulet might take; the Volume icon, for example, seems to emit different numbers of sound waves depending on your volume setting. Edit each of the graphics as you see fit. (The ones whose names are tagged with an s or w represent the inverted highlighted graphic, which you see when you actually click the menulet.)


17.4 Replacing Your Home-Folder Icon

The icon Mac OS X uses for your Home folder looks like a fairy tale cottage: one door, one chimney, one window. That's great for the masses, but if it strikes you as too much of a sissy house, you can substitute a graphic that suits you better: Trump Tower, a cave mouth, prison bars...

The file to edit is in the System [image] Library [image] CoreServices [image] SystemIcons.bundle [image] Contents [image] Resources folder; it's called SystemIcons.rsrc.

This, unfortunately, is not a standard graphic that any old Photoshop or GraphicConverter can open. Instead, opening it requires a shareware program called Iconographer X. (It's available at www.missingmanuals.com, among other places.)

Iconographer isn't a piece of cake to master—you need to create your icons in several different sizes, complete with a black silhouette mask (to make it opaque) for each size. But if you're enough of a perfectionist to want a different Home icon, you'll put in the time. See Figure 17-5.

Figure 17-5. First, from www.missingmanuals.com, download Iconographer X (shown here). Use it to open your SystemIcons.rsrc file, which contains many of Mac OS X's basic icons. Then replace the icon with one of your own design— or one you've downloaded from Pixelpalooza.
    [ Team LiB ]


17.5 Replacing the Finder Icons

This one's easy: Just download CandyBar, a simple drag-and-drop program for Mac OS X 10.2. With no technical skill whatsoever, you can use this program to replace the icon pictures featured on your folders, disks, and the Finder toolbar. It even comes with several collections of perky (but non-photorealistic) replacement icons (Figure 17-6).

Figure 17-6. To use CandyBar, just drag your new icons onto the appropriate slots (lower left). When you restart the Mac, you'll find your new icons in place, as shown here on the toolbar (upper right). Restoring the original icons is equally simple. (Note that replacing the Home icon changes only the toolbar icon for Home—not the Dock icon, which requires the Iconographer technique described above.)
    [ Team LiB ]


17.6 Rewriting the Words

Mac OS X stores the text and settings of its menus, dialog boxes, and other elements in special text files called plist (for Property List) files. They sit in one of the three Library folders (in your Home folder, the System folder, or the hard drive window).

The easiest way to edit them is to use Apple's PropertyList Editor, a program that came on your Mac OS X Developer CD. Once you've installed your developer tools as described in The Developer Tools CD Extras, you'll find PropertyList Editor in Developer [image] Applications.

There are hundreds of plist files, so some experimentation and patience is required. Most of the cool changes you can make to your plists can be made much more easily using TinkerTool, described at the beginning of this chapter. Here, however, is an example of a smaller change you can make this way.

17.6.1 Renaming the Trash

It's called Trash, but in Mac OS X, it looks more like an office wastebasket. When inspiration on the work you're supposed to be doing runs dry, consider remedying this discrepancy by changing the name of the Trash icon to something more appropriate.

In PropertyList Editor, choose File [image] Open. Navigate to System [image] Library [image] Core Services [image] Dock [image] Contents [image] Resources [image] English.lproj [image] InfoPlist.strings.

Click the Root triangle to view and edit the three settings, as directed in Figure 17-7.

Figure 17-7. Top: This simple file contains the name of the Trash icon on the Dock—and the name of the Eject icon that replaces it when you're dragging a disk. By double-clicking the text in the Value column, you can edit these descriptions to change the corresponding names. Bottom: The resulting Trash has a very different name.

Once you're finished making the change, choose File [image] Save As, and save your edited plist document to the desktop. You can't simply save changes to the original, because Mac OS X is extremely protective of its System folder. Instead, you must now replace the original document (after making a safety copy, if you like) with your edited version. To do that, you must dodge Mac OS X's system software security in one of these ways:

  • Restart in Mac OS 9.

  • Log in as the root user (Section 11.7).

  • Log in as >console, a technique described in Section B.11. (This deposits you at a command line interface, and is therefore best for Unix aficionados. If you're one of them, use the sudo command to do your dirty deeds.)

In any case, the next time you log in, you'll see your new name on the Trash.

17.6.2 Rewording the Dock

Using the same routine described in the previous paragraphs, you can edit all of the commands that pertain to the Dock—both its commands in the [image] menu (Dock Preferences, Turn Magnification On, and so on) and the contextual menus that pop out of the Dock icons themselves. These wordings are in System [image] Library [image] Core Services [image] Dock.app [image] Contents [image] Resources [image] English.lproj [image] DockMenus.plist. Click the flippy triangles to see the various commands you can rewrite.


Part V: Mac OS X Online

Chapter 18: Internet Setup, the Firewall, and .Mac

Chapter 19: Mail

Chapter 20: Sherlock

Chapter 21: Web Sharing, FTP, and Remote Access


Chapter 18. Internet Setup, the Firewall, and .Mac

As Apple's programmers slogged away for months on the massive Mac OS X project, there was one spot where they must have felt like they were happily gliding on ice: networking and the Internet. For the most part, the Internet already runs on Unix, and hundreds of extremely polished tools and software chunks were already available.

Most people connect to the Internet using a modem that dials out over ordinary phone lines. But a rapidly growing minority connects over higher-speed wires, using so-called broadband connections that are always on: cable modems, DSL, or corporate networks. This chapter explains how to set up each one (and how to use each with a wireless AirPort system).

This chapter also describes some of Mac OS X's offbeat Internet featurettes: the iDisk, a backup or transfer disk that resides on the Internet; the other Apple ".Mac" account features, including HomePage (which lets you publish your own Web pages); the new Internet Connection Sharing, which lets several computers in the same household share a single broadband connection; and the system-wide Internet bookmarks known as Internet location files.


18.1 The Best News You've Heard All Day

If you upgraded to Mac OS X 10.2 from an earlier version of the Mac OS (like Mac OS 9 or Mac OS X 10.1), breathe easy. Mac OS X was kind enough to pick up your networking and Internet settings from that earlier installation. The moment you first see the Mac OS X desktop, you're ready to use the Internet (and skip the next two pages).

Read on, however, if you are setting up a new Mac, want to create a new Internet account, used Mac OS X's "clean install" option (Appendix A), or otherwise need to plug in the Internet settings manually.


18.2 Connecting by Dial-up Modem

If you intend to connect to the Internet via ordinary phone lines, courtesy of your Mac's built-in modem, you need to sign up for Internet service. Hundreds of companies, large and small, would love to become your Internet service provider (ISP), generally charging $20 or $22 per month for the privilege of connecting you to the great Internet.

A setup program for Earthlink, a popular ISP, presents itself as part of the Setup Assistant program that runs the first time you turn on a new Mac.

But if you aren't starting in such virgin territory (or if you want to sign up with a different ISP), you must plug a series of settings into the Network pane of System Preferences. This process may require the assistance of your ISP—in the form of its Web page, the little instruction sheets that came with your account, or a help-desk agent on the phone.

NOTE

The following instructions don't pertain to America Online. It comes with its own setup program and doesn't involve any settings in System Preferences.

18.2.1 Phase 1: The TCP/IP Tab

Start by opening System Preferences and clicking the Network icon. (You might suppose that the Internet tab would be the right place to start. But as described in Chapter 8, you use that control panel simply to specify your favorite Web browser, email program, and so on.)

When you choose Internal Modem from the Show pop-up menu, you see a Configure pop-up menu and two text boxes. Your main mission here is to fill in the Domain Name Server numbers provided by your ISP—at least if you hope to get onto the Web. If Using PPP is selected in the Configure pop-up menu, then move on to Phase 2. (If you find yourself unable to get online, however, contact your ISP on the off chance that some unusual settings are required here.)

18.2.2 Phase 2: The PPP Tab

Now click the PPP tab (Figure 18-1) and fill in the blanks like this:

  • Service Provider. Type in the name of your ISP, if you like (EarthLink, for example).

  • Account Name. Your account name, as assigned by the ISP, is one of the most important pieces of information yet. If you're BillG@earthlink.net, for example, type BillG here.

  • Password. Specify your ISP account password here. Turn on "Save password" if you'd rather not retype it every time you connect.

  • Telephone Number. This, of course, is the local access number that your modem is supposed to dial to connect to your ISP.

    TIP

    If you need your Mac to dial a 9 or an 8 for an outside line (as you would from within a hotel), or *70 to turn off Call Waiting, add it to the beginning of the phone number followed by a comma. The comma means "pause for two seconds." You can also put the comma to good use when typing in the dialing sequence for a calling-card number.

  • Alternate Number. This blank lets you type in a number to dial if the first one is busy.

  • PPP Options. Click this button to bring up a special Options dialog box, filled with checkboxes that control your online sessions. Here, for example, you can specify how long the Mac waits before hanging up the phone line after your last online activity, and how many times the Mac should redial if the ISP phone number is busy.

    TIP

    In the Session Options, one checkbox you'll almost certainly want to turn on is "Connect automatically when needed." It makes your Mac dial the Internet automatically whenever you check your email or open your Web browser. (Otherwise, you'd have to establish the Internet call manually, using the Internet Connect program described on Section 9.1.11. Only then could you check your email or open your Web browser.)

18.2.3 Phase 3: The Proxies Tab

Most people can ignore this tab altogether. (Proxy servers are computers used primarily by corporations to accelerate or filter the delivery of Internet information. Of course, if you work in a corporation, you probably don't connect to the Internet with a dial-up modem anyway. If you are that rare exception, ask your network administrator to show you how to set up this screen.)

18.2.4 Phase 4: The Modem Tab

This is where you specify the kind of modem you have. Most Mac OS X-compatible Macs have built-in Apple modems, which is why the pop-up menu already says "Apple Internal 56K Modem (v.90)." If you, the heretic, have some other kind of modem, choose its name from the pop-up menu.

TIP

This list of modems corresponds to configuration files in your Library [image] Modem Scripts folder. You can save some disk space and simplify your life by throwing away the scripts for all of the modems except the one you actually use.

Some of the other settings that can be handy include:

  • Sound. By clicking Off, you make your Mac dial the Internet silently, sparing sleeping family members or dorm roommates from having to listen to your modem shriek as it connects.

  • Dialing. Specify what kind of phone service you have—Tone or, in a few rural locations, Pulse.

  • Wait for dial tone before dialing. This is for you, North American laptop owners. Because the dial tones in certain foreign countries sound weird to the Mac, it therefore won't dial; it's still listening for that good old North American dial tone. In that case, turning off this checkbox makes the Mac dial bravely even though it hasn't heard the sound it's listening for.

Figure 18-1. Even if several user accounts (Chapter 11) are set up on your Mac, they all share the same Internet connection settings. Only an administrator can make changes to the Internet dial-up settings. That's why the little padlock appears in the lower-left corner of the dialog box. When you're finished making your settings, either close the window or click Apply Now.

18.2.5 Going Online

That's all there is to it. If you turned on "Connect automatically when needed," your Mac dials and connects to the Internet automatically whenever an Internet-related program tries to connect (a Web browser or email program, for example).

If you didn't turn on that option, then you make your Mac dial the Internet in one of these ways:

  • Using Internet Connect. This little program is in your Applications folder. The main item of interest here is the Connect button, which makes the Mac dial. Once the indicators show that you're online, open your Web browser, email program, or other Internet software and get surfing.

    By clicking the black triangle button next to the Configuration pop-up menu, you can collapse the Internet Connect window so that it takes up much less screen space. You hide everything, in fact, except the pop-up menu and the Connect/Disconnect button.

    If you're smart, however, you'll turn on the "Show modem status on menu bar" checkbox. It adds a tiny telephone icon—the Modem Status menulet—to the upper-right corner of your screen, which lets you completely bypass Internet Connect the next time you want to go online (Figure 18-2).

  • Use the menu-bar icon. Just click the Modem Status menulet and choose Connect from the pop-up menu. Your Mac dials without even blocking your desktop picture with a dialog box.

Figure 18-2. Going online automatically (by launching an Internet program) is by far the most convenient method, but you can also go online on command, in one of these two ways. Top: The quick way is to choose Connect from this menulet (which doesn't appear until you turn on "Show modem status on menu bar" on the Internet Connect screen). Bottom: You can also go online manually the long way (using Internet Connect, shown here in its expanded form).

18.2.6 Disconnecting

The Mac automatically drops the phone line 15 minutes after your last activity online (or whatever interval you specified in the PPP Options dialog box). In fact, if other people have accounts on your Mac (Chapter 11), the Mac doesn't even hang up when you log out. It maintains the connection so that the next person can Net-surf without redialing.

Of course, if other people in your household are screaming for you to get off the line so that they can make a call, you can also disconnect manually. Either choose Disconnect from the Modem Status menulet or click Disconnect in the Internet Connect window (both shown in Figure 18-2).

TIP

If you have more than one ISP, or if you travel between locations with your laptop, don't miss the Location feature. It lets you switch sets of dial-up modem settings—including the local phone number—with a simple menu selection. It's described in Section 18.6.


18.3 Broadband Connections

If you have a cable modem, DSL, or office network, you're one of the lucky ones. You have a high-speed, broadband connection to the Internet that's always available, always on. You never have to wait to dial, to disconnect, or to download. You're connected to the Net via your Mac's Ethernet jack, leaving its built-in modem benched.

You set up your account like this: Open System Preferences; click the Network icon; from the Show pop-up menu, choose either AirPort or Built-in Ethernet (or the name of the Ethernet card that's connected to your Internet equipment), depending on how your Mac is connected to the broadband modem. Now, you see something like Figure 18-3.

The next step is to make a selection from the Configure pop-up menu. Only your service provider (cable TV company or phone company, for example) can tell you exactly which settings to use, but you'll generally choose one of these options:

  • Manually. Your cable or phone company will tell you precisely which IP address (Internet address) to type in here. The bad news is that you'll also have to fill in all the other boxes here—Subnet Mask, Router, and so on—with cryptic numbers separated by periods.

    On the other hand, look at the bright side: You've just been given a static IP address, an Internet address that is all your own and that won't change. Because your Mac has this one reliable address, several cool Mac OS X features are available to you. For example, you'll be able to access your files from anywhere in the world, as described in Chapter 21.

  • Using DHCP. This acronym means dynamic host configuration protocol, the operative word being dynamic. If your ISP tells you to use this option, then it intends to assign your Mac a different IP address every time it turns on.

    The good news is that this option saves you from having to fill in any of the other boxes in this control panel. Instead, all the settings will come to you over the Internet. (The one occasional exception: the Domain Name Servers box.)

    The bad news is that you don't necessarily have a single, unchanging IP address, which can make it more difficult to use the remote control features of Mac OS X, like dialing in from the road. (There is a workaround, however; see IP Addresses and You.)

That's all the setup—click Apply Now. If your settings are correct, you're online, now and forever. You never have to worry about connecting or disconnecting.

TIP

If you have more than one Mac, you can share a single cable modem or DSL box among them, no matter what your phone or cable company tells you.

There are two ways to go about it. One is to use software, in the form of Mac OS X's Internet Connection Sharing feature (Section 18.8). The other is to use hardware, which means buying a router: a box that intercepts the signal from the cable modem or DSL box and shares it with all the different Macs you've plugged into it. (Many of these routers double as Ethernet hubs, providing either four or eight jacks into which you can plug the Macs.) As a bonus, many of these routers act as firewalls to keep out hackers.

Figure 18-3. Don't be alarmed by the morass of numbers and periods—it's all in good fun. (If you find TCP/IP fun, that is.) In this illustration, you see the setup for a cable-modem account with a static IP address, which means you have to type in all of these numbers yourself, as guided by the cable company. The alternative is a DHCP server account, which fills most of it in automatically.
    [ Team LiB ]


18.4 AirPort Networks

AirPort is Apple's term for the 802.11 wireless networking technology. If you have it, you'd remember having paid $100 for an AirPort card, which lets any modern Mac model communicate with an AirPort base station up to 100 feet away, much like a cordless phone. Doing so lets you surf the Web from your laptop in the TV room, for example, or share files with someone across the building from you.

The base station can take any of these forms:

  • The $300 AirPort Base Station (which looks like a small flying saucer), or a non-Apple brand of the same thing (Section 12.1.2).

  • An AirPort-equipped Mac that you've configured to serve as a software-based base station. This feature was born in Mac OS 9, disappeared for the first year of Mac OS X's existence, but reappeared in Mac OS X 10.2. See Section 18.8 for setup instructions.

In any case, if your base station is plugged into an Ethernet hub, then 10 or 20 airport-equipped Macs can join an existing Ethernet network without wiring. If you go online using the base station's modem, plug it into a phone jack. Or, if you have a broadband modem, connect it to the WAN (wide area network) port of your hub—not one of the regular Ethernet jacks. Then plug the base station into one of the regular jacks.

For the easiest AirPort network setup, begin by configuring your Mac so that it can go online the wired way, as described on the previous pages. Once it's capable of connecting to the Internet via wires, you can then use the Airport Setup Assistant (in your Applications [image] Utilities folder) to transmit those Internet settings wirelessly to the base station itself. From then on, the base station's modem or Ethernet jack—not your Mac's—will do the connecting to the Internet.

At that point, you can do all the controlling you like from the AirPort menulet (Figure 18-4).

Figure 18-4. Once your AirPort system is working, you can use the menu bar icon to turn off your AirPort card (for battery savings in a laptop), to switch from one AirPort network to another (in schools or companies that have more than one), and to check your wireless signal strength (by counting the "waves" coming out of the icon on your menu bar).

PPoE and DSL

If you have DSL service, you may be directed to click the PPoE tab (in the Network pane of System Preferences). It stands for PPP over Ethernet, meaning that although your DSL "modem" is connected to your Ethernet port, you still have to make and break your Internet connections manually, as though you had a dial-up modem.

Fill in the PPoE tab as directed by your ISP (usually just your account name and password). From here on in, you start and end your Internet connections exactly as though you had a dial-up modem, as described in Section 18.2.

You may discover that turning on PPoE disables AppleTalk. If you need AppleTalk (for connecting to older Macs on the network, for example), here's a tip: On the Network pane of System Preferences, choose Show [image] Network Configurations. Duplicate and rename your Ethernet setup. Set up the new configuration with AppleTalk on, using a manually assigned IP address (like 192.168.1.10).

Now your Mac can talk on two "networks" at once on the same Ethernet port—your DSL company and your older Macs on the network.


18.5 The Jaguar Firewall

If you have a broadband, always-on connection, you're connected to the Internet 24 hours a day. It's theoretically—though remotely—possible for some cretin to use automated hacking software to flood you with files or take control of your machine. Fortunately, Mac OS X 10.2's new firewall feature puts up an impenetrable barrier to such mischief.

Open the Sharing panel of System Preferences. Click the Firewall tab (Figure 18-5), and then click Start. That's almost all there is to it: you're protected.

Figure 18-5. For the first time, Mac OS X comes with a built-in firewall, sparing you the trouble of installing a shareware one like Firewalk or BrickHouse. Click Start to turn it on. Older versions of Mac OS X came with a firewall, too, but they lacked a graphic front end that non-programmers could use to turn it on.

Only two complications may remain:

  • Are you using Mac OS X's new Internet connection-sharing feature (Section 18.8)? If so, it's important to turn on the firewall only for the first Mac—the one that's the gateway to the Internet. Leave the firewall turned off on all the Macs "downstream" from it.

  • Believe it or not, the firewall blocks signals from iChat's Rendezvous network (see Rendezvous). If you want to permit chatting to cross through your firewall, you'll have to build it a manual tunnel, as described in the box below.

    NOTE

    This simple firewall doesn't let you create complex rules (preprogrammed guidelines that permit or deny certain kinds of Internet traffic). For that degree of flexibility, install a shareware program like Firewalk or Brickhouse (available from www.missingmanuals.com, for example).

All the Firewall Checkboxes

Why can't I turn the checkboxes on the Firewall dialog box on or off?

These checkboxes are really only indicators, not controls. You can't turn them on or off by clicking—only by changing the setup on the Services tab.

The checkboxes here list certain ports—numbered tunnels for certain kinds of Internet traffic. Each service (Personal Web Sharing, Personal File Sharing, and so on) conducts its business on a specific port.

For example, the Personal Web Sharing service watches port 80 for requests (from the Internet) for the Web pages you've created on your Mac, as described in Chapter 21. The Personal File Sharing service watches port 548 for requests to access shared folders and disks (Chapter 12).

That's why the only way to turn these checkboxes on or off is by visiting the Services tab of the Sharing panel. Whenever you turn on one of the services on the Services tab, Mac OS X turns on the corresponding checkbox on the Firewall tab automatically.

Likewise, turn the service off to close the port. (Turn off all of the services you don't need, so the bad guys can't use the corresponding ports to access your computer.)

It's important to note that you'll only need to keep ports open for those services you're providing, and not those you're using on other computers. For example, you don't need to keep port 80 open when you're accessing other people's Web pages, and you don't need to keep port 548 open if you're accessing other Macs on the network.

Incidentally, the Firewall pane lists only the services that come built into to Mac OS X. As power users know, there are plenty of other network services worth running that aren't listed here: IRC, Retrospect, MSN Messenger, and (at least until version 10.2.2) even iChat's Rendezvous networking. You have to open their ports manually.

To do so, click New on the Firewall pane. The resulting sheet has a pop-up menu listing a handful of common services, and a text box showing the associated port for that service. If the service you would like to run is listed, choose it from the pop-up menu and click OK. You've just added a new checkbox to the Firewall pane.

If you don't see your service listed, choose Other in the Port Name pop-up menu. Enter the port number associated with that service and a description. (Hint: iChat Rendezvous is on port 5298.) If you don't know the correct port number to use, search the port database at http://ports.tantalo.net.


18.6 Switching Locations

If you travel with a laptop, you know the drill. You're constantly opening up System Preferences [image] Network so that you can switch between Internet settings: Ethernet at the office, dial-up at home. Or maybe you simply visit the branch office from time to time, and you're getting tired of having to change the local access number for your ISP each time you leave home (and return home again).

The simple solution is the [image] [image] Location submenu. As Figure 18-6 illustrates, all you have to do is tell it where you are. Mac OS X handles the details of switching to the correct Internet connection and phone number.

Figure 18-6. The Location feature lets you switch from one "location" to another just by choosing its name—either from the menu (top) or from this pop-up menu in System Preferences (bottom). The Automatic location just means "the standard, default one you originally set up." (Don't be fooled: Despite its name, Automatic isn't the only location that offers multihoming, which is described later in this chapter.)

18.6.1 Creating a New Location

To create a Location, which is nothing more than a set of memorized settings, open System Preferences, click Network, and choose New Location from the Location pop-up menu. You'll be asked to provide a name for your new location, such as Chicago Office or Dining Room Floor.

When you click OK, you return to the Network panel, which is now blank. Take this opportunity to set up the kind of Internet connection you use at the corresponding location, just as described on the first pages of this chapter. If you travel regularly, in fact, you can use Location Manager to build a long list of city locations, each of which "knows" the local phone number for your Internet access company (because you've entered it on the PPP tab).

A key part of making a new Location is putting the various Internet connection types (Ethernet, AirPort, Modem, Bluetooth) into the correct order. Your connections will be slightly quicker if you give the modem priority in your Hotel setup, the AirPort connection priority in your Starbucks setup, and so on.

In fact, if you use nothing but a cable modem when you're at home, you may want to create a location in which only the Ethernet connection is active. Conversely, if your laptop uses nothing but its dial-up modem when on the road, your Location could include nothing but the Internal Modem connection. You'll save a few seconds each time you try to go online, because your Mac won't bother hunting for an Internet connection that doesn't exist (see "Multihoming," below).

18.6.2 Making the Switch

Once you've set up your various locations, you can switch among them using either the Location pop-up menu (in System Preferences [image] Network) or the [image] [image] Location submenu, as shown in Figure 18-6. As soon as you do so, your Mac is automatically set to dial the new phone number, or to connect using the different method.

TIP

If you have a laptop, create a connection called Offline. From the Show pop-up menu, choose Active Network Ports; turn off all the connection methods you see in the list. When you're finished, you've got yourself a laptop that will never attempt to go online. This setup will save you the occasional interruption of a program that tries to dial but takes three minutes to discover you're on Flight 800 to Miami and have no phone line available.

The Internet via Classic

As explained in Chapter 5, the Classic environment may look and feel like Mac OS 9, but it's actually just a simulation. You're still running Mac OS X. Signals that Classic programs try to send directly to the hardware of your Mac—its modem, for instance—must then pass through the Mac OS X software layer.

In many cases, that's no big deal. If you inspect your TCP/IP control panel in Classic, you'll see that Apple has shrewdly rigged it to inherit the Internet settings you've established for Mac OS X. (Don't fiddle with them, either.) If you're connected to the Internet via your Ethernet jack (cable modem, DSL), your Classic programs can get online without a hiccup.

If you connect to the Internet via dial-up modem, however, you may find that Classic programs don't automatically dial when you run them. The solution: Connect to the Internet manually in Mac OS X (using the Internet Connect program, for example) before switching to the Classic program and going online.


18.7 Multihoming

Speaking of different ways to get online, Mac OS X offers one of the coolest features known to Internet-loving mankind: multihoming. That's the ability to auto-detect which Internet connection methods are available, and then switch to the fastest one available—automatically.

This feature is especially ideal for laptops. When you open your Web browser, your laptop might first check to see if it's at the office, plugged into a cable modem via the Ethernet—the fastest possible connection. If not, it automatically looks for an AirPort network. Finally, if it draws a blank there, the laptop reluctantly dials the modem. It may not be the fastest Internet connection, but it's all you've got at the moment.

In short, for each location you create, you can specify which network connections the Mac should look for, and in which order. You can even turn off some connections entirely. For example, if you have a desktop Mac that's always connected to a cable modem, you may never want your Mac to dial using its built-in modem. In that case, you could turn off the modem entirely.

Here's how to go about using this multihoming feature:

  1. Open System Preferences. Click the Network icon.

    Make sure the appropriate location is selected in the Location pop-up menu.

  2. From the Show pop-up menu, choose Network Port Configurations.

    Now you see the display shown in Figure 18-7. It lists all the different ways your Mac knows how to go online, or onto an office network.

  3. Drag the items up and down in the list into priority order.

    If you have a cable modem, DSL, or office network connection, for example, you might want to drag Built-in Ethernet to the top of the list, since that's almost always the fastest way to get online.

    At this point, you can also turn off any connections you don't want your Mac to use when it's in this location—the internal modem, for example.

  4. Click Apply Now.
Figure 18-7. The key to multihoming is sliding the network connection methods' names up or down (and turning off the ones you don't intend to use in this location). You can also rename the different configurations just by double-clicking them.

Your Mac will actually switch connections—not just each time you go online, but even in real time, during a single Internet session. If lightning takes out your cable modem in the middle of your Web surfing, your Mac will seamlessly switch to your AirPort network—or, if necessary, dial using the modem—to keep your session alive.


18.8 Internet Sharing

If you have cable modem or DSL service, you're a very lucky individual. Not only do you benefit from spectacular speed when surfing the Web or processing email, but your connection is on full-time. You never have to wait for some modem to dial (screeching all the way), and wait again for it to disconnect. It's just too bad that only one computer in your household or office can enjoy these luxuries.

Internet Sharing as a Bridge

Ordinarily, only one Mac has Internet Sharing turned on: the one that's connected directly to the Internet.

There are, however, times when you might want another machine "downstream" to have it turned on, too—and that's when you want to bridge two networks.

Consider the setup illustrated here, where there are really two different networks: one that uses AirPort, and another connected to an Ethernet hub.

If you play your cards right, you can actually set things up so that all of these Macs can get online simultaneously, using a single Internet connection.

Set up the gateway Mac so that it's an AirPort base station, exactly as described on these pages.

Start setting up the bridge Mac the way you'd set up the other AirPort Macs—with AirPort selected as the primary connection method, and "Using DHCP" turned on in the Network panel.

Then visit the bridge Mac's Sharing panel. Turn on Internet Sharing here, too, but this time select "Share the connection with other computers on Built-in Ethernet."

The bridge Mac is now communicating on both networks. It uses the AirPort connection as a bridge to the gateway Mac and the Internet—and its Ethernet connection to share that happiness with the wired Macs in its own neighborhood.

Fortunately, it doesn't have to be that way. You can spread the joy of high-speed Internet to every Mac (and PC) on your network in either of two ways:

  • Buy a router. A router (also called a residential gateway) is a little box, costing about $80, that connects directly to the cable modem or DSL box. In most cases, it doubles as a hub, providing multiple Internet jacks into which you can plug your PCs. As a bonus, a router provides excellent security, serving as a firewall to keep out unsolicited visits from hackers on the Internet. (If you use one, turn off Mac OS X's own firewall, as described earlier in this chapter.)

  • Use Internet Sharing. Internet Sharing, a powerful new feature in Mac OS X 10.2, is the software version of a router, in that it distributes a single Internet signal to every computer on the network. But unlike a router, it's free. You just fire it up on the one Mac that's connected directly to the Internet—the gateway computer. (The Internet Sharing feature is also responsible for Mac OS X 10.2's software base station feature for AirPort Macs, as described on Section 18.8.)

    But there's a downside: If the gateway Mac is turned off, none of the other machines can get online.

Most people use Internet Sharing to share a broadband connection like a cable modem or DSL. But in fact, Internet Sharing works even if the gateway Mac connects to the Internet via dial-up modem or Bluetooth cell phone. The only requirement is that the gateway Mac also has a network connection (Ethernet or AirPort) to the Macs that will share the connection.

18.8.1 Turning on Internet Sharing

To turn on Internet Sharing on the gateway Mac, open the Sharing panel of System Preferences. Click the Internet tab and then click Start, as shown in Figure 18-8. (In most setups, you'll want to turn on Internet Sharing only on the gateway Mac.)

Internet Sharing Using a Modem

My eMac isn't anywhere close to a phone jack. Can I use Internet Sharing to get online via the dial-up modem of my upstairs Power Mac?

As long as your eMac is connected to the gateway machine via a network (Ethernet or AirPort), the answer is yes.

Think about it: Dial-up modems and Bluetooth cell phones may be listed in the Network panel of System Preferences, but they are only Internet connections, not home-network connections. If you want the gateway Mac to share its dial-up or Bluetooth connection with other machines on your network, therefore, the selected Location (in the Network panel of System Preferences) must list both the modem/Bluetooth connection and either Ethernet or AirPort.

The bottom line: If the Show: pop-up menu in your Network panel shows only Internal Modem or only Bluetooth, then you won't be able to turn on Internet Sharing at all.

Make sure that the correct checkboxes are selected, to reflect how the gateway Mac is connected to the others:

  • Share your Internet connection with AirPort-equipped computers. This is the software base-station effect described in the next section.

  • Share the connection with other computers on Built-in Ethernet. This option is for wired networks. In other words, it gives Internet access to other Macs or PCs on the same Ethernet network as the gateway Mac. (That could mean a group of them all connected to the same Ethernet hub, or a single other Mac connected to the gateway machine with an Ethernet crossover cable.)

    NOTE

    Which checkboxes appear here depend on which kinds of Internet connections are turned on in the Network panel of System Preferences. If the gateway Mac doesn't have an AirPort card installed, for example, or if AirPort is turned off in the current configuration, the AirPort option doesn't appear.

Now visit each of the other Macs on the same network. Open the Network panel of System Preferences. Using the Show pop-up menu, choose AirPort or Built-in Ethernet—whichever reflects how each Mac is connected to your network. Then, from the Configure pop-up menu, choose Using DHCP. Leave everything else blank, as shown in Figure 18-8. Finally, click Apply Now.

Figure 18-8. Top: Ka-ching! Mac OS X's new Internet Sharing button just saved you the cost of an $80 hardware router. Bottom: All of the missing information here will be supplied by the gateway Mac—the one Mac that's directly connected to the broadband modem.

As long as the gateway Mac remains turned on, you should find that both it and your other Macs can get onto the Internet simultaneously, all at high speed. (Even Windows PCs on the same network can also get online, as long as you set them up to use DHCP just as you did your "downstream" Macs.)

NOTE

You may wonder: Your gateway Mac only has one Ethernet port. How can you plug in both the cable modem and the local network?

One approach is to install a second Ethernet card. The more economical approach: Connect the cable modem to the Uplink or WAN jack on your Ethernet hub. Your gateway Mac plugs into the hub as usual.

18.8.2 The Software Base Station Effect

If the gateway Mac has an AirPort card, turning on Internet Sharing (and "Share your Internet connection with AirPort-equipped computers") has another profound effect: It creates a software base station. The Mac itself is now the transmitter for Internet signals to and from any other AirPort-equipped Macs within range. You just saved yourself the $300 cost of a physical, flying saucer Apple base station!


18.9 .Mac Services

In January 2000, Apple CEO Steve Jobs explained to the Macworld Expo crowds that he and his team had had a mighty brainstorm: Apple controls both ends of the connection between a Mac and the Apple Web site. As a result, Apple should be able to create some pretty clever Internet-based features as a reward to loyal Mac fans. Later that same day, the Apple Web site offered a suite of free services called iTools.

Then the technology bubble burst.

In July 2002, Steve Jobs once again appeared before an Expo audience, this time to announce that iTools would no longer be free. It would now cost $100 per year, bearing a new name—.Mac ("dot-mac"). For a full description, see Figure 18-9.

18.9.1 What .Mac Gets You

For anyone who's willing to pay the fee, the crown jewel of the .Mac services is iDisk, which creates a 100 MB hard-drive icon on your desktop. Anything you drag into the folders inside this icon gets copied to Apple's secure servers on the Internet. Meanwhile, on your end, it appears to work just like a very, very slow hard drive.

In other words, iDisk can be helpful for people whose Macs don't have floppy drives or Zip drives—and even a good idea for those who do. Because this backup disk is off-site, if a fire or thief destroys your office and your backup disks, your iDisk is still safe.

Furthermore, you can pull the iDisk onto any computer's screen—Mac or Windows—at your office, at your home, at your friend's house, so you don't need to carry around a physical disk to transport important files.

Best of all, the iDisk is extremely well integrated into Mac OS X. For example, when you're saving a document from within a program, you can save it directly onto your iDisk.

The iDisk isn't the only .Mac feature, however. Signing up for an .Mac account also gives you goodies called iCards, HomePage, and Email. In the following pages, you'll find out how to use each of these features.

18.9.2 Signing Up for .Mac

Open System Preferences. When you click Internet, the .Mac tab is staring you in the face. Click Sign Up.

You now go online, where your Web browser has opened up to the .Mac sign-up screen. Fill in your name and address, make up an account name and password, turn off the checkbox that invites you to get junk mail, and so on.

The final step is to return to the Internet pane of System Preferences. On the .Mac tab, fill in the account name and password you just composed. You're ready to use .Mac.

Figure 18-9. The .Mac Web site features special tabs across the top. For example, the iCards feature lets you send attractively designed electronic greeting cards by email to anyone on the Internet. The Backup feature works in conjunction with a basic backup program that you can download from this site. Webmail and HomePage are the other second-tier features. The best feature, however, is iDisk.

18.9.3 iDisk

As noted above, iDisk is a virtual disk that behaves as though it's an external (and very slow) hard drive attached to your Mac. (You can pay for a larger disk, if you need it; details are on the Apple Web site.)

18.9.3.1 Pulling it onto your screen

Apple must really love the iDisk concept, because it has devised about 300 different ways to pull the iDisk icon onto your screen:

  • Choose Go [image] iDisk (or press Shift- [image] -I), as shown in Figure 18-10.

  • Click the iDisk icon on the toolbar of any Finder window. (If it's not there, see Section 3.4.2.)

  • From within any program, choose File [image] Save As or File [image] Open. In the Save or Open dialog box, choose iDisk from the Where pop-up menu (see Figure 18-10).

  • Double-click the alias you made of your iDisk the last time it was onscreen.

  • Choose Go [image] Connect to Server. At the bottom of the resulting dialog box, type http://idisk.mac.com/yourname (substitute your actual account name for yourname). Press Enter. In the next dialog box, type your .Mac name and password, and then click Connect. (This is the quickest approach if you're using somebody else's Mac OS X machine.)

  • On a Mac OS 9 machine, choose [image] [image] Chooser, click AppleShare, click Server IP Address button, type idisk.mac.com in the Server Address box, and then click Connect. Type your .Mac member name and password, and then click Connect. Select your iDisk and then click OK.

  • Visit www.mac.com and click the iDisk icon. Type in your name and password, and then click Enter. Finally, click Open Your iDisk. (Clearly, this is a lot more work than the one-click methods already described. Use this technique when you're using a Mac OS 9 machine far from home, for example.)

At this point, using iDisk is exactly like using a very slow—but very safe—floppy disk or Zip disk. You can drag files or folders from your hard drive into one of the folders that appear on the iDisk.

Figure 18-10. Choose Go iDisk (top left) or, from within a Save dialog box, pick Where iDisk (top right). When the iDisk finally appears (bottom left), double-click it—and wait—to see its contents (bottom right). Note that you can't create your own folders on this special disk; you must drag your files directly into one of the folders shown here.

NOTE

You can't create your own folders on the iDisk. You must put your files and folders into one of the folders already on the iDisk, such as Documents or Pictures. If you try to drag an icon directly into the iDisk window, or onto the iDisk icon, for example, you'll get an error message.

Thereafter, you can retrieve or open whatever you copied to the iDisk. Open one of the folders on it; you can now open, rename, trash, or copy (to your hard drive) whatever you find inside.

The iDisk from Windows

In the old days, you could only get to your iDisk from a Macintosh. These days, you can bring your iDisk onto the screen of any computer, even one running Windows or Linux.

The procedure varies by operating system, but the general idea is the same: You're going to create a new "network place" that uses the address http://idisk.mac.com/yourname, where yourname is your .Mac account name.

In Windows 2000, Me, or XP, there's a quick way to do that. Choose File [image] Open from within Internet Explorer. Turn on the "Open as Web Folder" checkbox, and then type your iDisk's address (http://idisk.mac.com/yourname). Enter your name and password when you're asked for it. When it's all over, your iDisk window appears on the screen exactly as though it's a very slow hard drive.

Thereafter, you can summon your iDisk by double-clicking its icon in the Network Places folder.

Windows XP: Choose Tools [image] Map Network Drive in any desktop window.

Windows 2000: Choose Tools [image] Map Network Drive. Click "Web folder or FTP site."

Windows 98: Open My Computer. Double-click the Web Folders icon; double-click Add Web Folder.

In each case, you should now type in this address as the location to add: http://idisk.mac.com/yourname (where yourname is your .Mac member name), as shown here. When you're asked for a name and password, type in your usual .Mac name and password.

After a minute or two, you'll find the icon for your iDisk in the My Computer window, sitting there as though it's a hard drive attached to the PC. (In Windows XP, for example, it's in the Network Drives category, called something like "Frank23 on 'idisk.mac.com.'")

18.9.3.2 The software stash

The Software folder on your iDisk is different from all the others. It holds an entire software collection you didn't even know you had.

Inside are various folders containing both Apple software updates and the most popular Mac OS X shareware and freeware programs. After reviewing these programs, drag the software you want to your hard drive or your desktop. You can open or install it from there. (Fortunately, none of this eats into your 100 MB limit.)

18.9.3.3 The permanence of the iDisk

You can leave the iDisk's icon onscreen for as long as you like. The new permanence of the iDisk is a side benefit of the so-called WebDAV technology that's built into Mac OS X 10.1 and later.

If you have a full-time Internet connection, great: you can consider the iDisk a permanent fixture of your Macintosh. But even if you have a dial-up Internet account, you can leave the iDisk on your screen. Whenever you double-click it or save something onto it, your modem automatically dials the Internet and opens the pipes you need to feed your iDisk.

18.9.3.4 The Public folder

In general, whatever you put onto your iDisk is private. Without your password, nobody can see what you've stored there. There's one exception, however: Whatever you put into the Public folder on any iDisk can be seen, opened, and copied by any other .Mac member. All they need is your member name—not your password. (Think of the iDisk Public folder as the long-lost twin of the Public folder in your own Home folder.)

The Public folder is terrific for storing family photos where anyone who's interested can look at them. It's also handy when you're collaborating; just post the latest drafts of your work in the Public folder for your co-workers to review.

To view someone else's Public folder, use one of these techniques (suppose the person's .Mac name is SkiBunny23):

  • From Mac OS X 10.2. Choose Go [image] Connect to Server. At the bottom of the dialog box, type http://idisk.mac.com/skibunny23/Public. Click Connect or press Enter. If a password is required, use public as the user name and, well, the password as the password.

    TIP

    Actually, there's a simpler way: Use iDisk Utility, described below.

  • From Mac OS 9. Choose [image] [image] Chooser, click AppleShare, click the Server IP Address button, type idisk.mac.com in the Server Address box, and then click Connect. Type skibunny23; for the password, use public (unless the folder really is password-protected, in which case you should type the password you were given). Then click Connect. Select the iDisk and then click OK.

  • From Windows. See The iDisk from Windows.

After a minute or so, a new iDisk icon appears on your desktop, bearing that member's name. Double-click it to view its contents. You can copy these files to your hard drive, or double-click them to open them directly.

18.9.3.5 Checking your free disk space

To see how much room is left on your iDisk, summon its status bar as you would in any Finder window: by choosing View [image] Show Status Bar.

18.9.3.6 iDisk Utility

When you visit www.mac.com, sign in, and click the iDisk icon, you'll be offered the chance to download a program called iDisk Utility. As shown in Figure 18-11, it offers three handy functions.

  • Let people put stuff in your Public folder. Ordinarily, only you can drop things in there—but if you turn on "Read-Write" (Figure 18-11), other people can deposit stuff there, too.

  • Password-protect your Public folder. Probably a good idea if you decide to make your Public folder available for deposits.

  • Open someone else's Public folder quickly. You only need to type the person's member name and click Open.

Figure 18-11. This whole business of using iDisk public folders—yours and other people's—is a lot simpler if you have this handy utility. If you're that occasional oddball who actually has more than one iDisk, this little program lets you pull them all onto your desktop at once, too.

18.9.4 Email

Apple offers an email address to each .Mac member. Of course, anyone who's able to get to the Apple Web site probably already has an email account.

So why bother? The first advantage is the simple address: YourName@mac.com. And because .Mac is a Mac-only service, the odds are good that you'll be able to claim the name you want. No longer must you be known as bgates28514@earthlink.net. (Cultdom has its privileges.)

Second, Mac.com addresses are integrated into the Mail program that comes with Mac OS X, as you'll see in the next chapter. And finally, you can read your .Mac email from any computer anywhere in the world, via the www.mac.com Web site.

18.9.5 HomePage

Creating a Web page (an HTML document) isn't difficult. Using a program like Dreamweaver, Netscape Composer, or even AppleWorks, you can design the text and graphics for a simple Web page in a single afternoon. It's much more difficult, however, to figure out how to post that Web page—to hang it on the Internet where the world can see it. To do that, you need special software, several passwords and codes, and a lot of help from your ISP.

The .Mac HomePage feature eliminates all that hassle. All you have to do is drag your Web-page documents and graphics into the Sites folder on your iDisk (described in the previous section). Your Web page is instantly available for viewing by the 300 million people on the Internet.

If you already know how to design Web pages, great; put the HTML documents and graphics you've created into the Sites folder of your iDisk.

TIP

Remember Image Capture, described in Section 9.1.10? One of its best stunts is turning photos downloaded from your digital camera into a Web page. After it has done so, drag the resulting HTML documents and image folders into the Sites folder—and presto, you've got yourself a photo-gallery Web page.

Then tell your friends its Web address. Suppose that the Web page you designed is called index.html, and that your .Mac member name is SkiBunny. In that case, your custom-designed Web address is http://homepage.mac.com/skibunny/index.html.

And if you have no experience designing Web pages, you can use .Mac itself to create attractive, if simple, Web pages. Sign into the Apple Web site's .Mac screen. If you click HomePage, you'll find a large gallery of canned Web site design templates that you can easily fill up and post in cyberspace: photo albums, movie players, ré;sumé;s, baby announcements, and so on.

When you finally click the Publish button at the top of the screen, new Web page (HTML) documents appear in the Sites folder of your iDisk. (If you know how to use a Web-design program like Dreamweaver, you can edit these documents.) Also, your screen now displays your page's URL (Web address), which you can email to anyone who'd be interested. Unfortunately, it's not particularly catchy: it's along the lines of http://homepage.mac.com/YourMemberName/baby.html.

Finally, your Web page is available for anyone on the Internet to see. Corporations and professional Web designers may sniff at the simplicity of the result—but it takes them a lot longer than ten minutes to do their thing.

TIP

You can create as many Web pages as you want. When you return to the HomePage screen, a list of your existing Web pages appears (complete with Edit Page and Delete Page buttons).


18.10 Internet Location Files

One of the least convenient aspects of using the Internet is having to remember the often cumbersome addresses for various Internet features. The Mac offers a clever way to manage and memorize these addresses: Internet location files. Figure 18-12 shows the procedure for creating one of these special clipping files.

Figure 18-12. To create an Internet location file, highlight an Internet address in any drag-and-droppable program (such as TextEdit or Stickies). Drag the highlighted text to your desktop, where it becomes an Internet location file.

The idea is simple: When you double-click an Internet location file, your Web browser opens automatically to that page, or your email program launches and generates a new, blank, preaddressed outgoing message.

In other words, an Internet location file is like a system-wide Bookmarks feature. You might consider gathering together the location files for Web sites you frequently visit, put them into a folder, and put that folder into the Dock. Do the same with addresses to which you frequently send email. Thereafter, you save a step every time you want to jump to a particular Web page or send email to a particular person—just choose the appropriate name from the Dock folder's pop-up menu.

TIP

Rename your Internet location files. Doing so doesn't affect their original programming—they still take you to the same Web pages or email addresses—but it lets you substitute plain English names ("Bob Smith" instead of bsmith@earthlink.net, for example).

Although Web and email addresses are by far the most popular uses of the Internet location file feature, they're not the only ones. You can also create location files for the addresses of newsgroups (news://news.apple.com), FTP sites (ftp://ftp.apple.com), AppleShare servers (afp://at/Engineering:IL5 3rd Floor), AppleTalk zones (at://IL5 2nd Floor), and even Web pages stored on your Mac (file://Macintosh HD/Website Stuff/home.html).

TIP

As far as your Mac is concerned, an Internet location file and a Favorite (or bookmark), as defined by Internet Explorer, are the same thing. As Figure 18-13 illustrates, you can create one from the other just by dragging.

Figure 18-13. In Internet Explorer, choose Favorites Organize Favorites. Now, impressively enough, you can drag Internet location files from the desktop directly into your bookmarks list. Oddly, this trick even works with email location files; if you add one to your Favorites menu, then choosing it (from within Internet Explorer) launches your email program and preaddresses an outgoing message.
    [ Team LiB ]


Chapter 19. Mail and Address Book

Email is a fast, cheap, convenient communication medium; it's almost embarrassing these days to admit that you don't have an email address. Once you have one, though, you'll be happy to discover that Mac OS X includes Mail, a program that lets you get and send email messages. It's a surprisingly complete, refreshingly attractive program, much improved in Mac OS X 10.2, that's filled with shortcuts and surprises—and it's free.


19.1 Setting Up Mail

What you see the first time you open Mail (by clicking its icon on the Dock, for example, or from your Applications folder) may vary. If you've signed up for a Mac.com account (and typed its name into the Internet panel of System Preferences), you're all ready to go. You've just saved yourself several minutes of typing and fiddling.

If you're using a regular Internet service provider (ISP) account instead, you'll confront the dialog box shown in Figure 19-1, where you're supposed to input the various settings to specify your email account. (Some of this information may require the help of your ISP's phone representative.) Here's the rundown:

  • Your Name will appear in the "From" field of the email you send. Type it just the way you'd like it to appear.

  • Email Address. This is the address you were assigned when you signed up for Internet services, such as billg@microsoft.com.

  • Incoming Mail Server, Mail Server Type, Outgoing (SMTP) Mail Server. Enter the information your ISP gave you about its mail servers: the type of server, the name of the incoming mail server, and the name of the outgoing mail server. Most of the time, the incoming server is a POP3 server and its name is connected to the name of your ISP, such as popmail.mindspring.com. The outgoing mail server (also called the SMTP server) looks something like mail.mindspring.com.

  • User Account ID, Password. Enter the name and password provided by your ISP.

Click OK when you're finished.

Figure 19-1. This dialog box lets you plug in the email settings provided by your ISP. If you want to add a second email account later, choose Mail Preferences and then click Create Account, which opens up a duplicate of this dialog box. (Mail collects all of your email in a single set of "mailbox" folders. If you'd rather see a separate set of Inbox, Outbox, and other folders for each account, choose Mail Preferences. Click Accounts, and then turn on "Show this account separately in mailboxes drawer.")

Now Mail offers to import your email collection from whichever email program you used before your Mac OS X adventure began—Entourage, Outlook Express, Claris Emailer, Netscape, or Eudora. (If you import from a Mac OS 9 program, make sure Classic is already running during the importing process; see Chapter 5.) Importing is a big help in making a smooth transition between your old email world and your new one. Figure 19-2 has the details.

Figure 19-2. If you click Yes (top), Mail will offer to import your old email collection from whichever program you used before you switched to Mac OS X (bottom left). You can even specify which email folders you want to import (bottom right). When the importing process is finished—which can take quite awhile—you'll find precisely the same folders already set up in Mail.
    [ Team LiB ]


19.2 Checking Your Mail

You get new mail and send mail you've written using the Get Mail command. You can trigger it in any of several ways:

  • Click Get Mail on the toolbar.

  • Choose Mailbox [image] Get New Mail. (If you have several accounts, you can check only one of them by choosing from the Mailbox [image] Get New Mail In Account submenu.)

  • Press Shift- [image] -N.

  • Wait. Mail comes set to check your email automatically every few minutes. To adjust its timing or turn it off completely, choose Mail [image] Preferences; choose a time interval from the "Check for new mail" pop-up menu.

Now Mail contacts the mail servers listed in the account list, retrieving new messages and downloading any files attached to those messages. It also sends any outgoing messages and their attachments.

TIP

The Activity window gives you a Stop button, progress bars, and other useful information. Summon it by choosing Window [image] Show Activity Viewer, or by double-clicking the little rotating arrows that appear in the upper-right corner of the Mail window when the program is checking for new messages.

POP, IMAP, and Web-based Mail

When it comes to email, there are three primary flavors of servers (Internet computers that process email): POP (also known as POP3), IMAP (also known as IMAP4), and Web-based. Each has its own distinct feeling, with different strengths and weaknesses. (AOL mail could be considered a fourth kind, but Mail can't talk to it.)

POP accounts are the most common kind. A POP server transfers your incoming mail to your hard drive before you read it, which works fine as long as you're only using one computer to access your email.

If you want to take your email world along with you on the road, you have to copy the Mail folder in your Home [image] Library folder into the corresponding location on your laptop's hard drive. When you run Mail on the laptop, you'll find your messages and attachments already in place.

IMAP servers are newer and have more features than POP servers, but as a result they don't enjoy as much popularity or support. IMAP servers store all of your mail for you, rather than making you download it each time you connect. As a result, you can access the same mail regardless of the computer you use. IMAP servers remember which messages you've read and sent, to boot. (Your Mac.com account is an IMAP account, which is why you can access the mail in your Inbox repeatedly from any Mac in the world. As a bonus, it's also a Web-based email program, meaning you can also read your mail using any Web browser on any computer.)

One downside to this approach, of course, is that you can't work with your email except when you're online, because all of your mail is on an Internet server, not on your hard drive. Another disadvantage is that if you don't conscientiously manually delete mail after you've read it, your online mailbox eventually overflows. Sooner or later, the system starts bouncing new messages back to their senders, annoying your friends and depriving you of the chance to read what they had to say.

Free, Web-based servers like Hotmail also store your mail on the Internet, and you can use a Web browser on any computer to read and send messages. They're also slower and more cumbersome to use than "regular" email accounts. Mail can't check these accounts at all. (Mail can check your .Mac account, which you can also check from a Web page. But it's not free.)

19.2.1 The Mailbox Drawer

Mail organizes your email into folders that Apple calls mailboxes at one side of the screen, in a sliding pane that looks and acts like a drawer (Figure 19-3). The Mailbox icon on the toolbar opens and closes it. Your mail folders are probably listed under the heading Personal Mailboxes; if you have a Mac.com address, it gets a heading of its own called .Mac. Under these headings, sometimes hidden by the "flippy triangles," you may find these mailbox folders:

  • In holds mail you've received. If you have more than one email account, you can expand its flippy triangle to see the separate "folders" for your individual accounts. You'll see this pattern repeated with the Sent, Junk, and other mailboxes, too—separate accounts have separate headings under the main one.

  • Out holds mail you've written and saved but haven't yet sent.

  • Drafts holds messages you've started but haven't yet finished, and don't want to send just yet.

  • Sent holds copies of messages you've sent.

  • Junk appears automatically when you turn on the Automatic mode for Mail's spam filter, as described later in this chapter.

  • On My Mac is a "folder" where you can file messages, within subfolders, from a standard ISP account (Earthlink, for example).

  • .Mac lists the subfolders you've created for filing messages from your .Mac account (Chapter 18).

  • Trash works a lot like the Trash on your desktop, in that messages you put there don't actually disappear. They remain in the Trash folder, awaiting rescue on the day you decide that you'd like to retrieve them.

To see what's in one of these folders, click it once. The list of its messages appears in the top half of the main window. When you click a message name, the message itself appears in the bottom half of the main window.

Figure 19-3. The many panes of Mail. Click a mailbox icon in the drawer pane to see its contents in the upper-left pane. (Shown here are two accounts: A regular ISP account and a Mac.com account.) When you click the name of a message in the main list (or press the up and down arrow keys to highlight successive message names in the list), you see the message itself in the Preview pane.
    [ Team LiB ]


19.3 Writing Messages

To send email to a recipient, click the Compose icon on the toolbar. The New Message form, shown in Figure 19-4, opens so you can begin creating the message.

Here's how you go about writing a message:

  1. Type the email address of the recipient in the To field.

    If you want to send this message to more than one person, separate their addresses with commas: bob@earthlink.net, billg@microsoft.com, steve@apple.com.

    You don't have to remember and type those addresses, either. If somebody is in your address book (Rebuilding Your Mail Databases), just type the first couple letters of his name; Mail automatically completes the address. (If the first guess is wrong, just type another letter or two until Mail revises its proposal.)

    As in most dialog boxes, you can jump from blank to blank (from the To field to the CC field, for example) by pressing the Tab key.

  2. To send a copy of the message to other recipients, enter the email address(es) in the CC field.

    CC stands for carbon copy. Getting an email message where your name is in the CC line implies: "I sent you a copy because I thought you'd want to know about this correspondence, but I'm not expecting you to reply."

  3. Type the topic of the message in the Subject field.

    It's courteous to put some thought into the Subject line (use "Change in plans for next week" instead of "Yo," for example).

  4. Specify an email format.

    There are two kinds of email: plain text and formatted (HTML or, in Mail's case, what Apple calls Rich Text). Plain text messages are faster to send and open, are universally compatible with the world's email programs, and are greatly preferred by many veteran computer fans. And even though the message is plain, you can still attach pictures and other files.

    By contrast, formatted messages sometimes open slowly, and in some email programs the formatting doesn't come through at all.

    To control which kind of mail you send on a message-by-message basis, choose, from the Format menu, either Make Plain Text or Make Rich Text. To change the factory setting for new outgoing messages, choose Mail [image] Preferences; click the Composing icon; and choose from the Format pop-up menu.

    TIP

    If you plan to send formatted mail, remember that your recipients won't see the fonts you specify unless their machines have the same ones installed. Bottom line: For email to Mac and Windows fans alike, stick to Arial, Times, Courier, and similarly universal choices.

  5. Type your message in the message box.

    You can use all standard editing techniques, including the Copy and Paste commands, drag-and-drop, and so on. If you selected the Rich Text style of email, you can even use word processor-like formatting (Figure 19-5).

    As you type, Mail checks your spelling, using a dotted underline to mark questionable words (also shown in Figure 19-5). To check for alternative spellings for a suspect word, Control-click the underlined word; a list of suggestions appears in the contextual menu. Click the word you really intended, or choose Learn Spelling to add the word to the Mac OS X dictionary.

    (To turn off automatic spell check, choose Edit [image] Spelling [image] Check Spelling As You Type so that the checkmark disappears. If you want to spell-check a message all at once, choose Edit [image] Spelling [image] Check Spelling [ [image] -;] after composing it.)

    TIP

    If you're composing a long email message, or if it's one you don't want to send until later, click the Save as Draft button, press [image] -S, or choose File [image] Save As Draft. You've just saved the message in your Drafts folder. To reopen a saved draft later, click the Drafts icon in the mailbox drawer, and then click the draft that you want to work on.

  6. Click Send (or press Shift- [image] -D).

    If you're not already online, your modem dials, squeals, connects to the Internet, and sends the message.

    TIP

    If you'd rather have Mail place each message you write in the Outbox folder instead of connecting to the Net when you click Send, choose Mailbox [image] Go Offline. While you're offline, Mail will refrain from trying to connect, which is a great feature when you're working on a laptop at 39,000 feet. (Choose Mailbox [image] Go Online to reverse the procedure.)
Figure 19-4. A message has two sections: the header, which holds information about the message; and the body, the big empty white area that contains the message itself. In addition, the Mail window has a toolbar, which you can use to access other features for composing and sending messages. The Signature pop-up menu doesn't exist until you create a signature (Section 19.3.2).

The Mighty Morphing Interface

You don't have to be content with the factory-installed design of the Mail screen; you can control almost every aspect of its look and layout.

For example, you can control the main window's information columns exactly as you would in a Finder list view window—make a column narrower or wider by dragging the right edge of its column heading, rearrange the columns by dragging their titles, and so on. You can also control which columns appear, using the Hide and Show commands in the View menu. Similarly, you can sort your email by clicking these column headings, exactly as in the Finder (click a second time to reverse the sorting).

The various panels of the main window are also under your control. For example, you can drag the divider bar—between the list of messages and the Preview pane—up or down to adjust the relative proportions, as shown here. In fact, you can get rid of the Preview pane altogether just by double-clicking the divider line, double-clicking just above the vertical scroll bar, or dragging the divider line's handle all the way to the bottom of the screen. (Bring it back by dragging the divider line back up from the bottom.)

You can also control the mailbox's drawer. Drag its outer edge inward or outward to make the drawer wider or narrower, for example. You can even make the drawer disappear or reappear completely by clicking the Mailbox icon on the toolbar.

If you'd like to swap the drawer to the other side of the main window, drag a message in the main message list horizontally toward the side where you want the drawer to appear.

Finally, you have full control over the toolbar, which works much like the Finder toolbar. You can rearrange or remove icon buttons (by [image] -dragging them); add interesting new buttons to the toolbar (choose View [image] Customize Toolbar); change its display to show just text labels or just icons—either large or small (by repeatedly [image] -clicking the white, oval, upper-right toolbar button); or hide the toolbar entirely (by clicking that white button or using the View [image] Hide Toolbar command). Chapter 3 offers full details on Mac OS X toolbar customization.

19.3.1 Attaching Files to Messages

Sending little text messages is fine, but it's not much help when you want to send somebody a photograph, a sound, or a Word document. To attach a file to a message you've written, use one of these methods:

  • Drag the icons you want to attach directly off the desktop (or out of a folder window) into the New Message window. There your attachments appear with their own hyperlinked icons (Figure 19-5), meaning that your recipient can simply click to open them.

  • Click the Attach icon on the New Message toolbar, choose Edit [image] Attach File, or press Shift- [image] -A. The standard Open File dialog box now appears, so that you can navigate to and select the files you want to include.

    TIP

    You can choose multiple files simultaneously in this dialog box. Just [image] -click or Shift-click the individual files you want, just as though you were selecting them in a Finder column-view window.

    Once you've selected them, click Open (or press Enter). You return to the New Message window, where the attachments' icons appear, ready to ride along when you send the message.

Figure 19-5. If you really want to use formatting, click the Fonts icon on the toolbar to open the Font panel described in Section 13.6.3, or the Colors icon to open The Color Picker. The Format menu (in the menu bar) contains even more controls—paragraph alignment (left, right, or justify), and even Copy and Paste Style commands that let you transfer formatting from one block of text to another.

To remove an attachment, drag across its icon to highlight it, and then press the Delete key. (You can also drag an attachment icon clear out of the window onto your Dock's Trash, or choose Edit [image] Remove Attachments.)

If you have a high-speed connection like a cable modem, by the way, have pity on your recipient. A big picture or movie file might take you only seconds to send, but tie up your correspondent's modem for hours.

NOTE

Mail automatically uses the MIME/Base64 encoding scheme for sending attachments. As a result, your Mac- and Windows-using correspondents will generally have no problem opening files you send.

Unfortunately, Mail offers no way to choose a different encoding scheme. Nor does Mail offer automatic compression (using StuffIt, for example); if you want to compress your files before sending them, do so using DropStuff, which you can download as part of the shareware StuffIt Lite package from www.aladdinsys.com.

Blind Carbon Copies

A blind carbon copy is a secret copy. This feature lets you send a copy of a message to somebody secretly, without any of the other recipients knowing that you did so. To view this field when composing a message, choose Edit [image] Add Bcc Header.

You can use the BCC field to quietly signal a third party that a message has been sent. For example, if you send your co-worker a message that says, "Chris, it bothers me that you've been cheating the customers," you could BCC your boss or supervisor to clue her in without getting into trouble with Chris.

The BCC box is useful in other ways, too. Many people send email messages (containing jokes, for example) to a long list of recipients. You, the recipient, have to scroll through a very long list of names the sender placed in the To or CC field.

But if the sender used the BCC field to hold all the recipients' email addresses, you, the recipient, won't see any names but your own at the top of the email. (Unfortunately, spammers, those awful people who send you junk mail, have also learned this trick.)

19.3.2 Signatures

Signatures are bits of text that get stamped at the bottom of your outgoing email messages. A signature may contain a name, a postal address, a pithy quote, or even a scan of your real signature, as shown in Figure 19-4.

To create a signature, choose Mail [image] Preferences, and then click the Signatures icon (Figure 19-6). You can create any number of signatures by clicking the Add Signature button, which opens an editing window in which you can type your new signature and define a name for it.

Once you've created a signature or two, you can tack one of them onto your outgoing mail—either always or on a message-by-message basis.

  • Always append a signature. On the Signatures preference screen (Figure 19-6, top), use the Select Signature pop-up menu to choose the signature that you'd like to have at the bottom of every email message. (You can always override this choice on a message-by-message basis.)

    TIP

    If you use the Select Signature pop-up menu to choose Randomly or Sequentially, Mail will choose a different one of these gems to grace the bottom of each email message that you send out. This is the way to rotate your quotes from, say, Monty Python, without seeming repetitive to your correspondents.

  • Message by message. On the Signatures preference screen, turn on "Show signature menu on compose window." From now on, a Signature pop-up menu appears just above the message-body area on every outgoing email note. When you choose from it, Mail pastes the signature at the bottom of the message.

Figure 19-6. Top: Your list of signatures and the doorway to the signature-creation box. Bottom: After typing some signature material, don't miss the Format menu, which you can use to dress up your signature with colors and other formatting. You can even drag or paste a picture into the signature box. Click OK when you're finished. (You'll be able to use formatted signatures only if you're sending Rich Text messages, of course.)
    [ Team LiB ]


19.4 Reading Email

Mail puts all the email you get into your Inbox; the statistic in parentheses after the word Inbox lets you know how many of its messages you haven't yet read. New messages are also denoted by colorful, liquidy dots in the main list.

TIP

The Mail icon in the Dock also shows you how many new messages you have waiting—it's the number in the red circle, as shown in Figure 19-7.

Click the Inbox folder to see a list of received messages. If it's a long list, press Control-Page Up and Control-Page Down to scroll. Click the name of a message once to read it in the Preview pane, or double-click a message to open it into a separate window.

TIP

Instead of reading your mail, you might prefer to have Mac OS X read it to you, as you sit back in your chair and sip your strawberry daiquiri. Just Control-click inside the Preview pane and choose Speech [image] Start Speaking from the contextual menu. You'll hear the message read aloud, in the voice you've selected on the Speech pane of System Preferences (Chapter 8).

To stop the insanity, choose Speech [image] Stop Speaking from the same contextual menu.

Once you've viewed a message, you can respond to it, delete it, print it, file it, and so on. The following pages should get you started.

All the Little Symbols

The first column of the main email list shows little symbols that let you know at a glance how you've processed certain messages. The most common one is, of course, the gelatinous blue dot ( [image]), which means "new message." (After reading a message, you can mark it once again as an unread message by choosing Message [image] Mark As Unread—or Control-clicking the message's name and choosing Mark As Unread from the contextual menu.)

You might also see these symbols, which represent messages that you've replied to ( [image]), forwarded ( [image]), redirected ( [image]), or flagged ( [image]).

Incidentally, you may have noticed that, by default, Mail marks a message as having been read the moment you click it. You can change it back to unread, of course, by Control-clicking it—but there's also a more permanent workaround. Just double-click the divider bar above the Preview pane, which hides the Preview pane itself. Once the Preview pane is gone, Mail no longer marks messages "read" just because you clicked one in the list. (You can bring back the Preview pane by double-clicking just above the vertical scroll bar, or by dragging the divider bar back up from the bottom.)

19.4.1 Adding the Sender to Your Address Book

Mail offers a timesaving feature, the Message [image] Add Sender To Address Book command. Whenever you choose it, Mail memorizes the email address of the person whose message is on the screen. In fact, you can highlight a huge number of messages and add them all simultaneously using this technique.

Thereafter, you'll be able to write new messages to somebody just by typing the first couple letters of the name.

19.4.2 Opening Attachments

Just as you can attach files to a message, so people often send files to you. Sometimes they don't even bother to type a message; you wind up receiving an empty email message with a file attached. Only the presence of the file's icon in the message body tells you that there's something attached.

TIP

Mail doesn't ordinarily indicate the presence of attachments in the main mail list. It can do so, however. Just choose View [image] Columns [image] Attachments. A new column appears in the email list—at the far right—where you'll see a paper-clip icon and the number of file attachments listed for each message.

Mail doesn't store downloaded files as normal file icons on your hard drive. They're actually encoded right into the .mbox mailbox databases described in Secrets of the Mbox Files. To extract an attached file from this mass of software, you must proceed in one of these ways:

  • Drag the attachment icon out of the message window and onto any visible portion of your desktop, as shown in Figure 19-7.

  • Double-click the attachment's icon in the message. If you were sent a document (such as a photo, Word file, Excel file, and so on), it now opens in the corresponding program (Preview, Word, Excel, or whatever).

    WARNING

    After the attachment is open, use the File [image] Save As command to save the file into a folder of your choice. Otherwise, any changes you make won't be visible in the file except when you open it from within Mail.

Figure 19-7. Dragging an attachment's icon onto your desktop takes the file out of the Mail world and into your standard desktop world, where you can file it, trash it, open it, or manipulate it as you would any file.
19.4.2.1 When attachments don't open

Several factors may be at work if you're unable to open a file attachment. For starters, your correspondent's email program may have compressed or encoded the file to make it take less time to send. If you're having trouble getting a file to open, therefore, your first step should be to drag the attachment's icon onto that of StuffIt Expander, which is in your Applications [image] Utilities folder. This little program can gracefully re-expand just about any geeky Internet file. (Real Mac OS X masters simplify their lives by parking Expander on the Dock for easy drag-and-drop access.)

If the file still won't open, then you may be dealing with a file from a Windows PC that requires a little more effort to open. For example:

  • .exe denotes an executable file—in other words, a Windows program. By itself, your Mac can't run Windows programs, just as Windows computers can't run Macintosh programs.

  • .html. A file whose name ends in .html or .htm is a Web page. In the beginning, Web pages hung out only on the Internet. These days, however, you're increasingly likely to find that you've downloaded one to your Mac's hard drive (it may be a software manual for some shareware, for example). You can open it just by double-clicking; Mac OS X comes set to open all .htm and .html files into your Web browser.

  • .vcf. A "business-card" file; see Section 19.6.2.

If you were sent a file with a three-letter code not listed here, you may well have yourself a file that can be opened only by a Windows program that you don't actually own. You might consider asking your correspondent to resend it in one of the more universal formats, such as the graphics formats JPEG and TIFF, and the text formats RTF, TXT, and PDF. (Mac OS X opens all of these formats easily.)

The Resend Command

Hey, what happened to the Resend command? What if I want to resend a message, or send it to somebody new after I've already sent it once?

No problem. Just Option-double-click the message in your Sent mailbox. Mail dutifully opens up a brand-new duplicate, ready for you to edit, readdress if you like, and then send again.

(The prescribed Apple route is to highlight the message and then choose File [image] Open As New Message, but that's a lot more trouble.)

19.4.3 Replying to a Message

To answer a message, click the Reply button on the message toolbar (or choose Message [image] Reply To Sender, or just press [image] -R). If the message was originally addressed to multiple recipients, you can send your reply to everyone simultaneously by clicking the Reply to All button instead.

A new message window opens, already addressed. As a courtesy to your correspondent, Mail places the original message at the bottom of the window, denoted by brackets or a vertical bar, as shown in Figure 19-8.

TIP

If you highlight some text before clicking Reply, Mail pastes only that portion of the original message into your reply. That's a great convenience to your correspondent, who now knows exactly which part of the message you're responding to.

At this point, you can add or delete recipients, edit the Subject line or the original message, attach a file, and so on.

TIP

Use the Return key to create blank lines in the original message. Using this method, you can splice your own comments into the paragraphs of the original message, replying point by point. The brackets preceding each line of the original message help your correspondent keep straight what's yours and what's hers.

When you're finished, click Send. (If you click Reply All in the message window, your message goes to everyone who received the original note, even if you began the reply process by clicking Reply. Mac OS X, in other words, gives you a second chance to address your reply to everyone.)

Figure 19-8. In Rich Text-formatted Mail messages (not to be confused with RTF [Rich Text Format] word processing format, which is very different), a reply includes the original message, marked in a special color (which you can change in Mail Preferences) and with a vertical bar to differentiate it from the text of your reply. (In plain-text messages, each line of the reply is >denoted >with >brackets, although only your recipient will see them.) The original sender's name is automatically placed in the To field. The subject is the same as the original subject with the addition of Re: (shorthand for Regarding). You're ready to type your response.

19.4.4 Forwarding Messages

Instead of replying to the person who sent you a message, you may sometimes want to pass the note on to a third person.

To do so, click the Forward toolbar button (or choose Message [image] Forward Message, or press Shift- [image] -F). A new message opens, looking a lot like the one that appears when you reply. You may wish to precede the original message with a comment of your own, along the lines of: "Frank: I thought you'd be interested in this joke about Congress."

Finally, address it as you would any outgoing piece of mail.

19.4.5 Redirecting Messages

A redirected message is similar to a forwarded message, with one extremely useful difference. When you forward a message, your recipient sees that it came from you. When you redirect it, your recipient sees the original writer's name as the sender. The message bears no trace of your involvement (unless the recipient thinks to choose View [image] Show All Headers). In other words, a redirected message uses you as a low-profile relay station between two other people.

Treasure this feature. Plenty of email programs, including Outlook and Outlook Express for Windows, don't offer a Redirect command at all. You can use it to transfer messages from one of your own accounts to another, or to pass along a message that came to you by mistake.

To redirect a message, choose Message [image] Redirect Message, or press Shift- [image] -E. You get an outgoing copy of the message—this time without any quoting marks. (You can't edit redirected messages, since they're supposed to end up at their destination intact.)

19.4.6 Printing Messages

Sometimes there's no substitute for a printout. Choose File [image] Print, or press [image] -P to summon the Print dialog box (Section 13.2.2).

19.4.7 Filing Messages

Mail lets you create new mailboxes in the drawer. You might create one for important messages, another for all order confirmations from Web shopping, still another for friends and family, and so on. You can even create mailboxes inside these mailboxes, a feature beloved by the hopelessly organized.

To create a new mailbox folder, choose Mailbox [image] New Mailbox. The Mac asks you to title the new mailbox. If you have more than one email account, it lets you specify which one will contain the new folder. (The dialog box also points out that you can create folders inside folders by using slashes. For example, if you type Work/Urgent, you'll get two new folders—one called Work, and another inside it called Urgent.)

When you click OK, a new icon appears in the mailbox drawer, ready for use.

TIP

The Mailbox menu also contains the commands you need to rename or delete an existing mailbox. You can also drag the mailbox icons up and down in the drawer to place one inside of another.

You can move a message (or group of messages) into a mailbox in any of three ways:

  • Drag it out of the list pane onto the mailbox icon (Figure 19-9).

  • Highlight one or more messages in the list pane and then choose from the Message [image] Transfer submenu, which lists all your mailboxes.

  • Control-click a message (or one of several that you've highlighted). From the resulting contextual menu, choose Transfer, and then choose the mailbox you want from the submenu.

Figure 19-9. You can use any part of a message's "row" in the list as a handle; the little envelope cursor tells you that Mail knows what's happening. You can also drag messages en masse onto a folder. If you Option-drag a message into a folder, you make a copy, leaving the original message where it was.

19.4.8 Flagging Messages

Sometimes you'll receive email that prompts you to some sort of action, but you may not have the time (or the fortitude) to face the task at the moment. ("Hi there... it's me, your accountant. Would you mind rounding up your expenses for 1993 through 2002 and sending me a list by email?")

That's why Mail lets you flag a message, summoning a little flag icon in a new column next to a message's name. These indicators can mean anything you like—they simply call attention to certain messages. You can sort your mail list so that all your flagged messages are listed first (click the flag at the top of the column heading), for example.

To flag a message in this way, select the message (or several messages) and choose Message [image] Mark As Flagged, or press Option- [image] -G, or Control-click the message's name in the list and choose Mark As Flagged from the contextual menu. (To clear the flags, repeat the procedure, but use the Mark As Unflagged commands instead.)

19.4.9 Finding Messages

As noted earlier in this chapter, you can sort the columns in your main email list just by clicking the headings (From, Subject, Date & Time, and so on).

But when you deal with masses of email, you may find it easier to process your messages using any of Mail's three message-finding methods.

19.4.9.1 Finding messages within a mailbox

See the little text box in the upper-right corner of your main mail window? You can use it to hide all but certain messages, as shown in Figure 19-10.

TIP

You can also set up Mail to show you only certain messages that you've manually selected, hiding all others in the list. To do so, highlight the messages you want, using the techniques described in Section 2.3. Then choose View [image] Focus On Selected Messages. (To see all of them again, choose View [image] Show All Messages.)

Figure 19-10. Top: Use the pop-up menu to specify how you want to filter your email list (message body, subject, recipient, or sender), and whether you want to search just the current mailbox or all mailboxes. Type the text you're looking for in the Subject box. Bottom: As you type, Mail shrinks the list of email messages in real time, so that you're looking at only the ones matching what you typed. (In this case, messages with the word of in the subject line.) To return to seeing all of your messages, click the tiny X at the right side of the search box.
19.4.9.2 Finding text within an open message

You can also search for certain text within a single message. Choose Edit [image] Find (or press [image] -F) to bring up the Find panel shown in Figure 19-11.

Figure 19-11. The Find panel works just as it might in a word processor, except that the Replace function works only on messages that you have written yourself. Mail doesn't let you change the words of mail you've received.

19.4.10 Deleting Messages

Sometimes it's junk mail. Sometimes you're just done with it. Either way, it's a snap to delete a selected message, several selected messages, or a message that's currently before you on the screen. Use any of these methods:

  • Press the Delete key.

  • Click the Delete button on the toolbar.

  • Choose Message [image] Delete.

  • Drag a message (or several selected messages) out of the list window and into your Trash mailbox—or even onto the Dock's Trash icon.

    TIP

    If you delete a message by accident, the Undo command (Edit [image] Undo or [image] -Z) restores it.

All of these commands move the messages to the Trash folder. If you like, you can click its icon to view a list of the messages you've deleted. You can even rescue messages by dragging them into any other mailbox (such as right back into the In box).

19.4.10.1 Emptying the Trash folder

Mail doesn't vaporize messages in the Trash folder until you "empty the trash." You can empty it in any of several ways:

  • Click a message, or a folder, within the Trash folder list and then click the Delete icon on the toolbar (or press the Delete key). Now it's really gone.

  • Choose Mailbox [image] Erase Deleted Message ( [image] -K).

  • Control-click the Trash mailbox icon and choose Erase Deleted Messages from the contextual menu.

  • Wait. Mail will permanently delete these messages automatically after a week.

    If a week is too long (or not long enough), you can change this interval. Choose Mail [image] Preferences, double-click the account name, click Special Mailboxes, and set the "Erase deleted messages when" pop-up menu. It offers choices like "Never," "One day old," "One week old," "One month old," and "Quitting Mail" (which makes the program delete your deleted messages every time you quit the program).

19.4.10.2 Method 2: Deleted mail turns invisible

Mail offers a second—and very unusual—method of deleting messages that doesn't involve the Trash folder at all. Using this method, pressing the Delete key (or clicking the Delete toolbar button) simply hides the selected message in the list. Hidden messages remain hidden, but don't go away for good until you use the Rebuild Mailbox command described in Rebuilding Your Mail Databases.

If this arrangement sounds useful, choose Mail [image] Preferences, double-click the account name, click Special Mailboxes, and turn off the checkbox called "Move deleted mail to a separate folder" or "Move deleted messages to the Trash mailbox," depending on what kind of email account you have. From now on, messages you delete simply vanish from the list.

They're not really gone, however. You can bring them back, at least in ghostly form, by choosing View [image] Show Deleted Messages (or pressing [image] -L). Figure 19-12 shows the idea.

Using this system, in other words, you never truly delete messages; you just hide them.

At first, you might be concerned about the disk space and database size involved in keeping your old messages around forever like this. The truth is, however, that Mac OS X is perfectly capable of maintaining many thousands of messages in its mailbox databases. Meanwhile, there's a huge benefit to this arrangement: Almost everyone, sooner or later, wishes they could resurrect one deleted message or another—maybe months later, maybe years later. Using the hidden-deleted-message system, your old messages are always around for reference.

When you do want to purge these messages for good, you can always return to the Special Mailboxes dialog box and turn the "Move deleted mail to a separate folder" checkbox back on.

Figure 19-12. The grayish type indicates deleted messages. (It may be difficult, in this grayscale illustration, to see the difference between green junk mail and gray deleted mail, but you'll see it on your screen.) You can bring any of them back from the world of the dead by selecting them and then choosing Message Undelete (or just pressing Shift- -U), or choosing the same command from the contextual menu. The gray type turns to black, and the message is alive and well once again.

19.4.11 Using Message Rules

Once you know how to create folders, the next step in managing your email is to set up a series of message rules (filters) that file, answer, or delete incoming messages automatically based on their contents, such as their subject, address, or size. Message rules require you to think like the distant relative of a programmer, but the mental effort can reward you many times over; message rules turn Mail into a surprisingly smart and efficient secretary.

Secrets of the Mbox Files

As noted earlier in this chapter, Mail keeps your messages in a series of mailbox database files in your Home [image] Library [image] Mail [image] Mailboxes folder, inside folders named for your accounts. (The files within—Outbox, Sent Messages, and so on—are packages, as described in When Programs Are Actually Folders. To see the actual .mbox files inside of one, Control-click its icon and choose Show Package Contents.)

Knowing this permits you to perform a number of interesting tricks. First of all, now you know what files to back up for safekeeping.

Second, you now have yourself a beautiful monthly archiving system. Each month, create a new mailbox folder in Mail, named for a certain month ("June2002.mbox"). Drag into it all the mail you want to archive, and then back up just that mailbox file from your hard drive—instant archiving system! (If you ever want to work with these messages again, just drag that .mbox file back into your Home [image] Library [image] Mail folder before opening Mail.)

Third, now you know which files to copy to your laptop to maintain email continuity when you travel.

19.4.11.1 Setting up message rules

Here's how to set one up:

  1. Choose Mail [image] Preferences. In the Preferences dialog box, click the Rules icon.

    The Rules dialog box appears, as shown at top in Figure 19-13.

  2. Click Add Rule.

    Now the dialog box shown at bottom in Figure 19-13 appears.

  3. Use the Criteria options to specify how Mail should select messages to process.

    For example, if you'd like the program to watch out for messages from a particular person, you would set up the first two pop-up menus to say "From" and "Contains," respectively.

    To flag messages containing loan, $$$$, XXXX, !!!!, and so on, set the pop-up menus to say "Subject" and "Contains."

    In fact, you can set up multiple criteria here, so that you flag messages whose subjects contain any one of those common spam triggers. (If you change the "any" pop-up menu to say "all," then all of the criteria must be true for the rule to kick in.)

  4. Specify which words or people you want the message rule to watch for.

    In the text box to the right of the two pop-up menus, type the word, address, name, or phrase you want Mail to watch for—a person's name, or XXXX, in the previous examples.

  5. In the lower half of the box, specify what you want to happen to messages that match the criteria.

    If, in Steps 1 and 2, you've told your rule to watch for junk mail containing $$$$ in the Subject line, here's where you can tell Mail to delete it or move it into, say, a Junk folder.

    With a little imagination, you'll see how the options in this pop-up menu can do absolutely amazing things with your incoming email. Mail can colorize, delete, move, redirect, or forward messages—or even play a sound when you get a certain message. (Consider, for example, what happens when you go on a trip. By setting up the controls as shown in Figure 19-13, you have specified that messages your boss, Chris Herbert, sends to your .Mac account are to be redirected to your vacation email address, feelio@yahoo.com. The rest of the mail will just have to wait until you're home again.)

  6. In the very top box, name your mail rule. Click OK.

    Now the Rules dialog box appears (Figure 19-13, top). Here you can choose a sequence for the rules you've created by dragging them up and down. Here, too, you can turn off the ones you won't be needing at the moment, but may use again one day.

    TIP

    Mail applies rules as they appear, from top to bottom, in the list. If a rule doesn't seem to be working properly, it may be that an earlier rule is intercepting and processing the message before the "broken" rule even sees it. To fix this, try dragging the rule up or down in the list.
Figure 19-13. Top: Mail rules can screen out junk mail, serve as an email answering machine, or call important messages to your attention. All mail message rules you've created appear in this list. (The color shading for each rule is a reflection of the colorizing options you set up, if any.) Bottom: Double-click a rule to open the Edit Rule dialog box, where you can specify what the rule does.

The Email Answering Machine

If you're going on vacation, you can turn Mail into an email answering machine that sends a canned "I'm away until the 15th" message to everyone who writes you.

To do so, set the pop-up menus in the Rules dialog box so that they say "To or Cc" and "Contains"; type your own email address in the text box. In the bottom half of the dialog box, turn on the Reply checkbox. Click "Set message" and type your boilerplate reply in the resulting box.

Important: If you subscribe to mailing lists, set up another mail rule that intercepts and files them before your answering-machine rule kicks in. Otherwise, you'll incur the wrath of the other Internet citizens by littering their email discussion groups with copies of your auto-reply message.


19.5 The Spam Filter

Many of the improvements Apple made in the 10.2 version of its Mail program are tiny tweaks. A few examples: You can Control-click almost anything to see a pop-up menu of useful commands; a little orange symbol next to somebody's name lets you know when one of your iChat buddies is online; and the program remembers the positions of your open windows.

Canning Spam

Help! I'm awash in junk email!

The Junk filter goes a long way toward cleaning out the spam from your mail collection. But because it doesn't catch everything, you're better off avoiding getting spam to begin with. For example:

  • If you have more than one email account, consider using one just for online shopping, Web site and software registration, and newsgroup posting. Spammers have automated software robots that scour every public Internet message and Web page, recording email addresses they find. These are the primary sources of spam, so at least you're now restricting the junk mail to one secondary mail account. (Reserve a separate email account for person-to-person email.)

  • When filling out forms online, turn off the checkboxes that say, "Yes, send me exciting offers and news from your partners."

  • When posting messages in a newsgroup, insert the letters NOSPAM somewhere into your email address. Anyone replying to you via email must delete the NOSPAM from your email address, which is a slight hassle. Meanwhile, however, the spammers' software robots will lift a bogus email address from your newsgroup posts.

Finally, don't miss the Message [image] Bounce to Sender command. This juicy Mail bonus sends a junk message back to the sender, coded as though it had reached a nonworking email address. Not only are the spammers inconvenienced, but they may take your name off their list.

19.5.1 Using the Junk Mail Filter

The most talked-about item, though, is the new Junk Mail Filter. You'll see its effects the first time you check your messages: A certain swath of message titles appear in color. These are the messages that Mail considers junk.

During your first couple of weeks with Mail, your job is to supervise Mail's coloring job. That is, if you get spam that Mail misses, click the message and then click the Junk button at the top of its window (identified in Figure 19-3), or the Junk icon on the toolbar. On the other hand, if Mail flags legitimate mail as spam, swat it gently on the nose and click the Not Junk button. Over time, Mail should get better and better at filtering your mail.

The only trouble with this so-called Training mode is that you're still left with the task of trashing the spam yourself. But once Mail has perfected its filtering skills to your satisfaction, choose Mail [image] Junk Mail [image] Automatic. From now on, Mail automatically files what it deems junk into a Junk Mail box, where it's much easier to scan and delete the messages en masse.

TIP

In the Rules dialog box shown in Figure 19-13, you can see that Apple performs its magic using a Junk rule. By editing it, you can make the sieve more or less restrictive. For example, you could click the + button next to one of the conditions, and then choose Account from the new pop-up menu, so that the junk mail filter applies only to one of your email accounts.

Rebuilding Your Mail Databases

As noted earlier in this chapter, Mail keeps your messages in a series of mailbox database files in your Home [image] Library [image] Mail [image] Mailboxes folder.

Over time, you add and delete hundreds of messages from these database files. Inevitably, some digital sawdust gets left behind, resulting in peculiarities when addressing messages or general Mail sluggishness. You also wind up with massive message files hidden on your hard drive, which can consume hundreds of megabytes of disk space. That's a particular bummer if you like to copy your message databases to your laptop when you go on a trip.

Fortunately, it's easy enough to rebuild the message databases. Doing so cleanses, repairs, and purges your message files. As a result, you wind up with a much more compact and healthy database.

To rebuild an email database, highlight it in the mailboxes "drawer" in Mail. (Highlight several, if you like.) Then choose Mailbox [image] Rebuild Mailbox. Mac OS X takes several minutes or hours, depending on the sizes of your mailboxes, to repair and compact your database.


19.6 Address Book

Address Book is Mac OS X's little-black-book program—an electronic Rolodex where you can conveniently stash the names, job titles, addresses, phone numbers, email addresses, and Internet chat screen names of all the people in your life (Figure 19-14). Of course, Address Book can hold other contact information too, such as birthdays and anniversaries, as well as any other scraps and tidbits of personal data you'd like to keep at your fingertips.

Once you make Address Book the central repository of all your personal contact information, you can call up this information in a number of convenient ways:

  • You can launch Address Book and search for a contact by typing just a few letters in the Search box.

  • When you're composing messages in Mac OS X's Mail program, Address Book automatically fills in email addresses for you.

  • When you use iChat to exchange instant messages with people in your Address Book, the pictures you've stored of them automatically appear in chat windows.

  • Address Book can send its information to an iPod, giving you a little white "little black book" that fits in your shirt pocket, can be operated one-handed, and comes with built-in musical accompaniment. (The easiest way is to use iSync, described at the end of Chapter 18.)

  • If you have a Bluetooth cell phone, Address Book can exchange information with your phone and even dial it for you. Incoming calls to your phone wirelessly trigger Address Book to display the number or name of the caller. Using the same wireless connection, you can also exchange contact info between Address Book and Palm-compatible handhelds.

Address Book got a major overhaul—and a slew of new features—in Mac OS X 10.2. You can find the program in your Applications folder, or you can open it from within Mail by choosing Window [image] Address Book.

Figure 19-14. The big question: Why isn't this program named iContact? With its three-paned view, soft rounded buttons and brushed-aluminum style windows, it certainly looks like a close cousin of iPhoto and iTunes.

19.6.1 Creating Address Cards

Each entry in your Address Book is called a card—essentially an electronic version of a paper Rolodex card, with predefined spaces to hold all the standard contact information.

To add a new person to your collection of contacts, choose File [image] New Card, or press [image] -N, or click the + button beneath the Name column. Then type in the contact information, pressing the Tab key to move from field to field. If one of your contacts happens to have three office phone extensions, a pager number, two home phone lines, a cell phone and a couple of fax machines, no problem—you can add as many fields as you need, as shown in Figure 19-15.

Figure 19-15. Don't be fooled by the fact that there are only two phone fields visible when you first create a new address card; you can add as many more fields as you want. Click the little round + buttons when editing a card to add more phone, email, chat name, and address fields. (The buttons appear only when existing fields are filled.) Click a field's name to change its label. You can select one of the standard labels from the pop-up menu—home, work, and so on—or make up your own labels by choosing Custom, as seen in the lower portion of this figure.

Each card also contains a freeform Notes field at the bottom, where you can type any other random crumbs of information you'd like to store about the person (spouse's name, embarrassing nicknames, favorite Chinese restaurant, and so on).

TIP

You can drag text clippings or selected text from other drag-and-drop aware programs directly into the Notes field.

19.6.1.1 Editing an address

When you create a new address card, you're automatically in Edit mode, which means you can add and remove fields and change the information on the card. As soon as you perform a search or select another address card, however, Address Book flips into Browse Mode, where you can view and copy contact information but not change it. To return to Edit mode, choose Edit [image] Edit Card, or click the Edit button at the bottom of the Address Book window. You can flip back and forth between Edit and Browse modes by pressing [image] -L.

TIP

Regardless of what mode you're in—Edit or Browse—you can always type, drag, or paste text into the Notes field of an address card.

Figure 19-16. This example shows three other types of fields that you can plug into your address cards. The phonetic first/last name fields (shown at top) let you store phonetic spellings of hard-to-pronounce names. The other two fields store birthdays and screen names for instant messaging networks such as Jabber and Yahoo (not that you would ever use anything but iChat, of course).
19.6.1.2 Adding addresses from Mail

You can also send new contacts to the Address Book directly from the Mail program, saving you the trouble of having to manually type names and email addresses. Select an email message in Mail, then choose Message [image] Add Sender to Address Book (or press [image] -Y) and you're done. A new card is automatically added to the Address Book, with the name and email address fields already filled in. (Later, you can edit the card in Address Book to add phone numbers, street addresses, and so on.)

19.6.2 Importing Addresses

The easiest way to add people to Address Book is to import them from another program. If you've already got contacts in a program like Entourage, Outlook Express, or Palm Desktop, you're in luck: You can load your existing contacts right into Address Book without having to retype a single entry.

Address Book isn't smart enough to read an Entourage or Outlook Express database—it can only import files in vCard format or the less commonly used LDIF format. But Mac OS X 10.2 comes with a handy AppleScript that lets you import addresses from six of the most popular contact manager programs: Entourage, Outlook Express, Palm Desktop, Eudora, Claris Emailer, and Netscape.

The script you need is called Import Addresses. It's in your Library [image] Scripts [image] Mail Scripts folder. Just double-click it and follow the prompts. A minute or two later, you'll have all your old contacts safely transferred into Address Book.

TIP

If you're using Mac OS X's Script Menu feature, as explained in Section 7.1, you can access the Import Addresses script directly from the Scripts menu on the Finder menu bar.

19.6.2.1 About vCards

Address Book can exchange contact information with other programs primarily through vCards. vCard is short for virtual business card. More and more email programs send and receive these electronic business cards, which you can easily spot by the .vcf extension on their names.

If you ever receive an email to which a vCard file is attached, drag the .vcf file into your Address Book window to create an instant entry with a complete set of information. You can create vCards of your own, too: just drag a name out of your Address Book and onto the desktop (or into a piece of outgoing mail).

The Windows-to-Address Book Journey

Getting names and addresses out of one Mac program and into another is one thing, but what if your contacts are stored on a Windows computer running Microsoft Outlook—the most-used contact manager in the world?

Fortunately, there's a way to grab all those phone numbers and email addresses out of Outlook and slide them into Address Book without having to manually re-enter any of the information—but the journey isn't exactly a one-click operation. Outlook for Windows, it turns out, can't export contacts as .vcf files (the format that Address Book requires for import) as a group—only one by one, and who's got the time for that?

The easiest way is to email yourself all your contacts. For reasons known only to a handful of Microsoft engineers, Outlook can't export contacts as vCards, but it can email them as vCard attachments. Select all your contacts in Outlook, then choose Action [image] Forward as vCard. You'll end up with an email containing lots of little .vcf attachments. Send this email to yourself, then open the message and drag the attached .vcf files straight into Address Book. (If you have more than a couple hundred contacts, you might want to do them in a few batches, rather than create an email with 700 attachments.) Odd though it is, this is the least labor-intensive way to import a large number of addresses from Outlook.

There's one other option, but it requires that you have either Outlook Express or Entourage on your Mac. Use Outlook's Export command to create a tab-delimited text file containing all your contacts, then copy the text file to your Mac. Address Book can't do anything with this text file, but Outlook Express and Entourage can.

Choose File [image] Import in either program to get the process going. You'll have to step through an ugly Import dialog box like the one shown here to map the Outlook fields to the Mac program, but you should be able to successfully get all your contacts transferred intact. The final step is to use the Import Addresses script described in the "Importing Addresses" section above to move the addresses from Outlook Express or Entourage into Address Book.

19.6.3 Adding Pictures

You can dress up each Address Book entry not only with textual information, but also with a photo. Whenever you're editing somebody's address book card, just drag a digital photo—preferably 64 pixels square, or a multiple of it—into the "picture well" just to the left of the person's name, as shown in Figure 19-15. Or click the picture well and browse to the picture via a standard Open dialog box.

NOTE

The pictures you add to Address Cards have to be in JPEG, GIF, TIFF, PNG, or PDF format.

You don't necessarily have to use an actual photo, of course. You can add any graphic that you want to represent someone, even if it's a Bart Simpson face or skull and crossbones.

From now on, if you receive an email from that person, the photo shows up right in the email message (if you're lucky; this feature has a reputation for flakiness). And in iChat, the photo appears next to each utterance of that person.

TIP

If you've got your snapshots organized with iPhoto, it's particularly easy to add a picture to any address card. You can drag directly from the main iPhoto window to the picture frame on the address card to insert it.

19.6.3.1 Replacing and removing a picture

To replace a photo that you've attached to an address card, just drag a new image on top of the old one. If you want to get rid of an existing picture without replacing it, select the card, then choose Card [image] Clear Custom Image.

19.6.4 Setting Up Groups

A group is a collection of related address cards, saved under a single descriptive name. Organizing your contact entries into groups can make them much easier to find and use—especially when your database of names and addresses climbs into the hundreds. For example, if you regularly send out a family newsletter to 35 relatives, you might gather the address cards of all your assorted siblings, cousins, nieces, nephews, uncles, and aunts into a single group called Family. When addressing an outgoing message using Mail, you can type this group name instead of having to painstakingly fill in the addresses of everybody who's supposed to get the newsletter. A person can be a member of as many different groups as you want.

To create a group, click the + button at the bottom of the Group column in the Address Book window, or choose File [image] New Group, or press Shift- [image] -N. Type a name for the newly spawned group icon in the Group column, and then populate it with address cards by dragging entries from the Names list into the group. If you're familiar with iTunes or iPhoto, you'll feel right at home doing this; it's just like adding photos to an album, or songs to a playlist. Clicking on a group name automatically locates and displays (in the Names column) all the names that are a part of that group—and hides any that aren't.

TIP

To turn a set of address cards into a group very quickly, select multiple entries from the Names column—by either Shift-clicking the names (to make contiguous selections) or [image] -clicking (for non-contiguous selections)—then choose File [image] New Group From Selection. You end up with a new group containing all the selected names.

19.6.4.1 Removing someone from a group

To take someone out of a group, first click the group name in the Group column, then click the person's name in the Name column and press the Delete key. Cutting someone from a group doesn't remove his record from your Address Book—just his membership in that particular group list.

NOTE

Be careful with that Delete key! Deleting a name when a group is selected in the Groups column simply removes the entry from the group list. But pressing Delete when All is selected in the Group column completely deletes the record from the Address Book. You have one chance to get it back: Use the Edit [image] Undo Delete command ( [image] -Z).

19.6.5 Finding an Address

Search for an Address Book entry just by typing a few letters of a name or address, or any other snippet of contact information into the capsule-shaped Search box on the toolbar (see Figure 19-17).

Figure 19-17. With each letter you type, Address Book filters through all your entries and displays the number of matching address cards just to the left of the search field. The matching records themselves appear in the Name column, with the first of the matching card entries displayed in the main window.

TIP

No need to click in the search field to start doing a search; just press [image] -F to jump directly to the search field and start typing.

If Address Book finds more than one matching card, click the arrow buttons at the bottom of the window to move from card to card. You can also press Return to browse among the matching card entries (or Shift-Return to move backward through them).

Once you've found the card you're looking for, you can perform some interesting stunts. If you click the label of a phone number, for example, you see the Large Type option: Address Book displays the number in an absurdly gigantic font that fills the entire width of your screen, making it all but impossible to misread the number as you dial the phone across the room. You can also click the label of an email address to create a pre-addressed email message, or click a home page label to launch your Web browser and go to somebody's site. Clicking on an address label even gives you the option of getting a map of the address via your Web browser (Figure 19-18).

You can also copy and paste (or drag) address card info into another program or convert it into a Sticky Note, as shown in Figure 19-18(bottom).

Figure 19-18. Top: The options that become available when you click the field labels on an address card vary according to field type. Pop-up menus let you send email, open Web pages, or view a map, depending on the field you've clicked. Bottom: One easy way to extract contact information from Address Book is to export an address card as a Sticky Note. Click on the card you want to copy, press -A to select all the card content, then choose Address Book Services Make New Sticky Note (or press Shift- -Y) to generate a fresh sticky note containing all the selected contact info.

19.6.6 Changing the Address Book Display

You can't do much to customize Address Book's appearance, but the Preferences panel (choose Address Book [image] Preferences) gives you at least a couple of options that are worth checking out:

  • Display order. Choose to have names displayed with the first name followed by the last name, or vice versa.

  • Sort order. Sort the entries in Address Book by either first or last name.

  • Font size. Choose from Regular, Large or Extra Large. Unfortunately, you can't change anything else about the font used in the Address Book; the color, face and style are all locked down.

19.6.7 Printing Options—or Lack Thereof

With Address Book, you get only two choices when it comes to printing: You can print out a phone list, or you can print out an email address list. Although Address Book lets you store street addresses, home pages, iChat screen names, and other notes, you can't print this information.

To print either the phone or email list, choose File [image] Print. In the Print dialog box, switch the printing options pop-up menu from Copies & Pages to Address Book, then select either Phone List or Email List from the Print pop-up menu.

If you do want to print more than just phone numbers or email addresses, your only option is to export your contacts as vCards (Section 19.6.2), and then import the vCards into a program like Entourage, which includes a much wider range of printing options.

19.6.8 Backing Up Your Addresses

When you think about it, the contents of your Address Book may represent years of typing and compiling effort. Losing all that information to a corrupted database—or a hard drive crash—could be devastating. Here are two ways to protect your Address Book data:

  • Use the Backup command. Periodically choose File [image] Backup Database when running Address Book. If something goes wrong—say, a batch of important contacts get inadvertently deleted—you can go back to a previously saved version to rescue the data by choosing File [image] Revert to Database Backup.

  • Make a backup copy of your entire Address Book database. Inside your Home folder, go to Library [image] Application Support [image] AddressBook. Copy the contents of the whole AddressBook folder and put the copy on another disk—burn it to a CD, download it to your iPod, or upload it to a file server, for example. Now your contact data is safe even in the event of a hard drive crash.

19.6.9 Address Book and Bluetooth

Address Book can do far more than just store, retrieve, and display phone numbers. It can actually dial them using your cell phone, thanks to the Bluetooth wireless technology.

19.6.9.1 Getting Bluetooth-enabled

To make Address Book talk to the outside world in this way, you have to pair it with a Bluetooth-enabled cell phone. (And your Mac, of course, must have a Bluetooth USB adapter installed—such as Apple's $50 model.) Once you've plugged in and turned on all the hardware, your cell phone and Mac have to "find" each other on the wireless network—a task managed by the Bluetooth pane of System Preferences.

Once you've got your computer and phone connected, launch Address Book. You'll see a Bluetooth logo in the Address Book window, letting you know that your phone and computer "see" each other and that you can now make calls and send cell phone messages from your computer.

19.6.9.2 Dialing with Address Book

To make a phone call, click any phone-number field label on an address card and choose Dial from the pop-up menu. Then pick up your cell phone and wait for the person you're calling to answer.

You can also use Address Book to send SMS text messages directly to other cell phones. (SMS stands for "short message service," and refers to the feature of cell phones that lets you send and receive short text messages.) To send an SMS message, click a phone number field label on an address card and choose Send SMS Message from the pop-up menu. Type your message and send it off. Of course, this works only if you transmit the text message to a cell phone that also has SMS message capabilities.

Counting Your Contacts

After you've spent a little time with Address Book, it'll hit you: There's absolutely no way to tell how many address cards you've got in there. The program has no status bars or any other indicators displaying a record count.

There is, however, one simple way to get a quick count of your addresses. Make sure the Group column is set to All, so that you can see all the address cards you've created. Click in the Name column and press [image] -A to select all the names in your list. Now, with the names still selected, start dragging them—as if you were going to add them to a group folder or drop them on the desktop—but don't release the mouse button. As soon as you start dragging, the little badge that appears just under the pointer tells you the total number of all your contacts (because you had them all selected before you started dragging). Once you get the record count, drop the files back in the Name column.

19.6.9.3 Receiving calls

Once your cell phone and Mac have met, Address Book can notify you of incoming calls, too. It's Caller ID on the Mac!

When a call comes in, a window opens (assuming Address Book is open), showing the caller's number in jumbo type . If it's somebody in your Address Book, you even see the caller's name.

Click Answer and then pick up your cell phone to begin your conversation. If you click Send to Voicemail instead, your phone stops ringing and you dump the caller into your cell service's answering machine, just as though you'd pressed the Voicemail button on the phone.

Sometimes, you may prefer to send the caller to voice mail and create a new SMS message to reply. In that case, click Send SMS Reply. This way, you shut up the ringing phone while your family is sleeping, but still manage to type out a reply (like "It's 3:35 AM, for God's sake! What are you doing!?").


Chapter 20. Sherlock 3, iChat, and iCal

Apple is unabashedly intrigued by the possibilities of the Internet. With each new release of Mac OS X, more clever tendrils reach out from the Mac to the world's biggest network. In 10.2, three completely new programs debut, each designed to harness the Internet's power. They include Sherlock 3 (whose relationship to previous versions of Sherlock are in name only), iCal, a new calendar program, and iChat, an America Online-compatible instant-messenger program.

This chapter tackles this motley crew one by one.


20.1 Sherlock 3

Sherlock is like a Web browser that's specifically fine-tuned to bring you certain popular kinds of up-to-date Web info, without the waiting, without the navigation hassle—and without the ads.

As though to pound home the point that Sherlock is now an Internet-only search tool, you'll find that you can't even open it if you aren't online.

Once you have opened it, however, some fascinating, timesaving goodies await you. The Sherlock channels (icons on its toolbar) bring Web information directly to your Sherlock window, formatted for maximum impact: graphs when you search for stock prices, QuickTime previews when you search for movies, maps when you search for flights, and so on.

Here's how the channels work.

20.1.1 Internet

The Internet channel simply means, "search the Web." You type what you're looking for into the "Topic or Description" box, and then press Enter (or click the green magnifying glass button). After a moment, you see a tidy list of Web sites that match what you looked for, sorted, at the outset, by relevance (see Figure 20-1).

TIP

Sherlock generally sends your search request to all of the search services listed at the bottom of the window (About.com, Looksmart.com, Lycos, and so on). But if you click one of these search pages' logos, your Web browser opens up to that search site so that you can confine your quest to it.

Figure 20-1. When you search the Internet, you get a list of Web pages that contain the text you seek. As with find-by-content searches, many of these results are sorted by relevance. The whole affair saves you the trouble of firing up a whole big browser just for a quick Web-page check.

Here's what you can do with one of these results:

  • Read the first paragraph. Click one of the Web pages listed in the search results; as shown in Figure 20-1, Sherlock displays the first paragraph or so of text that appears on that Web page. This blurb is a very useful preview, one that can save you the effort of opening that Web page only to find that it's not what you were looking for.

  • Go to the Web page. Double-click one of the listings to launch your Web browser and actually visit the corresponding page.

    TIP

    If your Web browser is already open, you can drag one of the Sherlock results directly into its window to switch to the corresponding new page.

  • Create an Internet location file. If you think you might like to visit one of these Web sites later, drag it out of the list and onto your desktop, where it becomes an Internet location file (see Section 18.10). You can also drag it directly into the Internet Explorer Favorites list, where it becomes a bookmark for that browser.

Of course, if you did your Web search right in your Web browser, you could use Google, a far better search page than any of the ones that Sherlock consults.

Still, using Sherlock 3 has its advantages. For example, Sherlock can search at least seven search engines simultaneously (listed at the bottom of the window). Furthermore, it's nice to perform this kind of search without actually having to launch your Web browser.

20.1.2 Pictures

Need a photo of something? Type in whatever you're looking for into this channel's "Picture Topic or Description" box—Santa Claus, October squash, Keanu Reeves—and then press Enter. In a flash, you see thumbnails of photographs from Web pages all over the Internet that match your search (see Figure 20-2). Double-click one to view it on the actual Web page in your browser, so that you can download it—and pay for it.

Figure 20-2. If you are a busy graphic designer with the money to pay for professionally captured, professional-resolution digital images, this channel can be very useful. It's like having the searchable catalogs of several stock-art companies at your fingertips.

Note, by the way, that you only get to see a few pictures at a time. Watch the phrase next to the green magnifying-glass icon; if it says "Click again for more pictures," you're not yet seeing all of them. Keep clicking until it says "No pictures found." Now you're seeing everything Sherlock found.

TIP

For noncommercial use, the Image Search tab of Google.com is far more powerful. It finds far more pictures on the topic you're seeking, because it grabs them from thousands of everyday Web pages, rather than limiting its search to commercial stock-photo companies. (Yes, you should ask for permission from these Web sites before using pictures of theirs for some other purpose.)

20.1.3 Stocks

This one is amazing. Type the name or stock symbol of a company into the box, and then press Enter. (If Sherlock isn't sure which company you meant, you'll see a list of matching companies so that you can click the right one.)

In a moment, you're shown not only the current stock price and accompanying statistics (Figure 20-3), but also headlines relating to the company and a graph of its stock performance.

Figure 20-3. You can manipulate the columns of stock information just as you do in the Finder: click a heading to sort the list of stocks by that criterion (Symbol, Last Trade, or whatever). And you can drag these headings horizontally to rearrange them. To preserve the stock graph, drag it to your desktop, where it becomes a picture clipping that you can file away for future use.

Here's some of the fun you can have with this module:

  • Double-click the row of stock information to go to the company's Lycos financial-information page in your Web browser. Much more statistical detail appears here.

  • Click one of the headlines to view the full article in the area at the bottom of the window. You can select this text and copy it.

  • From the Chart pop-up menu, choose Week, Year, or Intraday (meaning "just today so far") to change the graph.

  • Each time you add a stock name, your list of stocks grows. To remove one, just click its row and then press the Delete key.

20.1.4 Movies

For the movie fan, this single feature of Sherlock might be worth the entire price of Mac OS X right there. It makes finding a movie or theater in your neighborhood so easy and efficient that Moviefone.com looks positively antique by comparison. As you can see in Figure 20-4, it's an instantaneously updated database of movies and show times for your neighborhood.

Figure 20-4. Type your city and state—or just your zip code—into the text box at the top, and then press Enter. After a moment, you'll see a list of movies playing near you—in the first column. Click one to see the theaters where it's playing (in the second column); click one of those to see today's show times (in the last column). Meanwhile, you even see the address of the theater, its distance from you, the movie poster, the movie's rating and length, a description, and—if you wait long enough—even the QuickTime trailer for the movie. Life is sweet.

The only thing stopping this module from becoming an international smash hit is that, in fact, it doesn't work internationally. At the moment, it knows only about movie theaters in the United States.

20.1.5 Yellow Pages

A Yellow Pages of every business and organization in the entire United States wouldn't be especially convenient. In fact, it would probably occupy your entire living room. And yet think of the convenience of having such a thing. It would be so useful to find out where the closest Chinese restaurant, hospital, or all-night drugstore is, especially if you're a laptop-carrying road warrior in a strange city.

Well, now you have one. Into the Business Name box, type whatever it is you're looking for, exactly as though it's a heading in the Yellow Pages business directory. You could type drug store, cleaning service, health club, tailor, library, or whatever. When you press Enter, Sherlock not only shows you a list of businesses and organizations that meet your criteria, but it also shows you the phone number, address, and even a map (Figure 20-5).

TIP

Sherlock will find you a list of local drug stores, but it doesn't know anything about drugstores. The point is to try a couple of different search terms until you find some "hits."

Sherlock is even happy to provide you with driving directions to the selected business—but first you have to tell it where you are. Choose Sherlock [image] Preferences. On the Locations tab, click Home. Type your address information into the appropriate boxes. Then quit and reopen Sherlock; from now on, you'll get turn-by-turn driving directions, as shown in Figure 20-5.

Figure 20-5. It's a nationwide Yellow Pages—without the ads, bulk, and paper cuts. Frankly, it's so fast and handy that it puts similar Web directories and the real Yellow Pages to shame. If you double-click one of the results, a bigger, more detailed map appears in your Web browser.

By clicking Add, you can even insert additional locations, so that as you travel, telling Sherlock where you are is only a couple of clicks away.

TIP

If you choose File [image] Print, Sherlock does the right thing. It creates a beautifully formatted page that identifies the currently highlighted business, its address and phone number, driving directions, and the map, all ready to print and take with you. This, ladies and gentlemen, is progress.

20.1.6 eBay

This one is for you, auction freaks. Into the Item Title box, type whatever it is you're looking for—ceramic angel, Babe Ruth baseball card, PowerBook G4, or whatever. When you press Enter, Sherlock displays a list of all matching items from the eBay Web site currently on auction, complete with description, number of bids, remaining time for the auction, and more. Use the pop-up menus on this screen to further narrow the listing, by specifying price ranges, categories, geographical regions, and so on.

Two different mechanisms let you sort the results, slicing and dicing them to feed your obsession. Using the pop-up menu to the right of the "priced between" boxes, you can specify that the items appear listed by price, by time remaining in the auction, and so on. Or you can click the column headings (Title, Price, Bids, or Ends).

If one of the items catches your eye, click its name and then click Track Auction (bottom right). From now on, you can view your list of especially interesting items by switching the Search/Track button to Track mode. (All other items are hidden until you click Search again.)

All of this is especially useful if you're a real eBay aficionado. You know, in that case, that most of these deals are made or broken in the final moments of the auction, as all the patient vultures jump in. Now, thanks to Sherlock, you can keep your eye on all of your auctions at once.

20.1.7 Flights

The Flights module is actually two modules in one.

  • Flight Finder. If you're planning a trip, Sherlock can show you a list of flights that match your itinerary. Just type the arrival and departure cities into the appropriate boxes—or use the pop-up menus provided—and then press Enter.

    In this mode, Sherlock is not, by any means, a comprehensive travel Web site like Expedia, Orbitz, or Travelocity. For example, it primarily shows you direct flights only, and just those in the next 24 hours or so. On the other hand, this is precisely the tool to use when a friend or relative is flying in, and you're unsure of the flight number or airline.

  • Flight Tracker. If you already know a flight number, Sherlock can tell you whether or not it's going to be on time, which airport terminal to go to, and even where, on the map, the flight is at the moment. See Figure 20-6 for an example.

20.1.8 Dictionary

Never again will your family gatherings devolve into heated arguments over Scrabble. Now you have a powerful, instantaneous, electronic dictionary built right into your operating system. Just type a word into the Word to Define box and then press Enter.

In seconds, you see what looks like a photocopy of the relevant page from the American Heritage Dictionary, complete with phonetic spelling, syllabication, every conceivable word-form variant of the word, and (at the lower half of the window) even synonyms, if there are any. For dedicated word nerds, this feature is indisputably convenient, handy, useful, suitable, expedient, clever, nimble, and slick.

Figure 20-6. If you know the airline and flight number, use the controls at the top of the window to specify them. You'll be shown the schedule, airport, date, flight time remaining, type of airplane, and so on. If you don't have a specific flight number, plug in the departure and arrival cities, using the resulting list to find your flight. If the flight is en route, you see a map of its progress, as shown here.

20.1.9 Translation

The next time you travel abroad, plan your trip so that your laptop always has high-speed wireless Internet access wherever you go (yeah, right). You'll be able to use this module to translate your utterances—or those of the natives—to and from about seventeen languages.

Just type the sentence or paragraph into the Original Text box, choose the language direction you want from the central pop-up menu, and then press Enter. In a flash, the bottom of the window shows the translation.

Of course, these translations are performed by automated software robots on the Web. As a result, they're not nearly as accurate as what you'd get from a paid professional. On the other hand, when you're standing in the middle of a strange city and you don't know the language—and you desperately need to express yourself—what Sherlock provides may just be good enough.

TIP

Your first instinct may be to assume that this module is designed for translating things you want to say into the local language. However, you may find it even more useful for translating foreign language paragraphs—from email or Web pages, for example—into your own language so that you can read it.

20.1.10 AppleCare

This module gives you a direct line to Apple's Knowledge Base, a huge collection of answers, troubleshooting tips, and feature explanations for every Mac model ever made. It's based on the same technical library consulted by Apple's tech-support representatives, by the way, so you may as well check it before you call the Apple help line.

The trick is to use just a few words in the Topic or Description box—you might type Mac OS X Simple Finder, for example, or Windows networking. When you press Enter, you see a list of the articles from the library. Click one to read the article in the bottom half of the window.

20.1.11 Of Plug-ins

Incidentally, these aren't the only Sherlock channels. Apple has published the necessary technical guidelines, in the hope that programmers around the world will rise to the occasion of writing plug-ins that create new Sherlock channels. Check VersionTracker.com from time to time to see what's come up.


20.2 iChat

iChat is Apple's take on instant messaging. If you don't know what instant messaging is, chances are there's a teenager near you who does.

It's like live email. You type messages to friends and colleagues in a chat window, in real time, and they type replies back to you. Instant messaging can be a great way to converse with the privacy of email but the immediacy of the phone.

In this regard, iChat is a lot like AOL's popular Instant Messenger (AIM) and Buddy Chats. In fact, iChat lets you type back and forth with any of AIM's 150 million members (it speaks the same "chat" language), which is a huge advantage. But iChat's visual design is pure Apple, complete with comic strip-style word balloons and a candy-coated interface.

If you've used AOL Instant Messenger (or any of its competitors, such as Yahoo Messenger and MSN Messenger), you'll find that iChat has some interesting quirks and perks that entice you to switch. And if you've never been one to spend a lot of time chatting, iChat may change your tune.

20.2.1 Two Chat Networks

iChat lets you reach out to fellow chat partners on two different networks:

  • The Internet. If you've signed up for a free .Mac account or a free AOL Instant Messenger account, you can chat with anyone in the 150-million-member AOL Instant Messenger network.

  • Your own local network. Thanks to the Rendezvous technology described in Rendezvous, you can communicate with other Macs on your office network without signing up for anything at all—and without being online. This is a terrific feature when you're sitting around a conference table, idly chatting with colleagues using your wireless laptop (and the boss thinks you're taking notes).

These two kinds of chats operate in parallel. Each network (AIM and Rendezvous) has its own separate Buddy List window, as described in Section 20.2.4, and its own chat window. The File menu offers separate commands for connecting to each network ("Log In to AIM" and "Log In to Rendezvous").

Otherwise, however, chatting works identically on both networks. Keep that in mind as you read the following pages.

20.2.2 Signing Up

When you first launch iChat, you see the "Welcome To iChat" window (Figure 20-7). To use iChat via the Internet, you need an account. Fortunately, these accounts are free, and there are a couple different ways to acquire one.

If you're already a member of Apple's .Mac service (Chapter 18), your Mac.com user name and password appear here automatically. If not, you can access iChat in either of two ways: via a free .Mac account or with a free AIM account.

Figure 20-7. Nobody can use iChat without an account name and password. It can be your Mac.com user name, AOL screen name, or any screen name that's a part of the big AOL/Netscape online conglomeration.
20.2.2.1 A Free .Mac Account

Although Apple charges $100 for an annual .Mac subscription, you can get an iChat-only account for free. The trick is to sign up for a "trial" subscription to .Mac. (Click the "Sign up for Mac.com" button in the Welcome To iChat window. Your Web browser takes you to Apple's .Mac Web site, where you can sign up for the trial account. This doesn't involve providing a credit card number.) Enter the account name and password you've assigned yourself in the Welcome To iChat window and click OK. (According to Apple, when your trial period ends, you'll lose access to all of the other stuff that .Mac provides, but you'll get to keep your iChat name.)

NOTE

The one drawback to using a Mac.com account on iChat is that people who use very old versions of AOL-compatible instant-messaging programs may have trouble "seeing" you on the network. (Suggest to such people that they upgrade to the latest version of their free instant-messaging software.)

Also, note that if your .Mac name is missingmanualguy, you'll actually appear to everyone else as missingmanualguy@mac.com. The software tacks on the "@mac.com" suffix automatically, which adds a certain unwieldiness to your "handle."

20.2.2.2 An AIM Account

You don't have to have a .Mac name to use iChat; you can use an AOL Instant Messenger (AIM) name instead.

From the Account Type pop-up menu on the Welcome to iChat screen, choose AIM Account. From here, choose the category that fits you:

  • You're a paying AOL member. You're now all set. Just enter your AOL screen name and password, and click OK.

  • You've used AOL Instant Messenger (AIM) before. You can use your AIM screen name and password here.

  • You've never used AOL or AIM. You may still have a valid chat name if you've ever created a screen name at Netscape.com or one of the Time Warner Web sites (People, Time, and Sports Illustrated magazines, plus CNN.com), all of which are part of the same megalithic AOL Time Warner family.

  • None of the above. If you've racked your brain and can't come up with an AOL account name and password, don't worry—you can get one for free. Open your Web browser and go to my.screenname.aol.com. Click "Get a Screen Name" to make up an AOL screen name. (You'll have to be creative to come up with a unique name; consider mixing numbers and letters. Remember that 150 million people before you have already claimed the obvious names.)

    Once you've signed up, you can enter your new name and password in the Welcome to iChat screen. You're almost ready to go!

When you click OK after entering your screen name, a dialog box asks, "Do you want to turn on Rendezvous messaging?" As noted above, that refers to chats with other people in your building, on your network. Your answer here doesn't really matter; if you decline, you can always choose iChat [image] Log Into Rendezvous later.

TIP

If you turn on "Enable local network messaging" in the iChat [image] Preferences dialog box, Rendezvous will always turn on when you use iChat.

20.2.3 The Buddy List

Once you've entered your account information, you're technically ready to start chatting. But you can't chat by yourself. You need a chatting companion, or what's sweetly called a buddy in instant-messaging circles. Fortunately, iChat comes complete with a Buddy List window in which you can house the chat "addresses" for all your friends, relatives, and colleagues out there on the Internet.

NOTE

There's a very similar list for chatting on your office network, by the way: the Rendezvous list. The following discussion deals mainly with the Buddy List window, though, because you can't put any names into your Rendezvous list. Anyone who's on the network (and running iChat) appears automatically in the Rendezvous list, courtesy of the Rendezvous technology.

20.2.3.1 Making a List

When you start iChat, your Buddy List automatically appears (Figure 20-8). (If you don't see it, choose Window [image] Buddy List.)

Figure 20-8. The Buddy List is where you store the names of everyone you know who uses iChat or AOL Instant Messenger. Click the + button to add a new buddy, either by connecting your buddy to the name of someone in your address book or by adding a brand-new buddy from scratch.

Adding a buddy to this list entails knowing that person's account name, whether it's on AIM or Mac.com. Once you have it, you can either choose Buddies [image] Add a Buddy (Shift- [image] -A) or click the + button at the bottom-left corner of the Buddy List window.

Out slides a sheet attached to the Buddy List window, offering a window into the new Address Book program (Chapter 19). It displays the names of everyone in your Address Book. Just scroll through the list until you find the name you want (or enter the first few letters into the Search box), click the name, and then click Select Buddy.

If your chat companion isn't already in your Address Book, click New Person and proceed as shown in Figure 20-9. If you've got a digital picture of him on hand, by the way, you can save time by dragging it into the box above the words Buddy Icon. That way, when you see him online, you'll see his mug shot too. Silly as it sounds, it really helps the iChat experience to see the face of the person you're chatting with.

Figure 20-9. Enter your friend's AIM or Mac.com address in this window and click Add to add him as a buddy; his real name (not account name) will appear in your Buddy List. You're adding this person to both your Buddy List and Address Book.
20.2.3.2 Mysteriously self-appearing names

If you've used AIM before, you may find that you've already got buddies in your list. That's because AIM accounts store their buddy lists on AOL's computers, so that you can keep your buddies even if you switch computers. Likewise, if you add buddies to your AIM account's buddy list using iChat, they'll appear in your buddy list when you use the AIM chat program itself.

TIP

As you accumulate buddies, your Buddy List may become crowded. But if you click the lower-left icon in your Buddy List window and, from its pop-up menu, turn off "Show Offline Buddies," you'll only see your currently online buddies in the Buddy List—a much more meaningful list for the temporarily lonely.

20.2.4 Let the Chat Begin

As with any conversation, somebody has to talk first. In chat circles, that's called inviting someone to a chat.

20.2.4.1 They invite you

To "turn on your pager" so that you'll be notified when someone wants to chat with you, run iChat. Hide its windows, if you like, by pressing [image] -H.

When someone tries to "page" you for a chat, iChat will come forward automatically and show you the invitation message like the one in Figure 20-10. If the person initiating a chat isn't already in your Buddy List, you'll simply see a note that says "Message from [name of the person]."

Figure 20-10. Top: To begin chatting, click the invitation window, type a response in the bottom text box, and click Join (or press Enter). Or click Block to lock out the person sending you messages—a good trick if someone's harassing you. Bottom: The Participants drawer shows you who's involved here. You can drag a file onto someone's name as an "attachment" that's sent instantly.

Named Chats

Occasionally, you might be asked by friends to join a particular chat already in progress, in a named chat room. Maybe you're a member of a fantasy football league, and your preseason draft is taking place in an AOL chat room.

To join an existing named chat, choose File [image] Go to Chat. Type the name of the chat you want to join, and click OK.

To create your own named chat, choose File [image] Go to Chat, type a unique name for it, and click OK. Then you'll be in an empty chat room. Tell your friends the name of the room you've created, or just drag their icons out of the Buddy List and into the chat's Participants list to invite them to your chat.

20.2.4.2 You invite them

To invite somebody in your Buddy List to chat, just double-click the name, type a quick invite ("You there?"), and press Enter.

Or, to initiate a chat with someone who isn't in the Buddy List, choose File [image] New Chat With Person. Type the account name of the person and click OK; iChat will invite that person to chat with you.

20.2.4.3 The chat begins

A chat works like this: Each time you or your chat partner types something and then presses Enter, the text appears on both your screens, as shown in Figure 20-11. iChat displays each typed comment in the chat window next to an icon, which can be any of these three things:

  • A picture you added. If you've added a picture of your buddy to the Buddy List or Address Book, you see it here next to each utterance by that person.

  • A picture they added. If the buddy added her own picture—to her own copy of iChat or AOL Instant Messenger—it will be transmitted to you, appearing automatically in the chat window. Cool!

  • Generic. If nobody's done icon-dragging of any sort, you'll get a generic icon—either a blue globe (for .Mac people) or the AOL Instant Messenger man-with-a-word-balloon (for AIM people).

Text you type appears at the right side of the screen, in the same cartoon-style word balloon. If you haven't yet created a custom icon, you'll look like a blue globe.

Figure 20-11. As you chat, iChat colors the word balloons of various chat participants differently, so you can easily tell them apart. You can set your default balloon shade, text font, and much more in iChat's preferences. You can also turn off all of this balloon-and-icon business.

TIP

Being a blue globe is really boring. Get a digital picture of yourself and drag it into the box next to your name in the Buddy List. If you're the shy type who doesn't like to be photographed, find some other image that you like—a TV star, cartoon character, even your cat—and drag that in. iChat really works much better when someone can connect you with a visual representation.

20.2.4.4 In-chat fun

Typing back and forth isn't the only thing you can do during a chat. You can also perform any of these productivity stunts:

  • Get Info on someone. If you click the name of someone in your Buddy list and then choose Buddies [image] Get Info, you get a little Info window about your buddy, where you can edit her name, address, and picture.

    If you choose Actions from the Show pop-up menu, meanwhile, you can make iChat react when this buddy logs in, logs out, or changes status—for example, by playing a sound or saying, "He's here! He's here!"

  • Send an Instant Message. Not everything in a chat session has to be "heard" by all participants. If you choose Buddies [image] Send an Instant Message, you'll get a private chat window, where you can "whisper" something directly to a special someone behind the other chatters' backs.

  • Send Direct Message. A Direct Message is exactly like an Instant Message except that it's exclusively for sending notes to other people using iChat. It sends a message Mac to Mac, rather than via AOL's central server (which is what happens during an Instant Message session).

  • Send Email. If someone messages you, "Hey, will you email me directions?" you can do so on the spot by choosing Buddies [image] Send Email. Your Mail program opens up automatically so that you can send the note along.

  • Send a File. Via this command, you can quickly send a file to one of your buddies. Click the command, then pick the file you want to send; iChat will send it directly to your buddy.

    TIP

    Better yet, just drag the file's icon from the Finder into the box where you normally type. This trick works great with pictures! In any case, it's also a great way to transfer a file that would be too big to send by email. A chat window never gets "full."

    Note, though, that this option isn't available in old versions of the AOL Instant Messenger program—only new versions and iChat users.

20.2.4.5 The Chat transcript

Every now and then, you'll wish you could preserve a chat for all time: a particularly meaningful conversation with a friend, lover, or business associate.

On the iChat [image] Preferences [image] Messages panel, you can turn on "Automatically save chat transcripts." From now on, the text of your conversations is automatically saved in your Home [image] Documents [image] iChats folder. To view a chat later, just double-click its icon. It opens within iChat, compete with all colors and formatting.

TIP

Even if you don't turn on this "Automatically" checkbox, you can always save individual chats in progress by choosing File [image] Save a Copy As.

20.2.4.6 The Chat toolbar

iChat's message windows contain a five-button toolbar, whose buttons provide quick access to some widely disparate but very useful iChat features. Here's a rundown, from left to right (see Figure 20-11):

  • Show or hide participants. Click this button to hide or show the "drawer" that lists every person participating in your current chat, as shown in Figure 20-10 at bottom. To invite somebody new to the current chat, click the + button at the bottom of the drawer (and choose from the resulting pop-up menu), or drag the person's icon out of the Buddy List window and into this drawer. Either way, iChat sends an invitation to chat.

    TIP

    You can drag files from the Finder onto individual participants' names in this drawer to send files directly to them.

  • Bold, Italic. Makes your next typed utterance bold or italic. (You can also press [image] -B or [image] -I.)

  • Insert a smiley. Can't remember exactly which combination of punctuation marks makes the smiley face that's sticking out its tongue? Just use this quick-access menu of smiley options. When you choose a face (Undecided, Angry, Frown, etc.), iChat inserts it as a graphic right into the typed response you're about to send.

    If you do remember which characters make up an old-fashioned smiley—where :) means a smiling face, for example—you can save time by typing them instead of using the pop-up menu. iChat converts them into smiley icons on the fly.

  • Send a file. Clicking this icon lets you send a file to all the participants of your chat. You can also just drag a file from the Finder into your chat window. (Contrast this with dragging an icon onto an individual name in the Participants drawer, which sends a file privately.) Keep in mind that not all versions of AOL Instant Messenger can accept file transfers.

    TIP

    When you minimize the iChat message window, its Dock icon displays the icon of the person you're chatting with—a handy reminder that they're still there, just lurking in your Dock.

20.2.4.7 Popping the Balloons

The words you might have for iChat's word-balloon design might be "cute" and "distinctive." But it's equally likely that your choice of words includes "juvenile" and "annoying."

Fortunately, behind iChat's candy coating are enough options that you'll certainly find one that works for you (see Figure 20-12). While a chat is going on, you can change the look of your chat easily using the View menu. For example:

  • Kill the balloons. Choose View [image] Show as Text. Now your message window is a series of colored rectangles—iChat user icons on the left side, chat text next to them. Choose View [image] Show as Balloons to return to the Peanuts look.

  • Kill the icons. Choose View [image] Show Names to ditch the icons entirely, replacing them with plain old names. This setup works best in conjunction with Show as Text—you'll still get colored rectangles to help you differentiate between different chat participants, but the iChat window will otherwise be text-based and compact. Choose View [image] Show Pictures to bring back the icons; choose View [image] Show Pictures and Names if you'd like to see both at the same time.

  • Change the background. If you tire of iChat's white background, you can change it to any image using View [image] Set Chat Background. Better yet, find a picture you like and drag it into your chat window—iChat will immediately make that image the background of your chat. To get rid of the background and revert to soothing white, just chose View [image] Clear Chat Background.

    TIP

    Ordinarily, messages you type aren't "broadcast" until you actually press Enter. But if you prefer the adrenaline rush of a live, watch-my-letters-appear-as-I-type-them effect, choose iChat [image] Preferences. Turn on "Send text as I type." (As noted in the dialog box, this feature works only in Rendezvous chats within your building.)

Figure 20-12. iChat can look like almost anything. From top left: With balloons hidden, with names hidden, and with pictures hidden. You make these changes for a chat in progress using the View menu. You can also change the color and typeface settings, meanwhile, in the iChat Preferences Messages panel.

20.2.5 iChat Tweaks

If you've done nothing but chat in iChat, you haven't even scratched the surface. The program's iChat [image] Preferences dialog box and Buddies menu give you plenty of additional control.

When you open the Preferences window, you'll see a toolbar with four icons: Accounts, Messages, Actions, and Privacy. Here's a look at what you can do inside each one of them.

20.2.5.1 Accounts panel

If you have more than one AIM or .Mac account, you can switch among them here (see Figure 20-13). First, log out of one account (choose iChat [image] Log Out of AIM, for example, or press the Log Out button in this very window). Then choose another account name from the pop-up menu next to the Screen Name box, and log back in (iChat [image] Log Into AIM). Your passwords are conveniently saved for you in your Mac OS X Keychain.

Figure 20-13. Switch between different AIM accounts and force iChat to stay logged in even when you quit, all from the Accounts preference window.

If you chat only on your local network or only via the Internet, you can turn off "Enable AIM" or "Enable local network messaging" to prevent iChat from trying to log in. And if you don't want to talk to anyone, you could turn off both boxes—or just quit iChat and stop reading.

The Status Settings section of the Accounts preferences contains one of the most important hidden features of iChat. Here's what the four checkboxes do:

  • When iChat opens, automatically log in. If this box is checked, you'll automatically be logged into AIM, Rendezvous, or both (depending on the boxes you turn on in this preference window) when you open iChat.

    TIP

    If you always want to be available for iChatting and be visible on your buddies' buddy lists, designate iChat as a startup item (Section 11.2.6). Then, each time you log into your Mac, iChat will both open and log you in automatically.

  • Use shapes to indicate status. Usually, the color of the spheres next to people's names in the Buddy List and Rendezvous window indicates their status: a green sphere means you're available, yellow means you're idle, and red means you're unavailable. This box makes these icons take on different shapes, too, presumably to help the color-blind or people reading black-and-white books.

  • Show status in menu bar. This may be the most powerful and life-changing feature of iChat. If this box is turned on, a small iChat menu appears as a menulet at the right side of your menu bar. As shown in Figure 20-14, it lets you change your iChat status, whether you're in iChat or not.

  • When I quit iChat, set my status to Offline. If you leave this box turned off, then quitting iChat won't actually log you out. That's pretty powerful, because it means you can quit iChat and still be available for chats with your friends.

    Otherwise, when you quit the program, you'll remain with whatever status you had when you were in iChat. You can still modify that status via the iChat menu item, and if one of your buddies starts a chat for you, the menu item will automatically launch iChat and open a new message window with your buddy's message in it.

Nothing will make you a more diehard user of iChat than leaving it on at all times. With iChat and its menulet, you can be ready for any chat that comes along, without spending a lot of time in the iChat program itself.

Figure 20-14. If you choose a red or green status option and aren't currently logged in, the menu item will log you in automatically—without opening iChat itself. As your buddies come and go, you'll see their names reflected in the Buddy List at the bottom of the menu. If you select the name of one of your buddies, iChat will open automatically and create a new chat window with that buddy.
20.2.5.2 Messages panel

The Messages preference panel lets you design your chat windows—the background color, word balloon color, typeface and size of text you type, and your personal icon.

If you want to set a special background image for your chats, you can do that, too—just drag a graphics file into the chat preview box. You can revert to a white background by choosing View [image] Clear Background.

No matter what font and color you've selected for your standard utterances, you can always override those choices on a message-by-message basis using the Format [image] Show Fonts command. The standard Mac OS X Fonts panel appears, which you can use to change the font of your outgoing messages. Of course, the flip side of this good news is that other people can send you messages in their chosen fonts and colors.

On the day your pal starts typing to you in a practically unreadable neon-yellow, 8-point Comic Sans—perhaps because he or she is trying to break up with you—you'll be grateful for the "Reformat incoming messages" checkbox. It lets you override your conversation partner's font and color choices.

20.2.5.3 Actions panel

The Actions section of the iChat preferences lets you choose how iChat responds to various events. For example, it can play a sound, bounce its Dock icon, or say something out loud whenever you log in, log out, receive new messages, or whatever.

20.2.5.4 Privacy panel

If you're worried about being interrupted by people who think they're your buddies but are horribly, horribly confused, you can limit your visibility.

On the Privacy panel, you start out with the "Allow anyone" setting, which means that anyone can chat with you. (You still have one small level of privacy, even at this level: If you turn off "Allow anyone to see that I am idle," nobody will know when you've stepped away from your Mac to make a sandwich.)

The other privacy levels are:

  • Allow people in my Buddy List. Only people in your buddy list can see you and chat with you.

  • Allow people listed below. You can create a list of "allowed" people by clicking the + button and typing in names.

  • Block people listed below. Useful if you generally like everyone, but want to block certain people who are annoying or harassing you.

  • Block everyone. Nobody can see you, and you can't see anyone. If you're tempted to use this feature, here's a more useful one: iChat [image] Quit iChat.


20.3 iCal and iSync

To further build up its collection of Mac OS X-only "i-apps"—and to help promote its $100-per-year .Mac services—Apple unveiled iCal, the company's first calendar program, in July 2002. (If your copy of Mac OS X didn't come with iCal, you can download it from the Apple Web site.)

In many ways, iCal is not so different from those "Hunks of the Midwest Police Stations" paper calendars we leave hanging on our walls for months past their natural life span. But iCal offers several advantages over paper calendars. For example:

  • It can automate the process of entering repeating events, such as weekly staff meetings or gym workout dates.

  • iCal can give you a gentle nudge (with a sound, a dialog box, or even an email) when an important appointment is approaching.

  • iCal can share information with your Address Book program, with Mail, with your iPod, with other Macs, with "published" calendars on the Internet, or with a Palm organizer. Some of these features require one of those .Mac accounts described in Chapter 18, and some require iSync (described at the end of this chapter). But iCal also works just fine on a single Mac, even without an Internet connection.

20.3.1 Working with Views

When you open iCal, you see something like Figure 20-15. By clicking one of the View buttons on the bottom edge of the calendar, you can switch among any of these views:

  • Day shows the appointments for a single day in the main calendar area, broken down by time slot.

    If you choose iCal [image] Preferences, in fact, you can specify what hours constitute a workday. This is ideal both for those annoying power-life people who get up at 5 a.m. for two hours of calisthenics, as well as the more reasonable people who sleep until 10:30 a.m. before rolling out of bed and heading over to the home office in the den. This same dialog box lets you limit the number of hours visible in each Day view (choose from the "Show __ hours at a time" pop-up menu); as you make this number lower, the time slots get larger, for your nearsighted pleasure.

  • Week fills the main display area with seven columns, reflecting the current week.

    TIP

    If you enjoy an eccentric work schedule, you can redefine which days constitute your work "week" by choosing iCal [image] Preferences and adjusting the "Days per week" and "Start week on" pop-up menus. If you work three days a week starting on Tuesday, iCal is ready for you.

  • Month shows the entire month that contains the current date. Click a date number to jump to the day view for that date.

    TIP

    iCal provides a quick way to get to the current day's date—choose Calendar [image] Go to Today, or press [image] -T.

Figure 20-15. The miniature calendar at left provides an overview of adjacent months; you can jump to a different week or day by using the triangle buttons for navigation, and then clicking within the numbers. At right, you can see a big view of the current month, week, or day. If an event has a reminder, a small alarm clock icon appears in the box; if the event is recurring, it shows two arc-shaped arrows in a yin-yang arrangement.

20.3.2 Recording Events

The basic iCal calendar is easy to figure out. After all, with the exception of one unfortunate Gregorian incident, we've been using calendars successfully for centuries.

Even so, there are two ways to record a new appointment: a simple way and a more flexible, elaborate way.

20.3.2.1 The easy way

You can quickly record an appointment using any of several techniques, listed here in order of decreasing efficiency:

  • Double-click the appointed time on the calendar, in any view. A colored box appears, where you type the name for your new appointment.

  • When viewing a day or week view, drag vertically through the time slots that represent the appointment's duration, and then type inside the newly created colored box (see Figure 20-16).

  • Using the month view, double-click the appropriate date, and then type in the newly created colored bar.

  • Choose File [image] New (or press [image] -N). A new appointment appears on the currently selected day, regardless of the current view.

Unless you use the drag-over-hours method, a new event believes itself to be one hour long, but you can adjust its duration by dragging the bottom edge vertically. Drag the dark top bar up or down to adjust the start time.

In many cases, that's all there is to it. You have just specified the day, time, and title of the appointment. You can get on with your life.

Figure 20-16. You can open this New Event window by double-clicking a calendar square, or dragging through a swath of hours on any day or week view (background, left). The ending date information is generally dimmed except for events that span more than one day. (And to make an event do that, you must turn on "All-day event.")
20.3.2.2 The long way

On the other hand, whenever you create a new appointment, you simultaneously bring up the Event Info window shown in Figure 20-16. Using it, you can create far more specific appointments, decked out with far more bells and whistles. Here's an unusually elaborate example of how you might enter an appointment:

  1. Click inside the Subject box. Type a name for this appointment.

    For example, you might type Fly to Phoenix.

  2. Press Tab to jump to the "All day event" checkbox. Turn it on, if you like.

    You can either press the Space bar or click the checkbox with your mouse.

    "All-day event," of course, refers to something that has no specific time of day associated with it: a holiday, a birthday, a book deadline. When you turn on this box, you'll see the name of the appointment jump to the top of the iCal screen, in the area reserved for this kind of thing (see Figure 20-16).

    TIP

    If you turn on "All-day event," the lower Date box becomes un-dimmed so that you can specify a different ending date. This way, you can create banners like the one shown in Figure 20-14.

  3. Press Tab. Specify the starting and ending times for this appointment.

    If you opened this dialog box by dragging through time slots on the calendar, you can skip this step; iCal has already filled in the starting and ending times for you.

    Otherwise, you can adjust the times shown here by typing, clicking buttons, or both. (Press Tab to jump from one setting to another, and from there to the hours and minutes of the starting time.)

    For example, start by clicking the hour, then increase or decrease this number by clicking either the arrow buttons or by pressing your up and down arrow keys. Of course, you can also type a number. Press Tab to highlight the minutes, and repeat the arrow buttons-or-keys business. Finally, press Tab to highlight the AM/PM indicator, and type either A or P to change it, if necessary. (You can also press the up or down arrow keys or the Space bar to toggle between AM and PM.)

  4. Use the Calendar pop-up menu to specify which calendar this appointment will belong to.

    A calendar, in iCal's confusing terminology, is a subset—a category—into which you can place various appointments. You can create one for yourself, another for family-only events, another for book-club appointments, and so on. Later, you'll be able to hide and show these categories at will, adding or removing them from the calendar with a single click. Details begin in Section 20.3.5.

    TIP

    Use this same pop-up menu to change an appointment's category. If you filed something in Company Memos that should have been in Sweet Nothings for Honey-Poo, open its Event Info window and reassign it. Quick.

    At this point, you may also want to use the Status pop-up menu to classify this appointment as Tentative, Confirmed, or Canceled.

  5. Set up a reminder, if you like.

    If you click the second icon at the top of the Event Info window (the ringing bell), you can specify how you want iCal to notify you when a certain appointment is about to begin. iCal can send the three kinds of flags to get your attention: it can display a message on the screen, send you an email, or play a sound.

    As shown in Figure 20-17, you can specify how much advance notice you want for this particular appointment. If it's a TV show you like to watch, you might set up a reminder only five minutes before airtime. If it's a birthday, you might set up a two-day warning to give yourself enough time to buy a present, and so on.
Figure 20-17. Top: By twiddling a few of these knobs and buttons, you can set up alarms for your appointments (left), make them repeat at regular intervals (middle), or invite all of your closest friends and co-workers—at least, those who happen to use Mac OS X 10.2 and iCal (right). Bottom: When a reminder comes due, iCal pops a reminder window in front of anything else on your screen.

TIP

iCal starts out proposing 15 minutes advance warning for every reminder. But you can change this standard reminder setting. After arranging the reminder settings the way you like them for one appointment, click Set as Default at the bottom of this window.

  6. Setup a recurrence schedule, if you like.

    To see your options, click the third icon at the top of the Event Info window. The pop-up menu here (which starts out saying Never) contains common options for recurring events: daily, weekly, monthly, or yearly (Figure 20-17, middle). Once you've made a selection, you get an additional set of controls that let you set up variations like the first Sunday of the month, every Tuesday and Wednesday, and so on.

    The bottom part of the box lets you indicate how many times this event will recur. If you click " Never," you'll be stuck seeing this event repeating on your calendar until the end of time (a good choice for recording, say, your anniversary, especially if your spouse might be consulting the same calendar). You can also turn on " After___ time(s)," which is a useful option for car and mortgage payments. You can also turn on "On," and specify the date that the repetitions come to an end; use this option to indicate the last day of school, for example.

  7. If the appointment is a meeting or some other gathering, send out email invitations, if you like.

    Click the fourth icon at the top of the Event Window to view the list of invitees (Figure 20-17, right). Then choose Window [image] Show People (or click the Show Address Book button at the bottom right of the calendar window). You're shown a floating window that contains the names of the people in your Address Book. Drag the names of the interested parties into the Event Info window (be sure to drag the correct email address, if there's more than one per person), and then click Send Invitations.

    iCal fires up Mail and shows you a warning that AppleScript is about to send some mail, and then off go your invitations. Your guest gets an email message that says, "Chris Smith has invited you to the event: Company Hoedown, scheduled for Wednesday, February 02, 2005 at 3:00PM. To accept or decline this invitation, click the link below."

    Unfortunately, there generally is no link below unless your guests happen to use Mac OS X and Mail. Clicking the iCal.ics attachment—a standard calendar-program invitation file—in most programs opens up a calendar-event dialog box but offers no way to accept or decline it. It's a great idea for a feature, but extremely limited in scope at the moment.

    If your lucky recipient does use Mail, clicking the iCal.ics attachment opens up a dialog box like the one shown at top in Figure 20-18. The guest can click either Accept or Decline, once more setting the iCal/Mail wheels in motion.

    Now an RSVP message goes back to you. Once Mail has downloaded the response, you've opened its attachment, and you've clicked OK, iCal updates that person's status in the Event Info window. You'll see the word Pending, Accepted, or Declined next to each name. (And your guests, meanwhile, will be delighted to find that the appointment has automatically appeared on their calendars.)
Figure 20-18. Top: If you get an invitation in iCal that's been sent from iCal, you get Accept and Decline buttons, along with an automatic link to your own calendar. If you accept an invitation, iCal inserts the appropriate appointment into your calendar automatically. Bottom: If you've sent an invitation to another iCal fan, you'll receive the response by email in your Mail program. When you open the attachment, you see this dialog box—and when you click OK, iCal instantly updates the invitee's status in the Event Info window.

  8. Specify a calendar (category) for this appointment, if you like, using the pop-up menu at the right end of the toolbar.

    You can read more about calendars in Section 20.3.5; for now, it's enough to note that iCal's color-coded categories are helpful in distinguishing your calendar events at a glance. Family events might show up in blue, for example, or work events in red.

  9. Click the last Event Info toolbar button. In the white Notes area, type or paste any helpful text.

    Here's your chance to customize your calendar event. You can add any text that you like in the notes area—driving directions, contact phone numbers, a call history, or whatever.

Your newly scheduled event now shows up on the calendar, complete with the color coding that corresponds to the calendar category you've assigned.

20.3.3 What to Do with an Appointment

Once you've entrusted your agenda to iCal, you can start putting it to work. iCal is only too pleased to remind you (via pop-up messages) of your events, reschedule them, print them out, and so on. Here are a few of the possibilities.

20.3.3.1 Editing events

To edit a calendar event's name, just double-click it.

To edit any of the appointment's other characteristics, you have to open its Event Info window. To do that in day or week view, double-click the top bar (where its time appears); in month view, double-click the dot before the name. The calendar event pops up in its window (Figure 20-16), where you can alter any of its settings as you see fit.

TIP

If you simply want to change an appointment's "calendar" category, you can bypass the event dialog box. Instead, just Control-click the appointment's name (or anywhere on its block), and choose the category you want from the resulting contextual menu.

You don't have to bother with this if all you want to do is reschedule an event, however, as described next.

20.3.3.2 Rescheduling events

If an event in your life gets rescheduled, you can drag an appointment vertically in its column to make it later or earlier the same day, or horizontally to another date, using its "time bar" as a handle in day or week view. Note that if you reschedule a recurring event, iCal doesn't ask you if you want to change all occurrences. It only asks about that if you change the first one.

If something is postponed for, say, a month or two, you're in trouble; you can't drag an appointment beyond its month window. You have no choice but to double-click its name and then edit the starting and ending dates or times in the Event Info window. (Alas, iCal doesn't let you copy, cut, or paste calendar events.)

20.3.3.3 Lengthening or shortening events

If a scheduled meeting becomes shorter or your lunch hour becomes a lunch hour-and-a-half (in your dreams), changing the length of the representative calendar event is as easy as dragging the top or bottom border of its block in any column view (see Figure 20-19).

Figure 20-19. You can resize any iCal calendar event just by dragging its border. As your cursor touches the bottom edge of a calendar event, it turns into a horizontal line with arrows above and below. You can now drag the event's edge to make it take up more or less time on your calendar.
20.3.3.4 Printing Events

Although printing isn't iCal's strong suit, the program does offer a way of committing your calendars to paper. To do so, click the Print toolbar button, choose File [image] Print, or press [image] -P. Your printout looks like whatever the screen looks like: month, week, or day view. (Among other limitations, there's no way to print only a certain range of dates.)

20.3.3.5 Deleting events

To delete an appointment, just select it and then press the Delete key. In the confirmation dialog box, click Delete (or press Enter).

TIP

If you delete a recurring event (like a weekly meeting), iCal asks whether you want to delete just that particular instance of the event, or the whole series.

20.3.4 Searching for Events

You should recognize the oval text box at the bottom of the iCal screen immediately: it's almost identical to the one in the Finder toolbar. This search box is designed to let you hide all appointments except those matching what you type into it. Figure 20-20 has the details.

Figure 20-20. As you type into the search box, iCal filters your calendar until only events with matching text are visible. It screens out both the text list and the colored boxes on the calendar itself; you can produce, in seconds, a calendar that shows only events pertaining to a particular client or project. (You can also open up this list view by clicking the button identified here at right.)

20.3.5 The "Calendar" Category Concept

Just as iTunes has playlists that let you organize songs into subsets, and iPhoto has albums that let you organize photos into subsets, iCal has something called calendars that let you organize appointments into subsets. One person might have calendars called Home, Work, and TV Reminders. Another might have Me, Spouse 'n' Me, and Whole Family. A small business could have categories called Deductible Travel, R&D, and R&R. They can be anything you like.

To create a calendar, double-click any white space in the Calendar list (below the others), or click the + button at the lower-left corner of the iCal window. Type a name that defines the category in your mind (see Figure 20-21).

Figure 20-21. Left: "Calendars" (categories) are color-coded, so you'll always know whose appointments you're looking at. To make room for your calendar list, click the tiny calendar-grid button at the lower-left corner of the window to hide the mini-months. Right: You can edit the color and description of a category in its Info box.

To change the color-coding of your category, click the i info button at the lower-right corner of the iCal window. The Calendar Info window appears, looking a lot like the Event Info window you've already seen. Here, you can change the name, color, or description of this category.

You assign an appointment to one of these categories using the pop-up menu on its Event Info window. After that, you can hide or show an entire category of appointments at once just by turning on or off the appropriate checkbox in the Calendars list.

TIP

Click a calendar name before you create an appointment. That way, the appointment will already belong to the correct calendar.

20.3.6 "Publishing" Calendars to the Web

One of iCal's best features is its ability to post your calendar on the Web, so that other people—or you, using a different computer—can subscribe to it, which adds your appointments to their calendars. If you have a .Mac account, then anyone with a Web browser can also view your calendar, right online.

For example, you might use this feature to post the meeting schedule for a group or club that you manage, or to make clear the agenda for a series of financial meetings coming up that all of your coworkers will need to consult.

20.3.6.1 Publishing

iCal can publish only one "calendar" (category) at a time. Unfortunately, there's no way to publish both your corporate appointments and your personal ones. Begin, then, by clicking the calendar category you want in the left-side list.

Then choose Calendar [image] Publish; the dialog box shown in Figure 20-22 appears. Here you customize how your saved calendar is going to look and work. You can even turn on "Publish changes automatically," so that whenever you edit the calendar, iCal connects to the Internet and updates the calendar automatically.

Figure 20-22. Here, you can specify whether or not you want the reminder alarms to go along for the ride, and whether or not you want To Do items "published," too.If you click "Publish on .Mac," iCal posts the calendar—the actual, viewable calendar—on the Web, as shown in Figure 20-23.If you click "Publish on a web server," you have the freedom to upload the calendar to your own personal Web site. In this case, however, your fans will be able to download (and subscribe to) the calendar, but won't be able to view it online.

TIP

CalSync ($5, www.itoast.de/eng/calSync) lets you publish your calendars to any FTP server and have them updated automatically, in full subscribable form.

When you click Publish, your Mac connects to the Web and then shows you the Web address (URL) of the finished page, complete with a Send Mail that lets you fire the URL off to your colleagues.

20.3.6.2 Subscribing

If somebody else has published a calendar, you subscribe to it by choosing Calendar [image] Subscribe. In the Subscribe to Calendar dialog box, type in the Internet address you received from the person who published the calendar. Alternatively, click the Subscribe button in any iCal Web page (shown in Figure 20-23 at top right).

Figure 20-23. Your calendar is now live on the Web. Your visitors can control the view, switch dates, double-click an appointment for details—it's like iCal Live!

Either way, you can also specify how often you want your own copy to be updated (assuming you have a full-time Internet connection), and whether or not you want to be bothered with the publisher's alarms and notes.

When it's all over, you see a new "calendar" category in your left-side list, representing the appointments from the published calendar.

TIP

Want to try it out right now? Visit www.icalshare.com, a worldwide clearinghouse for sets of iCal appointments. You can subscribe to calendars for shuttle launches, Mac trade shows, National Hockey League teams, NASCAR races, soccer matches, the Iron Chef and Survivor TV shows, holidays, and much more. You'll never suffer from empty-calendar syndrome again.

This feature of iCal is a brilliant solution to the old, "My spouse and I each have a Palm, but we can't see each other's calendars" problem. In conjunction with iSync (described starting on the next page), each person can now summon the other's calendar to the screen on demand.

20.3.7 To Do Lists

iCal's Tasks feature lets you make a To Do list and helps to shepherd you along by giving you gentle reminders, if you so desire (Figure 20-24).

Figure 20-24. Using the To Do Info window (right), you can also give your note a priority, a calendar (category) assignment, or a due date. (Tasks that come due won't show up on the calendar itself, but a little exclamation-point triangle appears in the To Do Items list.)

To see the list, click the little pushpin button at the lower-right corner of the iCal screen. Add a new task by double-clicking in the To Do Items list that appears.

To change a task's priority, click the number 1, 2, or 3 as it appears in the list. To delete a task, click it in the task list and then press the Delete key.

20.3.8 iSync

If Apple ever had evidence to back up its "digital hub" hype, iSync is it.

This attractive, simple program is designed to keep the calendars and phone lists on your various computers, Palm organizer, cell phone, and even your iPod in perfect synchronization, sparing you the headache of the modern age: inputting the same information over and over again. (See Figure 20-25.) Here's what it can keep synched:

  • A Bluetooth phone. Of course, this also requires a Bluetooth adapter for your Mac. And it requires a certain amount of technical setup (creating a phone profile, pairing the phone with your Mac, opening iSync and choosing Device [image] Add Device, and selecting the phone). You'll find detailed instructions in the iSync Help screens.

  • Other Macs. This part requires a .Mac account, but it can be fantastically useful. It means that you and a colleague, or you and a spouse, or you and yourself at the office, can keep your calendars in sync, using the Internet as an intermediary.

    To set this up, just open iSync and click the .Mac icon. Click Register, type a name for your Mac, and then click Continue.

  • A Palm organizer. iSync can also keep iCal and Address Book synched with a Palm-compatible organizer. It doesn't do the work itself; it relies, behind the scenes, on Palm's own HotSync software, which must be installed and properly configured beforehand. (You must also install the separate iSync_Palm.pkg software after installing iSync and Palm Desktop.)

    Once that's done, open HotSync Manager in your Palm folder. Choose Hotsync [image] Conduit Settings. See where it says Address Book, Date Book, and To Do List? Double-click each one, select Do Nothing, and click Make Default.

    Then double-click iSync Conduit; turn on Synchronize Contacts and Synchronize Calendars; click OK; and quit HotSync Manager. You've just told Palm's own syncing software to butt out. From now on, iSync will handle these data types (Address Book, Date Book, and To Do List).

    Finally, in iSync, use the Devices [image] Add Device command to make iSync "see" your Palm, which you've put into its cradle, attched to its cable, or (if it's a Bluetooth Palm) made discoverable. To start the synchronization, press the physical HotSync button on the palmtop's cradle, cable, or HotSync screen. (Clicking iSync's Sync Now button never affects the Palm—only the iPod, phone, and .Mac connections.)

    NOTE

    All of this leaves your Palm memos unsynched, because neither Address Book nor iCal has a place for memos. The workaround: use Palm Desktop to view and edit them.

  • An iPod. Connect the iPod to the Mac, and help iSync find it using the Devices [image] Add Device command. Now it's simple to consult your little black book on your little white block. (Current iPod models include the calendar-display feature. If you have an older iPod, you can download the calendar module for it from the Apple Web site. Note, too, that the synching is one-way: iSync copies your calendar and phone book to the iPod, but of course you can't use the iPod to add to, edit, or delete any of this information.)

When you open iSync, its toolbar shows the icons of any synchable devices connected to your Mac at the moment. Click the appropriate gadget on the toolbar—your iPod, for example—to see the synching options available. Turn on the checkboxes you want, and then click the Sync Now button. iSync does the deed.

iSync is plenty smart when it comes to resolving conflicts among your gadgets. For example, if you edit somebody's home phone number on your Palm, and your spouse simultaneously edits the same person's office number on the Mac, iSync will smoothly incorporate both changes into all copies of your address book. Unless you and your spouse both change the home number in different ways; then iSync will present a Resolve Conflicts button. Click it, and choose which info you believe should prevail.

Figure 20-25. Using the To Do Info window (right), you can also give your note a priority, a calendar (category) assignment, or a due date. (Tasks that come due won't show up on the calendar itself, but a little exclamation-point triangle appears in the To Do Items list.)
    [ Team LiB ]


Chapter 21. SSH, FTP, VPN, and Web Sharing

Email and Web surfing may be the most popular Internet activities, but the world's most gigantic network has many other uses. The general idea, though, is always the same: letting one computer reach out and touch another.

Mac OS X offers a few features that embrace the more literal aspects of that notion. For example, you can turn your Mac into a Web server—an actual living Web site that anyone on the Internet can visit. This chapter also explores various advanced methods of manipulating your own Mac from the road, using such remote access technologies as long-distance file sharing, FTP, SSH, and—here's a new one in Mac OS X 10.2—virtual private networking (VPN).

NOTE

Most of these technologies are designed for full-time Internet connections (cable modem or DSL, for example). If you have a dial-up modem, these features work only when you're actually online.

Still, they may occasionally be useful even then. You could always call up a friend and say, "Check out my Web site right now—here's the current IP address" or call someone back home to say, "I have to grab a file off my hard drive. Could you make the Mac on my desk go online?"


21.1 Web Sharing

Using the Sharing panel of System Preferences, you can turn your Mac into a Web site (or server), accessible from the Web browsers of people on your office network, the Internet at large, or both.

This feature assumes, of course, that you've already created some Web pages. For this purpose, you can use Web-design programs (Macromedia Dreamweaver, for example, or the free Netscape Composer) or the File [image] Save as Web Page command of a program like Microsoft Word. Or you could let Mac OS X build Web pages for you using iPhoto.

After you provide your friends and co-workers with your Mac's Web site address, they can view your Web pages, graphics, and documents in their own Web browsers. And whenever you're online, your Web site is also available to anyone on the Internet—but you don't have to pay a penny to a Web-hosting company.

TIP

Web sharing is also an easy and efficient way to share your Mac files with Windows PCs, either those on your office network or those on the Internet. No special software or translation is required, and posting your files on the Web page avoids all the usual complexities of sending files by email.

Don't mistake Mac OS X's Web Sharing feature, by the way, with the relatively feeble equivalent feature in Mac OS 9 or Windows, which was designed to handle only a handful of visitors at a time (and couldn't handle anything fancy like CGI scripts). Inside Mac OS X is Apache, one of the strongest and most popular Unix Web server programs—precisely the same one that drives 60 percent of the Internet's commercial Web sites (including Apple.com).

The bottom line: If you build it, they won't necessarily come. But at least you'll have the capacity to handle them if they do.

IP Addresses and You

Every computer connected to the Internet, even temporarily, has its own exclusive IP address (IP stands for Internet Protocol). What's yours? Open the Sharing pane of System Preferences to find out (see Figure 21-1). As you'll see, an IP address is always made up of four numbers separated by periods.

Some Macs with broadband Internet connections have a permanent, unchanging address called a fixed or static IP address. Clearly, life is simpler if you have a fixed IP address, because other computers will always know where to find you.

Other Macs get assigned a new address each time they connect (a dynamic IP address). That's virtually always the case, for example, when you connect using a dial-up modem. (If you can't figure out whether your Mac has a static or fixed address, ask your Internet service provider.)

You might suppose that Mac fans with dynamic addresses can't use any of the remote-connection technologies described in this chapter. After all, your Mac's Web address changes every time you connect, making it impossible to provide a single, permanent address to your friends and co-workers.

The answer is a dynamic DNS service that gives your Mac a name, not a number. Whenever you're online, these free services automatically update the IP address associated with the name you've chosen (such as macmania.dyndns.org), so that your friends and colleagues can memorize a single address for your machine.

To sign up for one of these services, just go to their Web sites—www.dyndns.org, www.dhs.org, www.dtdns.com, www.hn.org, www.no-ip.com, and so on.

You'll also need to download and run a utility called an update client, which contacts your DNS service and keeps it up to date with your latest IP address, regularly and automatically. Check your DNS service's Web site for a list of compatible update clients.

Once you've got a fixed DNS name associated with your Mac, you'll be able to access it from elsewhere (provided it's online at the time) via File Sharing (Chapter 12), the screen-sharing program called Timbuktu, the Web Sharing and FTP features described in this chapter, and so on.

(If you have a fixed address, you can also pay a few dollars a year to register your own domain name, a bona fide address like www.yournamehere.com. To register one [or to find out if the name you want is taken], visit a site like www.networksolutions.com.)

All of this leaves only one big question remaining: What if you want to connect to a Mac that's connected to a firewall or router? For the answer, see the box in Connecting Through a Router.

21.1.1 Firing Up Personal Web Sharing

Here's how you turn your Mac into a low-budget Web site:

  1. Put the HTML documents, graphics, and files you want to publish into your Home [image] Sites folder.

    Everyone with an account on your Mac has a Sites folder, and therefore the Mac can actually serve up lots of Web sites at once.

    Your Web site's home page, by the way, must be named index.html. (Apple has already put an index.html document into your Sites folder, just to give you the idea; feel free to replace it.)

  2. Open System Preferences; click Sharing (Figure 21-1).

    Open System Preferences by clicking its Dock icon or by choosing its name from the [image] menu.

  3. Turn on the Personal Web Sharing checkbox.

    You've just made the contents of your Web Pages folder available to anyone who connects to your Mac.

    TIP

    Take this opportunity to turn on Mac OS X's firewall, too (Section 18.5). You wouldn't want Internet hoodlums to take advantage of your open Web connection.

  4. Note your IP address.

    In general, your Mac's Web address is based on its IP address (or Network Address), the string of numbers separated by periods that appears near the top of the Sharing pane.

    TIP

    If you connect to the Internet via dial-up modem, you may not see an IP address here until you're online.

  5. Email your new Web address to your friends and co-workers.

    In this example, your address is http://111.222.3.44/~chris/ (the number is your IP address, and the name should be your short user name). Don't forget the final slash. Tell your friends to bookmark it so they won't have to remember this address, or use one of the DNS naming services described in IP Addresses and You.

    TIP

    That IP address with all the numbers is the one that people on the Internet need. People on your local office network can use your Mac's Rendezvous name (Section 12.2.1) to connect instead. In this case, they'd type http://office-mac.local/~chris into their Web browsers, where office-mac.local is your Mac's Rendezvous name.

You've just put your folder-based Web page on the Internet for all to see—that is, all who know your secret Web address. Maybe you'll want to distribute the address only to other people on your office network, using your tiny Web site as a distribution source for documents. Or maybe you'll want to go whole hog, hosting an e-commerce Web site (read on).

Figure 21-1. Use the Web Sharing System Preferences pane to make designated folders on your hard drive available to anyone on the Internet. Note your Mac's IP address, indicated here. It's the basis for all of the fun Mac-sharing-over-the-Internet features described in this chapter.

21.1.2 The Mac's Own Web Site

The instructions above show you how to create a Web site in your Home [image] Sites folder. In other words, they guide you through the process of creating a personal Web site.

But if you have an Administrator account (Chapter 11), you can also put your Web pages into the main hard drive window's Library [image] WebServer [image] Documents folder. This is your Mac's main Web site folder, and its address is simply http://111.222.3.44/—that is, it's just your IP address, no user name needed. (Of course, if you have a DNS name for your Web server, you can use that, as well. Also, if people will be connecting from across your office network rather than the Internet, they can replace the IP number with your Mac's Rendezvous name.)

Working with this primary Web site folder is only slightly different from using the personal ones described above. Because you're now working inside an official Mac OS X system folder, you must mind your privileges (Section 11.4). Using the File [image] Get Info command, you should set up the permissions of any folders and documents inside the Library [image] WebServer [image] Documents folder (an Images folder, for example) like this:

  • Owner: Read & Write

  • Group: Read & Write (or Read Only, if you don't want other administrators to have access)

  • Everyone: Read Only

You've just ensured that your visitors will be allowed to see your Web documents—and that random Internet citizens can't make any changes to them.

NOTE

This step is especially important if you've copied HTML documents over from another Mac, or even from Mac OS 9. The Mac automatically gives Read permissions only to their owner (meaning only the owner can open them). It's up to you to permit the rest of the Group—and Everyone else—to see them.

21.1.3 The Easiest Way to Distribute Files

Here's a handy secret: If there isn't a document whose name is index.html in your Sites folder (or Library [image] WebServer [image] Documents folder), then visitors see, in their browsers, a handy list of the files that are in that folder (see Figure 21-2).

Figure 21-2. Here's a great way to make files available to other people on your network or collaborators across the Internet. Just put your files into the Sites or Library WebServer Documents folder and make sure nothing is named index.html. The Parent Directory link takes you to the folder that contains this one—if you've been given access to it, that is.

This is a terrific convenience: It offers a quick, simple way for you to make a bunch of documents available for downloading. All your visitors have to do is click one of these file names. It downloads immediately, no matter what kind of computer your Web visitor is using.

TIP

If people are experiencing trouble downloading your files, here are some tips. First of all, if one of the files listed is a graphic, like a JPEG or GIF file, it appears right in the browser window. Tell your visitors to Alt-click or Option-click the link to download it instead. Second, if a file doesn't download properly, you may need to compress it using StuffIt Deluxe or StuffIt Lite (a free download from www.aladdinsys.com) first.

Adding CGI Scripts

A CGI script (computer gateway interface) is a program—written in a language like Perl, AppleScript, or Java—that runs right on your Web page. You've seen these on many a Web page: Web-visitor counters, interactive polls, shopping forms, and so on.

If you've got a CGI script of your own that you'd like to incorporate into your Web page, copy it into your Library [image] WebServer [image] CGI-Executables folder (this means you, administrators). The script's Web address becomes http://111.222.3.44/cgi-bin/scriptname. (Substitute your actual IP address and the real name of the script file, of course.)

Unfortunately, you won't get far testing out your CGI script—or even one of the two sample scripts Apple provides in the CGI-Executables folder—because they come with their "execute" permissions turned off. To turn them on again, you need to use the chmod (change mode) command.

The easy way is to drag them onto the icon of SuperGetInfo, a shareware program you can download from www.missingmanuals.com. Just drag the CGI script's icon onto SuperGetInfo, click the Permissions tab, and turn on the top three checkboxes, as shown here.

You can also do this in Terminal; at the % prompt, switch the Mac's attention to the proper folder like this:

cd /Library/WebServer/CGI-Executables

Press Enter. At the next prompt, type:

sudo chmod 755 test-cgi

The chmod command is a quick way to change access privileges—including Execute permission, which isn't available in the File [image] Get Info window.

The 755 business is a long story, which you can read at any Terminal prompt by typing man chmod and hitting Enter. In short, however, this code is shorthand for "Change the permissions so that everyone can read and execute (but not make changes to) this file"—just what you want for a CGI script.

After hitting Enter, you're ready to proceed. Now sudo asks for your administrator's password. Once you've entered it, press Enter; the deed is done. You can test your script either on the same Mac (http://localhost/cgi-bin/test-cgi) or on another one across the network or across the Internet (http://111.222.3.44/cgi-bin/test-cgi).

21.1.4 Browser Navigation of Your Own Mac

Once you've turned on Web Sharing, you can navigate the folders of your own machine right from within a browser—just use localhost as the "Web address."

To see what's in your own Sites folder, for example, type http://localhost/~chris/ (or whatever your short account name is) into your browser's address bar. Or to see what's in the Library [image] WebServer [image] Documents folder, http://localhost/ is all you need.

TIP

Actually, in any address that involves the word localhost (like the previous examples), you can leave out the word localhost to save a little typing. But keep all the slashes that surround it. For example, http:/// is enough to see the list of documents in your Mac's main Web-pages folder.

But why stop at HTML documents? You can see the contents of any folder on your Mac, just by typing its folder pathname. For example, to see what's in your Documents folder, type file:///Users/chris/Documents/ into your browser's Address bar. You get a tidy list like the one shown in Figure 21-2, revealing what's in that folder. Click a link to open it.

21.1.5 More on Apache

As noted above, Apache is the most popular Web-serving software in the world. As you can well imagine, it's powerful, reliable—and very technical. It is, after all, a Unix program.

You can read more at any of these sources:

  • The Apache manual. To open it up, type http://localhost/manual/ into your browser's address bar. You won't get far reading this thing if you haven't spent some time at a technical college, but at least you'll know what you're up against.

  • Apache: The Definitive Guide. A book from O'Reilly.

  • MacOSXHints.com. Dozens of Mac OS X fans have posted specific Apache-tweaking tips and tricks at www.macosxhints.com.

Note, too, that $300 will buy you a graphic front end for the various Apache settings, in the form of Tenon's iTools program (no relation to Apple's old iTools service). It still requires an understanding of the technical aspects of Web hosting, but at least it spares you from having to type out Unix commands to make your changes.


21.2 FTP

FTP sites (file transfer protocol) store pieces of software that can be accessed from the Internet. If you've heard of FTP at all, it was probably under one of two circumstances—either you've downloaded software from an Internet FTP site, or you've created and maintained your own Web site.

21.2.1 Uploading and Downloading from FTP Sites

Hooking into an FTP site generally requires an FTP client program that runs on the kind of computer you use (Mac, Windows, or whatever). On Mac OS X, popular FTP client programs include the shareware programs Fetch, Interarchy, and Captain FTP, and the free RBrowser Lite (available from www.versiontracker.com, for example).

Using these programs, Web designers, for example, can view a list of all the text and graphics documents, sitting there on an Internet-connected computer somewhere, that make up their Web pages. When they want to update one of those pages, they add it to this list; to delete a Web page, they remove it from this list.

21.2.2 Just Downloading from FTP Sites

If you're just going to look at and download files (but not upload or delete any), you don't even need a special FTP program like Fetch. You can get to the files much more directly using one of these two methods:

  • Any old Web browser will work. Just type ftp://ftp.apple.com (or whatever the address is) into the address bar. A dialog box asks for an account name and password, if they're required. Once you're in, you see a list of everything on the FTP server, displayed much like the list shown in Figure 21-3.

  • Using the Finder's Go [image] Connect to Server command, you can mount read-only FTP volumes right on your desktop, much like a public iDisk.

    In the Connect to Server dialog box, just enter the address of the FTP server you would like to mount—ftp://ftp.apple.com, for example. You'll soon see the ftp.apple.com icon appear on your desktop just like your other disks. Open it up and drag out whatever you want to download.

Figure 21-3. Lower right: To access your Mac from across the Internet, fire up Fetch and use the address ftp://111.222.33.4 (or whatever your IP address is). (In Fetch, shown here on a Mac OS 9 machine, you can leave off the ftp:// portion.) Top left: Once you're looking at an FTP server's contents, you can drag files from your desktop into the list. Copy them to your Mac by dragging them out of the list onto your desktop.

NOTE

Even in Mac OS X 10.2.1, this feature is hit or miss, its success depending on which FTP site you're attempting to reach. At best, you can bring FTP sites onto your desktop as read-only "disks" (that is, you can't upload files—only download them.). At worst, the whole Finder crashes, sometimes to the extent that you'll need to reboot your computer. Mac OS X 10.3, anyone?

21.2.3 Becoming an FTP Server

Thanks to Mac OS X and its Wonder Unix, you can also turn your own Mac into an FTP site. Once again, the key is the Sharing pane of System Preferences; this time, just turn on the FTP Access checkbox.

Once again, the key to your own Mac is its IP address, as shown at the bottom of the Sharing pane. At this point, you, or other people you trust, can connect to your FTP server by running an FTP program like Fetch (see Figure 21-3) or just typing ftp://111.222.33.4 into their Web browsers.

Figure 21-4. The Connect to Server dialog box lets you type in the IP address for the shared Mac to which you want access. (Ensuring that the shared Mac is turned on and connected to the Internet is the network administrator's problem.)
    [ Team LiB ]


21.3 Connecting from the Road

You can also connect to your Mac's regular File Sharing feature (Chapter 12) from over the Internet. This feature is a blessing to anyone who travels, whether with a laptop or to a branch office, because you'll never be up the creek without a paddle if you discover that you left an important file at home.

To connect over the Internet, make sure that you've set up the home-base Mac for file sharing, as directed in Chapter 12. Then, once you're on the road, go online, and proceed like this:

  1. Choose Go [image] Connect to Server.

    The Connect to Server dialog box appears, as shown in Figure 21-4.

  2. Type in the IP address (or domain name) of the Mac to which you want to connect, and then click Connect (or press Enter).

    If you don't know the shared Mac's IP address, pick up the phone and call somebody in the office there. That person can find out the shared Mac's IP address by opening the Network pane (or Sharing pane) of System Preferences.

    And if you've signed up for a DNS naming service as described in IP Addresses and You, you can type your Mac's domain name instead.

  3. Continue with step 3 on Section 12.2.2.

    This kind of connection is slower than an Ethernet hookup in the same building. But when you're in Hong Kong and need a document from your Mac in Minneapolis, you may not care.

Connecting Through a Router

I want to connect to my home network from the road. Trouble is, I have a router that shares my broadband modem with a bunch of Macs. How do I get into one specific Mac? It doesn't really have a "real" IP address, because the router is sharing the cable modem's signal!

It's possible—just technical.

Most home broadband routers offer a feature called port forwarding, in which signals intended for a specific port (All the Firewall Checkboxes) on the router (port 22 for ssh, for example) get passed on to whichever computer on the network you've designated to receive it. (You specify this using the router's management software.) You can specify a different machine for different ports: all port-80 communications goes to one machine doing Web serving, for example; all 584 goes to another machine doing file sharing, and so on.

Even if you're enough of a technical mastermind to set up this port-forwarding business, however, you still won't be able to access two different machines using the same port. For some services, including ssh and Timbuktu, you can work around this limitation by logging into the machine specified for port forwarding, and then from that machine, log into the others on the rest of the network.


21.4 Remote Access with SSH

Are you a geek? Take this simple test at home. Do you get excited about Mac OS X's ability to permit SSH access?

If you answered "What's SSH?" or "I'm already being quiet," then the following discussion of Unix remote control may not interest you. To be sure, SSH is not a program with a graphic user interface (icons and menus). You operate it from within a program like Terminal by typing commands, exactly as described in Chapter 15.

If you're willing to overlook that little peccadillo, though, SSH (Secure Shell) is an extremely powerful tool. It lets you connect to your Mac from anywhere—from across the network or across the Internet. And once you're connected, you can take complete control of it, copying files, running commands, rearranging folders, or even shutting it down, all by remote control.

21.4.1 Getting In

Here's how you go about using SSH:

  1. Set up your Mac by opening the Sharing panel of System Preferences, and then turning on the Remote Login checkbox.

    You've just told the Mac it's OK for you (or other people with accounts on your machine) to connect from the road. Quit System Preferences.

  2. Go away.

    You can move to another machine on the network, or another computer on the Internet. Once you're online with that other machine, you can contact your home-base machine from within a program like Terminal.

    TIP

    It doesn't have to be Terminal, and it doesn't have to be a Mac. You can get SSH client programs for almost any kind of computer, including Windows and Mac OS 9.

    For pre-Mac OS X Macs, for example, you can try MacSSH or NiftyTelnet SSH, both of which you can download from www.missingmanuals.com. To find SSH programs for Windows, visit www.versiontracker.com, click the Windows tab, and search for SSH.

  3. At the % prompt, type ssh -l chris 111.222.3.44. Press Enter.

    Instead of chris, substitute your short account name (as you're known on the Mac you're tapping into), and replace the phony IP address shown here with your real one. (If your Mac back home has a domain name unto itself, such as macmania.com, you can type that instead of the IP address.)

    If all goes well, the ssh command acknowledges your first successful connection by displaying a message like this: "The authenticity of host '172.24.30.189 (172.24.30.189)' can't be established. RSA key fingerprint is d9:f4:11:b0:27:1a:f1: 14:c3:cd:25:85:2b:78:4d:e7. Are you sure you want to continue connecting (yes/no)?" (This message won't appear on subsequent connections.) You're seeing SSH's security features at work.

  4. Type yes and press Enter.

    Now you see one more note: "Warning: Permanently added '172.24.30.189' (RSA) to the list of known hosts." You're then asked for your account password.

  5. Type your account password and press Enter.

    You're in. Issue whatever commands you want. You can now conduct a full Unix Terminal session as described in Chapter 15 and Chapter 16—but by remote control.

    TIP

    For a list of options you can use in SSH, type ssh at the prompt (nothing more) and press Enter.

Where Did Telnet Go?

How do I telnet into my Mac OS X machine?

Telnet and SSH are very similar in concept. But the problem with telnet is that it's more susceptible to hackers.

The SSH networking program, on the other hand, is extremely secure, immune to all kinds of the hacker attacks you may have read about: IP spoofing, IP source writing, DNS spoofing, and so on. That's why Apple replaced its telnet feature with SSH beginning in Mac OS X 10.1.

Apple also hopes that Unix-savvy Mac fans will recognize SSH to be a superior replacement for such remote control Unix programs as rlogin, rsh, and rcp (via scp), for that matter.

21.4.2 Remote Control Program Killing

One of the most common uses of SSH is quitting a stuck program. Maybe it's a program that doesn't respond to the usual Force Quit commands—maybe even the Finder or Terminal. Or maybe, having just arrived in Accounting on the fifth floor, you realize that you accidentally left your Web browser, open to Dilbert.com, up on your screen in clear view of passersby.

In any case, you'd fire up Terminal and proceed like this (what you type is shown in bold; responses are in normal type):

[home-mac:~] chris% ssh 172.24.30.182
The authenticity of host '172.24.30.182 (172.24.30.182)' can't
be established. RSA key fingerprint is
d9:f4:11:b0:27:1a:f1:14:c3:cd:25:85:2b:78:4d:e7.
Are you sure you want to continue connecting (yes/no)? yes
Warning: Permanently added '172.24.30.182' (RSA) to the list of known hosts.
chris@172.24.30.189's password: fisheggs
Welcome to Darwin!
[office-mac:~] chris% top

The top command, as described in Section 16.3.7, displays a list of running programs. After a block of memory statistics, you might see a list like this:

387 top       10.0%  0:07.39  1  14  14   200K   248K   440K  1.37M
382 tcsh       0.0%  0:00.21  1  24  15   444K   568K   904K  5.72M
381 Terminal  12.5%  0:07.76  5  91 164  3.03M+ 6.34M  7.02M+ 54.0M
377 klist      0.0%  0:00.21  1  20  20   264K   964K   832K  5.62M
376 tcsh       0.0%  0:00.01  1   9  14    36K   776K   172K  5.72M
375 CCacheServ 2.5%  0:03.72  1  21  20   288K   948K   880K  5.36M
371 Finder     0.0%  0:04.85  3  91 210  9.20M  7.32M  10.8M  58.2M
358 Sherlock   0.0%  0:05.15  1  63  81  1.98M  5.71M  5.04M  47.4M

As you can see, the Finder is process #371. If that's the stuck program, then, you could quit it like so:

[office-mac:~] chris% kill 371

Or if you're sure of the program's exact name, just use the killall command with the program's name instead of its process ID. To handle a stuck Finder, you would type this:

[office-mac:~] chris% killall Finder

Either way, the Finder promptly quits (and relaunches in a healthier incarnation, you hope). You could also, at this point, type shutdown now to make your Mac, elsewhere on the network, shut down. Type exit to complete your SSH session.

TIP

If you're intrigued by the notion of accessing your Mac from across the Net, try out Memora Server. It lets you—or selected family and friends—listen to music, open photos, or watch movies stored on your Mac OS X machine, from any Web browser on any machine. A three-week trial is available at www.memora.com.


21.5 Virtual Private Networking

After reading the previous pages, you might assume that it's a piece of cake for business people to connect to their corporate networks across the Internet from wherever they happen to be: their homes, hotel rooms, or local Starbucks. But even though the steps on the preceding pages work fine if you're dialing into your home machine, they'll probably fail miserably when you want to connect to a corporate network. There's one enormous obstacle in your way: Internet security.

The typical corporate network is guarded by a team of steely-eyed administrators for whom Job Number One is preventing access by unauthorized visitors. They perform this job primarily with the aid of a super-secure firewall that seals off the company's network from the Internet.

So how can you tap into the network from the road? One solution is to create a hole in the firewall for each authorized user—software that permits incoming Internet traffic only from specified IP addresses like your Mac's. Unfortunately, this setup isn't bulletproof, security-wise. It's also a pain for administrators to manage.

Another solution: You could dial directly into the corporate network, modem-to-modem. That's plenty secure, but it bypasses the Internet, and therefore winds up being expensive. (Want proof? Try this simple test: Make a call from the Tokyo Hilton to the Poughkeepsie Sheet Metal home office. Have a look at your hotel bill when you check out.)

Fortunately, there's a third solution that's both secure and cheap: the Virtual Private Network, or VPN. Running a VPN allows you to create a super-secure "tunnel" from your Mac, across the Internet, and straight into your corporate network. All data passing through this tunnel is heavily encrypted; to the Internet eavesdropper, it looks like so much undecipherable gobbledygook.

And it's cheap—whether you're accessing the Internet via your home DSL, via a local ISP number from a hotel, or wirelessly from your stool at Starbucks.

Remember, though, that VPN is a corporate tool, run by corporate nerds. You can't use this new Mac OS X 10.2 feature without these pieces in place:

  • A VPN server. This is a big deal. If your tech department tells you they don't have one, then that's that—no tunneling for you.

    Furthermore, Mac OS X's VPN software can speak only to VPN servers that speak PPTP (Point to Point Tunneling Protocol), a relative of the PPP language spoken by modems when connecting to the Internet.

    You'll also need to know the Internet address of your VPN server (for example, vpn.ferrets-r-us.com).

    TIP

    Mac OS X's built-in VPN software can also speak IPSec, a Unix VPN protocol. However, this one doesn't have any graphic "front end," meaning that you can use it only by typing commands into the Terminal program. If your corporate server happens to use IPSec, you may find it simpler to use a program like VPN Tracker, available from www.equinux.com/vpntracker.

  • An account on the VPN server or NT domain. PPTP servers are typically part of Microsoft Windows NT networks. Ask your network administrator to help you set up the correct type of account. You'll need to know your account's user name, password and domain name (if any).

21.5.1 Making the VPN Connection

Once you know everything's in place, you connect to the corporate network as follows:

  1. Connect to the Internet.

    Connect the way you normally do—via cable modem, DSL, office network, modem, AirPort, or whatever.

  2. Open Internet Connect.

    It's in your Applications folder.

  3. Choose File [image] New VPN Connection Window (Figure 21-5).

    The first time you do this, a dialog box tells you, "Your computer needs to be set up for VPN (PPTP) connections." Click Continue, and provide an Administrator's name and password, if necessary.

  4. Enter the VPN server address, your VPN account username, and your password. Click Connect.

    If all goes well, several status messages go by. The last one says, "Connected."

    At this point, you're connected to the corporate network. You can perform the same network-related tasks you could if you were actually in that office: check your email, view internal corporate Web pages, access internal FTP servers, make printouts on laser printers thousands of miles away, and so on.

    You generally can't browse things, though. That is, you can't choose Go [image] Connect to Server to view a list of the other computers on the office network, or open Print Center to see a list of networked printers.

    To access these services, you must know their IP addresses. For example, to connect to a shared folder on another computer, choose Go [image] Connect to Server, type its network address, and press Enter.

    TIP

    To connect to a shared folder on a Windows machine, the address looks like this: smb://111.222.33.4/sales-docs. Of course, you'd substitute the correct IP address for the dummy one shown here, and insert the actual name of the shared folder. (You can also use its DNS name instead of the IP address, if you know it, like this: smb://big-blue-server.ferret-lan.com/sales-docs.)

    Classic programs can use your VPN connection, too.

  5. When you're finished accessing the remote network, return to Internet Connect. In the VPN Connection window, click Disconnect.

    It's a good idea to close the tunnel when you're not using it, since it can slow down your Web browser in the meantime.

21.5.2 The Fine Points of VPN

For all the wonders of VPN, here are some possible complications:

  • If you're using a router at home (a little box that shares one cable modem or DSL box with several computers), it might not be able to handle the PPTP protocol, or it might not have that feature turned on. Check the router's manual, or ask its manufacturer for more information.

    For example, the first-generation (silver) AirPort base stations don't support PPTP at all. Neither do the newer, white models—unless you've upgraded to version 2.0.4 or later of the AirPort software.

  • If the corporate network doesn't seem to like your name and password, you might need to add your NT domain name and a backward slash to the beginning of your account name (like this: dom01\msmith) before trying again.

    If you're able to make the connection, but experiencing trouble reaching services by their DNS names (for example, big-blue-server.com), your Mac could be having difficulty finding the right DNS server. Working with your network administrator, open the Network pane of System Preferences. From the Show pop-up menu, choose PPTP; enter the desired DNS server addresses in the DNS Servers box. Click Apply Now, and then try the VPN connection again.

  • If you're still having problems using the VPN, look at the logs (automatically kept technical records) for clues to share with your network administrator. To view these records, open Internet Connect and choose Window [image] Connection Log.

Figure 21-5. You're on your way to joining the corporate network—from thousands of miles away. Virtual private networking is ideal for the paranoid (because it's very secure) and the cheap (because you're using the Internet as a giant wire home).
    [ Team LiB ]


Part VI: Appendixes

Appendix A: Installing Mac OS X 10.2

Appendix B: Troubleshooting

Appendix C: The "Where'd It Go?" Dictionary (Mac Version)

Appendix D: The "Where'd It Go?" Dictionary (Windows Version)

Appendix E: Where to Go From Here

Appendix F: The Master Mac OS X Keystroke List


Appendix A. Installing Mac OS X 10.2

If your computer came with Mac OS X 10.2 already installed on it, you can skip this appendix—for now. But if you're running an earlier version of the Mac OS and want to savor the X experience, this appendix describes how to install the new operating system on your Mac.


A.1 Getting Ready to Install

For starters, verify that you and your Mac have what it takes to handle Mac OS X—specifically this:

  • A Macintosh that came with a G3 or G4 processor. In other words, a Power Mac G3, Power Mac G4, iMac, eMac, iBook, PowerBook G4, or PowerBook G3 (except the very first model, the one bearing a six-color Apple logo). See Installing Mac OS X on Forbidden Macs, however. (According to Apple, Macs with G3 or G4 upgrade cards don't qualify.)

    As you'd probably guess, older Macs run Mac OS X slowly. The newer gear is much more fun.

  • Plenty of free hard disk space. You need 1.9 GB free to install Mac OS X.

  • A lot of memory. Remember that when you use Mac OS X, you'll often be running Mac OS 9 (in the form of the Classic simulator) simultaneously. One modern operating system takes a lot of RAM; two of them require even more. Apple recommends at least 128 MB of memory, but Mac OS X absolutely loves memory. For the greatest speed, install 256 megs, 384 megs, or more if you can afford it (and these days, you probably can).

  • The latest version of Mac OS 9. Once again, Mac OS X and Mac OS 9 will be coexisting on the same computer. You'll have the best luck if you upgrade your copy of Mac OS 9 (version 9.2.2 or later) before installing Mac OS X.

  • The latest firmware. Firmware describes the hard-coded, burned-in software that controls the actual circuitry of your Mac. Every now and then, Apple updates it for certain Mac models, and it's very important that your Mac has the absolute latest. The Software Update control panel of Mac OS 9 is supposed to alert you automatically when such updates become available, but the Utilities [image] Firmware Updates folder on your Mac OS X CD also contains a set of the very latest. Open the folder bearing your Mac model's name and run the updater inside before diving into Mac OS X. (These updaters are also available for download from the Support area of the Apple Web site, of course.)

All that, believe it or not, is the easy part. The more difficult part is assessing whether you'll actually be happy in Mac OS X. Are the programs you use available in Mac OS X versions? Will your scanner and printer work? As noted in Chapter 5, you want to minimize returning to Mac OS 9 just to run some program or piece of add-on equipment that hasn't yet been adapted for Mac OS X.

A.1.1 The Partitioning Question

In the coming months and years, you'll save yourself a lot of trouble and time if you keep Mac OS 9 and Mac OS X on two different drives. This kind of setup offers several advantages:

  • It's much easier to switch between the two operating systems at startup time. (You may hear this feature called dual booting.) Note, however, that this option is not even available on Macs made after January 2003.

  • Troubleshooting Mac OS 9 or Mac OS X is much easier.

  • You don't have to see, or try to distinguish, your Mac OS 9 and Mac OS X folders all mixed together in the single hard drive window (two Applications folders, two System folders, and so on).

The easy and expensive way to achieve this happiness is, of course, to install Mac OS X on a second hard drive (like an iPod).

Fortunately, there's also a free method: partitioning your Mac's main hard drive—dividing its surface so that it appears on your desktop with two different icons and two different names. You can keep Mac OS 9 on one, and Mac OS X on the other. Now you can live like a king, enjoying all the advantages of having two separate hard drives.

Unfortunately, partitioning your hard drive requires first erasing it completely. And that, of course, involves copying all of your files and programs onto some kind of backup disk first—and then copying them back onto the hard drive when the process is over. Ponder this compromise, weighing it against the advantages of partitioning.

If you decide that all that backing up, erasing, and copying is too much hassle to merit the payoff, no harm done. It's perfectly OK to install Mac OS X right onto your Mac OS 9 hard drive. You'll find instructions for both methods in the coming pages.

NOTE

You may have to partition your hard drive if you have certain older Mac models: a PowerBook that lacks USB jacks, a beige Power Mac G3, or an iMac with a CD tray. If your Mac model is one of these, here's the strange little footnote to the installation instructions: You must install Mac OS X onto a partition that's "within" the first 8 GB of the disk. If your hard drive is smaller than 8 GB as it is, never mind—you don't have to partition. If it's larger, however, run Disk Utility as described next to create smaller partitions.

Installing Mac OS X on Forbidden Macs

Apple says that you can't install Mac OS X except on models with G3 or G4 processors. The truth is a little bit more complicated: The Mac OS X installer doesn't run on any models except those, but Mac OS X itself can indeed be made to work. All you need is a patch to make the installer work, and a few pieces of software in the System folder.

That's exactly the point of the XPostFacto, a free program that lets Mac OS X operate on certain pre-G3 Macintosh models, such as Macintosh 7300, 7500, 7600, 8500, 8600, 9500, 9600, and certain clones (Umax S900 and J700, and Power Computing PowerWave and PowerTower Pro).

There are a few glitches along the way, though. For example, you can't reboot into Mac OS 9.2 (although you can use it for Classic). For rebooting purposes, basically the only solution is to keep a separate partition with Mac OS 9.1 on it.

Even so, if your Mac has enough speed and memory, there's no reason why you can't enjoy Mac OS X and all the cool new programs that run only on it. Just don't call Apple asking for technical support.

You can download XPostFacto (and get your questions answered) at http://eshop.macsales.com/OSXCenter.

A.1.2 How to Partition

If you decide to partition your drive, on the other hand, here's how to do it:

  1. Back up everything worth preserving.

    Burn it onto CDs, copy it onto another Mac over the network, email it to yourself, whatever it takes—just remember that you're about to erase the hard drive completely.

  2. Insert the Mac OS X CD. Double-click the Install Mac OS X icon. Click the Restart button.

    Your Mac restarts, booting up from the Mac OS X CD. After a moment, the Installer screen appears—but you don't want to install Mac OS X just now, so don't click Continue.

  3. Choose Installer [image] Open Disk Utility.

    The Disk Utility program opens.

  4. Click the Partition tab. Partition your hard drive as shown in Figure 9-15.

    Actually, you can create more than two partitions, if you see any value in it.

    TIP

    How do you decide how big to make the partitions? If you expect to use your Mac OS 9 System Folder primarily as the basis of your Classic environment (see Chapter 5), its partition can be fairly small—maybe 2 GB or so. The same advice applies if you're an iMovie fan; give the Mac OS X partition as much space as you can, so your DV files will have somewhere to go.

    If you expect to restart your Mac in Mac OS 9 quite a bit, however (if indeed your Mac model can do that), you may want to divide the hard drive roughly in half, so that you'll have plenty of room no matter which operating system you're using.

  5. Click OK. In the warning box, click Partition.

    Now you've done it. Disk Utility erases your hard drive and divides it into the number of partitions you've specified. When the progress bar disappears, choose Disk Utility [image] Quit Disk Utility. You arrive at the first Mac OS X installer screen; skip to step 3 on the next page.


A.2 Four Kinds of Installation

The Mac OS X installer can perform a number of different installations. For example, it can put a copy of Mac OS X 10.2 onto a hard drive that currently has any of these previous installations:

  • None. If you one day need to erase your hard drive—because it's completely hosed, or, less drastically, because you've bought a new, empty external hard drive—this is how you'll do it. See "The Basic Installation" on the next page for the step-by-step process.

  • Mac OS 9 on the hard drive. See "The Basic Installation" for the step-by-step process.

  • Mac OS X 10.0 or 10.1. The 10.2 installer can turn your older copy of Mac OS X into the 10.2 version, in the process maintaining all of your older preferences, fonts, documents, accounts, and so on. See Section A.4.

    On the other hand, a substantial body of evidence (specifically, hundreds of moaning Mac fans online) points to the wisdom of performing a clean install rather than an upgrade installation. You'll still maintain all of your documents and accounts, although you may have to reset a few settings, and the occasional program may need reinstalling. But overall, a clean installation (rather than an upgrade) provides a healthier, more glitch-proof copy of 10.2. See The Clean Install.

  • Mac OS X 10.2. In times of dire troubleshooting, when nothing in Appendix B has helped, you can actually give yourself a fresh copy of 10.2, even though 10.2 is already on the hard drive. This process is called a clean install, and its reappearance in Mac OS X 10.2 is one of the new version's most welcome features. See The Clean Install.


A.3 The Basic Installation

The installation process takes about an hour, but for the sake of your own psyche, you'll probably want to set aside a whole afternoon. Once the installation is over, you'll want to play around, organize your files, and learn the lay of the land.

A.3.1 The Installer

Here's how to install Mac OS X 10.2 onto a drive that doesn't have a version of Mac OS X on it already:

  1. Insert the Mac OS X CD.

    What you see in its main window differs depending on your version of Mac OS X, but there's always a Read Me document worth reviewing before you begin.

  2. Double-click the Install Mac OS X icon. When the Restart button appears, click it.

    The Mac starts up from the CD and takes you directly to the first Installer screen.

    NOTE

    If you're installing a Mac OS X update and not a fresh copy, you'll be asked for an Administrator's password (see Chapter 11). Installing new versions of the operating system is something that only competent people are allowed to do.

    The installer will soon fall into a pattern: Read the instructions, make a couple choices, and click Continue to advance to the next screen.

    As you go, the list on the left side of the screen shows where you are in the overall procedure.

    You can back out of the installation at any time before step 6, just by choosing Installer [image] Quit. When the Restart button appears, click it. Then eject the Mac OS X CD, either by holding down the mouse button while the computer restarts or, if you have a tray-loading CD drive, pushing its eject button during the moment of darkness during the restart.

  3. Click your way through the Select Language, Welcome, Important Information, and Software License Agreement screens.

    Important Information duplicates the Read Me file; the Software License Agreement requires you to click a button confirming that you agree with whatever Apple's lawyers say.

  4. On the Select a Destination screen, click the disk or partition on which you want to install Mac OS X.

    Icons for all of your disks (or partitions) appear onscreen, but ones that are off-limits to Mac OS X (like CDs and USB hard drives) appear dimmed. Click the icon of the drive—or the partition, if you've created one to hold Mac OS X—that will be your new main startup drive.

    NOTE

    If a yellow exclamation point triangle logo appears on a drive, either the drive doesn't have enough space for the installation, or it has a newer version of Mac OS X 10.2 on it. (Click the drive icon and read the message at the bottom of the dialog box to find out.) That's the case if you're trying to do a clean install from a 10.2 CD, but you already have 10.2.1 on the hard drive, for example. No problem; you should be reading the The Clean Install instructions anyway.

  5. Click Continue.

    You arrive at the Easy Install screen. The easiest way to proceed here is to click Install. But you can save a few hundred megabytes of disk space if you take the time to click Customize.

    The Installer displays a list of the various chunks that constitute Mac OS X. A few of them are easily dispensable. For example, if you turn off Fonts for Additional Languages, Additional Asian Fonts, Localized Files (for Japanese, German, and French), and the printer models that you don't own, you save a staggering 890 MB. It's like getting a whole hard drive for free (ka-ching!). Click Install.

    Now you're in for a long wait as the Installer copies software onto your hard drive.

  6. When the first CD pops out, insert Disk 2.

    The installer picks up right where it left off.

    When the installer's finished, you see a message indicating that your Mac will restart in 30 seconds. If you haven't wandered off to watch TV, click the Restart button to end the countdown and get on with it.

Mac OS X is now installed on your Mac—but you're not quite ready to use it yet. See The Setup Assistant.


A.4 The Upgrade Installation

If Mac OS X version 10.0-point-anything (or 10.1-point-anything) is on your hard drive, the Mac OS X 10.2 installer can neatly nip and tuck its software code, turning it into version 10.2. Everything remains just as you had it: your accounts, folders, files, email, network settings, everything-else settings, and so on.

When you're ready to perform the upgrade installation, follow the preceding steps 1-4. On the Select a Destination Disk screen, however, click Options.

Now you're offered four variations of the basic installation. The one you want is Upgrade Mac OS X. Click it and then click OK. Proceed with the previous step 5.


A.5 The Clean Install

In Mac OS 9 and Windows, the clean install is considered an essential troubleshooting technique. It entails installing a second System Folder or WINDOWS/WINNT folder—a fresh one, uncontaminated by the detritus left behind by you and your software programs.

In general, though, you and your software can't invade the Mac OS X System folder. The kind of gradual corruption that could occur in those older operating systems is theoretically impossible in Mac OS X, and therefore the need to perform a clean install is almost completely eliminated.

That's the theory, anyway. In fact, somehow or other, things can go wrong with your Mac OS X installation. Maybe someone was fiddling around in Terminal and accidentally deleted or changed some important underlying files. Certain shareware programs can perform deep-seated changes like this, too.

The point is that eventually you may want to start over with a pristine, perfect copy of Mac OS X. And now, thanks to the new Clean Install option, you can—without having to erase the hard drive first, as you did in earlier Mac OS X versions.

TIP

You can't perform a clean install "upward" from an earlier version of Mac OS X—only from 10.2. In other words, if you have 10.1 and want a clean, perfect installation of 10.2, perform an Upgrade installation first, as described above. Then perform another installation, this one a clean one, as described here.

Start by following steps 1-4 that start in Section A.3.1. When you come to the Select a Destination Disk screen, click Options.

Now you're offered four kinds of installation. Turn on "Archive and Install" and then "Preserve Users and Network Settings."

This powerful option leaves all of your accounts (Home folders, documents, pictures, movies, Favorites, email, and so on) untouched. As the option's name implies, it also leaves your network and Internet settings alone. But it deactivates your old System folder (storing it in a new folder called Previous System Folder) and puts a new one in its place. And that's exactly what you want.

NOTE

You can erase the hard drive at this point if you want to. The "Erase destination" checkbox wipes out everything on the selected drive before installing Mac OS X. (From the pop-up menu, choose Mac OS Extended. The other choice, UNIX File System, is exclusively for people who want to write UNIX programs or require a case-sensitive directory system.)


A.6 The Setup Assistant

When the Mac "comes to" after a basic installation, the first thing you experience is some arty, liquid visual effects, some jazzy music, and an animated stream of Welcome messages in various languages. Once Apple has finished showing off its multimedia prowess, you arrive at a Welcome screen.

Once again, you're in for a click-through-the-screens experience, this time with the aim of setting up your Mac's various settings. After answering the questions on each screen, click Continue.

  1. Choose your area of the country.

    If you chose English as your primary language during the installation phase, for example, you're now asked which particular regional form of English you speak: United States, Australia, Canada, or United Kingdom. Select the appropriate one and click Continue.

  2. Choose a keyboard layout.

    The Character Palette describes the purpose of keyboard layouts. Most people can click right past this screen.

  3. Fill in the Registration Information screen, if you like.

    This is your chance to become a grain of sand on the great beach of the Apple database. Click Continue.

    TIP

    If you're not interested in providing your personal information to Apple, or if you've already done so during a previous installation, press [image] -Q. A message offers you Skip, Shut Down, and Cancel buttons. If you click Skip, you jump straight ahead to step 5.

  4. Answer "A Few More Questions."

    This window includes two pop-up menus that let you tell Apple where your computer will be used (Home, Home Business, and so on) and what you do for a living. You'll also find buttons that let you accept or decline some exciting new junk mail from Apple and its partners. Click Continue.

    The "Thank You" screen now appears, telling you that the information you've just supplied will be sent to Apple as soon as you connect to the Internet. Click Continue.

  5. Create your Administrator account (Figure A-1).

    Most of the steps up to this point have been pretty inconsequential, but this is a big moment. You're about to create your account—your Administrator account, in fact, as described in Chapter 11.

    All you have to do is make up a name, a short variation of your name, and a password (Section 11.2). Choose carefully; you can't easily change your name later.
Figure A-1. If you are the only person who uses your Mac—if it's your personal laptop, for example—none of this information is especially important. You'll never have to remember any of it. In fact, if security isn't an issue for you, you might want to consider leaving the Pass-word field empty. (The Mac will warn you that this isn't a particularly secure scenario if you work on an office network, but you don't care. Having no password will make it easier for you to hook up your Mac to another one, as described in Chapter 12.)

  1. As noted in Figure A-1, this is the only chance you'll ever have to create an Administrator account with no password at all. If you're the only one who uses your Mac, it's perfectly OK to leave the password field empty.

    What you do here is extremely important, especially if several different people use this Mac at different times, or if other people connect to it on a network. See Section 11.2 for details on creating a password and a hint that will help you remember it.

    Click Continue.

    NOTE

    The rest of the setup process involves the creation of an Internet account. If your Mac was already connected to the Internet under Mac OS 9, Mac OS X is kind enough to absorb those settings and take you straight to the final screen. In other words, you may not encounter the screens described in steps 6, 7, 8, and 9.

  2. Specify how you want to connect to the Internet.

    You can tell the setup program that you don't want to set up an Internet account right now. Otherwise, the buttons on this screen let you sign up for an EarthLink Internet account (about $22 per month) or indicate that you already have an Internet service.

    Click Continue. (For the purposes of these instructions, let's say that you decided not to sign up for an EarthLink account, which would introduce a detour in the setup process.)

  3. Indicate how your Mac is connected to the Internet.

    Your choices are "Telephone modem" (your Mac's built-in dial-up modem); "local area network (LAN)" (either an office network or a router connected to your cable modem or DSL); "Cable modem" (a cable modem connected directly to your Mac); "DSL (Digital Subscriber Line)" (one that's connected directly to your Mac); and, if you have an AirPort card, "AirPort wireless."

    When you click Continue, you may be asked for the specific information—the local access number, account name and password, and so on—for your Internet account. See Chapter 18 for advice on filling in these settings. Click Continue.

  4. Sign up for a .Mac account, if you wish.

    You can read all about .Mac accounts in Chapter 18. The crown jewel, of course, is the 100 MB, Internet-based backup hard drive called an iDisk. If you already have a .Mac account, click the appropriate button and fill in your account name and password. If not, click the .Mac button; you're offered the opportunity to make up an iTools name and password.

  5. Go online.

    When you click Continue, you wind up at the Now You're Ready to Connect screen. If you click Continue, your Mac attempts to connect to the Internet and send your registration information to Apple, as three blue blobs juggle themselves to entertain you.

    When the registration is complete, you're offered the opportunity to set up your email account. If you've just been through the .Mac business, your account information—that is, your yourname@mac.com email account information—is already filled in. To set up a different email account, click "Add my existing email account" and fill in the information on the right side of the screen. (Advice on what to fill in here appears on Section 19.1.) When you're done, click Continue.

  6. Set the time zone, date, and time.

    These final screens help to set your Mac's built-in clock. This is a surprisingly important step, since it determines how the files you create will know whether they are older or newer than other versions.

    When you click Continue, the final screen asks you to enjoy your Apple computer. When you click Done, you wind up at the Mac OS X desktop, as described in Chapter 1.


A.7 Uninstalling Mac OS X

There's no easy way to remove Mac OS X if you decide that you don't like it.

The chief problem is that thousands of its pieces are invisible. Even if you start up the Mac from another disk and then drag all the visible Mac OS X folders to the Trash, you'll leave behind many megabytes of software crumbs that you can't see.

Here and there, in books and on Web sites, you'll find conflicting lists of these invisible files, along with elaborate steps for making them visible and then throwing them away. The truth is, however, that you'll save time by simply backing up the data that's worth preserving—your Home folder, Applications folder, Library folder, and whatever folders you use in Mac OS 9—and then erasing the hard drive or partition, using the Drive Setup program on your Mac OS 9 CD.

At this point, your hard drive will be clean, fresh, and ready for an up-to-date installation of Mac OS 9.

NOTE

This advice is a limited-time offer. If your Mac was made after January 2003, it can't start up from Mac OS 9. In that case, Mac OS X is your operating system, take it or leave it.


Appendix B. Troubleshooting

Whether it's a car engine or an operating system, anything with several thousand parts can develop the occasional technical hiccup. Mac OS X is far more resilient than its predecessors, but it's still a complex system with the potential for occasional glitches.

Beware, however: very few pages of the traditional troubleshooting workbook apply to Mac OS X. Traditional Mac fans can forget about all the conventional rituals, including giving a program more memory, turning off system extensions, and rebuilding the desktop; Windows refugees can forget all about driver conflicts, IRQs, and the Registry.

In short, Mac OS X is a whole new world when it comes to troubleshooting.

It's safe to say that you'll have to do less troubleshooting in Mac OS X than in Mac OS 9 and Windows, especially considering that most freaky little glitches go away if you just try these two steps, one at a time:

  • Quit and restart the wayward program.

  • Log out and log back in again.

It's the other problems that will drive you batty. Ladies and gentlemen, here it is: the new Macintosh troubleshooting curriculum.


B.1 Problems That Aren't Problems

Before you panic, accept the possibility that whatever is frustrating you is a Mac OS X difference, not a Mac OS X problem. Plenty of "problems" turn out simply to be quirks of the way Mac OS X works. For example:

  • My System Preferences controls are dimmed. As noted in Chapter 8, many of Mac OS X's control panels are off-limits to standard account holders. That is, only people with Administrator accounts are allowed to make changes, as indicated by the padlock icon at the lower-left corner of such panels.

  • I can't log in! I'm in an endless login loop! If the standard Login screen never seems to appear, it's because somebody has turned on the automatic login feature described on Section 11.3. The Login screen won't appear, giving you a chance to sign in with your own account, until somebody either turns off automatic login or chooses [image] [image] Log Out.

  • I can't move or open a folder. Like it or not, Mac OS X is Unix, and Unix has a very strict sense of who, among the people who share a Mac over time, owns certain files and folders. For starters, people who don't have Administrator accounts aren't allowed to move, or even open, certain important folders. Section 11.2 has much more on this topic.

  • My hard drive is filled with weird-looking files. If you inspect your Mac OS X computer from across the network, you may well be appalled: Its main hard drive window is filled with icons called mach, mach.sym, and mach_kernel that you've never seen when seated at your Mac in person. These are only a few of the thousands of Unix files that constitute Mac OS X—and are generally hidden from view. You can usually see them only from across the network or from Terminal. Ignore them.

If whatever problem you're having doesn't fall into one of the preceding categories, then maybe something truly has gone wrong; read on.


B.2 Minor Eccentric Behavior

Mac OS X itself is generally about as unstable as Mount Everest. It's the programs that most often cause you grief.

All kinds of glitches may befall you. Maybe Mail has sprouted new mailboxes, or your Freehand palettes won't stay put, or the Dock leaves remnants of its "puff of smoke" animation on the screen.

When a single program is acting up like this, try the following steps, in the following sequence.

B.2.1 First Resort: Look for an Update

If a program starts acting up immediately after you've installed or upgraded to Mac OS X 10.2, chances are good that it has some minor incompatibility. Chances are also good that you'll find an updated version on the company's Web site.

B.2.2 Second Resort: Restart the Program

If a program starts acting up, the first and easiest step to take is simply to quit the program and start it up again.

Remember that in Mac OS X, every program lives and dies in solitude, in its own stainless-steel memory bubble. Jettisoning a confused program doesn't affect other running programs in the least. Restarting the flaky program lets it load from scratch, having forgotten all about its previous problems.

B.2.3 Third Resort: Toss the Prefs File

Here we are in the age of Mac OS X, and we're still throwing away preference files?

Absolutely. A corrupted preference file can bewilder the program that depends on it just as badly as it did in Mac OS 9.

Before you go on a dumpfest, however, take this simple test. Log in using a different account (perhaps a dummy account that you create just for testing purposes). Run the problem program. Is the problem gone? If so, then the glitch exists only when you are logged in—which means it's a problem with your copy of the program's preferences.

Return to your own account. Open your Home folder [image] Library [image] Preferences folder, where you'll find neatly labeled preference files for all of the programs you use. Each ends with the file name suffix .plist. For example, com.apple.finder.plist is the Finder's preference file, com.apple.dock.plist is the Dock's, and so on.

Put the suspect preference file into the Trash, but don't empty it. The next time you run the recalcitrant program, it will build itself a brand-new preference file that, if you're lucky, lacks whatever corruption was causing your problems.

If not, quit the program. You can reinstate its original .plist file from the Trash, if you'd find that helpful as you pursue your troubleshooting agenda.

Remember, however, that you actually have three Preferences folders. In addition to your own Home folder's stash, there's a second one in the Library folder in the main hard drive window (which administrators are allowed to trash), and a third in the System [image] Library folder in the main hard drive window (which nobody is allowed to trash).

The only way to throw away the .plist files from this most deep-seated source (inside the System folder) is to use one of the usual security-bypass methods described in Fixing Permissions Problems.

In any case, the next time you log in, the Mac will create fresh, virginal preference files.

B.2.4 Fourth Resort: Log Out

Sometimes you can give Mac OS X or its programs a swift kick by logging out ( [image] [image] Log Out) and logging back in again. It's an inconvenient step, but not nearly as time-consuming as restarting the computer.

B.2.5 Fifth Resort: Empty the Login Items List

If a program is crashing just after you log in, inspect and clear out your Login Items list (Section 11.2.6). It may be that you've set up a program to auto-start...a program that doesn't like auto-starting in Mac OS X 10.2.

B.2.6 Last Resort: Trash and Reinstall the Program

Sometimes reinstalling the problem program clears up whatever the glitch was.

First, however, throw away all traces of it. Fortunately, trashing a program is much easier in Mac OS X than in Mac OS 9, thanks to its application package structure (When Programs Are Actually Folders). Just open the Applications folder and drag the program's icon (or its folder) to the Trash. In most cases, the only remaining piece to discard is its .plist file(s) in your Home [image] Library [image] Preferences folder.

Then reinstall the program from its original CD or installer—after first checking the company's Web site to see if there's an updated version, of course.


B.3 Frozen Programs (Force Quitting)

The occasional unresponsive application has become such a part of Mac OS X life that, among the Mac cognoscenti online, the dreaded, endless "please wait" cursor has been given its own acronym: SBOD (Spinning Beachball of Death). When the SBOD strikes, no amount of mouse clicking and keyboard pounding will get you out of the recalcitrant program.

The situation is clearly better in Mac OS X 10.2. Now, at least, your cursor turns back into an arrow when you move it off of the balky program's window. But that doesn't stop the balkiness.

Here are the different ways you can go about force quitting a stuck program (the equivalent of pressing Ctrl-Alt-Delete in Windows), in increasing order of desperation:

  • Use the Dock. If you can't use the program's regularly scheduled File [image] Quit command, try Control-clicking its Dock icon and choosing Quit from the pop-up menu.

  • Force quit the usual way. Choose [image] [image] Force Quit to terminate the stuck program, or use one of the other force-quit methods described in Section 4.1.2.

  • Force quit the sneaky way. Some programs, including the Dock, don't show up at all in the usual Force Quit dialog box. Your next attempt, therefore, should be to open the Process Viewer program (in Applications [image] Utilities), which shows everything that's running. Double-click a program to force quit it. (Unix hounds: You can also use the kill command in Terminal, as described in Section 16.3.2.)

    TIP

    If you find yourself having to quit the Dock more than once, here's an easier way: make yourself a little AppleScript (Chapter 7) consisting of a single line: tell application "Dock" to quit. Save it as an application. Whenever you feel that the Dock needs a good kick in the rear, double-click your little AppleScript.

  • Force quit remotely. If the Finder itself has locked up, you can't very well get to Process Viewer. At this point, you may have to abort the locked program from another computer across the network, if you're on one, by using the SSH (secure shell) command. The end of Chapter 21 offers a blow-by-blow description of how you might terminate a program by remote control in this way, either from elsewhere on the office network or even from across the Internet.

    TIP

    If all of this seems like a lot to remember, you can always force-restart the Mac. On desktop Macs, press the left-pointing triangle button on the front or side of the computer; on laptops, you press Control- [image] -power button.

The Microsoft Word Crash Bug

Ever since I installed Jaguar, Microsoft Word X unexpectedly quits. Any ideas?

You have two alternatives: First, use the Uninstall program on your Microsoft Office X CD to remove all traces of Office—and then reinstall it. (Your documents will remain untouched.)

Second, wait for Microsoft to solve the problem and release another double-decimal-point upgrade.


B.4 Error Messages When Opening

If you get an error message when you try to open something (a program, a document, a folder), it may be that the permissions of either that item or something in your System folder have become muddled. It can happen to the best of us.

Fortunately, a new option in Mac OS X 10.2 is designed to identify and fix such problems automatically. Open your Applications [image] Utilities folder, and launch Disk Utility. Click the First Aid tab, click your hard drive, click Verify, click Verify Disk Permissions, and then read an article while the Mac checks out your disk; see Figure B-1.

Figure B-1. If the program finds anything amiss, you'll see a message like this one. You may recognize this notation as Unix shorthand for read, write, and execute privileges (Chapter 16). If you agree with the Mac's assessment (and unless you're a hard-core Unix geek, you have no choice), click Repair. Disk Utility whirls into action, cleaning up each of the problems and reporting the results to you in the display window.
    [ Team LiB ]


B.5 The Wrong Program Opens

As noted in Chapter 4, the way documents are linked to the programs that can open them is very different in Mac OS X than it was before. Some documents have invisible, four-letter type and creator codes that tell them which programs they "belong to." Other documents lack these codes, and open up in whichever program recognizes its file name extension (.doc or .txt, for example).

Section 4.3.4.1 shows you how to choose which program opens a certain document (or kind of document). But that's not much help when you double-click a SimpleText document and have to sit there while SimpleText opens up—in Classic, mandating a 45-second wait.

The simple rule to remember here is that creator codes override file name extensions. In other words, a file called Contract.txt generally opens in Mac OS X's TextEdit—if it doesn't have a four-letter creator code behind the scenes. If that same file has SimpleText's creator code (ttxt), however, it opens in SimpleText (and Classic) no matter what its file name is.

In the SimpleText case, the quick solution is to install the Carbonized (that is, Mac OS X-compatible) version of SimpleText. It's on the Mac OS X Developer CD (see The Developer Tools CD Extras).

In other cases, the quickest solution may be to strip away the type and creator codes. You can do that by dragging the troubled files' icons onto a program like Wipe Creator (available from the software page of www.missingmanuals.com). At that point, Mac OS X has only the document's file name extension to go on when choosing a program to open it.

Fixing Permissions Problems

Sooner or later, when you try to move, rename, or delete a certain file or folder, you may get an error message like this—"The folder 'Junk' could not be opened because you do not have sufficient access privileges"—or this: "The operation could not be completed because this item is owned by Chris" (or by root, which means by Mac OS X itself).

Both kinds of messages, with their awkward passive-voice construction, clank on the trained English-speaking ear. However, what they're trying to say is, you've run into a permissions problem.

As noted in Chapter 11, Mac OS X is designed to accommodate a number of different people who share the same Mac over time. Nobody is allowed to meddle with other people's files or folders. But even if you're the solo operator of your Mac, you still share it with Mac OS X itself (which the error messages may refer to as root or system).

In any case, if you're confident that whatever you're trying to do isn't some kind of nihilistic, self-destructive act like trashing the Applications folder, it's easy enough to get past these limitations. Just highlight the recalcitrant file or folder and then choose File [image] Get Info. In its window, you'll find an Ownership & Permissions panel that lets you reassign ownership of any icon to, for example, yourself (if you have an Administrator account, that is). Make sure your permission is "Read & Write." (Just don't perform this surgery on files in the System folder.)

Now you own that folder or file, and you can do whatever you like with it.


B.6 Can't Empty the Trash

The can't-empty-the-trash problem is far less common in Mac OS X 10.2 than in previous Mac OS X versions. Clearly, Apple received plenty of customer feedback on this one.

If you're having trouble emptying the Trash, however, start by holding down the mouse on the Trash icon itself. When you choose Empty Trash from the pop-up menu, Mac OS X empties the Trash without complaint, locked files and all.

If emptying the Trash gives you "Could not be completed because this item is owned by Marge," you're trying to move or delete another Mac account holder's stuff. As you know, that's a big no-no in Mac OS X.

In that case, just make yourself the new owner of the file or folder, as described in the box on the preceding page.


B.7 Can't Move or Rename an Icon

If you're not allowed to drag an icon somewhere, the error message that appears almost always hits the nail on the head: You're trying to move a file or folder that isn't yours. Again, the box on the facing page explains the solutions to this problem.


B.8 Application Won't Open

If a program won't open (if its icon bounces merrily in the Dock for a few seconds, for instance, but then nothing happens), begin by trashing its preference file, as described in Section B.2.3. If that doesn't solve it, reinstalling the program usually does.


B.9 Program Icons Turn to Folders

You may remember that in Mac OS X, almost every application, behind the scenes, is actually a folder. All you see (and double-click to open) is one icon called Mail, for example, but inside are dozens of folders, icons, and chunks of software code. The only way you'd ever know that a Mac OS X "application icon" is an optical illusion would be to Control-click the application and, from the pop-up menu, choose Show Package Contents.

Every now and then, though—most often after a power failure—Mac OS X puts on a much more showy display of this feature than perhaps you'd like: Suddenly all applications show up as folders, whose names bear the suffix .app. All very educational, of course, but now you have no way to actually run those programs, because the icon to double-click has disappeared.

B.9.1 First Resort: Trash the Three Prefs

Most of the time, the generic-folders problem stems from the corruption of three particular preference files in your Home [image] Library [image] Preferences folder: namely, LSApplications, LSClaimedTypes, and LSSchemes. Throw them away, and then log out. When you log back in, your applications should all have been restored to their rightful conditions.

NOTE

Tossing these preference files also discards any document-to-application relationships you've established as described in Section 4.3.4.1.

B.9.2 Second Resort: Check the Disk

Sometimes your NetInfo database—the central database of all accounts, programs, connections, and everything Mac OS X knows about its world—gets confused. Running Disk Utility or fsck, its Unix equivalent, should clear it up (Section B.11.1).

B.9.3 Last Resort: Make it Your Own

Finally, it's conceivable that the permissions for your own Home folder have become hosed, meaning that Mac OS X believes that somebody else owns your Home folder.

Check its access privileges by highlighting your Home folder's icon and choosing File [image] Get Info. If you aren't identified as the owner (on the Ownership & Permissions panel), see Fixing Permissions Problems.

The Shift Key, "Safe Mode," and You

Mac OS 9 fans press the Shift key at startup to turn off the extensions. Windows fans press an Fkey to start up in Safe Mode. Either way, the idea is the same: to turn off all non-essential system-software nubbins in an effort to get a sick machine at least powered up.

Although not one person in a hundred knows it, Mac OS X offers the same kind of emergency keystroke. It can come in handy when you've just installed some new piece of software and find that you can't even start up the machine; with this trick, you can at least turn on the computer so that you can uninstall the cranky program.

The trick is to press the Shift key as the machine is starting up. Hold it down from the startup chime until you see the words "Safe Boot" on the progress-bar box.

You've just turned off a large mass of kernel extensions, which are chunks of software that add various features to the basic operating system. You'll find a long list of standard features inoperable: Mac OS X's sound software; laptop-specific features like PC cards, infrared, and internal modems; all USB gadgets except the keyboard and mouse; FireWire camcorders; and any feature that didn't come from Apple.

The next time you restart, all of this goodness will be restored (assuming you're no longer clutching the Shift key in a sweaty panic).

As noted in Appendix F, by the way, there's another use for the Shift key: If you press it just after logging in but before the desktop appears, you prevent any Finder windows from opening and prevent any startup items from opening—that is, icons you added to your Login Items list (Section 11.2.6).

This, too, is a troubleshooting tactic. If some startup item crashes your Mac every time it opens, you can squelch it just long enough to remove it from your Login Items list.


B.10 Startup Problems

Not every problem you encounter is related to running applications. Sometimes trouble strikes before you even get that far. The following are examples.

B.10.1 Kernel Panic

When you see the cheerful, multilingual dialog box shown in Figure B-2, you've got yourself a kernel panic—a Unix nervous breakdown.

Figure B-2. A kernel panic is almost always related to some piece of add-on hardware. And look at the bright side: At least you get this handsome dialog box in Mac OS X 10.2. That's a lot better than the Mac OS X 10.0 and 10.1 effect—random text gibberish super-imposing itself on your screen.

(In such situations, user panic might be the more applicable term, but that's programmers for you.)

Kernel panics were rare to begin with, but in Mac OS X 10.2 and later they're increasingly unusual. If you see one at all, it's almost always the result of a hardware glitch: some memory board, accelerator card, graphics card, SCSI gear, or USB hub that Mac OS X doesn't like.

If simply restarting the machine doesn't help, detach every shred of gear that didn't come from Apple. Restore these components to the Mac one at a time until you find out which one was causing Mac OS X's bad hair day. If you're able to pinpoint the culprit, seek its manufacturer (or its Web site) on a quest for updated drivers, or at least try to find out for sure whether the add-on is compatible with Mac OS X.

TIP

This advice goes for your Macintosh itself. Apple periodically updates the Mac's own "drivers" in the form of a firmware update. You download these updaters from the Support area of Apple's Web site (if indeed Mac OS X's own Software Update mechanism doesn't alert you to its existence).

There's one other cause for kernel panics, by the way, and that's moving, renaming, or changing the access permissions for Mac OS X's essential system files and folders—the Applications or System folder, for example. (See Fixing Permissions Problems for more on permissions.) This cause isn't even worth mentioning, of course, because nobody would be that foolish.

B.10.2 Freezes During Startup

If the Mac locks up during the startup process, you need to run Mac OS X's disk-repair program, as described below.

B.10.3 Gray Screen During Startup

Confirm that your Mac has the latest firmware, as described in the previous Tip. Detach and test all your non-Apple add-ons, also as described in the previous paragraphs. Finally, perform a disk check (see below).

B.10.4 Blue Screen During Startup

Most of the troubleshooting steps for this problem (which is usually accompanied by the Spinning Beachball of Death cursor) are the same as those described under "Kernel Panic," above. But there's one other cause to examine: a corrupted font file in your Mac OS 9 System Folder.

To test for this problem, restart the Mac in Mac OS 9, open its System Folder (that's the folder called System Folder, not just System), and drag the Fonts folder to the desktop. Restart in Mac OS X. If the startup proceeds smoothly, you know you've got a damaged font file in that Fonts folder.

B.10.5 Forgotten Password

If you or one of the other people who use your Mac have forgotten the corresponding account password, no worries: just read The Case of the Forgotten Password.


B.11 Fixing the Disk

As noted in the introduction of this book, the beauty of Mac OS X's design is that the operating system itself is frozen in its perfect, pristine state, impervious to conflicting system extensions, clueless Mac users, and other sources of disaster.

That's the theory, anyway. But what happens if something goes wrong with the complex software that operates the hard drive itself?

Fortunately, Mac OS X comes with its own disk-repair program. In the familiar Mac universe of icons and menus, it takes the form of a program in Applications [image] Utilities called Disk Utility. In the barren world of Terminal and the command line interface, there's a utility that works just as well but bears a different name: fsck (for file system check).

In any case, running Disk Utility or its alter ego fsck is a powerful and useful troubleshooting tool that can cure all kinds of strange ills, including these problems, among others:

  • Your Mac freezes during startup, either before or after the Login screen.

  • The startup process interrupts itself with the appearance of the text-only command line.

  • You get the "applications showing up as folders" problem (see Section B.9).

B.11.1 Method 1: Disk Utility

The easiest way to check your disk is to use the Disk Utility program. Use this method if your Mac can, indeed, start up. (See Method 2 if you can't even get that far.)

Disk Utility can't check the disk it's on. That's why you have to restart the computer from the Mac OS X CD-ROM (or another startup disk), and run Disk Utility from there. The process goes like this:

  1. Start up the Mac from the Mac OS X CD.

    The best way to do that is to insert the CD and then restart the Mac while holding down the C key.

    You wind up, after some time, at the Mac OS X Installer screen. Don't be fooled—installing Mac OS X is not what you want to do here. Don't click Continue!

  2. Choose Installer [image] Open Disk Utility.

    That's the unexpected step. After a moment, the Disk Utility screen appears.

  3. Click the First Aid tab.

    The program now looks like the illustration in Figure B-3.
Figure B-3. Disk Utility is the Mac OS X version of the old Disk First Aid program. When your hard drive is acting up, don't waste your time with the Verify button. It's exclusively for use on disks that you can't repair, like CD-ROMs and the startup disk—disks you just want to have a look at.

  4. Click the disk or disk partition you want to fix, and then click Repair.

    The Mac whirls into action, checking a list of very technical disk-formatting parameters.

If you see the message, "The volume 'Macintosh HD' appears to be OK," that's meant to be good news. Believe it or not, that cautious statement is as definitive an affirmation as Disk Utility is capable of making about the health of your disk.

NOTE

Don't be alarmed. The message's last line says "Repair completed" whether or not any repairing was done at all.

Disk Utility may also tell you that the disk is damaged, but that it can't help you. In that case, you need a more heavy-duty disk-repair program like Drive 10 (www.micromat.com).

B.11.2 Method 2: fsck at the Console

Disk Utility isn't of much use when you can't find the Mac OS X CD, when your CD drive isn't working, or when you're in a hurry to get past the startup problems that are plaguing your machine. In these cases, you'll be glad that you can boot into the Mac's raw Unix underlayer to perform some diagnostic (and healing) commands.

Specifically, you'll be glad that you can run the Unix program fsck, for which Disk Utility is little more than a pretty faceplate.

Like any Unix program, fsck runs at the command line. You launch it from the all-text, black Unix screen by typing the command and pressing Enter.

B.11.2.1 Single-user mode ( -S at startup)

The Terminal program is the best known form of Mac OS X's command line, but it's not the only one. In fact, there are several other ways to get there.

In general, you don't hear them mentioned except in the context of troubleshooting, because the Terminal program offers many more convenient features for doing the same thing. And because it's contained in a Mac OS X-style window, Terminal is not so disorienting as the three methods you're about to read.

All of these techniques take you into console mode, shown in Figure B-4. In console mode, Unix takes over your screen completely, showing white type against black, no windows or icons in sight. Abandon the mouse, all ye who enter here; in console mode, you can't do anything but type commands.

Figure B-4. In console mode, your entire screen is a command line interface. Unix jockeys can go to town here. Everyone else can timidly type fsck -y after the localhost # prompt—see this prompt on the very last line?—and hope for the best.

To get there in times of startup troubleshooting, press [image] -S while the Mac is starting up. (If you're stuck at the frozen remnants of a previous startup attempt, you may first have to force-restart your Mac; see the tip in Section B.3.)

Instead of arriving at the usual desktop, you see technical-looking text scrolling up a black screen as the Mac runs its various startup routines. When it finally stops at the localhost # prompt, you're ready to type commands. You're now in what's called single-user mode, meaning that the Unix multiple-accounts software has yet to load. You won't be asked to log in.

At the localhost # prompt, type fsck -y (note the space before the hyphen) and press Enter. (The y means "yes," as in "yes, I want you to fix any problems automatically.")

TIP

You've probably gone to this trouble for the sake of running fsck, the Unix disk-checking program. But you can also use ls, cd, rm, or any of the other Unix commands described in Chapter 15 and Chapter 16.

Now the file system check program takes over, running through five sets of tests. When it's complete, you'll see one of two messages:

  • The volume Macintosh HD appears to be OK. All is well. Type reboot and press Return to proceed to the usual Login screen and desktop.

  • File system was modified. A good sign, but just a beginning. You need to run the program again. One fsck pass often repairs only one layer of problems, leaving another to be patched in the next pass. Type fsck -y a second time, a third time, and so on, until you finally arrive at a "disk appears to be OK" message.

Viruses? What viruses?

One great thing about the old Mac OS was that there were hardly any viruses to worry about—all of the nasties seemed to be written for Windows. But now that we're using Unix, which has been around for 30 years and has a huge user base, is it time to worry again?

Nope. There are even fewer viruses for Unix than for the Mac OS.

You still need to be careful with Word and Excel macro viruses, of course. If you open a Word or Excel attachment sent by email from someone else, and a big fat dialog box warns you that it contains macros, simply click Disable Macros and get on with your life.

Otherwise, you have little to worry about. Sleep well.

B.11.2.2 Other ways to get to the console

Pressing [image] -S at startup isn't the only way to get to the console (command line). You can also:

  • Log in as >console. Get rid of the names and pictures of your account holders on the Login screen by opening the Accounts panel of System Preferences; clicking Login Options; and selecting "Name and password."

    Then, when you sign in, type >console as your user name, and leave the password field blank. When you click Log In, you arrive at the usual black console screen.

  • Parachute out of Terminal. From within Terminal (see Chapter 15), type sudo shutdown now. Once again, you arrive in console mode—black screen, no windows, ready to accept your Unix commands.

For most Mac fans, however, the primary reason to use console mode is to run fsck, and the best way to do that is by pressing [image] -S at startup.

TIP

In all cases, typing reboot at the prompt and pressing Return is how you get back to the familiar Aqua world of icons and windows.

The Reinstall

When some component is missing, your troubleshooting steps have failed, and Mac OS X continues to act up, consider reinstalling Mac OS X.

That's not a big deal at all. It involves inserting the Mac OS X CD, restarting the Mac, pressing the C key as the computer starts up, and proceeding with the installer as described in Appendix C.

The good news is that reinstalling Mac OS X doesn't touch your files, folders, or settings. It simply patches whatever holes have opened up in the Unix undercarriage of your operating system—which, every now and then, does you a world of good.

In the days before Mac OS X 10.2, there was a bit of bad news at the far end, though. Apple continues to hone Mac OS X with successive versions—10.2.1, 10.2.2, whatever. If you installed downloaded updates after you'd installed your CD-based version of Mac OS X, you were out of luck. The installer couldn't install an older copy of Mac OS X on top of an updated one.

The 10.2 installer, however, offers a new Archive & Install option—in geek language a clean install. (Appendix A has the details.) It gives you a brand-new Mac OS X System folder, neatly retiring the previous one (and, in fact, renaming it Previous System Folder).

Yes, your new, virginal System folder isn't the latest version of Mac OS X. But that's OK—it's now safe to install all of the updaters you've run since your Mac OS X CD was pressed. In no time (all right, in 35 minutes), you'll be right back where you were, this time without the glitches.


B.12 Where to Get Troubleshooting Help

If the basic steps described in this chapter haven't helped, the universe is crawling with additional help sources.

B.12.1 Help Online

These Internet sites contain nothing but troubleshooting discussions, tools, and help:

  • MacFixIt (www.macfixit.com). The world's one-stop resource for troubleshooting advice.

  • Mac newsgroups (such as comp.system.mac). A newsgroup is an Internet bulletin board, which you can access using a program like Microsoft Entourage or Thoth (www.thothsw.com). If you're polite and concise, you can post questions to the multitudes here and get more replies to them than you'll know what to do with.

  • Other Apple support resources (apple.com/support). Apple's help Web site also includes downloadable manuals, software updates, frequently asked questions, and many other resources.

The mother of all troubleshooting resources, however, is Apple's own Knowledge Base. This is the collection of 50,000 individual technical articles, organized in a searchable database, that the Apple technicians themselves consult when you call for help.

If you like, you can visit this library using your Web browser (http://kbase.info.apple.com) or right within Sherlock 3 (click the AppleCare icon). You can search it either by typing in keywords or by using pop-up menus of question categories.

B.12.2 Help by Telephone

Finally, consider contacting whoever sold you the component that's making your life miserable: the printer company, scanner company, software company, or whatever.

If it's a Mac OS problem, you can call Apple at 800-275-2273 (that's 800-APL-CARE). For the first 90 days following your purchase of Mac OS X (which, as far as Apple knows, is the date of your first call), the technicians will answer your questions for free.

After that, unless you've paid for AppleCare for your Mac (a three-year extended warranty program), Apple will charge you to answer your questions—unless the problem turns out to be Apple's fault, in which case they won't charge you.


Appendix C. The "Where'd It Go?" Dictionary (Mac Version)

This one's for you, veteran Mac fans. Even if you ultimately conclude that Mac OS X's stability, good looks, and security make it worth the switch, you'll do quite a bit of fumbling at first to find your way around.

Here's your complete guide to which of the classic Mac features survive in Mac OS X 10.2, which have moved around to confuse you—and which have bitten the dust.

TIP

Some commands are listed under the names of the menus in which they appear. Applications, System Folder folders, and control panels are all listed under their own names.


C.1 Classic Mac Features

C.1.1 ~ATM control panel

You won't find Adobe Type Manager (ATM) in Mac OS X. The ability to smooth out jagged edges on PostScript fonts is built in and no longer requires this separate control panel. See Chapter 13 for more on fonts.

C.1.2 Appearance control panel

There's no longer a control panel called Appearance, but the best of its features are still around. Here's the rundown:

  • Themes tab. Gone.

  • Appearance tab. You'll find the equivalent pop-up menus (for text highlight color, etc.) in Mac OS X's System Preferences [image] General pane.

  • Fonts tab. You can't change the fonts used by Mac OS X (although TinkerTool, described in Chapter 17, lets you change some of them). You can, though, change the type size used by the names of icons, either in a single window or globally. Choose View [image] View Options to see the controls.

  • Desktop tab. Now you apply a picture to your desktop by opening the System Preferences [image] Desktop panel.

  • Sound tab. On the Sound panel of System Preferences, you can turn on "Play user interface sound effects," which adds tiny, subtle sound effects to your mouse movements when you drag something off the Dock or empty the Trash.

  • Options. The Smart Scrolling option is now in the System Preferences [image] General pane. There's no longer a "double-click title bar to windowshade the window" option, because the equivalent effect is always on in Mac OS X. (Double-clicking a title bar minimizes the window.)

C.1.3 Apple DVD Player

It's now called DVD Player, and (if your Mac does, in fact, have a DVD player built in) it's in the Applications folder.

C.1.4 Apple Extras

There's no longer an Apple Extras folder, but several of the items that used to be in this folder live on in new locations. For example:

  • The AppleScript folder is now in the Applications folder.

  • Digital Color Meter, which used to be in the Monitor Extras folder, is now located in Applications [image] Utilities. See Chapter 9.

  • The Font Extras folder, which contained the FontSync control panel, is gone, but FontSync itself is alive and well. The AppleScripts that let you use FontSync sit in the hard drive's Library [image] Scripts [image] FontSync Scripts folder.

  • The Mac OS Runtime for Java folder is gone, but the Apple Applet Runner, which was inside that folder, has been replaced with the Applet Launcher in Applications [image] Utilities.

Most of the other Apple Extras items—miscellaneous folders like FireWire, Iomega, and Apple LaserWriter Software—have disappeared because they've been incorporated into Mac OS X itself.

C.1.5 Apple menu

The [image] menu is still in Mac OS X, but it's no longer customizable. Instead, it lists several useful commands that you'll want to access no matter what program you're using: Sleep, Restart, Shut Down, and so on. The [image] menu's quick-access icon launching features have now been taken over by the Dock (Chapter 3).

  • About This Computer. This command's functions have been scattered across Mac OS X. To find out your Mac's system-software version, total installed memory, and processor type, choose [image] [image] About This Mac. For memory stats on running programs, go to Applications [image] Utilities and open Process Viewer. It shows you, perhaps, a little more information than you need, but the memory consumption listings are still there, updated in real time (because Mac OS X programs don't use a fixed amount of RAM; they constantly adjust as needed).

  • Apple System Profiler. Still in Mac OS X, better than ever—but now found in Applications [image] Utilities.

  • Calculator. Dramatically revamped (see Chapter 9) and moved to your Applications folder.

  • Chooser. Eliminated. Its two primary functions—choosing a printer and connecting to a network—have been moved to Print Center (in Applications [image] Utilities) and the Go [image] Connect to Server command, respectively.

  • Control Panels. It's now called System Preferences (Chapter 8). You can get to it by clicking its Dock icon or by choosing [image] [image] System Preferences.

  • Favorites. In Mac OS X, your favorites are now listed as a submenu of the Go [image] Favorites command in the Finder.

  • Key Caps. Better than ever. Now in the Applications [image] Utilities folder.

  • Network Browser. Eliminated. Use the Go [image] Connect to Server command at the desktop instead.

  • Recent Applications, Recent Documents, Recent Servers. Recent Applications and Recent Documents are now submenus of the [image] [image] Recent Items command. To see networked disks (servers) to which you've recently connected, choose either Go [image] Recent Folders or, for a network-only list, Go [image] Connect to Server. In the Connect to Server box, the pop-up menu lists recently accessed servers.

  • Remote Access Status. It's now called Internet Connect, and it's in your Applications folder.

  • Scrapbook. Eliminated. The closest equivalent is Stickies (in your Applications folder), which can now accept graphics, sounds, and movies.

  • Sherlock 2. Sherlock (now version 3) is still the Mac's search engine for the Web, but now you launch it by clicking the Sherlock icon on the Dock. (You can always double-click it in the Applications folder, but that takes longer.)

    You no longer use Sherlock to search for files, however. For that purpose, use the Search bar or File [image] Find command described in Chapter 2.

  • Speakable Items. To get the list of speakable commands that your Mac can understand, first turn on Speakable Items using System PREFERENCES [image] SPEECH [image] Speech Recognition [image] On/Off. The round Speech Feedback panel appears on your screen. Click the small black triangle at the bottom of the panel and choose the Open Speech Commands window (see Chapter 14).

  • Stickies. Received a major update in Mac OS X, as described in Chapter 9. (It's in the Applications folder.)

C.1.6 Apple Menu Options control panel

Gone, because there are no [image] menu options in Mac OS X. The menu isn't customizable or configurable.

C.1.7 AppleCD Audio Player

Replaced by the vastly superior iTunes (in the Applications folder). See Chapter 10.

C.1.8 AppleScript

Apple's built-in scripting language for the Mac works in Mac OS X. But the Mac OS X 10.2 Finder isn't recordable, so you can't create Finder scripts simply by having Script Editor record your actions, step by step. To write your own scripts, you actually need to type some code (Chapter 7). Find the Script Editor in the Applications [image] AppleScripts folder.

C.1.9 AppleTalk control panel

These networking controls are now in the System Preferences [image] Network panel.

C.1.10 Application menu

Gone. You now use the Dock to see which programs you have running (the icons with little black triangles beneath them) and to switch between those programs. As noted in Chapter 4, however, you can still use the Dock for many of the tricks the Application menu used to play.

The Hide application and Hide Others commands, meanwhile, are now at the left end of the menu bar in the new Application menu—the one that bears the current application's name.

C.1.11 Audio CD AutoPlay

This option—once a part of the QuickTime Settings control panel—has moved. When you insert a music CD, the iTunes 3 program opens automatically (assuming you haven't changed the settings in the CDs & DVDs panel of System Preferences).

In the iTunes Preferences window, go to the General panel and choose Begin Playing from the "On CD Insert" pop-up menu.

C.1.12 Balloon Help

Balloon Help is officially retired.

C.1.13 Battery Level

The status of the battery in your PowerBook or iBook used to be displayed in the Control Strip. In Mac OS X, this indicator appears on the menu bar—immediately after you open System Preferences [image] Energy Saver [image] Options and turn it on.

C.1.14 Button View

Reincarnated, sort of, as Simple Finder mode (Chapter 11).

C.1.15 Chooser

Replaced by Print Center and the Go [image] Connect to Server command. See the [image] menu entry above for more information.

C.1.16 Clean Up command

Just where it always was, good as ever.

C.1.17 Click-and-a-half

Mac OS X 10.2 folders are spring-loaded: If you drag an icon onto one and don't let go of the mouse button, the window springs open around it so that you can continue your drag. But they still don't pop open automatically when you hover over them after a "click-and-a-half"—when you double-click, then do another half-click, so that the mouse button stays down. (Sound complicated? Maybe that's why Apple killed it.)

C.1.18 CloseView

This control panel, which produced a magnified view of the Mac screen for visually impaired users, is back—now in an enormously enhanced, easy-to-use version. It's now found on the Universal Access panel of System Preferences, described in Chapter 8.

C.1.19 -Drag to scroll an icon-view window

Now you hold down Option and [image] to achieve this function.

C.1.20 -Shift-3, -Shift-4

These keystrokes still take pictures of your screen, with even more options available in 10.2 (Section 13.10).

C.1.21 Collapse box

Windows don't collapse with a "window shade" action in Mac OS X, but you can minimize them, reducing them to icons that stay parked in the Dock until you need them. Click the yellow button on the left side of a window's title bar, or press [image] -M, to minimize it.

C.1.22 ColorSync control panel

ColorSync color management settings are now set in System Preferences [image] ColorSync. You can also get information about your ColorSync profiles using the ColorSync Utility, located in Applications [image] Utilities.

C.1.23 Contextual Menu Items folder

Mac OS X makes extensive use of contextual pop-up menus, but there's no longer a folder into which you can drop expansion modules to add new contextual menu commands.

C.1.24 Control panels

There are no control panels in Mac OS X. Instead, there's a program called System Preferences that handles the various hardware and software settings formerly configured with control panels. Choose [image] [image] System Preferences, or click the System Preferences icon on the Dock. (System Preferences is also in the Applications folder.)

C.1.25 Control Strip control panel

The Control Strip is gone. However, several of its traditional features survive in the form of menulets—icon/pop-up menus in your menu bar that let you monitor and control dial-up settings, monitor resolution, color depth, sound volume, and battery levels, as well as the date and time. You make these menulets appear using checkboxes in the corresponding panes of System Preferences (such as Displays, Sound, Energy Saver, and Date & Time), and the Internet Connect application.

C.1.26 Date & Time control panel

Replaced by the Date & Time panel in System Preferences.

C.1.27 Desktop clippings

Text and picture clippings produced by dragging selected text and images to the desktop work just as they did in Mac OS 9.

C.1.28 Desktop printers

Desktop icons no longer represent each printer configured to work with your Mac. To see what printers you have available, or to configure a new printer, use Print Center (in Applications [image] Utilities). But even that's unnecessary when you just want to switch printers; you can do so right in the Print dialog box.

C.1.29 Dial Assist control panel

Eliminated. Enter dialing information for dial-up modem connections in the PPP pane of the System Preferences [image] Network panel.

C.1.30 Disk First Aid

Disk First Aid is now a part of Disk Utility, located in the Applications [image] Utilities folder. Launch Disk Utility and click the First Aid tab.

C.1.31 Disk icons

Disk icons still appear on the desktop, but a checkbox in Finder [image] Preferences now gives you the option of not having hard disks, network volumes, CDs, or other removable disks appear on the desktop.

C.1.32 Draggable window edges

Gone. You can drag a Mac OS X window only by its title bar, not the side edges or bottom.

C.1.33 Drive Setup

Drive Setup is now a part of Disk Utility, in the Applications [image] Utilities folder. Launch Disk Utility and go to the Erase and Partition panes.

C.1.34 Edit menu

This Finder menu is alive and well, capable now of copying and pasting files from window to window.

C.1.35 Eject

Now located in the Finder's File menu instead of the now-defunct Special menu.

C.1.36 Empty Trash

Moved to the Finder menu. You can also access the Empty Trash command by clicking and holding down the mouse button when pointing to the Trash icon in the Dock, by Control-clicking the Trash, or by pressing Shift- [image] -Delete.

C.1.37 Encrypt

You can no longer encrypt and lock individual files, at least not without add-on shareware.

C.1.38 Energy Saver control panel

Now located in the Energy Saver panel of System Preferences.

C.1.39 Erase Disk

Erase Disk is no longer a Finder command. To erase a disk (or reformat it), use the Erase panel of the Disk Utility program, which is in the Applications [image] Utilities folder.

C.1.40 Extensions

Extensions don't exist in Mac OS X. Neither do extension conflicts—the number one cause of crashes, freezes, and hangs on traditional Macs. This is a good thing.

C.1.41 Extensions Manager control panel

No extensions means no Extensions Manager.

C.1.42 Favorites

Moved from the [image] menu to the Finder's Go menu (and the Finder toolbar). Favorites also has its own dedicated keyboard shortcut: Shift- [image] -F.

C.1.43 File Exchange control panel

Eliminated. Mac OS X now understands and remembers the three-letter file extensions PCs use to recognize file types for better Mac/PC file compatibility. Still, if you want to remap a certain document so that it opens in a different program (a primary function of the old File Exchange program), proceed like this: Highlight its icon, choose File [image] Get Info, open the Open With panel, choose a new program from the pop-up menu, and then click the Change All button.

C.1.44 File menu

Most of the Finder's File menu has stayed the same, with the following exceptions:

  • A New Finder Window command ( [image] -N) has been added.

  • The New Folder command has a new keyboard shortcut: Shift- [image] -N.

  • The Encrypt command is gone.

  • The Eject command has migrated over from the Special menu.

  • Burn Disc was added.

C.1.45 File Sharing control panel

Replaced by the Sharing panel of System Preferences.

C.1.46 File Synchronization control panel

Eliminated. Use a program like Iomega's QuickSync, or the Backup program that comes with a .Mac account, to keep a folder automatically backed up instead.

C.1.47 Find Similar Files

This contextual menu item is no longer available.

C.1.48 Finder (the application)

Mac OS X still has an actual Finder program, residing in System [image] Library [image] CoreServices. You can't do anything to the file, of course, other than take note of where it lives.

C.1.49 Finder Preferences

Moved from the Edit menu to Finder [image] Preferences.

C.1.50 Fonts folder

Mac OS X doesn't have a Fonts folder—it has five of them; see Chapter 13.

C.1.51 FontSync

The control panel, which was hidden away in the Apple Extras folder under Mac OS 9, is obsolete. The AppleScripts that allow you to create FontSync profiles are in your Library [image] Scripts [image] FontSync Scripts folder.

C.1.52 Force quitting

You can still press Option- [image] -Esc to quit a locked-up program, but it's much easier and safer to do so in Mac OS X (Section 4.1.2).

C.1.53 General Controls control panel

The control panel is gone, and so are the various options it offered. In Mac OS X, you can't change the insertion-point blinking rate, nor the number of times a menu command flashes when you select it. (Of course, you can still launch General Controls when you're using the Classic environment, as described in Chapter 5.)

C.1.54 Get Info

It's still here, and better than ever in Mac OS X 10.2 (see Chapter 2). A few changes are worth noting: The Memory panel is gone, because you no longer have to manually adjust the amount of memory needed for each program. Also, the Sharing panel is now called Ownership & Permissions, a new Name & Extension panel is available, and an "Open with application" panel (documents only) lets you decide which program opens when you double-click a certain document (or kind of document).

C.1.55 Graphing Calculator

No longer included with Mac OS X.

C.1.56 Grid Spacing

Finder Preferences no longer offers the choice between Tight and Wide grid-spacing for icon views.

C.1.57 Help menu

A trimmed-down Help menu retains its position in the Finder menu bar. It now contains a single item, Mac Help, which launches the Mac OS X Help system.

C.1.58 Hide commands

Commands for hiding the active program, or hiding everything else but the active program, have moved from the old Application menu (on the far right of the menu bar) to the new Application menu (the one on the left next to the [image] menu) that bears the name of the frontmost program. Hiding the current program also now has an official keyboard shortcut (in most programs): -H. And hiding all other programs has a keyboard shortcut, too, although it works in even fewer programs: Option- [image] -H.

C.1.59 Info Strip

The Info Strip at the top of Finder windows is now called the Status Bar. Choose View [image] Show Status Bar to display your available disk space and each folder's item count.

C.1.60 Infrared control panel

Gone. Infrared networking doesn't work in Mac OS X.

C.1.61 Internet control panel

Replaced by System Preferences [image] Internet panel.

C.1.62 Internet Utilities

No longer included. Some of the programs that used to be stored in this folder under Mac OS 9—such as StuffIt Expander—are now in the Applications [image] Utilities folder.

C.1.63 iTunes

An updated version of iTunes is in the Applications folder.

C.1.64 Key Caps

The new Mac OS X version is in the Applications [image] Utilities folder.

C.1.65 Keyboard control panel

The functions of this old control panel are split between two System Preferences panels. You can find the Key Repeat and Delay Until Repeat controls in the System Preferences [image] Keyboard panel. You switch keyboard layouts (for use with other languages) in the Input Menu pane of the System Preferences [image] International panel.

The Function Keys feature of the Mac OS 9 Keyboard control panel isn't in Mac OS X; you can no longer open selected files or programs by pressing the Fkeys at the top of your keyboard. (You can, however, now operate menus, open Dock icons, and navigate dialog boxes from the keyboard, as described in Section 4.4.)

C.1.66 Keychain Access control panel

Replaced by the Keychain Access program, located in Applications [image] Utilities.

C.1.67 Label command

Obliterated. You can't apply color or text labels to icons in Mac OS X. Some people manage by typing identifying phrases into the Comments boxes of their icons (highlight an icon, choose File [image] Get Info).

C.1.68 Launcher control panel

Replaced by the far superior Dock.

C.1.69 Location Manager

The control panel is gone. But in System Preferences [image] Network, you can save various dialing and networking settings on a location-by-location basis using the Location pop-up menu. Thereafter, you can switch settings using the [image] [image] Locations submenu. (Locations no longer store printer, volume, clock, and other settings.)

C.1.70 Locked

You can still lock any file on your Mac by selecting its icon, choosing File [image] Get Info and turning on the Locked checkbox in the Info window.

C.1.71 Mac Help

Apple's help system is still accessible from the Help menu in the Finder's menu bar.

C.1.72 Mac OS Runtime for Java

The old Apple Applet Runner has been replaced by Applet Launcher, which is in the Applications [image] Utilities folder. See Chapter 9 for details.

C.1.73 Map control panel

Eliminated. You can set your Mac's location/time zone using the Time Zone pane of System Preferences [image] Date & Time. But without the venerable Map control panel, there's no longer any way to calculate the distance between two cities.

C.1.74 Memory control panel

Gone. Memory management in Mac OS X is a hands-off affair, as the system simply gives each running program as much memory as it needs without requiring you to adjust settings.

C.1.75 Modem control panel

Replaced by the Modem pane in System Preferences [image] Network panel.

C.1.76 Monitors control panel

Replaced by System Preferences [image] Displays.

C.1.77 Mouse control panel

Replaced by System Preferences [image] Mouse.

C.1.78 Multiple Users control panel

Replaced, in a much more industrial-strength form, by System Preferences [image] Accounts (Chapter 11). Some login options that used to be handled by the Multiple Users control panel are on the System Preferences [image] Accounts [image] Login Options tab.

C.1.79 New Folder command

It's still in the File menu, but the keyboard shortcut has changed from [image] -N (which now opens a new Finder window) to Shift- [image] -N.

C.1.80 Note Pad

Gone. Use the new, improved Stickies to jot down quick notes.

C.1.81 Numbers control panel

Replaced by System Preferences [image] International panel [image] Numbers pane.

C.1.82 Open Transport

Open Transport networking is built into Mac OS X, but there's no Open Transport extension, and nothing for you to turn on, toggle, or trigger. Configure your network settings using the System Preferences [image] Network panel.

C.1.83 Picture 1, Picture 2...

You can still capture pictures of your Mac screen by pressing [image] -Shift-3 (for a full-screen grab) or [image] -Shift-4 (to grab a selected portion of the screen). However, the resulting image files, called Picture 1, Picture 2, and so on, now appear on the desktop instead of in the hard drive window—and in the more universal PDF format instead of PICT.

C.1.84 Pop-up windows

To create the Mac OS X equivalent of a pop-up window, just drag a folder or disk icon onto the Dock. From now on, when you click-and-hold (or Control-click) its docked icon, a list of its contents sprouts upward, for your perusal pleasure.

Or just drag a window to the bottom of the screen until only its title bar is visible. When you click the green Zoom button (or drag an icon onto the title bar), the window pops up just like a pop-up window of old.

C.1.85 Preferences folder

Mac OS X stashes away its own preference files in numerous hidden locations, but the folder that contains your application preference settings is in the Users [image] [your Home folder] [image] Library [image] Preferences folder. Preference files of this type (known in geek circles as plist, or property list, files) are even easier to identify in Mac OS X, because they clearly bear the application's name.

C.1.86 PrintMonitor

Obsolete. With Mac OS X, you monitor the queue of jobs waiting to be printed using Print Center, which is in Applications [image] Utilities. Launch Print Center, select a printer from the list of available printers, and choose Printers [image] Show Job.

C.1.87 Put Away command

It's gone. To eject Zip disks, CDs, and other removable disks, use the Eject command (or the Eject key on your keyboard). To put away files you've dragged to the desktop, you must drag them back to their original locations manually (or use the Edit [image] Undo command, if you remember to do so promptly).

C.1.88 QuickTime Settings control panel

Replaced by the System Preferences [image] QuickTime panel.

C.1.89 Quit command

It's not in the File menu of your programs any more—it's in the Application menu (the one bearing the program's name).

C.1.90 Remote Access

Replaced by Internet Connect, in the Applications folder.

C.1.91 Reset Column Positions

Gone. If you scramble the order and size of columns in a list view, there's no one-shot way to undo the mess.

C.1.92 Restart

Moved to the [image] menu.

C.1.93 Script Editor

A Mac OS X version of this AppleScript authoring program is now located in Applications [image] AppleScript.

C.1.94 Scripting Additions

Five scripting additions, which can add special functions to AppleScripts, are included with Mac OS X. They're now in System [image] Library [image] Scripting Additions.

C.1.95 Search Internet

The Search Internet command in the Finder's File menu is gone. Instead, you launch Sherlock by clicking its icon on the Dock (or in the Applications folder). Then click the blue crystal-ball icon to search the Web.

C.1.96 Security

Under Mac OS 9, the Security folder was the home of two programs, Apple File Security and Apple Verifier, which were used to encrypt and lock files using the Finder's Encrypt command. Both security applications are gone, having been replaced by the vault-like Unix accounts system described in Chapter 11.

C.1.97 Select New Original

Still lets you hook up aliases to new original files.

C.1.98 Set to Standard Views

This option, in Mac OS 9's View Options window, lets you apply a set of standard view settings simultaneously (as defined in Finder Preferences [image] Views) to any folder window. In Mac OS X, you accomplish the same thing in the View Options window by switching the top option from "This window only" to "Global."

C.1.99 Sherlock

There's a new Mac OS X version in the Applications folder. You can launch it from there, or by clicking its Dock icon.

Don't use it for finding files, however. In Mac OS X 10.2 and later, Sherlock searches only the Web. Use the File [image] Find command, or the new Search bar at the top of each Finder window, for finding files.

C.1.100 Show All

Works just like in Mac OS 9—that is, it brings all hidden windows into sight—but has been moved from the old Application menu (on the far right of the menu bar) to the new Application menu, which bears the name of the program you're using.

C.1.101 Show Clipboard

Unchanged from Mac OS 9.

C.1.102 Show warning before emptying Trash

This option is now in Finder [image] Preferences instead of the Trash's Get Info window.

C.1.103 Shut Down

Moved to the [image] menu.

C.1.104 Shutdown Items

There's no longer a Shutdown Items folder. In Mac OS X, there's no easy way to make certain icons open automatically when you shut down the machine.

C.1.105 Simple Finder

It's back in Mac OS X 10.2, better than before. Open System Preferences [image] Accounts pane, click a non-administrator user, and then click Capabilities. (See Chapter 11 for details.)

C.1.106 SimpleSound

Apple no longer includes this sound-recording program with Mac OS X.

C.1.107 SimpleText

Replaced by the vastly superior TextEdit program, in the Applications folder.

C.1.108 Size box

The button that lets you resize a window by dragging is still in the lower-right corner.

C.1.109 Sleep

The Sleep command has moved to the [image] menu.

C.1.110 Smart scrolling

Relocated from the Options pane of the Mac OS 9 Appearance control panel to System Preferences [image] General panel. The radio buttons in the middle of the panel control the placement of scroll arrows and the behavior of scroll bars.

C.1.111 Software Update control panel

Replaced by System Preferences [image] Software Update.

C.1.112 Sorting triangle

This tiny triangle, which indicates whether columns in list views are sorted in ascending or descending order, no longer appears atop each window's vertical scroll bar. Instead, you reverse the sorting order for lists of information (such as Mail messages or Finder list view items) by clicking a column heading (such as Name or Date).

C.1.113 Sound control panel

Replaced by System Preferences [image] Sound. But the new Sound preferences don't allow you to record new Alert sounds. See Chapter 8 for more information.

C.1.114 Special menu

Gone. This was the only Finder menu that was completely removed in Mac OS X. Most of the Special menu's commands now live in the File or [image] menus.

C.1.115 Speech control panel

Replaced by System Preferences [image] Speech, which offers far more sturdy text-to-speech and speech-recognition powers.

C.1.116 Spring-loaded folders

Mac OS X 10.2 folders once again pop open automatically when you drag icons over them, as described in Chapter 2.

C.1.117 Stationery Pad

Works just as it did in Mac OS 9 and earlier. The Stationery Pad checkbox is in each file's Get Info window.

C.1.118 Startup Disk control panel

Go to the System Preferences [image] Startup Disk panel to choose the disk and System folder—either Mac OS X or Mac OS 9—from which your Mac will start up next.

C.1.119 Startup Items

The Startup Items folder is gone, but you can still set up programs to launch automatically at startup. Just include those applications in the list of Login Items in the System Preferences [image] Login panel.

C.1.120 Stickies

A dramatically improved version of Stickies is in the Applications folder.

C.1.121 System file

You can't open it, modify it or move it, but Mac OS X does have a System file, just like earlier Mac versions. You'll find it in System [image] Library [image] CoreServices.

C.1.122 System Folder

Mac OS X's System Folder is simply called System, and it sits in your main hard drive window. There's a big difference, however: In Mac OS X, you're forbidden to add, remove, or change anything inside.

(You still have a System Folder, too—the home of the Mac OS 9 system software needed by your Mac to run Classic applications.)

C.1.123 TCP/IP control panel

Replaced by System Preferences [image] Network panel, which has a TCP/IP pane for configuring these settings.

C.1.124 TCP/IP, AppleTalk

Configure your TCP/IP and AppleTalk settings in System Preferences [image] Network.

C.1.125 Text control panel

Replaced by the System Preferences [image] International panel [image] Language pane. Choose the language you need from the Languages list box.

C.1.126 Trackpad

Replaced by a tab in the System Preferences [image] Mouse panel.

C.1.127 USB Printer Sharing

In Mac OS X 10.2, you can once again share a USB inkjet printer with other Macs on the network. On the Mac with the printer, open the Sharing panel of System Preferences. Turn on Printer Sharing.

On each of the other Macs, open the Print Center program (in your Applications [image] Utilities folder). Click Add. When the printer list appears, choose Directory Services from the top pop-up menu, and make sure that Rendezvous is selected in the bottom one. Presto! The name of the USB printer, elsewhere on the network, appears in the list. You're ready to share.

C.1.128 View menu

The "as Columns" view replaces the "as Buttons" view, and there are new commands pertaining to the new Finder toolbar. Otherwise, the View menu hasn't changed much (Chapter 1).

C.1.129 View Options

You still open View Options from the Finder's View menu. You'll find only a few changes: In list views, Mac OS X offers a choice of two icon sizes instead of three. In icon views, Mac OS X gives you total control over the size of icons, which you can adjust using the Icon Size slider, plus the ability to add a color or photo to the background of the window.

C.1.130 Warn before emptying

This option is now called "Show warning before emptying Trash" and is located in Finder [image] Preferences.

C.1.131 Web Pages folder

There's no longer a Web Pages folder to store the Web page files you publish using Personal Web Sharing. Instead, your public Web pages go in your Home [image] Sites folder or the Library [image] WebServer [image] Documents folder, as described in Chapter 21.

C.1.132 Web Sharing control panel

Replaced by a checkbox on the System PREFERENCES [image] SHARING panel.

C.1.133 Window collapsing

See "Collapse box."

C.1.134 Zoom box

Windows in Mac OS X no longer have a zoom box; they have a green zoom button, which makes a desktop window just large enough to show you all of the icons inside it.


Appendix D. The "Where'd It Go?" Dictionary (Windows Version)

Maybe you were persuaded by the Apple "Switch" ad campaign. Maybe you just like the looks of today's Macs. Or maybe you've just had one IRQ conflict too many. In any case, if you're switching to Mac OS X from Windows, this appendix is for you. It's an alphabetical listing of every common Windows function and where to find it in Mac OS X. After all, an operating system is an operating system. The actual functions are pretty much the same—they're just in different places.

TIP

If this listing only whets your appetite for information about making the switch, read Switching to the Mac: The Missing Manual. In addition to an expanded version of this appendix, it also contains useful information on moving your files from the PC to the Mac, copying over your email, transferring your address book, and so on.


D.1 Common Windows Functions

D.1.1 About [This Program]

To find out the version number of the program you're using, don't look in the Help menu. Instead, look in the application menu next to the [image] menu—the one that bears the name of the program you're in. That's where you find the About command for Macintosh programs.

D.1.2 Accessibility Options control panel

The special features that let you operate the computer even with impaired vision, hearing, or motor control are called Universal Access in Mac OS X 10.2. It's in System Preferences (see Chapter 8).

D.1.3 Active Desktop

The Mac never displays Web pages directly on the desktop—and knowing Apple, that's probably a point of pride.

D.1.4 Add Hardware control panel

The Mac requires no program for installing the driver for a new external gadget. The drivers for most printers, mice, keyboards, cameras, camcorders, and other accessories are preinstalled. If you plug something into the Mac and find that it doesn't work immediately, just install the driver from the included CD (or the manufacturer's Web site).

D.1.5 Add or Remove Programs control panel

Here's another one you just don't need on the Macintosh. Installing a program onto the Mac is described in Section 4.8. Removing a program simply involves dragging its icon to the Trash.

D.1.6 All Programs

There's no Programs menu built into Mac OS X, like the one on the Windows Start menu. On the other hand, you can make one of your own in five seconds. Just drag your Applications folder onto the end of the Dock. Now its icon is a tidy pop-up menu of every program on your machine.

D.1.7 Alt key

On the Mac, it's the Option key. You can substitute Option for Alt in any keystroke in most popular programs. The Option key has a number of secondary features on the Mac, too: It hides the windows of one program when you click into another, and so on.

D.1.8 Automatic Update

The System Preferences [image] Software Update panel does exactly the same thing.

D.1.9 Backspace key

It's in the same place on the Macintosh keyboard, but it's called the Delete key.

D.1.10 Battery Level

The status of the battery in your PowerBook or iBook laptop now appears in the menu bar, rather than in the system tray. (If you don't see it, open System Preferences [image] Energy Saver and turn it on.)

D.1.11 BIOS

You'll never have to update or even think about the ROM of your Macintosh (the approximate equivalent of the BIOS on the PC). It's permanent and unchanging. The very similar firmware of your Macintosh does occasionally have to be updated in order to work with a new version of the Mac operating system or some dramatic new feature—once every four years, perhaps. You'll be notified on the screen when the time comes.

D.1.12 Briefcase

Mac OS X doesn't have anything like the Briefcase, a Windows invention designed to help you keep your files in sync between a laptop and a desktop computer. On the other hand, if you sign up for a .Mac account (Chapter 18), you get a program called Backup that is similarly designed to keep folders synchronized between two machines. And you can use iSync (Chapter 20) to keep your calendar, addresses, and other items synched between multiple computers.

D.1.13 Calculator

The calculator program in Mac OS X is almost identical to the one in Windows XP, except that it can also perform conversions (temperature, distance, currency, and so on) and features an editable "paper tape." It sits in your Applications folder and is described in Chapter 9.

D.1.14 Camera and Scanner Wizard

When you connect a digital camera or scanner to your Mac, either iPhoto or Image Capture opens automatically and prepares to download the pictures automatically, just like the Camera and Scanner Wizard. Details on Image Capture in Chapter 9, and on iPhoto in iPhoto: The Missing Manual.

D.1.15 CDs

If your Mac keyboard has an Eject or F12 key in the upper-right corner, you hold it down for a moment to open the CD drawer, or, if you have a slot-loading CD drive, to spit out the CD that's in it. If it's an older Mac keyboard without an Eject key, you can eject a CD (or any other disk) by Control-clicking its desktop icon and choosing Eject from the contextual menu. There are various other ways to eject a disk, but the point is that you never do so by pushing the Eject button on the disk drive itself.

D.1.16 Character Map

This Windows program helps you find out what keys you need to press to trigger trademark symbols, copyright symbols, and other special characters. The equivalent on the Mac is Key Caps, which is in your Applications [image] Utilities folder—but the new Character Palette (The Character Palette) is even easier to use.

D.1.17 Clean Install

The Mac OS X 10.2 installer can give you a fresh, virginal copy of the operating system, just as the Windows installer does. Instructions are in Appendix A.

D.1.18 Clipboard

The Mac's clipboard works much like the one in Windows. In the Finder, you can choose Edit [image] Show Clipboard to see whatever you most recently copied or cut.

D.1.19 Command line

In Mac OS X, the command line is alive and well—but it speaks Unix, not DOS. You get to it by opening Terminal, which is described in Chapter 15 and Chapter 16.

D.1.20 Control Panel

There is a Control Panel in Mac OS X—but it's called System Preferences and is represented on the Dock by a little light-switch icon. As in Windows XP, you can view these icons either by category or in a simple alphabetical list: just choose either Show All In Categories or Show All Alphabetically from the View menu.

D.1.21 Copy, Cut, Paste

When you're editing in a word processor or graphics program, the Mac OS X Cut, Copy, and Paste commands work exactly as they do on Windows.

At the desktop, however, there are a few differences. You can indeed copy icons and paste them into a new window using the Copy and Paste commands—you just can't cut them out of a window, as you can in Windows. On the other hand, Mac OS X offers a handy secondary feature: if you paste into a word or text processor instead of into another desktop window, you get a tidy list of the names of the icons you copied.

D.1.22 Ctrl key

On the Macintosh, you generally substitute the [image] key in keystrokes that would normally involve the Control key. In other words, the Save command is now [image] -S instead of Ctrl-S, Open is [image] -O instead of Ctrl-O, and so on.

D.1.23 Date and Time

You set your Mac's calendar and clock in the Date & Time panel of System Preferences.

D.1.24 Delete Key (Forward Delete)

Desktop Mac keyboards have a forward-delete key exactly like the ones on PCs. On Mac laptops, you trigger the forward-delete function by pressing the regularly scheduled Delete key while pressing the Fn key in the lower-left corner of the keyboard.

D.1.25 Desktop

The Macintosh desktop is pretty much the same idea as the Windows desktop, with a few key differences:

  • Disk icons show up on the Mac desktop as soon as they are inserted or connected. You don't have to open a window to see their icons.

  • You change the desktop picture using the Desktop panel of System Preferences.

  • The Trash is an icon on the Dock, not loose on the desktop.

D.1.26 Directories

Most people call them folders on the Mac.

D.1.27 Disk Defragmenter

There's no such utility included with Mac OS X, although Norton Utilities for the Mac will do the job if you feel that it's essential to have your hard drive neatly defragmented. (A defragmenting program moves around the pieces of files on your hard drive in an effort to optimize their placement and speed of opening.)

D.1.28 Disks

Working with disks is very different on the Mac. Every disk inside, or attached to, a Macintosh is represented on the screen by an icon. Mac OS X does have something like the My Computer window (choose Go [image] Computer), but both the icons on the desktop and the icons in the Computer window reflect only the disks currently inserted in your Mac. You'll never see an icon for an empty drive, as you do on Windows, and there's no such thing as drive letters (because the Mac refers to disks, not to drives—and refers to them by name).

D.1.29 Display control panel

The functions of the Windows Display Control Panel lurk in the Mac OS X System Preferences program—just not all in one place. You set a desktop picture using the Desktop panel, choose a screen saver using the Screen Effects panel, and adjust your monitor settings using the Displays panel. (Mac OS X offers no ability to change the system-wide look of your computer, as you might using the Appearance tab in Windows.)

D.1.30 DLL files

The Macintosh equivalent of DLL files—shared libraries of programming code—are invisible and off-limits. As a result, no Macintosh user ever experiences DLL conflicts or out-of-date DLL files.

D.1.31 DOS prompt

There's a command line in Mac OS X, but it's Unix, not DOS. For details, see Chapter 15 and Chapter 16.

D.1.32 Drivers

See "Add or Remove Programs."

D.1.33 End Task dialog box

If some Macintosh program is hung or frozen, you escape it pretty much the same way you would in Windows: by forcing it to quit. To bring up the Force Quit dialog box, you press Option- [image] -Esc as described in Section 4.1.2.

D.1.34 Exiting programs

You can quit a program either by choosing Quit from the menu bearing its name (next to the [image] menu), or by right-clicking its Dock icon (or Control-clicking) and then choosing Quit from the pop-up menu.

D.1.35 Explorer

The Mac has its own "tree" view of the files and folders on your hard drive: list view. By expanding the "flippy triangles" of your folders, you build a hierarchy that shows you as much or as little detail as you like.

If you prefer the Explorer effect of clicking a folder in one pane to see its contents in the next, try Column view instead. Both views are described in Chapter 1.

D.1.36 Favorites

In Mac OS X, there isn't one single Favorites menu that lists both favorite Web sites and favorite icons. The Favorites menu of Internet Explorer, the Web browser, lists only Web sites, and the Favorites menu at the desktop (Section 2.6) lists only favorite files, folders, disks, and other icons.

D.1.37 Faxing

Not all Macs come with built-in faxing software—at this writing, only iBooks and iMacs do. (It's called FaxSTF, and it's in your Applications folder.) If you have another kind of Mac, consider installing the shareware program PageSender, the free Cocoa eFax, or any of the other faxing programs that come up when you search www.versiontracker.com for "fax."

D.1.38 File Sharing

See Chapter 12 for an in-depth look at the Macintosh networking and file-sharing system.

D.1.39 Floppy Disks

Don't bother looking; you won't find floppy drives on Macs. They disappeared in about 1997. According to Apple, it's much more efficient to transfer files between machines using an Ethernet cable (Chapter 12), a CD that you burned (Chapter 10), or email (Chapter 19).

Of course, you can buy an external USB floppy drive for any Mac for about $45.

D.1.40 Folder Options

The Folder Options control panel in Windows is a crazy collection of unrelated settings that boil down to this:

  • General tab. Exactly as in Windows, it's up to you whether or not double-clicking a folder opens up a second window—or just changes what's in the first one. On the Mac, you make these changes using the Finder [image] Preferences command. There you'll find the option called "Always open folders in a new window."

  • View tab. Most of the options here don't exist on the Mac. For example, system files are always hidden on the Mac; you can't opt to make them visible (at least not without add-on shareware). You can, however, choose whether you want to see the file name extensions in your desktop Windows (like .doc and .html). Choose Finder [image] Preferences, and turn "Always show file extensions" on or off.

  • File Types tab. Just as in Windows, you can reassign certain document types so that double-clicking opens them up in the program of your choice. But on the Mac, you can reassign either a whole class of files at once, as on Windows, or one file at a time. To do it, you use the Get Info window as described on Section 2.7.3.

  • Offline Files. There's no equivalent feature on the Mac.

D.1.41 Fonts

The Mac and Windows both use TrueType, PostScript, and Open Type fonts. (In fact, your Mac can even use the exact font files you had on Windows.) On the Mac, however, there are actually five different folders that can contain them. A complete discussion is in Section 13.6.

D.1.42 Help and Support

At the desktop, choose Help [image] Mac Help. In other programs, the Help command is generally at the right end of your menus, exactly as on Windows.

D.1.43 Hibernation

The Mac can't hibernate at all, as modern PCs do, cutting all power but remembering what programs and documents you had open for a faster restart later. Sleep mode is the closest it gets (see "Standby Mode").

D.1.44 Internet Explorer

The standard Web browser is in your Applications folder—or you can click its icon on your Dock. Take the time to explore the Macintosh version of this browser, which offers a number of useful features not available in Windows.

D.1.45 Internet Options

On the Mac, you find the options for your Web browser by choosing Internet Explorer [image] Preferences. (There is an Internet panel in System Preferences, but the only browser setting you can change here is your preferred startup Web page.)

D.1.46 IRQs

Forget it. They don't exist on the Mac.

D.1.47 Java

This interpreter of tiny Web-page programs is alive and well in Mac OS X. See Section 9.2.17 for details.

D.1.48 Keyboard control panel

You can make exactly the same kinds of settings—and more—on the Keyboard panel of System preferences.

D.1.49 Logging in

As it turns out, the multiple-accounts feature of Mac OS X is extremely similar to that of Windows 2000 and Windows XP. In either case, you can, if you wish, create a requirement to login with a name and password before using the computer. This arrangement keeps separate the documents, email, and settings of each person who uses the computer.

D.1.50 Mail control panel

Mac OS X comes with its own email program (see Chapter 19); all of its settings are contained within the program.

D.1.51 Maximize button

On the Mac, clicking the zoom button (the green button at the upper-left corner of a window) does something like the maximize button in Windows: it makes your window larger. On the Mac, however, clicking the zoom button never makes the window expand to fill the entire screen. Instead, the window grows—or shrinks—precisely enough to enclose its contents.

D.1.52 Menus

Here's one of the biggest differences between the Mac and Windows: On the Macintosh, there's only one menu bar, always at the very top of the screen. The menus change depending on the program and the window you're using, but the point is that the menu bar is no longer inside each window you open.

TIP

Just because you don't see the little underlines in the menus doesn't mean you can't operate all of the menus from the keyboard, as in Windows. See Section 4.4 for details.

D.1.53 Minimize button

You can minimize a Mac OS X window to the Dock, just the way you would minimize a Windows window to the taskbar. You do so by double-clicking its title bar, pressing [image] -M, choosing Window [image] Minimize Window, or clicking the yellow Minimize button at the top left of a window. (Restore the window by clicking its icon on the Dock.)

D.1.54 Mouse control panel

The equivalent settings await you in the Mouse panel of System Preferences.

D.1.55 My Computer

The Mac's Computer window is very similar (choose Go [image] Computer), in that it shows the icons of all disks (hard drive, CD, and so on). On the other hand, it shows only the disks that are actually inserted or connected (see "Disks").

D.1.56 My Documents, My Pictures, My Music

The equivalent buckets for your everyday documents, music files, and pictures are the Documents, Pictures, and Music folders in your Home folder. (See Section 2.1 for more on the Home folder.)

D.1.57 My Network Places

To see your "network neighborhood," choose Go [image] Connect to Server. All of the Macs and PCs on your network show up in the resulting list (see Chapter 11).

D.1.58 Network Neighborhood

See the previous entry.

D.1.59 Notepad

There's no Mac OS X Notepad program. But give Stickies a try (Section 9.1.19).

D.1.60 Personal Web Server

To find out how to turn your Mac into a state-of-the-art Web site, see Chapter 21.

D.1.61 Phone and Modem Options control panel

To find the modem settings for your Mac, open System Preferences. Click Network, choose Internal Modem from the Show pop-up menu, and click the Modem tab.

D.1.62 Power Options

To control when your Mac goes to sleep and (if it's a laptop) how much power it uses, use the Energy Saver panel of System Preferences (Chapter 8).

D.1.63 Printer Sharing

To share a USB inkjet printer with other Macs on the network, open the Sharing panel of System Preferences on the Mac with the printer. Turn on Printer Sharing.

On each of the other Macs, open the Print Center program (in the Applications [image] Utilities folder). Click Add. When the printer list appears, choose Directory Services from the top pop-up menu, and make sure that Rendezvous is selected in the bottom one. Presto! The name of the USB printer, elsewhere on the network, appears in the list. You're ready to share.

D.1.64 Printers and Faxes

For a list of your printers, open the Print Center program in your Applications [image] Utilities folder. You manage faxes using either FaxSTF or a shareware program (see "Faxing").

D.1.65 PrntScrn key

You capture pictures of your Mac screen by pressing Shift- [image] -3 (for a full-screen grab) or Shift- [image] -4 (to grab a selected portion of the screen). Details in Section 13.10.

D.1.66 Program Files folder

The Applications folder (Go [image] Applications) is like the Program Files folder in Windows—except that you're not discouraged from opening it and double-clicking things. On the Macintosh, every program bears its true name. Microsoft Word is called Microsoft Word, not WINWORD.EXE.

D.1.67 Properties dialog box

You can call up something very similar for any icon (file, folder, program, disk, printer) by highlighting its icon and then choosing File [image] Get Info.

But objects in Macintosh programs generally don't contain Properties dialog boxes.

D.1.68 Recycle Bin

Mac OS X has a Trash icon at the end of the Dock. In general, it works exactly like the Windows Recycle Bin—and why not, since the Macintosh Trash was Microsoft's inspiration?—but there are a couple of differences. The Macintosh never auto-empties it, for example, no matter how full your hard drive gets. That job is up to you (the simplest way is to Control-click it, or right-click it, and choose Empty Trash from the contextual menu).

The Mac never bothers you with an "Are you sure?" message when you throw something into the Trash, either. In fact, it doesn't even ask for confirmation when you empty the Trash (at least, not when you empty it by Control-clicking). The Mac interrupts you for permission only when you choose File [image] Empty Trash—and you can even turn that confirmation off, if you like (in Finder [image] Preferences).

To put icons into the Trash, drag them there, or highlight them and then press [image] -Delete.

D.1.69 Regional and Language Options control panel

The close equivalent is the International panel of System Preferences.

D.1.70 Registry

There is no registry. Let the celebration begin!

D.1.71 Run command

The equivalent command line is Terminal (Chapter 15).

D.1.72 Safe Mode

There's no real equivalent to Safe Mode on the Mac. You can press the Shift key during startup to suppress the loading of certain software libraries, but that still doesn't produce a massively stripped-down machine like Safe Mode does.

D.1.73 ScanDisk

Just like Windows, the Mac automatically scans and, if necessary, repairs its hard drive every time your machine starts up. To run such a check on command, open Disk Utility (located in the Applications [image] Utilities folder), and then click the First Aid tab.

D.1.74 Scheduled Tasks

To schedule a task to take place unattended, use the cron Unix command in Terminal (Section 16.4.6), or one of the scheduling programs listed at versiontracker.com.

D.1.75 Scrap files

On the Mac, they're called clipping files, and they're even more widely compatible. You create them the same way: Drag some highlighted text, or a graphic, out of a program's window and onto the desktop. There it becomes an independent clipping file that you can drag back in—to the same window, or a different one.

D.1.76 Screen saver

The Mac's screen savers are impressive. Open System Preferences and click the Screen Effects icon.

D.1.77 Search

In Mac OS X, you have two convenient ways to look for files. You can type into the Search bar at the top of every desktop window and then press Return (Section 2.9), or you can choose File [image] Finder for a more complete search by almost any criterion, including words inside the files. Chapter 2 contains details.

Note that in Mac OS X 10.2, the Find program finds only files. To find Web sites, you use Sherlock (Chapter 20).

D.1.78 Shortcut menus

They're called contextual menus in Mac parlance. You produce them by Control-clicking things like icons, list items, and so on. (If you have a two-button mouse, feel free to right-click instead of using the Control key.)

D.1.79 Shortcuts

On the Mac, they're known as aliases, and they're even more useful (and intelligent). See Section 2.5.

D.1.80 Sounds and Audio Devices

Open System Preferences; click the Sound icon.

D.1.81 Speech control panel

The Mac's center for speech recognition and text-to-speech is the Speech panel of System Preferences. As Chapter 14 makes clear, the Mac can read aloud any text in any program, and it lets you operate all menus, buttons, and dialog boxes by voice alone.

D.1.82 Standby mode

On the Mac, it's called Sleep, but it's the same idea. You make a Mac laptop sleep by closing the lid. You make a Mac desktop sleep by choosing [image] [image] Sleep, or just walking away; the Mac will go to sleep on its own, according to the settings in the Energy Saver panel of System Preferences.

D.1.83 Start menu

There's no Start menu in Mac OS X. Instead, you stash the icons of the programs, documents, and folders you use frequently onto the Dock at the bottom edge of the screen. (That is, it's usually at the bottom edge; you can also move it to either side of the screen using the [image] [image] Dock submenu.)

Exactly as with the Start menu, you can rearrange these icons (drag them horizontally) or remove the ones you don't use often (drag them away from the Dock and then release). To add new icons of your own, just drag them into place (applications go to the left of the Dock's divider line, documents and folders to the right).

D.1.84 StartUp folder

To make programs launch automatically at startup, include them in the list of Login Items in the System Preferences [image] Login panel.

D.1.85 System control panel

The Mac has no central equivalent of the System window on a Windows PC. But its functions have analogs here:

  • General tab. To find out your Mac OS X version number and the amount of memory on your Mac, choose [image] [image] About This Mac.

  • Computer Name tab. Open System Preferences, click Sharing, and edit your computer's network names here.

  • Hardware tab. The closest thing the Mac has to the Device Manager is Apple System Profiler (Section 9.2.3).

  • Advanced tab. In Mac OS X, you can't easily adjust your virtual memory, processor scheduling, or user profile information.

  • System Restore tab. This feature isn't available in Mac OS X. On the other hand, there's less need for it: because the System folder is essentially fixed under glass, you don't run into the kind of "uh-oh, my last driver installation just hosed my machine" problems that require "rewinding" your system in Windows.

  • Automatic Updates tab. Open System Preferences and click Software Updates.

  • Remote tab. These features are unavailable in Mac OS X.

D.1.86 System Tray

The perfect Mac OS X equivalent of the System Tray (also called the notification area) is the row of menulets at the upper-right corner of your screen; see Section 3.6.

D.1.87 Taskbar

Mac OS X doesn't have a taskbar, but it does have something very close: the Dock (Chapter 3). Open programs are indicated by a small black triangle beneath their icons on the Dock. If you hold down your cursor on one of these icons (or Control-click it, or right-click it), you'll get a pop-up list of the open windows in that program, exactly as in Windows XP.

Control-clicking a folder or disk icon on the Dock is even more useful. It produces a pop-up menu of everything inside that disk or folder—a terrific form of X-ray vision that has no equivalent in Windows.

On the other hand, some conventions never die. Much as on Windows, you cycle through the various open programs on your Dock by holding down the [image] key and pressing Tab repeatedly.

D.1.88 Taskbar and Start Menu control panel

To configure your Dock (the equivalent of the Taskbar and Start menu), choose [image] [image] Dock [image] Dock Preferences, or click the Dock icon in System Preferences.

D.1.89 "Three-fingered salute"

Instead of pressing Ctrl-Alt-Delete to jettison a stuck program on the Mac, you press Option- [image] -Esc. A Force Quit dialog box appears. Click the program you want to toss, click Force Quit, confirm your choice, and then relaunch the program to get on with your day.

D.1.90 ToolTips

Small, yellow identifying balloons pop up on the Mac almost as often as they do in Windows. Just point to a toolbar icon or truncated file name without clicking. (There's no way to turn these labels off.)

D.1.91 TweakUI

The closest equivalent for this free, downloadable, but unsupported Microsoft utility for tweaking the look of your PC is TinkerTool 2 for Mac OS X. It's described in Chapter 17.

D.1.92 User Accounts control panel

Like Windows 2000 and Windows XP, Mac OS X was designed from Square One to be a multiuser operating system, keeping the files, mail, and settings of each person separate. You set up and manage these accounts in System Preferences [image] Accounts (Chapter 11).

D.1.93 Window edges

You can enlarge or shrink a Mac OS X window only by dragging its lower-right corner—not its edges.

D.1.94 Windows (or WINNT) folder

Mac OS X's operating system resides in a folder simply called System, which sits in your main hard drive window. Exactly as in recent Windows versions, you're forbidden to add, remove, or change anything inside. Also as in Windows, most of it is invisible anyway.

D.1.95 Windows logo key

The Mac has no equivalent for the Windows logo key on most PC keyboards.

D.1.96 Windows Media Player

The Mac comes with individual programs for playing multimedia files:

  • QuickTime Player (Chapter 14) to play back movies and sounds.

  • iTunes (Chapter 10) to play CDs, Internet radio, MP3 files, and other audio files. (As a bonus, unlike Windows XP, iTunes can even create MP3 files.)

  • Apple DVD Player (Chapter 10) for playing DVDs. If your Mac does, in fact, have a DVD player built in, this program is in the Applications folder.

D.1.97 Windows Messenger

Mac OS X doesn't come with built-in videoconferencing and voice conferencing software, as Windows XP does.

For regular typed chat, however, use iChat, described in Chapter 20.

D.1.98 WordPad

The TextEdit program (in the Applications folder) is a barebones word processor like WordPad. It can't, alas, open Word files, as WordPad can (although it does open RTF files).

D.1.99 Zip files

Zip files exist on the Mac, too, although StuffIt files are much more common. See Section 4.8 for a discussion of software compression standards on the Mac.


Appendix E. Where to Go From Here

If read in a comfortable chair with good lighting, this book can be the foundation of a sturdy Mac OS X education. But particularly when it comes to mastering the Unix side of this operating system, years of study may await you still.


E.1 Web Sites

The Web is the salvation of the Mac OS X fan, especially considering the information vacuum that dominated Mac OS X's early days. The Internet was the only place where people could find out what the heck was going on with their beloved Macs. Here are the most notable Web sites for learning the finer points of Mac OS X.

E.1.1 Mac OS X

  • www.versiontracker.com. A massive database that tracks, and provides links to, all the latest software for Mac OS X.

  • www.macosxhints.com. A gold mine of tips, tricks, and hints.

  • www.resexcellence.com. Another rich resource of hacks and information on the underpinnings of Mac OS X.

  • www.apple.com/developer. Even if you aren't a developer, joining the Developer Connection (Apple's programmers' club) gets you an email newsletter, and the discussion boards are a great place for hearing Mac news first—all for free. (Pay $500 a year to become a Select member, and you get CDs mailed to you containing upcoming versions of Mac OS X.)

  • www.macobserver.com. A good source for news and commentary about the Mac and related products.

  • www.macworld.com. The discussion boards are an ideal place to find solutions for problems. When a bug pops up, the posts here are a great place to start.

  • www.macaddict.com. Another great location for discussion boards.

  • www.macfixit.com. The ultimate Mac troubleshooting Web site, complete with a hotbed of Mac OS X discussion.

  • www.macdevcenter.com. O'Reilly's own Mac site. Full of tutorials, news, and interesting weblogs (techie diaries).

  • www.geekculture.com. A hilarious satire site, dedicated to lampooning our tech addiction—especially Apple tech. Perhaps best known for the David Pogue's Head icon for Mac OS X (http://geekculture.com/download/davidpogue.html).

    Or perhaps not.

E.1.2 Mac OS X-Style Unix Lessons and Reference

  • www.westwind.com/reference/OS-X/commandline. A command reference of cd, ls, rm, and all the other commands you can use in Terminal or the console.

  • www.ee.surrey.ac.uk/Teaching/Unix. A convenient, free Web-based course in Unix for beginners, focused on the tcsh shell (the Mac OS X dialect).

    TIP

    Typing unix for beginners into a search page like Google.com nets dozens of superb help, tutorial, and reference Web sites. If possible, stick to those that feature the tcsh shell; that way, everything you learn online should be perfectly applicable to navigating Mac OS X via Terminal.


E.2 Advanced Books

By a happy coincidence, this book is printed and distributed by O'Reilly & Associates, the industry's leading source of books for programmers. And a big chunk of O'Reilly's catalog is dedicated to teaching Unix, especially intermediate and advanced Unix. If this book—particularly Chapter 7, Chapter 15, and Chapter 16 —have given you the programming bug or the Unix bug, here are some titles that apply:

E.2.1 Writing Software for Mac OS X

  • Learning Cocoa by Apple Computer, Inc. Eases you into the experience of writing Cocoa programs.

  • Learning Carbon by Apple Computer, Inc. Gives you a head start in writing Carbon programs.

  • AppleScript in a Nutshell by Bruce W. Perry. The first modern reference to AppleScript, including its use in Mac OS X.

  • Mac OS X for Unix Geeks by Brian Jepson & Ernest Rothman. Just what it says.

E.2.2 Unix Essentials

  • Learning the Unix Operating System, 5th Edition, by Jerry Peek. A good primer for Mac users who want to know a little more about Unix.

  • Learning GNU Emacs, 2nd Edition, by Debra Cameron, Bill Rosenblatt, & Eric Raymond. A comprehensive guide to the GNU Emacs editor, one of the most widely used and powerful Unix text editors.

  • Learning the vi Editor, 6th Edition, by Linda Lamb & Arnold Robbins. A complete guide to editing with vi, the text editor available on nearly every Unix system.

  • Unix in a Nutshell: System V Edition, 3rd Edition, by Arnold Robbins. A complete Unix reference, containing all commands and options, with descriptions and examples that put the commands in context.

  • Unix Power Tools, 2nd Edition, by Jerry Peek, Tim O'Reilly, & Mike Loukides. Practical advice about most every aspect of advanced Unix: POSIX utilities, GNU versions, detailed bash and tcsh shell coverage, a strong emphasis on Perl, and a CD-ROM that contains the best freeware available.

E.2.3 OS X Administration

  • Apache: The Definitive Guide, 2nd Edition, by Ben Laurie & Peter Laurie. Describes how to set up, and secure the Apache Web server software.

  • Essential System Administration, 2nd Edition, by Aileen Frisch. A compact, manageable introduction to the tasks faced by everyone responsible for a Unix system.


E.3 Email Lists

  • The OS X list. Once you've signed up (at www.themacintoshguy.com/lists/X.html), your email Inbox will overflow with Mac OS X discussion, chatter, and discoveries. A great place to ask questions, both simple and difficult.


Appendix F. The Master Mac OS X Keystroke List

Here it is, by popular, frustrated demand: The master list of every secret (or not-so-secret) keystroke in Mac OS X, including all of the keys you can press during startup. Clip and post to your monitor—unless, of course, you got this book from the library.


F.1 The Master List

F.1.1 Startup Keystrokes

Keys to Hold Down | Effect
C | Start up from a CD
D | Start up from the first partition
N | Start up from network server
T | Puts the Mac into FireWire Target Disk mode
X | Starts up in Mac OS X (if 9 is on the same disk)
Shift | Prevents startup items from opening
Option | Shows icons of all startup disks, so you can choose one for starting up.
-Option-Shift-Delete | Starts up from external drive (or CD)
-Option-P-R | Zaps the parameter RAM (PRAM). (Hold down until second chime.)
-Option-O-F | Brings up Open Firmware screen.
-V | Show Unix console messages during startup
-S | Start up in single user mode
mouse down | Ejects a stuck CD or DVD
Shift | Just after powering up: turns off kernel extensions (see Section B.10)
Shift | Later, after logging in: Prevents Finder windows from opening and startup items from opening. (They'll return the next time you start up.)

F.1.2 In the Finder

-Option-W | Closes all Finder windows
right arrow, left arrow | Expands or collapses a selected folder in list view
Option-right arrow | Expands a folder in a list view and all folders inside it
Option-left arrow | Collapses folder and all folders inside it
-up arrow | Opens parent folder
-Option-Shift-up arrow | Selects the Desktop
-down arrow | Opens the selected icon
Option-click the flippy triangle | Expands or collapses all folders within that window
Tab | Selects next icon alphabetically
Shift-Tab | Selects previous icon alphabetically
-Delete | Moves highlighted icons to the Trash
Space bar | Opens the disk or folder under mouse immediately (during a spring-loaded folder drag)
Option (when inserting a CD) | Show each session (on a multisession, ISO-9660 CD) as a separate icon

F.1.3 Power Keys

On keyboards with a power key: |
-Control-power | Forces a restart
Control- [image] -Option-power | Shuts down
-Option-power | Put recent models to sleep
On machines without a power key |
Control-Eject | Bring up dialog box for shutdown, sleep or restart
-Control-Eject | Forces a restart
Control- [image] -Option-Eject | Shuts down
-Option-Eject | Puts the Mac to sleep

F.1.4 Managing Programs

-Tab | Press and release: Switches back and forth between current and previous open program
-Tab | Hold down c: Press Tab repeatedly to cycle through open programs on the Dock. (Add Shift to cycle backward through open programs on the Dock)
-~ | Switches to next open window in this program
Option- [image] -Esc | Opens the Force Quit dialog box (to close a stuck program)
Shift- [image] -3 | Captures the screen image as a PDF file on your desktop
Shift- [image] -4 | Produces a crosshair; drag to capture a selected portion of the screen as a PDF graphics file. (Press Space to get the "camera" cursor that snips out just a menu, icon, or window.)
-Space | Switches keyboard layout (if more than one is installed)
Option-"Empty Trash" | Empties the trash without being asked "Are you sure?" (also nukes locked files)
Option-click a Dock icon or open window | Switches to new program and hides previous one
-Option drag | Scrolls a Finder window in any direction
-drag | Rearrange or remove menulets or toolbar icons
-click window title | Opens a pop-up menu showing the folder path
Option-click the Zoom button | Enlarges the window to full screen
Option-click the Minimize button | Minimizes all Finder windows
Option-click Close button | Closes all Finder windows
Shift-click the Minimize or Close button | Minimizes or closes window in slow motion
-Option-D | Hides/shows the Dock
-click a Dock icon | Reveals its actual Finder icon
-Option-click a Dock icon | Switches to this program and hides all others
Control-click (or click and hold on) a Dock icon | Opens a contextual menu
-drag an icon onto a Dock icon | Prevents Dock icons from moving, so that you can drop your icon onto one of them
-Option-drag an icon onto the Dock | Forces a Dock program icon to open the icon you're dropping


Colophon

Due to an annoying and permanent wrist ailment, the author wrote this book by voice, using Dragon Naturally Speaking on a Windows PC. The Microsoft Word files were then transferred (courtesy of Jaguar's new ability to see PCs on the same network) to a Power Mac G4 and a PowerBook G4, where they were edited and transmitted to the book's editors and technical reviewers.

The screenshots were captured with Ambrosia Software's Snapz Pro X (www.ambrosiasw.com). Adobe Photoshop and Macromedia Freehand (www.adobe.com) were called in as required for touching them up.

The book was designed and laid out in Adobe PageMaker 6.5 on a PowerBook G3 and Power Mac G4. The fonts used include Formata (as the sans-serif family) and Minion (as the serif body face). To provide the [image] and [image] symbols, a custom font was created using Macromedia Fontographer.

The book was generated as an Adobe Acrobat PDF file for proofreading and indexing, and finally transmitted to the printing plant in the form of PostScript files.

The online edition of this book was created by the Safari production group (John Chodacki, Becki Maisch, and Madeleine Newell) using a set of Frame-to-XML conversion and cleanup tools written and maintained by Erik Ray, Benn Salter, John Chodacki, and Jeff Liggett.


Team LiB

Brought to You by